-- name=int_button_map_impl
--******************************************************************************************
function public.Init ()
  --
  public.DIRECTION = 1;
  public.POSITION = 1024;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_map", {
    event_mdown = int_button_map.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

--  ObjSet("spr_int_button_map_button", {
--    event_mdown = int_button_map.MouseDown,
--    event_menter = private.MouseEnterAnim,
--    event_mleave = private.MouseLeaveAnim
--  });
--
end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );
  local obj = "spr_int_button_map_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

  ObjAnimate( "txt_int_button_map_text_focus", "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );
  ObjAnimate( "anm_int_button_map_focus", "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );  
  

  --ObjSet("vid_int_button_map", { playing = 1 });

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT ); 
  local obj = "spr_int_button_map_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

  ObjAnimate( "txt_int_button_map_text_focus", "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );
  ObjAnimate( "anm_int_button_map_focus", "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

  --ObjSet("vid_int_button_map", { playing = 0 });
  
end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

  
  else


  end;

end;
--******************************************************************************************