-- name=int_map_impl
--******************************************************************************************
function public.Init ()

  private.DIRECTION = 0;

  private.SHOW_ANIM_TIME = 0.3;
  private.HIDE_ANIM_TIME = 0.3;

 
  
  public.map_rooms=
  --[комната] = {принадлежность к странице, заблокированность, принадлежность к блоку ( или "комнате" ), { прогресс открывающий доступ - для первой локи блока  }}
  {
    ["house"]         = {1,0,1,{"opn_house"     }},
    ["ruralroad"]     = {1,0,2,{"opn_ruralroad" }},
    ["farm"]          = {1,0,3,{"opn_farm"      }},
    ["pond"]          = {1,0,4,{"opn_pond"      }},
    ["ruralhouse"]    = {1,0,5,{"opn_ruralhouse"}},
    ["cellar"]        = {1,0,6,{"opn_cellar"    }},
    ["neartower"]     = {1,0,7,{"opn_neartower" }},
    ["tower"]         = {1,0,8,{"opn_tower"     }},
    ["chapel"]        = {1,0,9,{"opn_chapel"    }},


--    ["inhouse"]      = {1,0,5},
--10
    ["nearpub"]      = {2,0,10,{"opn_nearpub"}},
    ["pub"]          = {2,0,11,{"opn_pub"}},
    ["darkquarter"]  = {2,0,12,{"opn_darkquarter"}},
    ["swamp"]        = {2,0,13,{"opn_swamp"}},
    ["mansion"]      = {2,0,14,{"opn_mansion"}},
    ["beyondtower"]  = {2,0,15,{"opn_beyondtower"}},
--16    
    ["jail"]         = {3,0,16,{"opn_jail"}},
    ["corridor"]     = {3,0,17,{"opn_corridor"}},
    ["rungs"]        = {3,0,18,{"opn_rungs"}},
    ["bedroom"]      = {3,0,19,{"opn_bedroom"}},
    ["hall"]         = {3,0,20,{"opn_hall"}},
    ["yard"]         = {3,0,21,{"opn_yard"}},    

    ["houseext"]     = {4,0,22,{"opn_houseext"}},
    ["inhouseext"]   = {4,0,23,{"opn_inhouseext"}},
    ["ruralroadext"] = {4,0,24,{"opn_ruralroadext"}},
    ["farmext"]      = {4,0,25,{"opn_farmext"}},
    ["pondext"]      = {4,0,26,{"opn_pondext"}},
    ["nearpubext"]   = {4,0,27,{"opn_nearpubext"}},
    ["pubext"]       = {4,0,28,{"opn_pubext"}},
    ["mallext"]      = {4,0,29,{"opn_mallext"}},
    ["staffonlyext"] = {4,0,30,{"opn_staffonlyext"}},   
    ["barnext"]      = {4,0,31,{"opn_barnext"}},   
   }

  --screen - { to screen, opn room }
  public.map_arrows = 
  {
    --[[1]]  --{2,"nearterem"};
    --[[2]]  --{1,"square"};

  }  

  for i = 1, #public.map_arrows do
    ObjSet( "spr_map_arrow_"..i.."_"..public.map_arrows[i][1], { 
      event_mdown = function() private.MapScreenChange(i,public.map_arrows[i][1]) end;
      --event_menter = function() private.MapScreenArrowEnter("spr_map_arrow_"..i.."_"..public.map_arrows[i][1]) end;
      --event_mleave = function() private.MapScreenArrowLeave("spr_map_arrow_"..i.."_"..public.map_arrows[i][1]) end;
    } )
  end

  local seted = {}
  for k,v in pairs( public.map_rooms ) do
    if type( v[3] ) ~= "string" then
      ObjSet( "spr_map_impl_screen_block_"..v[3].."_magnifier_dark", { 
        event_mdown = function() private.MapBlockShow(v[3]) end;
        --event_menter = function() private.MapBlockShowZoneEnter(v[3]) end;
        --event_mleave = function() private.MapBlockShowZoneLeave(v[3]) end;
        blendmode = 0;
      } )
      ObjSet( "spr_map_impl_screen_block_"..v[3].."_zone", { 
        event_mdown = function() private.MapBlockShow(v[3]) end;
        --event_menter = function() private.MapBlockShowZoneEnter(v[3]) end;
        --event_mleave = function() private.MapBlockShowZoneLeave(v[3]) end;
        blendmode = 0;
      } )
      ObjSet( "spr_map_impl_screen_block_"..k.."2", { 
        event_mdown = function() private.MapButtonJump(k) end;
        --event_menter = function() private.MapButtonEnter("spr_map_impl_screen_block_"..k.."2") end;
        --event_mleave = function() private.MapButtonLeave("spr_map_impl_screen_block_"..k.."2") end;
        blendmode = 0;
        alp = 0;
      } )
      seted[ v[3] ] = true;
    end;
  end;


      ObjSet( "obj_map_btn_close", { 
        event_mdown = function() private.MapButtonClose() end;
        --event_menter = function() private.MapButtonEnter("spr_map_btn_close_focus") end;
        --event_mleave = function() private.MapButtonLeave("spr_map_btn_close_focus") end;
      } );
      ObjSet( "obj_map_btn_exit", { 
        event_mdown = function() private.MapButtonClose() end;
        --event_menter = function() private.MapButtonEnter("spr_map_btn_exit_focus") ld.ShCur(CURSOR_DOWN) end;
        --event_mleave = function() private.MapButtonLeave("spr_map_btn_exit_focus") end;
      } );

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

  --public.grm_block_seting = {}

end;
--******************************************************************************************
function public.ShowAnim ( event_id )

  private.click_object = "";
  private.click_object_block = "";
  private.popup_button_active = false;
  private.popup_block_active = false;
  
  private.MapLockAll( 1 )
  SoundSfx( "aud_openmap" )
  
  if common.GetCurrentSubRoom() then
    ld.CloseSubRoom()
  elseif interface.GetCurrentComplexInv() ~= "" then
    common_impl.HideComplexItem();
  end;

  --PlayEnv( "assets/levels/common/audio/aud_map_env", 0, "", 0.5 );
  --SoundEnv( "aud_map_env", -1 )

  local trg = function() 
    private.MapLockAll( 0 ) 
    int_map.EventAnimEnd( '"..event_id.."' ); 
    if ng_global.currentprogress == 'std' then 
      level.tutorial_map2.first()
    end 
  end

  local tme = private.SHOW_ANIM_TIME;
  private.MapScreenNow = false
  if not private.MapScreenNow then
    local rm = ld.StringDivide( common.GetCurrentRoom() )[2];
    if  common_impl.hint[ "win_"..rm ] 
    and common_impl.hint[ "win_"..rm ].room 
    then
      rm = ld.StringDivide( common_impl.hint[ "win_"..rm ].room  )[2];
    end
    for k,v in pairs( public.map_rooms ) do
      if rm == k then
        private.MapScreenNow = v[1];
      end
    end;
  end

  private.UpdateMap(private.MapScreenNow);

  private.MapBlockPrewiewAnimator()

  ObjAnimate( "int_map", 8, 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim ( event_id )

  --SndStop("assets/levels/common/audio/aud_map_env",0.5);
  SoundSfx( "aud_closemap" )

  local trg = function()
    int_map.EventAnimEnd( event_id );
    ObjDelete( 'tmr_map_block_prewiew_animator' );
    private.MapBlockPrewiewAnimator_new_block_show_start=false;
  end;

  local tme = private.HIDE_ANIM_TIME;

  private.MapBlockPrewiewAnimator( true )

  ObjAnimate( "int_map", 8, 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.UpdateGameMode ( msg, params )

  if ( params.mode == 3 and not ng_global.gamemode_custom[ "tasks" ] ) then
    
  end;

end;
  --******************************************************************************************
  --******************************************************************************************
  --******************************************************************************************
  --******************************************************************************************
  --******************************************************************************************


function private.screenBlocks( lvl )
  seted = {}
  blocks = {}
  for k,v in pairs(public.map_rooms) do
    if v[1] == lvl and not seted[v[3] ] then
      seted[v[3] ] = true;
      table.insert( blocks, v[3] );
    end;
  end;
  return blocks
end;

--Доступность МГ до старта
function private.make_map_mg_hint_actions()
  if not private.map_mg_hint_actions then
    private.map_mg_hint_actions = {};
    for k,v in pairs(common_impl.hint) do
      if ( v.type == "use" or v.type == "click" )
      and v.zz and v.zz:find("^mg") then
        private.map_mg_hint_actions[v.zz] = private.map_mg_hint_actions[v.zz] or {}
        private.map_mg_hint_actions[v.zz][k]=v;
      end;
    end;
  end;
end

function private.UpdateMap(screen)
  
  private.make_map_mg_hint_actions();
  screen = screen or 1
  if not screen then
    
  end
  ld.LogTrace( "UpdateMap "..screen )
  ObjAttach("fx_map_impl_showpoint","int_map_impl_obj_root")
  private.MapBlockPrewiewAnimateRMSscreen = screen
  private.MapBlockPrewiewAnimateRMS = private.MapBlockPrewiewAnimateRMS or {}
  if not private.MapBlockPrewiewAnimateRMS[screen] then

    local prg_id = {}
    for i = 1, #game.progress_names do
      prg_id[ game.progress_names[i] ] = i
    end;
    private.MapBlockPrewiewAnimateRMS[screen] = {}
    for k,v in pairs( public.map_rooms ) do
      if v[1] == screen then
        if private.MapBlockPrewiewAnimateRMS[screen][ v[3] ] then
          local good = 1;
          for i = 1, #private.MapBlockPrewiewAnimateRMS[screen][ v[3] ] do
            if prg_id[ "opn_"..private.MapBlockPrewiewAnimateRMS[screen][ v[3] ][ i ] ] < prg_id[ "opn_"..k ] then
              good = i + 1;
            end;
          end;
          table.insert( private.MapBlockPrewiewAnimateRMS[screen][ v[3] ], good, k )
        else
          ObjSet( "obj_map_impl_screen_block_"..v[3].."_prewiew", { scale_x = 0.5, scale_y = 0.5, alp = 0 } )
          private.MapBlockPrewiewAnimateRMS[screen][ v[3] ] = { k }
        end
      end;
    end;
    for k,v in pairs( private.MapBlockPrewiewAnimateRMS[screen] ) do
      --ld.LogTrace( "obj_map_impl_screen_block_"..k.."_prewiew" )
      --ObjSet( "obj_map_impl_screen_block_"..k.."_prewiew", { scale_x = 0.5, scale_y = 0.5, alp = 0 } )
      ObjAnimate( "obj_map_impl_screen_block_"..k.."_prewiew", 8,0,0, _, { 0,0,0, 0.0,0,0 } )
      ObjSet( "spr_map_impl_screen_"..v[1].."3", { alp = 1 } );
    end;
  end;


  --скрытие блоков--
  ObjSet( "obj_map_impl_screen_intro_root", { alp = 1 } )
  ObjSet( "spr_map_impl_zoom", { input = 0, alp = 0 } )
  local blocks = private.screenBlocks( screen )
  --local count = 1;
  for i = 1, #blocks do
  --while ObjGet( "spr_map_impl_screen_block_"..count ) do
             --spr_map_impl_screen_block_1_zone
    --ObjSet( "spr_map_impl_screen_block_"..count.."_intro", { visible = 0 } )
    --ObjSet( "spr_map_impl_screen_block_"..count.."_arrow", { visible = 0 } )
    --ObjSet( "anm_map_impl_screen_block_"..count.."_intro", { visible = 0 } )
    local count = blocks[i]
    ObjSet( "spr_map_impl_screen_block_"..count.."_zone", { alp = 0, input = 0 } )
    ObjSet( "spr_map_impl_screen_block_"..count, { input = 0 } )
    ObjSet( "spr_map_impl_screen_block_"..count.."_pointer_block_place", { visible = 1 } )
    ObjSet( "spr_map_impl_screen_block_"..count.."_pointer_block_action", { visible = 0, alp = 0 } )
    ObjSet( "spr_map_impl_screen_block_"..count.."_pointer_block_player", { visible = 0, alp = 0 } )
    ObjSet( "spr_map_impl_screen_block_"..count.."_pointer_prewiew_place", { visible = 1 } )      
    ObjSet( "spr_map_impl_screen_block_"..count.."_pointer_prewiew_action", { visible = 0, alp = 0 } )
    ObjSet( "spr_map_impl_screen_block_"..count.."_pointer_prewiew_player", { visible = 0, alp = 0 } )



    --count = count + 1;
  end

  if ng_global.gamemode < 2 or (ng_global.gamemode == 3 and ng_global.gamemode_custom.tasks ) then
    ObjSet( "spr_map_impl_zoom_legend", {visible = 0} );
    ObjSet( "spr_map_legend", { res = "assets/interface/resources/map/legend" } )
  else
    ObjSet( "spr_map_impl_zoom_legend", {visible = 1} );
    ObjSet( "spr_map_legend", { res = "assets/interface/resources/map/legend2" } )
  end
  ------------------
  

--позиция игрока

    local prg=ng_global.currentprogress
    local player = "spr_map_impl_pointer_zoom_player";
    --ld.LogTrace( ng_global.progress[ prg ].common.currentmaproom );
    local name_room = common.GetObjectName( ng_global.progress[ prg ].common.currentmaproom );
    local lvl = 1
    local task_arr = {}
    for i,o in pairs(public.map_rooms) do
      if type(o[1]) ~= "string" then
        task_arr[i] = 0
        if i == name_room then
          lvl = screen or o[1] 
        end
        ---***********
        ObjAttach( "spr_map_impl_back_"..o[1], "int_map_impl_obj_root" );
        ObjAttach( "obj_map_impl_screen_"..o[1], "int_map_impl_obj_root" );
      end
    end

  --  ng_global.progress[ "std" ][ "tutor_map1" ].done = 1
    --if common.GetObjectName( GetCurrentRoom() ) ~= "ruins" and lvl == 1 then
    --  ld.tutorial.TutorialShow('tutor_map2', 0, 350, 350, 0, 150, 0)
    --end

---ВЫВОД СТРАНИЦЫ----------------------------------------------------------------------------------------
    ld.LogTrace( lvl );
    --ObjAttach( "spr_map_impl_back_"..lvl, "obj_map_impl_back" );
    ObjAttach( "obj_map_impl_screen_"..lvl.."_root", "obj_map_impl_root");
    
    for i,o in pairs(public.map_rooms) do
      local v
      if ng_global.progress[prg]["opn_"..i] then
        v = ng_global.progress[prg]["opn_"..i].done
        if o[1] ~= lvl or o[2] == 1 then
          v = 0
        end
        ObjSet( "spr_map_impl_screen_block_"..i, {input = v, visible = v} );
      end
      --ld.LogTrace( "spr_map_impl_screen_block_"..i.." "..tostring(v) )
      
    end

    local room_zone = "spr_map_impl_screen_block_"..name_room;
    local room_jump = "obj_map_impl_screen_block_"..name_room.."_pointers";
    if ObjGet( room_zone ) then
      local room_pos_x = ObjGet( room_zone ).pos_x + ObjGet( room_jump ).pos_x;
      local room_pos_y = ObjGet( room_zone ).pos_y + ObjGet( room_jump ).pos_y;  
      ObjAttach(player, room_jump)
    end;
 ----включение стрелок для перелистывания
    if public.map_arrows then
      for i = 1, #public.map_arrows do
        if public.map_arrows[i] then
          if ng_global.progress[ prg ][ "opn_"..public.map_arrows[i][2] ] and ng_global.progress[ prg ][ "opn_"..public.map_arrows[i][2] ].done == 1 then
            ObjSet( "spr_map_arrow_"..i.."_"..public.map_arrows[i][1], { alp = 1, input = 1 } )
          else
            ObjSet( "spr_map_arrow_"..i.."_"..public.map_arrows[i][1], { alp = 0, input = 0 } )
          end;
        end;
      end;
    end;
----

---Подсчет тасков----------------------------------------------------------------------------------------
    local logtrace_arr = {}
    function ld.MapAddCount(room,o) -- заполнение таблицы счетчиков
      room = ld.StringDivide(room)[2]
      if (room ~= "complex") and (not public.map_rooms[room]) then
        private.map_rooms_bad = private.map_rooms_bad or {}
        if not private.map_rooms_bad[room] then
          ld.LogTrace( "WARNING: ld.MapAddCount >> "..room )
          private.map_rooms_bad[room] = true
        end
        return
      end;

      if room ~= "complex" then
        --DbgTrace(room)
        if public.map_rooms[room][3] and type( public.map_rooms[room][3] ) =="string" then
          room = public.map_rooms[room][3]
        end;
        --if not task_arr[room] then DbgTrace(room) end
        task_arr[room] = task_arr[room] + 1
      end
      if ng_global.progress[prg]["opn_"..room] then
        if ng_global.progress[prg]["opn_"..room].done == 1 then
            --ld.LogTrace( room.." | "..o );
            if not logtrace_arr[room] then
              logtrace_arr[room] = {}
            end
            table.insert(logtrace_arr[room],o)
        else
          --ld.LogTrace( o );
        end;
      else
          if room == "deploy" then
            --ld.LogTrace( room.." | "..o );
          end;
      end;
    end
   
    for i,o in ipairs(game.progress_names) do -- перебор таблицы прогресса
      local obj = common_impl.hint[o]
      if obj and ng_global.progress[prg][o].done ~= 1 then  -- если объект хинтовый и прогресс не завершен
        if obj.type == "use" then  -- если юз
          if (obj.zz_gate and ObjGet(obj.zz_gate).input) or (not obj.zz_gate) then  -- если (в зумзоне/миниигре и зумзона/миниигра открыта) или (в комнате)
            if not obj.use_place or not ObjGet(obj.use_place) then 
              ld.LogTrace( "ERROR: MAP 'use' obj.use_place >> "..o.." >> "..(obj.use_place or "NONE") )
            elseif ObjGet(obj.use_place).input or ng_global.progress[prg][o].start == 1 then  -- если объекту включен инпут или начата последовательность с этим объектом(mmg)
              if ObjGet(obj.inv_obj).drag then -- если есть применяемый предмет
                ld.MapAddCount(obj.room,o)
              end
            end
          end
        elseif obj.type == "get" then -- если гет
          if (obj.zz_gate and ObjGet(obj.zz_gate).input) or (not obj.zz_gate) then  -- если это (в зумзоне/миниигре и зумзона/миниигра открыта) или (в комнате)
            if not obj.get_obj or not ObjGet(obj.get_obj) then 
              ld.LogTrace( "ERROR: MAP 'get' obj.get_obj >> "..o.." >> "..(obj.get_obj or "NONE") )
            elseif ObjGet(obj.get_obj).input or ng_global.progress[prg][o].start == 1 then  -- если объекту включен инпут или начата последовательность с этим объектом(mmg)
              ld.MapAddCount(obj.room,o)
            end
          end
        elseif obj.type == "click" then -- если клик

          if (obj.zz_gate and ObjGet(obj.zz_gate).input) or (not obj.zz_gate) then  -- если это (в зумзоне/миниигре и зумзона/миниигра открыта) или (в комнате)

            --if ( not ng_global.progress[prg][o].start and ObjGet(obj.use_place).input )
            --or ( ng_global.progress[prg][o].start and ng_global.progress[prg][o].start == 1 and ObjGet(obj.use_place).input ) then
          --ld.LogTrace( o );
            if not obj.use_place or not ObjGet(obj.use_place) then 
              ld.LogTrace( "ERROR: MAP 'click' obj.use_place >> "..o.." >> "..(obj.use_place or "NONE") )
            elseif ObjGet(obj.use_place).input or ng_global.progress[prg][o].start == 1 then  -- если объекту включен инпут или начата последовательность с этим объектом(mmg)
              if obj.get_obj then

                if ObjGet(obj.get_obj).input then-- исключение для фонтана в парке тип клик дополнительно проверяется по inv_obj или get_obj

                  ld.MapAddCount(obj.room,o)
                end
              elseif obj.inv_obj then

                if ObjGet(obj.inv_obj).drag then 

                  ld.MapAddCount(obj.room,o)
                end
              else

                ld.MapAddCount(obj.room,o)
              end
            end
          end

        elseif obj.type == "win" then -- если вин
          if not obj.zz then
            ld.LogTrace( "WARNING : "..o.." >>> no zz " )
          else
            local pref = ld.StringDivide(obj.zz)[1]
--private.map_mg_hint_actions[v.zz][k]=v
            if pref == "mg" then
              if ng_global.progress[prg][o].start == 1 then
                ld.MapAddCount(obj.room,o)
              elseif ObjGet( obj.zz_gate ).input and not private.map_mg_hint_actions[obj.zz] then
                --доп обработка не стартовавшей МГ
                ld.MapAddCount(obj.room,o)
              end;
            elseif pref == "ho" and ObjGet(obj.zz_gate).input then
                ld.MapAddCount(obj.room,o)
            end
          end
        end
      end
    end


  for i,o in pairs(public.map_rooms) do
    if type(o[1]) ~= "string" then
      local room = i
      local num = o[1]
      local lock = o[2]
      --local root_loc  = "spr_map_impl_screen_"..room.."_zone"
      local obj_ytask = "spr_map_impl_screen_block_"..room.."_pointer_zoom_action"
      local obj_ntask = "spr_map_impl_screen_block_"..room.."_pointer_zoom_place"
      local obj_xtask = "spr_map_impl_screen_block_"..room.."_pointer_zoom_lock"
      ObjSet(obj_ytask,{alp=0})
      ObjSet(obj_ntask,{alp=0})
      ObjSet(obj_xtask,{alp=0})
      
      if task_arr[room]>0 then
        if ng_global.gamemode < 2 or (ng_global.gamemode == 3 and ng_global.gamemode_custom.tasks ) then
          ObjSet(obj_ytask,{alp=1})
        else
          ObjSet(obj_ntask,{alp=1})
        end
        if lock == 1 then 
          DbgTrace("map_error: locked room have tasks: "..room)  
        end  
      elseif task_arr[room]==0 then
        ObjSet(obj_ntask,{alp=1})
      elseif task_arr[room]<0  then
        DbgTrace("map_error: tasks below 0: "..room)
      end
      if lock == 1 then 
        ObjSet(obj_ytask,{alp=0})
        ObjSet(obj_xtask,{alp=1})
        ObjSet(obj_ntask,{alp=0})
      end
    end
  end

--вывод доступных тасков
  for i,o in pairs(logtrace_arr) do
    for j,k in ipairs(o) do
      local zz = (common_impl.hint[k].zz and " | "..common_impl.hint[k].zz) or ""
      ld.LogTrace( i..zz.." | "..k );
    end
  end

--включение/выключение pointer для блоков
  local count = 1;
  while ObjGet( "spr_map_impl_screen_block_"..count ) do
    --DbgTrace("spr_map_impl_screen_block_"..count)
    local block = "spr_map_impl_screen_block_"..count;
    local childs = ObjGetRelations( block ).childs

    for i = 1, #childs do
      local child = childs[i];
      --DbgTrace( "\t"..tostring( child ) )
      --if child:find( "_zone$" ) then
        local divide = ld.StringDivide( child )
        local room = divide[#divide];
        --DbgTrace( "\t\t action "..tostring( room ).."\t"..ObjGet( "spr_map_impl_screen_block_"..room.."_pointer_zoom_action" ).alp )
        if public.map_rooms[ room ] then
          if ( ld.CheckRequirements( { "opn_"..room } ) and public.map_rooms[ room ][ 2 ] == 0 ) or ( public.map_rooms[ room ][ 4 ] and ld.CheckRequirements( public.map_rooms[ room ][ 4 ] )  and public.map_rooms[ room ][ 2 ] == 0 ) then
            --ObjAttach( block.."_zone", "obj_map_impl_screen_"..lvl )
            --ObjAttach( block, "obj_map_impl_screen_"..lvl )
            ObjSet( block.."_zone", { input = 1, alp = 1, visible = 1 } )
            --ld.LogTrace( block.."_zone".."\t"..room.."\t".."obj_map_impl_screen_"..lvl.." "..tostring( ObjGet( block.."_zone" ).input )  )

            if ObjGet( "spr_map_impl_screen_block_"..room.."_pointer_zoom_action" ).alp == 1 and ObjGet( "spr_map_impl_screen_block_"..room.."_pointer_zoom_action" ).visible then
              --ld.LogTrace( room.."\t"..block )
              ObjSet( block.."_pointer_block_action", { visible = 1, alp = 1 } )
              ObjSet( block.."_pointer_prewiew_action", { visible = 1, alp = 1 } )
            end;
          else
            --ObjDetach( block.."_zone" )
            --ObjDetach( block )
          end
          --if not ld.CheckRequirements( { "opn_"..room } ) and ( public.map_rooms[ room ][ 4 ] and ld.CheckRequirements( public.map_rooms[ room ][ 4 ] ) ) then
          --  ObjSet( block.."_pointer_0", { alp = 1, visible = 1, active = 1 } )
          --  --ld.LogTrace( "NEW BLOCK AVAILABLE\t"..count )
          --end;
          --if ObjGet( "spr_map_impl_screen_"..room.."_pointer_2" ).alp == 1 and ObjGet( "spr_map_impl_screen_"..room.."_pointer_2" ).visible then
          --  ld.LogTrace( room.."\t"..block )
          --  ObjSet( block.."_pointer_2", { visible = 1, alp = 1 } )
          --  ObjSet( block.."_pointer_1_2", { visible = 1, alp = 1 } )
          --end;
          local p_childs = ObjGetRelations( "obj_map_impl_screen_block_"..room.."_pointers" ).childs;
          for j = 1, #p_childs do
            if p_childs[j] == "spr_map_impl_pointer_zoom_player" then
              ObjSet( block.."_pointer_block_player", { alp = 1, visible = 1 } )
              ObjSet( block.."_pointer_prewiew_player", { alp = 1, visible = 1 } )
              break;
            end;
          end;
        end;
      --end;
    end;

    count = count + 1;
  end
end

------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapButtonEnter ( obj )
  
   -- ld.PlayAudio( "sfx", "common/audio/aud_map1_env", 0);
    if obj == "spr_map_impl_button_close" then
      SetCursor(CURSOR_DOWN);
    elseif obj == "spr_map_impl_button_close2" then
       SetCursor(CURSOR_HAND);
    else
      SetCursor(CURSOR_HAND)
    end;

    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, 8, 0, 0, "", { 0,0,alp, ( 1 - alp ) / 3 ,0,1 });

end;
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapButtonLeave ( obj )
  
  SetCursor(CURSOR_DEFAULT);
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, 8, 0, 0, "", { 0,0,alp, alp / 3,0,0 });
  
end;
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapButtonJump ( target_obj, force )
  
  if target_obj == private.click_object then
    
    local room = target_obj;
    
    if public.map_rooms[room][2] == 0 then -- not locked location check

      --if private.MapBlockPrewiewAnimator_new_block_show_start and not force then
      --  local aud = {
      --    {};
      --    { 0.2, 0.6, 1, 1.4, 1.8, 2.2, 2.6, 3 };
      --    {};
      --    {};
      --    {};
      --  }
      --  if not aud[private.MapBlockPrewiewAnimator_new_block_show_start]  or aud[private.MapBlockPrewiewAnimator_new_block_show_start] == 0 then
      --    private.MapButtonJump ( target_obj, 1 )
      --  else
      --      private.MapButtonJump ( target_obj, 1 )
      --  end;
      --else

        private.MapLockAll( 1, 1 )

          for i,o in pairs(public.map_rooms) do
            if type(o[1]) ~= "string" then
              ObjSet( "spr_map_impl_screen_"..i.."_zone", {input = 0} );
            end
          end
          
          --ld.PlayAudio( "sfx", "common/audio/aud_map", 0);
          ObjSet( "obj_map_impl_root", {input = 0});
          public.map_show = false;
          cmn.GotoRoom( "rm_"..room, _ )--, "map" );
          
          ld.StartTimer( "tmr_tmp_map_impl_jump_lock_relase", 1, function() private.MapLockAll( 0, 0 ) end )
          ld.StartTimer( "tmr_tmp_map_impl_jump", 0.5, function() int_map.Close(); private.MapActiveInterface(); end );
        --end;
      --end;

    end
  else
    private.click_object = target_obj;
  end;
  
end;
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapButtonClose()
  public.map_show = false;
  int_map.Close();
end;
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapActiveInterface()

  ObjSet( "obj_map_impl_root", {input = 1});

end;
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------


function private.MapScreenChange(from,to)
  ld.Lock( 1 )
--public.UpdateMap()
  --ObjSet( "obj_map_impl_screen_"..to, { alp = 0 } )
  --ObjAttach( "obj_map_impl_screen_"..to, "int_map_impl" );
  ObjAnimate( "obj_map_impl_screen_"..from.."_root", 8,0,0, function() private.MapScreenChangeEnd(from,to) end, { 0,0,1, 0.35,0,0 } )
  --ObjAnimate( "spr_map_impl_back_"..from, 8,0,0, "", { 0,0,1, 0.35,0,0 } )
  --ObjAnimate( "obj_map_impl_screen_"..to, 8,0,0, "", { 0,0,0, 0.35,0,1 } )
end;

function private.MapScreenChangeEnd(from,to)
  private.MapScreenNow = to
  ObjDetach("obj_map_impl_screen_"..from.."_root");
  private.UpdateMap(private.MapScreenNow)
  ObjAnimate( "obj_map_impl_screen_"..to.."_root", 8,0,0, function() ld.Lock( 0 ) end, { 0,0,0, 0.35,0,1 } )
  --ObjAnimate( "spr_map_impl_back_"..to, 8,0,0, "", { 0,0,0, 0.35,0,1 } )
  ObjSet( "obj_map_impl_screen_"..from.."_root", { alp = 1 } )
  --ObjSet( "obj_map_impl_screen_"..from, { alp = 1 } )
  
end

function private.MapScreenArrowEnter(obj)
  
  ld.ShCur(CURSOR_HAND)
  local obj = obj.."_light";
  local a = ObjGet( obj ).alp;
  ObjAnimate( obj, 8,0,0, "", { 0,0,a, (1-a)/3,0,1 } )
end;

function private.MapScreenArrowLeave(obj)
  ld.ShCur(CURSOR_DEFAULT)
  local obj = obj.."_light";
  local a = ObjGet( obj ).alp;
  ObjAnimate( obj, 8,0,0, "", { 0,0,a, a/3,0,0 } )
end;

------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapLockAll( lock, close )
  --ld.LogTrace( "MapLockAll "..tostring(lock).." "..tostring(close) )
  if lock == 1 then
    ObjSet( "int_map_impl", {input = 0});
    ld.Lock( 1 )
  elseif lock == 0 then
    if not ObjGet("obj_int_button_map").input and not close then

    else
      ObjSet( "int_map_impl", {input = 1});
      ld.Lock( 0 )
    end
  end;
  if close == 1 then
    ObjSet( "obj_map_impl_button", {input = 0});
  elseif lock == 0 then
    ObjSet( "obj_map_impl_button", {input = 1});
  end;
end;
function private.MapBlockPrewiewAnimatorNewBlockEnd()
  local i = private.MapBlockPrewiewAnimator_new_block_show_start
  local t = 0.5
  --ObjSet( "spr_map_impl_screen_block_"..i.."_intro", { visible = 1 } )
  --ObjSet( "spr_map_impl_screen_block_"..i.."_arrow", { visible = 1 } )
  --ObjAnimate( "spr_map_impl_screen_block_"..i.."_intro", 8,0,0, "", { 0,0,0, t,0,0, t*2,0,1 } )
  --ObjAnimate( "spr_map_impl_screen_block_"..i.."_arrow", 8,0,0, '', { 0,0,0, t*3,0,0, t*4,0,1 } )
  ObjAttach("fx_map_impl_showpoint","spr_map_impl_screen_block_"..i.."_zone")
  ObjSet( "fx_map_impl_showpoint", {active = 1, visible = 1} );
  PartSysRestart("fx_map_impl_showpoint")
  ObjAnimate( "fx_map_impl_showpoint", 8, 0, 0, function() private.MapLockAll(0,1) end, {0,0,0, 0.5,0,1} );
  --ObjAnimate( "obj_map_impl_screen_block_"..i.."_prewiew", 8,0,0, _, { 0,0,0, t*2,0,0, t*3,0,1, t*4,0,1 } )
  --ObjAnimate( "obj_map_impl_screen_block_"..i.."_prewiew", 6,0,0, , { 0,0,0,0, t*2,0,0,0, t*2.9,0,1.1,1.1, t*3.5,2,0.9,0.9 } )

  --ld.StartTimer( t*3, function() PlaySfx( "assets/levels/common/audio/aud_pointer", 0, "", 0 ) end )
end;

function private.MapBlockPrewiewAnimator( fade )
  
  --if 1 then return end;
  local c = GetZoomCursorPos();
  c = { c[1] - 512, c[2] - 384 };
  local t = 0.4
  local rv = 80;
  local rs = 40;
  local blocks = 0
  for k, v in pairs( public.map_rooms ) do
    if type( v[3] ) ~= "string" and v[3] > blocks then
      blocks = v[3]
    end;
  end;
  for i = blocks, 1, -1 do
    local mrc = 0;
    local mrd = 0;
    local prg = false;
    local pre = false;
    for k, v in pairs( public.map_rooms ) do
      if v[3]==i then
        if v[4] then
          prg = ld.CheckRequirements( v[4] )
        end;
        if v[5] then
          pre = ld.CheckRequirements( v[5] )
        end;
        mrc = mrc + 1;
        if not ld.CheckRequirements( { "opn_"..k } ) then
          mrd = mrd + 1
        end;
      end;
    end;
    --if mrc == mrd and false then --prg then
    if mrc == mrd then
      if prg then
        if not private.MapBlockPrewiewAnimator_new_block_show_start then
          private.MapLockAll( 1, 1 )
          for j = 1, blocks do
            if j ~= i then
              ObjSet( "spr_map_impl_screen_block_"..j.."_zone", { input = 0 } )
            end;
          end;
          private.MapBlockPrewiewAnimator_new_block_show_start = i;
          DbgTrace("NEW BLOCK SHOW "..i.." "..mrc.." "..mrd)
          
--          ObjSet( "obj_map_impl_screen_block_"..i.."_prewiew", { scale_x = 0.5, scale_y = 0.5, alp = 0 } )
--          ObjSet( "spr_map_impl_screen_block_"..i.."_dot", { visible = 0 } )
--          ObjSet( "spr_map_impl_screen_block_"..i.."_pointer_1_2", { visible = 0 } )
--          ObjSet( "spr_map_impl_screen_block_"..i.."_pointer_1", { visible = 0 } )
--
--          local aud = {
--            {};
--            { 0.2, 0.6, 1, 1.4, 1.8, 2.2, 2.6, 3 };
--            { 0.2, 0.6, 1, 1.4, 1.8, 2.2, 2.6, 3 };
--            { 0.2, 0.4, 0.7 };
--            { 0.2, 0.6, 1, 1.4, 1.8, 2.2, 2.6, 3, 3.4, 3.7, 4.1, 4.5, 4.8, 5.2 };
--          }
--          if ObjGet( "anm_map_impl_screen_block_"..private.MapBlockPrewiewAnimator_new_block_show_start.."_intro" ) then
--            for i = 1, #aud[private.MapBlockPrewiewAnimator_new_block_show_start] do
--              local sfx = i%2 == 0 and 310 or 311
--              ld.StartTimer( "tmr_MapBlockPrewiewAnimator_new_block_show_start_"..i, aud[private.MapBlockPrewiewAnimator_new_block_show_start][i], function() SoundSfx( "map_step" ) end )
--            end;
--
--            --ObjAnimate( "spr_map_impl_screen_block_"..int.MapBlockPrewiewAnimator_new_block_show_start.."_intro", 8,0,0, "", { 0,0,1, 0.5,0,0 } )
--            --ObjAnimate( "obj_map_impl_screen_block_"..int.MapBlockPrewiewAnimator_new_block_show_start.."_prewiew", 8,0,0, "", { 0,0,1, 0.5,0,0 } )
--            --ObjAnimate( "obj_map_impl_screen_block_"..int.MapBlockPrewiewAnimator_new_block_show_start.."_prewiew", 6,0,0, "", { 0,0,1,1, 0.5,0,0 } )
--
--            ObjSet( "anm_map_impl_screen_block_"..private.MapBlockPrewiewAnimator_new_block_show_start.."_intro", { visible = 1, alp = 1 } )
--            ComplexAnmPlay( "anm_map_impl_screen_block_"..private.MapBlockPrewiewAnimator_new_block_show_start.."_intro", "block"..private.MapBlockPrewiewAnimator_new_block_show_start, function() private.MapBlockPrewiewAnimatorNewBlockEnd(); end )
--          else
            private.MapBlockPrewiewAnimatorNewBlockEnd()
          --end

        end;  
      else
          --ObjSet( "spr_map_impl_screen_block_"..i.."_intro", { visible = 1, alp = 1 } )
          --ObjSet( "spr_map_impl_screen_block_"..i.."_arrow", { visible = 1, alp = 1 } )
          --ObjSet( "spr_map_impl_screen_block_"..i.."_zone", { input = 1 } )
      end;
    else
      local p = ObjGet( "obj_map_impl_screen_block_"..i.."_prewiew" )
      local z = ObjGet( "spr_map_impl_screen_block_"..i.."_zone" )
      if p then
        --ld.LogTrace( "anim "..p.name )
        local l,l1,l2;
        l1 = math.abs( c[1] - z.pos_x )
        l2 = math.abs( c[2] - z.pos_y )
        --l = l1 < l2 and l2 or l1;
        l = (l1^2+l2^2)^0.5
        if z.input
        and z.pos_x > ( c[1] - rv ) and z.pos_x < ( c[1] + rv ) 
        and z.pos_y > ( c[2] - rv ) and z.pos_y < ( c[2] + rv ) 
        and l < rv
        and not fade
        and not private.MapBlockPrewiewAnimator_new_block_show_start
        and not ObjGet( "spr_map_impl_zoom" ).input
        then
          ObjAnimate( p.name, 8,0,0, "", { 0,0,p.alp, t,0,1 } )
        else
          ObjAnimate( p.name, 8,0,0, "", { 0,0,p.alp, t,0,0 } )
        end;

        if  z.pos_x > ( c[1] - rv ) and z.pos_x < ( c[1] + rv ) 
        and z.pos_y > ( c[2] - rv ) and z.pos_y < ( c[2] + rv ) 
        and l < rv
        and not private.MapBlockPrewiewAnimator_new_block_show_start
        then

          --DbgTrace(l);
          if l < rs then l = rs end;
          l = l * 2;
          local sc = rv / l;
          if sc < 0.5 then 
            sc = 0.5
          elseif sc > 1 then
            sc = 1
          end;
          if sc == 1 and p.scale_x < 0.9 then
            private.MapBlockPrewiewAnimate( i, true )
            --ObjAnimate( p.name, 6,0,0, "*int.MapBlockPrewiewAnimate( "..i..", true )", { 0,0,p.scale_x,p.scale_y, t,0,sc,sc } )
          elseif sc < 1 and p.scale_x > 0.9 then
            --ObjAnimate( p.name, 6,0,0, "*int.MapBlockPrewiewAnimate( "..i..", false )", { 0,0,p.scale_x,p.scale_y, t,0,sc,sc } )
            private.MapBlockPrewiewAnimate( i, false )
          end
            ObjAnimate( p.name, 6,0,0, "", { 0,0,p.scale_x,p.scale_y, t,0,sc,sc } )
            --ObjAnimate( p.name, 1,0,0, "", { 0,0,p.pos_y, t,0,-(sc-0.5)*100 + 50 } )
          --end;
        else
          ObjAnimate( p.name, 6,0,0, "", { 0,0,p.scale_x,p.scale_y, t,0,0.5,0.5 } )
          --ObjAnimate( p.name, 1,0,0, "", { 0,0,p.pos_y, t,0,50 } )
        end;
      end
    end;
  end;
  if not fade then
    ld.StartTimer( "tmr_map_block_prewiew_animator", 0.25, function() private.MapBlockPrewiewAnimator() end )
  end;
end;
function private.MapBlockShowZoneEnter( n )
    SetCursor(CURSOR_HAND)
    ObjSet( "spr_map_impl_screen_block_"..n.."_zone", {pos_z = 1 } );
    local o = ObjGet( "obj_map_impl_screen_block_"..n.."_prewiew" )
    ObjAnimate( o.name, 6,0,0, "", { 0,0,o.scale_x,o.scale_y, 0.4,3,1,1 } )
    ObjAnimate( o.name, 8, 0, 0, "", {0,0,o.alp, 0.4,0,1} );

end;
function private.MapBlockShowZoneLeave( n )
    SetCursor(CURSOR_DEFAULT)
    ObjSet( "spr_map_impl_screen_block_"..n.."_zone", {pos_z = 0 } );
    local o = ObjGet( "obj_map_impl_screen_block_"..n.."_prewiew" )
    ObjAnimate( o.name, 6,0,0, "", { 0,0,o.scale_x,o.scale_y, 0.4,3,0.9,0.9 } )
    ObjAnimate( o.name, 8, 0, 0, "", {0,0,o.alp, 0.4,0,0} );
end;

function private.MapBlockPrewiewAnimate( n, wiew )

  local rms = private.MapBlockPrewiewAnimateRMS[n]
--  {
--    {"nearpalace","palace","backyard"};
--    {"nearshop","shop","workroom"};
--    {"nearlibrary","library","secretroom"};
--    {"underground","square"};
--    {"nearcityhall","cityhall","clocktower","street","deck"};
--
--    {"queenpalaceext"};
--    {"gerhouseext"};
--    {"nearqueenpalaceext"};
--    {"kayext"};
--
--    {"backyardxyz"};
--    {"cavexyz"};
--    {"cityxyz"};
--    {"castlexyz"};
--  };
  --rms = rms[n];

  if not rms then
    return;
  end;
  --for k, v in pairs( public.map_rooms ) do
  --  if v[3] == n then table.insert( rms, k ) end
  --end;

  --local rc = 0
  --for i = 1, #rms, 1 do
  --  if not ld.CheckRequirements( { "opn_"..rms[i-rc] } ) then
  --    table.remove( rms, i - rc );
  --    rc = rc + 1;
  --  end;
  --end;
  --for k,v in pairs(public.map_rooms) do
  --  if v[3] == n and ld.CheckRequirements( { "opn_"..k } ) then
  --    table.insert( rms, k );
  --  end;
  --end;
  --DbgTrace( n.." "..tostring( wiew ) );
--  local t = 0.6;
--  for i = 1, #rms do
--      --ObjSet( "spr_map_impl_screen_"..rms[i].."3", { pos_z = i, alp = 1 } )
--    if wiew then
--
--      local wt = t*4;
--      local dt = wt*(i-1);
--      local mt = wt*(#rms);
--      if i > 1 then
--        ObjAttach( "spr_map_impl_screen_"..rms[i].."3", "obj_map_impl_screen_block_"..n.."_prewiew" )
--        local o = ObjGet( "spr_map_impl_screen_"..rms[i].."3" )
--        ObjAnimate( "spr_map_impl_screen_"..rms[i].."3", 8,1,0, "", { 0,0,o.alp, t/2,0,0, dt-t,0,0, dt,0,1, mt,0,1, mt+t,0,0 } )
--      end;
--    else
--      if i > 1 then
--        local o = ObjGet( "spr_map_impl_screen_"..rms[i].."3" )
--        ObjAnimate( "spr_map_impl_screen_"..rms[i].."3", 8,0,0, "", { 0,0,o.alp, t,0,0 } )
--      end;
--    end;
--  end;
end;

function private.MapBlockShow( n )
  
    if private.MapBlockShowLast and private.MapBlockShowLast ~= n then
      ObjDetach( "spr_map_impl_screen_block_"..private.MapBlockShowLast )
    end;
    private.MapBlockShowLast = n

    --DbgTrace( "MapBlockShow "..tostring(n) )
    local count = 0;
    local go_room = "*";
    for k, v in pairs( public.map_rooms ) do
      --ld.LogTrace( obj.." "..k.." "..v[3].." "..n )
      if v[ 3 ] == n then
        if v[ 4 ] then
          go_room = k;
        end;
        if ObjGet( "spr_map_impl_screen_block_"..k ).input then
          count = count + 1;
          if count > 1 then
            break;
          end;
        end;
      end;
    end;

    if count > 1 then

      ObjSet( "obj_map_impl_root", { input = 0 } )
      ObjSet( "spr_map_impl_screen_block_"..n, { input = 1 } )
      local o = ObjGet( "spr_map_impl_screen_block_"..n.."_zone" );
      local t = 0.4;
      --ObjAttach( "spr_map_impl_screen_block_"..n, "int_map_impl_obj_root" )

      
      ObjAttach( "spr_map_impl_zoom", "obj_map_impl_root" )
      ObjAttach( "spr_map_impl_screen_block_"..n, "spr_map_impl_zoom" )

      ObjAnimate( "spr_map_impl_zoom", 8,0,0, "", { 0,0,0, t,0,1 } )
      ObjAnimate( "spr_map_impl_zoom", 6,0,0, "", { 0,0,0,0, t,0,1,1 } )
      ObjAnimate( "spr_map_impl_zoom", 3,0,0, function() ObjSet( "spr_map_impl_zoom", { input = 1 } ); ObjSet( 'obj_map_impl_root', { input = 1 } ) end, { 0,0,o.pos_x,o.pos_y, t,0,0,0 } )

      ObjSet( "obj_map_impl_zoom_close_root", { input = 1 } )

      local objs = { "obj_map_impl_screen_block_close_left","obj_map_impl_screen_block_close_right","obj_map_impl_screen_block_close_top","obj_map_impl_screen_block_close_bottom","spr_map_impl_zoom_close_light" }
      for i = 1, #objs do
        ObjSet( objs[i], { 
          event_mdown = function() private.MapBlockHide(n) end;
          -- = function() private.MapBlockHideMouseEnter("spr_map_impl_zoom_close") end;
          --event_mleave = function() private.MapBlockHideMouseLeave("spr_map_impl_zoom_close") end;
        } )
      end

--      ObjSet( "obj_map_impl_screen_block_close_left", { event_menter = "*int.MapBlockHideMouseEnter( 'spr_map_impl_screen_block_"..n.."_close' )", event_mleave = "*int.MapBlockHideMouseLeave( 'spr_map_impl_screen_block_"..n.."_close' )", event_mdown = "*int.MapBlockHide( 'spr_map_impl_screen_block_"..n.."_close' )" } )
--      ObjSet( "obj_map_impl_screen_block_close_right", { event_menter = "*int.MapBlockHideMouseEnter( 'spr_map_impl_screen_block_"..n.."_close' )", event_mleave = "*int.MapBlockHideMouseLeave( 'spr_map_impl_screen_block_"..n.."_close' )", event_mdown = "*int.MapBlockHide( 'spr_map_impl_screen_block_"..n.."_close' )" } )
--      ObjSet( "obj_map_impl_screen_block_close_top", { event_menter = "*int.MapBlockHideMouseEnter( 'spr_map_impl_screen_block_"..n.."_close' )", event_mleave = "*int.MapBlockHideMouseLeave( 'spr_map_impl_screen_block_"..n.."_close' )", event_mdown = "*int.MapBlockHide( 'spr_map_impl_screen_block_"..n.."_close' )" } )
--      ObjSet( "obj_map_impl_screen_block_close_bottom", { event_menter = "*int.MapBlockHideMouseEnter( 'spr_map_impl_screen_block_"..n.."_close' )", event_mleave = "*int.MapBlockHideMouseLeave( 'spr_map_impl_screen_block_"..n.."_close' )", event_mdown = "*int.MapBlockHide( 'spr_map_impl_screen_block_"..n.."_close' )" } )
--  
    else
      --ld.LogTrace( "go to "..go_room )
      private.MapButtonJump ( go_room );
    end;

end;
function private.MapBlockHide( n )
  ObjSet( "obj_map_impl_root", { input = 0 } )

  local f_end = function()

    ObjSet( "obj_map_impl_root", { input = 1 } )
  end;

  local o = ObjGet( "spr_map_impl_screen_block_"..n.."_zone" );
  local t = 0.4;

  ObjSet( "spr_map_impl_zoom", { input = 0 } )
  ObjAnimate( "spr_map_impl_zoom", 8,0,0, "", { 0,0,1, t,0,0 } )
  ObjAnimate( "spr_map_impl_zoom", 6,0,0, "", { 0,0,1,1, t,0,0,0 } )
  ObjAnimate( "spr_map_impl_zoom", 3,0,0, f_end, { 0,0,0,0, t,0,o.pos_x,o.pos_y } )
end;
function private.MapBlockHideMouseEnter( obj )
  SetCursor(CURSOR_HAND)
  local o = ObjGet( obj.."_light" );
  ObjAnimate( o.name, 8,0,0, "", { 0,0,o.alp, (1-o.alp)/3,0,1 } )
end;
function private.MapBlockHideMouseLeave( obj )
  SetCursor(CURSOR_DEFAULT)
  local o = ObjGet( obj.."_light" );
  ObjAnimate( o.name, 8,0,0, "", { 0,0,o.alp, (o.alp)/3,0,0 } )
end;