-- name=ho_commodeho
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "commodeho" );
  game.relations[ "ho_commodeho" ].exitroom = "rm_cellar";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_commodeho" ] = { type = "win", room = "rm_cellar", zz = "ho_commodeho", zz_gate = "gho_cellar_commodeho" };
 
  local win_commodeho_func = function ()

    if ( cmn.IsEventDone( "win_commodeho" ) ) then
      interface.InventoryItemAdd( "inv_parcel", "spr_commodeho_win" );
      ObjSet( "inv_parcel", {drag=0} );
      ObjDelete( "gho_cellar_commodeho" );
    end;

  end;
  cmn.AddSubscriber( "win_commodeho", win_commodeho_func );
  
  local unmark_aaa = function () 
    ObjSet( "spr_commodeho_aaa", {alp = 1,input=1} );
    ObjDelete("spr_commodeho_aaa_part_1")
    ObjDelete("spr_commodeho_aaa_part_2")
    ObjDelete( "spr_commodeho_aaa_part_2_sh");
  end;
  cmn.AddSubscriber( "commodeho_unmark_aaa", unmark_aaa, "ho_commodeho" );
  
  local start_commodeho_func = function ()
  if not cmn.IsEventDone("win_commodeho") then
    if cmn.IsUnmarkedTask("commodeho","aaa") then -- ящик
      unmark_aaa()
    end   
  end
  end;
  cmn.AddSubscriber( "win_commodeho", start_commodeho_func, "ho_commodeho" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_cellar_env" );

  if ( not cmn.IsEventDone( "opn_commodeho" ) ) then

    cmn.InitHo( "commodeho" );
    cmn.SetMarkedTask( "commodeho", "aaa" );
    cmn.SetMarkedTask( "commodeho", "lll" );
    cmn.SetMarkedTask( "commodeho", "ddd" );
    cmn.SetMarkedTask( "commodeho", "jjj" );
    cmn.SetMarkedTask( "commodeho", "eee" );
    cmn.SetMarkedTask( "commodeho", "hhh" );
    cmn.SetMarkedTask( "commodeho", "fff" );
    cmn.SetMarkedTask( "commodeho", "iii" );
    cmn.SetMarkedTask( "commodeho", "ggg" );
    cmn.SetMarkedTask( "commodeho", "kkk" );


    
    cmn.SetEventDone( "opn_commodeho" );
    ng_global.progress["std"]["win_commodeho"].state = {}
    ng_global.progress["std"]["win_commodeho"].state.open_box = {0,0}
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 1, { { "spr_commodeho_aaa" },{"spr_commodeho_aaa_part_1","spr_commodeho_aaa_part_2"} });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_commodeho_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_commodeho_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 1, { { "spr_commodeho_ddd" },  {"obj_commodeho_openbox_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_commodeho_eee" },  {"obj_commodeho_openbox_2"},{"obj_commodeho_closebox_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 1, { { "spr_commodeho_fff" },  {"obj_commodeho_openbox_2"},{"obj_commodeho_closebox_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 1, { { "spr_commodeho_ggg" },{"obj_commodeho_closebox_1"},{"obj_commodeho_closebox_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 1, { { "spr_commodeho_hhh" },  {"obj_commodeho_openbox_2"},{"obj_commodeho_closebox_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 1, { { "spr_commodeho_iii" },{"obj_commodeho_closebox_1"},{"obj_commodeho_closebox_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 1, { { "spr_commodeho_jjj" },  {"obj_commodeho_openbox_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 1, { { "spr_commodeho_kkk" },  {"obj_commodeho_closebox_1"},{"obj_commodeho_closebox_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 1, { { "spr_commodeho_lll" },  {"obj_commodeho_openbox_1"} } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

  for j = 1, #ng_global.progress["std"]["win_commodeho"].found do

    local name = tostring( ng_global.progress["std"]["win_commodeho"].found[j]["object"] );
   
    ObjDelete( name );

  end;
  private.CheckBox();
  
  port.TapDownTimer(0.7,function() interface.WidgetSetInput(InterfaceWidget_TaskPanel,false); end );
end; 
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();
  interface.WidgetSetInput(InterfaceWidget_TaskPanel,true);

end;
--*********************************************************************************************************************
function public.HoComplete()
  ObjDelete("grm_commodeho_cellar") 
  -- common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_commodeho_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_commodeho_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;
function private.CheckFound(task)

  local check = false
  for i =1,#ng_global.progress["std"]["win_commodeho"].found do 
    if ng_global.progress["std"]["win_commodeho"].found[i].task == task then
      check = true 
      break
    end
  end
  
  return check
end

private.mark_task_arr = {
    {"lll","ddd","jjj"},
    {"eee","fff","hhh"},
    {"iii","ggg","kkk"},
  }
function private.UnmarkTask(box)
  ObjSet( "obj_commodeho_box_"..box, {input = 1} );
  for i=1,#private.mark_task_arr[box] do
    if not private.CheckFound(private.mark_task_arr[box][i]) then
      ObjSet( "spr_commodeho_"..private.mark_task_arr[box][i], {input = 1} );      
      cmn.UnmarkTask( "commodeho", private.mark_task_arr[box][i] );
    end
  end
end
function private.MarkTask(box)
  ObjSet( "obj_commodeho_box_"..box, {input = 0} );
  for i=1,#private.mark_task_arr[box] do
    if not private.CheckFound(private.mark_task_arr[box][i]) then    
      cmn.SetMarkedTask( "commodeho", private.mark_task_arr[box][i] );
      ObjSet( "spr_commodeho_"..private.mark_task_arr[box][i], {input = 0} );
      interface.TaskPanelTaskMark( "commodeho", private.mark_task_arr[box][i] )
    end
  end
end
----------------------------------------------------------------------------

function private.CheckBox()
  local state_box = ng_global.progress["std"]["win_commodeho"].state.open_box
  for i=1,2 do
    ObjSet( "obj_commodeho_box_"..i, {alp = state_box[i]} );
  end
  if state_box[1]==1 then
    private.MarkTask(2)
    private.MarkTask(3)
    private.UnmarkTask(1)
    ObjSet( "obj_commodeho_openbox_2", {input = 0} );    
    ObjSet( "obj_commodeho_openbox_1", {input = 0} );  
  elseif state_box[1]==0 and state_box[2]==1 then 
    ObjSet( "obj_commodeho_openbox_2", {input = 0} );    
    ObjSet( "obj_commodeho_openbox_1", {input = 1} );   
    private.MarkTask(1)
    private.MarkTask(3)  
    private.UnmarkTask(2)      
  elseif state_box[1]==0 and state_box[2]==0 then 
    ObjSet( "obj_commodeho_openbox_2", {input = 1} );    
    ObjSet( "obj_commodeho_openbox_1", {input = 1} );   
    private.MarkTask(1)
    private.MarkTask(2)  
    private.UnmarkTask(3)     
  end
end

function public.open_box(num)
  local f_end=function()
    ld.Lock(0)
    ng_global.progress["std"]["win_commodeho"].state.open_box[num]=1
    private.CheckBox()
  end
  ld.Lock(1)
  ObjAnimate( "obj_commodeho_box_"..num, 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
  SoundSfx( "aud_ho_commode_drawer_open" );
end
----------------------------------------------------------------------------

function public.close_box(num)
  local s = ng_global.progress["std"]["win_commodeho"].state
  local f_end=function()
    ld.Lock(0)
    ng_global.progress["std"]["win_commodeho"].state.open_box[num]=0
    private.CheckBox()
    --if ng_global.progress["std"]["win_commodeho"].state.open_box[1]+ng_global.progress["std"]["win_commodeho"].state.open_box[2] == 0 then
    --  ObjSet( "obj_commodeho_box_3", {input = 1} );
    --  private.UnmarkTask(3)
    --end
  end
  ld.Lock(1)
  ObjAnimate( "obj_commodeho_box_"..num, 8, 0, 0, f_end, {0,0,1, 0.5,0,0} );
  SoundSfx( "aud_ho_commode_drawer_close" );
end


----------------------------------------------------------------------------
function public.unmark_aaa()
  if ApplyObj("spr_commodeho_aaa_part_1","spr_commodeho_aaa_part_2") then 
    local f_end = function()
      ld.Lock(0)
      cmn.UnmarkTask( "commodeho", "aaa" );
      cmn.CallEventHandler( "commodeho_unmark_aaa" );      
    end
    ld.Lock(1)
    ObjDelete("spr_commodeho_aaa_part_2")
    ObjAnimate( "spr_commodeho_aaa", 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
    SoundSfx( "aud_ho_commode_brush" );
  else
    ObjSet("spr_commodeho_aaa_part_2",{pos_z = 5})
    ObjSet( "spr_commodeho_aaa_part_2_sh", {alp = 1} );
    SoundSfx( "aud_ho_commode_put" );
  end
end