-- name=rm_farm
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_farm";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  ld.NoteInit("spr_box_paper_small","spr_box_paper_big","farm_box_note_clk");
  -----------------------------------------------------------------------------------
function private.opn_farm()
  if not ( cmn.IsEventDone( "opn_farm" ) ) then
    cmn.SetEventDone( "opn_farm" );
    cmn.CallEventHandler( "opn_farm" )
    SoundTheme( "aud_adventure2_mus" );
  end;
  level.tutorial_map1.first()
  
end;
--------------------------------------------------------------------
local opn_farm = function() end;
local opn_farm_logic = function() end;
cmn.AddSubscriber( "opn_farm", opn_farm_logic )
cmn.AddSubscriber( "opn_farm", opn_farm, private.room_objname )
--------------------------------------------------------------------------------------------

function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "granny1" then
    if count_txt == 1 then
      --ld.AnimPlay( "anm_lemannmanorext_volfganext1_character", "func_cop_dialog_lvl4", "" )
    elseif count_txt == 2 then

    elseif count_txt == 3 then
      ld.Lock(1);
      ld.AnimPlay( "anm_farm_granny1_character", "give_puzzlepiece1", function() ld.Lock(0); end )
      SoundSfx( "aud_get_to_us" );
    elseif count_txt == 4 then  
      ObjSet( "spr_farm_puzzlepiece1", {visible = 1} );
      ld.AnimPlay( "anm_farm_granny1_character", "hand", "" )
      cmn.CallEventHandler( "get_puzzlepiece1" )
    end;  
  end
  if dlg_name == "granny2" then
    if count_txt == 1 then
      --ld.AnimPlay( "anm_lemannmanorext_volfganext1_character", "func_cop_dialog_lvl4", "" )
    elseif count_txt == 2 then
      ld.Lock(1);
      ld.AnimPlay( "anm_farm_granny2_character", "give_badge",  function() ld.Lock(0); end )
      SoundSfx( "aud_get_to_us" );
    elseif count_txt == 3 then
      ObjSet( "spr_farm_badge", {visible = 1} );
      ld.AnimPlay( "anm_farm_granny2_character", "hand", "" )
      cmn.CallEventHandler( "get_badge" )
    elseif count_txt == 4 then  

    end;  
  end
end;

--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_farm_granny1" ] = { type = "click", use_place = "gfx_farm_dlg_farm_granny1_zone", room = "rm_farm" };

private.dlg_farm_granny1_logic = function()
  ObjSet( "spr_farm_puzzlepiece1", { visible = 1, input = 1 } )
  ObjSet( "gfx_farm_yarn_zone", {input = 1, visible = 1} );
  ObjSet( "gzz_farm_colliepuppy", {input = 1, visible = 1} );
  ObjSet( "gzz_farm_box", {input = 1, visible = 1} );
  ObjSet( "gzz_farm_fence", {input = 1, visible = 1} );
  ObjSet( "gzz_farm_logs", {input = 1, visible = 1} );
  ObjSet( "gzz_farm_ruraldoor", {input = 1, visible = 1} );
end;
private.dlg_farm_granny1_beg = function()
  ObjDelete( "gfx_farm_dlg_farm_granny1_zone" );
end;
private.dlg_farm_granny1_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_farm_granny1", private.dlg_farm_granny1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_farm_granny1", private.dlg_farm_granny1_end, private.room_objname );
cmn.AddSubscriber( "dlg_farm_granny1", private.dlg_farm_granny1_logic );
cmn.AddSubscriber( "dlg_farm_granny1_beg", private.dlg_farm_granny1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_farm_granny1_end", private.dlg_farm_granny1_end, private.room_objname );
cmn.AddSubscriber( "dlg_farm_granny1_end", private.dlg_farm_granny1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_farm_granny1( obj )

  local func_end = function()
    cmn.SetEventDone( "dlg_farm_granny1" );
    cmn.CallEventHandler( "dlg_farm_granny1_end" );
    cmn.SetEventDone( "get_puzzlepiece1" );
    common_impl.Lock(0);
    ld.ShowBbt("after_dlg_granny1")
  end;

  -- cmn.CallEventHandler( "dlg_farm_granny1_beg" );
 
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  function public.dlg_farm_granny1_end()
    ObjSet( "dlg_farm_granny1", {bake=1} );
    if ObjGetRelations( "inv_puzzlepiece1" ).parent == "level_inv_hub" then
      ObjSet( "spr_farm_puzzlepiece1", {visible = 1} );
      cmn.CallEventHandler( "get_puzzlepiece1");      
    end
    common_impl.Lock(1);
    func_end()
  end
  
  cmn.CallEventHandler( "dlg_farm_granny1_beg" );
  
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  common_impl.dialog_character_loc = "anm_farm_anm_oldcowgirl_loc_anm"
  common_impl.continue_visible = false
  --func_end()
  common_impl.Start( "granny1", 4, nil, nil, true, "dlg_farm_granny1_end",{"aud_granny_1_voc","aud_granny_2_voc","aud_granny_3_voc"});    

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_puzzlepiece1" ] = { type = "get", get_obj = "spr_farm_puzzlepiece1", room = "rm_farm" };

private.get_puzzlepiece1_logic = function()
  
end;
private.get_puzzlepiece1_inv = function()
  interface.InventoryItemAdd("inv_puzzlepiece1","spr_farm_puzzlepiece1");
end;
private.get_puzzlepiece1_beg = function()
  ObjDelete("gfx_farm_puzzlepiece1")
end;
private.get_puzzlepiece1_end = function()
  
end;

cmn.AddSubscriber( "get_puzzlepiece1", private.get_puzzlepiece1_inv );
cmn.AddSubscriber( "get_puzzlepiece1", private.get_puzzlepiece1_beg, private.room_objname );
cmn.AddSubscriber( "get_puzzlepiece1", private.get_puzzlepiece1_end, private.room_objname );
cmn.AddSubscriber( "get_puzzlepiece1", private.get_puzzlepiece1_logic );
--------------------------------------------------------------------
function public.get_puzzlepiece1()
  cmn.SetEventDone( "get_puzzlepiece1" );
  cmn.CallEventHandler( "get_puzzlepiece1" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_yarn" ] = { type = "use", inv_obj = "inv_yarn", use_place = "gfx_farm_yarn_zone", room = "rm_farm" };

private.use_yarn_logic = function()
  ObjSet( "gfx_farm_dlg_farm_granny2_zone", { visible = 1, input = 1 } )

end;
private.use_yarn_inv = function()
  common_impl.ProcessMultiUseAll("yarn", "yarn")
end;
private.use_yarn_beg = function()
  ObjDelete( "gfx_farm_yarn_zone" );
end;
private.use_yarn_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_yarn", private.use_yarn_inv );
cmn.AddSubscriber( "use_yarn", private.use_yarn_beg, private.room_objname );
cmn.AddSubscriber( "use_yarn", private.use_yarn_end, private.room_objname );
cmn.AddSubscriber( "use_yarn", private.use_yarn_logic );
cmn.AddSubscriber( "use_yarn_inv", private.use_yarn_inv, private.room_objname );
cmn.AddSubscriber( "use_yarn_beg", private.use_yarn_beg, private.room_objname );
cmn.AddSubscriber( "use_yarn_end", private.use_yarn_end, private.room_objname );
cmn.AddSubscriber( "use_yarn_end", private.use_yarn_logic );
--------------------------------------------------------------------------------------------
function public.use_yarn( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    --  cmn.SetEventDone( "use_yarn" );
    -- cmn.CallEventHandler( "use_yarn_end" );
    common_impl.Lock(0);
    public.dlg_farm_granny2();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_yarn_inv" );
  cmn.CallEventHandler( "use_yarn_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_yarn_granny" );

 ld.StartTimer( 0.5, func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_farm_granny2" ] = { type = "click", use_place = "gfx_farm_dlg_farm_granny2_zone", room = "rm_farm" };

private.dlg_farm_granny2_logic = function()
  ObjSet( "spr_farm_badge", { visible = 1, input = 1 } )

end;
private.dlg_farm_granny2_beg = function()
  ObjDelete( "gfx_farm_dlg_farm_granny2_zone" );
end;
private.dlg_farm_granny2_end = function()
  ObjDelete("anm_farm_anm_oldcowgirl_loc_anm");
  ObjSet( "obj_farm_mail_clk_zone", {input = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_farm_granny2", private.dlg_farm_granny2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_farm_granny2", private.dlg_farm_granny2_end, private.room_objname );
cmn.AddSubscriber( "dlg_farm_granny2", private.dlg_farm_granny2_logic );
cmn.AddSubscriber( "dlg_farm_granny2_beg", private.dlg_farm_granny2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_farm_granny2_end", private.dlg_farm_granny2_end, private.room_objname );
cmn.AddSubscriber( "dlg_farm_granny2_end", private.dlg_farm_granny2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_farm_granny2( obj )

  local func_end = function()
    cmn.SetEventDone( "use_yarn" );
    cmn.CallEventHandler( "use_yarn_end" );
    cmn.SetEventDone( "dlg_farm_granny2" );
    cmn.CallEventHandler( "dlg_farm_granny2_end" );
    cmn.SetEventDone( "get_badge" );
    common_impl.Lock(0);
    ld.ShowBbt("after_dlg_granny2")
  end;

  cmn.CallEventHandler( "dlg_farm_granny2_beg" );
  
  function public.dlg_farm_granny2_end()
    ObjSet( "dlg_farm_granny2", {bake=1} );
    if ObjGetRelations( "inv_badge" ).parent == "level_inv_hub" then
      ObjSet( "spr_farm_badge", {visible = 1} );
      cmn.CallEventHandler( "get_badge");      
    end
    common_impl.Lock(1);
    func_end()
  end
  
  cmn.CallEventHandler( "dlg_farm_granny2_beg" );
  
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  -- common_impl.dialog_character_loc = "anm_farm_anm_oldcowgirl_loc_anm"
  ObjAnimate( "anm_farm_anm_oldcowgirl_loc_anm", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
  common_impl.continue_visible = false
  --func_end()
  common_impl.Start( "granny2", 3, nil, nil, true, "dlg_farm_granny2_end",{"aud_granny_4_voc","aud_granny_5_voc"});    

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_badge" ] = { type = "get", get_obj = "spr_farm_badge", room = "rm_farm" };

private.get_badge_logic = function()
  
end;
private.get_badge_inv = function()
  interface.InventoryItemAdd("inv_badge","spr_farm_badge");
  ObjSet( "inv_badge", { drag = 0 } );
end;
private.get_badge_beg = function()
  ObjDelete("gfx_farm_badge")
end;
private.get_badge_end = function()
  
end;

cmn.AddSubscriber( "get_badge", private.get_badge_inv );
cmn.AddSubscriber( "get_badge", private.get_badge_beg, private.room_objname );
cmn.AddSubscriber( "get_badge", private.get_badge_end, private.room_objname );
cmn.AddSubscriber( "get_badge", private.get_badge_logic );
--------------------------------------------------------------------
function public.get_badge()
  cmn.SetEventDone( "get_badge" );
  cmn.CallEventHandler( "get_badge" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_ruraldoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_rivet2" ] = { type = "get", get_obj = "spr_ruraldoor_rivet2", room = "rm_farm", zz = "zz_ruraldoor", zz_gate = "gzz_farm_ruraldoor" };

private.get_rivet2_logic = function()
  
end;
private.get_rivet2_inv = function()
  interface.InventoryItemAdd("inv_rivet2","spr_ruraldoor_rivet2");
end;
private.get_rivet2_beg = function()
  ObjDelete("gfx_ruraldoor_rivet2")
end;
private.get_rivet2_end = function()
  if common_impl.ZzCompleteCheck("get_rivet2") then ObjSet( common_impl.hint["get_rivet2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_ruraldoor_sh1_rivet2");
  ObjDelete("spr_ruraldoor_sh_rivet2");
end;

cmn.AddSubscriber( "get_rivet2", private.get_rivet2_inv );
cmn.AddSubscriber( "get_rivet2", private.get_rivet2_beg, private.room_objname );
cmn.AddSubscriber( "get_rivet2", private.get_rivet2_end, private.room_objname );
cmn.AddSubscriber( "get_rivet2", private.get_rivet2_logic );
--------------------------------------------------------------------
function public.get_rivet2()
  cmn.SetEventDone( "get_rivet2" );
  cmn.CallEventHandler( "get_rivet2" );
  if common_impl.ZzCompleteCheck("get_rivet2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_housekey_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_housekey' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_door_ruraldoor" );
  ld.AnimPlay( "anm_ruraldoor_anim_door", "idle_door", func_end )
end;  
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_housekey" ] = { type = "use", inv_obj = "inv_housekey", use_place = "gfx_ruraldoor_housekey_zone", room = "rm_farm", zz = "zz_ruraldoor", zz_gate = "gzz_farm_ruraldoor" };

private.use_housekey_logic = function()
 -- ObjSet( "grm_farm_ruralhouse", { visible = 1, input = 1 } )
  ObjSet( "gfx_ruraldoor_housekey_clk_zone", {input=1, visible=1} );
  
end;
private.use_housekey_inv = function()
  common_impl.ProcessMultiUseAll("housekey", "housekey")
end;
private.use_housekey_beg = function()
  ObjDelete( "gfx_ruraldoor_housekey_zone" );
end;
private.use_housekey_end = function()
  if common_impl.ZzCompleteCheck("use_housekey") then ObjSet( common_impl.hint["use_housekey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ruraldoor_anim_door", {animfunc="use_key", frame=999} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_housekey", private.use_housekey_inv );
cmn.AddSubscriber( "use_housekey", private.use_housekey_beg, private.room_objname );
cmn.AddSubscriber( "use_housekey", private.use_housekey_end, private.room_objname );
cmn.AddSubscriber( "use_housekey", private.use_housekey_logic );
cmn.AddSubscriber( "use_housekey_inv", private.use_housekey_inv, private.room_objname );
cmn.AddSubscriber( "use_housekey_beg", private.use_housekey_beg, private.room_objname );
cmn.AddSubscriber( "use_housekey_end", private.use_housekey_end, private.room_objname );
cmn.AddSubscriber( "use_housekey_end", private.use_housekey_logic );
--------------------------------------------------------------------------------------------
function public.use_housekey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_housekey" );
    cmn.CallEventHandler( "use_housekey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_housekey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_housekey_inv" );
  cmn.CallEventHandler( "use_housekey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ruraldoor_anim_door", "use_key", func_end );
  SoundSfx( "aud_use_key_ruraldoor" );
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_housekey" ] = { type = "click", use_place = "gfx_ruraldoor_housekey_clk_zone", room = "rm_farm", zz = "zz_ruraldoor", zz_gate = "gzz_farm_ruraldoor" };

private.clk_housekey_logic = function()
  ObjSet( "gfx_ruraldoor_housekey2_clk_zone", { visible = 1, input = 1 } )

end;
private.clk_housekey_beg = function()
  ObjDelete( "gfx_ruraldoor_housekey_clk_zone" );
end;
private.clk_housekey_end = function()
  ObjSet( "anm_ruraldoor_anim_door", {animfunc="use_key1", frame=999} );
  if common_impl.ZzCompleteCheck("clk_housekey") then ObjSet( common_impl.hint["clk_housekey"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_housekey", private.clk_housekey_beg, private.room_objname );
cmn.AddSubscriber( "clk_housekey", private.clk_housekey_end, private.room_objname );
cmn.AddSubscriber( "clk_housekey", private.clk_housekey_logic );
cmn.AddSubscriber( "clk_housekey_beg", private.clk_housekey_beg, private.room_objname );
cmn.AddSubscriber( "clk_housekey_end", private.clk_housekey_end, private.room_objname );
cmn.AddSubscriber( "clk_housekey_end", private.clk_housekey_logic );
--------------------------------------------------------------------------------------------
function public.clk_housekey( obj )

  local func_end = function()
    cmn.SetEventDone( "clk_housekey" );
    cmn.CallEventHandler( "clk_housekey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_housekey") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_housekey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ruraldoor_anim_door", "use_key1", func_end );
  SoundSfx( "aud_touch_key_ruraldoor" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_housekey2" ] = { type = "click", use_place = "gfx_ruraldoor_housekey2_clk_zone", room = "rm_farm", zz = "zz_ruraldoor", zz_gate = "gzz_farm_ruraldoor" };

private.clk_housekey2_logic = function()
  ObjSet( "grm_farm_ruralhouse", { visible = 1, input = 1 } )
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_farm_ruralhouse_focus");
    end;
end;
private.clk_housekey2_beg = function()
  ObjDelete( "gfx_ruraldoor_housekey2_clk_zone" );
end;
private.clk_housekey2_end = function()
  ObjSet( "anm_ruraldoor_anim_door", {animfunc="use_key2", frame=999} );
   if common_impl.ZzCompleteCheck("clk_housekey2") then ObjSet( common_impl.hint["clk_housekey2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_farm_door_open", {visible = 1} ); 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_housekey2", private.clk_housekey2_beg, private.room_objname );
cmn.AddSubscriber( "clk_housekey2", private.clk_housekey2_end, private.room_objname );
cmn.AddSubscriber( "clk_housekey2", private.clk_housekey2_logic );
cmn.AddSubscriber( "clk_housekey2_beg", private.clk_housekey2_beg, private.room_objname );
cmn.AddSubscriber( "clk_housekey2_end", private.clk_housekey2_end, private.room_objname );
cmn.AddSubscriber( "clk_housekey2_end", private.clk_housekey2_logic );
--------------------------------------------------------------------------------------------
function public.clk_housekey2( obj )

  local func_end = function()
    cmn.SetEventDone( "clk_housekey2" );
    cmn.CallEventHandler( "clk_housekey2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_housekey2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_housekey2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ruraldoor_anim_door", "use_key2", function() ld.StartTimer( 0.5, func_end ); end );
  SoundSfx( "aud_touch_ruraldoor" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_logs *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_wateringcan" ] = { type = "get", get_obj = "spr_logs_wateringcan", room = "rm_farm", zz = "zz_logs", zz_gate = "gzz_farm_logs" };

private.get_wateringcan_logic = function()
  ObjSet( "gfx_logs_saw_zone", {input = 1, visible = 1} );
end;
private.get_wateringcan_inv = function()
  interface.InventoryItemAdd("inv_wateringcan","spr_logs_wateringcan");
end;
private.get_wateringcan_beg = function()
  ObjDelete("gfx_logs_wateringcan")
end;
private.get_wateringcan_end = function()
  if common_impl.ZzCompleteCheck("get_wateringcan") then ObjSet( common_impl.hint["get_wateringcan"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_logs_wateringcan_sh");
  ObjDelete("spr_farm_tr_wateringcan");
end;

cmn.AddSubscriber( "get_wateringcan", private.get_wateringcan_inv );
cmn.AddSubscriber( "get_wateringcan", private.get_wateringcan_beg, private.room_objname );
cmn.AddSubscriber( "get_wateringcan", private.get_wateringcan_end, private.room_objname );
cmn.AddSubscriber( "get_wateringcan", private.get_wateringcan_logic );
--------------------------------------------------------------------
function public.get_wateringcan()
  cmn.SetEventDone( "get_wateringcan" );
  cmn.CallEventHandler( "get_wateringcan" );
  if common_impl.ZzCompleteCheck("get_wateringcan") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dullpruner" ] = { type = "use", inv_obj = "inv_dullpruner", use_place = "gfx_logs_dullpruner_zone", room = "rm_farm", zz = "zz_logs", zz_gate = "gzz_farm_logs" };

private.use_dullpruner_logic = function()
 -- ObjSet( "spr_logs_pruner", { visible = 1, input = 1 } )
  ObjSet( "gfx_logs_dullpruner_clk_zone", {input = 1, visible = 1} );
end;
private.use_dullpruner_inv = function()
  common_impl.ProcessMultiUseAll("dullpruner", "dullpruner")
end;
private.use_dullpruner_beg = function()
  ObjDelete( "gfx_logs_dullpruner_zone" );
end;
private.use_dullpruner_end = function()
  if common_impl.ZzCompleteCheck("use_dullpruner") then ObjSet( common_impl.hint["use_dullpruner"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_logs_anm_pruner", {animfunc = "use_pruner1", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dullpruner", private.use_dullpruner_inv );
cmn.AddSubscriber( "use_dullpruner", private.use_dullpruner_beg, private.room_objname );
cmn.AddSubscriber( "use_dullpruner", private.use_dullpruner_end, private.room_objname );
cmn.AddSubscriber( "use_dullpruner", private.use_dullpruner_logic );
cmn.AddSubscriber( "use_dullpruner_inv", private.use_dullpruner_inv, private.room_objname );
cmn.AddSubscriber( "use_dullpruner_beg", private.use_dullpruner_beg, private.room_objname );
cmn.AddSubscriber( "use_dullpruner_end", private.use_dullpruner_end, private.room_objname );
cmn.AddSubscriber( "use_dullpruner_end", private.use_dullpruner_logic );
--------------------------------------------------------------------------------------------
function public.use_dullpruner( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dullpruner" );
    cmn.CallEventHandler( "use_dullpruner_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dullpruner") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dullpruner_inv" );
  cmn.CallEventHandler( "use_dullpruner_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_logs_anm_pruner", "use_pruner", func_end );
  SoundSfx( "aud_use_pruner_grindstone" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_dullpruner" ] = { type = "click", use_place = "gfx_logs_dullpruner_clk_zone", room = "rm_farm" , zz = "zz_logs", zz_gate = "gzz_farm_logs"};

private.clk_dullpruner_logic = function()
--  ObjSet( "spr_logs_pruner", { visible = 1, input = 1 } )
 -- ObjSet( "gfx_logs_dullpruner_clk_zone", {input = 1, visible = 1} );
end;
private.clk_dullpruner_beg = function()
  ObjDelete( "gfx_logs_dullpruner_clk_zone" );
end;
private.clk_dullpruner_end = function()
  if common_impl.ZzCompleteCheck("clk_dullpruner") then ObjSet( common_impl.hint["clk_dullpruner"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_logs_anm_pruner", {animfunc = "end_pruner", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_dullpruner", private.clk_dullpruner_beg, private.room_objname );
cmn.AddSubscriber( "clk_dullpruner", private.clk_dullpruner_end, private.room_objname );
cmn.AddSubscriber( "clk_dullpruner", private.clk_dullpruner_logic );
cmn.AddSubscriber( "clk_dullpruner_beg", private.clk_dullpruner_beg, private.room_objname );
cmn.AddSubscriber( "clk_dullpruner_end", private.clk_dullpruner_end, private.room_objname );
cmn.AddSubscriber( "clk_dullpruner_end", private.clk_dullpruner_logic );
--------------------------------------------------------------------------------------------
function public.clk_dullpruner( obj )

  local func_end = function()
    cmn.SetEventDone( "clk_dullpruner" );
    cmn.CallEventHandler( "clk_dullpruner_end" );
    ObjSet( "spr_logs_pruner", {visible = 1} );
    cmn.SetEventDone( "get_pruner" );
    cmn.CallEventHandler( "get_pruner" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_dullpruner") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "clk_dullpruner_beg" );
  common_impl.Lock(1);

   ld.AnimPlay( "anm_logs_anm_pruner", "use_pruner1", func_end );
   SoundSfx( "aud_touch_grindstone" );
  --func_end()

end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "get_pruner" ] = { type = "get", get_obj = "spr_logs_pruner", room = "rm_farm", zz = "zz_logs", zz_gate = "gzz_farm_logs" };

private.get_pruner_logic = function()
  
end;
private.get_pruner_inv = function()
  interface.InventoryItemAdd("inv_pruner","spr_logs_pruner");
end;
private.get_pruner_beg = function()
  ObjDelete("gfx_logs_pruner")
end;
private.get_pruner_end = function()
  if common_impl.ZzCompleteCheck("get_pruner") then ObjSet( common_impl.hint["get_pruner"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_pruner", private.get_pruner_inv );
cmn.AddSubscriber( "get_pruner", private.get_pruner_beg, private.room_objname );
cmn.AddSubscriber( "get_pruner", private.get_pruner_end, private.room_objname );
cmn.AddSubscriber( "get_pruner", private.get_pruner_logic );
--------------------------------------------------------------------
function public.get_pruner()
  cmn.SetEventDone( "get_pruner" );
  cmn.CallEventHandler( "get_pruner" );
  if common_impl.ZzCompleteCheck("get_pruner") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_housekeylogs" ] = { type = "click", use_place = "gfx_logs_housekeylogs_clk_zone", room = "rm_farm" , zz = "zz_logs", zz_gate = "gzz_farm_logs"};

private.clk_housekeylogs_logic = function()
  ObjSet( "gfx_logs_cane_zone", {input = 1, visible = 1} );
end;
private.clk_housekeylogs_beg = function()
  ObjDelete( "gfx_logs_housekeylogs_clk_zone" );
end;
private.clk_housekeylogs_end = function()
  if common_impl.ZzCompleteCheck("clk_housekeylogs") then ObjSet( common_impl.hint["clk_housekeylogs"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_logs_anm_cane", {animfunc = "use_cane", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_housekeylogs", private.clk_housekeylogs_beg, private.room_objname );
cmn.AddSubscriber( "clk_housekeylogs", private.clk_housekeylogs_end, private.room_objname );
cmn.AddSubscriber( "clk_housekeylogs", private.clk_housekeylogs_logic );
cmn.AddSubscriber( "clk_housekeylogs_beg", private.clk_housekeylogs_beg, private.room_objname );
cmn.AddSubscriber( "clk_housekeylogs_end", private.clk_housekeylogs_end, private.room_objname );
cmn.AddSubscriber( "clk_housekeylogs_end", private.clk_housekeylogs_logic );
--------------------------------------------------------------------------------------------
function public.clk_housekeylogs( obj )

  local func_end = function()
    cmn.SetEventDone( "clk_housekeylogs" );
    cmn.CallEventHandler( "clk_housekeylogs_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_housekeylogs")
    if common_impl.ZzCompleteCheck("clk_housekeylogs") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "clk_housekeylogs_beg" );
  common_impl.Lock(1);

   ld.AnimPlay( "anm_logs_anm_cane", "click_kay", func_end );
   SoundSfx( "aud_touch_key_logs" );
  --func_end()

end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_cane_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_cane' );
  end;
  
  ld.Lock(1);
  -- ld.AnimPlay( "anm_logs_anm_cane", "click_log", func_end );
  func_end();
end;  


common_impl.hint[ "use_cane" ] = { type = "use", inv_obj = "inv_cane", use_place = "gfx_logs_cane_zone", room = "rm_farm", zz = "zz_logs", zz_gate = "gzz_farm_logs" };

private.use_cane_logic = function()
 -- ObjSet( "spr_logs_housekey", { visible = 1, input = 1 } )
 -- ObjSet( "gfx_logs_saw_zone", {input = 1, visible = 1} );
end;
private.use_cane_inv = function()
  common_impl.ProcessMultiUseAll("cane", "cane")
end;
private.use_cane_beg = function()
  ObjDelete( "gfx_logs_cane_zone" );
end;
private.use_cane_end = function()
  if common_impl.ZzCompleteCheck("use_cane") then ObjSet( common_impl.hint["use_cane"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_logs_anm_cane", {animfunc = "trash", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cane", private.use_cane_inv );
cmn.AddSubscriber( "use_cane", private.use_cane_beg, private.room_objname );
cmn.AddSubscriber( "use_cane", private.use_cane_end, private.room_objname );
cmn.AddSubscriber( "use_cane", private.use_cane_logic );
cmn.AddSubscriber( "use_cane_inv", private.use_cane_inv, private.room_objname );
cmn.AddSubscriber( "use_cane_beg", private.use_cane_beg, private.room_objname );
cmn.AddSubscriber( "use_cane_end", private.use_cane_end, private.room_objname );
cmn.AddSubscriber( "use_cane_end", private.use_cane_logic );
--------------------------------------------------------------------------------------------
function public.use_cane( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cane" );
    cmn.CallEventHandler( "use_cane_end" );
    ObjSet( "spr_logs_housekey", { visible = 1});
    cmn.SetEventDone( "get_housekey" );
    cmn.CallEventHandler( "get_housekey" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cane") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cane_inv" );
  cmn.CallEventHandler( "use_cane_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_logs_anm_cane", "use_cane", func_end );
  SoundSfx( "aud_use_cane_logs" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_housekey" ] = { type = "get", get_obj = "spr_logs_housekey", room = "rm_farm", zz = "zz_logs", zz_gate = "gzz_farm_logs" };

private.get_housekey_logic = function()
  
end;
private.get_housekey_inv = function()
  interface.InventoryItemAdd("inv_housekey","spr_logs_housekey");
end;
private.get_housekey_beg = function()
  ObjDelete("gfx_logs_housekey")
end;
private.get_housekey_end = function()
  if common_impl.ZzCompleteCheck("get_housekey") then ObjSet( common_impl.hint["get_housekey"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_housekey", private.get_housekey_inv );
cmn.AddSubscriber( "get_housekey", private.get_housekey_beg, private.room_objname );
cmn.AddSubscriber( "get_housekey", private.get_housekey_end, private.room_objname );
cmn.AddSubscriber( "get_housekey", private.get_housekey_logic );
--------------------------------------------------------------------
function public.get_housekey()
  
  cmn.SetEventDone( "get_housekey" );
  cmn.CallEventHandler( "get_housekey" );
  if common_impl.ZzCompleteCheck("get_housekey") then ld.CloseSubRoom() end;
  
  if port.isPortable()==1 then
      iOS_RateMe();
    end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_saw" ] = { type = "use", inv_obj = "inv_saw", use_place = "gfx_logs_saw_zone", room = "rm_farm", zz = "zz_logs", zz_gate = "gzz_farm_logs" };

private.use_saw_logic = function()
  ObjSet( "spr_logs_boards", { visible = 1, input = 1 } )

end;
private.use_saw_inv = function()
  common_impl.ProcessMultiUseAll("saw", "saw")
end;
private.use_saw_beg = function()
  ObjDelete( "gfx_logs_saw_zone" );
end;
private.use_saw_end = function()
  if common_impl.ZzCompleteCheck("use_saw") then ObjSet( common_impl.hint["use_saw"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete( "anm_logs_anm_boards");
  ObjSet( "spr_logs_boards_sh", {visible = 1} );
  ObjDelete("spr_farm_log1");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_saw", private.use_saw_inv );
cmn.AddSubscriber( "use_saw", private.use_saw_beg, private.room_objname );
cmn.AddSubscriber( "use_saw", private.use_saw_end, private.room_objname );
cmn.AddSubscriber( "use_saw", private.use_saw_logic );
cmn.AddSubscriber( "use_saw_inv", private.use_saw_inv, private.room_objname );
cmn.AddSubscriber( "use_saw_beg", private.use_saw_beg, private.room_objname );
cmn.AddSubscriber( "use_saw_end", private.use_saw_end, private.room_objname );
cmn.AddSubscriber( "use_saw_end", private.use_saw_logic );
--------------------------------------------------------------------------------------------
function public.use_saw( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_saw" );
    cmn.CallEventHandler( "use_saw_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_saw") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_saw_inv" );
  cmn.CallEventHandler( "use_saw_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_logs_anm_boards", "use_saw", func_end );
  SoundSfx( "aud_use_saw_logs" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_boards" ] = { type = "get", get_obj = "spr_logs_boards", room = "rm_farm", zz = "zz_logs", zz_gate = "gzz_farm_logs" };

private.get_boards_logic = function()
  
end;
private.get_boards_inv = function()
  interface.InventoryItemAdd("inv_boards","spr_logs_boards");
end;
private.get_boards_beg = function()
  ObjDelete("gfx_logs_boards")
end;
private.get_boards_end = function()
  if common_impl.ZzCompleteCheck("get_boards") then ObjSet( common_impl.hint["get_boards"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_logs_boards_sh");
end;

cmn.AddSubscriber( "get_boards", private.get_boards_inv );
cmn.AddSubscriber( "get_boards", private.get_boards_beg, private.room_objname );
cmn.AddSubscriber( "get_boards", private.get_boards_end, private.room_objname );
cmn.AddSubscriber( "get_boards", private.get_boards_logic );
--------------------------------------------------------------------
function public.get_boards()
  cmn.SetEventDone( "get_boards" );
  cmn.CallEventHandler( "get_boards" );
  if common_impl.ZzCompleteCheck("get_boards") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_fence *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_brokenpruner" ] = { type = "get", get_obj = "spr_fence_brokenpruner", room = "rm_farm", zz = "zz_fence", zz_gate = "gzz_farm_fence" };

private.get_brokenpruner_logic = function()
  ObjSet( "gfx_fence_puzzlepiece1_zone", {input = 1, visible = 1} );
  ObjSet( "gfx_fence_puzzlepiece2_zone", {input = 1, visible = 1} );
end;
private.get_brokenpruner_inv = function()
  interface.InventoryItemAdd("inv_brokenpruner","spr_fence_brokenpruner");
  ObjSet( "inv_brokenpruner", { drag = 0 } );
end;
private.get_brokenpruner_beg = function()
  ObjDelete("gfx_fence_brokenpruner")
end;
private.get_brokenpruner_end = function()
  if common_impl.ZzCompleteCheck("get_brokenpruner") then ObjSet( common_impl.hint["get_brokenpruner"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_fence_sh_brokenpruner");
end;

cmn.AddSubscriber( "get_brokenpruner", private.get_brokenpruner_inv );
cmn.AddSubscriber( "get_brokenpruner", private.get_brokenpruner_beg, private.room_objname );
cmn.AddSubscriber( "get_brokenpruner", private.get_brokenpruner_end, private.room_objname );
cmn.AddSubscriber( "get_brokenpruner", private.get_brokenpruner_logic );
--------------------------------------------------------------------
function public.get_brokenpruner()
  cmn.SetEventDone( "get_brokenpruner" );
  cmn.CallEventHandler( "get_brokenpruner" );
  if common_impl.ZzCompleteCheck("get_brokenpruner") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_puzzlepiece1" ] = { type = "use", inv_obj = "inv_puzzlepiece1", use_place = "gfx_fence_puzzlepiece1_zone", room = "rm_farm", zz = "zz_fence", zz_gate = "gzz_farm_fence" };

private.use_puzzlepiece1_logic = function()
  if ld.CheckRequirements( {"use_puzzlepiece1","use_puzzlepiece2"} ) then
  ObjSet( "gmg_farm_fencepuzzle", { visible = 1, input = 1 } )
  end;

end;
private.use_puzzlepiece1_inv = function()
  common_impl.ProcessMultiUseAll("puzzlepiece1", "puzzlepiece1")
end;
private.use_puzzlepiece1_beg = function()
  ObjDelete( "gfx_fence_puzzlepiece1_zone" );
end;
private.use_puzzlepiece1_end = function()
  if common_impl.ZzCompleteCheck("use_puzzlepiece1") then ObjSet( common_impl.hint["use_puzzlepiece1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_fence_anm_fence_part_1",{animfunc="use_c2_1", frame=999, pos_z=4});
  if ld.CheckRequirements( {"use_puzzlepiece1","use_puzzlepiece2"} ) then
     ObjDelete("anm_fence_anm_fence_list");
     ObjDelete("spr_farm_tr_list");
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_puzzlepiece1", private.use_puzzlepiece1_inv );
cmn.AddSubscriber( "use_puzzlepiece1", private.use_puzzlepiece1_beg, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece1", private.use_puzzlepiece1_end, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece1", private.use_puzzlepiece1_logic );
cmn.AddSubscriber( "use_puzzlepiece1_inv", private.use_puzzlepiece1_inv, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece1_beg", private.use_puzzlepiece1_beg, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece1_end", private.use_puzzlepiece1_end, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece1_end", private.use_puzzlepiece1_logic );
--------------------------------------------------------------------------------------------
function public.use_puzzlepiece1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_puzzlepiece1" );
    cmn.CallEventHandler( "use_puzzlepiece1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_puzzlepiece1") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_puzzlepiece2","use_puzzlepiece1"} ) then
      cmn.GotoRoom("mg_fencepuzzle");
    end;  
  end;

  local func_preend = function()
    if  ld.CheckRequirements({"use_puzzlepiece2"}) then 
      SoundSfx( "aud_dorian_portrait_fall" );
      ld.AnimPlay("anm_fence_anm_fence_list","list",func_end);
    else 
      func_end();
    end;  
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_puzzlepiece1_inv" );
  cmn.CallEventHandler( "use_puzzlepiece1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_fence_anm_fence_part_1", "use_c2_1", func_preend );
  SoundSfx( "aud_use_hexagon_fencepuzzle" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_puzzlepiece2" ] = { type = "use", inv_obj = "inv_puzzlepiece2", use_place = "gfx_fence_puzzlepiece2_zone", room = "rm_farm", zz = "zz_fence", zz_gate = "gzz_farm_fence" };

private.use_puzzlepiece2_logic = function()
  if ld.CheckRequirements( {"use_puzzlepiece2","use_puzzlepiece1"} ) then
  ObjSet( "gmg_farm_fencepuzzle", { visible = 1, input = 1 } )
  end;

end;
private.use_puzzlepiece2_inv = function()
  common_impl.ProcessMultiUseAll("puzzlepiece2", "puzzlepiece2")
end;
private.use_puzzlepiece2_beg = function()
  ObjDelete( "gfx_fence_puzzlepiece2_zone" );
end;
private.use_puzzlepiece2_end = function()
  if common_impl.ZzCompleteCheck("use_puzzlepiece2") then ObjSet( common_impl.hint["use_puzzlepiece2"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_puzzlepiece1","use_puzzlepiece2"} ) then
     ObjDelete("anm_fence_anm_fence_list");
      ObjDelete("spr_farm_tr_list");
  end;  
  ObjSet("anm_fence_anm_fence_part_2",{animfunc="use_c14_2", frame=999, pos_z=4}); 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_puzzlepiece2", private.use_puzzlepiece2_inv );
cmn.AddSubscriber( "use_puzzlepiece2", private.use_puzzlepiece2_beg, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece2", private.use_puzzlepiece2_end, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece2", private.use_puzzlepiece2_logic );
cmn.AddSubscriber( "use_puzzlepiece2_inv", private.use_puzzlepiece2_inv, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece2_beg", private.use_puzzlepiece2_beg, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece2_end", private.use_puzzlepiece2_end, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece2_end", private.use_puzzlepiece2_logic );
--------------------------------------------------------------------------------------------
function public.use_puzzlepiece2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_puzzlepiece2" );
    cmn.CallEventHandler( "use_puzzlepiece2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_puzzlepiece2") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_puzzlepiece2","use_puzzlepiece1"} ) then
      cmn.GotoRoom("mg_fencepuzzle");
    end;  
  end;

  local func_preend = function()
  if  ld.CheckRequirements({"use_puzzlepiece1"}) then 
      SoundSfx( "aud_dorian_portrait_fall" );
      ld.AnimPlay("anm_fence_anm_fence_list","list",func_end);
    else 
      func_end();
    end;  
  end;
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_puzzlepiece2_inv" );
  cmn.CallEventHandler( "use_puzzlepiece2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_fence_anm_fence_part_2", "use_c14_2", func_preend );
  SoundSfx( "aud_use_hexagon_fencepuzzle" )
 -- func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_box *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_amulethorse1" ] = { type = "get", get_obj = "spr_box_amulethorse1", room = "rm_farm", zz = "zz_box", zz_gate = "gzz_farm_box" };

private.get_amulethorse1_logic = function()
  
end;
private.get_amulethorse1_inv = function()
  interface.InventoryItemAdd("inv_amulethorse","spr_box_amulethorse1",function() level_inv.ProcessGetAmulethorseAll( "get_amulethorse1" ) end);
end;
private.get_amulethorse1_beg = function()
  ObjDelete("gfx_box_amulethorse1")
end;
private.get_amulethorse1_end = function()
  if common_impl.ZzCompleteCheck("get_amulethorse1") then ObjSet( common_impl.hint["get_amulethorse1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_box_sh_amulethorse1");
  ObjDelete("spr_farm_tr_amulethorse1");
end;

cmn.AddSubscriber( "get_amulethorse1", private.get_amulethorse1_inv );
cmn.AddSubscriber( "get_amulethorse1", private.get_amulethorse1_beg, private.room_objname );
cmn.AddSubscriber( "get_amulethorse1", private.get_amulethorse1_end, private.room_objname );
cmn.AddSubscriber( "get_amulethorse1", private.get_amulethorse1_logic );
--------------------------------------------------------------------
function public.get_amulethorse1()
  cmn.SetEventDone( "get_amulethorse1" );
  cmn.CallEventHandler( "get_amulethorse1" );
  if common_impl.ZzCompleteCheck("get_amulethorse1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_nailpuller_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_nailpuller' )
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_boards_box" );
  ld.AnimPlay( "anm_box_anm", "idle_bred", func_end )
end;  



common_impl.hint[ "use_nailpuller" ] = { type = "use", inv_obj = "inv_nailpuller", use_place = "gfx_box_nailpuller_zone", room = "rm_farm", zz = "zz_box", zz_gate = "gzz_farm_box" };

private.use_nailpuller_logic = function()
  ObjSet( "spr_box_amulethorse1", { visible = 1, input = 1 } )
  ObjSet( "spr_box_wool", { visible = 1, input = 1 } )
  ObjSet( "gfx_box_wool", {visible = 1} );
  ObjSet( "gfx_box_amulethorse1", {visible = 1} );
end;
private.use_nailpuller_inv = function()
  common_impl.ProcessMultiUseAll("nailpuller", "nailpuller")
end;
private.use_nailpuller_beg = function()
  ObjDelete( "gfx_box_nailpuller_zone" );
end;
private.use_nailpuller_end = function()
  if common_impl.ZzCompleteCheck("use_nailpuller") then ObjSet( common_impl.hint["use_nailpuller"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_box_anm", {animfunc="end_nailpuller", frame=0} );
  ObjDelete("spr_farm_tr_bred");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_nailpuller", private.use_nailpuller_inv );
cmn.AddSubscriber( "use_nailpuller", private.use_nailpuller_beg, private.room_objname );
cmn.AddSubscriber( "use_nailpuller", private.use_nailpuller_end, private.room_objname );
cmn.AddSubscriber( "use_nailpuller", private.use_nailpuller_logic );
cmn.AddSubscriber( "use_nailpuller_inv", private.use_nailpuller_inv, private.room_objname );
cmn.AddSubscriber( "use_nailpuller_beg", private.use_nailpuller_beg, private.room_objname );
cmn.AddSubscriber( "use_nailpuller_end", private.use_nailpuller_end, private.room_objname );
cmn.AddSubscriber( "use_nailpuller_end", private.use_nailpuller_logic );
--------------------------------------------------------------------------------------------
function public.use_nailpuller( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_nailpuller" );
    cmn.CallEventHandler( "use_nailpuller_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_nailpuller") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_nailpuller_inv" );
  cmn.CallEventHandler( "use_nailpuller_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_box_anm", "use_nailpuller1", func_end );
  SoundSfx( "aud_use_nailpuller_box" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_glassshard3" ] = { type = "get", get_obj = "spr_box_glassshard3", room = "rm_farm", zz = "zz_box", zz_gate = "gzz_farm_box" };

private.get_glassshard3_logic = function()
  
end;
private.get_glassshard3_inv = function()
  interface.InventoryItemAdd("inv_glassshard","spr_box_glassshard3",function() level_inv.ProcessGetGlassshardAll( "get_glassshard3" ) end);
end;
private.get_glassshard3_beg = function()
  ObjDelete("gfx_box_glassshard3")
end;
private.get_glassshard3_end = function()
  if common_impl.ZzCompleteCheck("get_glassshard3") then ObjSet( common_impl.hint["get_glassshard3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_box_sh_glassshard3");
  ObjDelete("spr_farm_tr_glassshard3");
end;

cmn.AddSubscriber( "get_glassshard3", private.get_glassshard3_inv );
cmn.AddSubscriber( "get_glassshard3", private.get_glassshard3_beg, private.room_objname );
cmn.AddSubscriber( "get_glassshard3", private.get_glassshard3_end, private.room_objname );
cmn.AddSubscriber( "get_glassshard3", private.get_glassshard3_logic );
--------------------------------------------------------------------
function public.get_glassshard3()
  cmn.SetEventDone( "get_glassshard3" );
  cmn.CallEventHandler( "get_glassshard3" );
  if common_impl.ZzCompleteCheck("get_glassshard3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wool" ] = { type = "get", get_obj = "spr_box_wool", room = "rm_farm", zz = "zz_box", zz_gate = "gzz_farm_box" };

private.get_wool_logic = function()
  
end;
private.get_wool_inv = function()
  interface.InventoryItemAdd("inv_wool","spr_box_wool");
end;
private.get_wool_beg = function()
  ObjDelete("gfx_box_wool")
end;
private.get_wool_end = function()
  if common_impl.ZzCompleteCheck("get_wool") then ObjSet( common_impl.hint["get_wool"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_box_sh_wool");
  ObjDelete("spr_farm_tr_wool");
end;

cmn.AddSubscriber( "get_wool", private.get_wool_inv );
cmn.AddSubscriber( "get_wool", private.get_wool_beg, private.room_objname );
cmn.AddSubscriber( "get_wool", private.get_wool_end, private.room_objname );
cmn.AddSubscriber( "get_wool", private.get_wool_logic );
--------------------------------------------------------------------
function public.get_wool()
  cmn.SetEventDone( "get_wool" );
  cmn.CallEventHandler( "get_wool" );
  if common_impl.ZzCompleteCheck("get_wool") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_colliepuppy *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_toypuppy_zone_clk()
  local func_end = function()
    common_impl.ShowBbt( 'need_toypuppy' );
    ld.Lock(0);
    ObjSet( "anm_colliepuppy_anm", {animfunc = "statics", frame = 0, playing = 1 } );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_dog_farm" );
  ld.AnimPlay( "anm_colliepuppy_anm", "idle_colli", func_end )
end;  
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_toypuppy" ] = { type = "use", inv_obj = "inv_toypuppy", use_place = "gfx_colliepuppy_toypuppy_zone", room = "rm_farm", zz = "zz_colliepuppy", zz_gate = "gzz_farm_colliepuppy" };

private.use_toypuppy_logic = function()
  ObjSet( "spr_colliepuppy_net", { visible = 1, input = 1 } )
  ObjSet( "spr_colliepuppy_tube2", { visible = 0, input = 1 } )
  ObjSet( "gfx_colliepuppy_tube2", {visible = 1} );
end;
private.use_toypuppy_inv = function()
  common_impl.ProcessMultiUseAll("toypuppy", "toypuppy")
end;
private.use_toypuppy_beg = function()
  ObjDelete( "gfx_colliepuppy_toypuppy_zone" );
end;
private.use_toypuppy_end = function()
  if common_impl.ZzCompleteCheck("use_toypuppy") then ObjSet( common_impl.hint["use_toypuppy"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_colliepuppy_anm", {animfunc = "end_tybe2", frame = 0 } );
  ObjSet( "spr_colliepuppy_sh_net", {visible = 1} );
  ObjSet( "anm_farm_anim_colli", {animfunc = "anim_colli_sit", frame = 0, playing = 1 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_toypuppy", private.use_toypuppy_inv );
cmn.AddSubscriber( "use_toypuppy", private.use_toypuppy_beg, private.room_objname );
cmn.AddSubscriber( "use_toypuppy", private.use_toypuppy_end, private.room_objname );
cmn.AddSubscriber( "use_toypuppy", private.use_toypuppy_logic );
cmn.AddSubscriber( "use_toypuppy_inv", private.use_toypuppy_inv, private.room_objname );
cmn.AddSubscriber( "use_toypuppy_beg", private.use_toypuppy_beg, private.room_objname );
cmn.AddSubscriber( "use_toypuppy_end", private.use_toypuppy_end, private.room_objname );
cmn.AddSubscriber( "use_toypuppy_end", private.use_toypuppy_logic );
--------------------------------------------------------------------------------------------
function public.use_toypuppy( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_toypuppy" );
    cmn.CallEventHandler( "use_toypuppy_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_toypuppy") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_toypuppy_inv" );
  cmn.CallEventHandler( "use_toypuppy_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_colliepuppy_anm", "use_toy", func_end );
  SoundSfx( "aud_paper_toy" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_net" ] = { type = "get", get_obj = "spr_colliepuppy_net", room = "rm_farm", zz = "zz_colliepuppy", zz_gate = "gzz_farm_colliepuppy" };

private.get_net_logic = function()
  
end;
private.get_net_inv = function()
  interface.InventoryItemAdd("inv_net","spr_colliepuppy_net");
end;
private.get_net_beg = function()
  ObjDelete("gfx_colliepuppy_net")
end;
private.get_net_end = function()
  if common_impl.ZzCompleteCheck("get_net") then ObjSet( common_impl.hint["get_net"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_colliepuppy_sh_net");
  ObjDelete("spr_farm_tr_net");
end;

cmn.AddSubscriber( "get_net", private.get_net_inv );
cmn.AddSubscriber( "get_net", private.get_net_beg, private.room_objname );
cmn.AddSubscriber( "get_net", private.get_net_end, private.room_objname );
cmn.AddSubscriber( "get_net", private.get_net_logic );
--------------------------------------------------------------------
function public.get_net()
  cmn.SetEventDone( "get_net" );
  cmn.CallEventHandler( "get_net" );
  if common_impl.ZzCompleteCheck("get_net") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tube2" ] = { type = "get", get_obj = "spr_colliepuppy_tube2", room = "rm_farm", zz = "zz_colliepuppy", zz_gate = "gzz_farm_colliepuppy" };

private.get_tube2_logic = function()
  
end;
private.get_tube2_inv = function()
  interface.InventoryItemAdd("inv_tube","spr_colliepuppy_tube2",function() level_inv.ProcessGetTubeAll( "get_tube2" ) end);
end;
private.get_tube2_beg = function()
  ObjDelete("gfx_colliepuppy_tube2")
end;
private.get_tube2_end = function()
  if common_impl.ZzCompleteCheck("get_tube2") then ObjSet( common_impl.hint["get_tube2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_colliepuppy_anm", {animfunc = "end_net", frame = 0 } );
  ObjDelete("spr_farm_tr_tube");
end;

cmn.AddSubscriber( "get_tube2", private.get_tube2_inv );
cmn.AddSubscriber( "get_tube2", private.get_tube2_beg, private.room_objname );
cmn.AddSubscriber( "get_tube2", private.get_tube2_end, private.room_objname );
cmn.AddSubscriber( "get_tube2", private.get_tube2_logic );
--------------------------------------------------------------------
function public.get_tube2()
  ObjSet( "spr_colliepuppy_tube2", {visible = 1} );
  cmn.SetEventDone( "get_tube2" );
  cmn.CallEventHandler( "get_tube2" );
  if common_impl.ZzCompleteCheck("get_tube2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_fencepuzzle_for_farm = function()
    if ld.CheckRequirements( {"win_fencepuzzle"} ) then
      ObjSet( "gmg_farm_fencepuzzle", {input = 0, visible = 0} );
      ObjSet( "spr_farm_zz_open", {visible = 1} );
    end
  end;
  cmn.AddSubscriber("win_fencepuzzle", win_fencepuzzle_for_farm, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_farm();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_farm_env" );
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_colliepuppy" );
  function zz_colliepuppy.Open()
  end;
  function zz_colliepuppy.PreOpen()
  end;
  function zz_colliepuppy.PreClose()
  end;
  function zz_colliepuppy.Close()
  end;

  subroom.Define( "zz_box" );
  function zz_box.Open()
  end;
  function zz_box.PreOpen()
  end;
  function zz_box.PreClose()
  end;
  function zz_box.Close()
  end;

  subroom.Define( "zz_fence" );
  function zz_fence.Open()
  end;
  function zz_fence.PreOpen()
  end;
  function zz_fence.PreClose()
  end;
  function zz_fence.Close()
  end;

  subroom.Define( "zz_logs" );
  function zz_logs.Open()
  end;
  function zz_logs.PreOpen()
  end;
  function zz_logs.PreClose()
  end;
  function zz_logs.Close()
  end;

  subroom.Define( "zz_ruraldoor" );
  function zz_ruraldoor.Open()
  end;
  function zz_ruraldoor.PreOpen()
  end;
  function zz_ruraldoor.PreClose()
  end;
  function zz_ruraldoor.Close()
  end;
  
end;
--*********************************************************************************************************************

function public.farm_mail_zone_clk()
  local func_end= function()
     ObjSet( "obj_farm_mail_clk_zone", {input = 1} );
  end;
  
  ObjSet( "obj_farm_mail_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_farm_anim_click_1", "anim_click_1", func_end )
end;  

local farm_pumpkin_count=0;

function public.farm_pumpkin_zone_clk()
  local func_end= function()
     if farm_pumpkin_count~=4 then 
       ObjSet( "obj_farm_pumpkin_clk_zone", {input = 1} );
     end;  
  end;
  
  SoundSfx( "aud_touch_pumpkin" ); 
  ObjSet( "obj_farm_pumpkin_clk_zone", {input = 0} );
  farm_pumpkin_count=farm_pumpkin_count+1;
  ld.AnimPlay( "anm_farm_anim_pumpkin_click_"..farm_pumpkin_count, "pumpkin_click_"..farm_pumpkin_count, func_end )
end;  

------------------------------------------------------------------------------------------------------------------------