-- name=rm_neartower
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_neartower";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
   private.vid_neartower_horse_root =  {"vid_neartower_horse_static_1","vid_neartower_horse_static_2","vid_neartower_horse_static_3"};
  
  ld.VidStaticInit( 
      private.vid_neartower_horse_root,                                                        --оъект видео
      { "rm_neartower", "zz_basrelief", "zz_towerentrance", "zz_dray","zz_ground","zz_slab"}, --к чему относится объект
      {"aud_horse_static_1_77","aud_horse_static_2_32","aud_horse_static_3_40"},        --SFX
      { 3, 6 },                                                                            --рандом запуска от до
      false,                                                              --прогрес по которому статика будет играть
      false,      --прогресс по которому статика перестаёт играть  
      "opn_neartower"
  );
  --------------------------------------------------------------------------------------------
function private.opn_neartower()
  if not ( cmn.IsEventDone( "opn_neartower" ) ) then
    cmn.SetEventDone( "opn_neartower" );
    cmn.CallEventHandler( "opn_neartower" )
    ld.ShowBbt("opn_neartower")
    SoundTheme( "aud_adventure2_mus" );
  end;
end;
--------------------------------------------------------------------
local opn_neartower = function() end;
local opn_neartower_logic = function() end;
cmn.AddSubscriber( "opn_neartower", opn_neartower_logic )
cmn.AddSubscriber( "opn_neartower", opn_neartower, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------
--common_impl.hint[ "get_amulethorse3" ] = { type = "get", get_obj = "spr_neartower_amulethorse3", room = "rm_neartower" };
--
--private.get_amulethorse3_logic = function()
--  
--end;
--private.get_amulethorse3_inv = function()
--  interface.InventoryItemAdd("inv_amulethorse","spr_neartower_amulethorse3",function() level_inv.ProcessGetAmulethorseAll( "get_amulethorse3" ) end);
--end;
--private.get_amulethorse3_beg = function()
--  ObjDelete("gfx_neartower_amulethorse3")
--end;
--private.get_amulethorse3_end = function()
--  
--end;
--
--cmn.AddSubscriber( "get_amulethorse3", private.get_amulethorse3_inv );
--cmn.AddSubscriber( "get_amulethorse3", private.get_amulethorse3_beg, private.room_objname );
--cmn.AddSubscriber( "get_amulethorse3", private.get_amulethorse3_end, private.room_objname );
--cmn.AddSubscriber( "get_amulethorse3", private.get_amulethorse3_logic );
----------------------------------------------------------------------
--function public.get_amulethorse3()
--  cmn.SetEventDone( "get_amulethorse3" );
--  cmn.CallEventHandler( "get_amulethorse3" );
--end
----------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_slab *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
function private.opn_neartowerslab()
  if not ( cmn.IsEventDone( "opn_neartowerslab" ) ) then
    cmn.SetEventDone( "opn_neartowerslab" );
    cmn.CallEventHandler( "opn_neartowerslab" )
    ld.ShowBbt("opn_neartower_slab")
  end;
end;
--------------------------------------------------------------------
local opn_neartowerslab = function() end;
local opn_neartowerslab_logic = function() end;
cmn.AddSubscriber( "opn_neartowerslab", opn_neartowerslab_logic )
cmn.AddSubscriber( "opn_neartowerslab", opn_neartowerslab, private.room_objname )
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_veil" ] = { type = "get", get_obj = "spr_slab_veil", room = "rm_neartower", zz = "zz_slab", zz_gate = "gzz_neartower_slab" };

private.get_veil_logic = function()
  
end;
private.get_veil_inv = function()
  interface.InventoryItemAdd("inv_veil","spr_slab_veil");
end;
private.get_veil_beg = function()
  ObjDelete("gfx_slab_veil")
end;
private.get_veil_end = function()
  if common_impl.ZzCompleteCheck("get_veil") then ObjSet( common_impl.hint["get_veil"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_slab_sh_veil");
  ObjDelete("spr_neartower_tr_veil");
end;

cmn.AddSubscriber( "get_veil", private.get_veil_inv );
cmn.AddSubscriber( "get_veil", private.get_veil_beg, private.room_objname );
cmn.AddSubscriber( "get_veil", private.get_veil_end, private.room_objname );
cmn.AddSubscriber( "get_veil", private.get_veil_logic );
--------------------------------------------------------------------
function public.get_veil()
  cmn.SetEventDone( "get_veil" );
  cmn.CallEventHandler( "get_veil" );
  if common_impl.ZzCompleteCheck("get_veil") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_amuletcross()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_amuletcross' );
  end;
  if ld.CheckRequirements( {"get_veil"} ) then
    ld.Lock(1);
    SoundSfx( "aud_touch_right_stab" );
    ld.AnimPlay( "anm_slab_anim_slab_right", "idle_plit2", func_end );
  else
    common_impl.ShowBbt( 'need_amuletcross' );
  end
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "use_amuletcross" ] = { type = "use", inv_obj = "inv_amuletcross", use_place = "gfx_slab_amuletcross_zone", room = "rm_neartower", zz = "zz_slab", zz_gate = "gzz_neartower_slab" };

private.use_amuletcross_logic = function()
  ObjSet( "spr_slab_wing1", { input = 1 } )

end;
private.use_amuletcross_inv = function()
  common_impl.ProcessMultiUseAll("amuletcross", "amuletcross")
end;
private.use_amuletcross_beg = function()
  ObjDelete( "gfx_slab_amuletcross_zone" );
end;
private.use_amuletcross_end = function()
  if common_impl.ZzCompleteCheck("use_amuletcross") then ObjSet( common_impl.hint["use_amuletcross"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_slab_anim_slab_right", {animfunc = "end_wing", frame = 0 } );
  ObjSet( "gfx_slab_wing1", {visible = 1} );
  ObjSet( "spr_neartower_cover1", {pos_x = 300, pos_y = 483} );
  ObjSet( "spr_neartower_tr_amuletcross", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletcross", private.use_amuletcross_inv );
cmn.AddSubscriber( "use_amuletcross", private.use_amuletcross_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletcross", private.use_amuletcross_end, private.room_objname );
cmn.AddSubscriber( "use_amuletcross", private.use_amuletcross_logic );
cmn.AddSubscriber( "use_amuletcross_inv", private.use_amuletcross_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletcross_beg", private.use_amuletcross_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletcross_end", private.use_amuletcross_end, private.room_objname );
cmn.AddSubscriber( "use_amuletcross_end", private.use_amuletcross_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletcross( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletcross" );
    cmn.CallEventHandler( "use_amuletcross_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletcross") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletcross_inv" );
  cmn.CallEventHandler( "use_amuletcross_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_slab_anim_slab_right", "use_krest", func_end );
  SoundSfx( "aud_use_cross_right_slab" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wing1" ] = { type = "get", get_obj = "spr_slab_wing1", room = "rm_neartower", zz = "zz_slab", zz_gate = "gzz_neartower_slab" };

private.get_wing1_logic = function()
  
end;
private.get_wing1_inv = function()
  interface.InventoryItemAdd("inv_wing1","spr_slab_wing1");
end;
private.get_wing1_beg = function()
  ObjDelete("gfx_slab_wing1")
end;
private.get_wing1_end = function()
  if common_impl.ZzCompleteCheck("get_wing1") then ObjSet( common_impl.hint["get_wing1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_slab_anim_slab_right", {animfunc = "end_plit_krest", frame = 0 } );
  ObjDelete("spr_neartower_tr_wing1");
end;

cmn.AddSubscriber( "get_wing1", private.get_wing1_inv );
cmn.AddSubscriber( "get_wing1", private.get_wing1_beg, private.room_objname );
cmn.AddSubscriber( "get_wing1", private.get_wing1_end, private.room_objname );
cmn.AddSubscriber( "get_wing1", private.get_wing1_logic );
--------------------------------------------------------------------
function public.get_wing1()
  ObjSet( "spr_slab_wing1", { visible = 1 } )
  cmn.SetEventDone( "get_wing1" );
  cmn.CallEventHandler( "get_wing1" );
  if common_impl.ZzCompleteCheck("get_wing1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_amulethexagon()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_amulethexagon' )
  end;
  ld.Lock(1);
  SoundSfx( "aud_touch_left_stab" );
  ld.AnimPlay( "anm_slab_anim_slab_left", "idle_plit_star", func_end );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "use_amulethexagon" ] = { type = "use", inv_obj = "inv_amulethexagon", use_place = "gfx_slab_amulethexagon_zone", room = "rm_neartower", zz = "zz_slab", zz_gate = "gzz_neartower_slab" };

private.use_amulethexagon_logic = function()
  ObjSet( "spr_slab_scepter", {  input = 1 } )

end;
private.use_amulethexagon_inv = function()
  common_impl.ProcessMultiUseAll("amulethexagon", "amulethexagon")
end;
private.use_amulethexagon_beg = function()
  ObjDelete( "gfx_slab_amulethexagon_zone" );
end;
private.use_amulethexagon_end = function()
  if common_impl.ZzCompleteCheck("use_amulethexagon") then ObjSet( common_impl.hint["use_amulethexagon"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_slab_anim_slab_left", {animfunc = "end_scepter", frame = 0 } );
  ObjSet( "gfx_slab_scepter", {  visible = 1 } )
  ObjSet( "spr_neartower_cover2", {pos_x = 245, pos_y = 574} );
  ObjSet( "spr_neartower_tr_amulethexagon1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amulethexagon", private.use_amulethexagon_inv );
cmn.AddSubscriber( "use_amulethexagon", private.use_amulethexagon_beg, private.room_objname );
cmn.AddSubscriber( "use_amulethexagon", private.use_amulethexagon_end, private.room_objname );
cmn.AddSubscriber( "use_amulethexagon", private.use_amulethexagon_logic );
cmn.AddSubscriber( "use_amulethexagon_inv", private.use_amulethexagon_inv, private.room_objname );
cmn.AddSubscriber( "use_amulethexagon_beg", private.use_amulethexagon_beg, private.room_objname );
cmn.AddSubscriber( "use_amulethexagon_end", private.use_amulethexagon_end, private.room_objname );
cmn.AddSubscriber( "use_amulethexagon_end", private.use_amulethexagon_logic );
--------------------------------------------------------------------------------------------
function public.use_amulethexagon( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amulethexagon" );
    cmn.CallEventHandler( "use_amulethexagon_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amulethexagon") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amulethexagon_inv" );
  cmn.CallEventHandler( "use_amulethexagon_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_slab_anim_slab_left", "use_star", func_end );
  SoundSfx( "aud_use_star_left_slab" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scepter" ] = { type = "get", get_obj = "spr_slab_scepter", room = "rm_neartower", zz = "zz_slab", zz_gate = "gzz_neartower_slab" };

private.get_scepter_logic = function()
  
end;
private.get_scepter_inv = function()
  interface.InventoryItemAdd("inv_scepter","spr_slab_scepter");
end;
private.get_scepter_beg = function()
  ObjDelete("gfx_slab_scepter")
end;
private.get_scepter_end = function()
  if common_impl.ZzCompleteCheck("get_scepter") then ObjSet( common_impl.hint["get_scepter"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_slab_anim_slab_left", {animfunc = "end_plit_star", frame = 0 } );
  ObjDelete("spr_neartower_tr_scepter");
end;

cmn.AddSubscriber( "get_scepter", private.get_scepter_inv );
cmn.AddSubscriber( "get_scepter", private.get_scepter_beg, private.room_objname );
cmn.AddSubscriber( "get_scepter", private.get_scepter_end, private.room_objname );
cmn.AddSubscriber( "get_scepter", private.get_scepter_logic );
--------------------------------------------------------------------
function public.get_scepter()
    ObjSet( "spr_slab_scepter", {  visible = 1 } )
  cmn.SetEventDone( "get_scepter" );
  cmn.CallEventHandler( "get_scepter" );
  if common_impl.ZzCompleteCheck("get_scepter") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_ground *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
function public.idle_clk_cover()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_shovel' )
  end;
  ld.Lock(1);
  ld.AnimPlay( "anm_ground_anm", "cklick_cover", func_end );
  SoundSfx( "aud_touch_chest_ground" );
end;

common_impl.hint[ "get_glassshard4" ] = { type = "get", get_obj = "spr_ground_glassshard4", room = "rm_neartower", zz = "zz_ground", zz_gate = "gzz_neartower_ground" };

private.get_glassshard4_logic = function()

end;
private.get_glassshard4_inv = function()
  interface.InventoryItemAdd("inv_glassshard","spr_ground_glassshard4",function() level_inv.ProcessGetGlassshardAll( "get_glassshard4" ) end);
end;
private.get_glassshard4_beg = function()
  ObjDelete("gfx_ground_glassshard4")
end;
private.get_glassshard4_end = function()
  if common_impl.ZzCompleteCheck("get_glassshard4") then ObjSet( common_impl.hint["get_glassshard4"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_glassshard4", private.get_glassshard4_inv );
cmn.AddSubscriber( "get_glassshard4", private.get_glassshard4_beg, private.room_objname );
cmn.AddSubscriber( "get_glassshard4", private.get_glassshard4_end, private.room_objname );
cmn.AddSubscriber( "get_glassshard4", private.get_glassshard4_logic );
--------------------------------------------------------------------
function public.get_glassshard4()
  cmn.SetEventDone( "get_glassshard4" );
  cmn.CallEventHandler( "get_glassshard4" );
  if common_impl.ZzCompleteCheck("get_glassshard4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_shovel" ] = { type = "use", inv_obj = "inv_shovel", use_place = "gfx_ground_shovel_zone", room = "rm_neartower", zz = "zz_ground", zz_gate = "gzz_neartower_ground" };

private.use_shovel_logic = function()
  ObjSet( "gho_neartower_groundho", { visible = 1, input = 1, active = 1 } )

end;
private.use_shovel_inv = function()
  common_impl.ProcessMultiUseAll("shovel", "shovel")
end;
private.use_shovel_beg = function()
  ObjDelete( "gfx_ground_shovel_zone" );
end;
private.use_shovel_end = function()
  if common_impl.ZzCompleteCheck("use_shovel") then ObjSet( common_impl.hint["use_shovel"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_neartower_tr_ho_groundho", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_shovel", private.use_shovel_inv );
cmn.AddSubscriber( "use_shovel", private.use_shovel_beg, private.room_objname );
cmn.AddSubscriber( "use_shovel", private.use_shovel_end, private.room_objname );
cmn.AddSubscriber( "use_shovel", private.use_shovel_logic );
cmn.AddSubscriber( "use_shovel_inv", private.use_shovel_inv, private.room_objname );
cmn.AddSubscriber( "use_shovel_beg", private.use_shovel_beg, private.room_objname );
cmn.AddSubscriber( "use_shovel_end", private.use_shovel_end, private.room_objname );
cmn.AddSubscriber( "use_shovel_end", private.use_shovel_logic );
--------------------------------------------------------------------------------------------
function public.use_shovel( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_shovel" );
    cmn.CallEventHandler( "use_shovel_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_shovel") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_shovel_inv" );
  cmn.CallEventHandler( "use_shovel_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ground_anm", "use_shovel", function()  ld.AnimPlay( "anm_ground_anm", "cover_open",  func_end ); end  );
  SoundSfx( "aud_use_shovel_ground" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_dray *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_coin_dray" ] = { type = "use", inv_obj = "inv_coin", use_place = "gfx_dray_coin_dray_zone", room = "rm_neartower", zz = "zz_dray", zz_gate = "gzz_neartower_dray" };

private.use_coin_dray_logic = function()
  ObjSet( "spr_dray_wheeldistaff", { visible = 1, input = 1 } )

end;
private.use_coin_dray_inv = function()
  common_impl.ProcessMultiUseAll("coin", "coin_dray")
end;
private.use_coin_dray_beg = function()
  ObjDelete( "gfx_dray_coin_dray_zone" );
end;
private.use_coin_dray_end = function()
  if common_impl.ZzCompleteCheck("use_coin_dray") then ObjSet( common_impl.hint["use_coin_dray"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("obj_dray_idle_clk_zone");
  ObjDelete("spr_dray_screw");
  ObjDelete("vid_dray_vid_coin_cart_32");
  ObjSet( "spr_neartower_tr_cart", {visible = 1} );
  ObjDelete("spr_neartower_cart");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_coin_dray", private.use_coin_dray_inv );
cmn.AddSubscriber( "use_coin_dray", private.use_coin_dray_beg, private.room_objname );
cmn.AddSubscriber( "use_coin_dray", private.use_coin_dray_end, private.room_objname );
cmn.AddSubscriber( "use_coin_dray", private.use_coin_dray_logic );
cmn.AddSubscriber( "use_coin_dray_inv", private.use_coin_dray_inv, private.room_objname );
cmn.AddSubscriber( "use_coin_dray_beg", private.use_coin_dray_beg, private.room_objname );
cmn.AddSubscriber( "use_coin_dray_end", private.use_coin_dray_end, private.room_objname );
cmn.AddSubscriber( "use_coin_dray_end", private.use_coin_dray_logic );
--------------------------------------------------------------------------------------------
function public.use_coin_dray( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_coin_dray" );
    cmn.CallEventHandler( "use_coin_dray_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_coin_dray") then ld.CloseSubRoom() end;
    if common_impl.ZzCompleteCheck("get_wheeldistaff") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  ObjSet( "spr_dray_screw", {visible = 0} );
  cmn.CallEventHandler( "use_coin_dray_inv" );
  cmn.CallEventHandler( "use_coin_dray_beg" );
  common_impl.Lock(1);

  local func_preend = function()
    ld.AnimPlay( "anm_dray_anm", "cart", func_end )
    cmn.SetEventDone("get_wheeldistaff"); 
    cmn.CallEventHandler( "get_wheeldistaff" );
  end

  ObjAttach("vid_dray_vid_coin_cart_32","zz_dray");
  VidPlay( "vid_dray_vid_coin_cart_32", function() func_preend() end  );
  SoundSfx( "aud_use_coin_dray" );
  --func_preend()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wheeldistaff" ] = { type = "get", get_obj = "spr_dray_wheeldistaff", room = "rm_neartower", zz = "zz_dray", zz_gate = "gzz_neartower_dray" };

private.get_wheeldistaff_logic = function()
  
end;
private.get_wheeldistaff_inv = function()
  interface.InventoryItemAdd("inv_wheeldistaff","spr_dray_wheeldistaff");
end;
private.get_wheeldistaff_beg = function()
  ObjDelete("gfx_dray_wheeldistaff")
end;
private.get_wheeldistaff_end = function()
  if common_impl.ZzCompleteCheck("get_wheeldistaff") then ObjSet( common_impl.hint["get_wheeldistaff"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_dray_sh_wheeldistaff");
end;

cmn.AddSubscriber( "get_wheeldistaff", private.get_wheeldistaff_inv );
cmn.AddSubscriber( "get_wheeldistaff", private.get_wheeldistaff_beg, private.room_objname );
cmn.AddSubscriber( "get_wheeldistaff", private.get_wheeldistaff_end, private.room_objname );
cmn.AddSubscriber( "get_wheeldistaff", private.get_wheeldistaff_logic );
--------------------------------------------------------------------
function public.get_wheeldistaff()
  cmn.SetEventDone( "get_wheeldistaff" );
  cmn.CallEventHandler( "get_wheeldistaff" );
  if common_impl.ZzCompleteCheck("get_wheeldistaff") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_towerentrance *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pin" ] = { type = "use", inv_obj = "inv_pin", use_place = "gfx_towerentrance_pin_zone", room = "rm_neartower", zz = "zz_towerentrance", zz_gate = "gzz_neartower_towerentrance" };

private.use_pin_logic = function()
   ObjSet( "gfx_towerentrance_clk_towerentrancedoor_zone", { visible = 1, input = 1 } )

end;
private.use_pin_inv = function()
  common_impl.ProcessMultiUseAll("pin", "pin")
end;
private.use_pin_beg = function()
  ObjDelete( "gfx_towerentrance_pin_zone" );
end;
private.use_pin_end = function()
  if common_impl.ZzCompleteCheck("use_pin") then ObjSet( common_impl.hint["use_pin"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pin", private.use_pin_inv );
cmn.AddSubscriber( "use_pin", private.use_pin_beg, private.room_objname );
cmn.AddSubscriber( "use_pin", private.use_pin_end, private.room_objname );
cmn.AddSubscriber( "use_pin", private.use_pin_logic );
cmn.AddSubscriber( "use_pin_inv", private.use_pin_inv, private.room_objname );
cmn.AddSubscriber( "use_pin_beg", private.use_pin_beg, private.room_objname );
cmn.AddSubscriber( "use_pin_end", private.use_pin_end, private.room_objname );
cmn.AddSubscriber( "use_pin_end", private.use_pin_logic );
--------------------------------------------------------------------------------------------
function public.use_pin( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pin" );
    cmn.CallEventHandler( "use_pin_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pin") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pin_inv" );
  cmn.CallEventHandler( "use_pin_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_towerentrance_anm", "use_pin", func_end );
  SoundSfx( "aud_use_pin_towerentrance" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
function public.clk_pin()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_pin' );
  end;
  ld.Lock(1);
  SoundSfx( "aud_touch_door_towerentrance" );
  ld.AnimPlay( "anm_towerentrance_anm", "idle", func_end );
end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_towerentrancedoor" ] = { type = "click", use_place = "gfx_towerentrance_clk_towerentrancedoor_zone", room = "rm_neartower", zz = "zz_towerentrance", zz_gate = "gzz_neartower_towerentrance"  };

private.clk_towerentrancedoor_logic = function()
  ObjSet( "grm_neartower_tower", { visible = 1, input = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_neartower_tower_focus");
    end;
end;
private.clk_towerentrancedoor_beg = function()
  ObjDelete( "gfx_towerentrance_clk_towerentrancedoor_zone" );
end;
private.clk_towerentrancedoor_end = function()
  if common_impl.ZzCompleteCheck("clk_towerentrancedoor") then ObjSet( common_impl.hint["clk_towerentrancedoor"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_neartower_tr_open_door", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_towerentrancedoor", private.clk_towerentrancedoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_towerentrancedoor", private.clk_towerentrancedoor_end, private.room_objname );
cmn.AddSubscriber( "clk_towerentrancedoor", private.clk_towerentrancedoor_logic );
cmn.AddSubscriber( "clk_towerentrancedoor_beg", private.clk_towerentrancedoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_towerentrancedoor_end", private.clk_towerentrancedoor_end, private.room_objname );
cmn.AddSubscriber( "clk_towerentrancedoor_end", private.clk_towerentrancedoor_logic );
--------------------------------------------------------------------------------------------
function public.clk_towerentrancedoor()
  
  local func_end = function()
    cmn.SetEventDone( "clk_towerentrancedoor" );
    cmn.CallEventHandler( "clk_towerentrancedoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_towerentrancedoor") then ld.CloseSubRoom() end;
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "clk_towerentrancedoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_towerentrance_anm", "open_door", func_end );
  SoundSfx( "aud_touch_towerentrance" );
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_basrelief *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mitten" ] = { type = "use", inv_obj = "inv_mitten", use_place = "gfx_basrelief_mitten_zone", room = "rm_neartower", zz = "zz_basrelief", zz_gate = "gzz_neartower_basrelief" };

private.use_mitten_logic = function()
  if ld.CheckRequirements( {"use_mitten","use_shield","use_scheme"} ) then
    
    ObjSet( "obj_basrelief_mmg_root", {input = 1} );
  end;

end;
private.use_mitten_inv = function()
  common_impl.ProcessMultiUseAll("mitten", "mitten")
end;
private.use_mitten_beg = function()
  ObjDelete( "gfx_basrelief_mitten_zone" );
end;
private.use_mitten_end = function()
  if common_impl.ZzCompleteCheck("use_mitten") then ObjSet( common_impl.hint["use_mitten"].zz_gate, { visible = 0, input = 0 } ); end;
 
  if ld.CheckRequirements( {"use_mitten","use_shield","use_scheme"} ) then
    ObjDelete("anm_basrelief_anim_basrelief_hand");
    ObjDelete("anm_basrelief_anim_basrelief");
    ObjSet( "spr_basrelief_c5", { visible = 1 } );
    ObjSet( "spr_basrelief_c8", { visible = 1 } );
    ObjDelete("spr_basrelief_c7_tr");
  else
    ObjSet( "anm_basrelief_anim_basrelief_hand", {animfunc = "use_c5", frame = 999 } );
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mitten", private.use_mitten_inv );
cmn.AddSubscriber( "use_mitten", private.use_mitten_beg, private.room_objname );
cmn.AddSubscriber( "use_mitten", private.use_mitten_end, private.room_objname );
cmn.AddSubscriber( "use_mitten", private.use_mitten_logic );
cmn.AddSubscriber( "use_mitten_inv", private.use_mitten_inv, private.room_objname );
cmn.AddSubscriber( "use_mitten_beg", private.use_mitten_beg, private.room_objname );
cmn.AddSubscriber( "use_mitten_end", private.use_mitten_end, private.room_objname );
cmn.AddSubscriber( "use_mitten_end", private.use_mitten_logic );
--------------------------------------------------------------------------------------------
function public.use_mitten( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mitten" );
    cmn.CallEventHandler( "use_mitten_end" );
    common_impl.Lock(0);
    if ld.CheckRequirements( {"use_mitten","use_shield","use_scheme"} ) then
      cmn.MiniGameShow( "knight" );
      public.win_knight_load(); 
    end;
    if common_impl.ZzCompleteCheck("use_mitten") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mitten_inv" );
  cmn.CallEventHandler( "use_mitten_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_basrelief_anim_basrelief_hand", "use_c5", func_end );
  SoundSfx( "aud_use_hand_basrelief" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "use_scheme" ] = { type = "use", inv_obj = "inv_scheme", use_place = "gfx_basrelief_scheme_zone", room = "rm_neartower", zz = "zz_basrelief", zz_gate = "gzz_neartower_basrelief" };

private.use_scheme_logic = function()
  if ld.CheckRequirements( {"use_shield","use_mitten","use_scheme"} ) then
  
    ObjSet( "obj_basrelief_mmg_root", {input = 1} );
  end;
end;
private.use_scheme_inv = function()
  common_impl.ProcessMultiUseAll("scheme", "scheme")
end;
private.use_scheme_beg = function()
  ObjDelete( "gfx_basrelief_scheme_zone" );
end;
private.use_scheme_end = function()
  if common_impl.ZzCompleteCheck("use_scheme") then ObjSet( common_impl.hint["use_scheme"].zz_gate, { visible = 0, input = 0 } ); end;
   if ld.CheckRequirements( {"use_mitten","use_shield","use_scheme"} ) then
    ObjDelete("anm_basrelief_anim_basrelief_hand");
    ObjDelete("anm_basrelief_anim_basrelief");
    ObjSet( "spr_basrelief_c5", { visible = 1 } );
    ObjSet( "spr_basrelief_c8", { visible = 1 } );
    ObjDelete("spr_basrelief_c7_tr");
  else
    ObjSet( "anm_basrelief_anim_basrelief_scheme", {animfunc = "end_list1", frame = 0 } );
  end;
  ObjSet( "spr_neartower_tr_list", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scheme", private.use_scheme_inv );
cmn.AddSubscriber( "use_scheme", private.use_scheme_beg, private.room_objname );
cmn.AddSubscriber( "use_scheme", private.use_scheme_end, private.room_objname );
cmn.AddSubscriber( "use_scheme", private.use_scheme_logic );
cmn.AddSubscriber( "use_scheme_inv", private.use_scheme_inv, private.room_objname );
cmn.AddSubscriber( "use_scheme_beg", private.use_scheme_beg, private.room_objname );
cmn.AddSubscriber( "use_scheme_end", private.use_scheme_end, private.room_objname );
cmn.AddSubscriber( "use_scheme_end", private.use_scheme_logic );
--------------------------------------------------------------------------------------------
function public.use_scheme( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scheme" );
    cmn.CallEventHandler( "use_scheme_end" );
    common_impl.Lock(0);
    if ld.CheckRequirements( {"use_mitten","use_shield","use_scheme"} ) then
      cmn.MiniGameShow( "knight" );
      public.win_knight_load(); 
    end;
    if common_impl.ZzCompleteCheck("use_scheme") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scheme_inv" );
  cmn.CallEventHandler( "use_scheme_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_basrelief_anim_basrelief_scheme", "use_list", func_end );
  SoundSfx( "aud_use_paper_basrelief" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_shield" ] = { type = "use", inv_obj = "inv_shield", use_place = "gfx_basrelief_shield_zone", room = "rm_neartower", zz = "zz_basrelief", zz_gate = "gzz_neartower_basrelief" };

private.use_shield_logic = function()
  if ld.CheckRequirements( {"use_shield","use_mitten","use_scheme"} ) then
  
    ObjSet( "obj_basrelief_mmg_root", {input = 1} );
  end;

end;
private.use_shield_inv = function()
  common_impl.ProcessMultiUseAll("shield", "shield")
end;
private.use_shield_beg = function()
  ObjDelete( "gfx_basrelief_shield_zone" );
end;
private.use_shield_end = function()
  if common_impl.ZzCompleteCheck("use_shield") then ObjSet( common_impl.hint["use_shield"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_mitten","use_shield","use_scheme"} ) then
    ObjDelete("anm_basrelief_anim_basrelief_hand");
    ObjDelete("anm_basrelief_anim_basrelief");
    ObjSet( "spr_basrelief_c5", { visible = 1 } );
    ObjSet( "spr_basrelief_c8", { visible = 1 } );
    ObjDelete("spr_basrelief_c7_tr");
  else
    ObjSet( "anm_basrelief_anim_basrelief", {animfunc = "use_c8", frame = 999 } );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_shield", private.use_shield_inv );
cmn.AddSubscriber( "use_shield", private.use_shield_beg, private.room_objname );
cmn.AddSubscriber( "use_shield", private.use_shield_end, private.room_objname );
cmn.AddSubscriber( "use_shield", private.use_shield_logic );
cmn.AddSubscriber( "use_shield_inv", private.use_shield_inv, private.room_objname );
cmn.AddSubscriber( "use_shield_beg", private.use_shield_beg, private.room_objname );
cmn.AddSubscriber( "use_shield_end", private.use_shield_end, private.room_objname );
cmn.AddSubscriber( "use_shield_end", private.use_shield_logic );
--------------------------------------------------------------------------------------------
function public.use_shield( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_shield" );
    cmn.CallEventHandler( "use_shield_end" );
    common_impl.Lock(0);
    if ld.CheckRequirements( {"use_mitten","use_shield","use_scheme"} ) then
      cmn.MiniGameShow( "knight" );
      public.win_knight_load(); 
    end;
    if common_impl.ZzCompleteCheck("use_shield") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_shield_inv" );
  cmn.CallEventHandler( "use_shield_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_basrelief_anim_basrelief", "use_c8", func_end );
  SoundSfx( "aud_use_shield_basrelief" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_knight" ] = { type = "click", use_place = "obj_basrelief_mmg_root", room = "rm_neartower", zz = "zz_basrelief", zz_gate = "gzz_neartower_basrelief" };

private.win_knight_logic = function()
  if ( cmn.IsEventDone( "win_knight" ) ) then
    ObjSet( "spr_basrelief_scottishstatue1", { visible = 1, input = 1 } )
    ObjSet( "spr_basrelief_amulethexagon", { visible = 1, input = 1 } )
  end
end;
private.win_knight_beg = function()
  
end;
private.win_knight_end = function()
  if common_impl.ZzCompleteCheck("win_knight") then ObjSet( common_impl.hint["win_knight"].zz_gate, { visible = 0, input = 0 } ); end;
  if ( cmn.IsEventDone( "win_knight" ) ) then
    for i = 1,8 do 
      ObjDelete( "spr_basrelief_lig_c"..i );
    end 
    ObjDelete( "obj_basrelief_mmg_root" );  
    ObjDelete( "spr_basrelief_door" ); 
    ObjDelete( "spr_basrelief_tr_door" ); 
    ObjDelete("anm_basrelief_anim_basrelief_win");
    ObjSet( "spr_basrelief_sh_amulethexagon", {visible = 1} );
    ObjSet( "spr_basrelief_sh_scottishstatue1", {visible = 1} );
    ObjSet( "spr_neartower_tr_basrelief", {visible = 1} );
    ObjDelete("spr_neartower_tr_list");
    ObjSet( "spr_neartower_tr_amulethexagon", {visible = 1} );
    ObjSet( "spr_neartower_tr_scottishstatue1", {visible = 1} );
    ObjDelete("anm_basrelief_anim_basrelief_scheme");
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_knight", private.win_knight_beg, private.room_objname );
cmn.AddSubscriber( "win_knight", private.win_knight_end, private.room_objname );
cmn.AddSubscriber( "win_knight", private.win_knight_logic );
cmn.AddSubscriber( "win_knight_beg", private.win_knight_beg, private.room_objname );
cmn.AddSubscriber( "win_knight_end", private.win_knight_end, private.room_objname );
cmn.AddSubscriber( "win_knight_end", private.win_knight_logic );
--------------------------------------------------------------------------------------------
function public.win_knight()

  local func_end = function()
    cmn.SetEventDone( "win_knight" );
    cmn.CallEventHandler( "win_knight_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_knight") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_knight_beg" );
  common_impl.Lock(1);
  cmn.MiniGameHide( "knight", true );
  ObjSet( "spr_basrelief_tr_list", {visible = 0} );
  ObjSet( "obj_basrelief_mmg_root", {visible = 0} );
  ObjSet( "spr_basrelief_door", {visible = 0} );
 
  ObjSet( "anm_basrelief_anim_basrelief_win", {visible = 1} );
  ObjSet( "anm_basrelief_anim_basrelief_scheme", {visible = 0} );
  ld.AnimPlay( "anm_basrelief_anim_basrelief_win", "open", func_end );
  --  SoundSfx( "aud_mg_basrelief_win" );
  --func_end()
  
end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------

local obj_pos = {{{-24,-95,0},{15,-69,1},{9,-81,0.5},{-12,-76,0.5}},
                 {{25,-90,0},{50,-102,0.5},{50,-102,0.5},{25,-90,0}},
                 {{19,-127,0},{32,-129,0.5},{32,-129,0.5},{19,-127,0}},
                 {{-23,-215,0},{-27,-212,0.5},{-30,-210,1},{-13,-202,-0.5}},
                 {{-133,-176,0},{-129,-211,0},{-148,-190,0.5},{-143,-156,0.5}},
                 {{-78,-142,0},{-79,-170,-0.5},{-79,-170,-0.5},{-78,-142,0}},
                 {{-96,-125,0},{-103,-164,-0.5},{-99,-158,0},{-96,-125,0}},
                 {{-53,-68,0},{-21,-35,1},{-36,-59,0.5},{-56,-58,0.5}}};
                 


function public.win_knight_load(fast) 
  if not ng_global.progress[ "std" ][ "win_knight" ].state then
    ng_global.progress[ "std" ][ "win_knight" ].state = {2,2,2,2,2,2,2,2};        
  end
  
  for i = 1, #ng_global.progress[ "std" ][ "win_knight" ].state do
    ObjSet( "spr_basrelief_c"..i, {pos_x = obj_pos[i][ng_global.progress[ "std" ][ "win_knight" ].state[i] ][1], 
                                   pos_y = obj_pos[i][ng_global.progress[ "std" ][ "win_knight" ].state[i] ][2], 
                                   ang = obj_pos[i][ng_global.progress[ "std" ][ "win_knight" ].state[i] ][3]} );
  end
end

function public.win_knight_hand(num)  
  ld.SetCursor( CURSOR_HAND );  
  if num == 4 then 
    ObjSet( "spr_basrelief_lig_c"..num, { alp = 1} );  
  elseif ((num == 5) or (num == 6) or (num == 7)) then
    ObjSet( "spr_basrelief_lig_c5", { alp = 1} ); 
    ObjSet( "spr_basrelief_lig_c6", { alp = 1} ); 
    ObjSet( "spr_basrelief_lig_c7", { alp = 1} ); 
  elseif ((num == 1) or (num == 2) or (num == 3) or (num == 8)) then
    ObjSet( "spr_basrelief_lig_c1", { alp = 1} ); 
    ObjSet( "spr_basrelief_lig_c2", { alp = 1} ); 
    ObjSet( "spr_basrelief_lig_c3", { alp = 1} ); 
    ObjSet( "spr_basrelief_lig_c8", { alp = 1} ); 
  end    
end

function public.win_knight_hand_defoult(num)  
  ld.SetCursor( CURSOR_DEFAULT ); 
  if num == 4 then 
    ObjSet( "spr_basrelief_lig_c"..num, { alp = 0} );  
  elseif ((num == 5) or (num == 6) or (num == 7)) then
    ObjSet( "spr_basrelief_lig_c5", { alp = 0} ); 
    ObjSet( "spr_basrelief_lig_c6", { alp = 0} ); 
    ObjSet( "spr_basrelief_lig_c7", { alp = 0} ); 
  elseif ((num == 1) or (num == 2) or (num == 3) or (num == 8)) then
    ObjSet( "spr_basrelief_lig_c1", { alp = 0} ); 
    ObjSet( "spr_basrelief_lig_c2", { alp = 0} ); 
    ObjSet( "spr_basrelief_lig_c3", { alp = 0} ); 
    ObjSet( "spr_basrelief_lig_c8", { alp = 0} ); 
  end    
end 

function private.win_knight_obj_move(num,step)
  ObjAnimate( "spr_basrelief_c"..num, 3, 0, 0, function() end,{0,0,ObjGet("spr_basrelief_c"..num).pos_x,ObjGet("spr_basrelief_c"..num).pos_y, 0.5,0,obj_pos[num][step][1],obj_pos[num][step][2]} );
  ObjAnimate( "spr_basrelief_c"..num, 7, 0, 0, function() end, {0,0,ObjGet("spr_basrelief_c"..num).ang, 0.5,0, obj_pos[num][step][3]} );  
end

function public.win_knight_clik(num)
  SoundSfx( "aud_mg_basrelief_rotate" );
  ld.Lock(1);
  local step;
  if ng_global.progress[ "std" ][ "win_knight" ].state[num] < 4 then
    step = ng_global.progress[ "std" ][ "win_knight" ].state[num] + 1;
  else
    step = 1;
  end
  if num == 4 then
      private.win_knight_obj_move(num, step);
      ng_global.progress[ "std" ][ "win_knight" ].state[num] =  step;
      if step == 1 then
        ObjSet( "spr_basrelief_c"..num, {input = 0} );  
      end
  elseif ((num == 5) or (num == 6) or (num == 7)) then
    for i = 5,7 do
        private.win_knight_obj_move(i, step);
        ng_global.progress[ "std" ][ "win_knight" ].state[i] =  step;
        if step == 1 then
          ObjSet( "spr_basrelief_c"..i, {input = 0} );  
        end
    end 
  elseif ((num == 1) or (num == 2) or (num == 3) or (num == 8)) then
    for i = 1,3 do
        private.win_knight_obj_move(i, step );
        ng_global.progress[ "std" ][ "win_knight" ].state[i] =  step;
        if step == 1 then
          ObjSet( "spr_basrelief_c"..i, {input = 0} );  
        end
    end 
    private.win_knight_obj_move(8, step);
    ng_global.progress[ "std" ][ "win_knight" ].state[8] =  step;
    if step == 1 then
      ObjSet( "spr_basrelief_c"..8, {input = 0} );  
    end
  end 
  ld.StartTimer( 0.5, function() ld.Lock(0); public.win_knight_check(); end )
end



function public.win_knight_check()
  for  i = 1, #ng_global.progress[ "std" ][ "win_knight" ].state do
    if ng_global.progress[ "std" ][ "win_knight" ].state[i] ~= 1 then
      return;
    end
  end
  ld.Lock(1);
  public.win_knight_skip();
end

    
function public.win_knight_skip(fast)
  if ng_global.progress[ "std" ][ "win_knight" ].state then
    ng_global.progress[ "std" ][ "win_knight" ].state = {2,2,2,2,2,2,2,2};
  end 
  local func_end = function()
    for i = 1,8 do 
      ObjAnimate( "spr_basrelief_lig_c"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
    end 
    ld.StartTimer( 0.5, function() ld.Lock(0); public.win_knight(); end )  
  end;
  for i = 1,8 do 
    ObjAnimate( "spr_basrelief_lig_c"..i, 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
  end
  SoundSfx( "aud_mg_basrelief_win" );
  ld.StartTimer( 0.5, function() func_end(); end ) 
end

function public.win_knight_reset()
  --ld.Lock(1);
  if ng_global.progress[ "std" ][ "win_knight" ].state then
    ng_global.progress[ "std" ][ "win_knight" ].state = {2,2,2,2,2,2,2,2};
  end  
   for i = 1,8 do
     ObjSet( "spr_basrelief_c"..i, {input = 1} );
     private.win_knight_obj_move(i,2);
     
  end
   ld.StartTimer( 0.5, function() ld.Lock(0); end )
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scottishstatue1" ] = { type = "get", get_obj = "spr_basrelief_scottishstatue1", room = "rm_neartower", zz = "zz_basrelief", zz_gate = "gzz_neartower_basrelief" };

private.get_scottishstatue1_logic = function()
  
end;
private.get_scottishstatue1_inv = function()
  interface.InventoryItemAdd("inv_scottishstatue1","spr_basrelief_scottishstatue1");
end;
private.get_scottishstatue1_beg = function()
  ObjDelete("gfx_basrelief_scottishstatue1")
end;
private.get_scottishstatue1_end = function()
  if common_impl.ZzCompleteCheck("get_scottishstatue1") then ObjSet( common_impl.hint["get_scottishstatue1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_basrelief_sh_scottishstatue1");
  ObjDelete("spr_neartower_tr_scottishstatue1");
end;

cmn.AddSubscriber( "get_scottishstatue1", private.get_scottishstatue1_inv );
cmn.AddSubscriber( "get_scottishstatue1", private.get_scottishstatue1_beg, private.room_objname );
cmn.AddSubscriber( "get_scottishstatue1", private.get_scottishstatue1_end, private.room_objname );
cmn.AddSubscriber( "get_scottishstatue1", private.get_scottishstatue1_logic );
--------------------------------------------------------------------
function public.get_scottishstatue1()
  cmn.SetEventDone( "get_scottishstatue1" );
  cmn.CallEventHandler( "get_scottishstatue1" );
  if common_impl.ZzCompleteCheck("get_scottishstatue1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amulethexagon" ] = { type = "get", get_obj = "spr_basrelief_amulethexagon", room = "rm_neartower", zz = "zz_basrelief", zz_gate = "gzz_neartower_basrelief" };

private.get_amulethexagon_logic = function()
  
end;
private.get_amulethexagon_inv = function()
  interface.InventoryItemAdd("inv_amulethexagon","spr_basrelief_amulethexagon");
end;
private.get_amulethexagon_beg = function()
  ObjDelete("gfx_basrelief_amulethexagon")
end;
private.get_amulethexagon_end = function()
  if common_impl.ZzCompleteCheck("get_amulethexagon") then ObjSet( common_impl.hint["get_amulethexagon"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_basrelief_sh_amulethexagon");
  ObjDelete("spr_neartower_tr_amulethexagon");
end;

cmn.AddSubscriber( "get_amulethexagon", private.get_amulethexagon_inv );
cmn.AddSubscriber( "get_amulethexagon", private.get_amulethexagon_beg, private.room_objname );
cmn.AddSubscriber( "get_amulethexagon", private.get_amulethexagon_end, private.room_objname );
cmn.AddSubscriber( "get_amulethexagon", private.get_amulethexagon_logic );
--------------------------------------------------------------------
function public.get_amulethexagon()
  cmn.SetEventDone( "get_amulethexagon" );
  cmn.CallEventHandler( "get_amulethexagon" );
  if common_impl.ZzCompleteCheck("get_amulethexagon") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_groundho_for_neartower = function()
    if ld.CheckRequirements( {"win_groundho"} ) then
      ObjSet( "gho_neartower_groundho", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_groundho", win_groundho_for_neartower, private.room_objname )

  function public.Skip()
  ld.LogTrace( "Skip" );
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_basrelief" ) and not ld.CheckRequirements( { "win_knight" } ) then
    ld.Lock(1); 
    for i = 1,8 do
      private.win_knight_obj_move(i,1)
    end    
    ld.StartTimer( 0.5, function() public.win_knight_skip(); end ) 
  end;

end;
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_basrelief" ) and not ld.CheckRequirements( { "win_knight" } ) then  
    ld.Lock(1);    
    public.win_knight_reset();
  end;

end;
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_neartower();
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_neartower_env" );
  --  private.horse_static();
end;
--*********************************************************************************************************************
function public.Close()
  ObjSet("tmr_neartower_horse",{playing=0})
  --VidStop(private.horse_cur)
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_basrelief" );
  function zz_basrelief.Open()
    if ld.CheckRequirements( {"use_mitten","use_shield", "use_scheme"} ) and not ld.CheckRequirements( {"win_knight"} ) then
      
      cmn.MiniGameShow( "knight" );
    end
  end;
  function zz_basrelief.PreOpen()
    if  not cmn.IsEventDone( "win_knight" )  and cmn.IsEventStart( "win_knight" ) and cmn.IsEventDone( "use_mitten" ) and cmn.IsEventDone( "use_shield" ) and cmn.IsEventDone( "use_scheme" ) then
       public.win_knight_load(1);   
    end
  end;
  function zz_basrelief.PreClose()
    if ld.CheckRequirements( {"use_mitten","use_shield", "use_scheme"} ) and not ld.CheckRequirements( {"win_knight"} ) then
      
      cmn.MiniGameHide( "knight" );
    end
  end;
  function zz_basrelief.Close()
  end;

  subroom.Define( "zz_towerentrance" );
  function zz_towerentrance.Open()
  end;
  function zz_towerentrance.PreOpen()
  end;
  function zz_towerentrance.PreClose()
  end;
  function zz_towerentrance.Close()
     
  end;

  subroom.Define( "zz_dray" );
  function zz_dray.Open()
  end;
  function zz_dray.PreOpen()
  end;
  function zz_dray.PreClose()
  end;
  function zz_dray.Close()
  end;

  subroom.Define( "zz_ground" );
  function zz_ground.Open()
  end;
  function zz_ground.PreOpen()
  end;
  function zz_ground.PreClose()
  end;
  function zz_ground.Close()
  end;

  subroom.Define( "zz_slab" );
  function zz_slab.Open()
    private.opn_neartowerslab();
  end;
  function zz_slab.PreOpen()
  end;
  function zz_slab.PreClose()
  end;
  function zz_slab.Close()
  end;
  
end;
--*********************************************************************************************************************
--private.horse_cur = ""
--function private.horse_static()
--  local f_end = function ()
--    ObjSet("tmr_neartower_horse",{endtrig=function()private.horse_static()end,playing=1,time=math.random(3,6)})
--  end
--  local r=math.random(3)
--  for i=1,3 do
--    ObjDetach("vid_neartower_horse_static_"..i)
--  end
--    private.horse_cur = "vid_neartower_horse_static_"..r
--    ObjAttach(private.horse_cur,"rm_neartower")
--    VidPlay(private.horse_cur,f_end)
--end