-- name=ho_bombthreeext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "bombthreeext" );
  game.relations[ "ho_bombthreeext" ].exitroom = "rm_pubext";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_bombthreeext" ] = { type = "win", room = "rm_pubext", zz = "ho_bombthreeext", zz_gate = "gho_pubext_bombthreeext" };
 
  local win_bombthreeext_func = function ()

    if ( cmn.IsEventDone( "win_bombthreeext" ) ) then
      interface.InventoryItemAdd( "inv_threethistleext", "spr_bombthreeext_win" );
      ObjDelete( "gho_pubext_bombthreeext" );
    end;

  end;
  cmn.AddSubscriber( "win_bombthreeext", win_bombthreeext_func );
  
  local start_bombthreeext_func = function ()
 if not cmn.IsEventDone("win_bombthreeext") then
      common_impl.ProcessHoStart( "bombthreeext" );

      local ho_found = ng_global.progress[ "ext" ][ "win_bombthreeext" ].found;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false } );

      end;

  end
  end;
  cmn.AddSubscriber( "win_bombthreeext", start_bombthreeext_func, "ho_bombthreeext" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_pubext_env" )
  SoundEnv("aud_ho_bombthreeext_bomb",1)

  if ( not cmn.IsEventDone( "opn_bombthreeext" ) ) then

    cmn.InitHo( "bombthreeext" );

    cmn.SetEventDone( "opn_bombthreeext" );
 
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_bombthreeext_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_bombthreeext_bbb"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_bombthreeext_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_bombthreeext_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_bombthreeext_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_bombthreeext_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_bombthreeext_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_bombthreeext_hhh"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_bombthreeext_iii"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_bombthreeext_jjj"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_bombthreeext_kkk"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_bombthreeext_lll"}); 

  
  SoundHoTheme( true )
  interface.ItemPanelShow( ho_items );
  if ng_global.progress[ "ext" ][ "win_bombthreeext" ].state_bbb then
    ObjSet("anm_bombthreeext_animbomb",{frame=ng_global.progress[ "ext" ][ "win_bombthreeext" ].state_bbb,playing=0})
    ObjSet("anm_bombthreeext_animbomb_sig",{playing=0})
  end
end;  
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.ItemPanelHide();

  if cmn.IsEventDone("win_bombthreeext") then SoundTheme("aud_danger_moment1_mus") end;
end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.DialogHo_Show()
  ObjDelete("gho_pubext_bombthreeext") 
  SoundEnv("aud_ho_bombthreeext_bomb",0)
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_bombthreeext_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_bombthreeext_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.Get_bbb()
  AnimPause("anm_bombthreeext_animbomb",1)
  AnimPause("anm_bombthreeext_animbomb_sig",1)
  local time = ObjGet("anm_bombthreeext_animbomb").frame
  ng_global.progress[ "ext" ][ "win_bombthreeext" ].state_bbb = time
end
