-- name=levelext_inv
function public.ProcessGetSkittleextAll( prg )
  local inv = "inv_skittleext"
  local prg_all = {"get_skittleext1","get_skittleext2","get_skittleext3"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  if public.ProcessDragChecker( inv, prg, prg_all ) then 
    ObjSet( inv, { drag = 1, event_mdown = "" } );
  else
    ObjSet( inv, { drag = 0 } );
  end  
end
function public.ProcessGetPubemblemextAll( prg )
  local inv = "inv_pubemblemext"
  local prg_all = {"get_pubemblemext1","get_pubemblemext2","get_pubemblemext3","get_pubemblemext4"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  if public.ProcessDragChecker( inv, prg, prg_all ) then 
    ObjSet( inv, { drag = 1, event_mdown = "" } );
  else
    ObjSet( inv, { drag = 0 } );
  end  
end
function public.ProcessGetCoinextAll( prg )
  local inv = "inv_coinext"
  local prg_all = {"get_coinext1","get_coinext2","get_coinext3","get_coinext4","get_coinext5"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  if public.ProcessDragChecker( inv, prg, prg_all ) then 
    ObjSet( inv, { drag = 1, event_mdown = "" } );
  else
    ObjSet( inv, { drag = 0 } );
  end  
end
function public.ProcessGetDecorpartextAll( prg )
  local inv = "inv_decorpartext"
  local prg_all = {"get_decorpartext1","get_decorpartext2","get_decorpartext3"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  if public.ProcessDragChecker( inv, prg, prg_all ) then 
    ObjSet( inv, { drag = 1, event_mdown = "" } );
  else
    ObjSet( inv, { drag = 0 } );
  end  
end
function public.ProcessGetPartswitchextAll( prg )
  local inv = "inv_partswitchext"
  local prg_all = {"get_partswitchext1","get_partswitchext2","get_partswitchext3"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  if public.ProcessDragChecker( inv, prg, prg_all ) then 
    ObjSet( inv, { drag = 1, event_mdown = "" } );
  else
    ObjSet( inv, { drag = 0 } );
  end  
end
-- name=levelext_inv
function public.ProcessGetMechanikextAll( prg )
  local inv = "inv_mechanikext"
  local prg_all = {"get_mechanikext1","get_mechanikext2"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  if public.ProcessDragChecker( inv, prg, prg_all ) then 
    ObjSet( inv, { drag = 1, event_mdown = "" } );
  else
    ObjSet( inv, { drag = 0 } );
  end  
end

function public.Init()
  if port.isPortable() == 1 then
    port.InventoryPopupInit("levelext_inv_hub");
    port.VideoResizeInRoom("levelext_inv");
  end;
  
function public.ProcessDragChecker( inv, prg, prg_all )
  if ( int_inventory.InventoryItemAddFly[inv] and int_inventory.InventoryItemAddFly[inv] == 0 and ( ld.CheckRequirements( prg_all, 1 ) == ( #prg_all - ( ld.CheckRequirements( { prg } ) and 0 or 1 ) ) ) )
  or ( not int_inventory.InventoryItemAddFly[inv] and ld.CheckRequirements( prg_all ) ) then 
    return true
  else
    return false
  end 
end;
public.use_add = {
--
----  ["inv_tin"]    = {
----    {"gfx_damagedshape_clk_damagedshape2_zone" ,"tin_on_opened_shape"};
----  };
----
--  ["obj_simon_cursor_drag"]  = {     --Саймон
--    { "gfx_sweetwindow_ropeladder_zone","simon_on_use_ropeladder"};
--    { "obj_neargrot_ropefakepuss_zone","puss_on_ropeneargrot"};
--  };
--
--  --["obj_simon_cursor_drag"]  = {     --Саймон
--  --  { "obj_neargrot_ropefakepuss_zone","puss_on_ropeneargrot"};
--  --};
--
  ["inv_scissorsext"]  = { 
    { "gfx_chatterext_daggerext_chatterext_zone","scissorsext_on_use_daggerext_chatterext"};
  };

}
ld.InvSetDropable         = int_inventory.InvSetDropable;
--*********************************************************************************************************************
--*********************************************************************************************************************
--ПЕРЕОПРЕДЕЛЕНИЕ ССЫЛКИ НА ИНВЕНТАРЬ
  level_inv = levelext_inv
--*********************************************************************************************************************
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_flashlightoffext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_batteryext_zone_clk(num)  --levelext_inv.use_batteryext_zone_clk(num)
  local func_end = function()
     ld.Lock(0);
     common_impl.ShowBbt( 'need_batteryext'..num )
  end;  
  
  
  
  ld.Lock(1);
  if cmn.IsEventDone("use_batteryext1") or cmn.IsEventDone("use_batteryext2") then 
    ld.AnimPlay( "anm_flashlightoffext_anm", "flashlight_idle2", func_end )
    SoundSfx( "aud_flashlight_touch" )
  else 
    ld.AnimPlay( "anm_flashlightoffext_anm", "flashlight_idle", func_end )
    SoundSfx( "aud_flashlight_touch" )
  end;  
  
end;



common_impl.hint[ "use_batteryext1" ] = { type = "use", inv_obj = "inv_batteryext1", use_place = "gfx_flashlightoffext_batteryext1_zone", room = "inv_complex_inv", zz = "inv_complex_flashlightoffext", zz_gate = "inv_flashlightoffext" };

private.use_batteryext1_logic = function()
  if ld.CheckRequirements( {"use_batteryext1","use_batteryext2"} ) then
    -- ObjSet( "spr_flashlightoffext_flashlightonext", { visible = 1, input = 1, active = 1 } )
     ObjSet( "gfx_flashlightoffext_clk_batteryexttest_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_batteryext1_inv = function()
  common_impl.ProcessMultiUseAll("batteryext1", "batteryext1")
end;
private.use_batteryext1_beg = function()
  ObjDelete( "gfx_flashlightoffext_batteryext1_zone" );
end;
private.use_batteryext1_end = function()
  if cmn.IsEventDone("use_batteryext1") and cmn.IsEventDone("use_batteryext2") then 
    ObjSet( "anm_flashlightoffext_anm", {animfunc = "test", frame = 0 } );
    ObjDelete("inv_flashlightoffext_state_tr_1")
    ObjSet( "inv_flashlightoffext_state_tr_2", {alp=1} );
  else 
    ObjSet( "anm_flashlightoffext_anm", {animfunc = "use_battery2", frame = 0 } );
    ObjDelete("inv_flashlightoffext_back")
    ObjSet( "inv_flashlightoffext_state_tr_1", {alp=1} );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_batteryext1", private.use_batteryext1_inv );
cmn.AddSubscriber( "use_batteryext1", private.use_batteryext1_beg );
cmn.AddSubscriber( "use_batteryext1", private.use_batteryext1_end );
cmn.AddSubscriber( "use_batteryext1", private.use_batteryext1_logic );
cmn.AddSubscriber( "use_batteryext1_inv", private.use_batteryext1_inv );
cmn.AddSubscriber( "use_batteryext1_beg", private.use_batteryext1_beg );
cmn.AddSubscriber( "use_batteryext1_end", private.use_batteryext1_end );
cmn.AddSubscriber( "use_batteryext1_end", private.use_batteryext1_logic );
--------------------------------------------------------------------------------------------
function public.use_batteryext1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_batteryext1" );
    cmn.CallEventHandler( "use_batteryext1_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_batteryext1_inv" );
  cmn.CallEventHandler( "use_batteryext1_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_batteryext1_flashlightoffext" )
  
  if cmn.IsEventDone("use_batteryext1") or cmn.IsEventDone("use_batteryext2") then 
    ld.AnimPlay( "anm_flashlightoffext_anm", "use_battery2", func_end )
  else 
    ld.AnimPlay( "anm_flashlightoffext_anm", "use_battery1", func_end )
  end;  
  
  --ld.AnimPlay( "", "", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_batteryext2" ] = { type = "use", inv_obj = "inv_batteryext2", use_place = "gfx_flashlightoffext_batteryext2_zone", room = "inv_complex_inv", zz = "inv_complex_flashlightoffext", zz_gate = "inv_flashlightoffext" };

private.use_batteryext2_logic = function()
  if ld.CheckRequirements( {"use_batteryext2","use_batteryext1"} ) then
    --ObjSet( "spr_flashlightoffext_flashlightonext", { visible = 1, input = 1, active = 1 } )
    ObjSet( "gfx_flashlightoffext_clk_batteryexttest_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_batteryext2_inv = function()
  common_impl.ProcessMultiUseAll("batteryext2", "batteryext2")
end;
private.use_batteryext2_beg = function()
  ObjDelete( "gfx_flashlightoffext_batteryext2_zone" );
end;
private.use_batteryext2_end = function()
  if cmn.IsEventDone("use_batteryext1") and cmn.IsEventDone("use_batteryext2") then 
    ObjSet( "anm_flashlightoffext_anm", {animfunc = "test", frame = 0 } );
    ObjDelete("inv_flashlightoffext_state_tr_1")
    ObjSet( "inv_flashlightoffext_state_tr_2", {alp=1} );
  else 
    ObjSet( "anm_flashlightoffext_anm", {animfunc = "use_battery2", frame = 0 } );
    ObjDelete("inv_flashlightoffext_back")
    ObjSet( "inv_flashlightoffext_state_tr_1", {alp=1} );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_batteryext2", private.use_batteryext2_inv );
cmn.AddSubscriber( "use_batteryext2", private.use_batteryext2_beg );
cmn.AddSubscriber( "use_batteryext2", private.use_batteryext2_end );
cmn.AddSubscriber( "use_batteryext2", private.use_batteryext2_logic );
cmn.AddSubscriber( "use_batteryext2_inv", private.use_batteryext2_inv );
cmn.AddSubscriber( "use_batteryext2_beg", private.use_batteryext2_beg );
cmn.AddSubscriber( "use_batteryext2_end", private.use_batteryext2_end );
cmn.AddSubscriber( "use_batteryext2_end", private.use_batteryext2_logic );
--------------------------------------------------------------------------------------------
function public.use_batteryext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_batteryext2" );
    cmn.CallEventHandler( "use_batteryext2_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_batteryext2_inv" );
  cmn.CallEventHandler( "use_batteryext2_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_batteryext2_flashlightoffext" )
  
  --ld.AnimPlay( "", "", func_end );
  --func_end()
  if cmn.IsEventDone("use_batteryext1") or cmn.IsEventDone("use_batteryext2") then 
    ld.AnimPlay( "anm_flashlightoffext_anm", "use_battery2", func_end )
  else 
    ld.AnimPlay( "anm_flashlightoffext_anm", "use_battery1", func_end )
  end;  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_batteryexttest" ] = { type = "click", use_place = "gfx_flashlightoffext_clk_batteryexttest_zone",room = "inv_complex_inv", zz = "inv_complex_flashlightoffext", zz_gate = "inv_flashlightoffext"  };

private.clk_batteryexttest_logic = function()
  ObjSet( "spr_flashlightoffext_flashlightonext", { visible = 1, input = 1, active = 1 } )
end;
private.clk_batteryexttest_beg = function()
  ObjDelete( "gfx_flashlightoffext_clk_batteryexttest_zone" );
end;
private.clk_batteryexttest_end = function()
  ObjDelete( "anm_flashlightoffext_anm");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_batteryexttest", private.clk_batteryexttest_beg );
cmn.AddSubscriber( "clk_batteryexttest", private.clk_batteryexttest_end );
cmn.AddSubscriber( "clk_batteryexttest", private.clk_batteryexttest_logic );
cmn.AddSubscriber( "clk_batteryexttest_beg", private.clk_batteryexttest_beg );
cmn.AddSubscriber( "clk_batteryexttest_end", private.clk_batteryexttest_end );
cmn.AddSubscriber( "clk_batteryexttest_end", private.clk_batteryexttest_logic );
--------------------------------------------------------------------------------------------
function public.clk_batteryexttest()

  local func_end = function()
    cmn.SetEventDone( "clk_batteryexttest" );
    cmn.CallEventHandler( "clk_batteryexttest_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_batteryexttest_beg" );
  common_impl.Lock(1);

 
  SoundSfx( "aud_flashlight_on" )
  ld.AnimPlay( "anm_flashlightoffext_anm", "test", func_end )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_flashlightonext" ] = { type = "get", get_obj = "spr_flashlightoffext_flashlightonext", room = "inv_complex_inv", zz = "inv_complex_flashlightoffext", zz_gate = "inv_flashlightoffext" };

private.get_flashlightonext_logic = function()
 
end;
private.get_flashlightonext_inv = function()
  interface.InventoryItemAdd("inv_flashlightonext","spr_flashlightoffext_flashlightonext");
  if common_impl.ZzCompleteCheck("get_flashlightonext") then interface.InventoryItemRemove("inv_flashlightoffext") end;
end;
private.get_flashlightonext_beg = function()
  ObjDelete("gfx_flashlightoffext_flashlightonext");
end;
private.get_flashlightonext_end = function()
  
end;

cmn.AddSubscriber( "get_flashlightonext", private.get_flashlightonext_inv );
cmn.AddSubscriber( "get_flashlightonext", private.get_flashlightonext_beg );
cmn.AddSubscriber( "get_flashlightonext", private.get_flashlightonext_end );
cmn.AddSubscriber( "get_flashlightonext", private.get_flashlightonext_logic );
--------------------------------------------------------------------
function public.get_flashlightonext()
  cmn.SetEventDone( "get_flashlightonext" );
  cmn.CallEventHandler( "get_flashlightonext" );
  if common_impl.ZzCompleteCheck("get_flashlightonext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_diaryext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_childkeyext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_childkeyext' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_diaryext_touch" );
  ld.AnimPlay( "anm_diaryext_anm", "book_idle", func_end )
end;  



common_impl.hint[ "use_childkeyext" ] = { type = "use", inv_obj = "inv_childkeyext", use_place = "gfx_diaryext_childkeyext_zone", room = "inv_complex_inv", zz = "inv_complex_diaryext", zz_gate = "inv_diaryext" };

private.use_childkeyext_logic = function()
  ObjSet( "gfx_diaryext_clk_diaryopnext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_childkeyext_inv = function()
  common_impl.ProcessMultiUseAll("childkeyext", "childkeyext")
end;
private.use_childkeyext_beg = function()
  ObjDelete( "gfx_diaryext_childkeyext_zone" );
end;
private.use_childkeyext_end = function()
  ObjSet( "anm_diaryext_anm", {animfunc="book_open", frame=0} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_childkeyext", private.use_childkeyext_inv );
cmn.AddSubscriber( "use_childkeyext", private.use_childkeyext_beg );
cmn.AddSubscriber( "use_childkeyext", private.use_childkeyext_end );
cmn.AddSubscriber( "use_childkeyext", private.use_childkeyext_logic );
cmn.AddSubscriber( "use_childkeyext_inv", private.use_childkeyext_inv );
cmn.AddSubscriber( "use_childkeyext_beg", private.use_childkeyext_beg );
cmn.AddSubscriber( "use_childkeyext_end", private.use_childkeyext_end );
cmn.AddSubscriber( "use_childkeyext_end", private.use_childkeyext_logic );
--------------------------------------------------------------------------------------------
function public.use_childkeyext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_childkeyext" );
    cmn.CallEventHandler( "use_childkeyext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_childkeyext_inv" );
  cmn.CallEventHandler( "use_childkeyext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_childkeyext_diaryext" )
  
  ld.AnimPlay( "anm_diaryext_anm", "use_key", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_diaryopnext" ] = { type = "click", use_place = "gfx_diaryext_clk_diaryopnext_zone", room = "inv_complex_inv", zz = "inv_complex_diaryext", zz_gate = "inv_diaryext" };

private.clk_diaryopnext_logic = function()
  ObjSet( "spr_diaryext_codeext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_diaryext_codeext", { active=1, visible = 1} );
end;
private.clk_diaryopnext_beg = function()
  ObjDelete( "gfx_diaryext_clk_diaryopnext_zone" );
end;
private.clk_diaryopnext_end = function()
  ObjSet( "anm_diaryext_anm", {animfunc = "book_open", frame = 999 } );
  ObjDelete("inv_diaryext_back")
  ObjSet( "inv_diaryext_tr_1", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_diaryopnext", private.clk_diaryopnext_beg );
cmn.AddSubscriber( "clk_diaryopnext", private.clk_diaryopnext_end );
cmn.AddSubscriber( "clk_diaryopnext", private.clk_diaryopnext_logic );
cmn.AddSubscriber( "clk_diaryopnext_beg", private.clk_diaryopnext_beg );
cmn.AddSubscriber( "clk_diaryopnext_end", private.clk_diaryopnext_end );
cmn.AddSubscriber( "clk_diaryopnext_end", private.clk_diaryopnext_logic );
--------------------------------------------------------------------------------------------
function public.clk_diaryopnext()

  local func_end = function()
    cmn.SetEventDone( "clk_diaryopnext" );
    cmn.CallEventHandler( "clk_diaryopnext_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_diaryopnext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_diaryext_anm", "book_open", func_end );
  SoundSfx( "aud_clk_diaryopnext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_codeext" ] = { type = "get", get_obj = "spr_diaryext_codeext", room = "inv_complex_inv", zz = "inv_complex_diaryext", zz_gate = "inv_diaryext" };

private.get_codeext_logic = function()
 
end;
private.get_codeext_inv = function()
  interface.InventoryItemAdd("inv_codeext","spr_diaryext_codeext");
  if common_impl.ZzCompleteCheck("get_codeext") then interface.InventoryItemRemove("inv_diaryext") end;
end;
private.get_codeext_beg = function()
  ObjDelete("gfx_diaryext_codeext");
end;
private.get_codeext_end = function()
  ObjSet( "anm_diaryext_anm", {animfunc = "book_open_static", frame = 0 } );
end;

cmn.AddSubscriber( "get_codeext", private.get_codeext_inv );
cmn.AddSubscriber( "get_codeext", private.get_codeext_beg );
cmn.AddSubscriber( "get_codeext", private.get_codeext_end );
cmn.AddSubscriber( "get_codeext", private.get_codeext_logic );
--------------------------------------------------------------------
function public.get_codeext()
  ObjSet( "spr_diaryext_codeext", {visible = 1} );
  cmn.SetEventDone( "get_codeext" );
  cmn.CallEventHandler( "get_codeext" );
  if common_impl.ZzCompleteCheck("get_codeext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_backpackext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_codeext" ] = { type = "use", inv_obj = "inv_codeext", use_place = "gfx_backpackext_codeext_zone", room = "inv_complex_inv", zz = "inv_complex_backpackext", zz_gate = "inv_backpackext" };

private.use_codeext_logic = function()
  --  ObjSet( "gfx_backpackext_clk_diarycodeext_zone", { visible = 1, input = 1, active = 1 } )
    ObjSet( "obj_backpackext_parts_root", {input = 1} );
    ObjSet( "obj_backpackext_num_root", {input = 1} );
end;
private.use_codeext_inv = function()
  common_impl.ProcessMultiUseAll("codeext", "codeext")
end;
private.use_codeext_beg = function()
  ObjDelete( "gfx_backpackext_codeext_zone" );
end;
private.use_codeext_end = function()
   ObjSet( "anm_backpackext_anm_code", {animfunc = "use_passcode", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_codeext", private.use_codeext_inv );
cmn.AddSubscriber( "use_codeext", private.use_codeext_beg );
cmn.AddSubscriber( "use_codeext", private.use_codeext_end );
cmn.AddSubscriber( "use_codeext", private.use_codeext_logic );
cmn.AddSubscriber( "use_codeext_inv", private.use_codeext_inv );
cmn.AddSubscriber( "use_codeext_beg", private.use_codeext_beg );
cmn.AddSubscriber( "use_codeext_end", private.use_codeext_end );
cmn.AddSubscriber( "use_codeext_end", private.use_codeext_logic );
--------------------------------------------------------------------------------------------
function public.use_codeext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_codeext" );
    cmn.CallEventHandler( "use_codeext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_codeext_inv" );
  cmn.CallEventHandler( "use_codeext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_codeext_backpackext" )
  
  ld.AnimPlay( "anm_backpackext_anm_code", "use_passcode", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
local backpackext_parts_p={0,0,0};
local backpackext_num_size=528;
local backpackext_num_step=backpackext_num_size/10;
local backpackext_fy=234;

function private.backpackext_stand_num()
  for i=1,3,1 do 
    local pos = backpackext_fy-backpackext_parts_p[i]*backpackext_num_step;
    ObjSet( "spr_backpackext_number"..i, {pos_y = pos} );
  end;  
  public.backpackext_win_ver();
end;  

function public.backpackext_num_mdown(num)  --levelext_inv.backpackext_num_mdown(num)
  local func_end = function()
    ld.Lock(0);
    private.backpackext_stand_num();
  end;  
  
  
  local cur_pos = ObjGet("spr_backpackext_number"..num).pos_y;
  backpackext_parts_p[num] =  math.fmod(backpackext_parts_p[num]+1,10); 
  
  SoundSfx( "aud_clk_diarycodeext" )
  if backpackext_parts_p[num]~=0 then 
  
      local new_pos = backpackext_fy-backpackext_parts_p[num]*backpackext_num_step;
      
      ld.Lock(1);
      ObjAnimate( "spr_backpackext_number"..num, 1, 0, 0, func_end, {0,0,cur_pos, 0.5,0,new_pos} );
  
  else
      local func_preend = function()
         ObjSet( "spr_backpackext_number"..num, {pos_y=backpackext_fy + 0.5*backpackext_num_step} );
         local new_pos2 = backpackext_fy; 
         ObjAnimate( "spr_backpackext_number"..num, 1, 0, 0, func_end, {0,0,(backpackext_fy + 0.5*backpackext_num_step), 0.25,0,new_pos2} );  
      end;  
      
      local new_pos = backpackext_fy-9.5*backpackext_num_step;   
      ld.Lock(1);
      ObjAnimate( "spr_backpackext_number"..num, 1, 0, 0, func_preend, {0,0,cur_pos, 0.25,0,new_pos} );
      
  end;    
  
end;
 

function public.backpackext_win_ver()
  if backpackext_parts_p[1]==4 and backpackext_parts_p[2]==7 and backpackext_parts_p[3]==2 then 
    public.clk_diarycodeext();
  end;  
end;  


common_impl.hint[ "clk_diarycodeext" ] = { type = "click", use_place = "obj_backpackext_num_root", room = "inv_complex_inv", zz = "inv_complex_backpackext", zz_gate = "inv_backpackext" };

private.clk_diarycodeext_logic = function()
    ObjSet( "gfx_backpackext_clk_diarycodeext2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_diarycodeext_beg = function()
  ObjDelete( "obj_backpackext_parts_root" );
end;
private.clk_diarycodeext_end = function()
  ObjSet( "anm_backpackext_anm", {animfunc = "click_on_bag", frame = 0 } );
  ObjDelete("anm_backpackext_anm_code");
  ObjDelete("inv_backpackext_back");
  ObjSet( "inv_backpackext_tr_1", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_diarycodeext", private.clk_diarycodeext_beg );
cmn.AddSubscriber( "clk_diarycodeext", private.clk_diarycodeext_end );
cmn.AddSubscriber( "clk_diarycodeext", private.clk_diarycodeext_logic );
cmn.AddSubscriber( "clk_diarycodeext_beg", private.clk_diarycodeext_beg );
cmn.AddSubscriber( "clk_diarycodeext_end", private.clk_diarycodeext_end );
cmn.AddSubscriber( "clk_diarycodeext_end", private.clk_diarycodeext_logic );
--------------------------------------------------------------------------------------------
function public.clk_diarycodeext()

  local func_end = function()
    cmn.SetEventDone( "clk_diarycodeext" );
    cmn.CallEventHandler( "clk_diarycodeext_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_diarycodeext_beg" );
  common_impl.Lock(1);

  ObjAnimate( "anm_backpackext_anm_code", 8, 0, 0, func_end, {0,0,1, 0.5,0,0} );
  ld.AnimPlay( "anm_backpackext_anm", "open_bag",function() end);
  SoundSfx( "aud_backpackext_open" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_diarycodeext2" ] = { type = "click", use_place = "gfx_backpackext_clk_diarycodeext2_zone", room = "inv_complex_inv", zz = "inv_complex_backpackext", zz_gate = "inv_backpackext" };

private.clk_diarycodeext2_logic = function()
  ObjSet( "spr_backpackext_pocketknifeext", { visible = 1, input = 1, active = 1 } )

end;
private.clk_diarycodeext2_beg = function()
  ObjDelete( "gfx_backpackext_clk_diarycodeext2_zone" );
end;
private.clk_diarycodeext2_end = function()
  ObjSet( "anm_backpackext_anm", {animfunc = "bag_static", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_diarycodeext2", private.clk_diarycodeext2_beg );
cmn.AddSubscriber( "clk_diarycodeext2", private.clk_diarycodeext2_end );
cmn.AddSubscriber( "clk_diarycodeext2", private.clk_diarycodeext2_logic );
cmn.AddSubscriber( "clk_diarycodeext2_beg", private.clk_diarycodeext2_beg );
cmn.AddSubscriber( "clk_diarycodeext2_end", private.clk_diarycodeext2_end );
cmn.AddSubscriber( "clk_diarycodeext2_end", private.clk_diarycodeext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_diarycodeext2()

  local func_end = function()
    cmn.SetEventDone( "clk_diarycodeext2" );
    cmn.CallEventHandler( "clk_diarycodeext2_end" );
    common_impl.Lock(0);
    public.get_pocketknifeext();
  end;

  cmn.CallEventHandler( "clk_diarycodeext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_backpackext_anm", "click_on_bag",func_end);
  SoundSfx( "aud_backpackext_touch" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pocketknifeext" ] = { type = "get", get_obj = "spr_backpackext_pocketknifeext", room = "inv_complex_inv", zz = "inv_complex_backpackext", zz_gate = "inv_backpackext" };

private.get_pocketknifeext_logic = function()
 
end;
private.get_pocketknifeext_inv = function()
  interface.InventoryItemAdd("inv_pocketknifeext","spr_backpackext_pocketknifeext");
  if common_impl.ZzCompleteCheck("get_pocketknifeext") then interface.InventoryItemRemove("inv_backpackext") end;
end;
private.get_pocketknifeext_beg = function()
  ObjDelete("gfx_backpackext_pocketknifeext");
end;
private.get_pocketknifeext_end = function()
  
end;

cmn.AddSubscriber( "get_pocketknifeext", private.get_pocketknifeext_inv );
cmn.AddSubscriber( "get_pocketknifeext", private.get_pocketknifeext_beg );
cmn.AddSubscriber( "get_pocketknifeext", private.get_pocketknifeext_end );
cmn.AddSubscriber( "get_pocketknifeext", private.get_pocketknifeext_logic );
--------------------------------------------------------------------
function public.get_pocketknifeext()
  cmn.SetEventDone( "get_pocketknifeext" );
  cmn.CallEventHandler( "get_pocketknifeext" );
  if common_impl.ZzCompleteCheck("get_pocketknifeext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
function public.backpackext_preopen()
  if not cmn.IsEventDone("clk_diarycodeext") then 
    private.backpackext_stand_num();
  end;  
end;  
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_pouchext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_opnpouchext" ] = { type = "click", use_place = "gfx_pouchext_clk_opnpouchext_zone", room = "inv_complex_inv", zz = "inv_complex_pouchext", zz_gate = "inv_pouchext" };

private.clk_opnpouchext_logic = function()
  ObjSet( "spr_pouchext_bluewireext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_pouchext_decorpartext1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_pouchext_handlesquareext", { visible = 1, input = 1, active = 1 } )
end;
private.clk_opnpouchext_beg = function()
  ObjDelete( "gfx_pouchext_clk_opnpouchext_zone" );
end;
private.clk_opnpouchext_end = function()
  ObjSet( "anm_pouchext_anm", {animfunc = "end", frame = 0 } );
  ObjSet( "spr_pouchext_trash", {visible = 1} );
  ObjDelete("inv_pouchext_back");
  ObjSet( "inv_pouchext_st2", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_opnpouchext", private.clk_opnpouchext_beg );
cmn.AddSubscriber( "clk_opnpouchext", private.clk_opnpouchext_end );
cmn.AddSubscriber( "clk_opnpouchext", private.clk_opnpouchext_logic );
cmn.AddSubscriber( "clk_opnpouchext_beg", private.clk_opnpouchext_beg );
cmn.AddSubscriber( "clk_opnpouchext_end", private.clk_opnpouchext_end );
cmn.AddSubscriber( "clk_opnpouchext_end", private.clk_opnpouchext_logic );
--------------------------------------------------------------------------------------------
function public.clk_opnpouchext()

  local func_end = function()
    cmn.SetEventDone( "clk_opnpouchext" );
    cmn.CallEventHandler( "clk_opnpouchext_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_opnpouchext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pouchext_anm", "cklik", func_end );
  SoundSfx( "aud_clk_opnpouchext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bluewireext" ] = { type = "get", get_obj = "spr_pouchext_bluewireext", room = "inv_complex_inv", zz = "inv_complex_pouchext", zz_gate = "inv_pouchext" };

private.get_bluewireext_logic = function()
 
end;
private.get_bluewireext_inv = function()
  interface.InventoryItemAdd("inv_bluewireext","spr_pouchext_bluewireext");
  if common_impl.ZzCompleteCheck("get_bluewireext") then interface.InventoryItemRemove("inv_pouchext") end;
end;
private.get_bluewireext_beg = function()
  ObjDelete("gfx_pouchext_bluewireext");
end;
private.get_bluewireext_end = function()
  ObjDelete("inv_pouchext_st4")
end;

cmn.AddSubscriber( "get_bluewireext", private.get_bluewireext_inv );
cmn.AddSubscriber( "get_bluewireext", private.get_bluewireext_beg );
cmn.AddSubscriber( "get_bluewireext", private.get_bluewireext_end );
cmn.AddSubscriber( "get_bluewireext", private.get_bluewireext_logic );
--------------------------------------------------------------------
function public.get_bluewireext()
  cmn.SetEventDone( "get_bluewireext" );
  cmn.CallEventHandler( "get_bluewireext" );
  if common_impl.ZzCompleteCheck("get_bluewireext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_decorpartext1" ] = { type = "get", get_obj = "spr_pouchext_decorpartext1", room = "inv_complex_inv", zz = "inv_complex_pouchext", zz_gate = "inv_pouchext" };

private.get_decorpartext1_logic = function()
 
end;
private.get_decorpartext1_inv = function()
  interface.InventoryItemAdd("inv_decorpartext","spr_pouchext_decorpartext1",function() level_inv.ProcessGetDecorpartextAll( "get_decorpartext1" ) end);
  if common_impl.ZzCompleteCheck("get_decorpartext1") then interface.InventoryItemRemove("inv_pouchext") end;
end;
private.get_decorpartext1_beg = function()
  ObjDelete("gfx_pouchext_decorpartext1");
end;
private.get_decorpartext1_end = function()
  ObjDelete("inv_pouchext_st5");
end;

cmn.AddSubscriber( "get_decorpartext1", private.get_decorpartext1_inv );
cmn.AddSubscriber( "get_decorpartext1", private.get_decorpartext1_beg );
cmn.AddSubscriber( "get_decorpartext1", private.get_decorpartext1_end );
cmn.AddSubscriber( "get_decorpartext1", private.get_decorpartext1_logic );
--------------------------------------------------------------------
function public.get_decorpartext1()
  cmn.SetEventDone( "get_decorpartext1" );
  cmn.CallEventHandler( "get_decorpartext1" );
  if common_impl.ZzCompleteCheck("get_decorpartext1") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_handlesquareext" ] = { type = "get", get_obj = "spr_pouchext_handlesquareext", room = "inv_complex_inv", zz = "inv_complex_pouchext", zz_gate = "inv_pouchext" };

private.get_handlesquareext_logic = function()
 
end;
private.get_handlesquareext_inv = function()
  interface.InventoryItemAdd("inv_handlesquareext","spr_pouchext_handlesquareext");
  if common_impl.ZzCompleteCheck("get_handlesquareext") then interface.InventoryItemRemove("inv_pouchext") end;
end;
private.get_handlesquareext_beg = function()
  ObjDelete("gfx_pouchext_handlesquareext");
end;
private.get_handlesquareext_end = function()
  ObjDelete("inv_pouchext_st3")
end;

cmn.AddSubscriber( "get_handlesquareext", private.get_handlesquareext_inv );
cmn.AddSubscriber( "get_handlesquareext", private.get_handlesquareext_beg );
cmn.AddSubscriber( "get_handlesquareext", private.get_handlesquareext_end );
cmn.AddSubscriber( "get_handlesquareext", private.get_handlesquareext_logic );
--------------------------------------------------------------------
function public.get_handlesquareext()
  cmn.SetEventDone( "get_handlesquareext" );
  cmn.CallEventHandler( "get_handlesquareext" );
  if common_impl.ZzCompleteCheck("get_handlesquareext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_parcelext *** () end
--*********************************************************************************************************************
----------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_opnparcelext" ] = { type = "click", use_place = "gfx_parcelext_clk_opnparcelext_zone", room = "inv_complex_inv", zz = "inv_complex_parcelext", zz_gate = "inv_parcelext" };
--
--private.clk_opnparcelext_logic = function()
--  ObjSet( "gfx_parcelext_clk_opnparcelext2_zone", { visible = 1, input = 1, active = 1 } )
--
--end;
--private.clk_opnparcelext_beg = function()
--  ObjDelete( "gfx_parcelext_clk_opnparcelext_zone" );
--end;
--private.clk_opnparcelext_end = function()
--   ObjSet( "anm_parcelext_anm", {animfunc = "cleek_2", frame = 0 } );
--   ObjDelete( "inv_parcelext_back");
--   ObjSet( "inv_parcelext_state_2", {alp=1} );
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_opnparcelext", private.clk_opnparcelext_beg );
--cmn.AddSubscriber( "clk_opnparcelext", private.clk_opnparcelext_end );
--cmn.AddSubscriber( "clk_opnparcelext", private.clk_opnparcelext_logic );
--cmn.AddSubscriber( "clk_opnparcelext_beg", private.clk_opnparcelext_beg );
--cmn.AddSubscriber( "clk_opnparcelext_end", private.clk_opnparcelext_end );
--cmn.AddSubscriber( "clk_opnparcelext_end", private.clk_opnparcelext_logic );
----------------------------------------------------------------------------------------------
--function public.clk_opnparcelext()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_opnparcelext" );
--    cmn.CallEventHandler( "clk_opnparcelext_end" );
--    common_impl.Lock(0);
--  end;
--
--  cmn.CallEventHandler( "clk_opnparcelext_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_parcelext_anm", "cleek_1", func_end );
--  SoundSfx( "aud_clk_opnparcelext" )
--  --func_end()
--
--end;
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_opnparcelext2" ] = { type = "click", use_place = "gfx_parcelext_clk_opnparcelext2_zone", room = "inv_complex_inv", zz = "inv_complex_parcelext", zz_gate = "inv_parcelext" };
--
--private.clk_opnparcelext2_logic = function()
--  ObjSet( "gfx_parcelext_clk_readletterext_zone", {active=1, input = 1, visible = 1} );
--  --   ObjSet( "spr_parcelext_yellowwireext", { visible = 0, input = 1, active = 1 } )
--  -- ObjSet( "gfx_parcelext_yellowwireext", {active=1, visible=1} );
--end;
--private.clk_opnparcelext2_beg = function()
--  ObjDelete( "gfx_parcelext_clk_opnparcelext2_zone" );
--end;
--private.clk_opnparcelext2_end = function()
--  ObjSet( "anm_parcelext_anm", {animfunc = "end_cleek_2", frame = 0 } );
--  ObjDelete( "inv_parcelext_state_2");
--  ObjSet( "inv_parcelext_state_3", {alp=1} );
-- end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_opnparcelext2", private.clk_opnparcelext2_beg );
--cmn.AddSubscriber( "clk_opnparcelext2", private.clk_opnparcelext2_end );
--cmn.AddSubscriber( "clk_opnparcelext2", private.clk_opnparcelext2_logic );
--cmn.AddSubscriber( "clk_opnparcelext2_beg", private.clk_opnparcelext2_beg );
--cmn.AddSubscriber( "clk_opnparcelext2_end", private.clk_opnparcelext2_end );
--cmn.AddSubscriber( "clk_opnparcelext2_end", private.clk_opnparcelext2_logic );
----------------------------------------------------------------------------------------------
--function public.clk_opnparcelext2()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_opnparcelext2" );
--    cmn.CallEventHandler( "clk_opnparcelext2_end" );
--    common_impl.Lock(0);
--  end;
--
--  cmn.CallEventHandler( "clk_opnparcelext2_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_parcelext_anm", "cleek_2", func_end );
--  SoundSfx( "aud_clk_opnparcelext" )
--  --func_end()
--
--end;
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_readletterext" ] = { type = "click", use_place = "gfx_parcelext_clk_readletterext_zone", room = "inv_complex_inv", zz = "inv_complex_parcelext", zz_gate = "inv_parcelext" };
--
--private.clk_readletterext_logic = function()
--  ObjSet( "gfx_parcelext_clk_readletterext2_zone", { visible = 1, input = 1, active = 1 } )
--
--end;
--private.clk_readletterext_beg = function()
--  ObjDelete( "gfx_parcelext_clk_readletterext_zone" );
--end;
--private.clk_readletterext_end = function()
--  ObjSet( "anm_parcelext_anm", {animfunc = "paper1", frame = 0 } );
--  --  ObjSet( "inv_parcelext_state_4", {alp=0});
--  -- ObjSet( "inv_parcelext_state_5", {alp=1} );
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_readletterext", private.clk_readletterext_beg );
--cmn.AddSubscriber( "clk_readletterext", private.clk_readletterext_end );
--cmn.AddSubscriber( "clk_readletterext", private.clk_readletterext_logic );
--cmn.AddSubscriber( "clk_readletterext_beg", private.clk_readletterext_beg );
--cmn.AddSubscriber( "clk_readletterext_end", private.clk_readletterext_end );
--cmn.AddSubscriber( "clk_readletterext_end", private.clk_readletterext_logic );
----------------------------------------------------------------------------------------------
--function public.clk_readletterext()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_readletterext" );
--    cmn.CallEventHandler( "clk_readletterext_end" );
--    common_impl.Lock(0);
--  end;
--
--  cmn.CallEventHandler( "clk_readletterext_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_parcelext_anm", "paper", func_end );
--  SoundSfx( "aud_clk_readletterext" )
--  --func_end()
--
--end;
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_readletterext2" ] = { type = "click", use_place = "gfx_parcelext_clk_readletterext2_zone", room = "inv_complex_inv", zz = "inv_complex_parcelext", zz_gate = "inv_parcelext" };
--
--private.clk_readletterext2_logic = function()
--  -- ObjSet( "gfx_parcelext_clk_readletterext2_zone", { visible = 1, input = 1, active = 1 } )
--   ObjSet( "spr_parcelext_yellowwireext", { visible = 0, input = 1, active = 1 } )
--   ObjSet( "gfx_parcelext_yellowwireext", {active=1, visible=1} );
--end;
--private.clk_readletterext2_beg = function()
--  ObjDelete( "gfx_parcelext_clk_readletterext2_zone" );
--end;
--private.clk_readletterext2_end = function()
--  ObjSet( "anm_parcelext_anm", {animfunc = "paper1", frame = 999 } );
--  ObjDelete( "inv_parcelext_state_3");
--  ObjSet( "inv_parcelext_state_4", {alp=1} );
--  -- interface.InventoryItemRemove("inv_parcelext");
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_readletterext2", private.clk_readletterext2_beg );
--cmn.AddSubscriber( "clk_readletterext2", private.clk_readletterext2_end );
--cmn.AddSubscriber( "clk_readletterext2", private.clk_readletterext2_logic );
--cmn.AddSubscriber( "clk_readletterext2_beg", private.clk_readletterext2_beg );
--cmn.AddSubscriber( "clk_readletterext2_end", private.clk_readletterext2_end );
--cmn.AddSubscriber( "clk_readletterext2_end", private.clk_readletterext2_logic );
----------------------------------------------------------------------------------------------
--function public.clk_readletterext2()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_readletterext2" );
--    cmn.CallEventHandler( "clk_readletterext2_end" );
--    common_impl.Lock(0);
--  end;
--
--  cmn.CallEventHandler( "clk_readletterext2_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_parcelext_anm", "paper1", func_end );
--  SoundSfx( "aud_clk_readletterext" )
--  --func_end()
--
--end;
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------
--common_impl.hint[ "get_yellowwireext" ] = { type = "get", get_obj = "spr_parcelext_yellowwireext", room = "inv_complex_inv", zz = "inv_complex_parcelext", zz_gate = "inv_parcelext" };
--
--private.get_yellowwireext_logic = function()
--  -- ObjSet( "gfx_parcelext_clk_readletterext_zone", {active=1, input = 1, visible = 1} );
--end;
--private.get_yellowwireext_inv = function()
--  interface.InventoryItemAdd("inv_yellowwireext","spr_parcelext_yellowwireext");
--  if common_impl.ZzCompleteCheck("get_yellowwireext") then interface.InventoryItemRemove("inv_parcelext") end;
--end;
--private.get_yellowwireext_beg = function()
--  ObjDelete("gfx_parcelext_yellowwireext");
--end;
--private.get_yellowwireext_end = function()
--  ObjSet( "anm_parcelext_anm", {animfunc = "end", frame = 0 } );
--  ObjDelete( "inv_parcelext_state_4");
--  ObjSet( "inv_parcelext_state_5", {alp=1} );
--end;
--
--cmn.AddSubscriber( "get_yellowwireext", private.get_yellowwireext_inv );
--cmn.AddSubscriber( "get_yellowwireext", private.get_yellowwireext_beg );
--cmn.AddSubscriber( "get_yellowwireext", private.get_yellowwireext_end );
--cmn.AddSubscriber( "get_yellowwireext", private.get_yellowwireext_logic );
----------------------------------------------------------------------
--function public.get_yellowwireext()
--  ObjSet( "spr_parcelext_yellowwireext", {visible = 1} );
--  cmn.SetEventDone( "get_yellowwireext" );
--  cmn.CallEventHandler( "get_yellowwireext" );
--  if common_impl.ZzCompleteCheck("get_yellowwireext") then common_impl.HideComplexItem() end;
--end
----------------------------------------------------------------------
--------------------------------------------------------------------
--function public.parcelext_preclose()
--    if ld.CheckRequirements({"clk_readletterext"}) and not cmn.IsEventDone("clk_readletterext2") then
--       cmn.SetEventDone( "clk_readletterext2" );
--       common_impl.HideComplexItem()
--       interface.InventoryItemRemove("inv_parcelext")
--    end
--end
--  
--function public.casket_close()
--
--end    
--------------------------------------------------------------------
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_bombmapext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.bombmapext_open()
  if  cmn.IsEventDone("get_bombmapext") and not cmn.IsEventDone("clk_anmbombext1") then 
     public.clk_anmbombext1();
  end;   
   
   --if cmn.IsEventDone("win_bombext2") and not cmn.IsEventDone("clk_anmbombext2") then 
  if cmn.IsEventDone("get_keyboothext") and not cmn.IsEventDone("clk_anmbombext2") then   
    public.clk_anmbombext2();
  end;

  if cmn.IsEventDone("win_bombthreeext") and not cmn.IsEventDone("clk_anmbombext3") then 
    public.clk_anmbombext3();
  end;  
  
  -- if cmn.IsEventDone("win_bombext4") and not cmn.IsEventDone("clk_anmbombext4") then
  if cmn.IsEventDone("get_keyboxext") and not cmn.IsEventDone("clk_anmbombext4") then   
    public.clk_anmbombext4();
  end;  
  
  -- if cmn.IsEventDone("win_bowlingext") and not cmn.IsEventDone("clk_anmbombext5") then
  if cmn.IsEventDone("get_badgelightningext") and not cmn.IsEventDone("clk_anmbombext5") then  
    public.clk_anmbombext5();
  end;  
end;  


function public.opnbombmapext_win_open()
   common_impl.ShowComplexItem( 'bombmapext' )
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_opnbombmapext" ] = { type = "click", use_place = "gfx_bombmapext_clk_opnbombmapext_zone", room = "inv_complex_inv", zz = "inv_complex_bombmapext", zz_gate = "inv_bombmapext" };

private.clk_opnbombmapext_logic = function()

end;
private.clk_opnbombmapext_beg = function()
  ObjDelete( "gfx_bombmapext_clk_opnbombmapext_zone" );
end;
private.clk_opnbombmapext_end = function()
  ObjDelete("vid_bombmapext_bombmap")
  ObjSet( "obj_bombmapext_map", {alp = 1} );
  ObjDelete("inv_bombmapext_back")
  ObjSet( "inv_bombmapext_map", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_opnbombmapext", private.clk_opnbombmapext_beg );
cmn.AddSubscriber( "clk_opnbombmapext", private.clk_opnbombmapext_end );
cmn.AddSubscriber( "clk_opnbombmapext", private.clk_opnbombmapext_logic );
cmn.AddSubscriber( "clk_opnbombmapext_beg", private.clk_opnbombmapext_beg );
cmn.AddSubscriber( "clk_opnbombmapext_end", private.clk_opnbombmapext_end );
cmn.AddSubscriber( "clk_opnbombmapext_end", private.clk_opnbombmapext_logic );
--------------------------------------------------------------------------------------------
function public.clk_opnbombmapext(without_unlock)

  local func_end = function()
    cmn.SetEventDone( "clk_opnbombmapext" );
    cmn.CallEventHandler( "clk_opnbombmapext_end" );
    if without_unlock~=true then  common_impl.Lock(0); end;
    ld.ShowBbt("opnbombmapext");
  end;

  cmn.CallEventHandler( "clk_opnbombmapext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_bombmap_open" )
  VidPlay("vid_bombmapext_bombmap",func_end)
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmbombext1" ] = { type = "click", use_place = "gfx_bombmapext_clk_anmbombext1_zone", room = "inv_complex_inv", zz = "inv_complex_bombmapext", zz_gate = "inv_bombmapext" };

private.clk_anmbombext1_logic = function()

end;
private.clk_anmbombext1_beg = function()
  ObjDelete( "gfx_bombmapext_clk_anmbombext1_zone" );
end;
private.clk_anmbombext1_end = function()
  ObjSet( "anm_bombmapext_anm_boom_1", {animfunc = "krest", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmbombext1", private.clk_anmbombext1_beg );
cmn.AddSubscriber( "clk_anmbombext1", private.clk_anmbombext1_end );
cmn.AddSubscriber( "clk_anmbombext1", private.clk_anmbombext1_logic );
cmn.AddSubscriber( "clk_anmbombext1_beg", private.clk_anmbombext1_beg );
cmn.AddSubscriber( "clk_anmbombext1_end", private.clk_anmbombext1_end );
cmn.AddSubscriber( "clk_anmbombext1_end", private.clk_anmbombext1_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmbombext1()

 
  local func_end = function()
    cmn.SetEventDone( "clk_anmbombext1" );
    cmn.CallEventHandler( "clk_anmbombext1_end" );
    common_impl.Lock(0);
    ld.ShowBbt("afterclkbombmapext1");
  end;

  local func_preend2 = function()
   
    ld.AnimPlay( "anm_bombmapext_anm_boom_1", "krest", func_end );
    SoundSfx( "aud_bombmap_cross" )
  end;  
  
  local func_preend1 = function()
    cmn.CallEventHandler( "clk_anmbombext1_beg" );
    
    --  common_impl.ShowComplexItem( 'bombmapext' )
    ld.StartTimer( 0.5, func_preend2 );
  end;
  --func_end()

  common_impl.Lock(1);
  if cmn.IsEventDone("clk_opnbombmapext") then 
     func_preend1();
  else 
     public.clk_opnbombmapext(true); --without_unlock
     ld.StartTimer( 4, func_preend1 ) ;
  end;  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmbombext2" ] = { type = "click", use_place = "gfx_bombmapext_clk_anmbombext2_zone", room = "inv_complex_inv", zz = "inv_complex_bombmapext", zz_gate = "inv_bombmapext" };

private.clk_anmbombext2_logic = function()

end;
private.clk_anmbombext2_beg = function()
  ObjDelete( "gfx_bombmapext_clk_anmbombext2_zone" );
end;
private.clk_anmbombext2_end = function()
   ObjSet( "anm_bombmapext_anm_boom_2", {animfunc = "krest", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmbombext2", private.clk_anmbombext2_beg );
cmn.AddSubscriber( "clk_anmbombext2", private.clk_anmbombext2_end );
cmn.AddSubscriber( "clk_anmbombext2", private.clk_anmbombext2_logic );
cmn.AddSubscriber( "clk_anmbombext2_beg", private.clk_anmbombext2_beg );
cmn.AddSubscriber( "clk_anmbombext2_end", private.clk_anmbombext2_end );
cmn.AddSubscriber( "clk_anmbombext2_end", private.clk_anmbombext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmbombext2()

  local func_end = function()
    cmn.SetEventDone( "clk_anmbombext2" );
    cmn.CallEventHandler( "clk_anmbombext2_end" );
    common_impl.Lock(0);
    ld.ShowBbt("afterclkbombmapext2");
  end;

  local func_preend = function()
   
    ld.AnimPlay( "anm_bombmapext_anm_boom_2", "krest", func_end );
    SoundSfx( "aud_bombmap_cross" )
  end;  
  
  local func_preend1 = function()
      cmn.CallEventHandler( "clk_anmbombext2_beg" );
      --common_impl.ShowComplexItem( 'bombmapext' )
      ld.StartTimer( 0.5, func_preend );
  end
  
  common_impl.Lock(1);
  if cmn.IsEventDone("clk_opnbombmapext") then 
     func_preend1();
  else 
     public.clk_opnbombmapext(true); --without_unlock
     ld.StartTimer( 4, func_preend1 ) ;
  end;  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmbombext3" ] = { type = "click", use_place = "gfx_bombmapext_clk_anmbombext3_zone", room = "inv_complex_inv", zz = "inv_complex_bombmapext", zz_gate = "inv_bombmapext" };

private.clk_anmbombext3_logic = function()

end;
private.clk_anmbombext3_beg = function()
  ObjDelete( "gfx_bombmapext_clk_anmbombext3_zone" );
end;
private.clk_anmbombext3_end = function()
   ObjSet( "anm_bombmapext_anm_boom_3", {animfunc = "krest", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmbombext3", private.clk_anmbombext3_beg );
cmn.AddSubscriber( "clk_anmbombext3", private.clk_anmbombext3_end );
cmn.AddSubscriber( "clk_anmbombext3", private.clk_anmbombext3_logic );
cmn.AddSubscriber( "clk_anmbombext3_beg", private.clk_anmbombext3_beg );
cmn.AddSubscriber( "clk_anmbombext3_end", private.clk_anmbombext3_end );
cmn.AddSubscriber( "clk_anmbombext3_end", private.clk_anmbombext3_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmbombext3()

  local func_end = function()
     cmn.SetEventDone( "clk_anmbombext3" );
     cmn.CallEventHandler( "clk_anmbombext3_end" );
    common_impl.Lock(0);
    ld.ShowBbt("afterclkbombmapext3");
  end;

  local func_preend = function()
   
    ld.AnimPlay( "anm_bombmapext_anm_boom_3", "krest", func_end );
    SoundSfx( "aud_bombmap_cross" )
  end;  
  
  local func_preend1 = function()
      cmn.CallEventHandler( "clk_anmbombext3_beg" );  
      --  common_impl.ShowComplexItem( 'bombmapext' )
      ld.StartTimer( 0.5, func_preend );
  end;
  
  common_impl.Lock(1);
  if cmn.IsEventDone("clk_opnbombmapext") then 
     func_preend1();
  else 
     public.clk_opnbombmapext(true); --without_unlock
     ld.StartTimer( 4, func_preend1 ) ;
  end;  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmbombext4" ] = { type = "click", use_place = "gfx_bombmapext_clk_anmbombext4_zone", room = "inv_complex_inv", zz = "inv_complex_bombmapext", zz_gate = "inv_bombmapext" };

private.clk_anmbombext4_logic = function()

end;
private.clk_anmbombext4_beg = function()
  ObjDelete( "gfx_bombmapext_clk_anmbombext4_zone" );
end;
private.clk_anmbombext4_end = function()
   ObjSet( "anm_bombmapext_anm_boom_4", {animfunc = "krest", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmbombext4", private.clk_anmbombext4_beg );
cmn.AddSubscriber( "clk_anmbombext4", private.clk_anmbombext4_end );
cmn.AddSubscriber( "clk_anmbombext4", private.clk_anmbombext4_logic );
cmn.AddSubscriber( "clk_anmbombext4_beg", private.clk_anmbombext4_beg );
cmn.AddSubscriber( "clk_anmbombext4_end", private.clk_anmbombext4_end );
cmn.AddSubscriber( "clk_anmbombext4_end", private.clk_anmbombext4_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmbombext4()

  local func_end = function()
    cmn.SetEventDone( "clk_anmbombext4" );
    cmn.CallEventHandler( "clk_anmbombext4_end" );
    common_impl.Lock(0);
     ld.ShowBbt("afterclkbombmapext4");
  end;

  local func_preend = function()
   
    ld.AnimPlay( "anm_bombmapext_anm_boom_4", "krest", func_end );
    SoundSfx( "aud_bombmap_cross" )
  end;  
  
  local func_preend1 = function() 
     cmn.CallEventHandler( "clk_anmbombext4_beg" );
     
     --common_impl.Lock(1);
     --common_impl.ShowComplexItem( 'bombmapext' )
     ld.StartTimer( 0.5, func_preend );
  end;

  common_impl.Lock(1);
  if cmn.IsEventDone("clk_opnbombmapext") then 
     func_preend1();
  else 
     public.clk_opnbombmapext(true); --without_unlock
     ld.StartTimer( 4, func_preend1 ) ;
  end;  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmbombext5" ] = { type = "click", use_place = "gfx_bombmapext_clk_anmbombext5_zone", room = "inv_complex_inv", zz = "inv_complex_bombmapext", zz_gate = "inv_bombmapext" };

private.clk_anmbombext5_logic = function()
   ObjSet( "gfx_bombmapext_clk_anmbombext6_zone", {active=1, input = 1, visible = 1} );
end;
private.clk_anmbombext5_beg = function()
  ObjDelete( "gfx_bombmapext_clk_anmbombext5_zone" );
end;
private.clk_anmbombext5_end = function()
    ObjSet( "anm_bombmapext_anm_boom_5", {animfunc = "krest", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmbombext5", private.clk_anmbombext5_beg );
cmn.AddSubscriber( "clk_anmbombext5", private.clk_anmbombext5_end );
cmn.AddSubscriber( "clk_anmbombext5", private.clk_anmbombext5_logic );
cmn.AddSubscriber( "clk_anmbombext5_beg", private.clk_anmbombext5_beg );
cmn.AddSubscriber( "clk_anmbombext5_end", private.clk_anmbombext5_end );
cmn.AddSubscriber( "clk_anmbombext5_end", private.clk_anmbombext5_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmbombext5()

  local func_end = function()
    cmn.SetEventDone( "clk_anmbombext5" );
    cmn.CallEventHandler( "clk_anmbombext5_end" );
    common_impl.Lock(0);
     ld.ShowBbt("afterclkbombmapext5");
  end;

  local func_preend = function()
   
    ld.AnimPlay( "anm_bombmapext_anm_boom_5", "krest", func_end );
    SoundSfx( "aud_bombmap_cross" )
  end;  
  
  local func_preend1 = function()
      cmn.CallEventHandler( "clk_anmbombext5_beg" );  
      -- common_impl.Lock(1);
      --common_impl.ShowComplexItem( 'bombmapext' )
      ld.StartTimer( 0.5, func_preend );
  end;

  common_impl.Lock(1);
  if cmn.IsEventDone("clk_opnbombmapext") then 
     func_preend1();
  else 
     public.clk_opnbombmapext(true); --without_unlock
     ld.StartTimer( 4, func_preend1 ) ;
  end;  
end;

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmbombext6" ] = { type = "click", use_place = "gfx_bombmapext_clk_anmbombext6_zone", room = "inv_complex_inv", zz = "inv_complex_bombmapext", zz_gate = "inv_bombmapext" };

private.clk_anmbombext6_logic = function()

end;
private.clk_anmbombext6_beg = function()
  ObjDelete( "gfx_bombmapext_clk_anmbombext6_zone" );
end;
private.clk_anmbombext6_end = function()
   if common_impl.ZzCompleteCheck("clk_anmbombext6") then interface.InventoryItemRemove("inv_bombmapext") end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmbombext6", private.clk_anmbombext6_beg );
cmn.AddSubscriber( "clk_anmbombext6", private.clk_anmbombext6_end );
cmn.AddSubscriber( "clk_anmbombext6", private.clk_anmbombext6_logic );
cmn.AddSubscriber( "clk_anmbombext6_beg", private.clk_anmbombext6_beg );
cmn.AddSubscriber( "clk_anmbombext6_end", private.clk_anmbombext6_end );
cmn.AddSubscriber( "clk_anmbombext6_end", private.clk_anmbombext6_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmbombext6()

  local func_end = function()
    cmn.SetEventDone( "clk_anmbombext6" );
    cmn.CallEventHandler( "clk_anmbombext6_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_anmbombext6") then common_impl.HideComplexItem() end;
  end;

  cmn.CallEventHandler( "clk_anmbombext6_beg" );  
  common_impl.Lock(1);
  func_end();
  SoundSfx( "aud_paper_close" );  
end; 
 
 
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_cigarcaseext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletanchorext" ] = { type = "use", inv_obj = "inv_amuletanchorext", use_place = "gfx_cigarcaseext_amuletanchorext_zone", room = "inv_complex_inv", zz = "inv_complex_cigarcaseext", zz_gate = "inv_cigarcaseext" };

private.use_amuletanchorext_logic = function()
  ObjSet( "gfx_cigarcaseext_clk_cigarcaseext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletanchorext_inv = function()
  common_impl.ProcessMultiUseAll("amuletanchorext", "amuletanchorext")
end;
private.use_amuletanchorext_beg = function()
  ObjDelete( "gfx_cigarcaseext_amuletanchorext_zone" );
end;
private.use_amuletanchorext_end = function()
  ObjSet("inv_cigarcaseext_back",{alp=0})
  ObjSet( "inv_cigarcaseext_state_1", {alp=1} );
  ObjSet( "anm_cigarcaseext_anm", {animfunc="cleek",frame=0} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletanchorext", private.use_amuletanchorext_inv );
cmn.AddSubscriber( "use_amuletanchorext", private.use_amuletanchorext_beg );
cmn.AddSubscriber( "use_amuletanchorext", private.use_amuletanchorext_end );
cmn.AddSubscriber( "use_amuletanchorext", private.use_amuletanchorext_logic );
cmn.AddSubscriber( "use_amuletanchorext_inv", private.use_amuletanchorext_inv );
cmn.AddSubscriber( "use_amuletanchorext_beg", private.use_amuletanchorext_beg );
cmn.AddSubscriber( "use_amuletanchorext_end", private.use_amuletanchorext_end );
cmn.AddSubscriber( "use_amuletanchorext_end", private.use_amuletanchorext_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletanchorext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletanchorext" );
    cmn.CallEventHandler( "use_amuletanchorext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletanchorext_inv" );
  cmn.CallEventHandler( "use_amuletanchorext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_amuletanchorext_cigarcaseext" )
  
  ld.AnimPlay( "anm_cigarcaseext_anm", "use_anchor", func_end );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_cigarcaseext" ] = { type = "click", use_place = "gfx_cigarcaseext_clk_cigarcaseext_zone", room = "inv_complex_inv", zz = "inv_complex_cigarcaseext", zz_gate = "inv_cigarcaseext" };

private.clk_cigarcaseext_logic = function()
  ObjSet( "spr_cigarcaseext_stapleext", { visible = 1, input = 1, active = 1 } )
end;
private.clk_cigarcaseext_beg = function()
  ObjDelete( "gfx_cigarcaseext_clk_cigarcaseext_zone" );
end;
private.clk_cigarcaseext_end = function()
  ObjSet( "spr_cigarcaseext_sh_stapleext", {alp = 1} );
  ObjSet( "inv_cigarcaseext_state_2", {alp=1} )
  ObjSet( "inv_cigarcaseext_state_1", {alp=0} )
  ObjSet("anm_cigarcaseext_anm",{animfunc="end",frame=0})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_cigarcaseext", private.clk_cigarcaseext_beg );
cmn.AddSubscriber( "clk_cigarcaseext", private.clk_cigarcaseext_end );
cmn.AddSubscriber( "clk_cigarcaseext", private.clk_cigarcaseext_logic );
cmn.AddSubscriber( "clk_cigarcaseext_beg", private.clk_cigarcaseext_beg );
cmn.AddSubscriber( "clk_cigarcaseext_end", private.clk_cigarcaseext_end );
cmn.AddSubscriber( "clk_cigarcaseext_end", private.clk_cigarcaseext_logic );
--------------------------------------------------------------------------------------------
function public.clk_cigarcaseext()

  local func_end = function()
    cmn.SetEventDone( "clk_cigarcaseext" );
    cmn.CallEventHandler( "clk_cigarcaseext_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_cigarcaseext_beg" );
  common_impl.Lock(1);
  SoundSfx( "aud_clk_cigarcaseext" )
  
  ld.AnimPlay( "anm_cigarcaseext_anm", "cleek", func_end );
  SoundSfx( "aud_cigarcaseext_touch" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_stapleext" ] = { type = "get", get_obj = "spr_cigarcaseext_stapleext", room = "inv_complex_inv", zz = "inv_complex_cigarcaseext", zz_gate = "inv_cigarcaseext" };

private.get_stapleext_logic = function()
 
end;
private.get_stapleext_inv = function()
  interface.InventoryItemAdd("inv_stapleext","spr_cigarcaseext_stapleext");
  if common_impl.ZzCompleteCheck("get_stapleext") then interface.InventoryItemRemove("inv_cigarcaseext") end;
end;
private.get_stapleext_beg = function()
  ObjDelete("gfx_cigarcaseext_stapleext");
end;
private.get_stapleext_end = function()
  ObjDelete("spr_cigarcaseext_sh_stapleext")
end;

cmn.AddSubscriber( "get_stapleext", private.get_stapleext_inv );
cmn.AddSubscriber( "get_stapleext", private.get_stapleext_beg );
cmn.AddSubscriber( "get_stapleext", private.get_stapleext_end );
cmn.AddSubscriber( "get_stapleext", private.get_stapleext_logic );
--------------------------------------------------------------------
function public.get_stapleext()
  cmn.SetEventDone( "get_stapleext" );
  cmn.CallEventHandler( "get_stapleext" );
  if common_impl.ZzCompleteCheck("get_stapleext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_velvetboxext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuleteagleext1" ] = { type = "use", inv_obj = "inv_amuleteagleext1", use_place = "gfx_velvetboxext_amuleteagleext1_zone", room = "inv_complex_inv", zz = "inv_complex_velvetboxext", zz_gate = "inv_velvetboxext" };

private.use_amuleteagleext1_logic = function()
  if ld.CheckRequirements( {"use_amuleteagleext1","use_amuleteagleext2"} ) then
    ObjSet( "gfx_velvetboxext_clk_velvetboxopnext_zone", {input = 1, visible = 1, active = 1} );
  end;

end;
private.use_amuleteagleext1_inv = function()
  common_impl.ProcessMultiUseAll("amuleteagleext1", "amuleteagleext1")
end;
private.use_amuleteagleext1_beg = function()
  ObjDelete( "gfx_velvetboxext_amuleteagleext1_zone" );
end;
private.use_amuleteagleext1_end = function()
  if ld.CheckRequirements( {"use_amuleteagleext1","use_amuleteagleext2"} ) then
    ObjSet( "anm_velvetboxext_anm", {animfunc="open_box",frame=0} );
    ObjDelete("anm_velvetboxext_anm_1")
    ObjDelete("anm_velvetboxext_anm_2")    
  else 
    ObjSet( "anm_velvetboxext_anm_1", {animfunc="use_eagle",frame=999} );
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuleteagleext1", private.use_amuleteagleext1_inv );
cmn.AddSubscriber( "use_amuleteagleext1", private.use_amuleteagleext1_beg );
cmn.AddSubscriber( "use_amuleteagleext1", private.use_amuleteagleext1_end );
cmn.AddSubscriber( "use_amuleteagleext1", private.use_amuleteagleext1_logic );
cmn.AddSubscriber( "use_amuleteagleext1_inv", private.use_amuleteagleext1_inv );
cmn.AddSubscriber( "use_amuleteagleext1_beg", private.use_amuleteagleext1_beg );
cmn.AddSubscriber( "use_amuleteagleext1_end", private.use_amuleteagleext1_end );
cmn.AddSubscriber( "use_amuleteagleext1_end", private.use_amuleteagleext1_logic );
--------------------------------------------------------------------------------------------
function public.use_amuleteagleext1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuleteagleext1" );
    cmn.CallEventHandler( "use_amuleteagleext1_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuleteagleext1_inv" );
  cmn.CallEventHandler( "use_amuleteagleext1_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_amuleteagleext1_velvetboxext" )
  
  ld.AnimPlay( "anm_velvetboxext_anm_1", "use_eagle", func_end );
 

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuleteagleext2" ] = { type = "use", inv_obj = "inv_amuleteagleext2", use_place = "gfx_velvetboxext_amuleteagleext2_zone", room = "inv_complex_inv", zz = "inv_complex_velvetboxext", zz_gate = "inv_velvetboxext" };

private.use_amuleteagleext2_logic = function()
  if ld.CheckRequirements( {"use_amuleteagleext1","use_amuleteagleext2"} ) then
    ObjSet( "gfx_velvetboxext_clk_velvetboxopnext_zone", {input = 1, visible = 1, active = 1} );
  end;
end;
private.use_amuleteagleext2_inv = function()
  common_impl.ProcessMultiUseAll("amuleteagleext2", "amuleteagleext2")
end;
private.use_amuleteagleext2_beg = function()
  ObjDelete( "gfx_velvetboxext_amuleteagleext2_zone" );
end;
private.use_amuleteagleext2_end = function()
  if ld.CheckRequirements( {"use_amuleteagleext1","use_amuleteagleext2"} ) then
    ObjSet( "anm_velvetboxext_anm", {animfunc="open_box",frame=0} );
    ObjDelete("anm_velvetboxext_anm_1")
    ObjDelete("anm_velvetboxext_anm_2")      
  else 
    ObjSet( "anm_velvetboxext_anm_2", {animfunc="use_eagle1",frame=999} );
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuleteagleext2", private.use_amuleteagleext2_inv );
cmn.AddSubscriber( "use_amuleteagleext2", private.use_amuleteagleext2_beg );
cmn.AddSubscriber( "use_amuleteagleext2", private.use_amuleteagleext2_end );
cmn.AddSubscriber( "use_amuleteagleext2", private.use_amuleteagleext2_logic );
cmn.AddSubscriber( "use_amuleteagleext2_inv", private.use_amuleteagleext2_inv );
cmn.AddSubscriber( "use_amuleteagleext2_beg", private.use_amuleteagleext2_beg );
cmn.AddSubscriber( "use_amuleteagleext2_end", private.use_amuleteagleext2_end );
cmn.AddSubscriber( "use_amuleteagleext2_end", private.use_amuleteagleext2_logic );
--------------------------------------------------------------------------------------------
function public.use_amuleteagleext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuleteagleext2" );
    cmn.CallEventHandler( "use_amuleteagleext2_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuleteagleext2_inv" );
  cmn.CallEventHandler( "use_amuleteagleext2_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_amuleteagleext2_velvetboxext" )
  
  ld.AnimPlay( "anm_velvetboxext_anm_2", "use_eagle1", func_end );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_velvetboxopnext" ] = { type = "click", use_place = "gfx_velvetboxext_clk_velvetboxopnext_zone", room = "inv_complex_inv", zz = "inv_complex_velvetboxext", zz_gate = "inv_velvetboxext" };

private.clk_velvetboxopnext_logic = function()
  ObjSet( "spr_velvetboxext_keytrunkext", {input = 1, visible = 1, active = 1} );
end;
private.clk_velvetboxopnext_beg = function()
  ObjDelete( "gfx_velvetboxext_clk_velvetboxopnext_zone" );
end;
private.clk_velvetboxopnext_end = function()
  ObjSet( "spr_velvetboxext_key_shadow", {alp = 1} );
  ObjSet("anm_velvetboxext_anm",{animfunc="box_static",frame=0})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_velvetboxopnext", private.clk_velvetboxopnext_beg );
cmn.AddSubscriber( "clk_velvetboxopnext", private.clk_velvetboxopnext_end );
cmn.AddSubscriber( "clk_velvetboxopnext", private.clk_velvetboxopnext_logic );
cmn.AddSubscriber( "clk_velvetboxopnext_beg", private.clk_velvetboxopnext_beg );
cmn.AddSubscriber( "clk_velvetboxopnext_end", private.clk_velvetboxopnext_end );
cmn.AddSubscriber( "clk_velvetboxopnext_end", private.clk_velvetboxopnext_logic );
--------------------------------------------------------------------------------------------
function public.clk_velvetboxopnext()

  local func_end = function()
    cmn.SetEventDone( "clk_velvetboxopnext" );
    cmn.CallEventHandler( "clk_velvetboxopnext_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_velvetboxopnext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_velvetboxext_anm", "open_box", func_end );
  SoundSfx( "aud_velvetboxext_touch" )
  --func_end()

end;
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_keytrunkext" ] = { type = "get", get_obj = "spr_velvetboxext_keytrunkext", room = "inv_complex_inv", zz = "inv_complex_velvetboxext", zz_gate = "inv_velvetboxext" };

private.get_keytrunkext_logic = function()
 
end;
private.get_keytrunkext_inv = function()
  interface.InventoryItemAdd("inv_keytrunkext","spr_velvetboxext_keytrunkext");
  if common_impl.ZzCompleteCheck("get_keytrunkext") then interface.InventoryItemRemove("inv_velvetboxext") end;
end;
private.get_keytrunkext_beg = function()
  ObjDelete("gfx_velvetboxext_keytrunkext");
end;
private.get_keytrunkext_end = function()
  ObjDelete("spr_velvetboxext_key_shadow")
end;

cmn.AddSubscriber( "get_keytrunkext", private.get_keytrunkext_inv );
cmn.AddSubscriber( "get_keytrunkext", private.get_keytrunkext_beg );
cmn.AddSubscriber( "get_keytrunkext", private.get_keytrunkext_end );
cmn.AddSubscriber( "get_keytrunkext", private.get_keytrunkext_logic );
--------------------------------------------------------------------
function public.get_keytrunkext()
  cmn.SetEventDone( "get_keytrunkext" );
  cmn.CallEventHandler( "get_keytrunkext" );
  if common_impl.ZzCompleteCheck("get_keytrunkext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_cannedext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_cannedext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_openerext' ); 
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_plastic" );
  ld.AnimPlay( "anm_cannedext_anm", "tin_idle", func_end );
end; 
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "use_openerext" ] = { type = "use", inv_obj = "inv_openerext", use_place = "gfx_cannedext_openerext_zone", room = "inv_complex_inv", zz = "inv_complex_cannedext", zz_gate = "inv_cannedext" };

private.use_openerext_logic = function()
  ObjSet( "spr_cannedext_opencannedext", { visible = 1, input = 1, active = 1 } )

end;
private.use_openerext_inv = function()
  common_impl.ProcessMultiUseAll("openerext", "openerext")
end;
private.use_openerext_beg = function()
  ObjDelete( "gfx_cannedext_openerext_zone" );
end;
private.use_openerext_end = function()
  ObjDelete("anm_cannedext_anm");
  ObjDelete("inv_cannedext_back");
  ObjSet( "inv_cannedext_state_tr_1", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_openerext", private.use_openerext_inv );
cmn.AddSubscriber( "use_openerext", private.use_openerext_beg );
cmn.AddSubscriber( "use_openerext", private.use_openerext_end );
cmn.AddSubscriber( "use_openerext", private.use_openerext_logic );
cmn.AddSubscriber( "use_openerext_inv", private.use_openerext_inv );
cmn.AddSubscriber( "use_openerext_beg", private.use_openerext_beg );
cmn.AddSubscriber( "use_openerext_end", private.use_openerext_end );
cmn.AddSubscriber( "use_openerext_end", private.use_openerext_logic );
--------------------------------------------------------------------------------------------
function public.use_openerext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_openerext" );
    cmn.CallEventHandler( "use_openerext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_openerext_inv" );
  cmn.CallEventHandler( "use_openerext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_openerext_cannedext" )
  
  ld.AnimPlay( "anm_cannedext_anm", "use_opener", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_opencannedext" ] = { type = "get", get_obj = "spr_cannedext_opencannedext", room = "inv_complex_inv", zz = "inv_complex_cannedext", zz_gate = "inv_cannedext" };

private.get_opencannedext_logic = function()
 
end;
private.get_opencannedext_inv = function()
  interface.InventoryItemAdd("inv_opencannedext","spr_cannedext_opencannedext");
  if common_impl.ZzCompleteCheck("get_opencannedext") then interface.InventoryItemRemove("inv_cannedext") end;
end;
private.get_opencannedext_beg = function()
  ObjDelete("gfx_cannedext_opencannedext");
end;
private.get_opencannedext_end = function()
  
end;

cmn.AddSubscriber( "get_opencannedext", private.get_opencannedext_inv );
cmn.AddSubscriber( "get_opencannedext", private.get_opencannedext_beg );
cmn.AddSubscriber( "get_opencannedext", private.get_opencannedext_end );
cmn.AddSubscriber( "get_opencannedext", private.get_opencannedext_logic );
--------------------------------------------------------------------
function public.get_opencannedext()
  cmn.SetEventDone( "get_opencannedext" );
  cmn.CallEventHandler( "get_opencannedext" );
  if common_impl.ZzCompleteCheck("get_opencannedext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_leatherbagext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_threepointedstarext" ] = { type = "use", inv_obj = "inv_threepointedstarext", use_place = "gfx_leatherbagext_threepointedstarext_zone", room = "inv_complex_inv", zz = "inv_complex_leatherbagext", zz_gate = "inv_leatherbagext" };

private.use_threepointedstarext_logic = function()
  ObjSet( "gfx_leatherbagext_clk_leatherbagopnext1_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_threepointedstarext_inv = function()
  common_impl.ProcessMultiUseAll("threepointedstarext", "threepointedstarext")
end;
private.use_threepointedstarext_beg = function()
  ObjDelete( "gfx_leatherbagext_threepointedstarext_zone" );
end;
private.use_threepointedstarext_end = function()
  ObjSet( "anm_leatherbagext_anm_1", {animfunc="take_compass",frame=0} );
  ObjDelete("inv_leatherbagext_tr4");
  ObjSet( "inv_leatherbagext_tr3", {alp=1, visible=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_threepointedstarext", private.use_threepointedstarext_inv );
cmn.AddSubscriber( "use_threepointedstarext", private.use_threepointedstarext_beg );
cmn.AddSubscriber( "use_threepointedstarext", private.use_threepointedstarext_end );
cmn.AddSubscriber( "use_threepointedstarext", private.use_threepointedstarext_logic );
cmn.AddSubscriber( "use_threepointedstarext_inv", private.use_threepointedstarext_inv );
cmn.AddSubscriber( "use_threepointedstarext_beg", private.use_threepointedstarext_beg );
cmn.AddSubscriber( "use_threepointedstarext_end", private.use_threepointedstarext_end );
cmn.AddSubscriber( "use_threepointedstarext_end", private.use_threepointedstarext_logic );
--------------------------------------------------------------------------------------------
function public.use_threepointedstarext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_threepointedstarext" );
    cmn.CallEventHandler( "use_threepointedstarext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_threepointedstarext_inv" );
  cmn.CallEventHandler( "use_threepointedstarext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_star_leatherbagext" )
  
  ld.AnimPlay( "anm_leatherbagext_anm_1", "use_star_a", func_end );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_leatherbagopnext1" ] = { type = "click", use_place = "gfx_leatherbagext_clk_leatherbagopnext1_zone", room = "inv_complex_inv", zz = "inv_complex_leatherbagext", zz_gate = "inv_leatherbagext" };

private.clk_leatherbagopnext1_logic = function()
  ObjSet( "spr_leatherbagext_coinext2", {input = 1, visible = 1, active = 1} );
  ObjSet( "spr_leatherbagext_compassext", {input = 1, visible = 1, active = 1} );
end;
private.clk_leatherbagopnext1_beg = function()
  ObjDelete( "gfx_leatherbagext_clk_leatherbagopnext1_zone" );
end;
private.clk_leatherbagopnext1_end = function()
  ObjSet( "anm_leatherbagext_anm_1", {animfunc="a_static",frame = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_leatherbagopnext1", private.clk_leatherbagopnext1_beg );
cmn.AddSubscriber( "clk_leatherbagopnext1", private.clk_leatherbagopnext1_end );
cmn.AddSubscriber( "clk_leatherbagopnext1", private.clk_leatherbagopnext1_logic );
cmn.AddSubscriber( "clk_leatherbagopnext1_beg", private.clk_leatherbagopnext1_beg );
cmn.AddSubscriber( "clk_leatherbagopnext1_end", private.clk_leatherbagopnext1_end );
cmn.AddSubscriber( "clk_leatherbagopnext1_end", private.clk_leatherbagopnext1_logic );
--------------------------------------------------------------------------------------------
function public.clk_leatherbagopnext1()

  local func_end = function()
    cmn.SetEventDone( "clk_leatherbagopnext1" );
    cmn.CallEventHandler( "clk_leatherbagopnext1_end" );
    common_impl.Lock(0);
    public.get_compassext()
    public.get_coinext2()
  end;

  cmn.CallEventHandler( "clk_leatherbagopnext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_leatherbagext_anm_1", "take_compass", func_end );
  SoundSfx( "aud_touch_items_leatherbagext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coinext2" ] = { type = "get", get_obj = "spr_leatherbagext_coinext2", room = "inv_complex_inv", zz = "inv_complex_leatherbagext", zz_gate = "inv_leatherbagext" };

private.get_coinext2_logic = function()
 
end;
private.get_coinext2_inv = function()
  interface.InventoryItemAdd("inv_coinext","spr_leatherbagext_coinext2",function() level_inv.ProcessGetCoinextAll( "get_coinext2" ) end);
  if common_impl.ZzCompleteCheck("get_coinext2") then interface.InventoryItemRemove("inv_leatherbagext") end;
end;
private.get_coinext2_beg = function()
  ObjDelete("gfx_leatherbagext_coinext2");
end;
private.get_coinext2_end = function()
  
end;

cmn.AddSubscriber( "get_coinext2", private.get_coinext2_inv );
cmn.AddSubscriber( "get_coinext2", private.get_coinext2_beg );
cmn.AddSubscriber( "get_coinext2", private.get_coinext2_end );
cmn.AddSubscriber( "get_coinext2", private.get_coinext2_logic );
--------------------------------------------------------------------
function public.get_coinext2()
  cmn.SetEventDone( "get_coinext2" );
  cmn.CallEventHandler( "get_coinext2" );
  if common_impl.ZzCompleteCheck("get_coinext2") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_compassext" ] = { type = "get", get_obj = "spr_leatherbagext_compassext", room = "inv_complex_inv", zz = "inv_complex_leatherbagext", zz_gate = "inv_leatherbagext" };

private.get_compassext_logic = function()
 
end;
private.get_compassext_inv = function()
  interface.InventoryItemAdd("inv_compassext","spr_leatherbagext_compassext");
  if common_impl.ZzCompleteCheck("get_compassext") then interface.InventoryItemRemove("inv_leatherbagext") end;
end;
private.get_compassext_beg = function()
  ObjDelete("gfx_leatherbagext_compassext");
end;
private.get_compassext_end = function()
  
end;

cmn.AddSubscriber( "get_compassext", private.get_compassext_inv );
cmn.AddSubscriber( "get_compassext", private.get_compassext_beg );
cmn.AddSubscriber( "get_compassext", private.get_compassext_end );
cmn.AddSubscriber( "get_compassext", private.get_compassext_logic );
--------------------------------------------------------------------
function public.get_compassext()
  cmn.SetEventDone( "get_compassext" );
  cmn.CallEventHandler( "get_compassext" );
  if common_impl.ZzCompleteCheck("get_compassext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fourpointedstarext" ] = { type = "use", inv_obj = "inv_fourpointedstarext", use_place = "gfx_leatherbagext_fourpointedstarext_zone", room = "inv_complex_inv", zz = "inv_complex_leatherbagext", zz_gate = "inv_leatherbagext" };

private.use_fourpointedstarext_logic = function()
  ObjSet( "gfx_leatherbagext_clk_leatherbagopnext2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_fourpointedstarext_inv = function()
  common_impl.ProcessMultiUseAll("fourpointedstarext", "fourpointedstarext")
end;
private.use_fourpointedstarext_beg = function()
  ObjDelete( "gfx_leatherbagext_fourpointedstarext_zone" );
end;
private.use_fourpointedstarext_end = function()
  ObjSet( "anm_leatherbagext_anm_2", {animfunc="take_key",frame=0} );
  ObjDelete("inv_leatherbagext_tr6");
  ObjSet( "inv_leatherbagext_tr5", {alp=1, visible=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fourpointedstarext", private.use_fourpointedstarext_inv );
cmn.AddSubscriber( "use_fourpointedstarext", private.use_fourpointedstarext_beg );
cmn.AddSubscriber( "use_fourpointedstarext", private.use_fourpointedstarext_end );
cmn.AddSubscriber( "use_fourpointedstarext", private.use_fourpointedstarext_logic );
cmn.AddSubscriber( "use_fourpointedstarext_inv", private.use_fourpointedstarext_inv );
cmn.AddSubscriber( "use_fourpointedstarext_beg", private.use_fourpointedstarext_beg );
cmn.AddSubscriber( "use_fourpointedstarext_end", private.use_fourpointedstarext_end );
cmn.AddSubscriber( "use_fourpointedstarext_end", private.use_fourpointedstarext_logic );
--------------------------------------------------------------------------------------------
function public.use_fourpointedstarext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fourpointedstarext" );
    cmn.CallEventHandler( "use_fourpointedstarext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fourpointedstarext_inv" );
  cmn.CallEventHandler( "use_fourpointedstarext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_star_leatherbagext" )
  
  ld.AnimPlay( "anm_leatherbagext_anm_2", "use_star_b", func_end );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_leatherbagopnext2" ] = { type = "click", use_place = "gfx_leatherbagext_clk_leatherbagopnext2_zone", room = "inv_complex_inv", zz = "inv_complex_leatherbagext", zz_gate = "inv_leatherbagext" };

private.clk_leatherbagopnext2_logic = function()
  ObjSet( "spr_leatherbagext_lumberroomkeyext", { visible = 1, input = 1, active = 1 } )
end;
private.clk_leatherbagopnext2_beg = function()
  ObjDelete( "gfx_leatherbagext_clk_leatherbagopnext2_zone" );
end;
private.clk_leatherbagopnext2_end = function()
  ObjSet( "anm_leatherbagext_anm_2", {animfunc="b_static",frame = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_leatherbagopnext2", private.clk_leatherbagopnext2_beg );
cmn.AddSubscriber( "clk_leatherbagopnext2", private.clk_leatherbagopnext2_end );
cmn.AddSubscriber( "clk_leatherbagopnext2", private.clk_leatherbagopnext2_logic );
cmn.AddSubscriber( "clk_leatherbagopnext2_beg", private.clk_leatherbagopnext2_beg );
cmn.AddSubscriber( "clk_leatherbagopnext2_end", private.clk_leatherbagopnext2_end );
cmn.AddSubscriber( "clk_leatherbagopnext2_end", private.clk_leatherbagopnext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_leatherbagopnext2()

  local func_end = function()
    cmn.SetEventDone( "clk_leatherbagopnext2" );
    cmn.CallEventHandler( "clk_leatherbagopnext2_end" );
    common_impl.Lock(0);
    public.get_lumberroomkeyext()
  end;

  cmn.CallEventHandler( "clk_leatherbagopnext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_leatherbagext_anm_2", "take_key", func_end );
  SoundSfx( "aud_touch_items_leatherbagext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lumberroomkeyext" ] = { type = "get", get_obj = "spr_leatherbagext_lumberroomkeyext", room = "inv_complex_inv", zz = "inv_complex_leatherbagext", zz_gate = "inv_leatherbagext" };

private.get_lumberroomkeyext_logic = function()
 
end;
private.get_lumberroomkeyext_inv = function()
  interface.InventoryItemAdd("inv_lumberroomkeyext","spr_leatherbagext_lumberroomkeyext");
  if common_impl.ZzCompleteCheck("get_lumberroomkeyext") then interface.InventoryItemRemove("inv_leatherbagext") end;
end;
private.get_lumberroomkeyext_beg = function()
  ObjDelete("gfx_leatherbagext_lumberroomkeyext");
end;
private.get_lumberroomkeyext_end = function()
  
end;

cmn.AddSubscriber( "get_lumberroomkeyext", private.get_lumberroomkeyext_inv );
cmn.AddSubscriber( "get_lumberroomkeyext", private.get_lumberroomkeyext_beg );
cmn.AddSubscriber( "get_lumberroomkeyext", private.get_lumberroomkeyext_end );
cmn.AddSubscriber( "get_lumberroomkeyext", private.get_lumberroomkeyext_logic );
--------------------------------------------------------------------
function public.get_lumberroomkeyext()
  cmn.SetEventDone( "get_lumberroomkeyext" );
  cmn.CallEventHandler( "get_lumberroomkeyext" );
  if common_impl.ZzCompleteCheck("get_lumberroomkeyext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fivepointedstarext" ] = { type = "use", inv_obj = "inv_fivepointedstarext", use_place = "gfx_leatherbagext_fivepointedstarext_zone", room = "inv_complex_inv", zz = "inv_complex_leatherbagext", zz_gate = "inv_leatherbagext" };

private.use_fivepointedstarext_logic = function()
  ObjSet( "gfx_leatherbagext_clk_leatherbagopnext3_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_fivepointedstarext_inv = function()
  common_impl.ProcessMultiUseAll("fivepointedstarext", "fivepointedstarext")
end;
private.use_fivepointedstarext_beg = function()
  ObjDelete( "gfx_leatherbagext_fivepointedstarext_zone" );
end;
private.use_fivepointedstarext_end = function()
  ObjSet( "anm_leatherbagext_anm_3", {animfunc="take_cup",frame=0} );
  ObjDelete("inv_leatherbagext_tr2")
  ObjSet( "inv_leatherbagext_tr1", {alp=1, visible=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fivepointedstarext", private.use_fivepointedstarext_inv );
cmn.AddSubscriber( "use_fivepointedstarext", private.use_fivepointedstarext_beg );
cmn.AddSubscriber( "use_fivepointedstarext", private.use_fivepointedstarext_end );
cmn.AddSubscriber( "use_fivepointedstarext", private.use_fivepointedstarext_logic );
cmn.AddSubscriber( "use_fivepointedstarext_inv", private.use_fivepointedstarext_inv );
cmn.AddSubscriber( "use_fivepointedstarext_beg", private.use_fivepointedstarext_beg );
cmn.AddSubscriber( "use_fivepointedstarext_end", private.use_fivepointedstarext_end );
cmn.AddSubscriber( "use_fivepointedstarext_end", private.use_fivepointedstarext_logic );
--------------------------------------------------------------------------------------------
function public.use_fivepointedstarext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fivepointedstarext" );
    cmn.CallEventHandler( "use_fivepointedstarext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fivepointedstarext_inv" );
  cmn.CallEventHandler( "use_fivepointedstarext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_star_leatherbagext" )
  
  ld.AnimPlay( "anm_leatherbagext_anm_3", "use_star_c", func_end );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_leatherbagopnext3" ] = { type = "click", use_place = "gfx_leatherbagext_clk_leatherbagopnext3_zone", room = "inv_complex_inv", zz = "inv_complex_leatherbagext", zz_gate = "inv_leatherbagext" };

private.clk_leatherbagopnext3_logic = function()
  ObjSet( "spr_leatherbagext_wineglassext", { visible = 1, input = 1, active = 1 } )
end;
private.clk_leatherbagopnext3_beg = function()
  ObjDelete( "gfx_leatherbagext_clk_leatherbagopnext3_zone" );
end;
private.clk_leatherbagopnext3_end = function()
  ObjSet( "anm_leatherbagext_anm_1", {animfunc="c_static",frame = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_leatherbagopnext3", private.clk_leatherbagopnext3_beg );
cmn.AddSubscriber( "clk_leatherbagopnext3", private.clk_leatherbagopnext3_end );
cmn.AddSubscriber( "clk_leatherbagopnext3", private.clk_leatherbagopnext3_logic );
cmn.AddSubscriber( "clk_leatherbagopnext3_beg", private.clk_leatherbagopnext3_beg );
cmn.AddSubscriber( "clk_leatherbagopnext3_end", private.clk_leatherbagopnext3_end );
cmn.AddSubscriber( "clk_leatherbagopnext3_end", private.clk_leatherbagopnext3_logic );
--------------------------------------------------------------------------------------------
function public.clk_leatherbagopnext3()

  local func_end = function()
    cmn.SetEventDone( "clk_leatherbagopnext3" );
    cmn.CallEventHandler( "clk_leatherbagopnext3_end" );
    common_impl.Lock(0);
    public.get_wineglassext()
  end;

  cmn.CallEventHandler( "clk_leatherbagopnext3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_leatherbagext_anm_3", "take_cup", func_end );
  SoundSfx( "aud_touch_items_leatherbagext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wineglassext" ] = { type = "get", get_obj = "spr_leatherbagext_wineglassext", room = "inv_complex_inv", zz = "inv_complex_leatherbagext", zz_gate = "inv_leatherbagext" };

private.get_wineglassext_logic = function()
 
end;
private.get_wineglassext_inv = function()
  interface.InventoryItemAdd("inv_wineglassext","spr_leatherbagext_wineglassext");
  if common_impl.ZzCompleteCheck("get_wineglassext") then interface.InventoryItemRemove("inv_leatherbagext") end;
end;
private.get_wineglassext_beg = function()
  ObjDelete("gfx_leatherbagext_wineglassext");
end;
private.get_wineglassext_end = function()
  
end;

cmn.AddSubscriber( "get_wineglassext", private.get_wineglassext_inv );
cmn.AddSubscriber( "get_wineglassext", private.get_wineglassext_beg );
cmn.AddSubscriber( "get_wineglassext", private.get_wineglassext_end );
cmn.AddSubscriber( "get_wineglassext", private.get_wineglassext_logic );
--------------------------------------------------------------------
function public.get_wineglassext()
  cmn.SetEventDone( "get_wineglassext" );
  cmn.CallEventHandler( "get_wineglassext" );
  if common_impl.ZzCompleteCheck("get_wineglassext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_ringsinwaterext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ringsext" ] = { type = "use", inv_obj = "inv_ringsext", use_place = "gfx_ringsinwaterext_ringsext_zone", room = "inv_complex_inv", zz = "inv_complex_ringsinwaterext", zz_gate = "inv_ringsinwaterext" };

private.use_ringsext_logic = function()
  ObjSet( "gfx_ringsinwaterext_win_ringsinwaterext_zone", { input = 1 } )

end;
private.use_ringsext_inv = function()
  common_impl.ProcessMultiUseAll("ringsext", "ringsext")
end;
private.use_ringsext_beg = function()
  ObjDelete( "gfx_ringsinwaterext_ringsext_zone" );
end;
private.use_ringsext_end = function()
  ObjSet("obj_ringsinwaterext_mmg_root",{alp=1,input=1})
  ObjSet("anm_ringsinwaterext_anm",{animfunc="amulet",frame=0})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ringsext", private.use_ringsext_inv );
cmn.AddSubscriber( "use_ringsext", private.use_ringsext_beg );
cmn.AddSubscriber( "use_ringsext", private.use_ringsext_end );
cmn.AddSubscriber( "use_ringsext", private.use_ringsext_logic );
cmn.AddSubscriber( "use_ringsext_inv", private.use_ringsext_inv );
cmn.AddSubscriber( "use_ringsext_beg", private.use_ringsext_beg );
cmn.AddSubscriber( "use_ringsext_end", private.use_ringsext_end );
cmn.AddSubscriber( "use_ringsext_end", private.use_ringsext_logic );
--------------------------------------------------------------------------------------------
function public.use_ringsext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    private.init_ringsinwaterext()
    cmn.MiniGameShow( "ringsinwaterext" );    
    cmn.SetEventDone( "use_ringsext" );
    cmn.CallEventHandler( "use_ringsext_end" );
    common_impl.Lock(0);
  end;
  local f_step = function ()
    ObjAnimate( "obj_ringsinwaterext_mmg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ringsext_inv" );
  cmn.CallEventHandler( "use_ringsext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_ringsext_ringsinwaterext" )
  
  ld.AnimPlay( "anm_ringsinwaterext_anm", "use_rings", f_step );


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_ringsinwaterext" ] = { type = "click", use_place = "gfx_ringsinwaterext_win_ringsinwaterext_zone", room = "inv_complex_inv", zz = "inv_complex_ringsinwaterext", zz_gate = "inv_ringsinwaterext" };

private.win_ringsinwaterext_logic = function()
  if cmn.IsEventDone("win_ringsinwaterext") then  
    ObjSet( "spr_ringsinwaterext_beermugext", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_ringsinwaterext_beg = function()
  if cmn.IsEventDone("win_ringsinwaterext") then   
    ObjDelete( "gfx_ringsinwaterext_win_ringsinwaterext_zone" );
  end
end;
private.win_ringsinwaterext_end = function()
  if cmn.IsEventDone("win_ringsinwaterext") then 
    ObjSet("anm_ringsinwaterext_anm",{animfunc="trash_tablet",frame=0})
    for i=1,3 do
      ObjSet("spr_ringsinwaterext_light_"..i,{alp=1})
    end
    ObjDelete("anm_ringsinwaterext_anm_rings")
    ObjSet( "obj_ringsinwaterext_mmg_root", {input = 0, visible = 0} );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_ringsinwaterext", private.win_ringsinwaterext_beg, private.room_objname );
cmn.AddSubscriber( "win_ringsinwaterext", private.win_ringsinwaterext_end, private.room_objname );
cmn.AddSubscriber( "win_ringsinwaterext", private.win_ringsinwaterext_logic );
cmn.AddSubscriber( "win_ringsinwaterext_beg", private.win_ringsinwaterext_beg, private.room_objname );
cmn.AddSubscriber( "win_ringsinwaterext_end", private.win_ringsinwaterext_end, private.room_objname );
cmn.AddSubscriber( "win_ringsinwaterext_end", private.win_ringsinwaterext_logic );
--------------------------------------------------------------------------------------------
function public.win_ringsinwaterext()

  local func_end = function()
    cmn.SetEventDone( "win_ringsinwaterext" );
    cmn.CallEventHandler( "win_ringsinwaterext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_ringsinwaterext") then common_impl.HideComplexItem() end;
  end;

  cmn.CallEventHandler( "win_ringsinwaterext_beg" );
  common_impl.Lock(1);
  cmn.MiniGameHide( "ringsinwaterext",true ); 
  
  ld.AnimPlay( "anm_ringsinwaterext_anm", "amulet", func_end );
  SoundSfx( "aud_mg_ringsinwaterext_win" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.init_ringsinwaterext()
  if not (cmn.IsEventStart("win_ringsinwaterext")) then
    ng_global.progress["ext"]["win_ringsinwaterext"].state = 0
  end
  private.load_ringsinwaterext()
end
function public.clk_ball()
  private.start_anim = false 

  ObjStopAnimate("spr_ringsinwaterext_runner_scale","pos_y")
  local s = ng_global.progress["ext"]["win_ringsinwaterext"].state
  ld.LogTrace(s)
  local y = ObjGet("spr_ringsinwaterext_runner_scale").pos_y
  ld.Lock(1)
  SoundSfx( "aud_mg_ringsinwaterext_click" );
  ObjSet("spr_ringsinwaterext_ringsinwater",{res="assets/levels/levelext/inv_deploy/inv_complex_ringsinwaterext/ringsinwater_"..ng_global.progress["ext"]["win_ringsinwaterext"].state + 1})
  if y<-20 then
    ld.AnimPlay( "anm_ringsinwaterext_anm_rings", "b_1",function()ld.Lock(0);private.start_ringsinwaterext() end  );
  elseif y>20 then
      ld.AnimPlay( "anm_ringsinwaterext_anm_rings", "b_3", function()ld.Lock(0);private.start_ringsinwaterext() end  );
  else 
    local func_end
    if s==2 then
      func_end = function()
        public.win_ringsinwaterext()
      --ld.AnimPlay( "anm_ringsinwaterext_anm", "get_badgelightning", function()ld.Lock(0);ld.LogTrace( "WIN" );end );
      end
    else 
      func_end = function()
        ld.Lock(0);
        SoundSfx( "aud_mg_ringsinwaterext_hit" );
        private.start_ringsinwaterext()
      end
    end
      ng_global.progress["ext"]["win_ringsinwaterext"].state = ng_global.progress["ext"]["win_ringsinwaterext"].state + 1
      ObjAnimate( "spr_ringsinwaterext_light_"..ng_global.progress["ext"]["win_ringsinwaterext"].state, 8, 0, 0, "", {0,0,0, 0.5,0,1} );
      ld.AnimPlay( "anm_ringsinwaterext_anm_rings", "b_2", func_end  );    
  end
end
function private.load_ringsinwaterext()
  for i=1,ng_global.progress["ext"]["win_ringsinwaterext"].state do
    ObjSet( "spr_ringsinwaterext_light_"..i, {alp = 1} );
  end
  private.start_ringsinwaterext()
end
function private.start_ringsinwaterext()
  if not private.start_anim then
    private.start_anim = true
    ObjAnimate("spr_ringsinwaterext_runner_scale","pos_y",1,0,"",{0,0,-90, 1,0,90,2,0,-90})
  end
end
function private.win_ringsinwaterext_reset()
  ng_global.progress["ext"]["win_ringsinwaterext"].state = 0
  for i=1,3 do
    ObjSet("spr_ringsinwaterext_light_"..i,{alp=0})
  end
end
function private.win_ringsinwaterext_skip()
  ObjAnimate( "spr_ringsinwaterext_mmg_root_scale", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
  public.win_ringsinwaterext()
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_beermugext" ] = { type = "get", get_obj = "spr_ringsinwaterext_beermugext", room = "inv_complex_inv", zz = "inv_complex_ringsinwaterext", zz_gate = "inv_ringsinwaterext" };

private.get_beermugext_logic = function()
 
end;
private.get_beermugext_inv = function()
  interface.InventoryItemAdd("inv_beermugext","spr_ringsinwaterext_beermugext");
  if common_impl.ZzCompleteCheck("get_beermugext") then interface.InventoryItemRemove("inv_ringsinwaterext") end;
end;
private.get_beermugext_beg = function()
  ObjDelete("gfx_ringsinwaterext_beermugext");
end;
private.get_beermugext_end = function()
  
end;

cmn.AddSubscriber( "get_beermugext", private.get_beermugext_inv );
cmn.AddSubscriber( "get_beermugext", private.get_beermugext_beg );
cmn.AddSubscriber( "get_beermugext", private.get_beermugext_end );
cmn.AddSubscriber( "get_beermugext", private.get_beermugext_logic );
--------------------------------------------------------------------
function public.get_beermugext()
  cmn.SetEventDone( "get_beermugext" );
  cmn.CallEventHandler( "get_beermugext" );
  if common_impl.ZzCompleteCheck("get_beermugext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
------------------------------------------------------------
function public.ringsinwaterext_preopen()
   if cmn.IsEventStart("win_ringsinwaterext") and not cmn.IsEventDone("win_ringsinwaterext") then
     private.init_ringsinwaterext()
        cmn.MiniGameShow( "ringsinwaterext" );
   end
end
  
function public.ringsinwaterext_open()
    if ld.CheckRequirements({"use_ringsext"}) and not cmn.IsEventDone("win_ringsinwaterext") then
      --  cmn.MiniGameShow( "casketmmg" );
    end
end
  
function public.ringsinwaterext_preclose()
    if ld.CheckRequirements({"use_ringsext"}) and not cmn.IsEventDone("win_ringsinwaterext") then
      cmn.MiniGameHide("ringsinwaterext");

    end
end
  
function public.ringsinwaterext_close()

end    
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_musicboxext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_ballerinaext_zone_clk()  
  local func_end = function()
     ld.Lock(0);
     common_impl.ShowBbt( 'need_ballerinaext' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_musicboxext_touch" )
  ld.AnimPlay( "anm_musicboxext_anm", "idle_ballerina1", func_end )
end;  


common_impl.hint[ "use_ballerinaext" ] = { type = "use", inv_obj = "inv_ballerinaext", use_place = "gfx_musicboxext_ballerinaext_zone", room = "inv_complex_inv", zz = "inv_complex_musicboxext", zz_gate = "inv_musicboxext" };

private.use_ballerinaext_logic = function()
  ObjSet( "gfx_musicboxext_keyboxext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_ballerinaext_inv = function()
  common_impl.ProcessMultiUseAll("ballerinaext", "ballerinaext")
end;
private.use_ballerinaext_beg = function()
  ObjDelete( "gfx_musicboxext_ballerinaext_zone" );
end;
private.use_ballerinaext_end = function()
  ObjSet( "anm_musicboxext_anm", {animfunc="use_keybox", frame=0} );
  ObjDelete("inv_musicboxext_back");
  ObjSet( "inv_musicboxext_st_2", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ballerinaext", private.use_ballerinaext_inv );
cmn.AddSubscriber( "use_ballerinaext", private.use_ballerinaext_beg );
cmn.AddSubscriber( "use_ballerinaext", private.use_ballerinaext_end );
cmn.AddSubscriber( "use_ballerinaext", private.use_ballerinaext_logic );
cmn.AddSubscriber( "use_ballerinaext_inv", private.use_ballerinaext_inv );
cmn.AddSubscriber( "use_ballerinaext_beg", private.use_ballerinaext_beg );
cmn.AddSubscriber( "use_ballerinaext_end", private.use_ballerinaext_end );
cmn.AddSubscriber( "use_ballerinaext_end", private.use_ballerinaext_logic );
--------------------------------------------------------------------------------------------
function public.use_ballerinaext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ballerinaext" );
    cmn.CallEventHandler( "use_ballerinaext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ballerinaext_inv" );
  cmn.CallEventHandler( "use_ballerinaext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_ballerinaext_musicboxext" )
  
  ld.AnimPlay( "anm_musicboxext_anm", "use_ballerina", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_keyboxext" ] = { type = "use", inv_obj = "inv_keyboxext", use_place = "gfx_musicboxext_keyboxext_zone", room = "inv_complex_inv", zz = "inv_complex_musicboxext", zz_gate = "inv_musicboxext" };

private.use_keyboxext_logic = function()
  ObjSet( "spr_musicboxext_amuletguitarext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_musicboxext_amuletguitarext", {active=1, visible = 1} );
end;
private.use_keyboxext_inv = function()
  common_impl.ProcessMultiUseAll("keyboxext", "keyboxext")
end;
private.use_keyboxext_beg = function()
  ObjDelete( "gfx_musicboxext_keyboxext_zone" );
end;
private.use_keyboxext_end = function()
  ObjSet( "anm_musicboxext_anm", {animfunc = "use_keybox", frame = 999 } );
  ObjDelete("inv_musicboxext_st_2");
  ObjSet( "inv_musicboxext_st_3", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_keyboxext", private.use_keyboxext_inv );
cmn.AddSubscriber( "use_keyboxext", private.use_keyboxext_beg );
cmn.AddSubscriber( "use_keyboxext", private.use_keyboxext_end );
cmn.AddSubscriber( "use_keyboxext", private.use_keyboxext_logic );
cmn.AddSubscriber( "use_keyboxext_inv", private.use_keyboxext_inv );
cmn.AddSubscriber( "use_keyboxext_beg", private.use_keyboxext_beg );
cmn.AddSubscriber( "use_keyboxext_end", private.use_keyboxext_end );
cmn.AddSubscriber( "use_keyboxext_end", private.use_keyboxext_logic );
--------------------------------------------------------------------------------------------
function public.use_keyboxext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_keyboxext" );
    cmn.CallEventHandler( "use_keyboxext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_keyboxext_inv" );
  cmn.CallEventHandler( "use_keyboxext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_keyboxext_musicboxext" )
  
  ld.AnimPlay( "anm_musicboxext_anm", "use_keybox", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletguitarext" ] = { type = "get", get_obj = "spr_musicboxext_amuletguitarext", room = "inv_complex_inv", zz = "inv_complex_musicboxext", zz_gate = "inv_musicboxext" };

private.get_amuletguitarext_logic = function()
 
end;
private.get_amuletguitarext_inv = function()
  interface.InventoryItemAdd("inv_amuletguitarext","spr_musicboxext_amuletguitarext");
  if common_impl.ZzCompleteCheck("get_amuletguitarext") then interface.InventoryItemRemove("inv_musicboxext") end;
end;
private.get_amuletguitarext_beg = function()
  ObjDelete("gfx_musicboxext_amuletguitarext");
end;
private.get_amuletguitarext_end = function()
  ObjSet( "anm_musicboxext_anm", {animfunc = "end_keybox", frame = 0 } );
  ObjDelete("inv_musicboxext_st_3")
  ObjSet( "inv_musicboxext_st_4", {alp=1} );
end;

cmn.AddSubscriber( "get_amuletguitarext", private.get_amuletguitarext_inv );
cmn.AddSubscriber( "get_amuletguitarext", private.get_amuletguitarext_beg );
cmn.AddSubscriber( "get_amuletguitarext", private.get_amuletguitarext_end );
cmn.AddSubscriber( "get_amuletguitarext", private.get_amuletguitarext_logic );
--------------------------------------------------------------------
function public.get_amuletguitarext()
  ObjSet( "spr_musicboxext_amuletguitarext", {visible = 1} );
  cmn.SetEventDone( "get_amuletguitarext" );
  cmn.CallEventHandler( "get_amuletguitarext" );
  if common_impl.ZzCompleteCheck("get_amuletguitarext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
end;
function public.Reset()
  mg_name = interface.GetCurrentComplexInv()
  ld.LogTrace( mg_name );
  if ( mg_name == "inv_complex_ringsinwaterext" ) and not ld.CheckRequirements( { "win_ringsinwaterext" } ) then  
    private.win_ringsinwaterext_reset()
  end;  
end
function public.Skip()
  mg_name = interface.GetCurrentComplexInv()
  if ( mg_name == "inv_complex_ringsinwaterext" ) and not ld.CheckRequirements( { "win_ringsinwaterext" } ) then
    private.win_ringsinwaterext_skip();
  end;  
end