-- name=rm_houseext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_houseext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_houseext()
  if not ( cmn.IsEventDone( "opn_houseext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_houseext" );
      cmn.CallEventHandler( "opn_houseext" )
      -- ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_houseext = function() end;
local opn_houseext_logic = function() 

end;
cmn.AddSubscriber( "opn_houseext", opn_houseext_logic )
cmn.AddSubscriber( "opn_houseext", opn_houseext, private.houseext_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_rootsext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_flashlightoffext" ] = { type = "get", get_obj = "spr_rootsext_flashlightoffext", room = "rm_houseext", zz = "zz_rootsext", zz_gate = "gzz_houseext_rootsext" };

private.get_flashlightoffext_logic = function()
  
end;
private.get_flashlightoffext_inv = function()
  interface.InventoryItemAdd("inv_flashlightoffext","spr_rootsext_flashlightoffext");
  ObjSet( "inv_flashlightoffext", { drag = 0 } );
end;
private.get_flashlightoffext_beg = function()
  ObjDelete("gfx_rootsext_flashlightoffext")
end;
private.get_flashlightoffext_end = function()
  if common_impl.ZzCompleteCheck("get_flashlightoffext") then ObjSet( common_impl.hint["get_flashlightoffext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_flashlightoffext", private.get_flashlightoffext_inv );
cmn.AddSubscriber( "get_flashlightoffext", private.get_flashlightoffext_beg, private.room_objname );
cmn.AddSubscriber( "get_flashlightoffext", private.get_flashlightoffext_end, private.room_objname );
cmn.AddSubscriber( "get_flashlightoffext", private.get_flashlightoffext_logic );
--------------------------------------------------------------------
function public.get_flashlightoffext()
  cmn.SetEventDone( "get_flashlightoffext" );
  cmn.CallEventHandler( "get_flashlightoffext" );
  if common_impl.ZzCompleteCheck("get_flashlightoffext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_axeext" ] = { type = "use", inv_obj = "inv_axeext", use_place = "gfx_rootsext_axeext_zone", room = "rm_houseext", zz = "zz_rootsext", zz_gate = "gzz_houseext_rootsext" };

private.use_axeext_logic = function()
  ObjSet( "gho_houseext_rootshoext", { visible = 1, input = 1, active = 1 } )

end;
private.use_axeext_inv = function()
  common_impl.ProcessMultiUseAll("axeext", "axeext")
end;
private.use_axeext_beg = function()
  ObjDelete( "gfx_rootsext_axeext_zone" );
end;
private.use_axeext_end = function()
  ObjSet( "anm_rootsext_anm", {animfunc="end_root",frame=0} );
  ObjDelete("spr_houseext_wood")
  if common_impl.ZzCompleteCheck("use_axeext") then ObjSet( common_impl.hint["use_axeext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_axeext", private.use_axeext_inv );
cmn.AddSubscriber( "use_axeext", private.use_axeext_beg, private.room_objname );
cmn.AddSubscriber( "use_axeext", private.use_axeext_end, private.room_objname );
cmn.AddSubscriber( "use_axeext", private.use_axeext_logic );
cmn.AddSubscriber( "use_axeext_inv", private.use_axeext_inv, private.room_objname );
cmn.AddSubscriber( "use_axeext_beg", private.use_axeext_beg, private.room_objname );
cmn.AddSubscriber( "use_axeext_end", private.use_axeext_end, private.room_objname );
cmn.AddSubscriber( "use_axeext_end", private.use_axeext_logic );
--------------------------------------------------------------------------------------------
function public.use_axeext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_axeext" );
    cmn.CallEventHandler( "use_axeext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_axeext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_axeext_inv" );
  cmn.CallEventHandler( "use_axeext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_rootsext_anm", "use_ax", func_end );
  SoundSfx( "aud_use_axeext_houseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_carext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_backpackext" ] = { type = "get", get_obj = "spr_carext_backpackext", room = "rm_houseext", zz = "zz_carext", zz_gate = "gzz_houseext_carext" };

private.get_backpackext_logic = function()
  ObjSet( "gfx_carext_keytrunkext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_backpackext_inv = function()
  interface.InventoryItemAdd("inv_backpackext","spr_carext_backpackext");
  ObjSet( "inv_backpackext", { drag = 0 } );
end;
private.get_backpackext_beg = function()
  ObjDelete("gfx_carext_backpackext")
end;
private.get_backpackext_end = function()
  ObjDelete("spr_carext_sh_backpackext")
  ObjDelete("spr_houseext_backpackext")
  if common_impl.ZzCompleteCheck("get_backpackext") then ObjSet( common_impl.hint["get_backpackext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_backpackext", private.get_backpackext_inv );
cmn.AddSubscriber( "get_backpackext", private.get_backpackext_beg, private.room_objname );
cmn.AddSubscriber( "get_backpackext", private.get_backpackext_end, private.room_objname );
cmn.AddSubscriber( "get_backpackext", private.get_backpackext_logic );
--------------------------------------------------------------------
function public.get_backpackext()
  cmn.SetEventDone( "get_backpackext" );
  cmn.CallEventHandler( "get_backpackext" );
  if common_impl.ZzCompleteCheck("get_backpackext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_keytrunkext" ] = { type = "use", inv_obj = "inv_keytrunkext", use_place = "gfx_carext_keytrunkext_zone", room = "rm_houseext", zz = "zz_carext", zz_gate = "gzz_houseext_carext" };

private.use_keytrunkext_logic = function()
  ObjSet( "gfx_carext_clk_opntrunkext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_keytrunkext_inv = function()
  common_impl.ProcessMultiUseAll("keytrunkext", "keytrunkext")
end;
private.use_keytrunkext_beg = function()
  ObjDelete( "gfx_carext_keytrunkext_zone" );
end;
private.use_keytrunkext_end = function()
  ObjSet("anm_carext_anm_lock",{animfunc="end_car",frame=0})
  ObjSet( "spr_houseext_open", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_keytrunkext") then ObjSet( common_impl.hint["use_keytrunkext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_keytrunkext", private.use_keytrunkext_inv );
cmn.AddSubscriber( "use_keytrunkext", private.use_keytrunkext_beg, private.room_objname );
cmn.AddSubscriber( "use_keytrunkext", private.use_keytrunkext_end, private.room_objname );
cmn.AddSubscriber( "use_keytrunkext", private.use_keytrunkext_logic );
cmn.AddSubscriber( "use_keytrunkext_inv", private.use_keytrunkext_inv, private.room_objname );
cmn.AddSubscriber( "use_keytrunkext_beg", private.use_keytrunkext_beg, private.room_objname );
cmn.AddSubscriber( "use_keytrunkext_end", private.use_keytrunkext_end, private.room_objname );
cmn.AddSubscriber( "use_keytrunkext_end", private.use_keytrunkext_logic );
--------------------------------------------------------------------------------------------
function public.use_keytrunkext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_keytrunkext" );
    cmn.CallEventHandler( "use_keytrunkext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_keytrunkext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_keytrunkext_inv" );
  cmn.CallEventHandler( "use_keytrunkext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_carext_anm_lock", "use_key", func_end );
  SoundSfx( "aud_use_keytrunkext_houseext" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_opntrunkext" ] = { type = "click", use_place = "gfx_carext_clk_opntrunkext_zone", room = "rm_houseext", zz = "zz_carext", zz_gate = "gzz_houseext_carext" };

private.clk_opntrunkext_logic = function()
  if ld.CheckRequirements( {"clk_opntrunkext"} ) then  
    ObjSet( "spr_carext_amuletsailext", { visible = 1, input = 1, active = 1 } )
  end
end;
private.clk_opntrunkext_beg = function()

end;
private.clk_opntrunkext_end = function()
  local param = ng_global.progress[ "ext" ][ "clk_opntrunkext" ].state
  if ld.CheckRequirements( {"clk_opntrunkext"} ) then    
    ObjDelete( "gfx_carext_clk_opntrunkext_zone" );
    ObjSet( "gfx_carext_amuletsailext", {visible = 1} );
  end

    if param == 2 then
      ObjSet( "anm_carext_anm_opntrunk_1", {frame=999} );
    elseif param == 3 then
      ObjSet( "anm_carext_anm_opntrunk_1", {frame=999} );
      ObjSet( "anm_carext_anm_opntrunk_2", {frame=999} );      
    elseif param == 4 then
      ObjSet( "anm_carext_anm_opntrunk_1", {frame=999} );
      ObjSet( "anm_carext_anm_opntrunk_2", {frame=999} );            
      ObjSet( "anm_carext_anm_opntrunk_3", {frame=999} );            
    else
    end 
  
  if common_impl.ZzCompleteCheck("clk_opntrunkext") then ObjSet( common_impl.hint["clk_opntrunkext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_opntrunkext", private.clk_opntrunkext_beg, private.room_objname );
cmn.AddSubscriber( "clk_opntrunkext", private.clk_opntrunkext_end, private.room_objname );
cmn.AddSubscriber( "clk_opntrunkext", private.clk_opntrunkext_logic );
cmn.AddSubscriber( "clk_opntrunkext_beg", private.clk_opntrunkext_beg, private.room_objname );
cmn.AddSubscriber( "clk_opntrunkext_end", private.clk_opntrunkext_end, private.room_objname );
cmn.AddSubscriber( "clk_opntrunkext_end", private.clk_opntrunkext_logic );
--------------------------------------------------------------------------------------------
function public.clk_opntrunkext()

  local func_end = function()
    ng_global.progress[ "ext" ][ "clk_opntrunkext" ].state = ng_global.progress[ "ext" ][ "clk_opntrunkext" ].state + 1    
    if ng_global.progress[ "ext" ][ "clk_opntrunkext" ].state ==4 then 
      cmn.SetEventDone( "clk_opntrunkext" );
    end
    
    cmn.CallEventHandler( "clk_opntrunkext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_opntrunkext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_opntrunkext_beg" );
  common_impl.Lock(1);

  
  if not ng_global.progress[ "ext" ][ "clk_opntrunkext" ].state then
    ng_global.progress[ "ext" ][ "clk_opntrunkext" ].state = 1
    cmn.SetEventStart("clk_opntrunkext")
  end
  local param = ng_global.progress[ "ext" ][ "clk_opntrunkext" ].state
  SoundSfx( "aud_touch_cloth_houseext" )
  ld.AnimPlay( "anm_carext_anm_opntrunk_"..param, "click_"..param, func_end );
  
  
   
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletsailext" ] = { type = "get", get_obj = "spr_carext_amuletsailext", room = "rm_houseext", zz = "zz_carext", zz_gate = "gzz_houseext_carext" };

private.get_amuletsailext_logic = function()
  
end;
private.get_amuletsailext_inv = function()
  interface.InventoryItemAdd("inv_amuletsailext","spr_carext_amuletsailext");
end;
private.get_amuletsailext_beg = function()
  ObjDelete("gfx_carext_amuletsailext")
end;
private.get_amuletsailext_end = function()
    ObjDelete("spr_carext_sh_amuletsailext")
  if common_impl.ZzCompleteCheck("get_amuletsailext") then ObjSet( common_impl.hint["get_amuletsailext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletsailext", private.get_amuletsailext_inv );
cmn.AddSubscriber( "get_amuletsailext", private.get_amuletsailext_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletsailext", private.get_amuletsailext_end, private.room_objname );
cmn.AddSubscriber( "get_amuletsailext", private.get_amuletsailext_logic );
--------------------------------------------------------------------
function public.get_amuletsailext()
  cmn.SetEventDone( "get_amuletsailext" );
  cmn.CallEventHandler( "get_amuletsailext" );
  if common_impl.ZzCompleteCheck("get_amuletsailext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_rootshoext_for_houseext = function()
    if ld.CheckRequirements( {"win_rootshoext"} ) then
      ObjSet( "gho_houseext_rootshoext", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_rootshoext", win_rootshoext_for_houseext, private.room_objname )
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_roomfireplaceext" ) and not ld.CheckRequirements( { "win_mmgext_roomfireplace" } ) then
    
  end;

end;
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_roomfireplaceext" ) and not ld.CheckRequirements( { "win_mmgext_roomfireplace" } ) then
    
  end;

end;



end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_houseext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_houseext_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_carext" );
  function zz_carext.Open()
  end;
  function zz_carext.PreOpen()
  end;
  function zz_carext.PreClose()
  end;
  function zz_carext.Close()
  end;

  subroom.Define( "zz_rootsext" );
  function zz_rootsext.Open()
  end;
  function zz_rootsext.PreOpen()
  end;
  function zz_rootsext.PreClose()
  end;
  function zz_rootsext.Close()
  end;

end;
--*********************************************************************************************************************