-- name=rm_pondext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_pondext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_pondext()
  if not ( cmn.IsEventDone( "opn_pondext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_pondext" );
      cmn.CallEventHandler( "opn_pondext" )
      --  ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opnpondext");
      SoundTheme( "aud_adventure2_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_pondext = function() end;
local opn_pondext_logic = function() end;
cmn.AddSubscriber( "opn_pondext", opn_pondext_logic )
cmn.AddSubscriber( "opn_pondext", opn_pondext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_binsext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_amuleteagleext1" ] = { type = "get", get_obj = "spr_binsext_amuleteagleext1", room = "rm_pondext", zz = "zz_binsext", zz_gate = "gzz_pondext_binsext" };

private.get_amuleteagleext1_logic = function()
  ObjSet( "gfx_binsext_amuletsailext_zone", {active=1, input = 1, visible = 1} );
end;
private.get_amuleteagleext1_inv = function()
  interface.InventoryItemAdd("inv_amuleteagleext1","spr_binsext_amuleteagleext1");
end;
private.get_amuleteagleext1_beg = function()
  ObjDelete("gfx_binsext_amuleteagleext1")
end;
private.get_amuleteagleext1_end = function()
  if common_impl.ZzCompleteCheck("get_amuleteagleext1") then ObjSet( common_impl.hint["get_amuleteagleext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_binsext_amuleteagleext1_sh");
  ObjDelete("spr_pondext_tr2");
end;

cmn.AddSubscriber( "get_amuleteagleext1", private.get_amuleteagleext1_inv );
cmn.AddSubscriber( "get_amuleteagleext1", private.get_amuleteagleext1_beg, private.room_objname );
cmn.AddSubscriber( "get_amuleteagleext1", private.get_amuleteagleext1_end, private.room_objname );
cmn.AddSubscriber( "get_amuleteagleext1", private.get_amuleteagleext1_logic );
--------------------------------------------------------------------
function public.get_amuleteagleext1()
  cmn.SetEventDone( "get_amuleteagleext1" );
  cmn.CallEventHandler( "get_amuleteagleext1" );
  if common_impl.ZzCompleteCheck("get_amuleteagleext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_amuletsailext_zone_clk()  --rm_pondext.use_amuletsailext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_amuletsailext' )   
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_big_metal" );
  ld.AnimPlay( "anm_binsext_anm_cover2", "idle_cover2", func_end );
end;  


common_impl.hint[ "use_amuletsailext" ] = { type = "use", inv_obj = "inv_amuletsailext", use_place = "gfx_binsext_amuletsailext_zone", room = "rm_pondext", zz = "zz_binsext", zz_gate = "gzz_pondext_binsext" };

private.use_amuletsailext_logic = function()
  ObjSet( "spr_binsext_openerext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_binsext_thistleext", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletsailext_inv = function()
  common_impl.ProcessMultiUseAll("amuletsailext", "amuletsailext")
end;
private.use_amuletsailext_beg = function()
  ObjDelete( "gfx_binsext_amuletsailext_zone" );
end;
private.use_amuletsailext_end = function()
  if common_impl.ZzCompleteCheck("use_amuletsailext") then ObjSet( common_impl.hint["use_amuletsailext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_binsext_anm_cover2")
  ObjSet( "spr_binsext_thistleext_sh", {visible = 1} );
  ObjSet( "spr_binsext_openerext_sh", {visible = 1} );
  ObjDelete("spr_pondext_tr3")
  ObjSet( "spr_pondext_tr1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletsailext", private.use_amuletsailext_inv );
cmn.AddSubscriber( "use_amuletsailext", private.use_amuletsailext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletsailext", private.use_amuletsailext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletsailext", private.use_amuletsailext_logic );
cmn.AddSubscriber( "use_amuletsailext_inv", private.use_amuletsailext_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletsailext_beg", private.use_amuletsailext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletsailext_end", private.use_amuletsailext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletsailext_end", private.use_amuletsailext_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletsailext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletsailext" );
    cmn.CallEventHandler( "use_amuletsailext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletsailext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletsailext_inv" );
  cmn.CallEventHandler( "use_amuletsailext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_binsext_anm_cover2", "use_boat", func_end );
  SoundSfx( "aud_use_amuletsailext_pondext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_openerext" ] = { type = "get", get_obj = "spr_binsext_openerext", room = "rm_pondext", zz = "zz_binsext", zz_gate = "gzz_pondext_binsext" };

private.get_openerext_logic = function()
  
end;
private.get_openerext_inv = function()
  interface.InventoryItemAdd("inv_openerext","spr_binsext_openerext");
end;
private.get_openerext_beg = function()
  ObjDelete("gfx_binsext_openerext")
end;
private.get_openerext_end = function()
  if common_impl.ZzCompleteCheck("get_openerext") then ObjSet( common_impl.hint["get_openerext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_binsext_openerext_sh")
end;

cmn.AddSubscriber( "get_openerext", private.get_openerext_inv );
cmn.AddSubscriber( "get_openerext", private.get_openerext_beg, private.room_objname );
cmn.AddSubscriber( "get_openerext", private.get_openerext_end, private.room_objname );
cmn.AddSubscriber( "get_openerext", private.get_openerext_logic );
--------------------------------------------------------------------
function public.get_openerext()
  cmn.SetEventDone( "get_openerext" );
  cmn.CallEventHandler( "get_openerext" );
  if common_impl.ZzCompleteCheck("get_openerext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_thistleext" ] = { type = "get", get_obj = "spr_binsext_thistleext", room = "rm_pondext", zz = "zz_binsext", zz_gate = "gzz_pondext_binsext" };

private.get_thistleext_logic = function()
  
end;
private.get_thistleext_inv = function()
  interface.InventoryItemAdd("inv_thistleext","spr_binsext_thistleext");
end;
private.get_thistleext_beg = function()
  ObjDelete("gfx_binsext_thistleext")
end;
private.get_thistleext_end = function()
  if common_impl.ZzCompleteCheck("get_thistleext") then ObjSet( common_impl.hint["get_thistleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_binsext_thistleext_sh")
end;

cmn.AddSubscriber( "get_thistleext", private.get_thistleext_inv );
cmn.AddSubscriber( "get_thistleext", private.get_thistleext_beg, private.room_objname );
cmn.AddSubscriber( "get_thistleext", private.get_thistleext_end, private.room_objname );
cmn.AddSubscriber( "get_thistleext", private.get_thistleext_logic );
--------------------------------------------------------------------
function public.get_thistleext()
  cmn.SetEventDone( "get_thistleext" );
  cmn.CallEventHandler( "get_thistleext" );
  if common_impl.ZzCompleteCheck("get_thistleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_compassext_zone_clk()  --rm_pondext.use_compassext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_compassext' )
  end;  
  
  SoundSfx( "aud_touch_big_metal" );
  ld.Lock(1);
  ld.AnimPlay( "anm_binsext_anm_cover1", "idle_cover1", func_end );
end;  


common_impl.hint[ "use_compassext" ] = { type = "use", inv_obj = "inv_compassext", use_place = "gfx_binsext_compassext_zone", room = "rm_pondext", zz = "zz_binsext", zz_gate = "gzz_pondext_binsext" };

private.use_compassext_logic = function()
  ObjSet( "spr_binsext_tokenext", { visible = 1, input = 1, active = 1 } )

end;
private.use_compassext_inv = function()
  common_impl.ProcessMultiUseAll("compassext", "compassext")
end;
private.use_compassext_beg = function()
  ObjDelete( "gfx_binsext_compassext_zone" );
end;
private.use_compassext_end = function()
  if common_impl.ZzCompleteCheck("use_compassext") then ObjSet( common_impl.hint["use_compassext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_binsext_anm_cover1")
  ObjSet( "spr_binsext_tokenext_sh", {visible = 1} );
  ObjDelete("spr_pondext_tr4");
  ObjSet( "spr_pondext_tr5", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_compassext", private.use_compassext_inv );
cmn.AddSubscriber( "use_compassext", private.use_compassext_beg, private.room_objname );
cmn.AddSubscriber( "use_compassext", private.use_compassext_end, private.room_objname );
cmn.AddSubscriber( "use_compassext", private.use_compassext_logic );
cmn.AddSubscriber( "use_compassext_inv", private.use_compassext_inv, private.room_objname );
cmn.AddSubscriber( "use_compassext_beg", private.use_compassext_beg, private.room_objname );
cmn.AddSubscriber( "use_compassext_end", private.use_compassext_end, private.room_objname );
cmn.AddSubscriber( "use_compassext_end", private.use_compassext_logic );
--------------------------------------------------------------------------------------------
function public.use_compassext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_compassext" );
    cmn.CallEventHandler( "use_compassext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_compassext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_compassext_inv" );
  cmn.CallEventHandler( "use_compassext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_binsext_anm_cover1", "use_compas", func_end );
  SoundSfx( "aud_use_compassext_pondext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tokenext" ] = { type = "get", get_obj = "spr_binsext_tokenext", room = "rm_pondext", zz = "zz_binsext", zz_gate = "gzz_pondext_binsext" };

private.get_tokenext_logic = function()
  
end;
private.get_tokenext_inv = function()
  interface.InventoryItemAdd("inv_tokenext","spr_binsext_tokenext");
end;
private.get_tokenext_beg = function()
  ObjDelete("gfx_binsext_tokenext")
end;
private.get_tokenext_end = function()
  if common_impl.ZzCompleteCheck("get_tokenext") then ObjSet( common_impl.hint["get_tokenext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_binsext_tokenext_sh")
end;

cmn.AddSubscriber( "get_tokenext", private.get_tokenext_inv );
cmn.AddSubscriber( "get_tokenext", private.get_tokenext_beg, private.room_objname );
cmn.AddSubscriber( "get_tokenext", private.get_tokenext_end, private.room_objname );
cmn.AddSubscriber( "get_tokenext", private.get_tokenext_logic );
--------------------------------------------------------------------
function public.get_tokenext()
  cmn.SetEventDone( "get_tokenext" );
  cmn.CallEventHandler( "get_tokenext" );
  if common_impl.ZzCompleteCheck("get_tokenext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_boothext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_cornext" ] = { type = "get", get_obj = "spr_boothext_cornext", room = "rm_pondext", zz = "zz_boothext", zz_gate = "gzz_pondext_boothext" };

private.get_cornext_logic = function()
  
end;
private.get_cornext_inv = function()
  interface.InventoryItemAdd("inv_cornext","spr_boothext_cornext");
end;
private.get_cornext_beg = function()
  ObjDelete("gfx_boothext_cornext")
end;
private.get_cornext_end = function()
  if common_impl.ZzCompleteCheck("get_cornext") then ObjSet( common_impl.hint["get_cornext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boothext_cornext_sh");
  ObjDelete("spr_pondext_tr9");
end;

cmn.AddSubscriber( "get_cornext", private.get_cornext_inv );
cmn.AddSubscriber( "get_cornext", private.get_cornext_beg, private.room_objname );
cmn.AddSubscriber( "get_cornext", private.get_cornext_end, private.room_objname );
cmn.AddSubscriber( "get_cornext", private.get_cornext_logic );
--------------------------------------------------------------------
function public.get_cornext()
  cmn.SetEventDone( "get_cornext" );
  cmn.CallEventHandler( "get_cornext" );
  if common_impl.ZzCompleteCheck("get_cornext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_keyboothext" ] = { type = "use", inv_obj = "inv_keyboothext", use_place = "gfx_boothext_keyboothext_zone", room = "rm_pondext", zz = "zz_boothext", zz_gate = "gzz_pondext_boothext" };

private.use_keyboothext_logic = function()
  -- ObjSet( "spr_boothext_rudderext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_boothext_clk_keyboothext_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_keyboothext_inv = function()
  common_impl.ProcessMultiUseAll("keyboothext", "keyboothext")
end;
private.use_keyboothext_beg = function()
  ObjDelete( "gfx_boothext_keyboothext_zone" );
end;
private.use_keyboothext_end = function()
  if common_impl.ZzCompleteCheck("use_keyboothext") then ObjSet( common_impl.hint["use_keyboothext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boothext_anm_window", {animfunc = "open_wind", frame = 0 } );
  ObjSet( "spr_pondext_tr7", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_keyboothext", private.use_keyboothext_inv );
cmn.AddSubscriber( "use_keyboothext", private.use_keyboothext_beg, private.room_objname );
cmn.AddSubscriber( "use_keyboothext", private.use_keyboothext_end, private.room_objname );
cmn.AddSubscriber( "use_keyboothext", private.use_keyboothext_logic );
cmn.AddSubscriber( "use_keyboothext_inv", private.use_keyboothext_inv, private.room_objname );
cmn.AddSubscriber( "use_keyboothext_beg", private.use_keyboothext_beg, private.room_objname );
cmn.AddSubscriber( "use_keyboothext_end", private.use_keyboothext_end, private.room_objname );
cmn.AddSubscriber( "use_keyboothext_end", private.use_keyboothext_logic );
--------------------------------------------------------------------------------------------
function public.use_keyboothext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_keyboothext" );
    cmn.CallEventHandler( "use_keyboothext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_keyboothext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_keyboothext_inv" );
  cmn.CallEventHandler( "use_keyboothext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boothext_anm_window", "use_key", func_end );
  SoundSfx( "aud_use_keyboothext_pondext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_keyboothext" ] = { type = "click", use_place = "gfx_boothext_clk_keyboothext_zone", room = "rm_pondext", zz = "zz_boothext", zz_gate = "gzz_pondext_boothext" };

private.clk_keyboothext_logic = function()
   ObjSet( "spr_boothext_rudderext", { visible = 1, input = 1, active = 1 } )
   ObjSet( "gfx_boothext_videotapeext_zone", {active = 1, input = 1, visible = 1} );
end;
private.clk_keyboothext_beg = function()
  ObjDelete( "gfx_boothext_clk_keyboothext_zone" );
end;
private.clk_keyboothext_end = function()
  if common_impl.ZzCompleteCheck("clk_keyboothext") then ObjSet( common_impl.hint["clk_keyboothext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boothext_anm_window", {animfunc = "end_wind", frame = 0 } );
  ObjSet( "spr_pondext_tr6", {visible = 1});
  ObjSet( "spr_boothext_rudderext_sh", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_keyboothext", private.clk_keyboothext_beg, private.room_objname );
cmn.AddSubscriber( "clk_keyboothext", private.clk_keyboothext_end, private.room_objname );
cmn.AddSubscriber( "clk_keyboothext", private.clk_keyboothext_logic );
cmn.AddSubscriber( "clk_keyboothext_beg", private.clk_keyboothext_beg, private.room_objname );
cmn.AddSubscriber( "clk_keyboothext_end", private.clk_keyboothext_end, private.room_objname );
cmn.AddSubscriber( "clk_keyboothext_end", private.clk_keyboothext_logic );
--------------------------------------------------------------------------------------------
function public.clk_keyboothext()

  local func_end = function()
    cmn.SetEventDone( "clk_keyboothext" );
    cmn.CallEventHandler( "clk_keyboothext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_keyboothext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_keyboothext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boothext_anm_window", "open_wind", func_end );
  SoundSfx( "aud_touch_keyboothext_pondext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_rudderext" ] = { type = "get", get_obj = "spr_boothext_rudderext", room = "rm_pondext", zz = "zz_boothext", zz_gate = "gzz_pondext_boothext" };

private.get_rudderext_logic = function()
  
end;
private.get_rudderext_inv = function()
  interface.InventoryItemAdd("inv_rudderext","spr_boothext_rudderext");
end;
private.get_rudderext_beg = function()
  ObjDelete("gfx_boothext_rudderext")
end;
private.get_rudderext_end = function()
  if common_impl.ZzCompleteCheck("get_rudderext") then ObjSet( common_impl.hint["get_rudderext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boothext_rudderext_sh")
end;

cmn.AddSubscriber( "get_rudderext", private.get_rudderext_inv );
cmn.AddSubscriber( "get_rudderext", private.get_rudderext_beg, private.room_objname );
cmn.AddSubscriber( "get_rudderext", private.get_rudderext_end, private.room_objname );
cmn.AddSubscriber( "get_rudderext", private.get_rudderext_logic );
--------------------------------------------------------------------
function public.get_rudderext()
  cmn.SetEventDone( "get_rudderext" );
  cmn.CallEventHandler( "get_rudderext" );
  if common_impl.ZzCompleteCheck("get_rudderext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_videotapeext" ] = { type = "use", inv_obj = "inv_videotapeext", use_place = "gfx_boothext_videotapeext_zone", room = "rm_pondext", zz = "zz_boothext", zz_gate = "gzz_pondext_boothext" };

private.use_videotapeext_logic = function()
  if ld.CheckRequirements( {"use_videotapeext"} ) then
    ObjSet("gfx_boothext_clk_anmcameraext_zone", { visible = 1, input = 1, active = 1 })
  end;

end;
private.use_videotapeext_inv = function()
  common_impl.ProcessMultiUseAll("videotapeext", "videotapeext")
end;
private.use_videotapeext_beg = function()
  ObjDelete( "gfx_boothext_videotapeext_zone" );
end;
private.use_videotapeext_end = function()
  if common_impl.ZzCompleteCheck("use_videotapeext") then ObjSet( common_impl.hint["use_videotapeext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boothext_anm_vhs", {animfunc = "end_cassett", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_videotapeext", private.use_videotapeext_inv );
cmn.AddSubscriber( "use_videotapeext", private.use_videotapeext_beg, private.room_objname );
cmn.AddSubscriber( "use_videotapeext", private.use_videotapeext_end, private.room_objname );
cmn.AddSubscriber( "use_videotapeext", private.use_videotapeext_logic );
cmn.AddSubscriber( "use_videotapeext_inv", private.use_videotapeext_inv, private.room_objname );
cmn.AddSubscriber( "use_videotapeext_beg", private.use_videotapeext_beg, private.room_objname );
cmn.AddSubscriber( "use_videotapeext_end", private.use_videotapeext_end, private.room_objname );
cmn.AddSubscriber( "use_videotapeext_end", private.use_videotapeext_logic );
--------------------------------------------------------------------------------------------
function public.use_videotapeext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_videotapeext" );
    cmn.CallEventHandler( "use_videotapeext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_videotapeext") then ld.CloseSubRoom() end;
    public.clk_anmcameraext();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_videotapeext_inv" );
  cmn.CallEventHandler( "use_videotapeext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boothext_anm_vhs", "use_cassett", func_end );
  SoundSfx( "aud_use_videotapeext_pondext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmcameraext" ] = { type = "click", use_place = "gfx_boothext_clk_anmcameraext_zone", room = "rm_pondext", zz = "zz_boothext", zz_gate = "gzz_pondext_boothext" };

private.clk_anmcameraext_logic = function()
  ObjSet( "spr_boothext_buttonext2", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_boothext_buttonext2", {active=1, visible=1} );
end;
private.clk_anmcameraext_beg = function()
  ObjDelete( "gfx_boothext_clk_anmcameraext_zone" );
end;
private.clk_anmcameraext_end = function()
  if common_impl.ZzCompleteCheck("clk_anmcameraext") then ObjSet( common_impl.hint["clk_anmcameraext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("vid_pondext_vid_cassete");
  ObjSet( "anm_boothext_anm_vhs", {animfunc = "butn", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmcameraext", private.clk_anmcameraext_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmcameraext", private.clk_anmcameraext_end, private.room_objname );
cmn.AddSubscriber( "clk_anmcameraext", private.clk_anmcameraext_logic );
cmn.AddSubscriber( "clk_anmcameraext_beg", private.clk_anmcameraext_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmcameraext_end", private.clk_anmcameraext_end, private.room_objname );
cmn.AddSubscriber( "clk_anmcameraext_end", private.clk_anmcameraext_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmcameraext()

  local func_end = function()
    cmn.SetEventDone( "clk_anmcameraext" );
    cmn.CallEventHandler( "clk_anmcameraext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_anmcameraext") then ld.CloseSubRoom() end;
    ld.ShowBbt("aftervidcassete");
    SoundTheme( "aud_danger2_mus" );
  end;

  local func_preend3 = function()
    SoundSfx( "aud_touch_button_spring_pondext" );
    ld.AnimPlay( "anm_boothext_anm_vhs", "butn", func_end )
  end;  
  
  
  local func_preend2 = function()
    ld.Lock(1);
    SoundEnv( "aud_pondext_env" )
    int.DialogVideoHide();
    common_impl.Gate_MDown( "gzz_pondext_boothext" );
    ld.StartTimer( 0.5, func_preend3 )
  end;  
  
  
  local func_preend = function()
    SoundEnv(0)
    ld.Lock(0);
    int.DialogVideoShow( "vid_pondext_vid_cassete", 1, func_preend2 );
    SoundVid( "aud_clk_anmcameraext" )
    VidPlay("vid_pondext_vid_cassete",func_preend2); 
  end;  
  
  
  cmn.CallEventHandler( "clk_anmcameraext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  
  --SoundSfx( "aud_clk_anmcameraext" )
  --func_end()
  ld.StartTimer( 0.5, function() ld.CloseSubRoom(); ld.StartTimer( 0.5, func_preend ) end )
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_buttonext2" ] = { type = "get", get_obj = "spr_boothext_buttonext2", room = "rm_pondext", zz = "zz_boothext", zz_gate = "gzz_pondext_boothext" };

private.get_buttonext2_logic = function()
  
end;
private.get_buttonext2_inv = function()
  interface.InventoryItemAdd("inv_buttonext2","spr_boothext_buttonext2");
end;
private.get_buttonext2_beg = function()
  ObjDelete("gfx_boothext_buttonext2")
end;
private.get_buttonext2_end = function()
  if common_impl.ZzCompleteCheck("get_buttonext2") then ObjSet( common_impl.hint["get_buttonext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boothext_anm_vhs", {animfunc = "butn_end", frame = 0 } );
end;

cmn.AddSubscriber( "get_buttonext2", private.get_buttonext2_inv );
cmn.AddSubscriber( "get_buttonext2", private.get_buttonext2_beg, private.room_objname );
cmn.AddSubscriber( "get_buttonext2", private.get_buttonext2_end, private.room_objname );
cmn.AddSubscriber( "get_buttonext2", private.get_buttonext2_logic );
--------------------------------------------------------------------
function public.get_buttonext2()
  ObjSet( "spr_boothext_buttonext2", {visible = 1} );
  cmn.SetEventDone( "get_buttonext2" );
  cmn.CallEventHandler( "get_buttonext2" );
  if common_impl.ZzCompleteCheck("get_buttonext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_boatext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_regulatorext_zone_clk()  --rm_pondext.use_regulatorext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_regulatorext' )
  end;  
  
  ld.Lock(1);
  ld.AnimPlay( "anm_boatext_anm_cover", "click_cover", func_end );
  SoundSfx( "aud_touch_small_door" );
end;  



common_impl.hint[ "use_regulatorext" ] = { type = "use", inv_obj = "inv_regulatorext", use_place = "gfx_boatext_regulatorext_zone", room = "rm_pondext", zz = "zz_boatext", zz_gate = "gzz_pondext_boatext" };

private.use_regulatorext_logic = function()
  ObjSet( "obj_boatext_mmg_root", { visible = 1, input = 1, active = 1, alp=1 } )

end;
private.use_regulatorext_inv = function()
  common_impl.ProcessMultiUseAll("regulatorext", "regulatorext")
end;
private.use_regulatorext_beg = function()
  ObjDelete( "gfx_boatext_regulatorext_zone" );
end;
private.use_regulatorext_end = function()
  if common_impl.ZzCompleteCheck("use_regulatorext") then ObjSet( common_impl.hint["use_regulatorext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boatext_anm_btn", {animfunc = "use_btn", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_regulatorext", private.use_regulatorext_inv );
cmn.AddSubscriber( "use_regulatorext", private.use_regulatorext_beg, private.room_objname );
cmn.AddSubscriber( "use_regulatorext", private.use_regulatorext_end, private.room_objname );
cmn.AddSubscriber( "use_regulatorext", private.use_regulatorext_logic );
cmn.AddSubscriber( "use_regulatorext_inv", private.use_regulatorext_inv, private.room_objname );
cmn.AddSubscriber( "use_regulatorext_beg", private.use_regulatorext_beg, private.room_objname );
cmn.AddSubscriber( "use_regulatorext_end", private.use_regulatorext_end, private.room_objname );
cmn.AddSubscriber( "use_regulatorext_end", private.use_regulatorext_logic );
--------------------------------------------------------------------------------------------
function public.use_regulatorext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    -- common_impl.Lock(0);
    private.init_bombext2();
    ObjSet( "obj_boatext_mmg_root", {alp=0} );
    ObjAnimate( "obj_boatext_mmg_root", 8, 0, 0, function() 
         common_impl.Lock(0); 
         cmn.SetEventDone( "use_regulatorext" );
         cmn.CallEventHandler( "use_regulatorext_end" );
         cmn.MiniGameShow( "bombext2" );
    end,{0,0,0, 0.5,0,1} );  
    if common_impl.ZzCompleteCheck("use_regulatorext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_regulatorext_inv" );
  cmn.CallEventHandler( "use_regulatorext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boatext_anm_btn", "use_btn", func_end );
  SoundSfx( "aud_use_regulatorext_pondext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_bombext2" ] = { type = "click", use_place = "obj_boatext_mmg_root", room = "rm_pondext", zz = "zz_boatext", zz_gate = "gzz_pondext_boatext" };

private.win_bombext2_logic = function()
  if cmn.IsEventDone("win_bombext2") then 
    ObjSet( "spr_boatext_keyboothext", { visible = 0, input = 1, active = 1 } )
    ObjSet( "gfx_boatext_keyboothext", {active=1, visible = 1} );
  end;
end;
private.win_bombext2_beg = function()
  if cmn.IsEventDone("win_bombext2") then 
  --   ObjDelete( "gfx_boatext_win_bombext2_zone" );
  end;   
end;
private.win_bombext2_end = function()
  if cmn.IsEventDone("win_bombext2") then 
     ObjDelete("obj_boatext_mmg_root")
     if common_impl.ZzCompleteCheck("win_bombext2") then ObjSet( common_impl.hint["win_bombext2"].zz_gate, { visible = 0, input = 0 } ); end;
     ObjSet( "spr_boatext_panel_trash", {visible = 1} );
     ObjDelete("anm_boatext_anm_btn");
     ObjSet( "anm_boatext_anm_cover", {animfunc = "open_cover", frame = 999 } );
     ObjDelete("anm_boatext_anm_btn_sign");
  end;   
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_bombext2", private.win_bombext2_beg, private.room_objname );
cmn.AddSubscriber( "win_bombext2", private.win_bombext2_end, private.room_objname );
cmn.AddSubscriber( "win_bombext2", private.win_bombext2_logic );
cmn.AddSubscriber( "win_bombext2_beg", private.win_bombext2_beg, private.room_objname );
cmn.AddSubscriber( "win_bombext2_end", private.win_bombext2_end, private.room_objname );
cmn.AddSubscriber( "win_bombext2_end", private.win_bombext2_logic );
--------------------------------------------------------------------------------------------
function public.win_bombext2()

  local func_end = function()
    cmn.SetEventDone( "win_bombext2" );
    cmn.CallEventHandler( "win_bombext2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_bombext2") then ld.CloseSubRoom() end;
    --  levelext_inv.opnbombmapext_win_open()
    SoundTheme( "aud_danger_moment1_mus" )
  end;

  local func_preend = function()
    SoundSfx( "aud_open_small_compartment_pondext" );
    ld.AnimPlay( "anm_boatext_anm_cover", "open_cover", func_end )
  end;  
  
  cmn.MiniGameHide( "bombext2",true ); 
  cmn.CallEventHandler( "win_bombext2_beg" );
  common_impl.Lock(1);

  ld.StartTimer( 0.3, function() 
      ObjSet( "anm_boatext_anm_btn", {visible = 0} );
      ObjSet( "spr_boatext_panel_trash", {visible = 1} );
      ObjAnimate( "obj_boatext_mmg_root", 8, 0, 0, func_preend, {0,0,1, 0.5,0,1, 1,0,0} );
      --ld.AnimPlay( "", "", func_end );
      SoundSfx( "aud_mg_boatext_win" );
      --func_end() 
   
   end )
  
end;
--------------------------------------------------------------------------------------------
private.win_bombext2_fp_array={};
private.win_bombext2_state = {};

private.win_bombext2_positions={{128 ,-131},{128 ,121 },{-136,-131},{-136,121 }, {62  ,-4  },{194 ,-4  },{-70 ,-4  },{-202,-4  },{-4,122}};
private.win_bombext2_parts_fp={9,8,7,6,1,4,3,2}
-----------------------------------------1------2--------3-------4------5-------6------7-----8-----9---
private.win_bombext2_parts_way_array={{3,5,6},{5,6,9},{1,7,8},{7,8,9},{1,2,9},{1,2},{3,4,9},{3,4},{2,4,5,7}};

function private.init_bombext2()
  if not (cmn.IsEventStart("win_bombext2")) then
   ng_global.progress["ext"]["win_bombext2"].state = {}
   private.win_bombext2_state= ld.TableCopy(private.win_bombext2_parts_fp);
   ng_global.progress["ext"]["win_bombext2"].state =  private.win_bombext2_state;
  else  
    
   private.win_bombext2_state=ng_global.progress["ext"]["win_bombext2"].state;
  end
  private.win_bombext2_stand_pos();  
end;  
--------------------------------------------------------------------
private.win_bombext2_patrs_init_flag = false;
function private.win_bombext2_patrs_init()
  --  ld.LogTrace( "inited open" );
  if private.win_bombext2_patrs_init_flag==false then 
    --    ld.LogTrace( "inited" );
      for i=1,8,1 do 
         --- create blue lights
         ObjCreate("spr_boatext_light_mg_blue_"..i,"spr")
         ObjSet( "spr_boatext_light_mg_blue_"..i, {input=0, visible=0, res="assets/levels/levelext/rm_pondext/zz_boatext/light_mg2"} );
         ObjAttach( "spr_boatext_light_mg_blue_"..i,"spr_boatext_btn_mg"..i);
         
         --- create red lights
         ObjCreate("spr_boatext_light_mg_red_"..i,"spr")
         ObjSet( "spr_boatext_light_mg_red_"..i, {input=0, visible=0, res="assets/levels/levelext/rm_pondext/zz_boatext/light_mg1"} );
         ObjAttach( "spr_boatext_light_mg_red_"..i,"spr_boatext_btn_mg"..i);
         
         -- create mdown zones 
         ObjSet( "spr_boatext_btn_mg"..i, {input=1, inputrect_init=1, inputrect_w=60, inputrect_h=60, inputrect_x=-30, inputrect_y=-30, event_mdown="rm_pondext.win_bombext2_part_mdown("..i..")", event_menter="ld.SetCursor(CURSOR_HAND)", event_mleave="ld.SetCursor(CURSOR_DEFAULT)"} );
      end;  
  end; 
  private.win_bombext2_patrs_init_flag = true;   
end;    

private.win_bombext2_stand_pos_sound_flag = false;
private.win_bombext2_stand_pos_count=0; --for sound

function private.win_bombext2_stand_pos(without_win)
  local win_ver_count=0;
  for i=1,8,1 do 
    ObjSet( "spr_boatext_light_mg_red_"..i, {input=0, visible=0,alp=0});
    ObjSet( "spr_boatext_light_mg_blue_"..i, {visible = 0, alp=1} );
    ObjSet( "spr_boatext_btn_mg"..i, {pos_x=private.win_bombext2_positions[private.win_bombext2_state[i] ][1], pos_y=private.win_bombext2_positions[private.win_bombext2_state[i] ][2]} );
    if private.win_bombext2_state[i] == i then ObjSet( "spr_boatext_light_mg_blue_"..i, {visible = 1, alp=1} ); win_ver_count=win_ver_count+1; end;
  end;  
  
  if private.win_bombext2_stand_pos_sound_flag ==true then 
    if private.win_bombext2_stand_pos_count<win_ver_count then 
      SoundSfx( "aud_mg_boatext_true" );
    end;
  end;  

  private.win_bombext2_stand_pos_count = win_ver_count;
  private.win_bombext2_stand_pos_sound_flag = true;
  if without_win~=1 and win_ver_count == 8 then public.win_bombext2(); end;
end;  
--------------------------------------------------------------------------------
function public.win_bombext2_reset()
  local func_end = function()
   ng_global.progress["ext"]["win_bombext2"].state = {}
   private.win_bombext2_state= ld.TableCopy(private.win_bombext2_parts_fp);
   ng_global.progress["ext"]["win_bombext2"].state =  private.win_bombext2_state;
   private.win_bombext2_stand_pos();  
   ObjAnimate( "obj_boatext_mmg_second_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );
  end;  
  
  
  private.win_bombext2_stand_pos_sound_flag = false;
  ld.Lock(1);
  ObjAnimate( "obj_boatext_mmg_second_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;  
--------------------------------------------------------------------------------
function public.win_bombext2_skip()
  local func_end = function()
    ng_global.progress["ext"]["win_bombext2"].state = {1,2,3,4,5,6,7,8};
   private.win_bombext2_state= ng_global.progress["ext"]["win_bombext2"].state;   
   private.win_bombext2_stand_pos(1); -- 1 - without win verification  
   ObjAnimate( "obj_boatext_mmg_second_root", 8, 0, 0, function() private.win_bombext2_stand_pos();  end, {0,0,0, 0.25,0,1} );
  end;  
  
  
  ld.Lock(1);
  ObjAnimate( "obj_boatext_mmg_second_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;  
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function private.win_bombext2_return_pos_value(pos)
  local count=0;
  for i=1,8,1 do 
    if  private.win_bombext2_state[i]==pos then 
      count=count+1;
    end;  
  end;  
  if count==0 then return true; else return false; end;
end;  

function private.win_bombext2_search_empty_pos(num)
  local part_pos = private.win_bombext2_state[num];
  for i=1,#private.win_bombext2_parts_way_array[part_pos],1 do 
    if private.win_bombext2_return_pos_value(private.win_bombext2_parts_way_array[part_pos][i])==true then return private.win_bombext2_parts_way_array[part_pos][i]; end;
  end;  
  return 0;
end;  

function public.win_bombext2_part_mdown(num)
  local func_end = function()
     ld.Lock(0);
      private.win_bombext2_stand_pos();
  end;
    
  ld.Lock(1);
  if private.win_bombext2_search_empty_pos(num)== 0 then 
     SoundSfx( "aud_mg_boatext_wrong" );
     ObjSet( "spr_boatext_light_mg_red_"..num, {visible = 1, alp=0} );
     ObjAnimate( "spr_boatext_light_mg_red_"..num, 8, 0, 0, func_end, {0,0,0, 0.25,0,1, 0.5,0,0} );
  else 
     local new_pos = private.win_bombext2_search_empty_pos(num);
     local new_pos_coord = ld.TableCopy(private.win_bombext2_positions[new_pos]);
     local cur_pos_coord = ld.TableCopy(private.win_bombext2_positions[private.win_bombext2_state[num] ]);
     
     private.win_bombext2_state[num] = new_pos;
     
     ObjAnimate( "spr_boatext_btn_mg"..num, 3, 0, 0, func_end, {0,0,cur_pos_coord[1],cur_pos_coord[2], 0.3,0,new_pos_coord[1],new_pos_coord[2]} );
     SoundSfx( "aud_mg_boatext_move" );
  end;  
end;  
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_keyboothext" ] = { type = "get", get_obj = "spr_boatext_keyboothext", room = "rm_pondext", zz = "zz_boatext", zz_gate = "gzz_pondext_boatext" };

private.get_keyboothext_logic = function()
  
end;
private.get_keyboothext_inv = function()
  interface.InventoryItemAdd("inv_keyboothext","spr_boatext_keyboothext");
end;
private.get_keyboothext_beg = function()
  ObjDelete("gfx_boatext_keyboothext")
end;
private.get_keyboothext_end = function()
  if common_impl.ZzCompleteCheck("get_keyboothext") then ObjSet( common_impl.hint["get_keyboothext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boatext_anm_cover", {animfunc = "open_end", frame = 0 } );
end;

cmn.AddSubscriber( "get_keyboothext", private.get_keyboothext_inv );
cmn.AddSubscriber( "get_keyboothext", private.get_keyboothext_beg, private.room_objname );
cmn.AddSubscriber( "get_keyboothext", private.get_keyboothext_end, private.room_objname );
cmn.AddSubscriber( "get_keyboothext", private.get_keyboothext_logic );
--------------------------------------------------------------------
function public.get_keyboothext()
  ObjSet( "spr_boatext_keyboothext", {visible = 1} );
  cmn.SetEventDone( "get_keyboothext" );
  cmn.CallEventHandler( "get_keyboothext" );
  if common_impl.ZzCompleteCheck("get_keyboothext") then ld.CloseSubRoom() end;
  levelext_inv.opnbombmapext_win_open()
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_rudderext_zone_clk()  --rm_pondext.use_rudderext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_rudderext' );
  end;  
  
  SoundSfx( "aud_touch_small_wood" );
  ld.Lock(1);
  ld.AnimPlay( "anm_boatext_anm_rudder", "idle_cover2", func_end )
  
end;  


common_impl.hint[ "use_rudderext" ] = { type = "use", inv_obj = "inv_rudderext", use_place = "gfx_boatext_rudderext_zone", room = "rm_pondext", zz = "zz_boatext", zz_gate = "gzz_pondext_boatext" };

private.use_rudderext_logic = function()
  ObjSet( "spr_boatext_hacksawext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_boatext_cannedext", { visible = 1, input = 1, active = 1 } )

end;
private.use_rudderext_inv = function()
  common_impl.ProcessMultiUseAll("rudderext", "rudderext")
end;
private.use_rudderext_beg = function()
  ObjDelete( "gfx_boatext_rudderext_zone" );
end;
private.use_rudderext_end = function()
  if common_impl.ZzCompleteCheck("use_rudderext") then ObjSet( common_impl.hint["use_rudderext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_boatext_cannedext_sh", {visible = 1} );
  ObjSet( "spr_boatext_hacksawext_sh", {visible = 1} );
  ObjSet( "anm_boatext_anm_rudder", {animfunc = "end_rudder", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rudderext", private.use_rudderext_inv );
cmn.AddSubscriber( "use_rudderext", private.use_rudderext_beg, private.room_objname );
cmn.AddSubscriber( "use_rudderext", private.use_rudderext_end, private.room_objname );
cmn.AddSubscriber( "use_rudderext", private.use_rudderext_logic );
cmn.AddSubscriber( "use_rudderext_inv", private.use_rudderext_inv, private.room_objname );
cmn.AddSubscriber( "use_rudderext_beg", private.use_rudderext_beg, private.room_objname );
cmn.AddSubscriber( "use_rudderext_end", private.use_rudderext_end, private.room_objname );
cmn.AddSubscriber( "use_rudderext_end", private.use_rudderext_logic );
--------------------------------------------------------------------------------------------
function public.use_rudderext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_rudderext" );
    cmn.CallEventHandler( "use_rudderext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rudderext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rudderext_inv" );
  cmn.CallEventHandler( "use_rudderext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boatext_anm_rudder", "use_rudder", func_end );
  SoundSfx( "aud_use_rudderext_pondext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hacksawext" ] = { type = "get", get_obj = "spr_boatext_hacksawext", room = "rm_pondext", zz = "zz_boatext", zz_gate = "gzz_pondext_boatext" };

private.get_hacksawext_logic = function()
  
end;
private.get_hacksawext_inv = function()
  interface.InventoryItemAdd("inv_hacksawext","spr_boatext_hacksawext");
end;
private.get_hacksawext_beg = function()
  ObjDelete("gfx_boatext_hacksawext")
end;
private.get_hacksawext_end = function()
  if common_impl.ZzCompleteCheck("get_hacksawext") then ObjSet( common_impl.hint["get_hacksawext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boatext_hacksawext_sh");
end;

cmn.AddSubscriber( "get_hacksawext", private.get_hacksawext_inv );
cmn.AddSubscriber( "get_hacksawext", private.get_hacksawext_beg, private.room_objname );
cmn.AddSubscriber( "get_hacksawext", private.get_hacksawext_end, private.room_objname );
cmn.AddSubscriber( "get_hacksawext", private.get_hacksawext_logic );
--------------------------------------------------------------------
function public.get_hacksawext()
  cmn.SetEventDone( "get_hacksawext" );
  cmn.CallEventHandler( "get_hacksawext" );
  if common_impl.ZzCompleteCheck("get_hacksawext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cannedext" ] = { type = "get", get_obj = "spr_boatext_cannedext", room = "rm_pondext", zz = "zz_boatext", zz_gate = "gzz_pondext_boatext" };

private.get_cannedext_logic = function()
  
end;
private.get_cannedext_inv = function()
  interface.InventoryItemAdd("inv_cannedext","spr_boatext_cannedext");
  ObjSet( "inv_cannedext", { drag = 0 } );
end;
private.get_cannedext_beg = function()
  ObjDelete("gfx_boatext_cannedext")
end;
private.get_cannedext_end = function()
  if common_impl.ZzCompleteCheck("get_cannedext") then ObjSet( common_impl.hint["get_cannedext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boatext_cannedext_sh")
end;

cmn.AddSubscriber( "get_cannedext", private.get_cannedext_inv );
cmn.AddSubscriber( "get_cannedext", private.get_cannedext_beg, private.room_objname );
cmn.AddSubscriber( "get_cannedext", private.get_cannedext_end, private.room_objname );
cmn.AddSubscriber( "get_cannedext", private.get_cannedext_logic );
--------------------------------------------------------------------
function public.get_cannedext()
  cmn.SetEventDone( "get_cannedext" );
  cmn.CallEventHandler( "get_cannedext" );
  if common_impl.ZzCompleteCheck("get_cannedext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_keycompartmentext_zone_clk() --rm_pondext.use_keycompartmentext_zone_clk()
  local func_end = function()
     ld.Lock(0);
     common_impl.ShowBbt( 'need_keycompartmentext' );
  end;
  
  SoundSfx( "aud_touch_small_wood" ); 
  ld.Lock(1);
  ld.AnimPlay( "anm_boatext_anm_key", "idle_cover1", func_end )
end;  


common_impl.hint[ "use_keycompartmentext" ] = { type = "use", inv_obj = "inv_keycompartmentext", use_place = "gfx_boatext_keycompartmentext_zone", room = "rm_pondext", zz = "zz_boatext", zz_gate = "gzz_pondext_boatext" };

private.use_keycompartmentext_logic = function()
  ObjSet( "spr_boatext_whiskeyext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_boatext_whiskeyext", {active=1, visible=1} );

end;
private.use_keycompartmentext_inv = function()
  common_impl.ProcessMultiUseAll("keycompartmentext", "keycompartmentext")
end;
private.use_keycompartmentext_beg = function()
  ObjDelete( "gfx_boatext_keycompartmentext_zone" );
end;
private.use_keycompartmentext_end = function()
  if common_impl.ZzCompleteCheck("use_keycompartmentext") then ObjSet( common_impl.hint["use_keycompartmentext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boatext_anm_key", {animfunc = "use_key", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_keycompartmentext", private.use_keycompartmentext_inv );
cmn.AddSubscriber( "use_keycompartmentext", private.use_keycompartmentext_beg, private.room_objname );
cmn.AddSubscriber( "use_keycompartmentext", private.use_keycompartmentext_end, private.room_objname );
cmn.AddSubscriber( "use_keycompartmentext", private.use_keycompartmentext_logic );
cmn.AddSubscriber( "use_keycompartmentext_inv", private.use_keycompartmentext_inv, private.room_objname );
cmn.AddSubscriber( "use_keycompartmentext_beg", private.use_keycompartmentext_beg, private.room_objname );
cmn.AddSubscriber( "use_keycompartmentext_end", private.use_keycompartmentext_end, private.room_objname );
cmn.AddSubscriber( "use_keycompartmentext_end", private.use_keycompartmentext_logic );
--------------------------------------------------------------------------------------------
function public.use_keycompartmentext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_keycompartmentext" );
    cmn.CallEventHandler( "use_keycompartmentext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_keycompartmentext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_keycompartmentext_inv" );
  cmn.CallEventHandler( "use_keycompartmentext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boatext_anm_key", "use_key", func_end );
  SoundSfx( "aud_use_keycompartmentext_pondext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_whiskeyext" ] = { type = "get", get_obj = "spr_boatext_whiskeyext", room = "rm_pondext", zz = "zz_boatext", zz_gate = "gzz_pondext_boatext" };

private.get_whiskeyext_logic = function()
  
end;
private.get_whiskeyext_inv = function()
  interface.InventoryItemAdd("inv_whiskeyext","spr_boatext_whiskeyext");
end;
private.get_whiskeyext_beg = function()
  ObjDelete("gfx_boatext_whiskeyext")
end;
private.get_whiskeyext_end = function()
  if common_impl.ZzCompleteCheck("get_whiskeyext") then ObjSet( common_impl.hint["get_whiskeyext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boatext_anm_key", {animfunc = "end_key", frame = 0 } );
end;

cmn.AddSubscriber( "get_whiskeyext", private.get_whiskeyext_inv );
cmn.AddSubscriber( "get_whiskeyext", private.get_whiskeyext_beg, private.room_objname );
cmn.AddSubscriber( "get_whiskeyext", private.get_whiskeyext_end, private.room_objname );
cmn.AddSubscriber( "get_whiskeyext", private.get_whiskeyext_logic );
--------------------------------------------------------------------
function public.get_whiskeyext()
  ObjSet( "spr_boatext_whiskeyext", {visible = 1} );
  cmn.SetEventDone( "get_whiskeyext" );
  cmn.CallEventHandler( "get_whiskeyext" );
  if common_impl.ZzCompleteCheck("get_whiskeyext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_boatext" ) and not ld.CheckRequirements( { "win_bombext2" } ) then  
      public.win_bombext2_reset()
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_boatext" ) and not ld.CheckRequirements( { "win_bombext2" } ) then
    public.win_bombext2_skip();
  end;
  
end
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_pondext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_pondext_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_boatext" );
  function zz_boatext.Open()
  end;
  function zz_boatext.PreOpen()
    if not cmn.IsEventDone("win_bombext2") then 
       private.win_bombext2_patrs_init();
    end;  
    
    if cmn.IsEventStart("win_bombext2") and not cmn.IsEventDone("win_bombext2") then 
        cmn.MiniGameShow( "bombext2" ); 
        private.init_bombext2();
     end;  
  end;
  function zz_boatext.PreClose()
  end;
  function zz_boatext.Close()
    if cmn.IsEventStart("win_bombext2") and not cmn.IsEventDone("win_bombext2") then 
       cmn.MiniGameHide( "bombext2" ); 
    end; 
  end;

  subroom.Define( "zz_boothext" );
  function zz_boothext.Open()
  end;
  function zz_boothext.PreOpen()
    SoundEnv("aud_inhouseext_tv_env",1);
  end;
  function zz_boothext.PreClose()
  end;
  function zz_boothext.Close()
     SoundEnv("aud_inhouseext_tv_env",0);
  end;

  subroom.Define( "zz_binsext" );
  function zz_binsext.Open()
  end;
  function zz_binsext.PreOpen()
  end;
  function zz_binsext.PreClose()
  end;
  function zz_binsext.Close()
  end;
  
end;
--*********************************************************************************************************************
---------------------------OTHERS----------------------------------
function public.pondext_frog_zone_clk(num)
  local func_end = function()
    ObjSet( "obj_pondext_frog_clk_zone"..num, {input=1} );  
  end;

  local frogs_sound_array={"aud_touch_frog_center_pondext","aud_touch_frog_left_pondext"};
  SoundSfx( frogs_sound_array[num] );
  ObjSet( "obj_pondext_frog_clk_zone"..num, {input=0} );
  ld.AnimPlay( "anm_pondext_anim_frog"..num, ObjGet("anm_pondext_anim_frog"..num).animfunc, func_end )  
end;  
---------------------------------------------------------------------