-- name=rm_staffonlyext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_staffonlyext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_staffonlyext()
  if not ( cmn.IsEventDone( "opn_staffonlyext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_staffonlyext" );
      cmn.CallEventHandler( "opn_staffonlyext" )
      --  ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("afterdlgglory");
      SoundTheme( "aud_danger_moment3_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_staffonlyext = function() end;
local opn_staffonlyext_logic = function() end;
cmn.AddSubscriber( "opn_staffonlyext", opn_staffonlyext_logic )
cmn.AddSubscriber( "opn_staffonlyext", opn_staffonlyext, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_servicecardext" ] = { type = "get", get_obj = "spr_staffonlyext_servicecardext", room = "rm_staffonlyext" };

private.get_servicecardext_logic = function()
  
end;
private.get_servicecardext_inv = function()
  interface.InventoryItemAdd("inv_servicecardext","spr_staffonlyext_servicecardext");
end;
private.get_servicecardext_beg = function()
  ObjDelete("gfx_staffonlyext_servicecardext")
end;
private.get_servicecardext_end = function()
  
end;

cmn.AddSubscriber( "get_servicecardext", private.get_servicecardext_inv );
cmn.AddSubscriber( "get_servicecardext", private.get_servicecardext_beg, private.room_objname );
cmn.AddSubscriber( "get_servicecardext", private.get_servicecardext_end, private.room_objname );
cmn.AddSubscriber( "get_servicecardext", private.get_servicecardext_logic );
--------------------------------------------------------------------
function public.get_servicecardext()
  cmn.SetEventDone( "get_servicecardext" );
  cmn.CallEventHandler( "get_servicecardext" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_keylatticeext" ] = { type = "use", inv_obj = "inv_keylatticeext", use_place = "gfx_staffonlyext_keylatticeext_zone", room = "rm_staffonlyext" };

private.use_keylatticeext_logic = function()
  ObjSet( "gfx_staffonlyext_clk_gagext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_keylatticeext_inv = function()
  common_impl.ProcessMultiUseAll("keylatticeext", "keylatticeext")
end;
private.use_keylatticeext_beg = function()
  ObjDelete( "gfx_staffonlyext_keylatticeext_zone" );
end;
private.use_keylatticeext_end = function()
  ObjSet( "anm_staffonlyext_door", {animfunc="door_end",frame=0} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_keylatticeext", private.use_keylatticeext_inv );
cmn.AddSubscriber( "use_keylatticeext", private.use_keylatticeext_beg, private.room_objname );
cmn.AddSubscriber( "use_keylatticeext", private.use_keylatticeext_end, private.room_objname );
cmn.AddSubscriber( "use_keylatticeext", private.use_keylatticeext_logic );
cmn.AddSubscriber( "use_keylatticeext_inv", private.use_keylatticeext_inv, private.room_objname );
cmn.AddSubscriber( "use_keylatticeext_beg", private.use_keylatticeext_beg, private.room_objname );
cmn.AddSubscriber( "use_keylatticeext_end", private.use_keylatticeext_end, private.room_objname );
cmn.AddSubscriber( "use_keylatticeext_end", private.use_keylatticeext_logic );
--------------------------------------------------------------------------------------------
function public.use_keylatticeext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_keylatticeext" );
    cmn.CallEventHandler( "use_keylatticeext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_keylatticeext_inv" );
  cmn.CallEventHandler( "use_keylatticeext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_staffonlyext_door", "door", func_end );
  SoundSfx( "aud_use_keylatticeext_staffonlyext" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_gagext" ] = { type = "click", use_place = "gfx_staffonlyext_clk_gagext_zone", room = "rm_staffonlyext" };

private.clk_gagext_logic = function()
  ObjSet( "gfx_staffonlyext_dlg_staffonlyext_gloriaext_zone", { visible = 1, input = 1, active = 1 } )
  --ObjSet( "spr_staffonlyext_plugwireext", { visible = 1, input = 1, active = 1 } )
end;
private.clk_gagext_beg = function()
  ObjDelete( "gfx_staffonlyext_clk_gagext_zone" );
end;
private.clk_gagext_end = function()
  ObjDelete("spr_staffonlyext_wire")
  ObjDelete("spr_staffonlyext_wire")
  ObjSet( "anm_staffonlyext_girl", {animfunc="static_girl2",playing=1} );
  ObjDelete("spr_staffonlyext_gag")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_gagext", private.clk_gagext_beg, private.room_objname );
cmn.AddSubscriber( "clk_gagext", private.clk_gagext_end, private.room_objname );
cmn.AddSubscriber( "clk_gagext", private.clk_gagext_logic );
cmn.AddSubscriber( "clk_gagext_beg", private.clk_gagext_beg, private.room_objname );
cmn.AddSubscriber( "clk_gagext_end", private.clk_gagext_end, private.room_objname );
cmn.AddSubscriber( "clk_gagext_end", private.clk_gagext_logic );
--------------------------------------------------------------------------------------------
function public.clk_gagext()

  local func_end = function()
    cmn.SetEventDone( "clk_gagext" );
    cmn.CallEventHandler( "clk_gagext_end" );
    -- public.get_plugwireext()
    public.dlg_staffonlyext_gloriaext();
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_gagext_beg" );
  common_impl.Lock(1);
  ObjAnimate( "spr_staffonlyext_wire", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
  ObjAnimate( "spr_staffonlyext_gag", 8, 0, 0, function()ld.AnimPlay( "anm_staffonlyext_girl", "girl", func_end ); end, {0,0,1, 0.5,0,0} );
  
  SoundSfx( "aud_clk_gagext" )


end;
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "gloriaext" then
    if count_txt == 1 then
      
    elseif count_txt == 2 then
        ld.Lock(1);
        ld.AnimPlay( "anm_staffonlyext_gloriaext", "give", function() ld.Lock(0); end )
      SoundSfx( "aud_get_to_us" );
    elseif count_txt == 3 then  
      ObjSet( "spr_staffonlyext_plugwireext", {visible = 1} );
      ld.AnimPlay( "anm_staffonlyext_gloriaext", "hand", "" )
      cmn.CallEventHandler( "get_plugwireext" )
    end;  
  end
 
end;  
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_staffonlyext_gloriaext" ] = { type = "click", use_place = "gfx_staffonlyext_dlg_staffonlyext_gloriaext_zone", room = "rm_staffonlyext" };

private.dlg_staffonlyext_gloriaext_logic = function()
  ObjSet( "spr_staffonlyext_plugwireext", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_staffonlyext_gloriaext_beg = function()
  ObjDelete( "gfx_staffonlyext_dlg_staffonlyext_gloriaext_zone" );
end;
private.dlg_staffonlyext_gloriaext_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_staffonlyext_gloriaext", private.dlg_staffonlyext_gloriaext_beg, private.room_objname );
cmn.AddSubscriber( "dlg_staffonlyext_gloriaext", private.dlg_staffonlyext_gloriaext_end, private.room_objname );
cmn.AddSubscriber( "dlg_staffonlyext_gloriaext", private.dlg_staffonlyext_gloriaext_logic );
cmn.AddSubscriber( "dlg_staffonlyext_gloriaext_beg", private.dlg_staffonlyext_gloriaext_beg, private.room_objname );
cmn.AddSubscriber( "dlg_staffonlyext_gloriaext_end", private.dlg_staffonlyext_gloriaext_end, private.room_objname );
cmn.AddSubscriber( "dlg_staffonlyext_gloriaext_end", private.dlg_staffonlyext_gloriaext_logic );
--------------------------------------------------------------------------------------------
function public.dlg_staffonlyext_gloriaext( obj )

 --local func_end = function()
 --  cmn.SetEventDone( "dlg_staffonlyext_gloriaext" );
 --  cmn.CallEventHandler( "dlg_staffonlyext_gloriaext_end" );
 --  common_impl.Lock(0);
 --end;

 --cmn.CallEventHandler( "dlg_staffonlyext_gloriaext_beg" );
 --common_impl.Lock(1);

 ----ld.AnimPlay( "", "", func_end );
 ----SoundSfx( 0 )
 --func_end()
 
 local func_end = function()
    cmn.SetEventDone( "dlg_staffonlyext_gloriaext" );
    cmn.CallEventHandler( "dlg_staffonlyext_gloriaext_end" );
    cmn.SetEventDone( "get_plugwireext" );
    common_impl.Lock(0);
    ld.ShowBbt("afterdlgglory")
  end;

  
  function public.staffonlyext_gloriaext_end()
    ObjSet( "dlg_staffonlyext_gloriaext", {bake=1} );
    if ObjGetRelations( "inv_plugwireext" ).parent == "levelext_inv_hub" then
      ObjSet( "spr_staffonlyext_plugwireext", {visible = 1} );
      cmn.CallEventHandler( "get_plugwireext");      
    end
    common_impl.Lock(1);
    func_end()
  end
  
  cmn.CallEventHandler( "dlg_staffonlyext_gloriaext_beg" );
  

  common_impl.dialog_character_loc = "anm_staffonlyext_girl";
  common_impl.continue_visible = false
  common_impl.Start( "gloriaext", 3, nil, nil, true, "staffonlyext_gloriaext_end",{"aud_gloria_1_voc","aud_gloria_2_voc"});    

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_plugwireext" ] = { type = "get", get_obj = "spr_staffonlyext_plugwireext", room = "rm_staffonlyext" };

private.get_plugwireext_logic = function()
  
end;
private.get_plugwireext_inv = function()
  interface.InventoryItemAdd("inv_plugwireext","spr_staffonlyext_plugwireext");
end;
private.get_plugwireext_beg = function()
  ObjDelete("gfx_staffonlyext_plugwireext")
end;
private.get_plugwireext_end = function()
  
end;

cmn.AddSubscriber( "get_plugwireext", private.get_plugwireext_inv );
cmn.AddSubscriber( "get_plugwireext", private.get_plugwireext_beg, private.room_objname );
cmn.AddSubscriber( "get_plugwireext", private.get_plugwireext_end, private.room_objname );
cmn.AddSubscriber( "get_plugwireext", private.get_plugwireext_logic );
--------------------------------------------------------------------
function public.get_plugwireext()
  cmn.SetEventDone( "get_plugwireext" );
  cmn.CallEventHandler( "get_plugwireext" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_outroext" ] = { type = "click", use_place = "gfx_staffonlyext_clk_outroext_zone", room = "rm_staffonlyext" };

private.clk_outroext_logic = function()

end;
private.clk_outroext_beg = function()
  ObjDelete( "gfx_staffonlyext_clk_outroext_zone" );
end;
private.clk_outroext_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_outroext", private.clk_outroext_beg, private.room_objname );
cmn.AddSubscriber( "clk_outroext", private.clk_outroext_end, private.room_objname );
cmn.AddSubscriber( "clk_outroext", private.clk_outroext_logic );
cmn.AddSubscriber( "clk_outroext_beg", private.clk_outroext_beg, private.room_objname );
cmn.AddSubscriber( "clk_outroext_end", private.clk_outroext_end, private.room_objname );
cmn.AddSubscriber( "clk_outroext_end", private.clk_outroext_logic );
--------------------------------------------------------------------------------------------
function public.clk_outroext()
  local func_end = function()
    SoundVoice(0);
    --ld.LogTrace( "clk_outrolvl1  func_end" );

    cmn.SetEventDone( "clk_outroext" );
    cmn.CallEventHandler( "clk_outroext_end" );
    --common_impl.Lock(0);

    ObjSet("rm_staffonlyext",{color_r=0,color_g=0,color_b=0})
--       local widget_settings = 
--          {
--            InterfaceWidget_Inventory,
--            InterfaceWidget_BtnHint,
--            InterfaceWidget_BtnGuide,
--            InterfaceWidget_BtnMenu,
--            InterfaceWidget_BtnMap,
--          }
--
--       for i = 1, #widget_settings do
--          interface.WidgetSetVisible( widget_settings[i], 0, false );
--       end;
      VidPause("vid_staffonlyext_vid_outro",1)
      ObjAnimate( "vid_staffonlyext_vid_outro", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
      int.DialogVideoHide();
      common.MenuCredits("game")
  end;

  cmn.CallEventHandler( "clk_outroext_beg" );
  common_impl.Lock(1);

  SoundEnv(0);
  --  ld.VidStaticPause( private.tower_vid_tower_conflict_array ); 
  ObjAttach("vid_staffonlyext_vid_outro","rm_staffonlyext");
  ObjSet( "vid_staffonlyext_vid_outro", {alp=0} );
  ObjAnimate( "vid_staffonlyext_vid_outro", 8, 0, 0, function() common_impl.Lock(0); end, {0,0,0, 0.5,0,1} );
    --  SoundSfx( "aud_clk_outroext" )
  ObjAnimate( "vid_staffonlyext_vid_outro", 7, 0, 0, function() SoundVid( "aud_clk_outroext" )   end, {0,0,0, 0,0,0} ); 
  VidPlay("vid_staffonlyext_vid_outro",func_end);
  --SoundVoice("aud_outro_voc");
  
  local widget_settings = 
     {
       InterfaceWidget_Inventory,
       InterfaceWidget_BtnHint,
       InterfaceWidget_BtnGuide,
       InterfaceWidget_BtnMenu,
       InterfaceWidget_BtnMap,
     }

  for i = 1, #widget_settings do
    interface.WidgetSetVisible( widget_settings[i], 0, false );
  end;  
  
  int.DialogVideoShow( "", 1, func_end, 1 ); 
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_switchboardext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_skittleext2" ] = { type = "get", get_obj = "spr_switchboardext_skittleext2", room = "rm_staffonlyext", zz = "zz_switchboardext", zz_gate = "gzz_staffonlyext_switchboardext" };

private.get_skittleext2_logic = function()
  
end;
private.get_skittleext2_inv = function()
  interface.InventoryItemAdd("inv_skittleext","spr_switchboardext_skittleext2",function() level_inv.ProcessGetSkittleextAll( "get_skittleext2" ) end);
end;
private.get_skittleext2_beg = function()
  ObjDelete("gfx_switchboardext_skittleext2")
end;
private.get_skittleext2_end = function()
  ObjDelete("spr_switchboardext_sh_skittleext2")
  ObjDelete("spr_staffonlyext_skittleext2")
  if common_impl.ZzCompleteCheck("get_skittleext2") then ObjSet( common_impl.hint["get_skittleext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_skittleext2", private.get_skittleext2_inv );
cmn.AddSubscriber( "get_skittleext2", private.get_skittleext2_beg, private.room_objname );
cmn.AddSubscriber( "get_skittleext2", private.get_skittleext2_end, private.room_objname );
cmn.AddSubscriber( "get_skittleext2", private.get_skittleext2_logic );
--------------------------------------------------------------------
function public.get_skittleext2()
  cmn.SetEventDone( "get_skittleext2" );
  cmn.CallEventHandler( "get_skittleext2" );
  if common_impl.ZzCompleteCheck("get_skittleext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_servicecardext" ] = { type = "use", inv_obj = "inv_servicecardext", use_place = "gfx_switchboardext_servicecardext_zone", room = "rm_staffonlyext", zz = "zz_switchboardext", zz_gate = "gzz_staffonlyext_switchboardext" };

private.use_servicecardext_logic = function()
  ObjSet( "spr_switchboardext_bottleext2", { visible = 1, input = 1, active = 1 } )

end;
private.use_servicecardext_inv = function()
  common_impl.ProcessMultiUseAll("servicecardext", "servicecardext")
end;
private.use_servicecardext_beg = function()
  ObjDelete( "gfx_switchboardext_servicecardext_zone" );
end;
private.use_servicecardext_end = function()
  ObjDelete("spr_staffonlyext_recess")
  ObjSet( "spr_switchboardext_sh_bottleext2", {alp = 1} );
  ObjSet("anm_switchboardext_anm_use_card",{animfunc="end_card",frame=0})
  ObjSet( "spr_switchboardext_tr_bottleext2", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_servicecardext") then ObjSet( common_impl.hint["use_servicecardext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_servicecardext", private.use_servicecardext_inv );
cmn.AddSubscriber( "use_servicecardext", private.use_servicecardext_beg, private.room_objname );
cmn.AddSubscriber( "use_servicecardext", private.use_servicecardext_end, private.room_objname );
cmn.AddSubscriber( "use_servicecardext", private.use_servicecardext_logic );
cmn.AddSubscriber( "use_servicecardext_inv", private.use_servicecardext_inv, private.room_objname );
cmn.AddSubscriber( "use_servicecardext_beg", private.use_servicecardext_beg, private.room_objname );
cmn.AddSubscriber( "use_servicecardext_end", private.use_servicecardext_end, private.room_objname );
cmn.AddSubscriber( "use_servicecardext_end", private.use_servicecardext_logic );
--------------------------------------------------------------------------------------------
function public.use_servicecardext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_servicecardext" );
    cmn.CallEventHandler( "use_servicecardext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_servicecardext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_servicecardext_inv" );
  cmn.CallEventHandler( "use_servicecardext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_switchboardext_anm_use_card", "use_card", func_end );
  SoundSfx( "aud_use_servicecardext_staffonlyext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bottleext2" ] = { type = "get", get_obj = "spr_switchboardext_bottleext2", room = "rm_staffonlyext", zz = "zz_switchboardext", zz_gate = "gzz_staffonlyext_switchboardext" };

private.get_bottleext2_logic = function()
  
end;
private.get_bottleext2_inv = function()
  interface.InventoryItemAdd("inv_bottleext2","spr_switchboardext_bottleext2");
end;
private.get_bottleext2_beg = function()
  ObjDelete("gfx_switchboardext_bottleext2")
end;
private.get_bottleext2_end = function()
  ObjDelete("spr_switchboardext_sh_bottleext2")
  ObjDelete("spr_staffonlyext_bottleext2")
  if common_impl.ZzCompleteCheck("get_bottleext2") then ObjSet( common_impl.hint["get_bottleext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bottleext2", private.get_bottleext2_inv );
cmn.AddSubscriber( "get_bottleext2", private.get_bottleext2_beg, private.room_objname );
cmn.AddSubscriber( "get_bottleext2", private.get_bottleext2_end, private.room_objname );
cmn.AddSubscriber( "get_bottleext2", private.get_bottleext2_logic );
--------------------------------------------------------------------
function public.get_bottleext2()
  cmn.SetEventDone( "get_bottleext2" );
  cmn.CallEventHandler( "get_bottleext2" );
  if common_impl.ZzCompleteCheck("get_bottleext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_badgelightningext" ] = { type = "use", inv_obj = "inv_badgelightningext", use_place = "gfx_switchboardext_badgelightningext_zone", room = "rm_staffonlyext", zz = "zz_switchboardext", zz_gate = "gzz_staffonlyext_switchboardext" };

private.use_badgelightningext_logic = function()
  ObjSet( "spr_switchboardext_keylatticeext", { visible = 1, input = 1, active = 1 } )

end;
private.use_badgelightningext_inv = function()
  common_impl.ProcessMultiUseAll("badgelightningext", "badgelightningext")
end;
private.use_badgelightningext_beg = function()
  ObjDelete( "gfx_switchboardext_badgelightningext_zone" );
end;
private.use_badgelightningext_end = function()
  ObjSet("spr_switchboardext_sh_keylatticeext",{alp=1})
  ObjSet("anm_switchboardext_anm_use_badgelightning",{animfunc="end_badgelightning",frame=0})
  ObjSet( "spr_staffonlyext_open_door", {alp = 1} );
  ObjSet( "spr_staffonlyext_keylatticeext", {alp = 1} );
  ObjSet( "spr_switchboardext_open_door", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_badgelightningext") then ObjSet( common_impl.hint["use_badgelightningext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_badgelightningext", private.use_badgelightningext_inv );
cmn.AddSubscriber( "use_badgelightningext", private.use_badgelightningext_beg, private.room_objname );
cmn.AddSubscriber( "use_badgelightningext", private.use_badgelightningext_end, private.room_objname );
cmn.AddSubscriber( "use_badgelightningext", private.use_badgelightningext_logic );
cmn.AddSubscriber( "use_badgelightningext_inv", private.use_badgelightningext_inv, private.room_objname );
cmn.AddSubscriber( "use_badgelightningext_beg", private.use_badgelightningext_beg, private.room_objname );
cmn.AddSubscriber( "use_badgelightningext_end", private.use_badgelightningext_end, private.room_objname );
cmn.AddSubscriber( "use_badgelightningext_end", private.use_badgelightningext_logic );
--------------------------------------------------------------------------------------------
function public.use_badgelightningext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_badgelightningext" );
    cmn.CallEventHandler( "use_badgelightningext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_badgelightningext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_badgelightningext_inv" );
  cmn.CallEventHandler( "use_badgelightningext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_switchboardext_anm_use_badgelightning", "use_badgelightning", func_end );
  SoundSfx( "aud_use_badgelightningext_staffonlyext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_keylatticeext" ] = { type = "get", get_obj = "spr_switchboardext_keylatticeext", room = "rm_staffonlyext", zz = "zz_switchboardext", zz_gate = "gzz_staffonlyext_switchboardext" };

private.get_keylatticeext_logic = function()
  
end;
private.get_keylatticeext_inv = function()
  interface.InventoryItemAdd("inv_keylatticeext","spr_switchboardext_keylatticeext");
end;
private.get_keylatticeext_beg = function()
  ObjDelete("gfx_switchboardext_keylatticeext")
end;
private.get_keylatticeext_end = function()
  ObjDelete("spr_switchboardext_sh_keylatticeext")
  ObjDelete("spr_staffonlyext_keylatticeext")
  if common_impl.ZzCompleteCheck("get_keylatticeext") then ObjSet( common_impl.hint["get_keylatticeext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_keylatticeext", private.get_keylatticeext_inv );
cmn.AddSubscriber( "get_keylatticeext", private.get_keylatticeext_beg, private.room_objname );
cmn.AddSubscriber( "get_keylatticeext", private.get_keylatticeext_end, private.room_objname );
cmn.AddSubscriber( "get_keylatticeext", private.get_keylatticeext_logic );
--------------------------------------------------------------------
function public.get_keylatticeext()
  cmn.SetEventDone( "get_keylatticeext" );
  cmn.CallEventHandler( "get_keylatticeext" );
  if common_impl.ZzCompleteCheck("get_keylatticeext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_phoneext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_bottleext1" ] = { type = "get", get_obj = "spr_phoneext_bottleext1", room = "rm_staffonlyext", zz = "zz_phoneext", zz_gate = "gzz_staffonlyext_phoneext" };

private.get_bottleext1_logic = function()
  
end;
private.get_bottleext1_inv = function()
  interface.InventoryItemAdd("inv_bottleext1","spr_phoneext_bottleext1");
end;
private.get_bottleext1_beg = function()
  ObjDelete("gfx_phoneext_bottleext1")
end;
private.get_bottleext1_end = function()
  ObjDelete("spr_phoneext_sh_bottleext1")
  ObjDelete("spr_staffonlyext_bottleext1")
  if common_impl.ZzCompleteCheck("get_bottleext1") then ObjSet( common_impl.hint["get_bottleext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bottleext1", private.get_bottleext1_inv );
cmn.AddSubscriber( "get_bottleext1", private.get_bottleext1_beg, private.room_objname );
cmn.AddSubscriber( "get_bottleext1", private.get_bottleext1_end, private.room_objname );
cmn.AddSubscriber( "get_bottleext1", private.get_bottleext1_logic );
--------------------------------------------------------------------
function public.get_bottleext1()
  cmn.SetEventDone( "get_bottleext1" );
  cmn.CallEventHandler( "get_bottleext1" );
  if common_impl.ZzCompleteCheck("get_bottleext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_plugwireext" ] = { type = "use", inv_obj = "inv_plugwireext", use_place = "gfx_phoneext_plugwireext_zone", room = "rm_staffonlyext", zz = "zz_phoneext", zz_gate = "gzz_staffonlyext_phoneext" };

private.use_plugwireext_logic = function()
  ObjSet( "gfx_phoneext_clk_plugwireext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_plugwireext_inv = function()
  common_impl.ProcessMultiUseAll("plugwireext", "plugwireext")
end;
private.use_plugwireext_beg = function()
  ObjDelete( "gfx_phoneext_plugwireext_zone" );
end;
private.use_plugwireext_end = function()
  ObjSet("anm_phoneext_anm",{animfunc="cleek",frame=0})
  ObjSet( "spr_staffonlyext_tr_plug_sockets", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_plugwireext") then ObjSet( common_impl.hint["use_plugwireext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_plugwireext", private.use_plugwireext_inv );
cmn.AddSubscriber( "use_plugwireext", private.use_plugwireext_beg, private.room_objname );
cmn.AddSubscriber( "use_plugwireext", private.use_plugwireext_end, private.room_objname );
cmn.AddSubscriber( "use_plugwireext", private.use_plugwireext_logic );
cmn.AddSubscriber( "use_plugwireext_inv", private.use_plugwireext_inv, private.room_objname );
cmn.AddSubscriber( "use_plugwireext_beg", private.use_plugwireext_beg, private.room_objname );
cmn.AddSubscriber( "use_plugwireext_end", private.use_plugwireext_end, private.room_objname );
cmn.AddSubscriber( "use_plugwireext_end", private.use_plugwireext_logic );
--------------------------------------------------------------------------------------------
function public.use_plugwireext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_plugwireext" );
    cmn.CallEventHandler( "use_plugwireext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_plugwireext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_plugwireext_inv" );
  cmn.CallEventHandler( "use_plugwireext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_phoneext_anm", "use_plug_sockets", func_end );
  SoundSfx( "aud_use_plugwireext_staffonlyext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_plugwireext" ] = { type = "click", use_place = "gfx_phoneext_clk_plugwireext_zone", room = "rm_staffonlyext", zz = "zz_phoneext", zz_gate = "gzz_staffonlyext_phoneext" };

private.clk_plugwireext_logic = function()
  ObjSet( "gfx_phoneext_clk_phoneext911_zone", {active = 1, input = 1, visible = 1} );
end;
private.clk_plugwireext_beg = function()
  ObjDelete( "gfx_phoneext_clk_plugwireext_zone" );
end;
private.clk_plugwireext_end = function()
  ObjSet( "anm_phoneext_anm", {animfunc="end_cleek",frame=0} );
  if common_impl.ZzCompleteCheck("clk_plugwireext") then ObjSet( common_impl.hint["clk_plugwireext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_plugwireext", private.clk_plugwireext_beg, private.room_objname );
cmn.AddSubscriber( "clk_plugwireext", private.clk_plugwireext_end, private.room_objname );
cmn.AddSubscriber( "clk_plugwireext", private.clk_plugwireext_logic );
cmn.AddSubscriber( "clk_plugwireext_beg", private.clk_plugwireext_beg, private.room_objname );
cmn.AddSubscriber( "clk_plugwireext_end", private.clk_plugwireext_end, private.room_objname );
cmn.AddSubscriber( "clk_plugwireext_end", private.clk_plugwireext_logic );
--------------------------------------------------------------------------------------------
function public.clk_plugwireext()

  local func_end = function()
    cmn.SetEventDone( "clk_plugwireext" );
    cmn.CallEventHandler( "clk_plugwireext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_plugwireext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_plugwireext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_phoneext_anm", "cleek", func_end );
  SoundSfx( "aud_touch_plugwireext_staffonlyext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_phoneext911" ] = { type = "click", use_place = "gfx_phoneext_clk_phoneext911_zone", room = "rm_staffonlyext", zz = "zz_phoneext", zz_gate = "gzz_staffonlyext_phoneext" };

private.clk_phoneext911_logic = function()
  if ld.CheckRequirements( {"clk_phoneext911"} ) then 
    ObjSet( "gfx_staffonlyext_clk_outroext_zone", {active = 1, input = 1, visible = 1} );
  end
end;
private.clk_phoneext911_beg = function()

end;
private.clk_phoneext911_end = function()
  if ld.CheckRequirements( {"clk_phoneext911"} ) then 
    ObjDelete( "gfx_phoneext_clk_phoneext911_zone" );
  end
  if common_impl.ZzCompleteCheck("clk_phoneext911") then ObjSet( common_impl.hint["clk_phoneext911"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_phoneext911", private.clk_phoneext911_beg, private.room_objname );
cmn.AddSubscriber( "clk_phoneext911", private.clk_phoneext911_end, private.room_objname );
cmn.AddSubscriber( "clk_phoneext911", private.clk_phoneext911_logic );
cmn.AddSubscriber( "clk_phoneext911_beg", private.clk_phoneext911_beg, private.room_objname );
cmn.AddSubscriber( "clk_phoneext911_end", private.clk_phoneext911_end, private.room_objname );
cmn.AddSubscriber( "clk_phoneext911_end", private.clk_phoneext911_logic );
--------------------------------------------------------------------------------------------
function public.clk_phoneext911()

  local func_end = function()
    
    ng_global.progress[ "ext" ][ "clk_phoneext911" ].state = ng_global.progress[ "ext" ][ "clk_phoneext911" ].state + 1 
 ld.LogTrace( ng_global.progress[ "ext" ][ "clk_phoneext911" ].state );   
    if ng_global.progress[ "ext" ][ "clk_phoneext911" ].state ==4 then 
      cmn.SetEventDone( "clk_phoneext911" );
    end
    cmn.CallEventHandler( "clk_phoneext911_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_phoneext911") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_phoneext911_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );

  if not ng_global.progress[ "ext" ][ "clk_phoneext911" ].state then
    ng_global.progress[ "ext" ][ "clk_phoneext911" ].state = 1
    cmn.SetEventStart("clk_phoneext911")
  end
  local param = ng_global.progress[ "ext" ][ "clk_phoneext911" ].state
  
  if ng_global.progress[ "ext" ][ "clk_phoneext911" ].state == 1  then 
    SoundSfx( "aud_touch_9_staffonlyext" );
  else 
    SoundSfx( "aud_touch_1_staffonlyext" );
  end;  
  
  ld.AnimPlay( "anm_phoneext_anm_phone", param, func_end );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_staffonlyext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_staffonlyext_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_phoneext" );
  function zz_phoneext.Open()
  end;
  function zz_phoneext.PreOpen()
  end;
  function zz_phoneext.PreClose()
    if not cmn.IsEventDone("clk_outroext") and cmn.IsEventDone("clk_phoneext911") then 
      public.clk_outroext()
    end
  end;
  function zz_phoneext.Close()
  end;

  subroom.Define( "zz_switchboardext" );
  function zz_switchboardext.Open()
  end;
  function zz_switchboardext.PreOpen()
  end;
  function zz_switchboardext.PreClose()
  end;
  function zz_switchboardext.Close()
  end;
  
end;
--*********************************************************************************************************************