-- name=ho_bombthreeextscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "bombthreeextscr" );
  game.relations[ "ho_bombthreeextscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_bombthreeextscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_bombthreeextscr", zz_gate = "gho_pubext_bombthreeextscr" };
 
  local win_bombthreeextscr_func = function ()

    if ( cmn.IsEventDone( "win_bombthreeextscr" ) ) then
      ObjDetach("spr_bombthreeextscr_win")
    end;

  end;
  cmn.AddSubscriber( "win_bombthreeextscr", win_bombthreeextscr_func );
  
  local start_bombthreeextscr_func = function ()
 if not cmn.IsEventDone("win_bombthreeextscr") then
      common_impl.ProcessHoStart( "bombthreeextscr" );

      local ho_found = ng_global.progress[ "scr" ][ "win_bombthreeextscr" ].found;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false } );

      end;

  end
  end;
  cmn.AddSubscriber( "win_bombthreeextscr", start_bombthreeextscr_func, "ho_bombthreeextscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_pubext_env" )
  SoundEnv("aud_ho_bombthreeext_bomb",1)

  if ( not cmn.IsEventDone( "opn_bombthreeextscr" ) ) then

    cmn.InitHo( "bombthreeextscr" );

    cmn.SetEventDone( "opn_bombthreeextscr" );
 
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_bombthreeextscr_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_bombthreeextscr_bbb"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_bombthreeextscr_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_bombthreeextscr_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_bombthreeextscr_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_bombthreeextscr_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_bombthreeextscr_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_bombthreeextscr_hhh"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_bombthreeextscr_iii"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_bombthreeextscr_jjj"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_bombthreeextscr_kkk"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_bombthreeextscr_lll"}); 

  
  SoundHoTheme( true )
  interface.ItemPanelShow( ho_items );
  if ng_global.progress[ "scr" ][ "win_bombthreeextscr" ].state_bbb then
    ObjSet("anm_bombthreeextscr_animbomb",{frame=ng_global.progress[ "scr" ][ "win_bombthreeextscr" ].state_bbb,playing=0})
    ObjSet("anm_bombthreeextscr_animbomb_sig",{playing=0})
  end
end;  
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.ItemPanelHide();

   if cmn.IsEventDone( "win_bombthreeextscr" ) then
      ng_global.progress["scr"]["win_bombthreeextscr"]={}
      ng_global.progress["scr"]["win_bombthreeextscr"].done = 0
      ng_global.progress["scr"]["opn_bombthreeextscr"].done = 0
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   end
end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.DialogHo_Show()
  ObjDelete("gho_pubext_bombthreeextscr") 

   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_bombthreeextscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_bombthreeextscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.Get_bbb()
  AnimPause("anm_bombthreeextscr_animbomb",1)
  AnimPause("anm_bombthreeextscr_animbomb_sig",1)
  local time = ObjGet("anm_bombthreeextscr_animbomb").frame
  ng_global.progress[ "scr" ][ "win_bombthreeextscr" ].state_bbb = time
end
