-- name=ho_bookhoscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "bookhoscr" );
  game.relations[ "ho_bookhoscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_bookhoscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_bookhoscr", zz_gate = "gho_mansion_bookhoscr" };
 
  local win_bookhoscr_func = function ()

    if ( cmn.IsEventDone( "win_bookhoscr" ) ) then
      ObjDetach("spr_bookhoscr_win")
    end;

  end;
  cmn.AddSubscriber( "win_bookhoscr", win_bookhoscr_func );
  
  local start_bookhoscr_func = function ()
  if not cmn.IsEventDone("win_bookhoscr") then
  
  end
  end;
  cmn.AddSubscriber( "win_bookhoscr", start_bookhoscr_func, "ho_bookhoscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( 0 )
  interface.WidgetSetVisible( "InterfaceWidget_Inventory", false,true );
  interface.WidgetSetInput("InterfaceWidget_Inventory", 0 )

    local ho_tasks = {};

  ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks = {
                                                            "fff",
                                                            --"aaa",
                                                            "lll",
                                                            "hhh",                              
                              
                                                            "bbb",
                                                            "ddd",
                                                            "ccc",
                                                            "eee",

                                                            "ggg",
                                                            "kkk",
                                                            "iii",                              
                                                            "jjj",
                              
                                                            "mmm",

                                                                  }


  if ng_global.progress[ "scr" ][ "win_bookhoscr" ].start ~= 1 then

    
    
    ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count = 1
    ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull = {}
    ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull["bbb"] = {0,0,0}


    ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_unmark = {}

    
    SoundVoice(0)
    ld.StartTimer( 1, function() SoundVoice( "aud_book_1_voc" ); ld.Lock(0); end )   
   -- PlayVoice( "assets/levels/common/audio/aud_boy_1_voc", 0, "", 0.0 )
  else
   -- PlayVoice( "assets/levels/common/audio/aud_boy_"..ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count.."_voc", 0, "", 0.0 )
  end;


  SoundHoTheme( true )
  ho_bookhoscr.check_task()
  private.load_task()
end;
--*********************************************************************************************************************
function public.Open()

  if ( not cmn.IsEventDone( "opn_bookhoscr" ) ) then

    cmn.InitHo( "bookhoscr" );

    cmn.SetEventDone( "opn_bookhoscr" );

  end;
  
  --interface.TaskPanelShow( ho_items );
  interface_impl.StartHoAchievements( "bookhoscr" );
end
--*********************************************************************************************************************
function public.PreClose()
  
  SoundVoice( 0 )
 -- int_simon.SimonVocStop()
  SoundHoTheme( false )
  --interface.TaskPanelHide();
   if cmn.IsEventDone( "win_bookhoscr" ) then
      ng_global.progress["scr"]["win_bookhoscr"]={}
      ng_global.progress["scr"]["win_bookhoscr"].done = 0
      ng_global.progress["scr"]["opn_bookhoscr"].done = 0
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   end

end;
---------------------------------------------------------------------------------------  
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.DialogHo_Show()
  ObjAnimate( "spr_bookhoscr_panel", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )



end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  

end;
----------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

--trg_bookhoscr_init_misc
----------------------------------------------------------------------------

function private.load_task()

  local task_count = ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count
  if not task_count then
    task_count = 1
  end
  --
  -- DbgTrace("task_count"..task_count)
  local obj_task = ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks[task_count]

  if     task_count >= 1 and task_count < 4 then
    ObjAttach("spr_bookhoscr_back_1","ho_bookhoscr")
  elseif task_count >= 4 and task_count < 8 then
    ObjDelete("spr_bookhoscr_back_1")
    ObjDelete("vid_bookhoscr_page_turn_1")
    ObjAttach("spr_bookhoscr_back_2","ho_bookhoscr")
  elseif task_count >= 8 and task_count < 12 then
    ObjDelete("spr_bookhoscr_back_1")
    ObjDelete("spr_bookhoscr_back_2")
    ObjDelete("vid_bookhoscr_page_turn_1")
    ObjDelete("vid_bookhoscr_page_turn_2")
    ObjAttach("spr_bookhoscr_back_3","ho_bookhoscr")
  elseif task_count >=12 then
    ObjDelete("spr_bookhoscr_back_1")
    ObjDelete("spr_bookhoscr_back_2")
    ObjDelete("spr_bookhoscr_back_3")
    ObjDelete("vid_bookhoscr_page_turn_1")
    ObjDelete("vid_bookhoscr_page_turn_2")
    ObjDelete("vid_bookhoscr_page_turn_3")
  end
        ObjSet( "spr_bookhoscr_zakladka", {visible = 1} );
  if obj_task then
    if ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[obj_task] then
        local arr_summ = 0
        for i=1,#ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[obj_task] do
          if ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[obj_task][i] ~= 1 then
            ObjSet( "spr_bookhoscr_"..obj_task.."_mull_"..i, {input = 1} );
            if ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_unmark[obj_task] then
              if ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_unmark[obj_task]["mull_"..i] and ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_unmark[obj_task]["mull_"..i] == 0 then
                ObjSet( "spr_bookhoscr_"..obj_task.."_mull_"..i, {input = 0} );
                --DbgTrace(obj_task.."  "..i.."   "..ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_unmark[obj_task]["mull_"..i])
              end
            end
            arr_summ = arr_summ + 1
          end
        end
        local previous_text = ObjGet("txt_bookhoscr_panel").text
        local current_text = "tsk_bookho_"..obj_task
        if current_text == previous_text then
          ObjSet( "txt_bookhoscr_panel", {text = current_text ,param0 = arr_summ} );
        else 
          local func_end=function()
          ObjSet( "txt_bookhoscr_panel", {text = current_text ,param0 = arr_summ} );
          ObjAnimate( "txt_bookhoscr_panel", 8, 0, 0, "", {0,0,1, 0.0,0,1} );
          end 
          ObjAnimate( "txt_bookhoscr_panel", 8, 0, 0, func_end, {0,0,1, 0.0,0,1} );
        end
    else 
        

        local previous_text = ObjGet("txt_bookhoscr_panel").text
        local current_text = "tsk_bookho_"..obj_task

        if current_text == previous_text then
          ObjSet( "txt_bookhoscr_panel", {text = current_text } );
        else 
          local func_end=function()
            ObjSet( "txt_bookhoscr_panel", {text = current_text} );
            ObjAnimate( "txt_bookhoscr_panel", 8, 0, 0, "", {0,0,1, 0.0,0,1} );
          end 
          ObjAnimate( "txt_bookhoscr_panel", 8, 0, 0, func_end, {0,0,1, 0.0,0,1} );
        end


        ObjSet( "spr_bookhoscr_"..obj_task, {input = 1} );
    end

  end  

--  private.voice = private.voice or {}
--  if not private.voice[ "aud_kitten_simon_story_"..task_count.."_voc" ] then
--    ObjAnimate( "anm_bookhoscr_star_moon", 7,0,0, function() 
--      SoundVoice( "aud_kitten_simon_story_"..task_count.."_voc" )
--      int_simon.SimonVoc( "vid_bookhoscr_vid_kitten_simon_story_"..task_count.."_voc" )
--      private.voice[ "aud_kitten_simon_story_"..task_count.."_voc" ] = true
--    end, { 0,0,0, 0,0,0 } )
--
--  end;
  
end
--
----------------------------------------------------------------------------
----------------------------------------------------------------------------
function public.check_task()

  local count = ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count or 0

    for i = 1,count do
       
      local task_name = ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks[i]

      if ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[task_name] then
        for a=1,#ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[task_name] do
          if ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[task_name][a] == 1 then
            ObjDelete("spr_bookhoscr_"..task_name.."_mull_"..a)
          end
        end
      end

      task_name = ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks[i-1]
      if task_name then
        ObjDelete("spr_bookhoscr_"..task_name)
      end

    end
      

end

----------------------------------------------------------------------------
----------------------------------------------------------------------------


function public.clk_task(task_name,mull)


  function private.clk_task_end()

    ho_bookhoscr.check_task();

    for i = 1, 12 do
      --SoundVoice(0);
      --SndStop( "assets/levels/common/audio/aud_boy_"..i.."_voc", 1 )
    end;


    if mull then

      ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[task_name][mull] = 1 
      local arr_sum  = 0
      for i=1,#ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[task_name] do
          arr_sum = arr_sum + ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[task_name][i]
      end
      if arr_sum == #ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[task_name] then
        ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count = ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count + 1
        --SoundVoice("aud_book_"..ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count.."_voc")
       -- PlayVoice( "assets/levels/common/audio/aud_boy_"..ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count.."_voc", 0, "", 0.0 )
      end

    else 
       ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count = ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count + 1
      --PlayVoice( "assets/levels/common/audio/aud_boy_"..ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count.."_voc", 0, "", 0.0 )
      -- SoundVoice("aud_book_"..ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count.."_voc")
    end

    ld.Lock(0)

    if ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count > #ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks then
      ho_bookhoscr.HoComplete()
    else 
      local task_count = ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count
      local check = true
      if ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks[task_count] ] then 
        if ld.TableSum(ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks[task_count] ]) ~=0 then
          check  = false 
        end
      end
      if     task_count == 4 and check then
        ld.Lock(1)
        ObjSet( "spr_bookhoscr_zakladka", {visible = 0} );

        ObjSet( "txt_bookhoscr_panel", {text = ""} );
        SoundSfx( "aud_turn_page_"..math.random(1,3),_,true )
        
        ObjAttach("spr_bookhoscr_back_2","ho_bookhoscr")
        --  ObjAnimate( "spr_bookhoscr_back_1", 8, 0, 0, function() ld.Lock(0);private.load_task();end, {0,0,1, 0.5,0,0} );
        ObjAnimate( "spr_bookhoscr_back_1", 8, 0, 0, function() private.load_task();end, {0,0,1, 0.5,0,0} );  
        SoundVoice(0);  
        ld.StartTimer( 1, function() SoundVoice( "aud_book_2_voc" ); ld.Lock(0); end )   
        --ObjAttach("vid_bookhoscr_page_turn_1","ho_bookhoscr")        
        --VidPlay("vid_bookhoscr_page_turn_1",function() ld.Lock(0);private.load_task();end)
        elseif task_count == 8 and check then
        ld.Lock(1)
        ObjSet( "spr_bookhoscr_zakladka", {visible = 0} );
        ObjSet( "txt_bookhoscr_panel", {text = ""} );
        SoundSfx( "aud_turn_page_"..math.random(1,3),_,true )
        ObjAttach("spr_bookhoscr_back_3","ho_bookhoscr")
        --ObjAnimate( "spr_bookhoscr_back_2", 8, 0, 0, function() ld.Lock(0);private.load_task();end, {0,0,1, 0.5,0,0} );     
        ObjAnimate( "spr_bookhoscr_back_2", 8, 0, 0, function() private.load_task();end, {0,0,1, 0.5,0,0} );  
        SoundVoice(0);    
        ld.StartTimer( 1, function() SoundVoice( "aud_book_3_voc" ); ld.Lock(0); end )      
        --ObjAttach("vid_bookhoscr_page_turn_2","ho_bookhoscr")          
        --VidPlay("vid_bookhoscr_page_turn_2",function() ld.Lock(0);private.load_task();end)
        elseif task_count == 12 and check then
        SoundVoice(0);   
        ld.Lock(1)
        ObjSet( "spr_bookhoscr_zakladka", {visible = 0} );
        --ObjDelete("spr_bookhoscr_back_3")
        ObjSet( "txt_bookhoscr_panel", {text = ""} );
        SoundSfx( "aud_turn_page_"..math.random(1,3),_,true )
        --ObjAttach("spr_bookhoscr_back_4","ho_bookhoscr")
        ObjAnimate( "spr_bookhoscr_back_3", 8, 0, 0, function() ld.Lock(0);private.load_task();end, {0,0,1, 0.5,0,0} );          
        --ObjAttach("vid_bookhoscr_page_turn_3","ho_bookhoscr")        
        --VidPlay("vid_bookhoscr_page_turn_3",function() ld.Lock(0);private.load_task();end)
      else 
        private.load_task()
      end
      ng_global.progress[ "scr" ][ "win_bookhoscr" ].start = 1
    end
  end



  ld.Lock(1)

  local mull_part = ""
  if mull then
    mull_part = "_mull_"..mull
  end

  local func_end = function()
     private.clk_task_end()
  end
  local object_name = "spr_bookhoscr_"..task_name..mull_part
  local collect_pos = GetObjPosByObj( object_name, InterfaceWidget_Top_Name );
  local collect_drawoff_x = ObjGet( object_name ).drawoff_x;
  local collect_drawoff_y = ObjGet( object_name ).drawoff_y;
  
  local collect_name  = "pfx_bookhoscr_collect_"..object_name;

  PlaySfx( "assets/levels/common/audio/aud_ho_clk", 0, "", 0.0 )

  ObjAttach( object_name, InterfaceWidget_Top_Name );
  ObjSet( object_name ,{ pos_x = collect_pos[1], pos_y = collect_pos[2],input=0 });
  
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,
  {
    res = "assets/interface/resources/effects_ho",
    pos_x = collect_drawoff_x, pos_y = collect_drawoff_y,
    active = 1, visible = 1, input = 0, pos_z = 10
  } );

  ObjAttach( collect_name, InterfaceWidget_Top_Name );
  ObjSet(collect_name, {blendmode = 2,pos_z = 50});
  
  PartSysSetMaskObj( collect_name, object_name );  
  ObjAnimate( object_name, "alp",0,0, func_end,
  { 
      0.0, 0, 1,
      0.3, 0, 1,
      0.6, 0, 0
  } );


end





function public.clk_hint()
    local ho_name = "bookhoscr"
    local ho_progress = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ];
    local hints_table = { hint = {} };
    local task_count = ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_count
    local task_name =  ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks[task_count] 
    local hint_obj_name
  --  ld.LogTrace( ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks[task_count] );
        if ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[task_name] then
          for i = 1,#ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[task_name] do
            if ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_mull[task_name][i] == 0 then
              hint_obj_name = "spr_bookhoscr_"..ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks[task_count].."_mull_"..i
              break
            end
          end
        else
       --   DbgTrace(task_name.."__"..ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_shark)

            hint_obj_name = "spr_bookhoscr_"..ng_global.progress[ "scr" ][ "win_bookhoscr" ].ho_tasks[task_count]
        end


--        if     hint_obj_name == "spr_bookhoscr_aaa_mull_1" and ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_unmark["aaa"].mull_1==0 then
--          hint_obj_name = "obj_bookhoscr_aaa1_open_zone"
--        elseif hint_obj_name == "spr_bookhoscr_aaa_mull_2" and ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_unmark["aaa"].mull_2==0 then
--          hint_obj_name = "obj_bookhoscr_aaa2_open_zone"
--        elseif hint_obj_name == "spr_bookhoscr_fff_mull_1" and ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_unmark["fff"].mull_1==0 then
--          hint_obj_name = "obj_bookhoscr_fff_open_zone"
--        elseif hint_obj_name == "spr_bookhoscr_fff_mull_2" and ng_global.progress[ "scr" ][ "win_bookhoscr" ].state_unmark["fff"].mull_2==0 then
--          hint_obj_name = "obj_bookhoscr_fff_open_zone"
--        end
--


        table.insert( hints_table.hint,  { ["pos_x"]=ObjGet(hint_obj_name).pos_x, ["pos_y"]=ObjGet(hint_obj_name).pos_y, ["obj_name"]=hint_obj_name } )   

    --int.ItemPanelEffect_ShowHoHint(hint_param)  
    MsgSend( Command_Effect_ShowHoHint, hints_table );
end