-- name=ho_groundhoscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "groundhoscr" );
  game.relations[ "ho_groundhoscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_groundhoscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_groundhoscr", zz_gate = "gho_neartower_groundhoscr" };
 
  local win_groundhoscr_func = function ()

    if ( cmn.IsEventDone( "win_groundhoscr" ) ) then
      ObjDetach("spr_groundhoscr_win")
    end;

  end;
  cmn.AddSubscriber( "win_groundhoscr", win_groundhoscr_func );
  
  local start_groundhoscr_func = function ()
  if not cmn.IsEventDone("win_groundhoscr") then
    interface.ProcessHoPairStart("groundhoscr")  -- загрузка по фаунду  
  end
  end;
  cmn.AddSubscriber( "win_groundhoscr", start_groundhoscr_func, "ho_groundhoscr" );  
        game.groundhoscr = {}
        game.groundhoscr.ho_tasks = {      {"aaa",  {"obj_groundhoscr_aaa_close_1","obj_groundhoscr_aaa_close_2"}}
                    , {"bbb",  {"obj_groundhoscr_bbb_close_1","obj_groundhoscr_bbb_close_2"}}
                    , {"ccc",  {"obj_groundhoscr_ccc_close_1","obj_groundhoscr_ccc_close_2"}}
                    , {"ddd",  {"obj_groundhoscr_ddd_close_1","obj_groundhoscr_ddd_close_2"}}
                    , {"eee",  {"obj_groundhoscr_eee_close_1","obj_groundhoscr_eee_close_2"}}
                    , {"fff",  {"obj_groundhoscr_fff_close_1","obj_groundhoscr_fff_close_2"}}
                    }
end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

 SoundEnv( "aud_neartower_env" );
 
 interface.PanelHoPairEffect_ResetState("groundhoscr")
  if ( not cmn.IsEventDone( "opn_groundhoscr" ) ) then
    
    cmn.InitHo( "groundhoscr" );

    cmn.SetEventDone( "opn_groundhoscr" );
    
  end;
interface.ProcessHoPairStart("groundhoscr")

--  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_groundhoscr_aaa" } });
--  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_groundhoscr_bbb" } } );
--  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_groundhoscr_ccc" } } );
--  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_groundhoscr_ddd" } } );
--  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_groundhoscr_eee" } } );
--  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_groundhoscr_fff" } } );
--  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_groundhoscr_ggg" } } );
--  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_groundhoscr_hhh" } } );
--  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_groundhoscr_iii" } } );
--  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_groundhoscr_jjj" } } );
--  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_groundhoscr_kkk" } } );
--  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_groundhoscr_lll" } } );
--  
--  SoundHoTheme( true );
--  interface.TaskPanelShow( ho_items );
--
--   for j = 1, #ng_global.progress["scr"]["win_groundhoscr"].found do
--
--    local name = tostring( ng_global.progress["scr"]["win_groundhoscr"].found[j]["object"] );
--   
--    ObjDelete( name );
--
--  end;

  local ho_tasks = {};
  interface.PanelHoPair_Show("groundhoscr",game.groundhoscr.ho_tasks)
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.PanelHoPair_Hide("groundhoscr")
   if cmn.IsEventDone( "win_groundhoscr" ) then
      ng_global.progress["scr"]["win_groundhoscr"]={}
      ng_global.progress["scr"]["win_groundhoscr"].done = 0
      ng_global.progress["scr"]["opn_groundhoscr"].done = 0
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   end
end;
--*********************************************************************************************************************
function public.HoComplete()
  ObjDelete("grm_groundhoscr_neartower")
  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_groundhoscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_groundhoscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
--for SFX
function public.groundhoscr_play_sfx(name)  --ho_groundhoscr.groundhoscr_play_sfx("")
  local name_array = {"ccc1","ccc2","fff1","bbb2","eee1","aaa1","fff2","bbb1","ddd1","aaa2","eee2","ddd2"}
  local sound_array = {"aud_ho_ground_visor","aud_ho_ground_card","aud_ho_ground_shell","aud_ho_ground_paper","aud_ho_ground_paper","aud_ho_ground_armor","aud_ho_ground_armor","aud_ho_ground_casket_heart","aud_ho_ground_gnome","aud_ho_ground_plate","aud_ho_ground_cup","aud_ho_ground_casket_wood"}; 

  for i=1,12,1 do 
     if name==name_array[i] then SoundSfx( sound_array[i] ); break;  end;
  end;  
end;  