-- name=mg_storystormscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_storystormscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
-- common_impl.hint[ "win_storystormscr" ] = {type = "win", use_place = "mg_storystormscr", room = "rm_jail", zz = "mg_storystormscr", zz_gate = "gmg_jail_storystormscr" };
--
-- local win_storystormscr_logic = function()
--   if ld.CheckRequirements( {"win_storystormscr"} ) then
--     ObjSet( "spr_storystormscr_cufflink", {input = 1, visible = 1} );
--     
--   end
-- end;
-- local win_storystormscr = function()
--   if ld.CheckRequirements( {"win_storystormscr"} ) then
--     ObjDelete("anm_storystormscr_strom")
--     ObjSet( "spr_storystormscr_sh_cufflink", {alp = 1} );
--   end
-- end;
-- cmn.AddSubscriber("win_storystormscr", win_storystormscr, private.room_objname )
-- cmn.AddSubscriber("win_storystormscr", win_storystormscr_logic )
  --------------------------------------------------------------------------------------------

----------------------------------------------------------------------
--common_impl.hint[ "get_cufflink" ] = { type = "get", get_obj = "spr_storystormscr_cufflink", room = "rm_jail", zz = "mg_storystormscr", zz_gate = "gmg_jail_storystormscr" };
--
--private.get_cufflink_logic = function()
--  
--end;
--private.get_cufflink_inv = function()
--  interface.InventoryItemAdd("inv_cufflink","spr_storystormscr_cufflink");
--end;
--private.get_cufflink_beg = function()
--  ObjDelete("gfx_storystormscr_cufflink")
--end;
--private.get_cufflink_end = function()
--  ObjDelete("spr_storystormscr_sh_cufflink")
--end;
--
--cmn.AddSubscriber( "get_cufflink", private.get_cufflink_inv );
--cmn.AddSubscriber( "get_cufflink", private.get_cufflink_beg, private.room_objname );
--cmn.AddSubscriber( "get_cufflink", private.get_cufflink_end, private.room_objname );
--cmn.AddSubscriber( "get_cufflink", private.get_cufflink_logic );
----------------------------------------------------------------------
--function public.get_cufflink()
--  cmn.SetEventDone( "get_cufflink" );
--  cmn.CallEventHandler( "get_cufflink" );
--  cmn.GotoRoom( "rm_jail" );
--end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_storystormscr"} ) then
    cmn.MiniGameShow( "storystormscr" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_jail_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_storystormscr"} ) then
    cmn.MiniGameHide( "storystormscr" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local lvl = ng_global.progress["scr"]["win_storystormscr"].state.lvl
  for i=1,#ng_global.progress["scr"]["win_storystormscr"].state.parts[lvl] do
    ng_global.progress["scr"]["win_storystormscr"].state.parts[lvl][i]=0
  end
   for j=1,#ng_global.progress["scr"]["win_storystormscr"].state.parts[lvl] do
      local obj =  "spr_storystormscr_part_"..lvl.."_"..j 
      ObjSet( obj, {input = 1} );
      ObjAnimate( obj, 3, 0, 0, "", {0,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y, 0.5,0,private.startpos_parts[lvl][j][1],private.startpos_parts[lvl][j][2]} );      
    end
    ld.Lock(1)
    ObjAnimate("obj_storystormscr_page_"..lvl,7,0,0,function()ld.Lock(0) end,{0,0,0,0.5,0,0})
end;
--*********************************************************************************************************************
private.skiped_press = false
function private.skip_anim()
  private.skiped_press = true
  local lvl = ng_global.progress["scr"]["win_storystormscr"].state.lvl
  for j=1,#ng_global.progress["scr"]["win_storystormscr"].state.parts[lvl] do
    ng_global.progress["scr"]["win_storystormscr"].state.parts[lvl][j]=1
    local obj =  "spr_storystormscr_part_"..lvl.."_"..j 
    local obj_zone = ObjGet("obj_storystormscr_part_"..lvl.."_"..j.."_zone")
    
    ObjSet( obj, {input = 0} );
    ObjAnimate( obj, 3, 0, 0, "", {0,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y, 0.5,0,obj_zone.pos_x,obj_zone.pos_y} );      
  end
  ld.Lock(1)
  ObjAnimate("obj_storystormscr_page_"..lvl,7,0,0,function()ld.Lock(0);private.check_lvl(lvl,private.skip_anim)end,{0,0,0,0.5,0,0})
end

function public.Skip()
  --private.Win();
  local lvl = ng_global.progress["scr"]["win_storystormscr"].state.lvl
  cmn.MiniGameHide();
  interface.WidgetSetVisible(InterfaceWidget_Inventory, 0, true );
  cmn.SetEventDone( "win_storystormscr" );
  private.skip_anim()

end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_storystormscr" );
  --cmn.CallEventHandler( "win_storystormscr" );
  --cmn.GotoRoom( "rm_jail" );
  interface.WidgetSetVisible(InterfaceWidget_Inventory, 1, true );
 -- interface_impl.ShowMgAchievements();
  rm_secretroomscr.GotoRoom( 'rm_secretroomscr' ) 
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(0);
  cmn.MiniGameHide(true);
  --SoundSfx( "aud_mg_storystorm_move" )
  --ld.AnimPlay("anm_storystormscr_strom","use_cufflin",private.WinEnd)
  private.WinEnd();
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
    if not ng_global.progress["scr"]["win_storystormscr"].state then
      ng_global.progress["scr"]["win_storystormscr"].state = {}
      ng_global.progress["scr"]["win_storystormscr"].state.lvl = 1
      ng_global.progress["scr"]["win_storystormscr"].state.parts = {
        {0,0,0, 0,0},
        {0,0,0, 0,0,0, 0,0,0},
        {0,0,0, 0,0,0, 0}
                                                               }
    end
    gm.loaded  = true;
    
  else
  
  end;
  private.load_state()
end

function gm.save()

end;

function private.load_state()
  if not ld.CheckRequirements( {"win_storystormscr"} ) then  
    private.load_lvl()
  end
end


private.startpos_parts = {
{{630,346},{103,391},{338,494}, {103,505},{783,552}                                          },
{{807,288},{387,555},{090,402}, {864,547},{541,545},{651,296}, {222,349},{719,249},{758,553}, },
{{881,366},{412,524},{630,364}, {848,504},{076,451},{435,448}, {084,324},                     }
}



function public.drop_part( obj )
  SoundSfx( "aud_mg_storystorm_set" );
  local lvl = tonumber(ld.StringDivide(obj)[4])
  local part = tonumber(ld.StringDivide(obj)[5])
  local obj_zone ="obj_storystormscr_part_"..lvl.."_"..part.."_zone"
  --ld.LogTrace( obj,obj_zone );
  if common_impl.ApplyCheck(obj,obj_zone) then
    ld.Lock(1)
    ng_global.progress["scr"]["win_storystormscr"].state.parts[lvl][part] = 1 
    ObjSet( obj, {pos_z=0,input=0})--,inputrect_init = 0})
    ObjAnimate( obj, 3, 0, 0, function() ld.Lock(0); private.check_lvl(lvl) end,
    {0,0,GetObjPosByObj(obj,"mg_storystormscr")[1],GetObjPosByObj(obj,"mg_storystormscr")[2], 0.2,0,ObjGet(obj_zone).pos_x,ObjGet(obj_zone).pos_y}
    );
  else 
    ld.Lock(1)
    ObjSet( obj, {pos_z=1} );
    ObjAnimate( obj, 3, 0, 0, function() ld.Lock(0); end,
    {0,0,GetObjPosByObj(obj,"mg_storystormscr")[1],GetObjPosByObj(obj,"mg_storystormscr")[2], 0.2,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y}
    );
  end
  
end

function private.check_lvl(lvl,func_end)
  --lvl=tonumber(lvl)
  if private.check_arr_lvl(lvl)  then
    private.story_start(func_end)
  end
end

function private.load_lvl(anim)
  for i=1,3 do
    ObjDetach("obj_storystormscr_page_"..i)
    ObjSet( "obj_storystormscr_page_"..i, {alp = 0} );
  end  

  local lvl = ng_global.progress["scr"]["win_storystormscr"].state.lvl
  local obj_lvl 
     
  if anim then  
    obj_lvl = "obj_storystormscr_page_"..lvl
    ObjAttach(obj_lvl,"mg_storystormscr")  
    ld.Lock(1)
    ld.AnimPlay("anm_storystormscr_strom","use_pal","")
    ObjAnimate(obj_lvl , 8, 0, 0, function() ld.Lock(0) end, {0,0,0, 2,0,1} );
    ObjSet(obj_lvl,{input=1})
    ld.StartTimer( 0.3, function() SoundSfx( "aud_mg_storystorm_show" ); end ) 
  else 
    if private.check_arr_lvl(lvl)  then lvl = lvl + 1 end
    ng_global.progress["scr"]["win_storystormscr"].state.lvl = lvl
    if lvl ~=4 then
      obj_lvl = "obj_storystormscr_page_"..lvl
      ObjAttach(obj_lvl,"mg_storystormscr")  
      ObjSet(obj_lvl,{input=1}) 
      ld.Lock(1)
      ld.AnimPlay("anm_storystormscr_strom","use_pal","")
      ld.StartTimer( 0.3, function() SoundSfx( "aud_mg_storystorm_show" ); end ) 
      ObjAnimate(obj_lvl , 8, 0, 0, function() ld.Lock(0) end, {0,0,0, 2,0,1} );      
      for j=1,3 do
        if ng_global.progress["scr"]["win_storystormscr"].state.parts[lvl][j] == 1 then
          local obj_zone = ObjGet("obj_storystormscr_part_"..lvl.."_"..j.."_zone")
          ObjSet("spr_storystormscr_part_"..lvl.."_"..j,{input=0,pos_x=obj_zone.pos_x,pos_y=obj_zone.pos_y})
        else 
         -- ObjSet("spr_storystormscr_part_"..lvl.."_"..j,{input=1})
        end
      end
    else 
      private.Win()
    end
  end
end
function private.check_arr_lvl(lvl) 
  local s = ng_global.progress["scr"]["win_storystormscr"].state
  local sum = 0
  for i=1,#s.parts[lvl] do
    sum=sum + s.parts[lvl][i]
  end
  if sum == #s.parts[lvl] then
    return true
  else 
    return false
  end
end

function private.story_start(f_end,lvl)
  local story = lvl or ng_global.progress["scr"]["win_storystormscr"].state.lvl
  local dial_end
  if story == 3 then
    dial_end = function()
      SoundVoice( 0 );
      if private.skiped_press then
        interface.WidgetSetVisible( InterfaceWidget_BtnHint, 1, true );
      end
      private.skiped_press=false
      private.WidgetSetVisible("show")
      interface.DialogStoryHide();
      ld.Lock(1)
      ObjAnimate( "obj_storystormscr_page_3", 8, 0, 0, function()private.Win()end, {0,0,1, 0.5,0,0} );
      
    end
  else 
    dial_end = function()
      SoundVoice( 0 );
      private.story_end(f_end)
    end
  end
  SoundVoice( 0 );
  ld.Lock(1); ld.StartTimer( 1, function() SoundVoice( "aud_story_"..story.."_voc" ); ld.Lock(0); end ) 
  private.WidgetSetVisible("hide")
  interface.DialogStoryShow( "", "str_storystorm_story_"..story,dial_end,dial_end, 0.5 )

end
function private.story_end(f_end)
  interface.DialogStoryHide()
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );
  private.WidgetSetVisible("show")
  local fun_end = function ()
    ld.Lock(0)
    ng_global.progress["scr"]["win_storystormscr"].state.lvl = ng_global.progress["scr"]["win_storystormscr"].state.lvl + 1
    if f_end then
      private.load_lvl(1)
      f_end()
    else 
      private.load_lvl(1)
    end
    
  end
  ld.Lock(1)
  local lvl = ng_global.progress["scr"]["win_storystormscr"].state.lvl 
  ObjAnimate( "obj_storystormscr_page_"..lvl, 8, 0, 0, fun_end, {0,0,1, 0.3,0,0} );
end
private.skiped_showed = false



function private.WidgetSetVisible(param)

  local widget_settings = 
  {
  --,
    InterfaceWidget_BtnGuide,
    InterfaceWidget_BtnMenu,
    InterfaceWidget_BtnMap,
  }  
  if private.skiped_press then
    table.insert(widget_settings,InterfaceWidget_BtnHint)
    --table.insert(widget_settings,InterfaceWidget_Inventory)
  else 
    table.insert(widget_settings,InterfaceWidget_BtnSkip)
    table.insert(widget_settings,InterfaceWidget_BtnReset)
    table.insert(widget_settings,InterfaceWidget_BtnInfo)    
  end  
  if not private.skiped_press then
    
    if param == "show" then 
      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], 1, true );
      end;
    elseif param == "hide" then 
      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], 0, false );
      end;    
    end
  else 
    if param == "hide" and not private.skiped_showed then
      private.skiped_showed = true
      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], 0, true );
        --ld.LogTrace( widget_settings[i] );
      end;
    end
  end
end


-----------------------------------------------------------------------------------------------------
------------------------- functions for sounds ------------------------------------------------------
function public.storystormscr_startdrag()  --mg_storystormscr.storystormscr_startdrag();
  SoundSfx( "aud_mg_storystorm_get" );
end;  
