-- name=rm_secretroomscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_secretroomscr";
  --------------------------------------------------------------------------------------------
end
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
  interface.WidgetSetInput(InterfaceWidget_BtnHint,false)
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundTheme( "aud_ho_mus",1 );
  SoundEnv( 0 )
  --SoundEnv( "aud_bonus_env" )
      local widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Panelscr,
        InterfaceWidget_ItemPanel,
      }

      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], false,false );
        interface.WidgetSetInput(widget_settings[i],false)
        
        
      end;
      
    --if not ng_global.progress[ "scr" ].common.gamewin and cmn.IsEventDone( "get_signstranik1scr" ) then
    --  --ng_global.progress[ "scr" ].common.time = int_panelscr.GetTime()  
    --  ng_global.progress[ "scr" ].common.gamewin = true 
    --  ng_global.progress[ "scr" ].common.gamestart = false      
    --  private.ShowAchiv()  
    --end
      
end;
--*********************************************************************************************************************
function public.Close()
      SoundTheme(0);
  
      local widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Panelscr,
        InterfaceWidget_ItemPanel,        
      }

      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], true,false );
        interface.WidgetSetInput(widget_settings[i],true)
      end;  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
private.tab = 
{
  "minigames",
  "hogames",


};
private.tab_current = "minigames"
private.minigames = {
  "mg_fencepuzzlescr",
  "mg_vitragemgscr",
  "mg_grillemgscr",
  "mg_gatemgscr",
  "mg_crossingscr",
  "mg_flowscr",
  "mg_storystormscr",
  "mg_carpetmgscr",
  "mg_clockmgscr",
  "mg_bomboneextscr",
  "mg_gatespondextscr",
  "mg_pubmgextscr",
  "mg_mechanismextscr",


}
private.mg_current = 1
private.hogames = {
  "ho_barnscr",
  "ho_commodehoscr",
  "ho_groundhoscr",
  "ho_pantryscr",  
  "ho_bookhoscr",
  "ho_chatterhoscr",
  "ho_puddlescr",
  "ho_suitcasescr",
  "ho_crystalhoscr",
  "ho_rootshoextscr",
  "ho_innerporchhoextscr",
  "ho_bombthreeextscr",  
  "ho_sweetsextscr",
}
private.ho_current = 1
----------------------------------------------------------------------------------------------------
function public.UpdateScr( new_scr )
   SoundSfx( "aud_click_menu" );
  
  new_scr = tonumber( new_scr );
  --SoundSfx( 2 )
  
  public.ActivateScr( 0 );
  local name = "obj_secretroomscr_"..private.tab[ new_scr ]
  local tme = 0.5;
      ObjSet( 'rm_secretroomscr', {  input = 0 } );
      ObjSet( name, { visible = 1 } );
      ObjAttach( name, "rm_secretroomscr" );
      ObjAnimate( name, "alp", 0, 0, function()
       public.ActivateScr( 1,name);
       ObjSet( 'rm_secretroomscr', {  input = 1 } );
       public.ActivateScr( 0,"spr_secretroomscr_button_"..private.tab[ new_scr ]);  end, 
      {
         0.0, 0, 0,
         tme, 0, 1
      } );
      local name_current = "obj_secretroomscr_"..private.tab_current
       ObjAnimate( name_current, 8, 0, 0, function()
       
       public.ActivateScr( 0,name_current); 
       public.ActivateScr( 1,"spr_secretroomscr_button_"..private.tab_current); 
       ObjDetach(name_current);
       private.tab_current = private.tab[ new_scr ]
       end , {0,0,tme, 0.5,0,0} );    
      
end;
--
function public.CloseScr( new_scr )
  new_scr = tonumber( new_scr );
  --SoundSfx( 2 )
  name = "obj_secretroomscr_"..private.tab[ new_scr ];
      ObjSet( 'rm_secretroomscr', {  input = 0 } );
      ObjAnimate( name, "alp", 0, 0, function() ObjSet( name, { visible = 0, input = 0 } ); ObjAttach( '"..name.."', 'hub_secretroomscr' );ObjSet( 'rm_secretroomscr', {  input = 1 } );end, 
      { 
        0.0, 0, ObjGet( name ).alp, 
        0.5, 0, 0
      } );
end
--
----------------------------------------------------------------------------------------------------
function public.ActivateScr( vinput, name )
 
  ObjSet( "obj_secretroomscr_buttons", { input = vinput } );

  if name then

    ObjSet( name, { input = vinput });

  end;

end;


----------------------------------------------------------------------------------------------------
function public.ButtonDownExit()
  
   SoundSfx( "aud_click_menu" );
  SaveProfiles();
  SaveSettings();

  SetCursor( CURSOR_DEFAULT );
  
  ng_global.is_scr = true;

  common.LevelSwitch( "menu", "game" );

end;

----------------------------------------------------------------------------------------------------
function public.ButtonMouseEnter( but_name )
  SoundSfx( "aud_guidance" );
  SetCursor( CURSOR_HAND );
  local obj = "spr_secretroomscr_button_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, 8, 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--------------------------------------------------------------------
function public.ButtonMouseLeave( but_name )

  SetCursor( CURSOR_DEFAULT );
  local obj = "spr_secretroomscr_button_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, 8, 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;

----------------------------------------------------------------------------------------------------

function public.MgNext( inc )
  SoundSfx( "aud_click_menu" );
  inc = tonumber( inc );
  local max_count = #private.minigames  ;
  local new_num;

  if private.mg_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.mg_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.mg_current + inc;
  end;

  local name     = "spr_secretroomscr_minigames_";
  local name_arr = "obj_secretroomscr_minigames_arrows";
  local tme      = 0.3;

  public.ActivateScr( 0, name_arr );
  ObjSet( 'rm_secretroomscr', {  input = 0 } );
  ObjAnimate( name..new_num, "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    tme, 0, 1
  } );

  ObjAnimate( name..private.mg_current, "alp", 0, 0, function() public.ActivateScr(1,name_arr);ObjSet( 'rm_secretroomscr', {  input = 1 } );end, 
  {
    0.0, 0, 1,
    tme, 0, 0
  } );
    
  ObjSet( "txt_secretroomscr_minigames_counter", { text = new_num.."/"..max_count } );
  private.mg_current = new_num;

  --SoundSfx( 2 )

end

function public.PlayMg()
   SoundSfx( "aud_click_menu" );
  --ld.LogTrace( private.minigames[private.mg_current] );
  local mg = common.GetObjectName( private.minigames[private.mg_current] )
  --if ld.CheckRequirements( {"win_"..mg} ) then
  --  --ng_global.progress["scr"]["win_"..mg].done = 0
  --  ng_global.progress["scr"]["win_"..mg].start = 0
  --  ng_global.progress["scr"]["win_"..mg].state = nil
  --end
  --
  --
  if ld.CheckRequirements( {"win_"..mg} ) then
      ld.LogTrace( "LevelSwitch" );
     ng_global.progress["scr"]["win_"..mg]={}
     ng_global.progress["scr"]["win_"..mg].done = 0
     ng_global.progress["scr"]["win_"..mg].start = 0
     ng_global.progress[ ng_global.currentprogress ].common.currentroom = nil
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter,"mg_"..mg )
  else 
     public.GotoRoom("mg_"..mg)

  end
end
----------------------------------------------------------------------------------------------------
function public.ResetMgGame()
  ld.LogTrace( private.minigames[private.mg_current] );
end

----------------------------------------------------------------------------------------------------

function public.HoNext( inc )
  SoundSfx( "aud_click_menu" );
  inc = tonumber( inc );
  local max_count = #private.hogames  ;
  local new_num;

  if private.ho_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.ho_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.ho_current + inc;
  end;

  local name     = "spr_secretroomscr_hogames_";
  local name_arr = "obj_secretroomscr_hogames_arrows";
  local tme      = 0.3;

  public.ActivateScr( 0, name_arr );
  ObjSet( 'rm_secretroomscr', {  input = 0 } );
  ObjAnimate( name..new_num, "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    tme, 0, 1
  } );

  ObjAnimate( name..private.ho_current, "alp", 0, 0, function() public.ActivateScr(1,name_arr);ObjSet( 'rm_secretroomscr', {  input = 1 } );end, 
  {
    0.0, 0, 1,
    tme, 0, 0
  } );
    
  ObjSet( "txt_secretroomscr_hogames_counter", { text = new_num.."/"..max_count } );
  private.ho_current = new_num;

  --SoundSfx( 2 )

end
function public.PlayHo()
   SoundSfx( "aud_click_menu" );
   --ld.LogTrace( private.hogames[private.ho_current] );
   local ho = common.GetObjectName( private.hogames[private.ho_current] )--.."scr"
  --if ld.CheckRequirements( {"win_"..ho} ) then
  --  --ng_global.progress["scr"]["win_"..mg].done = 0
  --  ng_global.progress["scr"]["opn_"..ho].done = 0 
  --  ng_global.progress["scr"]["win_"..ho].start = 0
  --  ng_global.progress["scr"]["win_"..ho].state = nil
  --  ng_global.progress["scr"]["win_"..ho].found = nil
  --end
  --public.GotoRoom("ho_"..ho)
  --ng_global.progress[ ng_global.currentprogress ].common.currentroom = nil
  if ld.CheckRequirements( {"win_"..ho} ) then
     ng_global.progress["scr"]["win_"..ho]={}
     ng_global.progress["scr"]["win_"..ho].done = 0
     ng_global.progress["scr"]["opn_"..ho].done = 0
     ng_global.progress[ ng_global.currentprogress ].common.currentroom = nil
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter,"ho_"..ho )
   else 
     public.GotoRoom("ho_"..ho)
  end
end
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
function public.ResetHoGame()
  SoundSfx( "aud_click_menu" );
  ld.LogTrace( private.minigames[private.ho_current] );
end
----------------------------------------------------------------------------------------------------

--[[
function public.PlaySecretgame()
   SoundSfx( "aud_click_menu" );
      
  if ng_global.progress[ "scr" ].common.gamewin == true then
    --ng_global.progress[ "scr" ].common.gamestart == false 
    common.DialogWindowShow( "common", "finishscr", true );
  else 
    if not ng_global.progress[ "scr" ].common.gamestart then
      ng_global.progress[ "scr" ].common.gamestart = true
      ng_global.progress[ "scr" ].common.cur_quest = "simbol" 
      ng_global.progress[ "scr" ].common.failed_without_hint = false
      ng_global.progress[ "scr" ].common.failed_less_6min = false 
      ng_global.progress[ "scr" ].common.failed_less_12min = false       
      ng_global.progress[ "scr" ].common.time = 0
    end   
    
    --common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter,"rm_neartemplescr" )
    public.LoadCurQuest()
    public.GotoRoom("rm_neartemplescr")
  end
end


function public.ResetSecretgame()
   SoundSfx( "aud_click_menu" );
  common.DialogWindowShow( "common", "resetscr", true );
end

common.dialog.common.buttons[ "finishscr" ] = { left = { text = "yes", func = "finishscr" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "resetscr" ] = { left = { text = "yes", func = "finishscr" }, center = nil, right = { text = "no", func = "Close" } };

function common.dialog.common.finishscr ()

  common.dialog.common.Close()
  ng_global.progress[ "scr" ].common.gamestart = false
  ng_global.progress[ "scr" ].common.gamewin = false 
  ng_global.progress[ "scr" ].common.failed_without_hint = false
  ng_global.progress[ "scr" ].common.failed_less_6min = false 
  ng_global.progress[ "scr" ].common.failed_less_12min = false    
  ng_global.progress[ "scr" ].common.cur_quest = "simbol" 
  ng_global.progress[ "scr" ].common.time = 0 
  for i=1,#game.progress_names do
    if string.find( game.progress_names[i], "get_" ) then
      ng_global.progress["scr"][game.progress_names[i] ].done = 0
    end
    --ng_global.progress["scr"][game.progress_names[i] ].start = 1  
  end
  public.PlaySecretgame()

end;
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
private.quests = 
{
 ["simbol"]     = {4,"hurdygurdy"},
 ["hurdygurdy"] = {8,"hat"},
 ["hat"]        = {12,"star"},
 ["star"]       = {16,"chimera"},
 ["chimera"]    = {20,"signstranik"},
 ["signstranik"]= {1,"winscr"}
}
function public.GetPartQuest(quest,param)
  cmn.SetEventDone( "get_"..quest..param.."scr" );
  local count = 0 
  for i=1,private.quests[quest][1] do
    if cmn.IsEventDone( "get_"..quest..i.."scr" )  then
      count =count + 1
    end
  end  
  int_panelscr.SetCurQuest(quest,count.."/"..private.quests[quest][1])  
  SoundSfx( "aud_get_collectibles" ); 
  ld.Lock(1)
   local object_name = "anm_"..quest..param.."scr"
    ObjSet( object_name, {input=0} );
    --ObjAttach( object_name, InterfaceWidget_Top_Name );
    local collect_name  = "fx_item_name_collect_"..object_name;
    ObjCreate( collect_name, "partsys" );
    
    ObjSet( collect_name,
    {
      res = "assets/levels/common/particle_collect",
      pos_x = ObjGet(object_name).pos_x, pos_y = ObjGet(object_name).pos_y,
      active = 1, visible = 1, input = 0, pos_z = 10
    } );

    ObjAttach( collect_name, ObjGetRelations(object_name).parent );
    ObjSet(collect_name, {blendmode = 2,pos_z = 50});
    PartSysStart(collect_name)


    local func_end = function()
      -- ld.Lock(0)
      
      ObjAnimate( collect_name, 8, 0, 0, 
      function()
        ObjDelete(collect_name);
        ObjSet(object_name,{alp=1,visible=0});
        public.CheckQuest(quest);
        ld.Lock(0);
      end,
      {0,0,1, 0.3,0,0} );
      -- ObjDelete(object_name)
    end

    ObjAnimate( object_name, "alp",0,0, func_end,
    { 
        0.0, 0, 1,
        0.3, 0, 1,
        0.6, 0, 0
    } );
  
  
  

--
--  local obj = "anm_"..quest..param.."scr"
--  ObjSet( obj, {input = 0} );
--  ObjAnimate( obj, 8, 0, 0, function()ld.Lock(0); end, {0,0,1, 0.5,0,0} );
end
 
function public.CheckQuest(param)
  local count = 0 
  for i=1,private.quests[param][1] do
    if cmn.IsEventDone( "get_"..param..i.."scr" )  then
      count =count + 1
    end
  end
  if count == private.quests[param][1] then
    public.StartNewQuest(private.quests[param][2])
  else 
    
  end 
end
function public.StartNewQuest(param)
  if param ~= "winscr" then
    ng_global.progress[ "scr" ].common.cur_quest = param
    local count = 0
    for o=1,private.quests[param][1] do
      if not cmn.IsEventDone( "get_"..param..o.."scr" ) then
        ObjSet( "anm_"..param..o.."scr", {input = 1, visible=1,playing=1 } );
        count = count + 1
      end
    end  
    levelscr.tutorial_prgbar.first()
    cmn.IsEventDone( "tutorial_prgbar" )
    int_panelscr.AnimPrgBar()
    int_panelscr.SetCurQuest(param,private.quests[param][1]-count.."/"..private.quests[param][1])      
  else 
    local f_end = function()
      public.GotoRoom("rm_secretroomscr")
      ld.Lock(0)
    end
      ng_global.progress[ "scr" ].common.time = int_panelscr.GetTime()  
      ng_global.progress[ "scr" ].common.gamewin = true 
      ng_global.progress[ "scr" ].common.gamestart = false      
      private.ShowAchiv()      
    int_panelscr.AnimPrgBar(f_end)
  end
end

function public.LoadCurQuest()
  if ng_global.progress[ "scr" ].common.failed_less_12min then
    ObjSet( "tmr_panelscr_timer_state", {time=720} );
    int_panelscr.SetTimer()
  else 
    int_panelscr.StartTimer(ng_global.progress[ "scr" ].common.time)
  end
  for i=1,#game.progress_names do
    if cmn.IsEventDone( game.progress_names[i] ) and string.find( game.progress_names[i], "get_" ) then
      ObjSet( "anm_"..common.GetObjectName(game.progress_names[i]), {input = 0, visible = 0,playing=0} );
    else 
      local frame_arr = {math.random(240,360),math.random(660,840)}
      local frame = frame_arr[math.random(1,2)]
      
      ObjSet( "anm_"..common.GetObjectName(game.progress_names[i]), {visible = 1,frame =frame,playing=0})
      
    end
  end
  local cur_quest = ""
  for a=1,#game.progress_names do
    if not cmn.IsEventDone( game.progress_names[a] ) and string.find( game.progress_names[a], "get_" ) then
      local s = game.progress_names[a]
      cur_quest = string.sub(s,string.find(s,"_")+1,string.find(s,"%d")-1)
      break
    end
  end
  if cur_quest ~="" then
    ld.LogTrace( cur_quest );
    local quest_count = 0
    for o=1,private.quests[cur_quest][1] do
      if not cmn.IsEventDone( "get_"..cur_quest..o.."scr" ) then
        local frame = ObjGet("anm_"..cur_quest..o.."scr").frame
        ObjSet( "anm_"..cur_quest..o.."scr", {input = 1, visible=1,playing=1,frame=frame } );
        quest_count = quest_count + 1 
      end
    end
    int_panelscr.SetCurQuest(cur_quest,private.quests[cur_quest][1]-quest_count.."/"..private.quests[cur_quest][1])
    int_panelscr.SetPrgBar()
  end
end

]]


function public.GotoRoom(room)
  common.GotoRoom(room,false,true);
  private.currentroom = room
end


function public.GetCurrentRoom()
  return private.currentroom;
end;



function private.ShowAchiv()
  if ng_global.progress[ "scr" ].common.time < 360 then
    interface.GetAchievement("scr_less_6min")  
    interface.GetAchievement("scr_less_12min") 
  elseif ng_global.progress[ "scr" ].common.time < 720 then
    interface.GetAchievement("scr_less_12min")  
  end
  if not ng_global.progress[ "scr" ].common.failed_without_hint then
    interface.GetAchievement("scr_without_hint")  
  end
  interface.GetAchievement("scr_wingame")
end
function public.FailedWithoutHint()
  if not ng_global.progress[ "scr" ].common.failed_without_hint then
    int_panelscr.FailedAch("scr_without_hint")
    ng_global.progress[ "scr" ].common.failed_without_hint = true 
  end
end
function public.FailedLess6min()
  if not ng_global.progress[ "scr" ].common.failed_less_6min then
    ng_global.progress[ "scr" ].common.failed_less_6min = true 
    int_panelscr.FailedAch("scr_less_6min")
  end
end
function public.FailedLess12min()
  if not ng_global.progress[ "scr" ].common.failed_less_12min then  
    int_panelscr.FailedAch("scr_less_12min")
    ng_global.progress[ "scr" ].common.failed_less_12min = true 
  end
end