-- name=ho_groundho
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "groundho" );
  game.relations[ "ho_groundho" ].exitroom = "rm_neartower";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_groundho" ] = { type = "win", room = "rm_neartower", zz = "ho_groundho", zz_gate = "gho_neartower_groundho" };
 
  local win_groundho_func = function ()

    if ( cmn.IsEventDone( "win_groundho" ) ) then
      interface.InventoryItemAdd( "inv_amulethorse", "spr_groundho_win",function() level_inv.ProcessGetAmulethorseAll( "win_groundho" ) end);
      ObjDelete( "gho_neartower_groundho" );
    end;

  end;
  cmn.AddSubscriber( "win_groundho", win_groundho_func );
  
  local start_groundho_func = function ()
  if not cmn.IsEventDone("win_groundho") then
    interface.ProcessHoPairStart("groundho")  -- загрузка по фаунду  
  end
  end;
  cmn.AddSubscriber( "win_groundho", start_groundho_func, "ho_groundho" );  
        game.groundho = {}
        game.groundho.ho_tasks = {      {"aaa",  {"obj_groundho_aaa_close_1","obj_groundho_aaa_close_2"}}
                    , {"bbb",  {"obj_groundho_bbb_close_1","obj_groundho_bbb_close_2"}}
                    , {"ccc",  {"obj_groundho_ccc_close_1","obj_groundho_ccc_close_2"}}
                    , {"ddd",  {"obj_groundho_ddd_close_1","obj_groundho_ddd_close_2"}}
                    , {"eee",  {"obj_groundho_eee_close_1","obj_groundho_eee_close_2"}}
                    , {"fff",  {"obj_groundho_fff_close_1","obj_groundho_fff_close_2"}}
                    }
end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

 SoundEnv( "aud_neartower_env" );
 
 interface.PanelHoPairEffect_ResetState("groundho")
  if ( not cmn.IsEventDone( "opn_groundho" ) ) then
    
    cmn.InitHo( "groundho" );

    cmn.SetEventDone( "opn_groundho" );
    interface.ProcessHoPairStart("groundho")
  end;


--  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_groundho_aaa" } });
--  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_groundho_bbb" } } );
--  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_groundho_ccc" } } );
--  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_groundho_ddd" } } );
--  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_groundho_eee" } } );
--  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_groundho_fff" } } );
--  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_groundho_ggg" } } );
--  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_groundho_hhh" } } );
--  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_groundho_iii" } } );
--  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_groundho_jjj" } } );
--  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_groundho_kkk" } } );
--  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_groundho_lll" } } );
--  
--  SoundHoTheme( true );
--  interface.TaskPanelShow( ho_items );
--
--   for j = 1, #ng_global.progress["std"]["win_groundho"].found do
--
--    local name = tostring( ng_global.progress["std"]["win_groundho"].found[j]["object"] );
--   
--    ObjDelete( name );
--
--  end;

  local ho_tasks = {};
  interface.PanelHoPair_Show("groundho",game.groundho.ho_tasks)
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.PanelHoPair_Hide("groundho")

end;
--*********************************************************************************************************************
function public.HoComplete()
  ObjDelete("grm_groundho_neartower")
  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_groundho_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_groundho_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
--for SFX
function public.groundho_play_sfx(name)  --ho_groundho.groundho_play_sfx("")
  local name_array = {"ccc1","ccc2","fff1","bbb2","eee1","aaa1","fff2","bbb1","ddd1","aaa2","eee2","ddd2"}
  local sound_array = {"aud_ho_ground_visor","aud_ho_ground_card","aud_ho_ground_shell","aud_ho_ground_paper","aud_ho_ground_paper","aud_ho_ground_armor","aud_ho_ground_armor","aud_ho_ground_casket_heart","aud_ho_ground_gnome","aud_ho_ground_plate","aud_ho_ground_cup","aud_ho_ground_casket_wood"}; 

  for i=1,12,1 do 
     if name==name_array[i] then SoundSfx( sound_array[i] ); break;  end;
  end;  
end;  