-- name=mg_crossing
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_crossing";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_crossing" ] = {type = "win", use_place = "mg_crossing", room = "rm_swamp", zz = "mg_crossing", zz_gate = "gmg_swamp_crossing" };

  local win_crossing_logic = function()
    if ld.CheckRequirements( {"win_crossing"} ) then
      ObjSet( "grm_swamp_beyondtower", {active = 1, visible = 1, input = 1} );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_swamp_beyondtower_focus");
      end;
      ObjDelete("gmg_swamp_crossing");
    end
  end;
  local win_crossing = function()
    if ld.CheckRequirements( {"win_crossing"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_crossing", win_crossing, private.room_objname )
  cmn.AddSubscriber("win_crossing", win_crossing_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
------------------------------------------------------------------------------------------------------------
--1 - susha, 2 - voronka
local crossming_pole={{0,0,1,0,0,0,1},
                    {2,0,0,0,1,0,0},
                    {0,1,2,0,2,1,0},
                    {0,0,0,1,0,0,0},
                    {0,1,0,0,1,0,1},
                    {0,1,1,0,0,0,1}}

--local fuckin_array={{881,593},
--{749,591},
--{626,587},
--{499,589},
--{370,590},
--{241,587},
--{115,591},
--{870,496},
--{749,494},
--{621,491},
--{507,491},
--{370,491},
--{247,492},
--{122,496},
--{869,404},
--{748,401},
--{623,401},
--{501,398},
--{380,401},
--{254,401},
--{138,401},
--{862,307},
--{749,305},
--{620,305},
--{499,305},
--{384,305},
--{267,305},
--{139,307},
--{863,216},
--{734,216},
--{626,218},
--{501,216},
--{380,218},
--{267,216},
--{152,218},
--{857,134},
--{733,129},
--{620,129},
--{501,129},
--{380,127},
--{267,127},
--{158,127}}                    
--         
--function private.show_norm_array_blyat()
--   local my_str=""
--   local count=0;
--   for i=42,1,-1 do 
--     my_str=my_str..",{"..fuckin_array[i][1]..","..fuckin_array[i][2].."}";
--     count=count+1;
--     if count==7 then ld.LogTrace( my_str ); count=0; my_str=""; end;
--   end;  
--end;
-- 

local crossingmg_position_array={{{158,127},{267,127},{380,127},{501,129},{620,129},{733,129},{857,134}},
                                {{152,218},{267,216},{380,218},{501,216},{626,218},{734,216},{863,216}},
                                {{139,307},{267,305},{384,305},{499,305},{620,305},{749,305},{862,307}},
                                {{138,401},{254,401},{380,401},{501,398},{623,401},{748,401},{869,404}},
                                {{122,496},{247,492},{370,491},{507,491},{621,491},{749,494},{870,496}},
                                {{115,591},{241,587},{370,590},{499,589},{626,587},{749,591},{881,593}}}          
                    
local crossingmg_start_positon={6,1};                    
local crossingmg_boat_way={{6,1}};

function private.crossingmg_get_pos(i,j)
  local pos=crossingmg_position_array[i][j];
  return pos;
end;  
    
local crossingmg_pole_created=0

function private.crossingmg_create_pole()
  if crossingmg_pole_created~=1 then 
    for i=1,6,1 do 
      for j=1,7,1 do 
        ObjCreate("spr_crossingmg_frog_"..i.."_"..j,"spr");
        ObjAttach("spr_crossingmg_frog_"..i.."_"..j,"obj_crossingmg_table");
        local my_pos = private.crossingmg_get_pos(i,j);
        ObjSet( "spr_crossingmg_frog_"..i.."_"..j, {active=1, input=0,visible=1,res="assets/levels/level/mg_crossing/fog",pos_x=my_pos[1], pos_y=my_pos[2]} );
      end;  
    end;  
    
    -- strelki 
    local ang_array={0,-1.57,3.14,1.57};
    for i=1,4,1 do 
      ObjCreate("spr_crossingmg_arrow_"..i,"spr");
      ObjAttach("spr_crossingmg_arrow_"..i,"obj_crossingmg_arrow_root");
      ObjSet( "spr_crossingmg_arrow_"..i, {alp=1, res="assets/levels/level/mg_crossing/arrow", input=0, visible=0, ang=0, inputrect_init=1, inputrect_w=100,  inputrect_h=100, inputrect_x=-50, inputrect_y=-50,
            event_mdown="mg_crossing.crossingmg_arrow_mdown("..i..");", event_menter="mg_crossing.crossingmg_arrow_menter("..i..");",event_mleave="mg_crossing.crossingmg_arrow_mleave("..i..");"} );
    end;  
    
    
    
    
    crossingmg_pole_created=1;
  end;
end;  

function private.crossingmg_stand_on_fp()
--  crossingmg_boat_way={{6,1}};
 ng_global.progress["std"]["win_crossing"].state[1],ng_global.progress["std"]["win_crossing"].state[2] =  crossingmg_start_positon[1],crossingmg_start_positon[2] ; 
--  crossingmg_boat_way = ng_global.progress["std"]["win_crossing"].state[3];
  ng_global.progress["std"]["win_crossing"].state[4]=0;
  
-- for i=1,6,1 do 
--     for j=1,7,1 do 
--        ObjSet( "spr_crossingmg_frog_"..i.."_"..j, {active=1, input=0, visible=1, alp=1 } );
--     end;  
-- end;  
     
  ObjSet( "anm_crossing_anim_boat", {animfunc = "boat_static", frame = 0, playing=1 } );
  ObjSet( "obj_crossingmg_boat_root", {ang=0} );  
  private.crossing_stand_on_pos();
end;  


function private.crossing_stand_on_pos()
  -- ld.LogTrace( "fp = "..ng_global.progress["std"]["win_crossing"].state[1].." "..ng_global.progress["std"]["win_crossing"].state[2] );
  
   local my_pos =  private.crossingmg_get_pos(ng_global.progress["std"]["win_crossing"].state[1],ng_global.progress["std"]["win_crossing"].state[2]);
   ObjSet( "obj_crossingmg_boat_root", {pos_x=my_pos[1], pos_y=my_pos[2], ang =  ng_global.progress["std"]["win_crossing"].state[4]} );
   ObjSet( "spr_crossingmg_frog_"..ng_global.progress["std"]["win_crossing"].state[1].."_"..ng_global.progress["std"]["win_crossing"].state[2], {visible=0} );
   
   for i=1,#ng_global.progress["std"]["win_crossing"].state[3],1 do 
      local ii,jj = ng_global.progress["std"]["win_crossing"].state[3][i][1],ng_global.progress["std"]["win_crossing"].state[3][i][2];
      ObjSet( "spr_crossingmg_frog_"..ii.."_"..jj, {visible=0, alp=0} );
   end;   
   private.crossingmg_win_ver(ng_global.progress["std"]["win_crossing"].state[1],ng_global.progress["std"]["win_crossing"].state[2]); 
   private.search_open_napr();  
end;  

  
local crossimg_open_napr={0,0,0,0};  --up,--right,--down,--left
local crossing_open_napr_pos={};
function  private.search_open_napr()
  for i=1,4,1 do 
    ObjSet( "spr_crossingmg_arrow_"..i, {input = 0} );
    crossing_open_napr_pos[i]={0,0};
  end;  
  
  
  crossimg_open_napr={0,0,0,0};
  local my_pos={ng_global.progress["std"]["win_crossing"].state[1],ng_global.progress["std"]["win_crossing"].state[2]};
  local i,j = my_pos[1], my_pos[2];
  
  if my_pos[1]>1 then
     crossimg_open_napr[1]=1;
     local cur_pos=private.crossingmg_get_pos(i-1,j);
     crossing_open_napr_pos[1]={i-1,j};
     ObjSet( "spr_crossingmg_arrow_"..1, {pos_x=cur_pos[1], pos_y=cur_pos[2], input=1});
  end;
  if my_pos[2]<7 then
     crossimg_open_napr[2]=1;
     local cur_pos=private.crossingmg_get_pos(i,j+1);
     crossing_open_napr_pos[2]={i,j+1};
     ObjSet( "spr_crossingmg_arrow_"..2, {pos_x=cur_pos[1], pos_y=cur_pos[2], input=1});
  end;
  if my_pos[1]<6 then
     crossimg_open_napr[3]=1;
     local cur_pos=private.crossingmg_get_pos(i+1,j);
     crossing_open_napr_pos[3]={i+1,j};
     ObjSet( "spr_crossingmg_arrow_"..3, {pos_x=cur_pos[1], pos_y=cur_pos[2], input=1});
  end;
  if my_pos[2]>1 then
     crossimg_open_napr[4]=1;
     local cur_pos=private.crossingmg_get_pos(i,j-1);
     crossing_open_napr_pos[4]={i,j-1};
     ObjSet( "spr_crossingmg_arrow_"..4, {pos_x=cur_pos[1], pos_y=cur_pos[2], input=1});
  end;
  
end;  

function public.crossingmg_arrow_menter(num)
  ObjSet( "spr_crossingmg_arrow_"..num, {visible=1, alp=0} );
  local o = ObjGet( "spr_crossingmg_arrow_"..num )
  ObjAnimate( "spr_crossingmg_arrow_"..num, 8,0,0, "", { 0,0,o.alp, (1-o.alp)/5,0,1 } )
  ld.SetCursor(CURSOR_HAND);
end;  
 
function public.crossingmg_arrow_mleave(num)
  ld.SetCursor(CURSOR_DEFAULT);
  local o = ObjGet( "spr_crossingmg_arrow_"..num )
  ObjAnimate( "spr_crossingmg_arrow_"..num, 8,0,0, function() ObjSet( "spr_crossingmg_arrow_"..num, {visible=0} ); end, { 0,0,o.alp, (1-o.alp)/5,0,0 } )
end;  

function private.crossingmg_new_ver(i,j)
  return crossming_pole[i][j];
end;  

function private.crossingmg_win_ver(i,j)
  if i==1 and j==2 then 
    private.Win();
  end;  
end;  


function public.crossingmg_arrow_mdown(num)
  local my_pos={ng_global.progress["std"]["win_crossing"].state[1],ng_global.progress["std"]["win_crossing"].state[2]};
  
  ld.Lock(1);
  local new_pos=private.crossingmg_get_pos(crossing_open_napr_pos[num][1],crossing_open_napr_pos[num][2])
  local new_x,new_y = new_pos[1], new_pos[2];
  --  ld.LogTrace( "new i,j = "..crossing_open_napr_pos[num][1].." "..crossing_open_napr_pos[num][2].." //new pos= "..new_x.." "..new_y );
  
  local func_motion_end=function()
    ng_global.progress["std"]["win_crossing"].state[1],ng_global.progress["std"]["win_crossing"].state[2] = crossing_open_napr_pos[num][1],crossing_open_napr_pos[num][2];
    local razm=#ng_global.progress["std"]["win_crossing"].state[3];
    ng_global.progress["std"]["win_crossing"].state[3][razm+1]={ng_global.progress["std"]["win_crossing"].state[1],ng_global.progress["std"]["win_crossing"].state[2]};
    ng_global.progress["std"]["win_crossing"].state[4] = ObjGet("obj_crossingmg_boat_root").ang;
    ld.Lock(0);
    private.crossing_stand_on_pos();
  end;
  
  
  local func_motion2 = function()
    local cur_pos_x = ObjGet("obj_crossingmg_boat_root").pos_x;
    local cur_pos_y = ObjGet("obj_crossingmg_boat_root").pos_y;
   -- ld.LogTrace( "cur_pos = "..cur_pos_x.." "..cur_pos_y.." // new_pos = "..new_x.." "..new_y );
   ObjAnimate( "obj_crossingmg_boat_root", 3, 0, 0, function() end, {0,0,cur_pos_x,cur_pos_y, 0.5,0,new_x,new_y} );
   ObjAnimate( "spr_crossingmg_frog_"..crossing_open_napr_pos[num][1].."_"..crossing_open_napr_pos[num][2], 8, 0, 0, function() end, {0,0,1, 0.25,0,0} );
   SoundSfx( "aud_mg_crossing_move" ); 
   
    local ver_res = private.crossingmg_new_ver(crossing_open_napr_pos[num][1], crossing_open_napr_pos[num][2]);
    if ver_res~=0 then 
       local razm=#ng_global.progress["std"]["win_crossing"].state[3];
       ng_global.progress["std"]["win_crossing"].state[3][razm+1]={crossing_open_napr_pos[num][1],crossing_open_napr_pos[num][2]};
       local boat_anim_func={"boat_scal","boat_dno"};
       local our_sfx = {"aud_mg_crossing_crash","aud_mg_crossing_whirpool"};
       ld.StartTimer( 0.25, function() SoundSfx( our_sfx[ver_res] ); ld.AnimPlay( "anm_crossing_anim_boat",boat_anim_func[ver_res], function() ld.Lock(0); public.Reset() end) end )
    else 
       ld.StartTimer( 0.5, func_motion_end)      
    end;  
  end;
  
  
  local func_motion = function()
     local ang_array={0,4.71,3.14,1.57};
     local cur_ang = ObjGet("obj_crossingmg_boat_root").ang;
     local new_ang = ang_array[num];
     if math.abs(new_ang-cur_ang)>0.01 then 
     
         if math.abs(new_ang - cur_ang)>math.pi then 
            local zn=(new_ang - cur_ang)/math.abs(new_ang - cur_ang);
            new_ang=cur_ang-zn*1.57;
         end;  
          ObjAnimate( "obj_crossingmg_boat_root", 7, 0, 0, function() func_motion2(); ObjSet( "obj_crossingmg_boat_root", {ang=ang_array[num]} ); end, {0,0,cur_ang, 0.25,0,new_ang} );
     else 
        func_motion2();
        ObjSet( "obj_crossingmg_boat_root", {ang=ang_array[num]} );   
     end;  
      -- ld.LogTrace( "cur_ang = "..cur_ang.." new_ang = "..ang_array[num] );
  end;
  
  func_motion();
end;  
--function private.crossing_
  

--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_crossing"} ) then
    cmn.MiniGameShow( "crossing" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_swamp_env" );
  private.crossingmg_create_pole();
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_crossing"} ) then
    cmn.MiniGameHide( "crossing" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function()
    ld.Lock(0);
    private.crossingmg_stand_on_fp();
  end;
  
  ld.Lock(1);
  ObjAnimate( "obj_crossingmg_boat_root", 8, 0, 0, function() end, {0,0,1, 0.25,0,0, 0.5,0,1} );
 -- for i=1,6,1 do 
 --     for j=1,7,1 do 
 --       if not (i==6 and j==1) then 
 --         ObjSet( "spr_crossingmg_frog_"..i.."_"..j, {active=1, input=0, visible=1 } );
 --         local cur_alp = ObjGet("spr_crossingmg_frog_"..i.."_"..j).alp;
 --     --    ld.LogTrace( "cur_alp i="..i.." j="..j.." alp="..cur_alp );
 --         ObjAnimate( "spr_crossingmg_frog_"..i.."_"..j, 8, 0, 0, function() end, {0,0,cur_alp, 0.7,0,1} );
 --       end;  
 --     end;  
 -- end;  
 ld.StartTimer( 0.25, func_end )  
end;
--*********************************************************************************************************************
function public.Skip()
  local func_end = function()
    private.Win();
  end;
  
  ld.Lock(1);
  for i=1,6,1 do 
      for j=1,7,1 do 
       if not (i==6 and j==1) then 
          ObjSet( "spr_crossingmg_frog_"..i.."_"..j, {active=1, input=0, visible=1 } );
          local cur_alp = ObjGet("spr_crossingmg_frog_"..i.."_"..j).alp;
      --    ld.LogTrace( "cur_alp i="..i.." j="..j.." alp="..cur_alp );
         ObjAnimate( "spr_crossingmg_frog_"..i.."_"..j, 8, 0, 0, function() end, {0,0,cur_alp, 0.25,0,0} );
       end;  
      end;  
  end;  
  ObjAnimate( "obj_crossingmg_boat_root", 8, 0, 0, function()
          local my_pos = private.crossingmg_get_pos(1,2);
          ObjSet( "obj_crossingmg_boat_root", {ang=0, pos_x=my_pos[1], pos_y=my_pos[2]} );
          ObjAnimate( "obj_crossingmg_boat_root", 8, 0, 0, func_end, {0,0,0, 0.25,0,1} );
  end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_crossing" );
  cmn.CallEventHandler( "win_crossing" );
  cmn.GotoRoom( "rm_beyondtower" );
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  local cur_alp= ObjGet("spr_crossingmg_frog_1_1").alp;
  ObjAnimate( "spr_crossingmg_frog_1_1", 8, 0, 0, function() end, {0,0,cur_alp, 0.25,0,0} );
  ld.StartTimer( 0.75, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["std"]["win_crossing"].state then
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_crossing"].state )
    else
      ng_global.progress["std"]["win_crossing"].state =  ld.TableCopy( crossingmg_start_positon ); 
      ng_global.progress["std"]["win_crossing"].state[3]=crossingmg_boat_way;
      crossingmg_boat_way = ng_global.progress["std"]["win_crossing"].state[3];
      ng_global.progress["std"]["win_crossing"].state[4]=0;
    end
  
    gm.loaded  = true;
  else
  
  end;
  private.crossing_stand_on_pos();
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_crossing"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;