-- name=level

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 13 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 11 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 9 );

  interface.WidgetAdd( InterfaceWidget_Effects );



  interface.WidgetAdd( InterfaceWidget_DialogHo,30 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  interface.WidgetAdd( InterfaceWidget_ItemPanel,9 );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog,30 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo,30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory,30 );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 30 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial,30 );

  interface.WidgetAdd( InterfaceWidget_Map, 16  );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  interface.PanelNotificationAdd(10);

  if IsCollectorsEdition() then
    interface.WidgetAdd( InterfaceWidget_StrategyGuide,30 );
    interface.WidgetAdd( InterfaceWidget_BtnGuide, 12 );  
  end
  

  
  --interface.DeployInvAdd(7);
  interface.ComplexInvAdd( 9 )
  interface.DialogHintAdd(20);
  --interface.Btn_DiaryAdd(12)
  --interface.InvestigationButtonAdd( 17 );
  --interface.DiaryAdd( 18 );
  --interface.DiaryDcnAdd( 31 );

  interface.PanelhopairAdd(9)

  interface.ButtonTaskAdd(20)
  interface.DialogTaskAdd(10)

  private.Init();


  ModLoad( "assets/levels/level/mod_level_inv" );
  level_inv.Init()

  private.TutorInit()--тутор
  --
  interface.ArrCards()
  interface.ArrPuzzles()

  common.LevelLoad( "level", "std", "rm_house", param );
  --ModLoad( "assets/interface/map/mod_map" );
  interface.ArrInvPlus()  -- проверка состояния плюсика для деплойных инв предметов

  interface.KeyUpdate();

  --временно залочена кнопка SG
  --interface.WidgetSetInput(InterfaceWidget_BtnGuide, 0)
  
  --interface.WidgetSetInput(InterfaceWidget_BtnMap, 0)
  
  ObjSet( "txt_int_dialog_character", {param0 = GetCurrentProfile()} );
  --автоподствновка имени игрока в диалоги

  interface.CheckPuzzles()
  interface.CheckMorphing()
  interface.CheckCards()
end;

--function public.SimonAdd() -- get_simon
--  
--  interface.SimonAdd(10)
-- -- int_simon.LoadAnotherPrg()
--end

function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_house"
    ,"rm_outro"
--[[AUTO]]  ,"ho_barn"
--[[AUTO]]  ,"rm_ruralroad"
--[[AUTO]]  ,"rm_farm"
--[[AUTO]]  ,"rm_pond"
--[[AUTO]]  ,"rm_ruralhouse"
--[[AUTO]]  ,"rm_cellar"
--[[AUTO]]  ,"ho_commodeho"
--[[AUTO]]  ,"rm_neartower"
--[[AUTO]]  ,"rm_tower"
--[[AUTO]]  ,"rm_chapel"
--[[AUTO]]  ,"mg_vitragemg"
--[[AUTO]]  ,"ho_groundho"
--[[AUTO]]  ,"mg_fencepuzzle"
--[[AUTO]]  ,"mg_grillemg"

--[[AUTO]]  ,"rm_nearpub"
--[[AUTO]]  ,"rm_pub"
--[[AUTO]]  ,"ho_pantry"
--[[AUTO]]  ,"rm_darkquarter"
--[[AUTO]]  ,"rm_swamp"
--[[AUTO]]  ,"rm_mansion"
--[[AUTO]]  ,"ho_bookho"
--[[AUTO]]  ,"rm_beyondtower"
--[[AUTO]]  ,"ho_chatterho"
--[[AUTO]]  ,"mg_flow"
--[[AUTO]]  ,"mg_crossing"
--[[AUTO]]  ,"mg_gatemg"
--[[AUTO]]  ,"rm_jail"
--[[AUTO]]  ,"mg_storystorm"
--[[AUTO]]  ,"rm_corridor"
--[[AUTO]]  ,"ho_puddle"
--[[AUTO]]  ,"rm_rungs"
--[[AUTO]]  ,"ho_suitcase"
--[[AUTO]]  ,"rm_bedroom"
--[[AUTO]]  ,"mg_carpetmg"
--[[AUTO]]  ,"rm_hall"
--[[AUTO]]  ,"mg_clockmg"
--[[AUTO]]  ,"ho_crystalho"
--[[AUTO]]  ,"rm_yard"
  };

  game.progress_names =
  {
     "opn_house"
 
--[[AUTO]]  ,"get_palette"
--[[AUTO]]  ,"use_palette"
--[[AUTO]]  ,"clk_picture"
--[[AUTO]]  ,"clk_anmhouse1"
--[[AUTO]]  ,"opn_barn"
--[[AUTO]]  ,"win_barn"
            ,"win_barn_task"
--[[AUTO]]  ,"clk_amuletopen"
            ,"win_amulet"
            
            -- ,"win_amuletphoto"
--[[AUTO]]  ,"clk_fotoamulet"
--[[AUTO]]  ,"get_familyamulet"
--[[AUTO]]  ,"clk_anmhouse2"
--[[AUTO]]  ,"opn_ruralroad"
--[[AUTO]]  ,"dlg_ruralroad_elizabeth1"
--[[AUTO]]  ,"clk_attack"
--[[AUTO]]  ,"get_handbag"
--[[AUTO]]  ,"clk_handbagopn1"
            ,"clk_handbagopn2"
            ,"clk_handbagopn3"
            ,"clk_handbagopn4"
            ,"clk_handbagopn5"
            ,"clk_handbagopn6"
            ,"clk_handbagopn7"
            ,"get_paper"
            ,"clk_handbagopn8"
            ,"get_rivet1"
            ,"clk_handbagopn9"
--[[AUTO]]  ,"get_amuletfeather1"
--[[AUTO]]  ,"get_tube1"
--[[AUTO]]  ,"get_medicine"
--[[AUTO]]  ,"get_glassshard1"
--[[AUTO]]  ,"use_medicine"
--[[AUTO]]  ,"dlg_ruralroad_william1"
--[[AUTO]]  ,"get_dagger"
--[[AUTO]]  ,"clk_williamgoaway"
--[[AUTO]]  ,"use_dagger"
--[[AUTO]]  ,"get_plaid"
--[[AUTO]]  ,"use_plaid"
--[[AUTO]]  ,"opn_farm"
--[[AUTO]]  ,"dlg_farm_granny1"
--[[AUTO]]  ,"get_puzzlepiece1"
--[[AUTO]]  ,"get_rivet2"
--[[AUTO]]  ,"get_wateringcan"
--[[AUTO]]  ,"use_rivet1"
--[[AUTO]]  ,"use_rivet2"
--[[AUTO]]  ,"get_coin"
--[[AUTO]]  ,"get_brokenpruner"
--[[AUTO]]  ,"use_coin_brokenpruner"
--[[AUTO]]  ,"get_dullpruner"
--[[AUTO]]  ,"use_dullpruner"
            ,"clk_dullpruner"
--[[AUTO]]  ,"get_pruner"
--[[AUTO]]  ,"use_pruner"
--[[AUTO]]  ,"get_puzzlepiece2"
--[[AUTO]]  ,"get_glassshard3"
--[[AUTO]]  ,"use_puzzlepiece1"
--[[AUTO]]  ,"use_puzzlepiece2"
--[[AUTO]]  ,"win_fencepuzzle"
--[[AUTO]]  ,"opn_pond"
--[[AUTO]]  ,"clk_escape"
--[[AUTO]]  ,"get_glassshard2"
--[[AUTO]]  ,"use_wateringcan"
--[[AUTO]]  ,"get_fullwateringcan"
--[[AUTO]]  ,"use_fullwateringcan"
--[[AUTO]]  ,"get_amuletfeather2"
--[[AUTO]]  ,"use_amuletfeather1"
--[[AUTO]]  ,"use_amuletfeather2"
--[[AUTO]]  ,"clk_baggageho"
            ,"win_baggage"
--[[AUTO]]  --,"get_cane"
            ,"clk_housekeylogs"
--[[AUTO]]  ,"use_cane"
--[[AUTO]]  ,"get_housekey"
--[[AUTO]]  ,"use_housekey"
            ,"clk_housekey"
            ,"clk_housekey2"
--[[AUTO]]  ,"opn_ruralhouse"
--[[AUTO]]  ,"get_thread"
--[[AUTO]]  ,"get_brokenbagpipe"
--[[AUTO]]  ,"get_knittingneedles"
--[[AUTO]]  ,"clk_paper1"
--[[AUTO]]  ,"clk_paper2"
            ,"clk_paper3"
            ,"clk_paper4"
            ,"clk_paper5"
--[[AUTO]]  ,"use_thread"
--[[AUTO]]  ,"get_toypuppy"
--[[AUTO]]  ,"use_toypuppy"
--[[AUTO]]  ,"get_net"
--[[AUTO]]  ,"get_tube2"
--[[AUTO]]  ,"use_net"
--[[AUTO]]  ,"get_shellfish"
--[[AUTO]]  ,"use_knittingneedles_shellfish"
--[[AUTO]]  ,"get_pearl"
--[[AUTO]]  ,"use_pearl"
            ,"clk_pearldoor"
--[[AUTO]]  ,"get_scissors"
--[[AUTO]]  ,"get_tube3"
--[[AUTO]]  ,"get_tube4"
            ,"clk_brokenbagpipe1"
            ,"clk_brokenbagpipe2"
--[[AUTO]]  ,"use_tube"
--[[AUTO]]  ,"get_bagpipe"
--[[AUTO]]  ,"use_bagpipe"
--[[AUTO]]  ,"win_bagpipe"
--[[AUTO]]  ,"opn_cellar"
--[[AUTO]]  ,"use_knittingneedles_furnace"
--[[AUTO]]  ,"get_amuletmouse"
--[[AUTO]]  ,"use_amuletmouse"
            ,"clk_amuletmousedoor"
--[[AUTO]]  ,"get_roundkey"
--[[AUTO]]  ,"use_roundkey"
--[[AUTO]]  ,"opn_commodeho"
--[[AUTO]]  ,"win_commodeho"
--[[AUTO]]  ,"clk_parcelopn1"
--[[AUTO]]  ,"clk_parcelopn2"
--[[AUTO]]  ,"get_glasses"
--[[AUTO]]  ,"get_clasp"
--[[AUTO]]  ,"get_candle"
--[[AUTO]]  ,"use_candle"
--[[AUTO]]  ,"get_lightedcandle"
--[[AUTO]]  ,"use_clasp"
--[[AUTO]]  ,"get_saw"
--[[AUTO]]  ,"get_nailpuller"
--[[AUTO]]  ,"get_canvasshovel"
--[[AUTO]]  ,"use_nailpuller"
--[[AUTO]]  ,"get_amulethorse1"
--[[AUTO]]  ,"get_wool"
--[[AUTO]]  ,"use_saw"
--[[AUTO]]  ,"get_boards"
--[[AUTO]]  ,"use_boards"
--[[AUTO]]  ,"win_boards"
--[[AUTO]]  ,"opn_neartower"
            ,"opn_neartowerslab"
--[[AUTO]]  ,"get_veil"
--[[AUTO]]  ,"get_glassshard4"
--[[AUTO]]  ,"use_coin_dray"
--[[AUTO]]  ,"get_wheeldistaff"
--[[AUTO]]  ,"use_wheeldistaff"
--[[AUTO]]  ,"use_wool"
            ,"clk_wool"
--[[AUTO]]  ,"get_yarn"
--[[AUTO]]  ,"use_yarn"
--[[AUTO]]  ,"dlg_farm_granny2"
--[[AUTO]]  ,"get_badge"
--[[AUTO]]  ,"clk_badgeopn"
--[[AUTO]]  ,"get_pin"
--[[AUTO]]  ,"use_pin"
            ,"clk_towerentrancedoor"
--[[AUTO]]  ,"opn_tower"
--[[AUTO]]  ,"use_veil"
--[[AUTO]]  ,"use_lightedcandle"

--[[AUTO]]  ,"get_flowerkey"
--[[AUTO]]  ,"get_amuletcross"
--[[AUTO]]  ,"get_mitten"
--[[AUTO]]  ,"use_amuletcross"
--[[AUTO]]  ,"get_wing1"
--[[AUTO]]  ,"use_flowerkey"
            ,"clk_flowerkeydoor"
--[[AUTO]]  ,"get_rope"
            ,"get_scheme"
--[[AUTO]]  ,"clk_rope1"
--[[AUTO]]  ,"clk_rope2"
            ,"clk_rope3"
--[[AUTO]]  ,"get_lasso"
--[[AUTO]]  ,"use_lasso"
--[[AUTO]]  ,"win_lasso"
--[[AUTO]]  ,"opn_chapel"
--[[AUTO]]  ,"get_glassshard5"
--[[AUTO]]  ,"use_glassshard"
--[[AUTO]]  ,"win_vitragemg"
--[[AUTO]]  ,"get_wing2"
--[[AUTO]]  ,"use_wing1"
--[[AUTO]]  ,"use_wing2"
--[[AUTO]]  ,"get_shield"
--[[AUTO]]  ,"get_amulethorse2"
--[[AUTO]]  ,"use_mitten"
--[[AUTO]]  ,"use_shield"
            ,"use_scheme"
--[[AUTO]]  ,"win_knight"
--[[AUTO]]  ,"get_scottishstatue1"
--[[AUTO]]  ,"get_amulethexagon"
--[[AUTO]]  ,"use_amulethexagon"
--[[AUTO]]  ,"get_scepter"
--[[AUTO]]  ,"use_scepter"
--[[AUTO]]  ,"get_scottishstatue2"
--[[AUTO]]  ,"get_casket"
--[[AUTO]]  ,"use_scottishstatue1"
--[[AUTO]]  ,"use_scottishstatue2"
            ,"clk_wallstone"
--[[AUTO]]  ,"get_squarekey"
--[[AUTO]]  ,"use_squarekey"
            ,"win_casketmmg"
            ,"clk_casketpaper1"
            ,"clk_casketpaper2"
--[[AUTO]]  ,"get_book"
--[[AUTO]]  ,"use_book"
--[[AUTO]]  ,"get_greencrystal"
--[[AUTO]]  ,"get_rosary"

--[[AUTO]]  ,"use_rosary"
--[[AUTO]]  ,"get_haft"
--[[AUTO]]  ,"use_haft"
--[[AUTO]]  ,"get_shovel"
--[[AUTO]]  ,"use_shovel"
--[[AUTO]]  ,"opn_groundho"
--[[AUTO]]  ,"win_groundho"
--[[AUTO]]  --,"get_amulethorse3"
--[[AUTO]]  ,"use_amulethorse"
--[[AUTO]]  ,"win_grillemg"
--[[AUTO]]  ,"clk_grileopn"
--[[AUTO]]  ,"clk_outrolvl1"
--[[AUTO]]  ,"clk_anmcoach1"
--[[AUTO]]  ,"dlg_ruralroad_elizabeth2"
--[[AUTO]]  ,"dlg_ruralroad_william2"
--[[AUTO]]  ,"clk_anmcoach2"
--[[AUTO]]  ,"get_barrel1"
--[[AUTO]]  ,"opn_nearpub"
--[[AUTO]]  ,"dlg_nearpub_william3"
--[[AUTO]]  ,"get_brokenrod"
--[[AUTO]]  ,"get_barrel2"
            ,"clk_dollglasses"
--[[AUTO]]  ,"use_glasses"
--[[AUTO]]  ,"get_clover"
--[[AUTO]]  ,"get_bell1"
--[[AUTO]]  ,"get_stone"
--[[AUTO]]  ,"use_stone"
--[[AUTO]]  ,"win_stones"
            ,"clk_opnstones"
--[[AUTO]]  ,"get_bell2"
--[[AUTO]]  ,"use_bell1"
--[[AUTO]]  ,"use_bell2"
--[[AUTO]]  ,"get_pubkey"
--[[AUTO]]  ,"use_pubkey_pubdoor2"
--[[AUTO]]  ,"opn_pub"
--[[AUTO]]  ,"dlg_pub_elizabeth3"
--[[AUTO]]  ,"get_brooch1"
--[[AUTO]]  ,"get_redcrystal"
--[[AUTO]]  ,"get_fishingline"
--[[AUTO]]  ,"get_plaquebelt"
--[[AUTO]]  ,"use_plaquebelt"
--[[AUTO]]  ,"get_bullring"
--[[AUTO]]  ,"get_barrel3"
--[[AUTO]]  --,"use_bullring_windowhole"
            ,"clk_box"
            --[[AUTO]]  --,"clk_herbs"
--[[AUTO]]  ,"get_esdoornblad"
--[[AUTO]]  ,"get_scarf"
            ,"clk_dollscarf"
--[[AUTO]]  ,"use_scarf"
--[[AUTO]]  ,"get_hook"
--[[AUTO]]  ,"use_fishingline"
--[[AUTO]]  ,"use_hook"
--[[AUTO]]  ,"get_rod"
--[[AUTO]]  ,"use_rod"
--[[AUTO]]  ,"get_barrel4"
--[[AUTO]]  ,"use_clover"
--[[AUTO]]  ,"use_esdoornblad"
--[[AUTO]]  ,"win_clovers"
--[[AUTO]]  ,"opn_pantry"
--[[AUTO]]  ,"win_pantry"
--[[AUTO]]  ,"clk_window"
--[[AUTO]]  ,"use_barrel"
--[[AUTO]]  ,"use_pubkey_pub"
--[[AUTO]]  ,"clk_clavecin"
--[[AUTO]]  ,"clk_raid"
--[[AUTO]]  ,"dlg_pub_william4"
            ,"get_carretkey"
           ,"clk_raidfornearpub"
            ,"use_carretkey"
            ,"clk_raggeddress"
--[[AUTO]]  ,"get_raggeddress"
--[[AUTO]]  ,"get_bigkey"
--[[AUTO]]  ,"use_bigkey"
            ,"clk_bigkey"
            ,"win_gatemg"
            ,"clk_gatemgfornearpub"
--[[AUTO]]  ,"opn_darkquarter"
--[[AUTO]]  ,"dlg_darkquarter_bandit1"
--[[AUTO]]  ,"get_monogramen"
--[[AUTO]]  ,"opn_swamp"
--[[AUTO]]  ,"clk_anmboat"
--[[AUTO]]  ,"get_lily1"
--[[AUTO]]  ,"use_bullring_mansiondoor"
--[[AUTO]]  ,"get_phoenix"
--[[AUTO]]  ,"use_scissors_ads"
--[[AUTO]]  ,"get_yellowcrystal"
--[[AUTO]]  ,"get_saltcellar"
--[[AUTO]]  ,"use_saltcellar"
--[[AUTO]]  ,"win_seasonings"
            ,"clk_hollow"
--[[AUTO]]  ,"get_talisman"
--[[AUTO]]  ,"use_talisman"
--[[AUTO]]  ,"get_brooch2"
--[[AUTO]]  ,"get_purse"
--[[AUTO]]  ,"use_monogramen"
--[[AUTO]]  ,"clk_pursenote"
--[[AUTO]]  ,"clk_pursestory"
--[[AUTO]]  ,"clk_purse"
            ,"clk_purse2"
--[[AUTO]]  ,"get_bird1"
--[[AUTO]]  ,"get_brooch3"
--[[AUTO]]  ,"get_boot"
--[[AUTO]]  ,"use_scissors_boot"
--[[AUTO]]  ,"clk_boot"
--[[AUTO]]  ,"get_cone1"
--[[AUTO]]  ,"get_axe"
--[[AUTO]]  ,"use_axe"
            ,"win_barrels"
            --[[AUTO]] -- ,"clk_barrelsho"
            --[[AUTO]]  --,"get_ladle"
--[[AUTO]]  ,"use_ladle"
--[[AUTO]]  ,"get_handle"
--[[AUTO]]  ,"get_screwdriver"
--[[AUTO]]  ,"get_cone2"
--[[AUTO]]  ,"use_screwdriver"
--[[AUTO]]  ,"get_frame"
--[[AUTO]]  ,"use_frame"
--[[AUTO]]  ,"get_birdclaw"
--[[AUTO]]  ,"use_birdclaw"
--[[AUTO]]  ,"get_brooch4"
            ,"clk_cobblershophandle"
--[[AUTO]]  ,"use_handle"
--[[AUTO]]  ,"get_needlethread"
--[[AUTO]]  ,"use_needlethread"
--[[AUTO]]  ,"use_brooch"
--[[AUTO]]  ,"get_dress"
--[[AUTO]]  ,"use_dress"
--[[AUTO]]  ,"dlg_darkquarter_bandit2"
--[[AUTO]]  ,"get_bracelet"
--[[AUTO]]  ,"use_bracelet"
            ,"clk_monumentbraceletcode"
--[[AUTO]]  ,"get_mansionkey"
--[[AUTO]]  ,"use_mansionkey"
--[[AUTO]]  ,"clk_mansiondoor"
--[[AUTO]]  ,"opn_mansion"
--[[AUTO]]  ,"get_smallchest"
--[[AUTO]]  ,"use_scissors_collection"
--[[AUTO]]  ,"get_amuletskull"
--[[AUTO]]  ,"use_amuletskull"
--[[AUTO]]  ,"get_brush"
--[[AUTO]]  ,"use_brush"
--[[AUTO]]  ,"get_dragon1"
--[[AUTO]]  ,"get_feather"
--[[AUTO]]  ,"get_jar"
--[[AUTO]]  ,"clk_jar"
--[[AUTO]]  ,"get_frog"
--[[AUTO]]  ,"use_frog"
--[[AUTO]]  ,"win_frogs"
--[[AUTO]]  ,"get_lily2"
--[[AUTO]]  ,"use_lily1"
--[[AUTO]]  ,"use_lily2"
--[[AUTO]]  ,"get_sword"
--[[AUTO]]  ,"use_sword"
--[[AUTO]]  ,"win_swords"
--[[AUTO]]  ,"get_ink"
--[[AUTO]]  ,"use_feather"
--[[AUTO]]  ,"use_ink"
            ,"clk_smallchest_paper1"
            ,"clk_smallchest_paper2"
--[[AUTO]]  ,"get_dragon2"
 --           ,"clk_bird"
--[[AUTO]]  ,"get_seed"
--[[AUTO]]  ,"use_seed"
--[[AUTO]]  ,"get_cone3"
--[[AUTO]]  ,"use_cone"
--[[AUTO]]  ,"clk_coach1"
--[[AUTO]]  ,"clk_coach2"
            ,"clk_coach3"
--[[AUTO]]  ,"get_bluecrystal"
--[[AUTO]]  ,"use_greencrystal"
--[[AUTO]]  ,"use_redcrystal"
--[[AUTO]]  ,"use_yellowcrystal"
--[[AUTO]]  ,"use_bluecrystal"
--[[AUTO]]  ,"opn_bookho"
--[[AUTO]]  ,"win_bookho"
--[[AUTO]]  ,"use_dragon"
            ,"clk_undergroundopn"

--[[AUTO]]  ,"get_lionfigure"
--[[AUTO]]  ,"get_keystar"
--[[AUTO]]  ,"use_keystar"
            ,"clk_door"
--[[AUTO]]  ,"get_paddle"
--[[AUTO]]  ,"use_paddle"
--[[AUTO]]  ,"win_crossing"
--[[AUTO]]  ,"opn_beyondtower"
--[[AUTO]]  ,"clk_anmladder"
--[[AUTO]]  ,"get_brokenladder"
--[[AUTO]]  ,"get_bird2"
--[[AUTO]]  ,"use_bird1"
--[[AUTO]]  ,"use_bird2"
--[[AUTO]]  ,"get_amuletphoenix"
--[[AUTO]]  ,"use_amuletphoenix"
--[[AUTO]]  ,"opn_chatterho"
--[[AUTO]]  ,"win_chatterho"
--[[AUTO]]  ,"use_valve"
--[[AUTO]]  ,"win_flow"
--[[AUTO]]  ,"get_butterfly"
--[[AUTO]]  ,"clk_butterfly1"
--[[AUTO]]  ,"clk_butterfly2"
--[[AUTO]]  ,"get_wire"
            ,"clk_brokenladder"
--[[AUTO]]  ,"use_wire"
--[[AUTO]]  ,"get_ladder"
--[[AUTO]]  ,"use_ladder"
--[[AUTO]]  ,"clk_outrolvl2"

--[[AUTO]]  ,"opn_jail"
--[[AUTO]]  ,"clk_anmjail"
--[[AUTO]]  ,"dlg_jail_storm1"
--[[AUTO]]  ,"use_scissors_jail"
--[[AUTO]]  ,"win_storystorm"
--[[AUTO]]  ,"get_cufflink"
--[[AUTO]]  ,"get_rose1"
--[[AUTO]]  ,"get_screw"
--[[AUTO]]  ,"use_cufflink"
--[[AUTO]]  ,"win_holelock"
--[[AUTO]]  ,"opn_corridor"
--[[AUTO]]  ,"get_numeral"
--[[AUTO]]  ,"get_handlebox"
--[[AUTO]]  ,"clk_moss"
--[[AUTO]]  ,"use_screw"
--[[AUTO]]  ,"get_numeral2"
--[[AUTO]]  ,"clk_bucket"
--[[AUTO]]  ,"opn_puddle"
--[[AUTO]]  ,"win_puddle"
--[[AUTO]]  ,"get_pick"
--[[AUTO]]  ,"use_pick_tile"
--[[AUTO]]  ,"get_stoneleaf1"
--[[AUTO]]  ,"use_pick_hidingplace"
--[[AUTO]]  ,"get_sack"
--[[AUTO]]  ,"clk_untiesack"
--[[AUTO]]  ,"get_stonesun"
--[[AUTO]]  ,"use_stonesun"
--[[AUTO]]  ,"get_wrench"
--[[AUTO]]  ,"use_wrench"
--[[AUTO]]  ,"get_stonemoon"
--[[AUTO]]  ,"use_stonemoon"
--[[AUTO]]  ,"get_spideramulet"
--[[AUTO]]  ,"use_spideramulet"
--[[AUTO]]  ,"get_stoneleaf2"
--[[AUTO]]  ,"use_stoneflower"
--[[AUTO]]  ,"use_stoneleaf1"
--[[AUTO]]  ,"use_stoneleaf2"
--[[AUTO]]  ,"opn_rungs"
--[[AUTO]]  ,"dlg_rungs_storm2"
--[[AUTO]]  ,"get_shawl"
--[[AUTO]]  ,"use_lionfigure"
--[[AUTO]]  ,"get_amuletlizard1"
--[[AUTO]]  ,"clk_shouts"
--[[AUTO]]  ,"get_crystalball1"
--[[AUTO]]  ,"get_amuletlizard2"
--[[AUTO]]  ,"get_shardpictures1"
--[[AUTO]]  ,"get_fiddlestick"
--[[AUTO]]  ,"use_scissors_picture"
--[[AUTO]]  ,"win_corners"
--[[AUTO]]  ,"get_swan"
--[[AUTO]]  ,"clk_turnswan"
--[[AUTO]]  ,"get_rose2"
--[[AUTO]]  ,"use_fiddlestick"
--[[AUTO]]  ,"get_amuletlizard3"
--[[AUTO]]  ,"get_belt"
--[[AUTO]]  ,"use_scissors_belt"
--[[AUTO]]  ,"get_latch"
--[[AUTO]]  ,"use_latch"
--[[AUTO]]  ,"opn_suitcase"
--[[AUTO]]  ,"win_suitcase"
--[[AUTO]]  ,"get_amuletlizard4"
--[[AUTO]]  ,"use_amuletlizard"
--[[AUTO]]  ,"get_chip"
--[[AUTO]]  ,"get_hammer"
--[[AUTO]]  ,"get_nails"
--[[AUTO]]  ,"use_chip"
--[[AUTO]]  ,"win_hidingplace"
--[[AUTO]]  ,"get_crystalball2"
--[[AUTO]]  ,"use_crystalball1"
--[[AUTO]]  ,"use_crystalball2"
--[[AUTO]]  ,"get_bedroomkey"
--[[AUTO]]  ,"use_bedroomkey"
--[[AUTO]]  ,"clk_bedroomdoor"
--[[AUTO]]  ,"opn_bedroom"
--[[AUTO]]--  ,"clk_gag"
--[[AUTO]]  ,"use_scissors_bedroom"
--[[AUTO]]  ,"dlg_bedroom_elizabeth4"
--[[AUTO]]  ,"use_familyamulet"
--[[AUTO]]  ,"dlg_bedroom_elizabeth5"
--[[AUTO]]  ,"get_shardpictures2"
--[[AUTO]]  ,"get_boxcase"
--[[AUTO]]  ,"get_waistbag"
--[[AUTO]]  ,"use_needlethread_carpet"
--[[AUTO]]  ,"win_carpetmg"
--[[AUTO]]  ,"get_amuletowl"
--[[AUTO]]  ,"use_amuletowl"
--[[AUTO]]  ,"get_shardpictures3"
--[[AUTO]]  ,"use_shardpictures"
--[[AUTO]]  ,"get_earlstamp"
--[[AUTO]]  ,"clk_earlstamp"
--[[AUTO]]  ,"get_lionfang"
--[[AUTO]]  ,"use_lionfang"
--[[AUTO]]  ,"get_hammerhandle"
--[[AUTO]]  ,"use_hammerhandle"
--[[AUTO]]  ,"get_hammerfull"
--[[AUTO]]  ,"use_handlebox"
--[[AUTO]]  ,"use_nails"
--[[AUTO]]  ,"use_hammerfull"
            ,"clk_fireplacebox1"
--[[AUTO]]  ,"get_hallkey"
--[[AUTO]]  ,"use_hallkey"
            ,"clk_hallkeydoor"
--[[AUTO]]  ,"opn_hall"
--[[AUTO]]  ,"get_rubyapple"
--[[AUTO]]  ,"get_silvershard"
--[[AUTO]]  ,"get_portraitpart1"
--[[AUTO]]  ,"get_medallion1"
--[[AUTO]]  ,"use_rubyapple"
--[[AUTO]]  ,"get_goldshard"
--[[AUTO]]  ,"get_portraitpart2"
--[[AUTO]]  ,"use_silvershard"
--[[AUTO]]  ,"use_goldshard"
--[[AUTO]]  ,"get_amuleteye"
--[[AUTO]]  ,"use_numeral"
--[[AUTO]]  ,"use_numeral2"
--[[AUTO]]  ,"win_clockmg"
--[[AUTO]]  ,"get_grapes"
--[[AUTO]]  ,"use_amuleteye"
--[[AUTO]]  ,"get_folio"
--[[AUTO]]  ,"get_bank"
--[[AUTO]]  ,"use_grapes"
--[[AUTO]]  ,"get_medallion2"
--[[AUTO]]  ,"get_earlion"
--[[AUTO]]  ,"use_earlion"
--[[AUTO]]  ,"get_piececrystal"
--[[AUTO]]  ,"get_chimeraeye1"
--[[AUTO]]  ,"use_bank"
--[[AUTO]]  ,"get_coalbank"
--[[AUTO]]  ,"use_piececrystal"
--[[AUTO]]  ,"opn_crystalho"
--[[AUTO]]  ,"win_crystalho"
--[[AUTO]]  ,"use_signet_bedroomflowers"
--[[AUTO]]  ,"get_staramulet"
--[[AUTO]]  ,"use_staramulet"
--[[AUTO]]  ,"use_scissors_folio"
--[[AUTO]]  ,"get_portraitstorm"
--[[AUTO]]  ,"use_signet_scryingcorner"
--[[AUTO]]  ,"get_redpaint"
--[[AUTO]]  ,"get_cherry"
--[[AUTO]]  ,"use_cherry"
--[[AUTO]]  ,"get_medallion3"
            ,"clk_scryingcorner"
--[[AUTO]]  ,"use_medallion"
--[[AUTO]]  ,"get_hexahedron"
            ,"get_chimeraeye2"
--[[AUTO]]  ,"use_hexahedron"
--[[AUTO]]  ,"use_shawl"
--[[AUTO]]  ,"get_portraitpart3"
--[[AUTO]]  ,"get_pinkpaint"
--[[AUTO]]  ,"use_redpaint"
--[[AUTO]]  ,"use_pinkpaint"
--[[AUTO]]  ,"win_paintmmg"
--[[AUTO]]  ,"get_dragonfly"
--[[AUTO]]  ,"use_dragonfly"
--[[AUTO]]  ,"get_keylock"
--[[AUTO]]  ,"use_keylock"
--[[AUTO]]  ,"opn_yard"
--[[AUTO]] -- ,"dlg_yard_gerald"
--[[AUTO]] -- ,"get_chimeraeye2"
--[[AUTO]]  ,"use_chimeraeye1"
--[[AUTO]]  ,"use_chimeraeye2"
--[[AUTO]]  ,"get_monogramdk"
--[[AUTO]]  ,"clk_vidchimera"
--[[AUTO]]  ,"use_monogramdk"
--[[AUTO]]  ,"get_greenstone"
--[[AUTO]]  ,"get_rose3"
--[[AUTO]]  ,"use_rose"
--[[AUTO]]  ,"get_vignette"
--[[AUTO]]  ,"use_portraitpart"
--[[AUTO]]  ,"get_williamportrait"
--[[AUTO]]  ,"use_coalbank"
--[[AUTO]]  ,"use_portraitstorm"
--[[AUTO]]  ,"use_williamportrait"
--[[AUTO]]  ,"use_greenstone"
--[[AUTO]] -- ,"win_potion"
--[[AUTO]]  ,"get_magicdust"
--[[AUTO]]  ,"use_magicdust"
            ,"clk_outrolvl3"
  };



  game.relations = {};

 --{ prg_true; prg_false; };
game.level_tasks = {
  "opn_house";
  "clk_anmhouse1";
  "win_barn_task";
  "opn_ruralroad";
  "clk_attack";
  "clk_williamgoaway";
  "clk_escape";
  
  "clk_anmcoach1";
  "clk_raid";
  "opn_darkquarter";
  "get_keystar";
  "get_paddle";
  "use_paddle";  
  "clk_anmladder";
  
  "clk_anmjail";
  "dlg_jail_storm1";
  "opn_corridor";
  "clk_shouts";
  "dlg_bedroom_elizabeth5";
  "get_magicdust"
  
};

end;

function Test ()

  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;


--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------tutorial----------------------------------------------

function private.TutorInit()

----------------------progress for tutorial
  game.tutorial_progress =
  {
    ["tutorial_question"]     = { uncecked = true, lock = 1, pos_x = 500, pos_y = 180 }
    ,["tutorial_zz"]          = { pos_x = 523, pos_y = 100, tut_arrows= {{pos_x =    0, pos_y =  250, ang =  3.14}} }
    ,["tutorial_get"]         = { pos_x = 512, pos_y = 250, tut_arrows= {{pos_x = -160, pos_y =  220, ang =  3.14}} }
    ,["tutorial_use"]         = { pos_x = 500, pos_y = 430, tut_arrows= {{pos_x = -280, pos_y =  200, ang =  3.14}} }   
    ,["tutorial_mg"]          = { pos_x = 580, pos_y = 450, tut_arrows= {{pos_x =  290, pos_y =   40, ang =  4.71}, {pos_x =  -450, pos_y =   160, ang =  2.35}} }
    ,["tutorial_hosparkles"]  = { gamemode_custom = "sparkle_area",pos_x = 550, pos_y = 230, tut_arrows= {{pos_x =  250, pos_y =  140, ang =  3.92}} }    
    ,["tutorial_ho"]          = { pos_x = 512, pos_y = 350, tut_arrows= {{pos_x =    0, pos_y =  250, ang =  3.14}} }
    ,["tutorial_hint"]        = { gamemode_custom = "hint", pos_x = 450, pos_y = 440, tut_arrows= {{pos_x = -300, pos_y =  140, ang =  2.36}} }    
    ,["tutorial_deploy"]      = { gamemode_custom = "plus_inv",pos_x = 500, pos_y = 430, tut_arrows= {{pos_x = -280, pos_y =  200, ang =  3.14}} }
    ,["tutorial_dialog"]      = { pos_x = 523, pos_y = 100, tut_arrows= {{pos_x =    0, pos_y =  250, ang =  3.14}} }
    --,["tutorial_use2"]        = { pos_x = 410, pos_y = 430, tut_arrows= {{pos_x = -160, pos_y =  200, ang =  3.14}, {pos_x =  290, pos_y =    10, ang =  4.84}} }
    ,["tutorial_task"]        = { pos_x = 620, pos_y = 391, tut_arrows= {{pos_x =  150, pos_y =  190, ang =  3.74}} }
    

    ,["tutorial_map1"]        = { pos_x = 550, pos_y = 400, tut_arrows= {{pos_x = 300, pos_y =  180, ang =  3.92}} }
    ,["tutorial_map2"]        = { pos_x = 600, pos_y = 200 }

    ,["tutorial_navigation"]  = { pos_x = 680, pos_y = 140, tut_arrows= {{pos_x = -240, pos_y =  130, ang =  3.04}} }
    ,["tutorial_ach"]         = { special = true, pos_x = 512, pos_y = 300, tut_arrows= {{pos_x = -300, pos_y = -50, ang = 0.785}} }
    ,["tutorial_puzzle"]      = { special = true, pos_x = 512, pos_y = 300, tut_arrows= {{pos_x = -300, pos_y = -50, ang = 0.785}} }
    ,["tutorial_morph"]       = { special = true, pos_x = 512, pos_y = 300, tut_arrows= {{pos_x = -300, pos_y = -50, ang = 0.785}} }
--SPECIAL FEATURES
    ,["tutorial_newho1"]= { special = true, pos_x = 512, pos_y = 350, tut_arrows= {{pos_x = 0, pos_y = 250, ang = 3.14}} }
    ,["tutorial_newho2_1"]= { special = true, pos_x = 277, pos_y = 380, tut_arrows= {{pos_x = 210, pos_y = 240, ang = 3.24}, {pos_x = 260, pos_y = 120, ang = -0.66}} }
    ,["tutorial_newho2_2"]= { special = true, pos_x = 362, pos_y = 200, tut_arrows= {{pos_x = 180, pos_y = 200, ang = 3.94}} }
    ,["tutorial_newho2_3"]= { special = true, pos_x = 512, pos_y = 350, tut_arrows= {{pos_x = 0, pos_y = 250, ang = 3.14}, {pos_x = -160, pos_y = -150, ang = 6.54}} }
    ,["tutorial_newho3"]= { special = true, pos_x = 512, pos_y = 350, tut_arrows= {{pos_x = 0, pos_y = 250, ang = 3.14}} }
  };
  
  for i,o in pairs(game.tutorial_progress) do

    table.insert(   game.progress_names, i );

    level[ i ] = {}
  end;
--level.tutorial_question.first()
--level.tutorial_zz.first()
--level.tutorial_get.first()
--level.tutorial_deploy.first()
--level.tutorial_use.first()
--level.tutorial_mg.first()
--level.tutorial_use2.first()
--level.tutorial_task.first()
--level.tutorial_hint.first()
--level.tutorial_navigation.first()
--level.tutorial_map1.first()
--level.tutorial_map2.first()
--level.tutorial_hosparkles.first()
--level.tutorial_ach.first()
--level.tutorial_puzzle.first()
--level.tutorial_morph.first()
--level.tutorial_newho1.first()
--level.tutorial_newho2.first()
--level.tutorial_newho3.first()

   level.tutorial_current = "";

----------------------------------------------------------------------------------------
  function private.TutorialShow(name, offset) -- set current and Show

 
    if game.tutorial_progress[name].uncecked or ( private.TutorialGameModeCheck( name ) ) 
      and (private.CheckTutorialGmdC(name)) then
      
      if level.tutorial_current and (level.tutorial_current == "tutorial_puzzle" or 
                                     level.tutorial_current == "tutorial_morph" or 
                                     level.tutorial_current == "tutorial_ach") then
        ObjSet( "tmr_int_panel_notification", {playing = 1} );
      end
      level.tutorial_current = name;
      local tut_params = game.tutorial_progress[name];
      if offset then
        for i = 1,#offset-1 do
          tut_params.tut_arrows[i].pos_x = tut_params.tut_arrows[i].pos_x + offset[i+1];
        end
        tut_params.pos_x = tut_params.pos_x + offset[1]
      end
      interface.TutorialShow( "str_"..name, tut_params.lock, tut_params.pos_x, tut_params.pos_y, tut_params.tut_arrows );

      return true
    else
      return false
    end
  end
  
  function private.CheckTutorialGmdC(name)
    if ng_global.gamemode == 3 then
      local gmdc = game.tutorial_progress[name].gamemode_custom
      if not gmdc or ( gmdc and ng_global.gamemode_custom[gmdc] ) then
        return true 
      else 
        return false 
      end
    else 
      return true 
    end
  end
  function private.TutorialHide() -- set current nil and Hide
    cmn.SetEventDone( level.tutorial_current );
    level.tutorial_current = nil
    interface.TutorialHide();
  end

  function public.TutorialDisable() -- skip tutor all
    level.tutorial_current = nil
    for i,o in pairs(game.tutorial_progress) do

      cmn.SetEventDone( i );

    end;

  end;

  function public.TutorialSpecialDisable() --  вырубает только стандартные
    -- ld.LogTrace( level.tutorial_current );
    if level.tutorial_current == "tutorial_puzzle" or 
       level.tutorial_current == "tutorial_morph" or 
       level.tutorial_current == "tutorial_ach" then 
       ObjSet( "tmr_int_panel_notification", {playing = 1} );
    end
    level.tutorial_current = nil
    for i,o in pairs(game.tutorial_progress) do

      if not o.special then
        cmn.SetEventDone( i );
      end

    end;
    level.tutorial_sp_skiped = true
  end;

  function private.TutorialGameModeCheck(tutorial_name)  -- проверка на кастом режим и выключен ли туториал
    if ng_global.gamemode == 3 and not ng_global.gamemode_custom["tutorial"] then
      cmn.SetEventDone(tutorial_name)
    end
    if not cmn.IsEventDone(tutorial_name) and cmn.IsEventDone( "tutorial_question" ) then
      return true
    else
      return false
    end
  end
----------------------------------------------------------------------------------------
  function public.tutorial_question.first()

    if ( ng_global.gamemode == 0 ) or (ng_global.gamemode == 3) then

      if ng_global.gamemode == 3 and not ng_global.gamemode_custom["tutorial"] then  --
        for i,o in pairs(game.tutorial_progress) do
          cmn.SetEventDone( i );
        end;
      end

      if  ( cmn.IsEventDone( "opn_house" ) )
      and ( not cmn.IsEventDone( "tutorial_question" ) )
      then
        private.TutorialShow("tutorial_question");
      end;

    else
      level.TutorialDisable();
    end;

  end;

  function public.tutorial_question.click() -- событие по клику на да
    private.TutorialHide()
    ld.Lock(1)
    ld.StartTimer( 0.3, function() ld.Lock(0);level.tutorial_zz.first() end )
  end
  function public.tutorial_question.click_no() --не обязательно
    --some code
    interface.TutorialHide();
    level.TutorialDisable();

  end
--------------------------------------------------------------------------------------------
  function public.tutorial_zz.first()
      if  ( cmn.IsEventDone( "tutorial_question" ) ) then
        private.TutorialShow("tutorial_zz");
      end
  end

  function public.tutorial_zz.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_get.first()
      private.TutorialShow("tutorial_get");
  end

  function public.tutorial_get.click()
    private.TutorialHide()
    public.tutorial_use.first()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_use.first()
      if ld.CheckRequirements( {"get_palette"} ) then
        local offset = ObjGet("hub_int_inventory_palette") and ObjGet("hub_int_inventory_palette").pos_x
        private.TutorialShow("tutorial_use",{0,offset});
      end
  end

  function public.tutorial_use.click()

    private.TutorialHide()
    
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_mg.first()
      if  ( cmn.IsEventStart( "win_fencepuzzle" ) ) then
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        private.TutorialShow("tutorial_mg",{offset,1,-2*offset});
      end
  end

  function public.tutorial_mg.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
  function public.tutorial_hosparkles.first()
      if  ( cmn.IsEventDone( "clk_anmhouse1" ) ) then
        private.TutorialShow("tutorial_hosparkles");
      end
  end

  function public.tutorial_hosparkles.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_ho.first()
      if ld.CheckRequirements( {"tutorial_question"} ) then
        private.TutorialShow("tutorial_ho");
      end
  end

  function public.tutorial_ho.click()

    private.TutorialHide()
    --ld.LockRm(1)
    ld.StartTimer( 0.6, function() level.tutorial_hint.first() end )
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_hint.first()
    if  ( cmn.IsEventDone( "tutorial_ho" ) ) and GetCurrentRoom() == "ho_barn" then
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        private.TutorialShow("tutorial_hint",{-offset});
      end
  end

  function public.tutorial_hint.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_dialog.first()
      if  ( cmn.IsEventDone( "tutorial_question" ) ) then
        private.TutorialShow("tutorial_dialog");
      end
  end

  function public.tutorial_dialog.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_task.first()
      if  ( cmn.IsEventDone( "use_hearth" ) ) then
        private.TutorialShow("tutorial_task")
        int_inventory_impl.TempLock(true)
      end
  end

  function public.tutorial_task.click()
    int_inventory_impl.TempLock(false)
    private.TutorialHide()
    ld.LockRm(1)
    ld.StartTimer( 0.3, function() ld.LockRm(0) level.tutorial_hint.first() end )
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_navigation.first()
      if  ( cmn.IsEventDone( "clk_gate" ) ) then
        private.TutorialShow("tutorial_navigation");
      end
  end

  function public.tutorial_navigation.click()
    private.TutorialHide()
  end

--------------------------------------------------------------------------------------------
  function public.tutorial_map1.first()
      if  ( cmn.IsEventDone( "opn_farm" ) ) then
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        private.TutorialShow("tutorial_map1",{offset});
      end
  end

  function public.tutorial_map1.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_map2.first()
    if  ( cmn.IsEventDone( "tutorial_question" ) and cmn.IsEventDone( "opn_farm" )) then
        private.TutorialShow("tutorial_map2");
      end
  end

  function public.tutorial_map2.click()
    private.TutorialHide()
    cmn.SetEventDone( "tutorial_map1" );
    
  end

--------------------------------------------------------------------------------------------
  function public.tutorial_deploy.first()
      if  ( cmn.IsEventDone( "win_barn" ) ) then
        local offset = ObjGet("hub_int_inventory_amulet") and ObjGet("hub_int_inventory_amulet").pos_x
        private.TutorialShow("tutorial_deploy",{0,offset});
      end
  end

  function public.tutorial_deploy.click()
      private.TutorialHide()
  end
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
  function private.tutorial_notification_first(type)
    if  ( cmn.IsEventDone( "tutorial_question" ) ) then
      local func_end = function()
        if level.tutorial_current == type then
          ObjSet( "tmr_int_panel_notification", {playing = 0} );
        end
      end
      if private.TutorialShow(type) then
        ld.StartTimer( "tmr_tutorial_panel_notification", 0.7 , func_end )
      end
    end
  end

  function private.tutorial_notification_click()
    ObjSet( "tmr_int_panel_notification", {playing = 1} );
    private.TutorialHide()
  end
  function private.tutorial_notification_click_no()
    private.TutorialHide()
    ObjSet( "tmr_int_panel_notification", {playing = 1} );
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_ach.first()
    private.tutorial_notification_first("tutorial_ach")
  end

  function public.tutorial_ach.click()
    private.tutorial_notification_click()
  end
  function public.tutorial_ach.click_no()
    private.tutorial_notification_click_no()
  end  
--------------------------------------------------------------------------------------------
  function public.tutorial_puzzle.first()
    private.tutorial_notification_first("tutorial_puzzle")
  end

  function public.tutorial_puzzle.click()
    private.tutorial_notification_click()
  end
  function public.tutorial_puzzle.click_no()
    private.tutorial_notification_click_no()
  end   
--------------------------------------------------------------------------------------------
  function public.tutorial_morph.first()
    private.tutorial_notification_first("tutorial_morph")
  end

  function public.tutorial_morph.click()
    private.tutorial_notification_click()
  end
  function public.tutorial_morph.click_no()
    private.tutorial_notification_click_no()
  end   
--------------------------------------------------------------------------------------------
--                SPECIAL FEATURES
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
  function public.tutorial_newho1.first()
      if  ( cmn.IsEventDone( "tutorial_newho1" ) ) then
        private.TutorialShow("tutorial_newho1");
      end
  end

  function public.tutorial_newho1.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
  function public.tutorial_newho2_1.first()
      if  ( cmn.IsEventDone( "tutorial_newho2_1" ) ) then
        private.TutorialShow("tutorial_newho2_1");
      end
  end

  function public.tutorial_newho2_1.click()
    private.TutorialHide()
    --ld.LockRm(1)
    --ld.StartTimer( 0.3, function() ld.LockRm(0) level.tutorial_newho2_2.first() end )    
  end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
  function public.tutorial_newho2_2.first()
      if  ( cmn.IsEventDone( "tutorial_newho2_2" ) ) then
        private.TutorialShow("tutorial_newho2_2");
      end
  end

  function public.tutorial_newho2_2.click()
    private.TutorialHide()
    --ld.LockRm(1)
    --ld.StartTimer( 0.3, function() ld.LockRm(0) level.tutorial_newho2_3.first() end )        
  end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
  function public.tutorial_newho2_3.first()
      if  ( cmn.IsEventDone( "tutorial_newho2_3" ) ) then
        private.TutorialShow("tutorial_newho2_3");
      end
  end

  function public.tutorial_newho2_3.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
  function public.tutorial_newho3.first()
      if  ( cmn.IsEventDone( "tutorial_newho3" ) ) then
        private.TutorialShow("tutorial_newho3");
      end
  end

  function public.tutorial_newho3.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------


end