-- name=rm_cellar
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cellar";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_cellar()
  if not ( cmn.IsEventDone( "opn_cellar" ) ) then
    SoundTheme( "aud_danger_moment1_mus" );
    cmn.SetEventDone( "opn_cellar" );
    cmn.CallEventHandler( "opn_cellar" )
    ld.ShowBbt("opn_cellar");
    ld.AnimPlay("anm_cellar_anm_back_mouse_click","mouse", function() ObjSet( "anm_cellar_anm_back_mouse_click", {animfunc = "mouse_static", playing = 1, looped = 1} );  end)
  end;
end;
--------------------------------------------------------------------
local opn_cellar = function() end;
local opn_cellar_logic = function()  end;
cmn.AddSubscriber( "opn_cellar", opn_cellar_logic )
cmn.AddSubscriber( "opn_cellar", opn_cellar, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_furnace *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_knittingneedles_furnace" ] = { type = "use", inv_obj = "inv_knittingneedles", use_place = "gfx_furnace_knittingneedles_furnace_zone", room = "rm_cellar", zz = "zz_furnace", zz_gate = "gzz_cellar_furnace" };

private.use_knittingneedles_furnace_logic = function()
  ObjSet( "spr_furnace_amuletmouse", { input = 1 } )

end;
private.use_knittingneedles_furnace_inv = function()
  common_impl.ProcessMultiUseAll("knittingneedles", "knittingneedles_furnace")
end;
private.use_knittingneedles_furnace_beg = function()
  ObjDelete( "gfx_furnace_knittingneedles_furnace_zone" );
end;
private.use_knittingneedles_furnace_end = function()
  if common_impl.ZzCompleteCheck("use_knittingneedles_furnace") then ObjSet( common_impl.hint["use_knittingneedles_furnace"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_furnace_anm_furnace_mouse", {animfunc = "end_mouse", frame = 0 } );
  ObjSet( "gfx_furnace_amuletmouse", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_knittingneedles_furnace", private.use_knittingneedles_furnace_inv );
cmn.AddSubscriber( "use_knittingneedles_furnace", private.use_knittingneedles_furnace_beg, private.room_objname );
cmn.AddSubscriber( "use_knittingneedles_furnace", private.use_knittingneedles_furnace_end, private.room_objname );
cmn.AddSubscriber( "use_knittingneedles_furnace", private.use_knittingneedles_furnace_logic );
cmn.AddSubscriber( "use_knittingneedles_furnace_inv", private.use_knittingneedles_furnace_inv, private.room_objname );
cmn.AddSubscriber( "use_knittingneedles_furnace_beg", private.use_knittingneedles_furnace_beg, private.room_objname );
cmn.AddSubscriber( "use_knittingneedles_furnace_end", private.use_knittingneedles_furnace_end, private.room_objname );
cmn.AddSubscriber( "use_knittingneedles_furnace_end", private.use_knittingneedles_furnace_logic );
--------------------------------------------------------------------------------------------
function public.use_knittingneedles_furnace( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_knittingneedles_furnace" );
    cmn.CallEventHandler( "use_knittingneedles_furnace_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_knittingneedles_furnace") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_knittingneedles_furnace_inv" );
  cmn.CallEventHandler( "use_knittingneedles_furnace_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_furnace_anm_furnace_mouse", "use_spoke", func_end );
  SoundSfx( "aud_use_spokes_fireplace" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletmouse" ] = { type = "get", get_obj = "spr_furnace_amuletmouse", room = "rm_cellar", zz = "zz_furnace", zz_gate = "gzz_cellar_furnace" };

private.get_amuletmouse_logic = function()
  
end;
private.get_amuletmouse_inv = function()
  interface.InventoryItemAdd("inv_amuletmouse","spr_furnace_amuletmouse");
end;
private.get_amuletmouse_beg = function()
  ObjDelete("gfx_furnace_amuletmouse")
end;
private.get_amuletmouse_end = function()
  if common_impl.ZzCompleteCheck("get_amuletmouse") then ObjSet( common_impl.hint["get_amuletmouse"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_furnace_anm_furnace_mouse");
end;

cmn.AddSubscriber( "get_amuletmouse", private.get_amuletmouse_inv );
cmn.AddSubscriber( "get_amuletmouse", private.get_amuletmouse_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletmouse", private.get_amuletmouse_end, private.room_objname );
cmn.AddSubscriber( "get_amuletmouse", private.get_amuletmouse_logic );
--------------------------------------------------------------------
function public.get_amuletmouse()
  ObjSet( "spr_furnace_amuletmouse", { visible = 1 } )
  cmn.SetEventDone( "get_amuletmouse" );
  cmn.CallEventHandler( "get_amuletmouse" );
  if common_impl.ZzCompleteCheck("get_amuletmouse") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_amuletmouse()

  local func_end = function()
    common_impl.ShowBbt( 'need_knittingneedles_furnace' );
    ld.Lock(0);
  end;
  ld.Lock(1);
  SoundSfx( "aud_touch_mouse_figure_fireplace" );
  ld.AnimPlay( "anm_furnace_anm_furnace_mouse", "idle_mouse", func_end );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "use_candle" ] = { type = "use", inv_obj = "inv_candle", use_place = "gfx_furnace_candle_zone", room = "rm_cellar", zz = "zz_furnace", zz_gate = "gzz_cellar_furnace" };

private.use_candle_logic = function()
  ObjSet( "spr_furnace_lightedcandle", { visible = 1, input = 1 } )

end;
private.use_candle_inv = function()
  common_impl.ProcessMultiUseAll("candle", "candle")
end;
private.use_candle_beg = function()
  ObjDelete( "gfx_furnace_candle_zone" );
end;
private.use_candle_end = function()
  if common_impl.ZzCompleteCheck("use_candle") then ObjSet( common_impl.hint["use_candle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_furnace_anm_furnace_candle");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_candle", private.use_candle_inv );
cmn.AddSubscriber( "use_candle", private.use_candle_beg, private.room_objname );
cmn.AddSubscriber( "use_candle", private.use_candle_end, private.room_objname );
cmn.AddSubscriber( "use_candle", private.use_candle_logic );
cmn.AddSubscriber( "use_candle_inv", private.use_candle_inv, private.room_objname );
cmn.AddSubscriber( "use_candle_beg", private.use_candle_beg, private.room_objname );
cmn.AddSubscriber( "use_candle_end", private.use_candle_end, private.room_objname );
cmn.AddSubscriber( "use_candle_end", private.use_candle_logic );
--------------------------------------------------------------------------------------------
function public.use_candle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_candle" );
    cmn.CallEventHandler( "use_candle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_candle") then ld.CloseSubRoom() end;
    if common_impl.ZzCompleteCheck("get_lightedcandle") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_candle_inv" );
  cmn.CallEventHandler( "use_candle_beg" );
  common_impl.Lock(1);
  
  ld.StartTimer( 3.25, function() cmn.SetEventDone( "get_lightedcandle" ); cmn.CallEventHandler( "get_lightedcandle" ); end )
  ld.AnimPlay( "anm_furnace_anm_furnace_candle", "use_lightedcandle", func_end );
  SoundSfx( "aud_use_candle_fireplace" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lightedcandle" ] = { type = "get", get_obj = "spr_furnace_lightedcandle", room = "rm_cellar", zz = "zz_furnace", zz_gate = "gzz_cellar_furnace" };

private.get_lightedcandle_logic = function()
  
end;
private.get_lightedcandle_inv = function()
  interface.InventoryItemAdd("inv_lightedcandle","spr_furnace_lightedcandle");
end;
private.get_lightedcandle_beg = function()
  ObjDelete("gfx_furnace_lightedcandle")
end;
private.get_lightedcandle_end = function()
  if common_impl.ZzCompleteCheck("get_lightedcandle") then ObjSet( common_impl.hint["get_lightedcandle"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lightedcandle", private.get_lightedcandle_inv );
cmn.AddSubscriber( "get_lightedcandle", private.get_lightedcandle_beg, private.room_objname );
cmn.AddSubscriber( "get_lightedcandle", private.get_lightedcandle_end, private.room_objname );
cmn.AddSubscriber( "get_lightedcandle", private.get_lightedcandle_logic );
--------------------------------------------------------------------
function public.get_lightedcandle()
  cmn.SetEventDone( "get_lightedcandle" );
  cmn.CallEventHandler( "get_lightedcandle" );
  if common_impl.ZzCompleteCheck("get_lightedcandle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_commode *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_roundkey" ] = { type = "use", inv_obj = "inv_roundkey", use_place = "gfx_commode_roundkey_zone", room = "rm_cellar", zz = "zz_commode", zz_gate = "gzz_cellar_commode" };

private.use_roundkey_logic = function()
  ObjSet( "gho_cellar_commodeho", { visible = 1, input = 1, active = 1 } )

end;
private.use_roundkey_inv = function()
  common_impl.ProcessMultiUseAll("roundkey", "roundkey")
end;
private.use_roundkey_beg = function()
  ObjDelete( "gfx_commode_roundkey_zone" );
end;
private.use_roundkey_end = function()
  if common_impl.ZzCompleteCheck("use_roundkey") then ObjSet( common_impl.hint["use_roundkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_cellar_tr_open_box1", {visible = 1} );
  ObjSet( "spr_cellar_tr_open_box2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_roundkey", private.use_roundkey_inv );
cmn.AddSubscriber( "use_roundkey", private.use_roundkey_beg, private.room_objname );
cmn.AddSubscriber( "use_roundkey", private.use_roundkey_end, private.room_objname );
cmn.AddSubscriber( "use_roundkey", private.use_roundkey_logic );
cmn.AddSubscriber( "use_roundkey_inv", private.use_roundkey_inv, private.room_objname );
cmn.AddSubscriber( "use_roundkey_beg", private.use_roundkey_beg, private.room_objname );
cmn.AddSubscriber( "use_roundkey_end", private.use_roundkey_end, private.room_objname );
cmn.AddSubscriber( "use_roundkey_end", private.use_roundkey_logic );
--------------------------------------------------------------------------------------------
function public.use_roundkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_roundkey" );
    cmn.CallEventHandler( "use_roundkey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_roundkey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_roundkey_inv" );
  cmn.CallEventHandler( "use_roundkey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_commode_anm", "use_key", function() ld.AnimPlay( "anm_commode_anm", "use_key1", func_end ); end );
  SoundSfx( "aud_use_key_commode" );
  --func_end()

end;

function public.clk_roundkey()

  local func_end = function()
  common_impl.ShowBbt( 'need_roundkey' );
    ld.Lock(0);
  end;
  ld.Lock(1);
  ld.AnimPlay( "anm_commode_anm", "idle_cover", func_end );
  SoundSfx( "aud_touch_drawer_commode" );
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_carpetbag *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_clasp()

  local func_end = function()
  common_impl.ShowBbt( 'need_clasp' );
    ld.Lock(0);
  end;
  ld.Lock(1);
  ld.AnimPlay( "anm_carpetbag_anm", "idle", func_end );
  SoundSfx( "aud_touch_lock_carpetbag" );
end;

common_impl.hint[ "use_clasp" ] = { type = "use", inv_obj = "inv_clasp", use_place = "gfx_carpetbag_clasp_zone", room = "rm_cellar", zz = "zz_carpetbag", zz_gate = "gzz_cellar_carpetbag" };

private.use_clasp_logic = function()
  ObjSet( "spr_carpetbag_saw", {  input = 1 } )
  ObjSet( "spr_carpetbag_nailpuller", { input = 1 } )
  ObjSet( "spr_carpetbag_canvasshovel", { input = 1 } )

end;
private.use_clasp_inv = function()
  common_impl.ProcessMultiUseAll("clasp", "clasp")
end;
private.use_clasp_beg = function()
  ObjDelete( "gfx_carpetbag_clasp_zone" );
end;
private.use_clasp_end = function()
  if common_impl.ZzCompleteCheck("use_clasp") then ObjSet( common_impl.hint["use_clasp"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_carpetbag_anm", {animfunc = "end_clasp", frame = 0 } );
  ObjSet( "spr_carpetbag_saw_tr", { visible = 1} );
  ObjSet( "spr_carpetbag_nailpuller_tr", { visible = 1 } );
  ObjSet( "spr_carpetbag_canvasshovel_tr", { visible = 1 } );
  ObjSet( "gfx_carpetbag_saw", { visible = 1} );
  ObjSet( "gfx_carpetbag_nailpuller", { visible = 1 } );
  ObjSet( "gfx_carpetbag_canvasshovel", { visible = 1 } );
  ObjSet( "spr_cellar_tr_open_carpetbag", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_clasp", private.use_clasp_inv );
cmn.AddSubscriber( "use_clasp", private.use_clasp_beg, private.room_objname );
cmn.AddSubscriber( "use_clasp", private.use_clasp_end, private.room_objname );
cmn.AddSubscriber( "use_clasp", private.use_clasp_logic );
cmn.AddSubscriber( "use_clasp_inv", private.use_clasp_inv, private.room_objname );
cmn.AddSubscriber( "use_clasp_beg", private.use_clasp_beg, private.room_objname );
cmn.AddSubscriber( "use_clasp_end", private.use_clasp_end, private.room_objname );
cmn.AddSubscriber( "use_clasp_end", private.use_clasp_logic );
--------------------------------------------------------------------------------------------
function public.use_clasp( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_clasp" );
    cmn.CallEventHandler( "use_clasp_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_clasp") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    ld.AnimPlay( "anm_carpetbag_anm", "use_clasp1", func_end );
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_clasp_inv" );
  cmn.CallEventHandler( "use_clasp_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_carpetbag_anm", "use_clasp", func_preend );
  SoundSfx( "aud_use_lock_carpetbag" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_saw" ] = { type = "get", get_obj = "spr_carpetbag_saw", room = "rm_cellar", zz = "zz_carpetbag", zz_gate = "gzz_cellar_carpetbag" };

private.get_saw_logic = function()
  
end;
private.get_saw_inv = function()
  interface.InventoryItemAdd("inv_saw","spr_carpetbag_saw");
end;
private.get_saw_beg = function()
  ObjDelete("gfx_carpetbag_saw")
end;
private.get_saw_end = function()
  if common_impl.ZzCompleteCheck("get_saw") then ObjSet( common_impl.hint["get_saw"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_carpetbag_saw_tr");
end;

cmn.AddSubscriber( "get_saw", private.get_saw_inv );
cmn.AddSubscriber( "get_saw", private.get_saw_beg, private.room_objname );
cmn.AddSubscriber( "get_saw", private.get_saw_end, private.room_objname );
cmn.AddSubscriber( "get_saw", private.get_saw_logic );
--------------------------------------------------------------------
function public.get_saw()
  ObjSet( "spr_carpetbag_saw", { visible = 1} );
  cmn.SetEventDone( "get_saw" );
  cmn.CallEventHandler( "get_saw" );
  if common_impl.ZzCompleteCheck("get_saw") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_nailpuller" ] = { type = "get", get_obj = "spr_carpetbag_nailpuller", room = "rm_cellar", zz = "zz_carpetbag", zz_gate = "gzz_cellar_carpetbag" };

private.get_nailpuller_logic = function()
  
end;
private.get_nailpuller_inv = function()
  interface.InventoryItemAdd("inv_nailpuller","spr_carpetbag_nailpuller");
end;
private.get_nailpuller_beg = function()
  ObjDelete("gfx_carpetbag_nailpuller")
end;
private.get_nailpuller_end = function()
  if common_impl.ZzCompleteCheck("get_nailpuller") then ObjSet( common_impl.hint["get_nailpuller"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_carpetbag_nailpuller_tr");

end;

cmn.AddSubscriber( "get_nailpuller", private.get_nailpuller_inv );
cmn.AddSubscriber( "get_nailpuller", private.get_nailpuller_beg, private.room_objname );
cmn.AddSubscriber( "get_nailpuller", private.get_nailpuller_end, private.room_objname );
cmn.AddSubscriber( "get_nailpuller", private.get_nailpuller_logic );
--------------------------------------------------------------------
function public.get_nailpuller()
  ObjSet( "spr_carpetbag_nailpuller", { visible = 1} );
  cmn.SetEventDone( "get_nailpuller" );
  cmn.CallEventHandler( "get_nailpuller" );
  if common_impl.ZzCompleteCheck("get_nailpuller") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_canvasshovel" ] = { type = "get", get_obj = "spr_carpetbag_canvasshovel", room = "rm_cellar", zz = "zz_carpetbag", zz_gate = "gzz_cellar_carpetbag" };

private.get_canvasshovel_logic = function()
  
end;
private.get_canvasshovel_inv = function()
  interface.InventoryItemAdd("inv_canvasshovel","spr_carpetbag_canvasshovel");
  ObjSet( "inv_canvasshovel", { drag = 0 } );
end;
private.get_canvasshovel_beg = function()
  ObjDelete("gfx_carpetbag_canvasshovel")
end;
private.get_canvasshovel_end = function()
  if common_impl.ZzCompleteCheck("get_canvasshovel") then ObjSet( common_impl.hint["get_canvasshovel"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_carpetbag_canvasshovel_tr");
end;

cmn.AddSubscriber( "get_canvasshovel", private.get_canvasshovel_inv );
cmn.AddSubscriber( "get_canvasshovel", private.get_canvasshovel_beg, private.room_objname );
cmn.AddSubscriber( "get_canvasshovel", private.get_canvasshovel_end, private.room_objname );
cmn.AddSubscriber( "get_canvasshovel", private.get_canvasshovel_logic );
--------------------------------------------------------------------
function public.get_canvasshovel()
  ObjSet( "spr_carpetbag_canvasshovel", { visible = 1} );
  cmn.SetEventDone( "get_canvasshovel" );
  cmn.CallEventHandler( "get_canvasshovel" );
  if common_impl.ZzCompleteCheck("get_canvasshovel") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------

function public.texture_clk()
  local func_end = function()
    ObjSet( "obj_cellar_texture_clk_zone", {input = 1} );
  end;
  ObjSet( "obj_cellar_texture_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_cellar_anm_back_texture", "anim_texture", func_end );
  SoundSfx( "aud_touch_curtain_cellar" )
end;

function public.wheel_clk()
  local func_end = function()
    ObjSet( "obj_cellar_wheel_clk_zone", {input = 1} );
  end;
  ObjSet( "obj_cellar_wheel_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_cellar_anm_back_wheel", "anim_wheel", func_end );
  SoundSfx( "aud_touch_wheel_cellar" );
end;

function public.board1_2_clk()
  local func_end = function()
    ObjSet( "obj_cellar_board1_2_clk_zone", {input = 1} );
  end;
  ObjSet( "obj_cellar_board1_2_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_cellar_anm_back_board1", "anim_board1", func_end );
  ld.AnimPlay( "anm_cellar_anm_back_board2", "anim_board2", func_end );
  SoundSfx( "aud_touch_boards_right_cellar" );
end;

function public.board3_4_clk()
  local func_end = function()
  ObjSet( "obj_cellar_board3_4_clk_zone", {input = 1} );
  end;
  ObjSet( "obj_cellar_board3_4_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_cellar_anm_back_board3", "anim_board3", func_end );
  ld.AnimPlay( "anm_cellar_anm_back_board4", "anim_board4", func_end );
  SoundSfx( "aud_touch_boards_left_cellar" );
end;

--local bool barrel_mouse = false;


function public.barrel_clk()
  local func_end = function()
    ObjSet( "obj_cellar_barrel_clk_zone", {input = 1} );
    ObjSet( "anm_cellar_anm_back_mouse_click", {animfunc = "mouse_clic", frame = 999, visible = 0 } );
    --ObjSet( "anm_cellar_anm_back_mouse_click", {animfunc = "mouse_static", playing = 0, looped = 0 });
   -- ld.AnimPlay( "anm_cellar_anm_back_mouse_click", "mouse_static", "" );
  end
  local func_preend = function()
    ld.StartTimer( 2, function()  ld.AnimPlay( "anm_cellar_anm_back_mouse_click", "mouse", func_end );   end )
  end;
  ObjSet( "obj_cellar_barrel_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_cellar_anm_back_barrel", "anim_barrel", func_end );
  ObjSet( "anm_cellar_anm_back_mouse_click", {animfunc = "mouse_static", playing = 0, looped = 0 });
  ld.AnimPlay( "anm_cellar_anm_back_mouse_click", "mouse_clic", func_end );
  
  
  SoundSfx( "aud_touch_barrel_cellar" )
end;


--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_commodeho_for_cellar = function()
    if ld.CheckRequirements( {"win_commodeho"} ) then
      ObjSet( "gho_cellar_commodeho", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_commodeho", win_commodeho_for_cellar, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_cellar();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_cellar_env" );
  SoundEnv("aud_cellar_fireplace_loc_env",1);
  if ld.CheckRequirements( {"opn_cellar"} ) then
    ObjSet( "anm_cellar_anm_back_mouse_click", {animfunc = "mouse_static", playing = 1, looped = 1, visible = 1} );
  end
  private.mouse_static();
end;
--*********************************************************************************************************************
function public.Close()
  ObjSet( "anm_cellar_anm_back_mouse_click", {animfunc = "mouse_static", playing = 0, looped = 0} );
  ObjSet("tmr_cellar_mouse",{playing = 0});
  AnimStop(private.mouse_cur);
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_carpetbag" );
  function zz_carpetbag.Open()
  end;
  function zz_carpetbag.PreOpen()
    
  end;
  function zz_carpetbag.PreClose()
  end;
  function zz_carpetbag.Close()
  end;

  subroom.Define( "zz_commode" );
  function zz_commode.Open()
  end;
  function zz_commode.PreOpen()
  end;
  function zz_commode.PreClose()
  end;
  function zz_commode.Close()
  end;

  subroom.Define( "zz_furnace" );
  function zz_furnace.Open()
  end;
  function zz_furnace.PreOpen()
    SoundEnv("aud_cellar_fireplace_loc_env",0);
    SoundEnv("aud_cellar_fireplace_zz_env",1);
  end;
  function zz_furnace.PreClose()
  end;
  function zz_furnace.Close()
    SoundEnv("aud_cellar_fireplace_loc_env",1);
    SoundEnv("aud_cellar_fireplace_zz_env",0);
  end;
  
end;
--*********************************************************************************************************************
local r = 1;
private.mouse_cur = ""
function private.mouse_static()
  local f_end = function ()
    ObjSet("tmr_cellar_mouse",{endtrig = function() private.mouse_static()end, playing = 1, time = math.random(5,10)});
    r = r + 1;
    if r > 2 then r = 1; end
  end
  --local r = math.random(2);
  
  for i = 1,2 do
    --ObjDetach("vid_neartower_horse_static_"..i)
  end
  private.mouse_cur = "anm_cellar_anm_back_mouse_"..r;
  SoundSfx( "aud_rat_run_cellar" );
  ld.AnimPlay(private.mouse_cur, "mouse"..r+1, f_end);
end