-- name=rm_darkquarter
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_darkquarter";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_darkquarter()
  if not ( cmn.IsEventDone( "opn_darkquarter" ) ) then
    cmn.SetEventDone( "opn_darkquarter" );
    cmn.CallEventHandler( "opn_darkquarter" )
    ld.ShowBbt("opn_darkquarter");
  end;
end;
--------------------------------------------------------------------
local opn_darkquarter = function() end;
local opn_darkquarter_logic = function() end;
cmn.AddSubscriber( "opn_darkquarter", opn_darkquarter_logic )
cmn.AddSubscriber( "opn_darkquarter", opn_darkquarter, private.room_objname )
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "bandit1" then
    if count_txt == 1 then

    elseif count_txt == 2 then
      ld.Lock(1);
      ld.AnimPlay( "anm_darkquarter_bandit1_character", "palm2", function() ld.Lock(0); end )
      SoundSfx( "aud_get_to_us" );
    elseif count_txt == 3 then  
      ObjSet( "spr_darkquarter_monogramen", {visible = 1} );
      ld.AnimPlay( "anm_darkquarter_bandit1_character", "palm1", "" )
      cmn.CallEventHandler( "get_monogramen" )
    end;  
  end
  if dlg_name == "bandit2" then
    if count_txt == 1 then
      ld.Lock(1);
      ObjSet( "anm_darkquarter_bandit2_character", {animfunc = "palm", frame = 0, playing=0 } );
      ld.StartTimer( 0.5, function() 
           ld.AnimPlay( "anm_darkquarter_bandit2_character", "palm", function() ld.Lock(0); end )
           SoundSfx( "aud_get_to_us" );
      end )
    elseif count_txt == 2 then
      ObjSet( "spr_darkquarter_bracelet", {visible = 1} );
      ld.AnimPlay( "anm_darkquarter_bandit2_character", "palm1", "" )
      cmn.CallEventHandler( "get_bracelet" )
    elseif count_txt == 3 then  

    end;  
  end
end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_darkquarter_bandit1" ] = { type = "click", use_place = "gfx_darkquarter_dlg_darkquarter_bandit1_zone", room = "rm_darkquarter" };

private.dlg_darkquarter_bandit1_logic = function()
  ObjSet( "spr_darkquarter_monogramen", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_darkquarter_dress_zone", { visible = 1, input = 1, active = 1 } );
  ObjSet( "gzz_darkquarter_cobblershop", { visible = 1, input = 1, active = 1 } );
  ObjSet( "gzz_darkquarter_ads", { visible = 1, input = 1, active = 1 } );
  ObjSet( "gzz_darkquarter_mansiondoor", { visible = 1, input = 1, active = 1 } );
  ObjSet( "gzz_darkquarter_monument", { visible = 1, input = 1, active = 1 } );
  ObjSet( "grm_darkquarter_swamp", {active=1, input = 1, visible = 1} );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_darkquarter_swamp_focus");
    end;
end;
private.dlg_darkquarter_bandit1_beg = function()
  ObjDelete( "gfx_darkquarter_dlg_darkquarter_bandit1_zone" );
end;
private.dlg_darkquarter_bandit1_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_darkquarter_bandit1", private.dlg_darkquarter_bandit1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_darkquarter_bandit1", private.dlg_darkquarter_bandit1_end, private.room_objname );
cmn.AddSubscriber( "dlg_darkquarter_bandit1", private.dlg_darkquarter_bandit1_logic );
cmn.AddSubscriber( "dlg_darkquarter_bandit1_beg", private.dlg_darkquarter_bandit1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_darkquarter_bandit1_end", private.dlg_darkquarter_bandit1_end, private.room_objname );
cmn.AddSubscriber( "dlg_darkquarter_bandit1_end", private.dlg_darkquarter_bandit1_logic );
--------------------------------------------------------------------------------------------

function public.dlg_darkquarter_bandit1( obj )

  local func_end = function()
    cmn.SetEventDone( "dlg_darkquarter_bandit1" );
    cmn.CallEventHandler( "dlg_darkquarter_bandit1_end" );
    cmn.SetEventDone( "get_monogramen" );
    common_impl.Lock(0);
    ld.ShowBbt("after_dlg_bandit1")
  end;

 
  function public.dlg_darkquarter_bandit1_end()
    ObjSet( "dlg_darkquarter_bandit1", {bake=1} );
    if ObjGetRelations( "inv_monogramen" ).parent == "level_inv_hub" then
      ObjSet( "spr_darkquarter_monogramen", {visible = 1} );
      cmn.CallEventHandler( "get_monogramen");      
    end
    common_impl.Lock(1);
    func_end()
  end
  
  cmn.CallEventHandler( "dlg_darkquarter_bandit1_beg" );
  
  --SoundSfx( 0 )
  common_impl.dialog_character_loc = "anm_darkquarter_girlthief"
  common_impl.continue_visible = false
  common_impl.Start( "bandit1", 3, nil, nil, true, "dlg_darkquarter_bandit1_end",{"aud_bandit_1_voc","aud_bandit_2_voc"});    

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_monogramen" ] = { type = "get", get_obj = "spr_darkquarter_monogramen", room = "rm_darkquarter" };

private.get_monogramen_logic = function()
  
end;
private.get_monogramen_inv = function()
  interface.InventoryItemAdd("inv_monogramen","spr_darkquarter_monogramen");
end;
private.get_monogramen_beg = function()
  ObjDelete("gfx_darkquarter_monogramen")
end;
private.get_monogramen_end = function()
  
end;

cmn.AddSubscriber( "get_monogramen", private.get_monogramen_inv );
cmn.AddSubscriber( "get_monogramen", private.get_monogramen_beg, private.room_objname );
cmn.AddSubscriber( "get_monogramen", private.get_monogramen_end, private.room_objname );
cmn.AddSubscriber( "get_monogramen", private.get_monogramen_logic );
--------------------------------------------------------------------
function public.get_monogramen()
  cmn.SetEventDone( "get_monogramen" );
  cmn.CallEventHandler( "get_monogramen" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dress" ] = { type = "use", inv_obj = "inv_dress", use_place = "gfx_darkquarter_dress_zone", room = "rm_darkquarter" };

private.use_dress_logic = function()
  ObjSet( "gfx_darkquarter_dlg_darkquarter_bandit2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_dress_inv = function()
  common_impl.ProcessMultiUseAll("dress", "dress")
end;
private.use_dress_beg = function()
  ObjDelete( "gfx_darkquarter_dress_zone" );
end;
private.use_dress_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dress", private.use_dress_inv );
cmn.AddSubscriber( "use_dress", private.use_dress_beg, private.room_objname );
cmn.AddSubscriber( "use_dress", private.use_dress_end, private.room_objname );
cmn.AddSubscriber( "use_dress", private.use_dress_logic );
cmn.AddSubscriber( "use_dress_inv", private.use_dress_inv, private.room_objname );
cmn.AddSubscriber( "use_dress_beg", private.use_dress_beg, private.room_objname );
cmn.AddSubscriber( "use_dress_end", private.use_dress_end, private.room_objname );
cmn.AddSubscriber( "use_dress_end", private.use_dress_logic );
--------------------------------------------------------------------------------------------
function public.use_dress( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    --cmn.SetEventDone( "use_dress" );
    cmn.CallEventHandler( "use_dress_end" );
    public.dlg_darkquarter_bandit2();
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dress_inv" );
  cmn.CallEventHandler( "use_dress_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_dress_darkquarter" );
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_darkquarter_bandit2" ] = { type = "click", use_place = "gfx_darkquarter_dlg_darkquarter_bandit2_zone", room = "rm_darkquarter" };

private.dlg_darkquarter_bandit2_logic = function()
  ObjSet( "spr_darkquarter_bracelet", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_darkquarter_bandit2_beg = function()
  ObjDelete( "gfx_darkquarter_dlg_darkquarter_bandit2_zone" );
end;
private.dlg_darkquarter_bandit2_end = function()
  ObjDelete("anm_darkquarter_girlthief");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_darkquarter_bandit2", private.dlg_darkquarter_bandit2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_darkquarter_bandit2", private.dlg_darkquarter_bandit2_end, private.room_objname );
cmn.AddSubscriber( "dlg_darkquarter_bandit2", private.dlg_darkquarter_bandit2_logic );
cmn.AddSubscriber( "dlg_darkquarter_bandit2_beg", private.dlg_darkquarter_bandit2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_darkquarter_bandit2_end", private.dlg_darkquarter_bandit2_end, private.room_objname );
cmn.AddSubscriber( "dlg_darkquarter_bandit2_end", private.dlg_darkquarter_bandit2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_darkquarter_bandit2( obj )

  local func_end = function()
    cmn.SetEventDone( "use_dress" );
    cmn.SetEventDone( "dlg_darkquarter_bandit2" );
    cmn.CallEventHandler( "dlg_darkquarter_bandit2_end" );
    cmn.SetEventDone( "get_bracelet" );
    common_impl.Lock(0);
    --  ld.ShowBbt("after_dlg_bandit2")
  end;

 
  function public.dlg_darkquarter_bandit2_end()
    ObjSet( "dlg_darkquarter_bandit2", {bake=1} );
    if ObjGetRelations( "inv_bracelet" ).parent == "level_inv_hub" then
      ObjSet( "spr_darkquarter_bracelet", {visible = 1} );
      cmn.CallEventHandler( "get_bracelet");      
    end
    common_impl.Lock(1);
    func_end()
  end
  
  cmn.CallEventHandler( "dlg_darkquarter_bandit2_beg" );
  
  --SoundSfx( 0 )
  common_impl.dialog_character_loc = "anm_darkquarter_girlthief"
  common_impl.continue_visible = false
  common_impl.Start( "bandit2", 2, nil, nil, true, "dlg_darkquarter_bandit2_end",{"aud_bandit_3_voc"});    

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bracelet" ] = { type = "get", get_obj = "spr_darkquarter_bracelet", room = "rm_darkquarter" };

private.get_bracelet_logic = function()
  
end;
private.get_bracelet_inv = function()
  interface.InventoryItemAdd("inv_bracelet","spr_darkquarter_bracelet");
end;
private.get_bracelet_beg = function()
  ObjDelete("gfx_darkquarter_bracelet")
end;
private.get_bracelet_end = function()
  
end;

cmn.AddSubscriber( "get_bracelet", private.get_bracelet_inv );
cmn.AddSubscriber( "get_bracelet", private.get_bracelet_beg, private.room_objname );
cmn.AddSubscriber( "get_bracelet", private.get_bracelet_end, private.room_objname );
cmn.AddSubscriber( "get_bracelet", private.get_bracelet_logic );
--------------------------------------------------------------------
function public.get_bracelet()
  cmn.SetEventDone( "get_bracelet" );
  cmn.CallEventHandler( "get_bracelet" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_mansiondoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_lily1" ] = { type = "get", get_obj = "spr_mansiondoor_lily1", room = "rm_darkquarter", zz = "zz_mansiondoor", zz_gate = "gzz_darkquarter_mansiondoor" };

private.get_lily1_logic = function()
   ObjSet( "gfx_mansiondoor_bullring_mansiondoor_zone", {active=1, input=1, visible=1} );
end;
private.get_lily1_inv = function()
  interface.InventoryItemAdd("inv_lily1","spr_mansiondoor_lily1");
end;
private.get_lily1_beg = function()
  ObjDelete("gfx_mansiondoor_lily1")
end;
private.get_lily1_end = function()
  if common_impl.ZzCompleteCheck("get_lily1") then ObjSet( common_impl.hint["get_lily1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_mansiondoor_anm", {animfunc = "use_ring", frame = 0 } );
end;

cmn.AddSubscriber( "get_lily1", private.get_lily1_inv );
cmn.AddSubscriber( "get_lily1", private.get_lily1_beg, private.room_objname );
cmn.AddSubscriber( "get_lily1", private.get_lily1_end, private.room_objname );
cmn.AddSubscriber( "get_lily1", private.get_lily1_logic );
cmn.AddSubscriber( "get_lily1_inv", private.get_lily1_inv );
cmn.AddSubscriber( "get_lily1_beg", private.get_lily1_beg, private.room_objname );
cmn.AddSubscriber( "get_lily1_end", private.get_lily1_end, private.room_objname );
cmn.AddSubscriber( "get_lily1_end", private.get_lily1_logic );
--------------------------------------------------------------------
function public.get_lily1()
  local func_end = function()
     ld.Lock(0); 
     ObjSet( "spr_mansiondoor_lily1", {pos_x=255, pos_y=308, visible=1} );
     cmn.CallEventHandler( "get_lily1_inv" );
     cmn.SetEventDone( "get_lily1" );
     cmn.CallEventHandler( "get_lily1_end" );
     if common_impl.ZzCompleteCheck("get_lily1") then ld.CloseSubRoom() end;
  end
  
  
  
  ld.Lock(1);
  cmn.CallEventHandler( "get_lily1_beg" );
  SoundSfx( "aud_touch_mansion_lock_luly" );
  ld.AnimPlay( "anm_mansiondoor_anm", "end_lily", func_end )
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
public.use_bullring_mansiondoor_zone_clk = function()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_bullring_mansiondoor' )
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_mansion_lock" );
  ld.AnimPlay( "anm_mansiondoor_anm", "idle", func_end )
end;


common_impl.hint[ "use_bullring_mansiondoor" ] = { type = "use", inv_obj = "inv_bullring", use_place = "gfx_mansiondoor_bullring_mansiondoor_zone", room = "rm_darkquarter", zz = "zz_mansiondoor", zz_gate = "gzz_darkquarter_mansiondoor" };

private.use_bullring_mansiondoor_logic = function()
--  ObjSet( "gfx_mansiondoor_mansionkey_zone", { visible = 1, input = 1, active = 1 } )
   if ld.CheckRequirements( {"use_bullring_mansiondoor","use_screwdriver"} ) then
      ObjSet( "gfx_mansiondoor_mansionkey_zone", { visible = 1, input = 1, active = 1 } )
   end;  
end;
private.use_bullring_mansiondoor_inv = function()
  common_impl.ProcessMultiUseAll("bullring", "bullring_mansiondoor")
end;
private.use_bullring_mansiondoor_beg = function()
  ObjDelete( "gfx_mansiondoor_bullring_mansiondoor_zone" );
end;
private.use_bullring_mansiondoor_end = function()
  if common_impl.ZzCompleteCheck("use_bullring_mansiondoor") then ObjSet( common_impl.hint["use_bullring_mansiondoor"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_mansiondoor_anm", {animfunc = "use_key", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bullring_mansiondoor", private.use_bullring_mansiondoor_inv );
cmn.AddSubscriber( "use_bullring_mansiondoor", private.use_bullring_mansiondoor_beg, private.room_objname );
cmn.AddSubscriber( "use_bullring_mansiondoor", private.use_bullring_mansiondoor_end, private.room_objname );
cmn.AddSubscriber( "use_bullring_mansiondoor", private.use_bullring_mansiondoor_logic );
cmn.AddSubscriber( "use_bullring_mansiondoor_inv", private.use_bullring_mansiondoor_inv, private.room_objname );
cmn.AddSubscriber( "use_bullring_mansiondoor_beg", private.use_bullring_mansiondoor_beg, private.room_objname );
cmn.AddSubscriber( "use_bullring_mansiondoor_end", private.use_bullring_mansiondoor_end, private.room_objname );
cmn.AddSubscriber( "use_bullring_mansiondoor_end", private.use_bullring_mansiondoor_logic );
--------------------------------------------------------------------------------------------
function public.use_bullring_mansiondoor( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bullring_mansiondoor" );
    cmn.CallEventHandler( "use_bullring_mansiondoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bullring_mansiondoor") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bullring_mansiondoor_inv" );
  cmn.CallEventHandler( "use_bullring_mansiondoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mansiondoor_anm", "use_ring", func_end );
  SoundSfx( "aud_use_ring_darkquarter" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_screwdriver" ] = { type = "use", inv_obj = "inv_screwdriver", use_place = "gfx_mansiondoor_screwdriver_zone", room = "rm_darkquarter", zz = "zz_mansiondoor", zz_gate = "gzz_darkquarter_mansiondoor" };

private.use_screwdriver_logic = function()
  ObjSet( "spr_mansiondoor_frame", { visible = 1, input = 1, active = 1 } )
   if ld.CheckRequirements( {"use_bullring_mansiondoor","use_screwdriver"} ) then
      ObjSet( "gfx_mansiondoor_mansionkey_zone", { visible = 1, input = 1, active = 1 } )
   end; 
end;
private.use_screwdriver_inv = function()
  common_impl.ProcessMultiUseAll("screwdriver", "screwdriver")
end;
private.use_screwdriver_beg = function()
  ObjDelete( "gfx_mansiondoor_screwdriver_zone" );
end;
private.use_screwdriver_end = function()
  if common_impl.ZzCompleteCheck("use_screwdriver") then ObjSet( common_impl.hint["use_screwdriver"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("vid_mansiondoor_vid_screwdriver_54");
  ObjDelete("spr_mansiondoor_screw")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_screwdriver", private.use_screwdriver_inv );
cmn.AddSubscriber( "use_screwdriver", private.use_screwdriver_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriver", private.use_screwdriver_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriver", private.use_screwdriver_logic );
cmn.AddSubscriber( "use_screwdriver_inv", private.use_screwdriver_inv, private.room_objname );
cmn.AddSubscriber( "use_screwdriver_beg", private.use_screwdriver_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriver_end", private.use_screwdriver_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriver_end", private.use_screwdriver_logic );
--------------------------------------------------------------------------------------------
function public.use_screwdriver( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_screwdriver" );
    cmn.CallEventHandler( "use_screwdriver_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_screwdriver") then ld.CloseSubRoom() end;
    cmn.SetEventDone( "get_frame" );
    cmn.CallEventHandler( "get_frame" );
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_screwdriver_inv" );
  cmn.CallEventHandler( "use_screwdriver_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_screwdriver_54" );
  --func_end()
  ObjSet( "spr_mansiondoor_screw", {visible = 0} );
  ObjAttach("vid_mansiondoor_vid_screwdriver_54","zz_mansiondoor");
  VidPlay("vid_mansiondoor_vid_screwdriver_54",func_end); 
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_frame" ] = { type = "get", get_obj = "spr_mansiondoor_frame", room = "rm_darkquarter", zz = "zz_mansiondoor", zz_gate = "gzz_darkquarter_mansiondoor" };

private.get_frame_logic = function()
  
end;
private.get_frame_inv = function()
  interface.InventoryItemAdd("inv_frame","spr_mansiondoor_frame");
end;
private.get_frame_beg = function()
  ObjDelete("gfx_mansiondoor_frame")
end;
private.get_frame_end = function()
  if common_impl.ZzCompleteCheck("get_frame") then ObjSet( common_impl.hint["get_frame"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_mansiondoor_sh_frame");
end;

cmn.AddSubscriber( "get_frame", private.get_frame_inv );
cmn.AddSubscriber( "get_frame", private.get_frame_beg, private.room_objname );
cmn.AddSubscriber( "get_frame", private.get_frame_end, private.room_objname );
cmn.AddSubscriber( "get_frame", private.get_frame_logic );
--------------------------------------------------------------------
function public.get_frame()
  cmn.SetEventDone( "get_frame" );
  cmn.CallEventHandler( "get_frame" );
  if common_impl.ZzCompleteCheck("get_frame") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mansionkey" ] = { type = "use", inv_obj = "inv_mansionkey", use_place = "gfx_mansiondoor_mansionkey_zone", room = "rm_darkquarter", zz = "zz_mansiondoor", zz_gate = "gzz_darkquarter_mansiondoor" };

private.use_mansionkey_logic = function()
  ObjSet( "gfx_mansiondoor_clk_mansiondoor_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_mansionkey_inv = function()
  common_impl.ProcessMultiUseAll("mansionkey", "mansionkey")
end;
private.use_mansionkey_beg = function()
  ObjDelete( "gfx_mansiondoor_mansionkey_zone" );
end;
private.use_mansionkey_end = function()
  if common_impl.ZzCompleteCheck("use_mansionkey") then ObjSet( common_impl.hint["use_mansionkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_mansiondoor_anm", {animfunc = "open_door", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mansionkey", private.use_mansionkey_inv );
cmn.AddSubscriber( "use_mansionkey", private.use_mansionkey_beg, private.room_objname );
cmn.AddSubscriber( "use_mansionkey", private.use_mansionkey_end, private.room_objname );
cmn.AddSubscriber( "use_mansionkey", private.use_mansionkey_logic );
cmn.AddSubscriber( "use_mansionkey_inv", private.use_mansionkey_inv, private.room_objname );
cmn.AddSubscriber( "use_mansionkey_beg", private.use_mansionkey_beg, private.room_objname );
cmn.AddSubscriber( "use_mansionkey_end", private.use_mansionkey_end, private.room_objname );
cmn.AddSubscriber( "use_mansionkey_end", private.use_mansionkey_logic );
--------------------------------------------------------------------------------------------
function public.use_mansionkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mansionkey" );
    cmn.CallEventHandler( "use_mansionkey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mansionkey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mansionkey_inv" );
  cmn.CallEventHandler( "use_mansionkey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mansiondoor_anm", "use_key", func_end );
  SoundSfx( "aud_use_mansion_key" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_mansiondoor" ] = { type = "click", use_place = "gfx_mansiondoor_clk_mansiondoor_zone", room = "rm_darkquarter", zz = "zz_mansiondoor", zz_gate = "gzz_darkquarter_mansiondoor" };

private.clk_mansiondoor_logic = function()
  ObjSet( "grm_darkquarter_mansion", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_darkquarter_mansion_focus");
  end;
end;
private.clk_mansiondoor_beg = function()
  ObjDelete( "gfx_mansiondoor_clk_mansiondoor_zone" );
end;
private.clk_mansiondoor_end = function()
  if common_impl.ZzCompleteCheck("clk_mansiondoor") then ObjSet( common_impl.hint["clk_mansiondoor"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_darkquarter_open_door", {active=1, visible=1} );
  --ObjDelete("anm_mansiondoor_anm");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_mansiondoor", private.clk_mansiondoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_mansiondoor", private.clk_mansiondoor_end, private.room_objname );
cmn.AddSubscriber( "clk_mansiondoor", private.clk_mansiondoor_logic );
cmn.AddSubscriber( "clk_mansiondoor_beg", private.clk_mansiondoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_mansiondoor_end", private.clk_mansiondoor_end, private.room_objname );
cmn.AddSubscriber( "clk_mansiondoor_end", private.clk_mansiondoor_logic );
--------------------------------------------------------------------------------------------
function public.clk_mansiondoor()

  local func_end = function()
    cmn.SetEventDone( "clk_mansiondoor" );
    cmn.CallEventHandler( "clk_mansiondoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_mansiondoor") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_mansiondoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mansiondoor_anm", "open_door", func_end );
  SoundSfx( "aud_touch_mansion_key" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_monument *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_phoenix" ] = { type = "get", get_obj = "spr_monument_phoenix", room = "rm_darkquarter", zz = "zz_monument", zz_gate = "gzz_darkquarter_monument" };

private.get_phoenix_logic = function()
  
end;
private.get_phoenix_inv = function()
  interface.InventoryItemAdd("inv_phoenix","spr_monument_phoenix");
  ObjSet( "inv_phoenix", { drag = 0 } );
  ObjSet( "gfx_monument_lily2_zone", {input = 1, visible = 1} );
end;
private.get_phoenix_beg = function()
  ObjDelete("gfx_monument_phoenix")
end;
private.get_phoenix_end = function()
  if common_impl.ZzCompleteCheck("get_phoenix") then ObjSet( common_impl.hint["get_phoenix"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_monument_sh_phoenix");
  ObjDelete("spr_darkquarter_phoenix");
end;

cmn.AddSubscriber( "get_phoenix", private.get_phoenix_inv );
cmn.AddSubscriber( "get_phoenix", private.get_phoenix_beg, private.room_objname );
cmn.AddSubscriber( "get_phoenix", private.get_phoenix_end, private.room_objname );
cmn.AddSubscriber( "get_phoenix", private.get_phoenix_logic );
--------------------------------------------------------------------
function public.get_phoenix()
  cmn.SetEventDone( "get_phoenix" );
  cmn.CallEventHandler( "get_phoenix" );
  if common_impl.ZzCompleteCheck("get_phoenix") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
public.use_bracelet_zone_clk = function()
  local func_end = function()
     ld.Lock(0);
     common_impl.ShowBbt( 'need_bracelet' )
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_statue_plate_darkquarter" );
  ld.AnimPlay( "anm_monument_anm_bracelet", "idle_door_2", func_end ) 
end;

common_impl.hint[ "use_bracelet" ] = { type = "use", inv_obj = "inv_bracelet", use_place = "gfx_monument_bracelet_zone", room = "rm_darkquarter", zz = "zz_monument", zz_gate = "gzz_darkquarter_monument" };

private.use_bracelet_logic = function()
--  ObjSet( "spr_monument_mansionkey", { visible = 1, input = 1, active = 1 } )
    ObjSet( "obj_monument_braceletcode", {input = 1, visible = 1} );
end;
private.use_bracelet_inv = function()
  common_impl.ProcessMultiUseAll("bracelet", "bracelet")
end;
private.use_bracelet_beg = function()
  ObjDelete( "gfx_monument_bracelet_zone" );
end;
private.use_bracelet_end = function()
  if common_impl.ZzCompleteCheck("use_bracelet") then ObjSet( common_impl.hint["use_bracelet"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_monument_anm_bracelet", {animfunc = "use_bracelet", frame = 999 } );
  ObjSet( "spr_darkquarter_bracelet_back", {active=1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bracelet", private.use_bracelet_inv );
cmn.AddSubscriber( "use_bracelet", private.use_bracelet_beg, private.room_objname );
cmn.AddSubscriber( "use_bracelet", private.use_bracelet_end, private.room_objname );
cmn.AddSubscriber( "use_bracelet", private.use_bracelet_logic );
cmn.AddSubscriber( "use_bracelet_inv", private.use_bracelet_inv, private.room_objname );
cmn.AddSubscriber( "use_bracelet_beg", private.use_bracelet_beg, private.room_objname );
cmn.AddSubscriber( "use_bracelet_end", private.use_bracelet_end, private.room_objname );
cmn.AddSubscriber( "use_bracelet_end", private.use_bracelet_logic );
--------------------------------------------------------------------------------------------
function public.use_bracelet( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bracelet" );
    cmn.CallEventHandler( "use_bracelet_end" );
    --   common_impl.Lock(0);
    private.monument_braceletcode_init();
    if common_impl.ZzCompleteCheck("use_bracelet") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bracelet_inv" );
  cmn.CallEventHandler( "use_bracelet_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_monument_anm_bracelet", "use_bracelet", func_end );
  SoundSfx( "aud_use_bracelet_darkquarter" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
local monumentbraceletcode_parts_fp_array={};  --only y
local monumentbraceletcode_parts_fp={1,2,3,4,5};
local monumentbraceletcode_parts_win_array = {3,1,2,5,4};
local monumentbraceletcode_selected_part = 0;

local monumentbraceletcode_parts_win_array_inverterted={}
function private.monumentbraceletcode_parts_win_array_inverterter()
   for i=1,5,1 do 
      for j=1,5,1 do 
         if monumentbraceletcode_parts_win_array[j]==i then monumentbraceletcode_parts_win_array_inverterted[i]=j; break end;
      end;  
   end;  
end;  


function private.clk_monumentbraceletcode_hint()
  --  ld.LogTrace( "show_hint" );
  for i=1,5,1 do 
      if  ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[private.monumentbraceletcode_get_pos(i)]~=monumentbraceletcode_parts_win_array[private.monumentbraceletcode_get_pos(i)] then 
         common_impl.HintShowAnm("spr_monument_mmg_symbol_"..i);
         common_impl.HintShowAnm("obj_monument_point_"..i);
         return;  
      end;   
  end;
  common_impl.HintShowAnm("obj_monument_braceletcode");   
end
common_impl.hint[ "clk_monumentbraceletcode" ] = { type = "click", use_place = "obj_monument_braceletcode", room = "rm_darkquarter", zz = "zz_monument", zz_gate = "gzz_darkquarter_monument" };
common_impl.hint[ "clk_monumentbraceletcode" ].hint = private.clk_monumentbraceletcode_hint;

--common_impl.hint[ "clk_monumentbraceletcode" ] = { type = "click", use_place = "obj_monument_braceletcode", room = "rm_darkquarter", zz = "zz_monument", zz_gate = "gzz_darkquarter_monument" };

private.clk_monumentbraceletcode_logic = function()
   if cmn.IsEventDone("clk_monumentbraceletcode") then 
     ObjSet( "spr_monument_mansionkey", { visible = 0, input = 1, active = 1 } )
     ObjSet( "gfx_monument_mansionkey", {input = 1, visible = 1, active=1} );
   end
end;
private.clk_monumentbraceletcode_beg = function()
  if cmn.IsEventDone("clk_monumentbraceletcode") then 
    --  ObjDelete( "gfx_monument_braceletcode" );
  end;
end;
private.clk_monumentbraceletcode_end = function()
--  ObjDelete("anm_monument_anm_bracelet");
    if cmn.IsEventDone("clk_monumentbraceletcode") then 
      ObjSet( "anm_monument_anm_bracelet", {animfunc = "open_door_2", frame = 999 } );
      ObjDelete("obj_monument_braceletcode");
      ObjDelete("spr_darkquarter_bracelet_back");
    end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_monumentbraceletcode", private.clk_monumentbraceletcode_beg, private.room_objname );
cmn.AddSubscriber( "clk_monumentbraceletcode", private.clk_monumentbraceletcode_end, private.room_objname );
cmn.AddSubscriber( "clk_monumentbraceletcode", private.clk_monumentbraceletcode_logic );
cmn.AddSubscriber( "clk_monumentbraceletcode_beg", private.clk_monumentbraceletcode_beg, private.room_objname );
cmn.AddSubscriber( "clk_monumentbraceletcode_end", private.clk_monumentbraceletcode_end, private.room_objname );
cmn.AddSubscriber( "clk_monumentbraceletcode_end", private.clk_monumentbraceletcode_logic );
--------------------------------------------------------------------------------------------
function public.clk_monumentbraceletcode( obj )

  local func_end = function()
    cmn.SetEventDone( "clk_monumentbraceletcode" );
    cmn.CallEventHandler( "clk_monumentbraceletcode_end" );
    common_impl.Lock(0);
  end;

  local func_preend = function()
     ld.AnimPlay( "anm_monument_anm_bracelet", "open_door_2", func_end );
     SoundSfx( "aud_open_statue_1_darkquarter" )
    --func_end()
  end;
  
  
  
  cmn.CallEventHandler( "clk_monumentbraceletcode_beg" );
  common_impl.Lock(1);

  local func_prepreend = function()
      ObjAnimate( "obj_monument_braceletcode", 8, 0, 0, func_preend, {0,0,1, 0.5,0,0} );
  end;
  
    
  ObjSet( "anm_monument_anm_bracelet", {animfunc = "open_door_2", frame = 0 } );  
  private.monumentbraceletcode_parts_win_array_inverterter();  
  local my_time=1;
  local time_step=0.2;
  for i=1,5,1 do 
     ld.StartTimer(my_time, function() ObjAnimate( "spr_monument_mmg_light_"..monumentbraceletcode_parts_win_array_inverterted[i], 8, 0, 0, function() end, {0,0,0, 0.5,0,1, 1,0,0} ); end); 
     my_time=my_time+time_step;
  end;  
  
  SoundSfx( "aud_mg_bracelet_true" ); 
   
  ld.StartTimer( 3, func_prepreend );  
end;
--------------------------------------------------------------------------------------------
function private.monument_braceletcode_get_parts_fp()
  for i=1,5,1 do 
     monumentbraceletcode_parts_fp_array[i]=ObjGet("spr_monument_mmg_symbol_"..i).pos_y;
  end;  
   
  for i=1,5,1 do 
    ObjSet( "spr_monument_mmg_symbol_"..i, {event_mdown="rm_darkquarter.monumentbraceletcode_part_mdown("..i..");", event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave = "ld.SetCursor(CURSOR_DEFAULT);", inputrect_init=1, inputrect_w=82, inputrect_h=82, inputrect_x=-41, inputrect_y=-41, pos_z=10} );
  end;  
end;  

------------------------------------------------------------------------------------------------------
function public.monument_braceletcode_zone_open()
   local func_end = function()
     ld.Lock(0);
     ObjSet( "obj_monument_braceletcode", {input = 1} );
     private.monument_braceletcode_init()
   end;
 
   ld.Lock(1);
   ObjAnimate( "obj_monument_braceletcode", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
end;  
----------------------------------------------------------------------------------------- 
function private.monument_braceletcode_init()
--  ld.LogTrace( "monument_braceletcode_init" );
  if not cmn.IsEventStart("clk_monumentbraceletcode") then 
--    ld.LogTrace( "not start" );
    cmn.SetEventStart("clk_monumentbraceletcode")
    ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state = ld.TableCopy(monumentbraceletcode_parts_fp);
    public.monument_braceletcode_zone_open();
  else   
--    ld.LogTrace( "start" );
    ObjSet( "obj_monument_braceletcode", {alp=1, input = 1} );
    private.monument_braceletcode_stand_on_pos()
  end;  
end;  
--------------------------------------------------------------------
function private.monument_braceletcode_stand_on_pos()
  for i=1,5,1 do 
    ObjSet( "spr_monument_mmg_symbol_"..i, {pos_y=monumentbraceletcode_parts_fp_array[ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[i] ]} );
  end;  
  
  for i=1,5,1 do 
    ObjSet( "spr_monument_mmg_light_"..i, {alp=0} );
  end;  
   
  if monumentbraceletcode_selected_part~=0 then ObjSet( "spr_monument_mmg_light_"..monumentbraceletcode_selected_part, {alp=1} ); end;
  
  private.monument_braceletcode_show_array(); 
  private.monument_braceletcode_parts_win_ver()
end;  
----------------------------------------------------------------------------------------
function private.monument_braceletcode_show_array()
  local my_str=""; 
  for i=1,5,1 do 
    my_str=my_str.." "..ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[i];
  end;  
--  ld.LogTrace( "my_str = "..my_str );
end;  
--------------------------------------------------------------------------------------------
function private.monument_braceletcode_parts_win_ver()
  local count=0;
  for i=1,5,1 do 
    if ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[i]==monumentbraceletcode_parts_win_array[i] then count=count+1; end;
  end;  
  if count==5 then public.clk_monumentbraceletcode() end;
end;  
-----------------------------------------------------------------------------------------------------------
function private.monumentbraceletcode_get_pos(num, array)
   if not array then 
      array = ld.TableCopy(ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state);
    end;  
  
   for i=1,5,1 do 
      if array[i]==num then return num; end;
   end;   
end;  

-----------------------------------------------------------------------------------------------------------
function public.monumentbraceletcode_part_mdown(num)
  local func_end=function()
    ld.Lock(0);
    private.monument_braceletcode_stand_on_pos();
  end;
  
  local func_preend = function()
    ObjSet( "spr_monument_mmg_symbol_"..num, {pos_z=10} );
    ObjSet( "spr_monument_mmg_symbol_"..monumentbraceletcode_selected_part, {pos_z=10} );
    ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[private.monumentbraceletcode_get_pos(num)], ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[private.monumentbraceletcode_get_pos(monumentbraceletcode_selected_part)] = ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[private.monumentbraceletcode_get_pos(monumentbraceletcode_selected_part)], ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[private.monumentbraceletcode_get_pos(num)];
    monumentbraceletcode_selected_part=0;
    func_end();
  end;
  
  SoundSfx( "aud_mg_bracelet_select" );
  if monumentbraceletcode_selected_part==0 then 
     monumentbraceletcode_selected_part=num;
     func_end();
  elseif monumentbraceletcode_selected_part==num then 
     monumentbraceletcode_selected_part=0;
     func_end();
  elseif monumentbraceletcode_selected_part~=num then 
     SoundSfx( "aud_mg_bracelet_move" );
     ld.Lock(1);
     ObjSet( "spr_monument_mmg_symbol_"..num, {pos_z=15} );
     ObjSet( "spr_monument_mmg_symbol_"..monumentbraceletcode_selected_part, {pos_z=15} );
     ObjAnimate( "spr_monument_mmg_symbol_"..num, 1, 0, 0, func_preend, {0,0,monumentbraceletcode_parts_fp_array[ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[private.monumentbraceletcode_get_pos(num)] ], 0.5,0,monumentbraceletcode_parts_fp_array[ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[private.monumentbraceletcode_get_pos(monumentbraceletcode_selected_part)] ]} );
     ObjAnimate( "spr_monument_mmg_symbol_"..monumentbraceletcode_selected_part, 1, 0, 0, function() end, {0,0,monumentbraceletcode_parts_fp_array[ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[private.monumentbraceletcode_get_pos(monumentbraceletcode_selected_part)] ], 0.5,0,monumentbraceletcode_parts_fp_array[ng_global.progress[ "std" ][ "clk_monumentbraceletcode" ].state[private.monumentbraceletcode_get_pos(num)] ]} );
     ObjAnimate( "spr_monument_mmg_light_"..num, 8, 0, 0, function() end, {0,0,0, 0.25,0,1, 0.5,0,0} );  
     ObjAnimate( "spr_monument_mmg_light_"..monumentbraceletcode_selected_part, 8, 0, 0, function() end, {0,0,0, 0.25,0,1, 0.5,0,0} );  
  end;  
end;  
------------------------------------------------------------------------------------------------------------
common_impl.hint[ "get_mansionkey" ] = { type = "get", get_obj = "spr_monument_mansionkey", room = "rm_darkquarter", zz = "zz_monument", zz_gate = "gzz_darkquarter_monument" };

private.get_mansionkey_logic = function()
  
end;
private.get_mansionkey_inv = function()
  interface.InventoryItemAdd("inv_mansionkey","spr_monument_mansionkey");
end;
private.get_mansionkey_beg = function()
  ObjDelete("gfx_monument_mansionkey")
end;
private.get_mansionkey_end = function()
  if common_impl.ZzCompleteCheck("get_mansionkey") then ObjSet( common_impl.hint["get_mansionkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_monument_anm_bracelet");
end;

cmn.AddSubscriber( "get_mansionkey", private.get_mansionkey_inv );
cmn.AddSubscriber( "get_mansionkey", private.get_mansionkey_beg, private.room_objname );
cmn.AddSubscriber( "get_mansionkey", private.get_mansionkey_end, private.room_objname );
cmn.AddSubscriber( "get_mansionkey", private.get_mansionkey_logic );
--------------------------------------------------------------------
function public.get_mansionkey()
  ObjSet( "spr_monument_mansionkey", {visible=1} );
  cmn.SetEventDone( "get_mansionkey" );
  cmn.CallEventHandler( "get_mansionkey" );
  if common_impl.ZzCompleteCheck("get_mansionkey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_lily_zone_clk(num)
   local func_end = function()
     ld.Lock(0);
     common_impl.ShowBbt( "need_lily"..num );
   end;
 
  
   if not (ld.CheckRequirements({"use_lily1"}) or ld.CheckRequirements( {"use_lily2"})) then 
      ld.Lock(1);
      SoundSfx( "aud_touch_statue_plate_darkquarter" );
      ld.AnimPlay( "anm_monument_anm_lily_door", "idle_door_1", func_end )
   else 
      func_end();
   end;
end;  


common_impl.hint[ "use_lily1" ] = { type = "use", inv_obj = "inv_lily1", use_place = "gfx_monument_lily1_zone", room = "rm_darkquarter", zz = "zz_monument", zz_gate = "gzz_darkquarter_monument" };

private.use_lily1_logic = function()
  if ld.CheckRequirements( {"use_lily1","use_lily2"} ) then
    ObjSet( "spr_monument_sword", { visible = 0, input = 1, active = 1 } )
    ObjSet( "gfx_monument_sword", {active=1, visible = 1} );
  end;

end;
private.use_lily1_inv = function()
  common_impl.ProcessMultiUseAll("lily1", "lily1")
end;
private.use_lily1_beg = function()
  ObjDelete( "gfx_monument_lily1_zone" );
end;
private.use_lily1_end = function()
  if common_impl.ZzCompleteCheck("use_lily1") then ObjSet( common_impl.hint["use_lily1"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_lily1","use_lily2"} ) then
     ObjDelete("anm_monument_anm_lily_1")
     ObjDelete("anm_monument_anm_lily_2")
     ObjSet("anm_monument_anm_lily_door",{animfunc = "open_door_1", frame = 999});  
     ObjDelete("spr_darkquarter_door_1"); 
  else  
     ObjSet( "anm_monument_anm_lily_1", {animfunc = "use_lily_1", frame = 999, pos_z=7 } );
     ObjSet( "spr_darkquarter_lily1", {active=1, visible = 1} );
  end;    
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lily1", private.use_lily1_inv );
cmn.AddSubscriber( "use_lily1", private.use_lily1_beg, private.room_objname );
cmn.AddSubscriber( "use_lily1", private.use_lily1_end, private.room_objname );
cmn.AddSubscriber( "use_lily1", private.use_lily1_logic );
cmn.AddSubscriber( "use_lily1_inv", private.use_lily1_inv, private.room_objname );
cmn.AddSubscriber( "use_lily1_beg", private.use_lily1_beg, private.room_objname );
cmn.AddSubscriber( "use_lily1_end", private.use_lily1_end, private.room_objname );
cmn.AddSubscriber( "use_lily1_end", private.use_lily1_logic );
--------------------------------------------------------------------------------------------
function public.use_lily1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lily1" );
    cmn.CallEventHandler( "use_lily1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lily1") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    if ld.CheckRequirements( {"use_lily1"} ) or  ld.CheckRequirements( {"use_lily2"} ) then
      ObjSet( "anm_monument_anm_lily_1", {visible = 0} );
      ObjSet( "anm_monument_anm_lily_2", {visible = 0} );
      SoundSfx( "aud_open_statue_2_darkquarter" );
      ld.AnimPlay( "anm_monument_anm_lily_door", "open_door_1", func_end )
    else  
      func_end();
    end  
  
  end;
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lily1_inv" );
  cmn.CallEventHandler( "use_lily1_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_monument_anm_lily_1", {pos_z=32} );
  ld.AnimPlay( "anm_monument_anm_lily_1", "use_lily_1", func_preend );
  SoundSfx( "aud_use_symbol_statue_darkquarter" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lily2" ] = { type = "use", inv_obj = "inv_lily2", use_place = "gfx_monument_lily2_zone", room = "rm_darkquarter", zz = "zz_monument", zz_gate = "gzz_darkquarter_monument" };

private.use_lily2_logic = function()
  if ld.CheckRequirements( {"use_lily2","use_lily1"} ) then
    ObjSet( "spr_monument_sword", { visible = 0, input = 1, active = 1 } )
    ObjSet( "gfx_monument_sword", {active=1, visible = 1} );
  end;

end;
private.use_lily2_inv = function()
  common_impl.ProcessMultiUseAll("lily2", "lily2")
end;
private.use_lily2_beg = function()
  ObjDelete( "gfx_monument_lily2_zone" );
end;
private.use_lily2_end = function()
  if common_impl.ZzCompleteCheck("use_lily2") then ObjSet( common_impl.hint["use_lily2"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_lily1","use_lily2"} ) then
     ObjDelete("anm_monument_anm_lily_1")
     ObjDelete("anm_monument_anm_lily_2")
     ObjSet("anm_monument_anm_lily_door",{animfunc = "open_door_1", frame = 999}); 
     ObjDelete("spr_darkquarter_door_1"); 
  else  
     ObjSet( "anm_monument_anm_lily_2", {animfunc = "use_lily_2", frame = 999 } );
     ObjSet( "spr_darkquarter_lily2", {active=1, visible = 1} );
  end;    
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lily2", private.use_lily2_inv );
cmn.AddSubscriber( "use_lily2", private.use_lily2_beg, private.room_objname );
cmn.AddSubscriber( "use_lily2", private.use_lily2_end, private.room_objname );
cmn.AddSubscriber( "use_lily2", private.use_lily2_logic );
cmn.AddSubscriber( "use_lily2_inv", private.use_lily2_inv, private.room_objname );
cmn.AddSubscriber( "use_lily2_beg", private.use_lily2_beg, private.room_objname );
cmn.AddSubscriber( "use_lily2_end", private.use_lily2_end, private.room_objname );
cmn.AddSubscriber( "use_lily2_end", private.use_lily2_logic );
--------------------------------------------------------------------------------------------
function public.use_lily2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lily2" );
    cmn.CallEventHandler( "use_lily2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lily2") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    if ld.CheckRequirements( {"use_lily1"} ) or  ld.CheckRequirements( {"use_lily2"} ) then
      ObjSet( "anm_monument_anm_lily_1", {visible = 0} );
      ObjSet( "anm_monument_anm_lily_2", {visible = 0} );
      SoundSfx( "aud_open_statue_2_darkquarter" );
      ld.AnimPlay( "anm_monument_anm_lily_door", "open_door_1", func_end )
    else  
      func_end();
    end  
  
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lily2_inv" );
  cmn.CallEventHandler( "use_lily2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_monument_anm_lily_2", "use_lily_2", func_preend );
  SoundSfx( "aud_use_symbol_statue_darkquarter" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sword" ] = { type = "get", get_obj = "spr_monument_sword", room = "rm_darkquarter", zz = "zz_monument", zz_gate = "gzz_darkquarter_monument" };

private.get_sword_logic = function()
  
end;
private.get_sword_inv = function()
  interface.InventoryItemAdd("inv_sword","spr_monument_sword");
end;
private.get_sword_beg = function()
  ObjDelete("gfx_monument_sword")
end;
private.get_sword_end = function()
  if common_impl.ZzCompleteCheck("get_sword") then ObjSet( common_impl.hint["get_sword"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_monument_anm_lily_door");
  ObjDelete("spr_darkquarter_sword");
end;

cmn.AddSubscriber( "get_sword", private.get_sword_inv );
cmn.AddSubscriber( "get_sword", private.get_sword_beg, private.room_objname );
cmn.AddSubscriber( "get_sword", private.get_sword_end, private.room_objname );
cmn.AddSubscriber( "get_sword", private.get_sword_logic );
--------------------------------------------------------------------
function public.get_sword()
  ObjSet( "spr_monument_sword", {visible = 1} );
  cmn.SetEventDone( "get_sword" );
  cmn.CallEventHandler( "get_sword" );
  if common_impl.ZzCompleteCheck("get_sword") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_ads *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
public.ads_paper_zone_clk = function()
  local func_end = function() 
    
  end;

  ObjDelete("obj_ads_paper_clk_zone");
  SoundSfx( "aud_touch_paper_darkquarter" );
  ld.AnimPlay( "anm_ads_anm_paper", "click_pappers", func_end )
end;
-----------------------------------------------------------------------------------------------
public.use_scissors_ads_zone_clk = function()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_scissors_ads' )
  end;  

  ld.Lock(1);
  SoundSfx( "aud_touch_diamond_darkquarter" );
  ld.AnimPlay( "anm_ads_anm", "idle_yellowcrystal", func_end )
end;
-----------------------------------------------------------------------------------------------
common_impl.hint[ "use_scissors_ads" ] = { type = "use", inv_obj = "inv_scissors", use_place = "gfx_ads_scissors_ads_zone", room = "rm_darkquarter", zz = "zz_ads", zz_gate = "gzz_darkquarter_ads" };

private.use_scissors_ads_logic = function()
  ObjSet( "spr_ads_yellowcrystal", { visible = 1, input = 1, active = 1 } )

end;
private.use_scissors_ads_inv = function()
  common_impl.ProcessMultiUseAll("scissors", "scissors_ads")
end;
private.use_scissors_ads_beg = function()
  ObjDelete( "gfx_ads_scissors_ads_zone" );
end;
private.use_scissors_ads_end = function()
  if common_impl.ZzCompleteCheck("use_scissors_ads") then ObjSet( common_impl.hint["use_scissors_ads"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete( "anm_ads_anm" );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scissors_ads", private.use_scissors_ads_inv );
cmn.AddSubscriber( "use_scissors_ads", private.use_scissors_ads_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors_ads", private.use_scissors_ads_end, private.room_objname );
cmn.AddSubscriber( "use_scissors_ads", private.use_scissors_ads_logic );
cmn.AddSubscriber( "use_scissors_ads_inv", private.use_scissors_ads_inv, private.room_objname );
cmn.AddSubscriber( "use_scissors_ads_beg", private.use_scissors_ads_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors_ads_end", private.use_scissors_ads_end, private.room_objname );
cmn.AddSubscriber( "use_scissors_ads_end", private.use_scissors_ads_logic );
--------------------------------------------------------------------------------------------
function public.use_scissors_ads( obj )

  local func_end = function()
    public.get_yellowcrystal();
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scissors_ads" );
    cmn.CallEventHandler( "use_scissors_ads_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_scissors_ads") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scissors_ads_inv" );
  cmn.CallEventHandler( "use_scissors_ads_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ads_anm", "use_scissors1", func_end );
  SoundSfx( "aud_use_scissors_darkquarter" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_yellowcrystal" ] = { type = "get", get_obj = "spr_ads_yellowcrystal", room = "rm_darkquarter", zz = "zz_ads", zz_gate = "gzz_darkquarter_ads" };

private.get_yellowcrystal_logic = function()
  
end;
private.get_yellowcrystal_inv = function()
  interface.InventoryItemAdd("inv_yellowcrystal","spr_ads_yellowcrystal");
end;
private.get_yellowcrystal_beg = function()
  ObjDelete("gfx_ads_yellowcrystal")
end;
private.get_yellowcrystal_end = function()
  if common_impl.ZzCompleteCheck("get_yellowcrystal") then ObjSet( common_impl.hint["get_yellowcrystal"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_darkquarter_yellowcrystal");
end;

cmn.AddSubscriber( "get_yellowcrystal", private.get_yellowcrystal_inv );
cmn.AddSubscriber( "get_yellowcrystal", private.get_yellowcrystal_beg, private.room_objname );
cmn.AddSubscriber( "get_yellowcrystal", private.get_yellowcrystal_end, private.room_objname );
cmn.AddSubscriber( "get_yellowcrystal", private.get_yellowcrystal_logic );
--------------------------------------------------------------------
function public.get_yellowcrystal()
  ObjSet( "spr_ads_yellowcrystal", {visible = 1} );
  cmn.SetEventDone( "get_yellowcrystal" );
  cmn.CallEventHandler( "get_yellowcrystal" );
  if common_impl.ZzCompleteCheck("get_yellowcrystal") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cobblershop *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_saltcellar" ] = { type = "get", get_obj = "spr_cobblershop_saltcellar", room = "rm_darkquarter", zz = "zz_cobblershop", zz_gate = "gzz_darkquarter_cobblershop" };

private.get_saltcellar_logic = function()
  
end;
private.get_saltcellar_inv = function()
  interface.InventoryItemAdd("inv_saltcellar","spr_cobblershop_saltcellar");
end;
private.get_saltcellar_beg = function()
  ObjDelete("gfx_cobblershop_saltcellar")
end;
private.get_saltcellar_end = function()
  if common_impl.ZzCompleteCheck("get_saltcellar") then ObjSet( common_impl.hint["get_saltcellar"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cobblershop_sh_saltcellar");
end;

cmn.AddSubscriber( "get_saltcellar", private.get_saltcellar_inv );
cmn.AddSubscriber( "get_saltcellar", private.get_saltcellar_beg, private.room_objname );
cmn.AddSubscriber( "get_saltcellar", private.get_saltcellar_end, private.room_objname );
cmn.AddSubscriber( "get_saltcellar", private.get_saltcellar_logic );
--------------------------------------------------------------------
function public.get_saltcellar()
  cmn.SetEventDone( "get_saltcellar" );
  cmn.CallEventHandler( "get_saltcellar" );
  if common_impl.ZzCompleteCheck("get_saltcellar") then ld.CloseSubRoom() end;
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_cobblershophandle" ] = { type = "click", use_place = "gfx_cobblershop_clk_cobblershophandle_zone", room = "rm_darkquarter", zz = "zz_cobblershop", zz_gate = "gzz_darkquarter_cobblershop" };

private.clk_cobblershophandle_logic = function()
  ObjSet( "gfx_cobblershop_handle_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_cobblershophandle_beg = function()
  ObjDelete( "gfx_cobblershop_clk_cobblershophandle_zone" );
end;
private.clk_cobblershophandle_end = function()
  if common_impl.ZzCompleteCheck("clk_cobblershophandle") then ObjSet( common_impl.hint["clk_cobblershophandle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cobblershop_anm_right_door", {animfunc = "use_handle", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_cobblershophandle", private.clk_cobblershophandle_beg, private.room_objname );
cmn.AddSubscriber( "clk_cobblershophandle", private.clk_cobblershophandle_end, private.room_objname );
cmn.AddSubscriber( "clk_cobblershophandle", private.clk_cobblershophandle_logic );
cmn.AddSubscriber( "clk_cobblershophandle_beg", private.clk_cobblershophandle_beg, private.room_objname );
cmn.AddSubscriber( "clk_cobblershophandle_end", private.clk_cobblershophandle_end, private.room_objname );
cmn.AddSubscriber( "clk_cobblershophandle_end", private.clk_cobblershophandle_logic );
--------------------------------------------------------------------------------------------
function public.clk_cobblershophandle()

  local func_end = function()
    cmn.SetEventDone( "clk_cobblershophandle" );
    cmn.CallEventHandler( "clk_cobblershophandle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_cobblershophandle") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_cobblershophandle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cobblershop_anm_right_door", "click_handle", func_end );
  SoundSfx( "aud_touch_drawer_handle_darkquarter_fall" );
  --  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_handle_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_handle' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_drawer_handle_darkquarter" );
  ld.AnimPlay( "anm_cobblershop_anm_right_door", "idle_handle", func_end );
end;  



common_impl.hint[ "use_handle" ] = { type = "use", inv_obj = "inv_handle", use_place = "gfx_cobblershop_handle_zone", room = "rm_darkquarter", zz = "zz_cobblershop", zz_gate = "gzz_darkquarter_cobblershop" };

private.use_handle_logic = function()
  ObjSet( "spr_cobblershop_needlethread", { visible = 1, input = 1, active = 1 } )

end;
private.use_handle_inv = function()
  common_impl.ProcessMultiUseAll("handle", "handle")
end;
private.use_handle_beg = function()
  ObjDelete( "gfx_cobblershop_handle_zone" );
end;
private.use_handle_end = function()
  if common_impl.ZzCompleteCheck("use_handle") then ObjSet( common_impl.hint["use_handle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cobblershop_anm_right_door", {animfunc = "static_handle", frame = 0 } );
  ObjSet( "spr_cobblershop_sh_needlethread", {active=1, input=1, visible=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_handle", private.use_handle_inv );
cmn.AddSubscriber( "use_handle", private.use_handle_beg, private.room_objname );
cmn.AddSubscriber( "use_handle", private.use_handle_end, private.room_objname );
cmn.AddSubscriber( "use_handle", private.use_handle_logic );
cmn.AddSubscriber( "use_handle_inv", private.use_handle_inv, private.room_objname );
cmn.AddSubscriber( "use_handle_beg", private.use_handle_beg, private.room_objname );
cmn.AddSubscriber( "use_handle_end", private.use_handle_end, private.room_objname );
cmn.AddSubscriber( "use_handle_end", private.use_handle_logic );
--------------------------------------------------------------------------------------------
function public.use_handle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_handle" );
    cmn.CallEventHandler( "use_handle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_handle") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_handle_inv" );
  cmn.CallEventHandler( "use_handle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cobblershop_anm_right_door", "use_handle", func_end );
  SoundSfx( "aud_use_drawer_handle_darkquarter" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_needlethread" ] = { type = "get", get_obj = "spr_cobblershop_needlethread", room = "rm_darkquarter", zz = "zz_cobblershop", zz_gate = "gzz_darkquarter_cobblershop" };

private.get_needlethread_logic = function()
  
end;
private.get_needlethread_inv = function()
  interface.InventoryItemAdd("inv_needlethread","spr_cobblershop_needlethread");
end;
private.get_needlethread_beg = function()
  ObjDelete("gfx_cobblershop_needlethread")
end;
private.get_needlethread_end = function()
  if common_impl.ZzCompleteCheck("get_needlethread") then ObjSet( common_impl.hint["get_needlethread"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cobblershop_sh_needlethread");
end;

cmn.AddSubscriber( "get_needlethread", private.get_needlethread_inv );
cmn.AddSubscriber( "get_needlethread", private.get_needlethread_beg, private.room_objname );
cmn.AddSubscriber( "get_needlethread", private.get_needlethread_end, private.room_objname );
cmn.AddSubscriber( "get_needlethread", private.get_needlethread_logic );
--------------------------------------------------------------------
function public.get_needlethread()
  cmn.SetEventDone( "get_needlethread" );
  cmn.CallEventHandler( "get_needlethread" );
  if common_impl.ZzCompleteCheck("get_needlethread") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_amuletskull_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_amuletskull' )
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_drawer_handle_darkquarter" );
  ld.AnimPlay( "anm_cobblershop_anm_left_door", "idle_amuletskul", func_end );
end;  


common_impl.hint[ "use_amuletskull" ] = { type = "use", inv_obj = "inv_amuletskull", use_place = "gfx_cobblershop_amuletskull_zone", room = "rm_darkquarter", zz = "zz_cobblershop", zz_gate = "gzz_darkquarter_cobblershop" };

private.use_amuletskull_logic = function()
  ObjSet( "spr_cobblershop_brush", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletskull_inv = function()
  common_impl.ProcessMultiUseAll("amuletskull", "amuletskull")
end;
private.use_amuletskull_beg = function()
  ObjDelete( "gfx_cobblershop_amuletskull_zone" );
end;
private.use_amuletskull_end = function()
  if common_impl.ZzCompleteCheck("use_amuletskull") then ObjSet( common_impl.hint["use_amuletskull"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cobblershop_anm_left_door", {animfunc = "static_amuletskul", frame = 0 } );
  ObjSet( "spr_cobblershop_sh_brush", {active=1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletskull", private.use_amuletskull_inv );
cmn.AddSubscriber( "use_amuletskull", private.use_amuletskull_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletskull", private.use_amuletskull_end, private.room_objname );
cmn.AddSubscriber( "use_amuletskull", private.use_amuletskull_logic );
cmn.AddSubscriber( "use_amuletskull_inv", private.use_amuletskull_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletskull_beg", private.use_amuletskull_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletskull_end", private.use_amuletskull_end, private.room_objname );
cmn.AddSubscriber( "use_amuletskull_end", private.use_amuletskull_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletskull( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletskull" );
    cmn.CallEventHandler( "use_amuletskull_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletskull") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletskull_inv" );
  cmn.CallEventHandler( "use_amuletskull_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cobblershop_anm_left_door", "use_amuletskul", func_end );
  SoundSfx( "aud_use_skull_amulet_darkquarter" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_brush" ] = { type = "get", get_obj = "spr_cobblershop_brush", room = "rm_darkquarter", zz = "zz_cobblershop", zz_gate = "gzz_darkquarter_cobblershop" };

private.get_brush_logic = function()
  
end;
private.get_brush_inv = function()
  interface.InventoryItemAdd("inv_brush","spr_cobblershop_brush");
end;
private.get_brush_beg = function()
  ObjDelete("gfx_cobblershop_brush")
end;
private.get_brush_end = function()
  if common_impl.ZzCompleteCheck("get_brush") then ObjSet( common_impl.hint["get_brush"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cobblershop_sh_brush");
end;

cmn.AddSubscriber( "get_brush", private.get_brush_inv );
cmn.AddSubscriber( "get_brush", private.get_brush_beg, private.room_objname );
cmn.AddSubscriber( "get_brush", private.get_brush_end, private.room_objname );
cmn.AddSubscriber( "get_brush", private.get_brush_logic );
--------------------------------------------------------------------
function public.get_brush()
  cmn.SetEventDone( "get_brush" );
  cmn.CallEventHandler( "get_brush" );
  if common_impl.ZzCompleteCheck("get_brush") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
  if not cmn.IsEventDone("clk_monumentbraceletcode") then 
       private.monument_braceletcode_get_parts_fp();
  end;  
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_darkquarter();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_darkquarter_env" );
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_cobblershop" );
  function zz_cobblershop.Open()
  end;
  function zz_cobblershop.PreOpen()
  end;
  function zz_cobblershop.PreClose()
  end;
  function zz_cobblershop.Close()
  end;

  subroom.Define( "zz_ads" );
  function zz_ads.Open()
  end;
  function zz_ads.PreOpen()
  end;
  function zz_ads.PreClose()
  end;
  function zz_ads.Close()
  end;

  subroom.Define( "zz_monument" );
  function zz_monument.Open()
  end;
  function zz_monument.PreOpen()
    if cmn.IsEventStart("clk_monumentbraceletcode") and not cmn.IsEventDone("clk_monumentbraceletcode") then 
       private.monument_braceletcode_init()
    end;  
  end;
  function zz_monument.PreClose()
  end;
  function zz_monument.Close()
  end;

  subroom.Define( "zz_mansiondoor" );
  function zz_mansiondoor.Open()
  end;
  function zz_mansiondoor.PreOpen()
  end;
  function zz_mansiondoor.PreClose()
  end;
  function zz_mansiondoor.Close()
  end;
  
end;
--*********************************************************************************************************************
--Other
function public.tabl_clk(num)
  local func_end=function()
    ObjSet( "obj_darkquarter_tabl"..num.."_clk_zone", {input = 1} );
    ObjSet( "anm_darkquarter_anm_back_tabl"..num, {animfunc = "tabl"..num.."_statik", frame = 0, playing=1 } );
  end;

  sfx = {"aud_touch_sign_left_darkquarter","aud_touch_sign_right_darkquarter"};
  
  SoundSfx( sfx[num] );
  ObjSet( "obj_darkquarter_tabl"..num.."_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_darkquarter_anm_back_tabl"..num, "tabl"..num.."_clic", func_end )
end;  
-----------------------------------------------------------------------------------------------------