-- name=rm_hall
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hall";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  ld.NoteInit("spr_exityard_text_small","spr_exityard_text_big");
  --------------------------------------------------------------------------------------------
function private.opn_hall()
  if not ( cmn.IsEventDone( "opn_hall" ) ) then
    cmn.SetEventDone( "opn_hall" );
    cmn.CallEventHandler( "opn_hall" )
  end;
end;
--------------------------------------------------------------------
local opn_hall = function() end;
local opn_hall_logic = function() end;
cmn.AddSubscriber( "opn_hall", opn_hall_logic )
cmn.AddSubscriber( "opn_hall", opn_hall, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_pierglass *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
function public.pierglass_idle_zone_clk()
  local func_end = function()
    ObjSet( "obj_pierglass_idle_zone_2", {input = 1} );
  end;
  

  ObjSet( "obj_pierglass_idle_zone_2", {input = 0} );
  SoundSfx( "aud_touch_crest_hall" )
  ld.AnimPlay( "anm_pierglass_anm_idle", "idle", func_end )
end;  

function public.pierglass_idle1_zone_clk()
  local func_end = function()
   ObjSet( "obj_pierglass_idle_zone", {input = 1} );
  end;
  

  ObjSet( "obj_pierglass_idle_zone", {input = 0} );
  SoundSfx( "aud_touch_perfume_hall" )
  ld.AnimPlay( "anm_pierglass_anm_idle1", "idle1", func_end )
end;  

----------------------------------------------------------------------------------------------------
common_impl.hint[ "get_rubyapple" ] = { type = "get", get_obj = "spr_pierglass_rubyapple", room = "rm_hall", zz = "zz_pierglass", zz_gate = "gzz_hall_pierglass" };

private.get_rubyapple_logic = function()
  
end;
private.get_rubyapple_inv = function()
  interface.InventoryItemAdd("inv_rubyapple","spr_pierglass_rubyapple");
end;
private.get_rubyapple_beg = function()
  ObjDelete("gfx_pierglass_rubyapple")
end;
private.get_rubyapple_end = function()
  if common_impl.ZzCompleteCheck("get_rubyapple") then ObjSet( common_impl.hint["get_rubyapple"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_pierglass_sh_apple");
end;

cmn.AddSubscriber( "get_rubyapple", private.get_rubyapple_inv );
cmn.AddSubscriber( "get_rubyapple", private.get_rubyapple_beg, private.room_objname );
cmn.AddSubscriber( "get_rubyapple", private.get_rubyapple_end, private.room_objname );
cmn.AddSubscriber( "get_rubyapple", private.get_rubyapple_logic );
--------------------------------------------------------------------
function public.get_rubyapple()
  cmn.SetEventDone( "get_rubyapple" );
  cmn.CallEventHandler( "get_rubyapple" );
  if common_impl.ZzCompleteCheck("get_rubyapple") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_cherry_zone_clk()
  local func_end = function()
    common_impl.ShowBbt( 'need_cherry' )
    ld.Lock(0);
  
  end;

  ld.Lock(1);
  ld.AnimPlay( "anm_pierglass_anm_cherry", "idle_b2", func_end )
  SoundSfx( "aud_touch_drawer_hall" )
end;  



common_impl.hint[ "use_cherry" ] = { type = "use", inv_obj = "inv_cherry", use_place = "gfx_pierglass_cherry_zone", room = "rm_hall", zz = "zz_pierglass", zz_gate = "gzz_hall_pierglass" };

private.use_cherry_logic = function()
  ObjSet( "spr_pierglass_medallion3", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_pierglass_medallion3", { visible = 1, active = 1 } );
end;
private.use_cherry_inv = function()
  common_impl.ProcessMultiUseAll("cherry", "cherry")
end;
private.use_cherry_beg = function()
  ObjDelete( "gfx_pierglass_cherry_zone" );
end;
private.use_cherry_end = function()
  if common_impl.ZzCompleteCheck("use_cherry") then ObjSet( common_impl.hint["use_cherry"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_pierglass_anm_cherry", {animfunc = "use_cherry", frame = 999 } );
  ObjSet( "spr_hall_cherry", {visible = 1} );
  ObjSet( "spr_hall_box_1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cherry", private.use_cherry_inv );
cmn.AddSubscriber( "use_cherry", private.use_cherry_beg, private.room_objname );
cmn.AddSubscriber( "use_cherry", private.use_cherry_end, private.room_objname );
cmn.AddSubscriber( "use_cherry", private.use_cherry_logic );
cmn.AddSubscriber( "use_cherry_inv", private.use_cherry_inv, private.room_objname );
cmn.AddSubscriber( "use_cherry_beg", private.use_cherry_beg, private.room_objname );
cmn.AddSubscriber( "use_cherry_end", private.use_cherry_end, private.room_objname );
cmn.AddSubscriber( "use_cherry_end", private.use_cherry_logic );
--------------------------------------------------------------------------------------------
function public.use_cherry( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cherry" );
    cmn.CallEventHandler( "use_cherry_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cherry") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cherry_inv" );
  cmn.CallEventHandler( "use_cherry_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pierglass_anm_cherry", "use_cherry", func_end );
  SoundSfx( "aud_use_cherry_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_medallion3" ] = { type = "get", get_obj = "spr_pierglass_medallion3", room = "rm_hall", zz = "zz_pierglass", zz_gate = "gzz_hall_pierglass" };

private.get_medallion3_logic = function()
  
end;
private.get_medallion3_inv = function()
  interface.InventoryItemAdd("inv_medallion","spr_pierglass_medallion3",function() level_inv.ProcessGetMedallionAll( "get_medallion3" ) end);
end;
private.get_medallion3_beg = function()
  ObjDelete("gfx_pierglass_medallion3")
end;
private.get_medallion3_end = function()
  if common_impl.ZzCompleteCheck("get_medallion3") then ObjSet( common_impl.hint["get_medallion3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_pierglass_anm_cherry", {animfunc = "end_cherry", frame = 0 } );
end;

cmn.AddSubscriber( "get_medallion3", private.get_medallion3_inv );
cmn.AddSubscriber( "get_medallion3", private.get_medallion3_beg, private.room_objname );
cmn.AddSubscriber( "get_medallion3", private.get_medallion3_end, private.room_objname );
cmn.AddSubscriber( "get_medallion3", private.get_medallion3_logic );
--------------------------------------------------------------------
function public.get_medallion3()
  ObjSet( "spr_pierglass_medallion3", {visible = 1} );
  cmn.SetEventDone( "get_medallion3" );
  cmn.CallEventHandler( "get_medallion3" );
  if common_impl.ZzCompleteCheck("get_medallion3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_rose_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_rose' )
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_drawer_hall" )
  ld.AnimPlay( "anm_pierglass_anm_rose", "idle_b1", func_end )
end  


common_impl.hint[ "use_rose" ] = { type = "use", inv_obj = "inv_rose", use_place = "gfx_pierglass_rose_zone", room = "rm_hall", zz = "zz_pierglass", zz_gate = "gzz_hall_pierglass" };

private.use_rose_logic = function()
  ObjSet( "spr_pierglass_vignette", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_pierglass_vignette", {active = 1, visible = 1} );
end;
private.use_rose_inv = function()
  common_impl.ProcessMultiUseAll("rose", "rose")
end;
private.use_rose_beg = function()
  ObjDelete( "gfx_pierglass_rose_zone" );
end;
private.use_rose_end = function()
  if common_impl.ZzCompleteCheck("use_rose") then ObjSet( common_impl.hint["use_rose"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_pierglass_anm_rose", {animfunc = "use_rose", frame = 999  } );
  ObjSet( "obj_hall_pierglass_roses_root", {visible = 1} );
  ObjSet( "spr_hall_box_2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rose", private.use_rose_inv );
cmn.AddSubscriber( "use_rose", private.use_rose_beg, private.room_objname );
cmn.AddSubscriber( "use_rose", private.use_rose_end, private.room_objname );
cmn.AddSubscriber( "use_rose", private.use_rose_logic );
cmn.AddSubscriber( "use_rose_inv", private.use_rose_inv, private.room_objname );
cmn.AddSubscriber( "use_rose_beg", private.use_rose_beg, private.room_objname );
cmn.AddSubscriber( "use_rose_end", private.use_rose_end, private.room_objname );
cmn.AddSubscriber( "use_rose_end", private.use_rose_logic );
--------------------------------------------------------------------------------------------
function public.use_rose( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_rose" );
    cmn.CallEventHandler( "use_rose_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rose") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rose_inv" );
  cmn.CallEventHandler( "use_rose_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pierglass_anm_rose", "use_rose", func_end );
  SoundSfx( "aud_use_rose_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_vignette" ] = { type = "get", get_obj = "spr_pierglass_vignette", room = "rm_hall", zz = "zz_pierglass", zz_gate = "gzz_hall_pierglass" };

private.get_vignette_logic = function()
  
end;
private.get_vignette_inv = function()
  interface.InventoryItemAdd("inv_vignette","spr_pierglass_vignette");
  ObjSet( "inv_vignette", { drag = 0 } );
end;
private.get_vignette_beg = function()
  ObjDelete("gfx_pierglass_vignette")
end;
private.get_vignette_end = function()
  if common_impl.ZzCompleteCheck("get_vignette") then ObjSet( common_impl.hint["get_vignette"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_pierglass_anm_rose", {animfunc = "end_rose", frame = 0 } );
end;

cmn.AddSubscriber( "get_vignette", private.get_vignette_inv );
cmn.AddSubscriber( "get_vignette", private.get_vignette_beg, private.room_objname );
cmn.AddSubscriber( "get_vignette", private.get_vignette_end, private.room_objname );
cmn.AddSubscriber( "get_vignette", private.get_vignette_logic );
--------------------------------------------------------------------
function public.get_vignette()
  ObjSet( "spr_pierglass_vignette", {visible = 1} );
  cmn.SetEventDone( "get_vignette" );
  cmn.CallEventHandler( "get_vignette" );
  if common_impl.ZzCompleteCheck("get_vignette") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_windowyard *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_silvershard" ] = { type = "get", get_obj = "spr_windowyard_silvershard", room = "rm_hall", zz = "zz_windowyard", zz_gate = "gzz_hall_windowyard" };

private.get_silvershard_logic = function()
  ObjSet( "gfx_windowyard_redpaint_zone", {active=1, input = 1, visible = 1} );
  ObjSet( "gfx_windowyard_pinkpaint_zone", {active=1, input=1, visible=1} );
end;
private.get_silvershard_inv = function()
  interface.InventoryItemAdd("inv_silvershard","spr_windowyard_silvershard");
end;
private.get_silvershard_beg = function()
  ObjDelete("gfx_windowyard_silvershard")
end;
private.get_silvershard_end = function()
  if common_impl.ZzCompleteCheck("get_silvershard") then ObjSet( common_impl.hint["get_silvershard"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_windowyard_sh_silvershard");
  ObjDelete("obj_windowyard_paint_idle_zone");
  ObjDelete("spr_hall_silvershard");
end;

cmn.AddSubscriber( "get_silvershard", private.get_silvershard_inv );
cmn.AddSubscriber( "get_silvershard", private.get_silvershard_beg, private.room_objname );
cmn.AddSubscriber( "get_silvershard", private.get_silvershard_end, private.room_objname );
cmn.AddSubscriber( "get_silvershard", private.get_silvershard_logic );
--------------------------------------------------------------------
function public.get_silvershard()
  cmn.SetEventDone( "get_silvershard" );
  cmn.CallEventHandler( "get_silvershard" );
  if common_impl.ZzCompleteCheck("get_silvershard") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_paint_zones_clk()
  local func_end = function()
    ld.Lock(0);
  end;
  
  ld.Lock(1);
  ld.AnimPlay( "anm_windowyard_anm", "idle", func_end )
  SoundSfx( "aud_touch_paint_hall" )
end;  




common_impl.hint[ "use_redpaint" ] = { type = "use", inv_obj = "inv_redpaint", use_place = "gfx_windowyard_redpaint_zone", room = "rm_hall", zz = "zz_windowyard", zz_gate = "gzz_hall_windowyard" };

private.use_redpaint_logic = function()
  if ld.CheckRequirements( {"use_redpaint","use_pinkpaint"} ) then
    ObjSet( "obj_windowyard_mmg_root", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_redpaint_inv = function()
  common_impl.ProcessMultiUseAll("redpaint", "redpaint")
end;
private.use_redpaint_beg = function()
  ObjDelete( "gfx_windowyard_redpaint_zone" );
end;
private.use_redpaint_end = function()
  if common_impl.ZzCompleteCheck("use_redpaint") then ObjSet( common_impl.hint["use_redpaint"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_windowyard_anm_orange", {animfunc = "use_orange", frame = 999 } );
  if ld.CheckRequirements( {"use_pinkpaint","use_redpaint"} ) then
    ObjSet( "anm_windowyard_anm", {animfunc = "end_paint", frame = 0 } ); 
    ObjSet( "spr_windowyard_sh_brush", {visible = 1} );
    ObjSet( "spr_windowyard_brush", {input = 1, visible = 1,drag=1} );
  end; 
  ObjSet( "spr_hall_orange_paint", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_redpaint", private.use_redpaint_inv );
cmn.AddSubscriber( "use_redpaint", private.use_redpaint_beg, private.room_objname );
cmn.AddSubscriber( "use_redpaint", private.use_redpaint_end, private.room_objname );
cmn.AddSubscriber( "use_redpaint", private.use_redpaint_logic );
cmn.AddSubscriber( "use_redpaint_inv", private.use_redpaint_inv, private.room_objname );
cmn.AddSubscriber( "use_redpaint_beg", private.use_redpaint_beg, private.room_objname );
cmn.AddSubscriber( "use_redpaint_end", private.use_redpaint_end, private.room_objname );
cmn.AddSubscriber( "use_redpaint_end", private.use_redpaint_logic );
--------------------------------------------------------------------------------------------
function public.use_redpaint( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_redpaint" );
    cmn.CallEventHandler( "use_redpaint_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_redpaint") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_pinkpaint","use_redpaint"} ) then
       private.init_paintmmg()    
       cmn.MiniGameShow( "paintmmg" );    
    end;  
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_redpaint_inv" );
  cmn.CallEventHandler( "use_redpaint_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_windowyard_anm_orange", "use_orange", func_end );
  SoundSfx( "aud_use_redpaint_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pinkpaint" ] = { type = "use", inv_obj = "inv_pinkpaint", use_place = "gfx_windowyard_pinkpaint_zone", room = "rm_hall", zz = "zz_windowyard", zz_gate = "gzz_hall_windowyard" };

private.use_pinkpaint_logic = function()
  if ld.CheckRequirements( {"use_pinkpaint","use_redpaint"} ) then
    ObjSet( "obj_windowyard_mmg_root", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_pinkpaint_inv = function()
  common_impl.ProcessMultiUseAll("pinkpaint", "pinkpaint")
end;
private.use_pinkpaint_beg = function()
  ObjDelete( "gfx_windowyard_pinkpaint_zone" );
end;
private.use_pinkpaint_end = function()
  if common_impl.ZzCompleteCheck("use_pinkpaint") then ObjSet( common_impl.hint["use_pinkpaint"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_windowyard_anm_pink", {animfunc = "use_pink", frame = 999 } );
  if ld.CheckRequirements( {"use_pinkpaint","use_redpaint"} ) then
    ObjSet( "anm_windowyard_anm", {animfunc = "end_paint", frame = 0 } ); 
    ObjSet( "spr_windowyard_sh_brush", {visible = 1} );
    ObjSet( "spr_windowyard_brush", {input = 1, visible = 1,drag=1} );
  end;   
  ObjSet( "spr_hall_pink_paint", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pinkpaint", private.use_pinkpaint_inv );
cmn.AddSubscriber( "use_pinkpaint", private.use_pinkpaint_beg, private.room_objname );
cmn.AddSubscriber( "use_pinkpaint", private.use_pinkpaint_end, private.room_objname );
cmn.AddSubscriber( "use_pinkpaint", private.use_pinkpaint_logic );
cmn.AddSubscriber( "use_pinkpaint_inv", private.use_pinkpaint_inv, private.room_objname );
cmn.AddSubscriber( "use_pinkpaint_beg", private.use_pinkpaint_beg, private.room_objname );
cmn.AddSubscriber( "use_pinkpaint_end", private.use_pinkpaint_end, private.room_objname );
cmn.AddSubscriber( "use_pinkpaint_end", private.use_pinkpaint_logic );
--------------------------------------------------------------------------------------------
function public.use_pinkpaint( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pinkpaint" );
    cmn.CallEventHandler( "use_pinkpaint_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pinkpaint") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_pinkpaint","use_redpaint"} ) then
       private.init_paintmmg()    
       cmn.MiniGameShow( "paintmmg" );    
    end;  
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pinkpaint_inv" );
  cmn.CallEventHandler( "use_pinkpaint_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_windowyard_anm_pink", "use_pink", func_end );
  SoundSfx( "aud_use_pinkpaint_hall" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_paintmmg" ] = { type = "click", use_place = "obj_windowyard_mmg_root", room = "rm_hall", zz = "zz_windowyard", zz_gate = "gzz_hall_windowyard" };

private.win_paintmmg_logic = function()
  if cmn.IsEventDone("win_paintmmg") then 
    ObjSet( "gfx_windowyard_dragonfly", {active=1, visible=1} );
    ObjSet( "spr_windowyard_dragonfly", { visible = 0, input = 1, active = 1 } )
    ObjSet( "obj_windowyard_mmg_root", {visible=0, input = 0} );
  end;
end;
private.win_paintmmg_beg = function()
 -- ObjDelete( "gfx_windowyard_win_paintmmg_zone" );
end;
private.win_paintmmg_end = function()
  if cmn.IsEventDone("win_paintmmg") then 
      if common_impl.ZzCompleteCheck("win_paintmmg") then ObjSet( common_impl.hint["win_paintmmg"].zz_gate, { visible = 0, input = 0 } ); end;
      ObjSet( "anm_windowyard_anm", {animfunc = "end_mmg", frame = 999 } );
      ObjDelete("anm_windowyard_anm_orange")
      ObjDelete("anm_windowyard_anm_pink")
      ObjDelete("spr_windowyard_brush")
      ObjDelete("spr_windowyard_sh_brush")
      --  ObjSet( "spr_windowyard_tr_dragonfly", {visible = 1} );
      ObjSet( "obj_hall_windowyard_mmg_win_root", {visible = 1} );
    end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_paintmmg", private.win_paintmmg_beg, private.room_objname );
cmn.AddSubscriber( "win_paintmmg", private.win_paintmmg_end, private.room_objname );
cmn.AddSubscriber( "win_paintmmg", private.win_paintmmg_logic );
cmn.AddSubscriber( "win_paintmmg_beg", private.win_paintmmg_beg, private.room_objname );
cmn.AddSubscriber( "win_paintmmg_end", private.win_paintmmg_end, private.room_objname );
cmn.AddSubscriber( "win_paintmmg_end", private.win_paintmmg_logic );
--------------------------------------------------------------------------------------------
function public.win_paintmmg()

  local func_end = function()
    cmn.SetEventDone( "win_paintmmg" );
    cmn.CallEventHandler( "win_paintmmg_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_paintmmg") then ld.CloseSubRoom() end;
  end;

  
  local func_preend = function()
    ObjSet( "obj_windowyard_mmg_root", {visible = 0} );
    ObjSet( "anm_windowyard_anm_pink", {visible = 0} );
    ObjSet( "anm_windowyard_anm_orange", {visible = 0} );
    ObjSet( "spr_windowyard_brush", {visible = 0} );
    ObjSet( "spr_windowyard_sh_brush", {visible = 0} );
    ObjSet( "anm_windowyard_anm", {animfunc = "end_mmg", frame = 0 } );
    ld.AnimPlay( "anm_windowyard_anm", "end_mmg", func_end )
  end;
  
  
  
  cmn.CallEventHandler( "win_paintmmg_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )

  cmn.MiniGameHide( "paintmmg",true ); 
  for i=1,4,1 do 
    local my_alp=ObjGet("spr_windowyard_light_"..private.win_paintmmg_names_root[i]).alp;
    ObjAnimate( "spr_windowyard_light_"..private.win_paintmmg_names_root[i], 8, 0, 0, function() end, {0,0,my_alp, 0.5,0,0} );
  end;  
  local brush_alp = ObjGet("spr_windowyard_tr_brush").alp;
  ObjAnimate( "spr_windowyard_tr_brush", 8, 0, 0, function() end, {0,0,brush_alp, 0.5,0,0} );
  
  ld.StartTimer( 0.5, func_preend )
  SoundSfx( "aud_mg_windowyard_win" );
end;

--------------------------------------------------------------------------------------------------------------
function private.win_paintmmg_skip()
  ObjStopDrag("spr_windowyard_brush");
  
  local func_end = function()
    private.win_paintmmg_state={{1,2,3,4},{1,1,1,1}};
    private.win_paintmmg_stand_pos(1);
    ObjAnimate( "obj_windowyard_mmg_root", 8, 0, 0, public.win_paintmmg, {0,0,0, 0.5,0,1} );
  end;
  
  ld.Lock(1);
  private.win_paintmmg_select_part=0;
  ObjAnimate( "obj_windowyard_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  

function private.win_paintmmg_reset()

  local func_end = function()
    private.win_paintmmg_state=ld.TableCopy(private.win_paintmmg_fp_array);
    ng_global.progress["std"]["win_paintmmg"].state =  private.win_paintmmg_state;
    private.win_paintmmg_stand_pos();
    ObjAnimate( "obj_windowyard_mmg_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.5,0,1} );
  end;
  
  ld.Lock(1);
  private.win_paintmmg_select_part=0;
  private.win_paintmmg_select_color=0;
  ObjSet( "spr_windowyard_tr_brush",{visible=0, alp=0})
  ObjAnimate( "obj_windowyard_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  





private.win_paintmmg_names_root={"butterfly","dragonfly1","fly","grasshopper"};
private.win_paintmmg_parts_xy_pos={};
private.win_paintmmg_init_flag=false;
private.win_paintmmg_state={{1,2,3,4},{0,0,0,0}};
private.win_paintmmg_fp_array={{3,4,2,1},{0,0,0,0}}  --first positions
private.win_paintmmg_select_part=0;

function private.win_paintmmg_parts_init()
   if private.win_paintmmg_init_flag==false then 
      for i=1,4,1 do 
         private.win_paintmmg_parts_xy_pos[i] = {ObjGet("obj_windowyard_mmg_part"..i).pos_x,ObjGet("obj_windowyard_mmg_part"..i).pos_y};
         ObjSet( "obj_windowyard_mmg_part"..i, {input=1, inputrect_init=1, inputrect_w=100, inputrect_h=100, inputrect_x=-50, inputrect_y=-50,
         event_mdown="rm_hall.win_paintmmg_part_mdown("..i..");", event_menter="rm_hall.win_paintmmg_part_menter("..i..");", event_mleave="rm_hall.win_paintmmg_part_mleave("..i..");"} );
      end; 
      private.win_paintmmg_init_flag=true; 
   end;  
end;

function private.win_paintmmg_stand_on_fp()
  for i=1,4,1 do 
    ObjSet( "obj_windowyard_mmg_part"..i, {pos_x=private.win_paintmmg_parts_xy_pos[private.win_paintmmg_fp_array[1][i] ][1],pos_y=private.win_paintmmg_parts_xy_pos[private.win_paintmmg_fp_array[1][i] ][2]} );
     ObjSet( "spr_windowyard_"..private.win_paintmmg_names_root[i], {visible=0} );
     ObjSet( "spr_windowyard_light_"..private.win_paintmmg_names_root[i], {visible=0} );
  end;  
end;  
  
 function private.win_paintmmg_stand_pos(without_win_ver)  
  local brush_count=0; 
  for i=1,4,1 do 
     local cur_pos_num = private.win_paintmmg_state[1][i]
   --  ld.LogTrace( "cur_pos_num = "..cur_pos_num );
     local my_z=5; if i>2 then my_z=6; end;
     ObjSet( "obj_windowyard_mmg_part"..i, {pos_x=private.win_paintmmg_parts_xy_pos[cur_pos_num][1],pos_y=private.win_paintmmg_parts_xy_pos[cur_pos_num][2], pos_z=my_z} );
     ObjSet( "spr_windowyard_"..private.win_paintmmg_names_root[i], {visible=private.win_paintmmg_state[2][i]} );
     if  private.win_paintmmg_state[1][i]==i and  private.win_paintmmg_state[2][i]==1 then 
        ObjSet( "spr_windowyard_light_"..private.win_paintmmg_names_root[i], {visible=1, alp=1, color_r=0, color_g=1, color_b=0} );
     else
        ObjSet( "spr_windowyard_light_"..private.win_paintmmg_names_root[i], {visible=0} );
     end; 
     if  private.win_paintmmg_state[2][i]==1 then brush_count=brush_count+1; end;
   end; 
   if brush_count==4 then ObjSet("spr_windowyard_brush",{input=0, drag=0});  private.paintmmg_sbros_nah=true;ObjStopDrag("spr_windowyard_brush"); else ObjSet("spr_windowyard_brush",{input=1, drag=1}) end;
   if without_win_ver~=1 then private.win_paintmmg_win_ver(); end;
end;  
  
function private.win_paintmmg_win_ver()
  count=0;
  for i=1,4,1 do
     if private.win_paintmmg_state[1][i]==i and private.win_paintmmg_state[2][i]==1 then count=count+1; end;
  end;  
   if count==4 then ObjStopDrag("spr_windowyard_brush");  public.win_paintmmg(); end;
end;  
  
  
function private.init_paintmmg()
  if not (cmn.IsEventStart("win_paintmmg")) then
    ng_global.progress["std"]["win_paintmmg"].state = {}
    private.win_paintmmg_state= ld.TableCopy(private.win_paintmmg_fp_array);
    ng_global.progress["std"]["win_paintmmg"].state =  private.win_paintmmg_state;
  else  
    private.win_paintmmg_state=ng_global.progress["std"]["win_paintmmg"].state;
  end
  private.win_paintmmg_stand_pos();  
end
------------------------------------------------------------------------------------------------------------
function public.win_paintmmg_part_menter(num)
   ld.SetCursor(CURSOR_HAND);
end;  

function  public.win_paintmmg_part_mleave(num)
   ld.SetCursor(CURSOR_DEFAULT);
end;

function public.win_paintmmg_part_mdown(num)
   local func_end = function()
      ld.Lock(0);
      ObjSet( "obj_windowyard_mmg_part"..num, {pos_z=5} );
      ObjSet( "obj_windowyard_mmg_part"..private.win_paintmmg_select_part, {pos_z=5} );
      local buf =  private.win_paintmmg_state[1][num];
      private.win_paintmmg_state[1][num] = private.win_paintmmg_state[1][private.win_paintmmg_select_part];
      private.win_paintmmg_state[1][private.win_paintmmg_select_part] = buf;
      private.win_paintmmg_select_part=0;
      private.win_paintmmg_stand_pos() 
   end; 
  
  
   if private.win_paintmmg_select_part==0 then 
      private.win_paintmmg_select_part=num;
      ObjSet( "spr_windowyard_light_"..private.win_paintmmg_names_root[num], {visible = 1, alp=1, color_r=0, color_g=0, color_b=1} );
   elseif private.win_paintmmg_select_part==num then 
      private.win_paintmmg_select_part=0;
      ObjSet( "spr_windowyard_light_"..private.win_paintmmg_names_root[num], {visible = 0, alp=1, color_r=1, color_g=1, color_b=1} );
      private.win_paintmmg_stand_pos(); 
   else 
      SoundSfx( "aud_mg_windowyard_move" );
      ld.Lock(1);
      local num_pos={ObjGet("obj_windowyard_mmg_part"..num).pos_x,ObjGet("obj_windowyard_mmg_part"..num).pos_y}
      local selected_pos={ObjGet("obj_windowyard_mmg_part"..private.win_paintmmg_select_part).pos_x,ObjGet("obj_windowyard_mmg_part"..private.win_paintmmg_select_part).pos_y}
      ObjSet( "spr_windowyard_light_"..private.win_paintmmg_names_root[num], {visible = 1, alp=1, color_r=0, color_g=0, color_b=1} );
      ObjSet( "spr_windowyard_light_"..private.win_paintmmg_names_root[ private.win_paintmmg_select_part], {visible = 1, alp=1, color_r=0, color_g=0, color_b=1} );
      ObjSet( "obj_windowyard_mmg_part"..num, {pos_z=10} );
      ObjSet( "obj_windowyard_mmg_part"..private.win_paintmmg_select_part, {pos_z=10} );
      ObjAnimate( "obj_windowyard_mmg_part"..num, 3, 0, 0, function() end, {0,0,num_pos[1],num_pos[2], 0.5,0,selected_pos[1],selected_pos[2]} );
      ObjAnimate( "obj_windowyard_mmg_part"..private.win_paintmmg_select_part, 3, 0, 0, func_end, {0,0,selected_pos[1],selected_pos[2], 0.5,0,num_pos[1],num_pos[2]} );
   end;  
  
end  

---------------------------------------------------------------------
private.win_paintmmg_colors_array={{0,40/255,142/255},{0,130/255,45/255},{185/255,0,150/255},{145/255,80/255,0}}-- blue, green, pink, orange
private.win_paintmmg_select_color=0;
private.win_paintmmg_true_color={3,2,1,4};

function public.win_paintmmg_brush_startdrag()
   ld.StartTimer( 0.1, function()  ld.SetCursor(CURSOR_NULL); end )
   ObjSet( "spr_windowyard_sh_brush", {visible = 0} );
   ObjSet( "spr_windowyard_brush", {pos_z=50, ang=-1} );
   SoundSfx( "aud_mg_windowyard_get" )
end;
 
function public.win_paintmmg_brush_drag()
   if not ApplyObj("obj_windowyard_brush_center_zone","zz_windowyard") then ObjStopDrag("spr_windowyard_brush"); end;
end;  
 
 
private.paintmmg_sbros_nah=false;  
function public.win_paintmmg_brush_dragdrop()
  local color_flag=false;
  local obj_flag=false;
  for i=1,4,1 do 
    if ApplyObj("spr_windowyard_tr_brush","obj_win_paintmmg_color"..i) then 
       SoundSfx( "aud_mg_windowyard_paint" )
       private.win_paintmmg_select_color=i;
       color_flag = true;
       ObjSet( "spr_windowyard_tr_brush", {visible=1, alp=1, color_r=private.win_paintmmg_colors_array[i][1], color_g=private.win_paintmmg_colors_array[i][2], color_b=private.win_paintmmg_colors_array[i][3]} );
    end;
    if ApplyObj("spr_windowyard_tr_brush","spr_windowyard_tr_"..private.win_paintmmg_names_root[i]) then 
        obj_flag=true;
        private.win_paintmmg_part_paint(i)
    end;  
     
  end;  
  
  if  (color_flag~=false or obj_flag~=false) and private.paintmmg_sbros_nah~=true then 
      --ObjDoNotDrop("spr_windowyard_brush");
  else 
      SoundSfx( "aud_mg_windowyard_release" );
      ld.SetCursor(CURSOR_DEFAULT);
      ObjSet( "spr_windowyard_sh_brush", {visible = 1} );
      ObjSet( "spr_windowyard_brush", {pos_z=30, ang=0} );
      private.paintmmg_sbros_nah=false; 
  end;
   
end;  
  
  
function private.win_paintmmg_part_paint(num)
  local func_end = function()
     ld.Lock(0);
     private.win_paintmmg_stand_pos();  
  end;

 
  if private.win_paintmmg_state[2][num]==0 then 
     ld.Lock(1);
     if private.win_paintmmg_true_color[num]==private.win_paintmmg_select_color then 
        private.win_paintmmg_state[2][num]=1;
        ObjSet( "spr_windowyard_"..private.win_paintmmg_names_root[num], {visible = 1, alp=0} );
        ObjAnimate( "spr_windowyard_"..private.win_paintmmg_names_root[num], 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
        SoundSfx( "aud_mg_windowyard_true" )
     else 
        ObjSet( "spr_windowyard_light_"..private.win_paintmmg_names_root[num], {visible=1, alp=0, color_r=1, color_g=0, coor_b=0} );
        ObjAnimate( "spr_windowyard_light_"..private.win_paintmmg_names_root[num], 8, 0, 0, func_end, {0,0,0, 0.25,0,1, 0.5,0,0} );
        SoundSfx( "aud_mg_windowyard_wrong" )
     end;  
  end;  
end;  
 -------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_dragonfly" ] = { type = "get", get_obj = "spr_windowyard_dragonfly", room = "rm_hall", zz = "zz_windowyard", zz_gate = "gzz_hall_windowyard" };

private.get_dragonfly_logic = function()
  
end;
private.get_dragonfly_inv = function()
  interface.InventoryItemAdd("inv_dragonfly","spr_windowyard_dragonfly");
end;
private.get_dragonfly_beg = function()
  ObjDelete("gfx_windowyard_dragonfly")
end;
private.get_dragonfly_end = function()
  if common_impl.ZzCompleteCheck("get_dragonfly") then ObjSet( common_impl.hint["get_dragonfly"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjDelete("spr_windowyard_tr_dragonfly")
  ObjSet( "anm_windowyard_anm", {animfunc = "end_mmg1", frame = 0 } );
  ObjDelete("spr_hall_tr_dragonfly1");
  ObjDelete("spr_hall_dragonfly1")
  ObjDelete("spr_hall_dragonfly")
end;

cmn.AddSubscriber( "get_dragonfly", private.get_dragonfly_inv );
cmn.AddSubscriber( "get_dragonfly", private.get_dragonfly_beg, private.room_objname );
cmn.AddSubscriber( "get_dragonfly", private.get_dragonfly_end, private.room_objname );
cmn.AddSubscriber( "get_dragonfly", private.get_dragonfly_logic );
--------------------------------------------------------------------
function public.get_dragonfly()
  ObjSet( "spr_windowyard_dragonfly", {visible = 1} );
  cmn.SetEventDone( "get_dragonfly" );
  cmn.CallEventHandler( "get_dragonfly" );
  if common_impl.ZzCompleteCheck("get_dragonfly") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_clock *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_portraitpart1" ] = { type = "get", get_obj = "spr_clock_portraitpart1", room = "rm_hall", zz = "zz_clock", zz_gate = "gzz_hall_clock" };

private.get_portraitpart1_logic = function()
  
end;
private.get_portraitpart1_inv = function()
  interface.InventoryItemAdd("inv_portraitpart","spr_clock_portraitpart1",function() level_inv.ProcessGetPortraitpartAll( "get_portraitpart1" ) end);
end;
private.get_portraitpart1_beg = function()
  ObjDelete("gfx_clock_portraitpart1")
end;
private.get_portraitpart1_end = function()
  if common_impl.ZzCompleteCheck("get_portraitpart1") then ObjSet( common_impl.hint["get_portraitpart1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_clock_sh_portraitpart1");
  ObjDelete("spr_hall_portraitpart1");
end;

cmn.AddSubscriber( "get_portraitpart1", private.get_portraitpart1_inv );
cmn.AddSubscriber( "get_portraitpart1", private.get_portraitpart1_beg, private.room_objname );
cmn.AddSubscriber( "get_portraitpart1", private.get_portraitpart1_end, private.room_objname );
cmn.AddSubscriber( "get_portraitpart1", private.get_portraitpart1_logic );
--------------------------------------------------------------------
function public.get_portraitpart1()
  cmn.SetEventDone( "get_portraitpart1" );
  cmn.CallEventHandler( "get_portraitpart1" );
  if common_impl.ZzCompleteCheck("get_portraitpart1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_silvershard_zone_clk()
  local func_end = function()
     common_impl.ShowBbt( 'need_silvershard' )
     ld.Lock(0);
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_clock_cover_hall" )
  ld.AnimPlay( "anm_clock_anm_clock_silver", "idle_door2", func_end )
end;  

common_impl.hint[ "use_silvershard" ] = { type = "use", inv_obj = "inv_silvershard", use_place = "gfx_clock_silvershard_zone", room = "rm_hall", zz = "zz_clock", zz_gate = "gzz_hall_clock" };

private.use_silvershard_logic = function()
  if ld.CheckRequirements( {"use_silvershard","use_goldshard"} ) then
    ObjSet( "spr_clock_amuleteye", { visible = 1, input = 1, active = 1 } )
    ObjSet( "gfx_clock_amuleteye", {active = 1, visible = 1} );
  end;

end;
private.use_silvershard_inv = function()
  common_impl.ProcessMultiUseAll("silvershard", "silvershard")
end;
private.use_silvershard_beg = function()
  ObjDelete( "gfx_clock_silvershard_zone" );
end;
private.use_silvershard_end = function()
  if common_impl.ZzCompleteCheck("use_silvershard") then ObjSet( common_impl.hint["use_silvershard"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_clock_anm_clock_silver");
  ObjDelete("spr_hall_door2");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_silvershard", private.use_silvershard_inv );
cmn.AddSubscriber( "use_silvershard", private.use_silvershard_beg, private.room_objname );
cmn.AddSubscriber( "use_silvershard", private.use_silvershard_end, private.room_objname );
cmn.AddSubscriber( "use_silvershard", private.use_silvershard_logic );
cmn.AddSubscriber( "use_silvershard_inv", private.use_silvershard_inv, private.room_objname );
cmn.AddSubscriber( "use_silvershard_beg", private.use_silvershard_beg, private.room_objname );
cmn.AddSubscriber( "use_silvershard_end", private.use_silvershard_end, private.room_objname );
cmn.AddSubscriber( "use_silvershard_end", private.use_silvershard_logic );
--------------------------------------------------------------------------------------------
function public.use_silvershard( obj )

  local func_end = function()
    ObjSet( "anm_clock_anm_clock_silver", {pos_z=15} );
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_silvershard" );
    cmn.CallEventHandler( "use_silvershard_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_silvershard") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_silvershard_inv" );
  cmn.CallEventHandler( "use_silvershard_beg" );
  common_impl.Lock(1);

  if not ld.CheckRequirements( {"get_portraitpart1"} ) then ObjSet( "anm_clock_anm_clock_silver", {pos_z=32} ); end;
  
  ld.AnimPlay( "anm_clock_anm_clock_silver", "use_silver", func_end );
  SoundSfx( "aud_use_silvershard_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_goldshard_zone_clk()
  local func_end = function()
     common_impl.ShowBbt( 'need_goldshard' )
     ld.Lock(0);
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_clock_cover_hall" )
  ld.AnimPlay( "anm_clock_anm_clock_gold", "idle_door1", func_end )
end;  


common_impl.hint[ "use_goldshard" ] = { type = "use", inv_obj = "inv_goldshard", use_place = "gfx_clock_goldshard_zone", room = "rm_hall", zz = "zz_clock", zz_gate = "gzz_hall_clock" };

private.use_goldshard_logic = function()
  if ld.CheckRequirements( {"use_goldshard","use_silvershard"} ) then
    ObjSet( "spr_clock_amuleteye", { visible = 1, input = 1, active = 1 } )
    ObjSet( "gfx_clock_amuleteye", {active = 1, visible = 1} );
  end;

end;
private.use_goldshard_inv = function()
  common_impl.ProcessMultiUseAll("goldshard", "goldshard")
end;
private.use_goldshard_beg = function()
  ObjDelete( "gfx_clock_goldshard_zone" );
end;
private.use_goldshard_end = function()
  if common_impl.ZzCompleteCheck("use_goldshard") then ObjSet( common_impl.hint["use_goldshard"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_clock_anm_clock_gold");
  ObjDelete("spr_hall_door1")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_goldshard", private.use_goldshard_inv );
cmn.AddSubscriber( "use_goldshard", private.use_goldshard_beg, private.room_objname );
cmn.AddSubscriber( "use_goldshard", private.use_goldshard_end, private.room_objname );
cmn.AddSubscriber( "use_goldshard", private.use_goldshard_logic );
cmn.AddSubscriber( "use_goldshard_inv", private.use_goldshard_inv, private.room_objname );
cmn.AddSubscriber( "use_goldshard_beg", private.use_goldshard_beg, private.room_objname );
cmn.AddSubscriber( "use_goldshard_end", private.use_goldshard_end, private.room_objname );
cmn.AddSubscriber( "use_goldshard_end", private.use_goldshard_logic );
--------------------------------------------------------------------------------------------
function public.use_goldshard( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_goldshard" );
    cmn.CallEventHandler( "use_goldshard_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_goldshard") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_goldshard_inv" );
  cmn.CallEventHandler( "use_goldshard_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_clock_anm_clock_gold", "use_gold", func_end );
  SoundSfx( "aud_use_goldshard_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuleteye" ] = { type = "get", get_obj = "spr_clock_amuleteye", room = "rm_hall", zz = "zz_clock", zz_gate = "gzz_hall_clock" };

private.get_amuleteye_logic = function()
  ObjSet( "gfx_clock_numeral_zone", {active=1, input = 1, visible = 1} );
  ObjSet( "gfx_clock_numeral2_zone", {active=1, input = 1, visible = 1} );
end;
private.get_amuleteye_inv = function()
  interface.InventoryItemAdd("inv_amuleteye","spr_clock_amuleteye");
end;
private.get_amuleteye_beg = function()
  ObjDelete("gfx_clock_amuleteye")
end;
private.get_amuleteye_end = function()
  if common_impl.ZzCompleteCheck("get_amuleteye") then ObjSet( common_impl.hint["get_amuleteye"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_clock_sh_amuleteye");
end;

cmn.AddSubscriber( "get_amuleteye", private.get_amuleteye_inv );
cmn.AddSubscriber( "get_amuleteye", private.get_amuleteye_beg, private.room_objname );
cmn.AddSubscriber( "get_amuleteye", private.get_amuleteye_end, private.room_objname );
cmn.AddSubscriber( "get_amuleteye", private.get_amuleteye_logic );
--------------------------------------------------------------------
function public.get_amuleteye()
  cmn.SetEventDone( "get_amuleteye" );
  cmn.CallEventHandler( "get_amuleteye" );
  if common_impl.ZzCompleteCheck("get_amuleteye") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_numeral" ] = { type = "use", inv_obj = "inv_numeral", use_place = "gfx_clock_numeral_zone", room = "rm_hall", zz = "zz_clock", zz_gate = "gzz_hall_clock" };

private.use_numeral_logic = function()
  ObjSet( "gmg_hall_clockmg", { visible = 1, input = 1, active = 1 } )

end;
private.use_numeral_inv = function()
  common_impl.ProcessMultiUseAll("numeral", "numeral")
end;
private.use_numeral_beg = function()
  ObjDelete( "gfx_clock_numeral_zone" );
end;
private.use_numeral_end = function()
  if common_impl.ZzCompleteCheck("use_numeral") then ObjSet( common_impl.hint["use_numeral"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_numeral","use_numeral2"} ) then
     --ObjDelete("anm_clock_anm_clock_a3")  
  else
     ObjSet( "anm_clock_anm_clock_a3", {animfunc = "use_a3", frame = 999 } );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_numeral", private.use_numeral_inv );
cmn.AddSubscriber( "use_numeral", private.use_numeral_beg, private.room_objname );
cmn.AddSubscriber( "use_numeral", private.use_numeral_end, private.room_objname );
cmn.AddSubscriber( "use_numeral", private.use_numeral_logic );
cmn.AddSubscriber( "use_numeral_inv", private.use_numeral_inv, private.room_objname );
cmn.AddSubscriber( "use_numeral_beg", private.use_numeral_beg, private.room_objname );
cmn.AddSubscriber( "use_numeral_end", private.use_numeral_end, private.room_objname );
cmn.AddSubscriber( "use_numeral_end", private.use_numeral_logic );
--------------------------------------------------------------------------------------------
function public.use_numeral( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_numeral" );
    cmn.CallEventHandler( "use_numeral_end" );
    common_impl.Lock(0);
    --  if common_impl.ZzCompleteCheck("use_numeral") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_numeral","use_numeral2"} ) then 
        ld.CloseSubRoom()
        cmn.GotoRoom("mg_clockmg"); 
    end;  
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_numeral_inv" );
  cmn.CallEventHandler( "use_numeral_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_clock_anm_clock_a3", "use_a3", func_end );
  SoundSfx( "aud_use_numeral_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_numeral2" ] = { type = "use", inv_obj = "inv_numeral2", use_place = "gfx_clock_numeral2_zone", room = "rm_hall", zz = "zz_clock", zz_gate = "gzz_hall_clock" };

private.use_numeral2_logic = function()
  ObjSet( "gmg_hall_clockmg", { visible = 1, input = 1, active = 1 } )

end;
private.use_numeral2_inv = function()
  common_impl.ProcessMultiUseAll("numeral2", "numeral2")
end;
private.use_numeral2_beg = function()
  ObjDelete( "gfx_clock_numeral2_zone" );
end;
private.use_numeral2_end = function()
  if common_impl.ZzCompleteCheck("use_numeral2") then ObjSet( common_impl.hint["use_numeral2"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_numeral","use_numeral2"} ) then
     --ObjDelete("anm_clock_anm_clock_a3")  
  else
     ObjSet( "anm_clock_anm_clock_a6", {animfunc = "use_a6", frame = 999 } );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_numeral2", private.use_numeral2_inv );
cmn.AddSubscriber( "use_numeral2", private.use_numeral2_beg, private.room_objname );
cmn.AddSubscriber( "use_numeral2", private.use_numeral2_end, private.room_objname );
cmn.AddSubscriber( "use_numeral2", private.use_numeral2_logic );
cmn.AddSubscriber( "use_numeral2_inv", private.use_numeral2_inv, private.room_objname );
cmn.AddSubscriber( "use_numeral2_beg", private.use_numeral2_beg, private.room_objname );
cmn.AddSubscriber( "use_numeral2_end", private.use_numeral2_end, private.room_objname );
cmn.AddSubscriber( "use_numeral2_end", private.use_numeral2_logic );
--------------------------------------------------------------------------------------------
function public.use_numeral2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_numeral2" );
    cmn.CallEventHandler( "use_numeral2_end" );
    common_impl.Lock(0);
    --  if common_impl.ZzCompleteCheck("use_numeral2") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_numeral","use_numeral2"} ) then 
        ld.CloseSubRoom()
        cmn.GotoRoom("mg_clockmg"); 
    end;  
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_numeral2_inv" );
  cmn.CallEventHandler( "use_numeral2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_clock_anm_clock_a6", "use_a6", func_end );
  SoundSfx( "aud_use_numeral_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_sideboard *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_medallion1" ] = { type = "get", get_obj = "spr_sideboard_medallion1", room = "rm_hall", zz = "zz_sideboard", zz_gate = "gzz_hall_sideboard" };

private.get_medallion1_logic = function()
  
end;
private.get_medallion1_inv = function()
  interface.InventoryItemAdd("inv_medallion","spr_sideboard_medallion1",function() level_inv.ProcessGetMedallionAll( "get_medallion1" ) end);
end;
private.get_medallion1_beg = function()
  ObjDelete("gfx_sideboard_medallion1")
end;
private.get_medallion1_end = function()
  if common_impl.ZzCompleteCheck("get_medallion1") then ObjSet( common_impl.hint["get_medallion1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_sideboard_sh_medallion1");
  if (cmn.IsEventDone("use_piececrystal")) then
    ObjSet( "gho_hall_crystalho", { visible = 1, input = 1, active = 1 } );
  end;
end;

cmn.AddSubscriber( "get_medallion1", private.get_medallion1_inv );
cmn.AddSubscriber( "get_medallion1", private.get_medallion1_beg, private.room_objname );
cmn.AddSubscriber( "get_medallion1", private.get_medallion1_end, private.room_objname );
cmn.AddSubscriber( "get_medallion1", private.get_medallion1_logic );
--------------------------------------------------------------------
function public.get_medallion1()
  cmn.SetEventDone( "get_medallion1" );
  cmn.CallEventHandler( "get_medallion1" );
  if common_impl.ZzCompleteCheck("get_medallion1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_piececrystal_zone_clk()
  local func_end = function()
     ld.Lock(0);
     common_impl.ShowBbt( 'need_piececrystal' );
  end;
  
  ld.Lock(1);
  ld.AnimPlay( "anm_sideboard_anm", "idle", func_end )
  SoundSfx( "aud_touch_figure_hall" )
end;  


common_impl.hint[ "use_piececrystal" ] = { type = "use", inv_obj = "inv_piececrystal", use_place = "gfx_sideboard_piececrystal_zone", room = "rm_hall", zz = "zz_sideboard", zz_gate = "gzz_hall_sideboard" };

private.use_piececrystal_logic = function()
  if (cmn.IsEventDone("get_medallion1")) then
    ObjSet( "gho_hall_crystalho", { visible = 1, input = 1, active = 1 } );
  end;
end;
private.use_piececrystal_inv = function()
  common_impl.ProcessMultiUseAll("piececrystal", "piececrystal")
end;
private.use_piececrystal_beg = function()
  ObjDelete( "gfx_sideboard_piececrystal_zone" );
end;
private.use_piececrystal_end = function()
  if common_impl.ZzCompleteCheck("use_piececrystal") then ObjSet( common_impl.hint["use_piececrystal"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_sideboard_anm", {animfunc = "end_piece", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_piececrystal", private.use_piececrystal_inv );
cmn.AddSubscriber( "use_piececrystal", private.use_piececrystal_beg, private.room_objname );
cmn.AddSubscriber( "use_piececrystal", private.use_piececrystal_end, private.room_objname );
cmn.AddSubscriber( "use_piececrystal", private.use_piececrystal_logic );
cmn.AddSubscriber( "use_piececrystal_inv", private.use_piececrystal_inv, private.room_objname );
cmn.AddSubscriber( "use_piececrystal_beg", private.use_piececrystal_beg, private.room_objname );
cmn.AddSubscriber( "use_piececrystal_end", private.use_piececrystal_end, private.room_objname );
cmn.AddSubscriber( "use_piececrystal_end", private.use_piececrystal_logic );
--------------------------------------------------------------------------------------------
function public.use_piececrystal( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_piececrystal" );
    cmn.CallEventHandler( "use_piececrystal_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_piececrystal") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_piececrystal_inv" );
  cmn.CallEventHandler( "use_piececrystal_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sideboard_anm", "use_piece", func_end );
  SoundSfx( "aud_use_piececrystal_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_exityard *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hexahedron_zone_ckl()
  local func_end = function()
     common_impl.ShowBbt( 'need_hexahedron' )
     ld.Lock(0);
  end;
  
  ld.Lock(1);
  ld.AnimPlay( "anm_exityard_anm_mailbox", "idle", func_end )
  SoundSfx( "aud_touch_box_hall" )
end;  




common_impl.hint[ "use_hexahedron" ] = { type = "use", inv_obj = "inv_hexahedron", use_place = "gfx_exityard_hexahedron_zone", room = "rm_hall", zz = "zz_exityard", zz_gate = "gzz_hall_exityard" };

private.use_hexahedron_logic = function()
  ObjSet( "gfx_exityard_shawl_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_hexahedron_inv = function()
  common_impl.ProcessMultiUseAll("hexahedron", "hexahedron")
end;
private.use_hexahedron_beg = function()
  ObjDelete( "gfx_exityard_hexahedron_zone" );
end;
private.use_hexahedron_end = function()
  if common_impl.ZzCompleteCheck("use_hexahedron") then ObjSet( common_impl.hint["use_hexahedron"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_exityard_anm_mailbox", {animfunc = "end_shawl", frame = 0 } );
  ObjDelete("spr_hall_screw");
  ObjDelete("spr_hall_cover");
  ObjSet( "spr_hall_cover_open", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hexahedron", private.use_hexahedron_inv );
cmn.AddSubscriber( "use_hexahedron", private.use_hexahedron_beg, private.room_objname );
cmn.AddSubscriber( "use_hexahedron", private.use_hexahedron_end, private.room_objname );
cmn.AddSubscriber( "use_hexahedron", private.use_hexahedron_logic );
cmn.AddSubscriber( "use_hexahedron_inv", private.use_hexahedron_inv, private.room_objname );
cmn.AddSubscriber( "use_hexahedron_beg", private.use_hexahedron_beg, private.room_objname );
cmn.AddSubscriber( "use_hexahedron_end", private.use_hexahedron_end, private.room_objname );
cmn.AddSubscriber( "use_hexahedron_end", private.use_hexahedron_logic );
--------------------------------------------------------------------------------------------
function public.use_hexahedron( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hexahedron" );
    cmn.CallEventHandler( "use_hexahedron_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hexahedron") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hexahedron_inv" );
  cmn.CallEventHandler( "use_hexahedron_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_exityard_anm_mailbox", "use_hexahedron", func_end );
  SoundSfx( "aud_use_hexahedron_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_shawl_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_shawl' );
  end;
  
  ld.Lock(1);
  ld.AnimPlay( "anm_exityard_anm_ant", "ant", func_end )
  SoundSfx( "aud_touch_ants" )
end;


common_impl.hint[ "use_shawl" ] = { type = "use", inv_obj = "inv_shawl", use_place = "gfx_exityard_shawl_zone", room = "rm_hall", zz = "zz_exityard", zz_gate = "gzz_hall_exityard" };

private.use_shawl_logic = function()
  ObjSet( "spr_exityard_portraitpart3", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_exityard_portraitpart3", {visible = 1, active = 1} );
  ObjSet( "spr_exityard_pinkpaint", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_exityard_pinkpaint", {active = 1, visible = 1} );

end;
private.use_shawl_inv = function()
  common_impl.ProcessMultiUseAll("shawl", "shawl")
end;
private.use_shawl_beg = function()
  ObjDelete( "gfx_exityard_shawl_zone" );
end;
private.use_shawl_end = function()
  if common_impl.ZzCompleteCheck("use_shawl") then ObjSet( common_impl.hint["use_shawl"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_exityard_anm_mailbox", {animfunc = "end_shawl", frame = 0 } );
  ObjDelete("anm_exityard_anm_ant");
  ObjSet( "spr_exityard_text_small", {input = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_shawl", private.use_shawl_inv );
cmn.AddSubscriber( "use_shawl", private.use_shawl_beg, private.room_objname );
cmn.AddSubscriber( "use_shawl", private.use_shawl_end, private.room_objname );
cmn.AddSubscriber( "use_shawl", private.use_shawl_logic );
cmn.AddSubscriber( "use_shawl_inv", private.use_shawl_inv, private.room_objname );
cmn.AddSubscriber( "use_shawl_beg", private.use_shawl_beg, private.room_objname );
cmn.AddSubscriber( "use_shawl_end", private.use_shawl_end, private.room_objname );
cmn.AddSubscriber( "use_shawl_end", private.use_shawl_logic );
--------------------------------------------------------------------------------------------
function public.use_shawl( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_shawl" );
    cmn.CallEventHandler( "use_shawl_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_shawl") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_shawl_inv" );
  cmn.CallEventHandler( "use_shawl_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_exityard_anm_mailbox", "use_shawl", func_end );
  ObjAnimate( "anm_exityard_anm_ant", 8, 0, 0, function() end, {0,0,1, 1,0,1, 1.5,0,0} );
  SoundSfx( "aud_use_shawl_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_portraitpart3" ] = { type = "get", get_obj = "spr_exityard_portraitpart3", room = "rm_hall", zz = "zz_exityard", zz_gate = "gzz_hall_exityard" };

private.get_portraitpart3_logic = function()
  
end;
private.get_portraitpart3_inv = function()
  interface.InventoryItemAdd("inv_portraitpart","spr_exityard_portraitpart3",function() level_inv.ProcessGetPortraitpartAll( "get_portraitpart3" ) end);
end;
private.get_portraitpart3_beg = function()
  ObjDelete("gfx_exityard_portraitpart3")
end;
private.get_portraitpart3_end = function()
  if common_impl.ZzCompleteCheck("get_portraitpart3") then ObjSet( common_impl.hint["get_portraitpart3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_exityard_sh_portraitpart3");
  ObjDelete("spr_hall_portraitpart3");
  if (cmn.IsEventDone("use_keylock")) then
    ObjSet( common_impl.hint["use_keylock"].zz_gate, { visible = 0, input = 0 } );
    ObjSet( "grm_hall_yard", { visible = 1, input = 1, active = 1 } );
    ObjSet( "spr_hall_open_door", {visible = 1} );
  end;
end;

cmn.AddSubscriber( "get_portraitpart3", private.get_portraitpart3_inv );
cmn.AddSubscriber( "get_portraitpart3", private.get_portraitpart3_beg, private.room_objname );
cmn.AddSubscriber( "get_portraitpart3", private.get_portraitpart3_end, private.room_objname );
cmn.AddSubscriber( "get_portraitpart3", private.get_portraitpart3_logic );
--------------------------------------------------------------------
function public.get_portraitpart3()
  cmn.SetEventDone( "get_portraitpart3" );
  cmn.CallEventHandler( "get_portraitpart3" );
  if common_impl.ZzCompleteCheck("get_portraitpart3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pinkpaint" ] = { type = "get", get_obj = "spr_exityard_pinkpaint", room = "rm_hall", zz = "zz_exityard", zz_gate = "gzz_hall_exityard" };

private.get_pinkpaint_logic = function()
  
end;
private.get_pinkpaint_inv = function()
  interface.InventoryItemAdd("inv_pinkpaint","spr_exityard_pinkpaint");
end;
private.get_pinkpaint_beg = function()
  ObjDelete("gfx_exityard_pinkpaint")
end;
private.get_pinkpaint_end = function()
  if common_impl.ZzCompleteCheck("get_pinkpaint") then ObjSet( common_impl.hint["get_pinkpaint"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_exityard_sh_pinkpaint");
  ObjDelete("spr_hall_pinkpaint");
end;

cmn.AddSubscriber( "get_pinkpaint", private.get_pinkpaint_inv );
cmn.AddSubscriber( "get_pinkpaint", private.get_pinkpaint_beg, private.room_objname );
cmn.AddSubscriber( "get_pinkpaint", private.get_pinkpaint_end, private.room_objname );
cmn.AddSubscriber( "get_pinkpaint", private.get_pinkpaint_logic );
--------------------------------------------------------------------
function public.get_pinkpaint()
  cmn.SetEventDone( "get_pinkpaint" );
  cmn.CallEventHandler( "get_pinkpaint" );
  if common_impl.ZzCompleteCheck("get_pinkpaint") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_keylock" ] = { type = "use", inv_obj = "inv_keylock", use_place = "gfx_exityard_keylock_zone", room = "rm_hall", zz = "zz_exityard", zz_gate = "gzz_hall_exityard" };

private.use_keylock_logic = function()
  if (cmn.IsEventDone("get_portraitpart3")) then
    ObjSet( "grm_hall_yard", { visible = 1, input = 1, active = 1 } );
  
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_hall_yard_focus");
    end;
  end;
end;
private.use_keylock_inv = function()
  common_impl.ProcessMultiUseAll("keylock", "keylock")
end;
private.use_keylock_beg = function()
  ObjDelete( "gfx_exityard_keylock_zone" );
end;
private.use_keylock_end = function()
  -- if common_impl.ZzCompleteCheck("use_keylock") then ObjSet( common_impl.hint["use_keylock"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_exityard_anm_mailbox", {animfunc = "use_key", frame = 999 } );
  ObjSet( "spr_exityard_text_small", {input = 0} );
  
  ObjDelete("obj_hall_exityard_tr_root");
  if (cmn.IsEventDone("get_portraitpart3")) then
    ObjSet( "spr_hall_open_door", {visible = 1} );
    ObjSet( common_impl.hint["use_keylock"].zz_gate, { visible = 0, input = 0 } );
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_keylock", private.use_keylock_inv );
cmn.AddSubscriber( "use_keylock", private.use_keylock_beg, private.room_objname );
cmn.AddSubscriber( "use_keylock", private.use_keylock_end, private.room_objname );
cmn.AddSubscriber( "use_keylock", private.use_keylock_logic );
cmn.AddSubscriber( "use_keylock_inv", private.use_keylock_inv, private.room_objname );
cmn.AddSubscriber( "use_keylock_beg", private.use_keylock_beg, private.room_objname );
cmn.AddSubscriber( "use_keylock_end", private.use_keylock_end, private.room_objname );
cmn.AddSubscriber( "use_keylock_end", private.use_keylock_logic );
--------------------------------------------------------------------------------------------
function public.use_keylock( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_keylock" );
    cmn.CallEventHandler( "use_keylock_end" );
    common_impl.Lock(0);
    -- if common_impl.ZzCompleteCheck("use_keylock") then ld.CloseSubRoom() end;
    ld.CloseSubRoom();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_keylock_inv" );
  cmn.CallEventHandler( "use_keylock_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_exityard_anm_mailbox", "use_key", func_end );
  SoundSfx( "aud_use_keylock_hall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_crystalho_for_hall = function()
    if ld.CheckRequirements( {"win_crystalho"} ) then
      ObjSet( "gho_hall_crystalho", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_crystalho", win_crystalho_for_hall, private.room_objname )
  local get_grapes_for_hall = function()
    if ld.CheckRequirements( {"get_grapes"} ) then
      ObjSet( "gmg_hall_clockmg", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("get_grapes", get_grapes_for_hall, private.room_objname )

end;
------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_windowyard" ) and not ld.CheckRequirements( { "win_paintmmg" } ) then  
     private.win_paintmmg_reset()
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_windowyard" ) and not ld.CheckRequirements( { "win_paintmmg" } ) then
    private.win_paintmmg_skip()
  end;
  
end


--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_hall();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_hall_env" )
  if cmn.IsEventDone("win_clockmg") then ObjSet( "spr_hall_open_clock", {visible = 1} ); end;
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_exityard" );
  function zz_exityard.Open()
  end;
  function zz_exityard.PreOpen()
  end;
  function zz_exityard.PreClose()
  end;
  function zz_exityard.Close()
  end;

  subroom.Define( "zz_sideboard" );
  function zz_sideboard.Open()
  end;
  function zz_sideboard.PreOpen()
  end;
  function zz_sideboard.PreClose()
  end;
  function zz_sideboard.Close()
  end;

  subroom.Define( "zz_clock" );
  function zz_clock.Open()
  end;
  function zz_clock.PreOpen()
  end;
  function zz_clock.PreClose()
  end;
  function zz_clock.Close()
  end;

  subroom.Define( "zz_windowyard" );
  function zz_windowyard.Open()
  end;
  function zz_windowyard.PreOpen()
     if not cmn.IsEventDone("win_paintmmg") then 
       private.win_paintmmg_parts_init();
       private.win_paintmmg_stand_on_fp();
     end;  
    
     if cmn.IsEventStart("win_paintmmg") and not cmn.IsEventDone("win_paintmmg") then 
      cmn.MiniGameShow( "paintmmg" ); 
      private.init_paintmmg()
     end;  
  end;
  function zz_windowyard.PreClose()
  end;
  function zz_windowyard.Close()
    if cmn.IsEventStart("win_paintmmg") and not cmn.IsEventDone("win_paintmmg") then 
       cmn.MiniGameHide( "paintmmg" ); 
    end; 
  end;

  subroom.Define( "zz_pierglass" );
  function zz_pierglass.Open()
  end;
  function zz_pierglass.PreOpen()
  end;
  function zz_pierglass.PreClose()
  end;
  function zz_pierglass.Close()
  end;
  
end;
--*********************************************************************************************************************
-- other funcs

function public.hall_tablecloth_clk_zone_clk()
  local func_end = function()
     ObjSet( "obj_hall_tablecloth_clk_zone", {input = 1} );
  end;  
  
  ObjSet( "obj_hall_tablecloth_clk_zone", {input = 0} );
  SoundSfx( "aud_touch_cloth_hall" );
  ld.AnimPlay( "anm_hall_anm2", "tablecloth", func_end )
end;  