-- name=rm_jail
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_jail";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_jail()
  if not ( cmn.IsEventDone( "opn_jail" ) ) then
    cmn.SetEventDone( "opn_jail" );
    cmn.CallEventHandler( "opn_jail" )
  end;
end;
--------------------------------------------------------------------
local opn_jail = function() end;
local opn_jail_logic = function() end;
cmn.AddSubscriber( "opn_jail", opn_jail_logic )
cmn.AddSubscriber( "opn_jail", opn_jail, private.room_objname )
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "storm1" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    end        
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmjail" ] = { type = "click", use_place = "gfx_jail_clk_anmjail_zone", room = "rm_jail" };

private.clk_anmjail_logic = function()
  ObjSet( "gfx_jail_dlg_jail_storm1_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_jail_jaillock", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_jail_tile", { visible = 1, input = 1, active = 1 } )
end;
private.clk_anmjail_beg = function()
  ObjDelete( "gfx_jail_clk_anmjail_zone" );
end;
private.clk_anmjail_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmjail", private.clk_anmjail_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmjail", private.clk_anmjail_end, private.room_objname );
cmn.AddSubscriber( "clk_anmjail", private.clk_anmjail_logic );
cmn.AddSubscriber( "clk_anmjail_beg", private.clk_anmjail_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmjail_end", private.clk_anmjail_end, private.room_objname );
cmn.AddSubscriber( "clk_anmjail_end", private.clk_anmjail_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmjail()

local widget_settings = 
     {
       InterfaceWidget_Inventory,
       InterfaceWidget_BtnHint,
       InterfaceWidget_BtnGuide,
       InterfaceWidget_BtnMenu,
       InterfaceWidget_BtnMap,
     }
     
  local func_end = function()
    cmn.SetEventDone( "clk_anmjail" );
    cmn.CallEventHandler( "clk_anmjail_end" );
    common_impl.Lock(0);
    ld.ShowBbt("opn_jail");
    SoundTheme( "aud_danger_moment1_mus" );
  end;

  local func_preend = function()
    SoundVoice( 0 );
   
    for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], 1, true );
    end;     
    ObjSet("rm_jail",{color_r=1,color_g=1,color_b=1})
    int.DialogVideoHide();
    SoundEnv( "aud_jail_env" );
    ld.Lock(1);
    ld.StartTimer( 0.5, func_end )
  end;
  
  cmn.CallEventHandler( "clk_anmjail_beg" );
  SoundEnv(0);
  SoundVid("aud_clk_anmjail");
  VidPlay("vid_jail_anmjail",func_preend);

  for i = 1, #widget_settings do
    interface.WidgetSetVisible( widget_settings[i], 0, false );
  end;  
  int.DialogVideoShow( "vid_jail_anmjail", 1, func_preend, 1 );   
  
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_jail_storm1" ] = { type = "click", use_place = "gfx_jail_dlg_jail_storm1_zone", room = "rm_jail" };

private.dlg_jail_storm1_logic = function()
  ObjSet( "gfx_jail_scissors_jail_zone", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_jail_storm1_beg = function()
  ObjDelete( "gfx_jail_dlg_jail_storm1_zone" );
end;
private.dlg_jail_storm1_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_jail_storm1", private.dlg_jail_storm1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_jail_storm1", private.dlg_jail_storm1_end, private.room_objname );
cmn.AddSubscriber( "dlg_jail_storm1", private.dlg_jail_storm1_logic );
cmn.AddSubscriber( "dlg_jail_storm1_beg", private.dlg_jail_storm1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_jail_storm1_end", private.dlg_jail_storm1_end, private.room_objname );
cmn.AddSubscriber( "dlg_jail_storm1_end", private.dlg_jail_storm1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_jail_storm1( obj )

  cmn.CallEventHandler( "dlg_jail_storm1_beg" );
  --common_impl.Lock(1);
  common_impl.dialog_character_loc = "anm_jail_man"
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  common_impl.Start( "storm1", 3, nil, nil, true, "dlg_jail_storm1_end",{"aud_storm_1_voc","aud_storm_2_voc"} );

end;

private.dlg_jail_storm1_end = function()
  ObjSet( "dlg_jail_storm1", {bake=1} );
  cmn.SetEventDone( "dlg_jail_storm1" );
  cmn.CallEventHandler( "dlg_jail_storm1_end" );
  --common_impl.Lock(0);
  --common_impl.Lock(0);
  --ld.ShowBbt("after_dlg_elizabeth2")
end;
function public.dlg_jail_storm1_end()
  private.dlg_jail_storm1_end()
end

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scissors_jail" ] = { type = "use", inv_obj = "inv_scissors", use_place = "gfx_jail_scissors_jail_zone", room = "rm_jail" };

private.use_scissors_jail_logic = function()
  ObjSet( "gmg_jail_storystorm", { visible = 1, input = 1, active = 1 } )

end;
private.use_scissors_jail_inv = function()
  common_impl.ProcessMultiUseAll("scissors", "scissors_jail")
end;
private.use_scissors_jail_beg = function()
  ObjDelete( "gfx_jail_scissors_jail_zone" );
end;
private.use_scissors_jail_end = function()
  
  ObjSet( "anm_jail_man", {animfunc="statik_man2",frame=0,playing=1} );
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scissors_jail", private.use_scissors_jail_inv );
cmn.AddSubscriber( "use_scissors_jail", private.use_scissors_jail_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors_jail", private.use_scissors_jail_end, private.room_objname );
cmn.AddSubscriber( "use_scissors_jail", private.use_scissors_jail_logic );
cmn.AddSubscriber( "use_scissors_jail_inv", private.use_scissors_jail_inv, private.room_objname );
cmn.AddSubscriber( "use_scissors_jail_beg", private.use_scissors_jail_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors_jail_end", private.use_scissors_jail_end, private.room_objname );
cmn.AddSubscriber( "use_scissors_jail_end", private.use_scissors_jail_logic );
--------------------------------------------------------------------------------------------
function public.use_scissors_jail( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scissors_jail" );
    cmn.CallEventHandler( "use_scissors_jail_end" );
    common_impl.Lock(0);
    cmn.GotoRoom( "mg_storystorm" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scissors_jail_inv" );
  cmn.CallEventHandler( "use_scissors_jail_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_jail_man", "scissors", func_end );
  SoundSfx( "aud_use_scissors_jail" );
  

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tile *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_rose1" ] = { type = "get", get_obj = "spr_tile_rose1", room = "rm_jail", zz = "zz_tile", zz_gate = "gzz_jail_tile" };

private.get_rose1_logic = function()
  
end;
private.get_rose1_inv = function()
  interface.InventoryItemAdd("inv_rose","spr_tile_rose1",function() level_inv.ProcessGetRoseAll( "get_rose1" ) end);
end;
private.get_rose1_beg = function()
  ObjDelete("gfx_tile_rose1")
end;
private.get_rose1_end = function()
  ObjDelete("spr_jail_rose")
  if common_impl.ZzCompleteCheck("get_rose1") then ObjSet( common_impl.hint["get_rose1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_rose1", private.get_rose1_inv );
cmn.AddSubscriber( "get_rose1", private.get_rose1_beg, private.room_objname );
cmn.AddSubscriber( "get_rose1", private.get_rose1_end, private.room_objname );
cmn.AddSubscriber( "get_rose1", private.get_rose1_logic );
--------------------------------------------------------------------
function public.get_rose1()
  cmn.SetEventDone( "get_rose1" );
  cmn.CallEventHandler( "get_rose1" );
  if common_impl.ZzCompleteCheck("get_rose1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pick_tile" ] = { type = "use", inv_obj = "inv_pick", use_place = "gfx_tile_pick_tile_zone", room = "rm_jail", zz = "zz_tile", zz_gate = "gzz_jail_tile" };

private.use_pick_tile_logic = function()
  ObjSet( "spr_tile_stoneleaf1", { visible = 1, input = 1, active = 1 } )

end;
private.use_pick_tile_inv = function()
  common_impl.ProcessMultiUseAll("pick", "pick_tile")
end;
private.use_pick_tile_beg = function()
  ObjDelete( "gfx_tile_pick_tile_zone" );
end;
private.use_pick_tile_end = function()
  ObjDelete("anm_tile_pick")
  ObjSet( "spr_tile_sh_stoneleaf1", {alp = 1} );
  ObjDelete("spr_jail_a1")
  if common_impl.ZzCompleteCheck("use_pick_tile") then ObjSet( common_impl.hint["use_pick_tile"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pick_tile", private.use_pick_tile_inv );
cmn.AddSubscriber( "use_pick_tile", private.use_pick_tile_beg, private.room_objname );
cmn.AddSubscriber( "use_pick_tile", private.use_pick_tile_end, private.room_objname );
cmn.AddSubscriber( "use_pick_tile", private.use_pick_tile_logic );
cmn.AddSubscriber( "use_pick_tile_inv", private.use_pick_tile_inv, private.room_objname );
cmn.AddSubscriber( "use_pick_tile_beg", private.use_pick_tile_beg, private.room_objname );
cmn.AddSubscriber( "use_pick_tile_end", private.use_pick_tile_end, private.room_objname );
cmn.AddSubscriber( "use_pick_tile_end", private.use_pick_tile_logic );
--------------------------------------------------------------------------------------------
function public.use_pick_tile( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pick_tile" );
    cmn.CallEventHandler( "use_pick_tile_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pick_tile") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pick_tile_inv" );
  cmn.CallEventHandler( "use_pick_tile_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tile_pick", "use_pick1", func_end );
  SoundSfx( "aud_use_pick_tile" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_stoneleaf1" ] = { type = "get", get_obj = "spr_tile_stoneleaf1", room = "rm_jail", zz = "zz_tile", zz_gate = "gzz_jail_tile" };

private.get_stoneleaf1_logic = function()
  
end;
private.get_stoneleaf1_inv = function()
  interface.InventoryItemAdd("inv_stoneleaf1","spr_tile_stoneleaf1");
end;
private.get_stoneleaf1_beg = function()
  ObjDelete("gfx_tile_stoneleaf1")
end;
private.get_stoneleaf1_end = function()
  ObjDelete("spr_tile_sh_stoneleaf1")
  ObjDelete("spr_jail_stoneleaf1")
  if common_impl.ZzCompleteCheck("get_stoneleaf1") then ObjSet( common_impl.hint["get_stoneleaf1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_stoneleaf1", private.get_stoneleaf1_inv );
cmn.AddSubscriber( "get_stoneleaf1", private.get_stoneleaf1_beg, private.room_objname );
cmn.AddSubscriber( "get_stoneleaf1", private.get_stoneleaf1_end, private.room_objname );
cmn.AddSubscriber( "get_stoneleaf1", private.get_stoneleaf1_logic );
--------------------------------------------------------------------
function public.get_stoneleaf1()
  cmn.SetEventDone( "get_stoneleaf1" );
  cmn.CallEventHandler( "get_stoneleaf1" );
  if common_impl.ZzCompleteCheck("get_stoneleaf1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_stonesun" ] = { type = "use", inv_obj = "inv_stonesun", use_place = "gfx_tile_stonesun_zone", room = "rm_jail", zz = "zz_tile", zz_gate = "gzz_jail_tile" };

private.use_stonesun_logic = function()
  ObjSet( "spr_tile_wrench", { visible = 1, input = 1, active = 1 } )

end;
private.use_stonesun_inv = function()
  common_impl.ProcessMultiUseAll("stonesun", "stonesun")
end;
private.use_stonesun_beg = function()
  ObjDelete( "gfx_tile_stonesun_zone" );
end;
private.use_stonesun_end = function()
  ObjDelete("anm_tile_use_stonesun")
  ObjSet( "gfx_tile_wrench", {visible = 1} );
  ObjDelete("spr_jail_b")
  if common_impl.ZzCompleteCheck("use_stonesun") then ObjSet( common_impl.hint["use_stonesun"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stonesun", private.use_stonesun_inv );
cmn.AddSubscriber( "use_stonesun", private.use_stonesun_beg, private.room_objname );
cmn.AddSubscriber( "use_stonesun", private.use_stonesun_end, private.room_objname );
cmn.AddSubscriber( "use_stonesun", private.use_stonesun_logic );
cmn.AddSubscriber( "use_stonesun_inv", private.use_stonesun_inv, private.room_objname );
cmn.AddSubscriber( "use_stonesun_beg", private.use_stonesun_beg, private.room_objname );
cmn.AddSubscriber( "use_stonesun_end", private.use_stonesun_end, private.room_objname );
cmn.AddSubscriber( "use_stonesun_end", private.use_stonesun_logic );
--------------------------------------------------------------------------------------------
function public.use_stonesun( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_stonesun" );
    cmn.CallEventHandler( "use_stonesun_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stonesun") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stonesun_inv" );
  cmn.CallEventHandler( "use_stonesun_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tile_use_stonesun", "use_stoneson", func_end );
  SoundSfx( "aud_use_stonesun_jail" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wrench" ] = { type = "get", get_obj = "spr_tile_wrench", room = "rm_jail", zz = "zz_tile", zz_gate = "gzz_jail_tile" };

private.get_wrench_logic = function()
  
end;
private.get_wrench_inv = function()
  interface.InventoryItemAdd("inv_wrench","spr_tile_wrench");
end;
private.get_wrench_beg = function()
  ObjDelete("gfx_tile_wrench")
end;
private.get_wrench_end = function()
  ObjDelete("spr_tile_sh_wrench")
  ObjDelete("spr_jail_wrench")
  if common_impl.ZzCompleteCheck("get_wrench") then ObjSet( common_impl.hint["get_wrench"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_wrench", private.get_wrench_inv );
cmn.AddSubscriber( "get_wrench", private.get_wrench_beg, private.room_objname );
cmn.AddSubscriber( "get_wrench", private.get_wrench_end, private.room_objname );
cmn.AddSubscriber( "get_wrench", private.get_wrench_logic );
--------------------------------------------------------------------
function public.get_wrench()
  
  cmn.SetEventDone( "get_wrench" );
  cmn.CallEventHandler( "get_wrench" );
  if common_impl.ZzCompleteCheck("get_wrench") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_stonemoon" ] = { type = "use", inv_obj = "inv_stonemoon", use_place = "gfx_tile_stonemoon_zone", room = "rm_jail", zz = "zz_tile", zz_gate = "gzz_jail_tile" };

private.use_stonemoon_logic = function()
  ObjSet( "spr_tile_spideramulet", { visible = 1, input = 1, active = 1 } )

end;
private.use_stonemoon_inv = function()
  common_impl.ProcessMultiUseAll("stonemoon", "stonemoon")
end;
private.use_stonemoon_beg = function()
  ObjDelete( "gfx_tile_stonemoon_zone" );
end;
private.use_stonemoon_end = function()
  ObjSet( "gfx_tile_spideramulet", {visible = 1} );
  ObjDelete("spr_jail_c")
  if common_impl.ZzCompleteCheck("use_stonemoon") then ObjSet( common_impl.hint["use_stonemoon"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stonemoon", private.use_stonemoon_inv );
cmn.AddSubscriber( "use_stonemoon", private.use_stonemoon_beg, private.room_objname );
cmn.AddSubscriber( "use_stonemoon", private.use_stonemoon_end, private.room_objname );
cmn.AddSubscriber( "use_stonemoon", private.use_stonemoon_logic );
cmn.AddSubscriber( "use_stonemoon_inv", private.use_stonemoon_inv, private.room_objname );
cmn.AddSubscriber( "use_stonemoon_beg", private.use_stonemoon_beg, private.room_objname );
cmn.AddSubscriber( "use_stonemoon_end", private.use_stonemoon_end, private.room_objname );
cmn.AddSubscriber( "use_stonemoon_end", private.use_stonemoon_logic );
--------------------------------------------------------------------------------------------
function public.use_stonemoon( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_stonemoon" );
    cmn.CallEventHandler( "use_stonemoon_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stonemoon") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stonemoon_inv" );
  cmn.CallEventHandler( "use_stonemoon_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tile_use_stonemoon", "use_stonemoon", func_end );
  SoundSfx( "aud_use_stonemoon_jail" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_spideramulet" ] = { type = "get", get_obj = "spr_tile_spideramulet", room = "rm_jail", zz = "zz_tile", zz_gate = "gzz_jail_tile" };

private.get_spideramulet_logic = function()
  
end;
private.get_spideramulet_inv = function()
  interface.InventoryItemAdd("inv_spideramulet","spr_tile_spideramulet");
end;
private.get_spideramulet_beg = function()
  ObjDelete("gfx_tile_spideramulet")
end;
private.get_spideramulet_end = function()
  ObjDelete("spr_tile_sh_spideramulet")
  ObjDelete("spr_jail_spideramulet")
  if common_impl.ZzCompleteCheck("get_spideramulet") then ObjSet( common_impl.hint["get_spideramulet"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_spideramulet", private.get_spideramulet_inv );
cmn.AddSubscriber( "get_spideramulet", private.get_spideramulet_beg, private.room_objname );
cmn.AddSubscriber( "get_spideramulet", private.get_spideramulet_end, private.room_objname );
cmn.AddSubscriber( "get_spideramulet", private.get_spideramulet_logic );
--------------------------------------------------------------------
function public.get_spideramulet()
  cmn.SetEventDone( "get_spideramulet" );
  cmn.CallEventHandler( "get_spideramulet" );
  if common_impl.ZzCompleteCheck("get_spideramulet") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_jaillock *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_screw" ] = { type = "get", get_obj = "spr_jaillock_screw", room = "rm_jail", zz = "zz_jaillock", zz_gate = "gzz_jail_jaillock" };

private.get_screw_logic = function()
  ObjSet( "gfx_jaillock_cufflink_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_screw_inv = function()
  interface.InventoryItemAdd("inv_screw","spr_jaillock_screw");
end;
private.get_screw_beg = function()
  ObjDelete("gfx_jaillock_screw")
end;
private.get_screw_end = function()
  ObjDelete("spr_jaillock_sh_screw")
  ObjDelete("spr_jaillock_tr_screw")
  if common_impl.ZzCompleteCheck("get_screw") then ObjSet( common_impl.hint["get_screw"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_screw", private.get_screw_inv );
cmn.AddSubscriber( "get_screw", private.get_screw_beg, private.room_objname );
cmn.AddSubscriber( "get_screw", private.get_screw_end, private.room_objname );
cmn.AddSubscriber( "get_screw", private.get_screw_logic );
--------------------------------------------------------------------
function public.get_screw()
  cmn.SetEventDone( "get_screw" );
  cmn.CallEventHandler( "get_screw" );
  if common_impl.ZzCompleteCheck("get_screw") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cufflink" ] = { type = "use", inv_obj = "inv_cufflink", use_place = "gfx_jaillock_cufflink_zone", room = "rm_jail", zz = "zz_jaillock", zz_gate = "gzz_jail_jaillock" };

private.use_cufflink_logic = function()
  ObjSet( "gfx_jaillock_win_holelock_zone", { input = 1 } )

end;
private.use_cufflink_inv = function()
  common_impl.ProcessMultiUseAll("cufflink", "cufflink")
end;
private.use_cufflink_beg = function()
  ObjDelete( "gfx_jaillock_cufflink_zone" );
end;
private.use_cufflink_end = function()
  ObjSet( "spr_jaillock_mmg_back", {alp = 1,input=1} );
  if common_impl.ZzCompleteCheck("use_cufflink") then ObjSet( common_impl.hint["use_cufflink"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cufflink", private.use_cufflink_inv );
cmn.AddSubscriber( "use_cufflink", private.use_cufflink_beg, private.room_objname );
cmn.AddSubscriber( "use_cufflink", private.use_cufflink_end, private.room_objname );
cmn.AddSubscriber( "use_cufflink", private.use_cufflink_logic );
cmn.AddSubscriber( "use_cufflink_inv", private.use_cufflink_inv, private.room_objname );
cmn.AddSubscriber( "use_cufflink_beg", private.use_cufflink_beg, private.room_objname );
cmn.AddSubscriber( "use_cufflink_end", private.use_cufflink_end, private.room_objname );
cmn.AddSubscriber( "use_cufflink_end", private.use_cufflink_logic );
--------------------------------------------------------------------------------------------
function public.use_cufflink( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    private.init_holelock()
    cmn.MiniGameShow( "holelock" );    
    cmn.SetEventDone( "use_cufflink" );
    cmn.CallEventHandler( "use_cufflink_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cufflink") then ld.CloseSubRoom() end;
  end;
  local f_step = function ()
    ObjAnimate( "spr_jaillock_mmg_back", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cufflink_inv" );
  cmn.CallEventHandler( "use_cufflink_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_jaillock_anm", "use_stud", f_step );
  SoundSfx( "aud_use_cufflink_jail" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_holelock" ] = { type = "click", use_place = "gfx_jaillock_win_holelock_zone", room = "rm_jail", zz = "zz_jaillock", zz_gate = "gzz_jail_jaillock" };

private.win_holelock_logic = function()
  if ld.CheckRequirements( {"win_holelock"} ) then
    ObjSet( "grm_jail_corridor", { visible = 1, input = 1, active = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_jail_corridor_focus");
    end;
  end
end;
private.win_holelock_beg = function()
  ObjDelete( "gfx_jaillock_win_holelock_zone" );
end;
private.win_holelock_end = function()
  if ld.CheckRequirements( {"win_holelock"} ) then
    ObjDelete("spr_jaillock_mmg_back")
    ObjDelete("spr_jail_door1")
    ObjSet( "spr_jail_door2", {alp = 1} );
  end  
  if common_impl.ZzCompleteCheck("win_holelock") then ObjSet( common_impl.hint["win_holelock"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_holelock", private.win_holelock_beg, private.room_objname );
cmn.AddSubscriber( "win_holelock", private.win_holelock_end, private.room_objname );
cmn.AddSubscriber( "win_holelock", private.win_holelock_logic );
cmn.AddSubscriber( "win_holelock_beg", private.win_holelock_beg, private.room_objname );
cmn.AddSubscriber( "win_holelock_end", private.win_holelock_end, private.room_objname );
cmn.AddSubscriber( "win_holelock_end", private.win_holelock_logic );
--------------------------------------------------------------------------------------------
function public.win_holelock()

  local func_end = function()
    cmn.SetEventDone( "win_holelock" );
    cmn.CallEventHandler( "win_holelock_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_holelock") then ld.CloseSubRoom() end;
  end;
  local f_step = function()
    ld.AnimPlay( "anm_jaillock_anm", "use_stud1", func_end );
    SoundSfx( "aud_touch_cufflink_jail" );
  end
  cmn.MiniGameHide("holelock",true)
  cmn.CallEventHandler( "win_holelock_beg" );
  common_impl.Lock(1);
  ObjAnimate( "spr_jaillock_mmg_back", 8, 0, 0, f_step, {0,0,1, 0.5,0,0} );
  
  --SoundSfx( 0 )
  

end;
--------------------------------------------------------------------------------------------
function private.init_holelock()
  if not (cmn.IsEventStart("win_holelock")) then
    ng_global.progress[ "std" ][ "win_holelock" ].state = {}
    ng_global.progress[ "std" ][ "win_holelock" ].state.cur_plank = 1
    ng_global.progress[ "std" ][ "win_holelock" ].state.plank = {0,0,0,0}
  end
end
private.win_holelock_win = {3,1,2,1}
function private.load_holelock(reset)
  local s = ng_global.progress[ "std" ][ "win_holelock" ].state
  for i=1,#s.plank do
    for a=1,6-i do
      ObjSet("spr_jaillock_mmg_plank_"..i.."_dot_"..a,{alp=0})
    end    
    for j=1,s.plank[i] do
      ObjSet("spr_jaillock_mmg_plank_"..i.."_dot_"..j,{alp=1})
    end 
  end
  ObjSet( "spr_jaillock_mmg_key", {pos_x = 131+(s.cur_plank-1)*77} );
  if not reset then
    private.check_holelock(1)
  end
end
function private.win_holelock_reset()
    ------ for sound ---------------------------
     local count=0;
     for i=1,4,1 do 
       count = count + ng_global.progress[ "std" ][ "win_holelock" ].state.plank[i];
     end;  
     if count>0 then ld.StartTimer( 0.49, function() SoundSfx( "aud_mg_jaillock_hide_green" ) end); end;
    ---------------------------------------------
    ng_global.progress[ "std" ][ "win_holelock" ].state.cur_plank = 1
    ng_global.progress[ "std" ][ "win_holelock" ].state.plank = {0,0,0,0}  
    ld.Lock(1)
    ObjAnimate( "spr_jaillock_mmg_key", 0, 0, 0, function()ld.Lock(0);private.load_holelock(1) end, {0,0,ObjGet("spr_jaillock_mmg_key").pos_x, 0.5,0,131} );
    SoundSfx( "aud_mg_jaillock_move_left" );
end
function private.win_holelock_skip()
  ng_global.progress[ "std" ][ "win_holelock" ].state.cur_plank = 5
   ng_global.progress[ "std" ][ "win_holelock" ].state.plank = {3,1,2,1}   
   for i=1,4 do
     for a=1,6-i do
      ObjSet("spr_jaillock_mmg_plank_"..i.."_dot_"..a,{alp=0})
     end 
   end 
   for j=1,4 do
     for b = 1,ng_global.progress[ "std" ][ "win_holelock" ].state.plank[j] do
       ObjAnimate( "spr_jaillock_mmg_plank_"..j.."_dot_"..b, 8, 0, 0, "", {0,0,0, 0.5,0,1} );
     end
   end
   
   ObjAnimate( "spr_jaillock_mmg_key",0, 0, 0, function()ld.Lock(0);private.check_holelock() end, {0,0,ObjGet("spr_jaillock_mmg_key").pos_x, 0.5,0,ObjGet("spr_jaillock_mmg_key").pos_x,1,0,362} );
   SoundSfx( "aud_mg_jaillock_move_right" )
end

function private.check_holelock(load_holelock)
  local check_count 
  local s = ng_global.progress[ "std" ][ "win_holelock" ].state
    if s.plank[s.cur_plank-1] == private.win_holelock_win[s.cur_plank-1] then
      check_count = true
    else 
      check_count = false
    end

  if ng_global.progress[ "std" ][ "win_holelock" ].state.cur_plank == 5 and check_count then
    ld.Lock(1)
    SoundSfx( "aud_mg_jaillock_move_win" );
    ObjAnimate( "spr_jaillock_mmg_key", 0, 0, 0, function()ld.Lock(0);public.win_holelock()end, {0,0,ObjGet("spr_jaillock_mmg_key").pos_x, 0.5,0,610} );
    elseif not load_holelock and not check_count then
      private.win_holelock_reset()
  end
    
end

function public.clk_jaillock_key(param)
  local s = ng_global.progress[ "std" ][ "win_holelock" ].state
  if param == 2 then
    SoundSfx( "aud_mg_jaillock_move_right" );
    
    ObjAnimate( "spr_jaillock_mmg_clk_key_right", 8, 0, 0, "", {0,0,1, 0.2,0,0,0.4,0,1} );
    ng_global.progress[ "std" ][ "win_holelock" ].state.cur_plank = s.cur_plank + 1
    ld.Lock(1)
    ObjAnimate( "spr_jaillock_mmg_key", 0, 0, 0, function()
      ld.Lock(0)
      --if ng_global.progress[ "std" ][ "win_holelock" ].state.cur_plank == 5  then
        private.check_holelock()
        --end
    end
    , {0,0,ObjGet("spr_jaillock_mmg_key").pos_x, 0.5,0,ObjGet("spr_jaillock_mmg_key").pos_x+77} );
    
  else 
    SoundSfx( "aud_mg_jaillock_up_down" );
    if param == 1 then
      ObjAnimate( "spr_jaillock_mmg_clk_key_down", 8, 0, 0, "", {0,0,1, 0.2,0,0,0.4,0,1} );
    else
      ObjAnimate( "spr_jaillock_mmg_clk_key_up", 8, 0, 0, "", {0,0,1, 0.2,0,0,0.4,0,1} );
    end
    local num = s.cur_plank
    -------------------- for sound -------------------------------------------
    if param==1 and ng_global.progress[ "std" ][ "win_holelock" ].state.plank[num]<(6-s.cur_plank) then 
      ld.StartTimer( 0.5, function() SoundSfx( "aud_mg_jaillock_show_green" )  end )
    elseif param==-1 and ng_global.progress[ "std" ][ "win_holelock" ].state.plank[num]>0 then  
      ld.StartTimer( 0.5, function() SoundSfx( "aud_mg_jaillock_hide_green" )  end )
    end;  
    --------------------------------------------------------------------------
    
    ng_global.progress[ "std" ][ "win_holelock" ].state.plank[num]=s.plank[num]+param
    if ng_global.progress[ "std" ][ "win_holelock" ].state.plank[num]+s.cur_plank > 6 then
      ng_global.progress[ "std" ][ "win_holelock" ].state.plank[num] = 6-s.cur_plank 
    elseif ng_global.progress[ "std" ][ "win_holelock" ].state.plank[num] <= 0 then
      ng_global.progress[ "std" ][ "win_holelock" ].state.plank[num] = 0
    end
    ld.Lock(1)
    ObjAnimate( "spr_jaillock_mmg_key", 7, 0, 0, function()ld.Lock(0); private.load_point(s.cur_plank) end, {0,0,0, 0.25,0,0.08, 0.5,0,0} );
    local obj_p = ObjGet("spr_jaillock_mmg_plank_"..s.cur_plank)
    ObjAnimate( obj_p.name, 1, 0, 0, "", {0,0,obj_p.pos_y,0.15,0,obj_p.pos_y, 0.3,0,obj_p.pos_y+20,0.5,0,obj_p.pos_y} );
   end
end

function private.load_point(num)
  for i=1,6-num do
    ObjSet( "spr_jaillock_mmg_plank_"..num.."_dot_"..i, {alp=0} );
  end
  for j=1,ng_global.progress[ "std" ][ "win_holelock" ].state.plank[num] do
    ObjSet( "spr_jaillock_mmg_plank_"..num.."_dot_"..j, {alp=1} );
  end
end
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local get_cufflink_for_jail = function()
    if ld.CheckRequirements( {"get_cufflink"} ) then
      ObjSet( "gmg_jail_storystorm", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("get_cufflink", get_cufflink_for_jail, private.room_objname )

  local opn_rungs_for_jail = function()
    if ld.CheckRequirements( {"opn_rungs"} ) then
      ObjDelete("anm_jail_man")
    end
  end;
  cmn.AddSubscriber("opn_rungs", opn_rungs_for_jail, private.room_objname )
  
end;
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_jaillock" ) and not ld.CheckRequirements( { "win_holelock" } ) then  
    private.win_holelock_reset();
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_jaillock" ) and not ld.CheckRequirements( { "win_holelock" } ) then
    private.win_holelock_skip();
  end;
  
end
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_jail();
  if not ld.CheckRequirements({"clk_anmjail"}) then
    public.clk_anmjail()
  end  
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements({"clk_anmjail"}) then
    ObjSet("rm_jail",{color_r=0,color_g=0,color_b=0})
  else  
    SoundEnv( "aud_jail_env" );
  end  
  if cmn.IsEventDone("win_storystorm") and not cmn.IsEventDone("opn_rungs")  then 
    ObjSet( "obj_jail_storm_clk_zone", {input = 1} );
  else
    ObjSet( "obj_jail_storm_clk_zone", {input = 0} );    
  end;  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_jaillock" );
  function zz_jaillock.Open()
  end;
  function zz_jaillock.PreOpen()
     if cmn.IsEventStart("win_holelock") and not cmn.IsEventDone("win_holelock") then 
       cmn.MiniGameShow( "holelock" ); 
       private.init_holelock()
       private.load_holelock()
     end;     
  end;
  function zz_jaillock.PreClose()
  end;
  function zz_jaillock.Close()
  end;

  subroom.Define( "zz_tile" );
  function zz_tile.Open()
  end;
  function zz_tile.PreOpen()
  end;
  function zz_tile.PreClose()
  end;
  function zz_tile.Close()
  end;
  
end;
--*********************************************************************************************************************