-- name=rm_nearpub
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearpub";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  ld.NoteInit("spr_coach_paper","spr_coach_paper1","nearpub_coachnoteclk");
  ld.NoteInit("spr_gate_paper","spr_gate_paper1");
  --------------------------------------------------------------------------------------------------------
function private.opn_nearpub()
  if not ( cmn.IsEventDone( "opn_nearpub" ) ) then
    cmn.SetEventDone( "opn_nearpub" );
    cmn.CallEventHandler( "opn_nearpub" )
  end;
end;
--------------------------------------------------------------------
local opn_nearpub = function() end;
local opn_nearpub_logic = function() end;
cmn.AddSubscriber( "opn_nearpub", opn_nearpub_logic )
cmn.AddSubscriber( "opn_nearpub", opn_nearpub, private.room_objname )
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--
 local clk_gatemgfornearpub_logic = function()
    ObjSet( "grm_nearpub_darkquarter", {active = 1, visible = 1, input = 1} );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearpub_darkquarter_focus");
    end;
 end;
 local clk_gatemgfornearpub = function()
      ObjDelete("anm_nearpub_anim_gate");  
  end;
cmn.AddSubscriber("clk_gatemgfornearpub", clk_gatemgfornearpub_logic, private.room_objname )
cmn.AddSubscriber("clk_gatemgfornearpub", clk_gatemgfornearpub )

function public.clk_gatemgfornearpub()
  local func_end = function()
      ld.Lock(0);
      cmn.SetEventDone( "clk_gatemgfornearpub" );
      cmn.CallEventHandler( "clk_gatemgfornearpub" );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_open_gate_nearpub" )
  ld.AnimPlay( "anm_nearpub_anim_gate", "anim_gate", func_end )  
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
private.clk_raidfornearpub_logic = function()
  ObjSet( "grm_nearpub_pub", {pos_x=676, pos_y=391, inputrect_init=1, inputrect_w=172, inputrect_h=166, inputrect_x=-81, inputrect_y=-69} );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearpub_pub_focus");
    end;
  ObjDelete("spr_nearpub_grm_rm_pub")
  ObjSet( "spr_nearpub_grm_rm_pub2", {visible = 1, active=1} );
end;
private.clk_raidfornearpub_end = function()
  ObjSet("obj_nearpub_pubdoor_open_tr_root",{visible=1, active=1});
  ObjSet( "spr_nearpub_tr_door_open", {active=0, visible = 0} );
  ObjSet( "spr_nearpub_tr_window_brouken", {visible=1, active=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_raidfornearpub", private.clk_raidfornearpub_end, private.room_objname );
cmn.AddSubscriber( "clk_raidfornearpub", private.clk_raidfornearpub_logic );

function public.clk_raidfornearpub()
  cmn.SetEventDone( "clk_raidfornearpub" );
  cmn.CallEventHandler( "clk_raidfornearpub" );
end;  
----------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "william3" then
    if count_txt == 1 then
      
      
    elseif count_txt == 2 then      
      
    end;  
  end

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_nearpub_william3" ] = { type = "click", use_place = "gfx_nearpub_dlg_nearpub_william3_zone", room = "rm_nearpub" };

private.dlg_nearpub_william3_logic = function()
  ObjSet( "gzz_nearpub_gate", {active=1, input=1, visible=1} );
  ObjSet( "gzz_nearpub_doll", {active=1, input=1, visible=1} );
  ObjSet( "gzz_nearpub_pubdoor", {active=1, input=1, visible=1} );
  ObjSet( "gfx_nearpub_carretkey_zone", {active = 1, input = 1, visible = 1} );
end;
private.dlg_nearpub_william3_beg = function()
  ObjDelete( "gfx_nearpub_dlg_nearpub_william3_zone" );
end;
private.dlg_nearpub_william3_end = function()
 -- ObjDelete("anm_nearpub_anm_willyam_anm");
  ObjSet( "obj_nearpub_anims_clk_zone", {active = 1, input = 1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_nearpub_william3", private.dlg_nearpub_william3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_nearpub_william3", private.dlg_nearpub_william3_end, private.room_objname );
cmn.AddSubscriber( "dlg_nearpub_william3", private.dlg_nearpub_william3_logic );
cmn.AddSubscriber( "dlg_nearpub_william3_beg", private.dlg_nearpub_william3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_nearpub_william3_end", private.dlg_nearpub_william3_end, private.room_objname );
cmn.AddSubscriber( "dlg_nearpub_william3_end", private.dlg_nearpub_william3_logic );
--------------------------------------------------------------------------------------------
function public.dlg_nearpub_william3( obj )
 
  cmn.CallEventHandler( "dlg_nearpub_william3_beg" );
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  common_impl.dialog_character_loc =  "anm_nearpub_anm_willyam_anm"
  common_impl.Start( "william3", 2, nil, nil, true, "dlg_nearpub_william3_end", {"aud_william_5_voc"} );

end;
private.dlg_nearpub_william3_end = function()
  ObjSet( "dlg_nearpub_william3", {bake=1} );
  cmn.SetEventDone( "dlg_nearpub_william3" );
  cmn.CallEventHandler( "dlg_nearpub_william3_end" );
  ld.ShowBbt("after_dlg_william3");
end;
function public.dlg_nearpub_william3_end()
   private.dlg_nearpub_william3_end()
end


--------------------------------------------------------------------------------------------
function public.use_carretkey_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_carretkey' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_wagon_door_nearpub" );
  ld.AnimPlay( "anm_nearpub_anm_key", "idle_doorknob", func_end )
end;  

-----------------------------------------------------------------------------------------
common_impl.hint[ "use_carretkey" ] = { type = "use", inv_obj = "inv_carretkey", use_place = "gfx_nearpub_carretkey_zone", room = "rm_nearpub" };

private.use_carretkey_logic = function()
  ObjSet( "gzz_nearpub_coach", { visible = 1, input = 1, active = 1 } )
end;
private.use_carretkey_inv = function()
  common_impl.ProcessMultiUseAll("carretkey", "carretkey")
end;
private.use_carretkey_beg = function()
  ObjDelete( "gfx_nearpub_carretkey_zone" );
end;
private.use_carretkey_end = function()
  ObjDelete("anm_nearpub_anm_key");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_carretkey", private.use_carretkey_inv );
cmn.AddSubscriber( "use_carretkey", private.use_carretkey_beg, private.room_objname );
cmn.AddSubscriber( "use_carretkey", private.use_carretkey_end, private.room_objname );
cmn.AddSubscriber( "use_carretkey", private.use_carretkey_logic );
cmn.AddSubscriber( "use_carretkey_inv", private.use_carretkey_inv, private.room_objname );
cmn.AddSubscriber( "use_carretkey_beg", private.use_carretkey_beg, private.room_objname );
cmn.AddSubscriber( "use_carretkey_end", private.use_carretkey_end, private.room_objname );
cmn.AddSubscriber( "use_carretkey_end", private.use_carretkey_logic );
--------------------------------------------------------------------------------------------
function public.use_carretkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_carretkey" );
    cmn.CallEventHandler( "use_carretkey_end" );
  end;

  --func_end()
  cmn.CallEventHandler( "use_carretkey_inv" );
  cmn.CallEventHandler( "use_carretkey_beg" );
  SoundSfx( "aud_use_wagon_key_nearpub" );
  ld.AnimPlay( "anm_nearpub_anm_key", "use_keycarriage", func_end )
end;
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_pubdoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_brokenrod" ] = { type = "get", get_obj = "spr_pubdoor_brokenrod", room = "rm_nearpub", zz = "zz_pubdoor", zz_gate = "gzz_nearpub_pubdoor" };

private.get_brokenrod_logic = function()
  
end;
private.get_brokenrod_inv = function()
  interface.InventoryItemAdd("inv_brokenrod","spr_pubdoor_brokenrod");
  ObjSet( "inv_brokenrod", { drag = 0 } );
  ObjSet( "gfx_pubdoor_pubkey_pubdoor2_zone", {input = 1, visible = 1, active=1} );
end;
private.get_brokenrod_beg = function()
  ObjDelete("gfx_pubdoor_brokenrod")
end;
private.get_brokenrod_end = function()
  if common_impl.ZzCompleteCheck("get_brokenrod") then ObjSet( common_impl.hint["get_brokenrod"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_pubdoor_sh_fishingrod");
  ObjDelete("spr_nearpub_tr_brokenrod");
end;

cmn.AddSubscriber( "get_brokenrod", private.get_brokenrod_inv );
cmn.AddSubscriber( "get_brokenrod", private.get_brokenrod_beg, private.room_objname );
cmn.AddSubscriber( "get_brokenrod", private.get_brokenrod_end, private.room_objname );
cmn.AddSubscriber( "get_brokenrod", private.get_brokenrod_logic );
--------------------------------------------------------------------
function public.get_brokenrod()
  cmn.SetEventDone( "get_brokenrod" );
  cmn.CallEventHandler( "get_brokenrod" );
  if common_impl.ZzCompleteCheck("get_brokenrod") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
function public.use_bell_zone_clk(num)
   local func_end = function()
     common_impl.ShowBbt( "need_bell"..num )
     ld.Lock(0);
   end;
  
  
   if ld.CheckRequirements( {"use_bell1"} ) or ld.CheckRequirements( {"use_bell2"} ) then
     func_end();
   else
     ld.Lock(1);
     SoundSfx( "aud_touch_bell_nearpub" );
     ld.AnimPlay( "anm_pubdoor_anm_bells", "idle_levbell", func_end );
   end;
end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bell1" ] = { type = "use", inv_obj = "inv_bell1", use_place = "gfx_pubdoor_bell1_zone", room = "rm_nearpub", zz = "zz_pubdoor", zz_gate = "gzz_nearpub_pubdoor" };

private.use_bell1_logic = function()
  if ld.CheckRequirements( {"use_bell1","use_bell2"} ) then
    ObjSet( "spr_pubdoor_pubkey", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_bell1_inv = function()
  common_impl.ProcessMultiUseAll("bell1", "bell1")
end;
private.use_bell1_beg = function()
  ObjDelete( "gfx_pubdoor_bell1_zone" );
end;
private.use_bell1_end = function()
  if common_impl.ZzCompleteCheck("use_bell1") then ObjSet( common_impl.hint["use_bell1"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_bell1","use_bell2"} ) then
     ObjDelete("anm_pubdoor_anm_bells_1");
     ObjDelete("anm_pubdoor_anm_bells_2");
     ObjSet( "anm_pubdoor_anm_bells", {animfunc = "end_bell", frame = 999 } ); 
  else 
     ObjSet( "anm_pubdoor_anm_bells_1", {animfunc = "use_bell", frame = 999, pos_z=11 } );   
  end;      
  ObjSet( "spr_nearpub_tr_bell2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bell1", private.use_bell1_inv );
cmn.AddSubscriber( "use_bell1", private.use_bell1_beg, private.room_objname );
cmn.AddSubscriber( "use_bell1", private.use_bell1_end, private.room_objname );
cmn.AddSubscriber( "use_bell1", private.use_bell1_logic );
cmn.AddSubscriber( "use_bell1_inv", private.use_bell1_inv, private.room_objname );
cmn.AddSubscriber( "use_bell1_beg", private.use_bell1_beg, private.room_objname );
cmn.AddSubscriber( "use_bell1_end", private.use_bell1_end, private.room_objname );
cmn.AddSubscriber( "use_bell1_end", private.use_bell1_logic );
--------------------------------------------------------------------------------------------
function public.use_bell1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bell1" );
    cmn.CallEventHandler( "use_bell1_end" );
    if ld.CheckRequirements( {"use_bell1","use_bell2"} ) then
      cmn.SetEventDone( "get_pubkey" );
      cmn.CallEventHandler( "get_pubkey" );
    end;  
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bell1") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
     if ld.CheckRequirements( {"use_bell1"} ) or ld.CheckRequirements( {"use_bell2"} ) then 
       ObjSet( "anm_pubdoor_anm_bells_1", {visible=0} );
       ObjSet( "anm_pubdoor_anm_bells_2", {visible=0} );
       ld.AnimPlay( "anm_pubdoor_anm_bells", "end_bell", func_end )
       SoundSfx( "aud_touch_bells_nearpub" );
     else 
       func_end();
     end;  
  end;
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bell1_inv" );
  cmn.CallEventHandler( "use_bell1_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_pubdoor_anm_bells_1", {pos_z=32} );
  ld.AnimPlay( "anm_pubdoor_anm_bells_1", "use_bell", func_preend );
  SoundSfx( "aud_use_bell_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bell2" ] = { type = "use", inv_obj = "inv_bell2", use_place = "gfx_pubdoor_bell2_zone", room = "rm_nearpub", zz = "zz_pubdoor", zz_gate = "gzz_nearpub_pubdoor" };

private.use_bell2_logic = function()
  if ld.CheckRequirements( {"use_bell2","use_bell1"} ) then
    ObjSet( "spr_pubdoor_pubkey", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_bell2_inv = function()
  common_impl.ProcessMultiUseAll("bell2", "bell2")
end;
private.use_bell2_beg = function()
  ObjDelete( "gfx_pubdoor_bell2_zone" );
end;
private.use_bell2_end = function()
  if common_impl.ZzCompleteCheck("use_bell2") then ObjSet( common_impl.hint["use_bell2"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_bell1","use_bell2"} ) then
     ObjDelete("anm_pubdoor_anm_bells_1");
     ObjDelete("anm_pubdoor_anm_bells_2");
     ObjSet( "anm_pubdoor_anm_bells", {animfunc = "end_bell", frame = 999 } ); 
  else
     ObjSet( "anm_pubdoor_anm_bells_2", {animfunc = "use_bell1", frame = 999, pos_z=12 } );       
  end;    
  ObjSet( "spr_nearpub_tr_bell", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bell2", private.use_bell2_inv );
cmn.AddSubscriber( "use_bell2", private.use_bell2_beg, private.room_objname );
cmn.AddSubscriber( "use_bell2", private.use_bell2_end, private.room_objname );
cmn.AddSubscriber( "use_bell2", private.use_bell2_logic );
cmn.AddSubscriber( "use_bell2_inv", private.use_bell2_inv, private.room_objname );
cmn.AddSubscriber( "use_bell2_beg", private.use_bell2_beg, private.room_objname );
cmn.AddSubscriber( "use_bell2_end", private.use_bell2_end, private.room_objname );
cmn.AddSubscriber( "use_bell2_end", private.use_bell2_logic );
--------------------------------------------------------------------------------------------
function public.use_bell2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bell2" );
    cmn.CallEventHandler( "use_bell2_end" );
    if ld.CheckRequirements( {"use_bell1","use_bell2"} ) then
      cmn.SetEventDone( "get_pubkey" );
      cmn.CallEventHandler( "get_pubkey" );
    end;  
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bell2") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
     if ld.CheckRequirements( {"use_bell1"} ) or ld.CheckRequirements( {"use_bell2"} ) then 
       ObjSet( "anm_pubdoor_anm_bells_1", {visible=0} );
       ObjSet( "anm_pubdoor_anm_bells_2", {visible=0} );
       ld.AnimPlay( "anm_pubdoor_anm_bells", "end_bell", func_end )
       SoundSfx( "aud_touch_bells_nearpub" );
     else 
       func_end();
     end;  
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bell2_inv" );
  cmn.CallEventHandler( "use_bell2_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_pubdoor_anm_bells_2", {pos_z=32} );
  ld.AnimPlay( "anm_pubdoor_anm_bells_2", "use_bell1", func_preend );
  SoundSfx( "aud_use_bell2_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pubkey" ] = { type = "get", get_obj = "spr_pubdoor_pubkey", room = "rm_nearpub", zz = "zz_pubdoor", zz_gate = "gzz_nearpub_pubdoor" };

private.get_pubkey_logic = function()
  
end;
private.get_pubkey_inv = function()
  interface.InventoryItemAdd("inv_pubkey","spr_pubdoor_pubkey");
end;
private.get_pubkey_beg = function()
  ObjDelete("gfx_pubdoor_pubkey")
end;
private.get_pubkey_end = function()
  if common_impl.ZzCompleteCheck("get_pubkey") then ObjSet( common_impl.hint["get_pubkey"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_pubkey", private.get_pubkey_inv );
cmn.AddSubscriber( "get_pubkey", private.get_pubkey_beg, private.room_objname );
cmn.AddSubscriber( "get_pubkey", private.get_pubkey_end, private.room_objname );
cmn.AddSubscriber( "get_pubkey", private.get_pubkey_logic );
--------------------------------------------------------------------
function public.get_pubkey()
  cmn.SetEventDone( "get_pubkey" );
  cmn.CallEventHandler( "get_pubkey" );
  if common_impl.ZzCompleteCheck("get_pubkey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
public.use_pubkey_pubdoor2_zone_clk = function()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_pubkey_pubdoor2' )
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_handle_nearpub" );
  ld.AnimPlay( "anm_pubdoor_anm_doorknob", "idle_doorknob", func_end )
end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pubkey_pubdoor2" ] = { type = "use", inv_obj = "inv_pubkey", use_place = "gfx_pubdoor_pubkey_pubdoor2_zone", room = "rm_nearpub", zz = "zz_pubdoor", zz_gate = "gzz_nearpub_pubdoor" };

private.use_pubkey_pubdoor2_logic = function()
  ObjSet( "grm_nearpub_pub", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearpub_pub_focus");
    end;
end;
private.use_pubkey_pubdoor2_inv = function()
  common_impl.ProcessMultiUseAll("pubkey", "pubkey_pubdoor2")
end;
private.use_pubkey_pubdoor2_beg = function()
  ObjDelete( "gfx_pubdoor_pubkey_pubdoor2_zone" );
end;
private.use_pubkey_pubdoor2_end = function()
  if common_impl.ZzCompleteCheck("use_pubkey_pubdoor2") then ObjSet( common_impl.hint["use_pubkey_pubdoor2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_pubdoor_anm_key", {animfunc = "use_key", frame = 999 } );
  ObjSet("obj_nearpub_pubdoor_open_tr_root",{visible=0, active=0});
  ObjSet( "spr_nearpub_tr_door_open", {active=1, visible = 1} );
  ObjDelete("anm_nearpub_anm_willyam_anm");
  ObjDelete("anm_nearpub_anm_elisabet_anm");
  ObjDelete("obj_nearpub_anims_clk_zone");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pubkey_pubdoor2", private.use_pubkey_pubdoor2_inv );
cmn.AddSubscriber( "use_pubkey_pubdoor2", private.use_pubkey_pubdoor2_beg, private.room_objname );
cmn.AddSubscriber( "use_pubkey_pubdoor2", private.use_pubkey_pubdoor2_end, private.room_objname );
cmn.AddSubscriber( "use_pubkey_pubdoor2", private.use_pubkey_pubdoor2_logic );
cmn.AddSubscriber( "use_pubkey_pubdoor2_inv", private.use_pubkey_pubdoor2_inv, private.room_objname );
cmn.AddSubscriber( "use_pubkey_pubdoor2_beg", private.use_pubkey_pubdoor2_beg, private.room_objname );
cmn.AddSubscriber( "use_pubkey_pubdoor2_end", private.use_pubkey_pubdoor2_end, private.room_objname );
cmn.AddSubscriber( "use_pubkey_pubdoor2_end", private.use_pubkey_pubdoor2_logic );
--------------------------------------------------------------------------------------------
function public.use_pubkey_pubdoor2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pubkey_pubdoor2" );
    cmn.CallEventHandler( "use_pubkey_pubdoor2_end" );
    common_impl.Lock(0);
    --   if common_impl.ZzCompleteCheck("use_pubkey_pubdoor2") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
     ld.CloseSubRoom()
     --  SoundSfx( "aud_open_door_nearpub" );
     ObjAnimate( "anm_nearpub_anm_willyam_anm", 8, 0, 0, function() end, {0,0,1, 0.5,0,1, 1,0,0} );
       ObjAnimate( "anm_nearpub_anm_elisabet_anm", 8, 0, 0, func_end, {0,0,1, 0.5,0,1, 1,0,0} );
     ObjAnimate( "obj_nearpub_pubdoor_open_tr_root", 8, 0, 0, function()  SoundSfx( "aud_open_door_nearpub" );  ObjSet("obj_nearpub_pubdoor_open_tr_root",{visible=0, active=0, alp=1}); end, {0,0,1, 0.1,0,0} );
     ObjSet( "spr_nearpub_tr_door_open", {active=1, visible = 1, alp=0} );
     ObjAnimate( "spr_nearpub_tr_door_open", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pubkey_pubdoor2_inv" );
  cmn.CallEventHandler( "use_pubkey_pubdoor2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pubdoor_anm_key", "use_key", func_preend );
  SoundSfx( "aud_use_key_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
function public.pubdoor_wanted_zone_clk()
  local func_end=function()
    ObjSet( "obj_pubdoor_wanted_clk_zone", {input = 1} );
  end;
  
  ObjSet( "obj_pubdoor_wanted_clk_zone", {input = 0} );
  SoundSfx( "aud_touch_wanted_nearpub" );
  ld.AnimPlay( "anm_pubdoor_anm_idle_wanted", "idle_wanted", func_end )
end;  

function public.pubdoor_plate_zone_clk()
  local func_end=function()
    ObjSet( "obj_pubdoor_plate_clk_zone", {input = 1} );
  end;
  
  ObjSet( "obj_pubdoor_plate_clk_zone", {input = 0} );
  SoundSfx( "aud_touch_plate_nearpub" )
  ld.AnimPlay( "anm_pubdoor_anm_idle_plate", "idle_plate", func_end )
end;  
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_doll *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_barrel2" ] = { type = "get", get_obj = "spr_doll_barrel2", room = "rm_nearpub", zz = "zz_doll", zz_gate = "gzz_nearpub_doll" };

private.get_barrel2_logic = function()
  
end;
private.get_barrel2_inv = function()
  interface.InventoryItemAdd("inv_barrel","spr_doll_barrel2",function() level_inv.ProcessGetBarrelAll( "get_barrel2" ) end);
end;
private.get_barrel2_beg = function()
  ObjDelete("gfx_doll_barrel2")
end;
private.get_barrel2_end = function()
  if common_impl.ZzCompleteCheck("get_barrel2") then ObjSet( common_impl.hint["get_barrel2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_nearpub_tr_barrel");
  ObjDelete("spr_doll_sh_barrel2");
end;

cmn.AddSubscriber( "get_barrel2", private.get_barrel2_inv );
cmn.AddSubscriber( "get_barrel2", private.get_barrel2_beg, private.room_objname );
cmn.AddSubscriber( "get_barrel2", private.get_barrel2_end, private.room_objname );
cmn.AddSubscriber( "get_barrel2", private.get_barrel2_logic );
--------------------------------------------------------------------
function public.get_barrel2()
  cmn.SetEventDone( "get_barrel2" );
  cmn.CallEventHandler( "get_barrel2" );
  if common_impl.ZzCompleteCheck("get_barrel2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_dollglasses" ] = { type = "click", use_place = "gfx_doll_clk_dollglasses_zone", room = "rm_nearpub", zz = "zz_doll", zz_gate = "gzz_nearpub_doll" };

private.clk_dollglasses_logic = function()
   ObjSet( "gfx_doll_glasses_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_dollglasses_beg = function()
  ObjDelete( "gfx_doll_clk_dollglasses_zone" );
end;
private.clk_dollglasses_end = function()
  if common_impl.ZzCompleteCheck("clk_dollglasses") then ObjSet( common_impl.hint["clk_dollglasses"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_doll_anm", {animfunc = "use_glasses", frame = 0 } );
  ObjSet( "spr_nearpub_glasses", {acttive=0, visible = 0} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_dollglasses", private.clk_dollglasses_beg, private.room_objname );
cmn.AddSubscriber( "clk_dollglasses", private.clk_dollglasses_end, private.room_objname );
cmn.AddSubscriber( "clk_dollglasses", private.clk_dollglasses_logic );
cmn.AddSubscriber( "clk_dollglasses_beg", private.clk_dollglasses_beg, private.room_objname );
cmn.AddSubscriber( "clk_dollglasses_end", private.clk_dollglasses_end, private.room_objname );
cmn.AddSubscriber( "clk_dollglasses_end", private.clk_dollglasses_logic );
--------------------------------------------------------------------------------------------
function public.clk_dollglasses()

  local func_end = function()
    cmn.SetEventDone( "clk_dollglasses" );
    cmn.CallEventHandler( "clk_dollglasses_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_dollglasses") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_dollglasses_beg" );
  common_impl.Lock(1);
  
  ld.AnimPlay( "anm_doll_anm", "click_glasses", func_end );
  SoundSfx( "aud_touch_doll_glasses" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_glasses_zone_clk()
  local func_end = function() 
    ld.Lock(0);
    common_impl.ShowBbt( 'need_glasses' );
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_doll" );
  ld.AnimPlay( "anm_doll_anm", "idle_doll", func_end )
end;  


common_impl.hint[ "use_glasses" ] = { type = "use", inv_obj = "inv_glasses", use_place = "gfx_doll_glasses_zone", room = "rm_nearpub", zz = "zz_doll", zz_gate = "gzz_nearpub_doll" };

private.use_glasses_logic = function()
  ObjSet( "spr_doll_clover", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_doll_clover", {visible=1, active=1} );
end;
private.use_glasses_inv = function()
  common_impl.ProcessMultiUseAll("glasses", "glasses")
end;
private.use_glasses_beg = function()
  ObjDelete( "gfx_doll_glasses_zone" );
end;
private.use_glasses_end = function()
  if common_impl.ZzCompleteCheck("use_glasses") then ObjSet( common_impl.hint["use_glasses"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_doll_anm", {animfunc = "use_glasses", frame = 999 } );
  ObjSet( "spr_nearpub_glasses", {active=1, visible = 1} );
  ObjSet( "spr_nearpub_tr_hand", {visible = 1, active=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_glasses", private.use_glasses_inv );
cmn.AddSubscriber( "use_glasses", private.use_glasses_beg, private.room_objname );
cmn.AddSubscriber( "use_glasses", private.use_glasses_end, private.room_objname );
cmn.AddSubscriber( "use_glasses", private.use_glasses_logic );
cmn.AddSubscriber( "use_glasses_inv", private.use_glasses_inv, private.room_objname );
cmn.AddSubscriber( "use_glasses_beg", private.use_glasses_beg, private.room_objname );
cmn.AddSubscriber( "use_glasses_end", private.use_glasses_end, private.room_objname );
cmn.AddSubscriber( "use_glasses_end", private.use_glasses_logic );
--------------------------------------------------------------------------------------------
function public.use_glasses( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_glasses" );
    cmn.CallEventHandler( "use_glasses_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_glasses") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_glasses_inv" );
  cmn.CallEventHandler( "use_glasses_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doll_anm", "use_glasses", func_end );
  SoundSfx( "aud_use_glasses_doll" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_clover" ] = { type = "get", get_obj = "spr_doll_clover", room = "rm_nearpub", zz = "zz_doll", zz_gate = "gzz_nearpub_doll" };

private.get_clover_logic = function()
  ObjSet( "gfx_doll_plaquebelt_zone", {active = 1, input=1, visible=1} );
end;
private.get_clover_inv = function()
  interface.InventoryItemAdd("inv_clover","spr_doll_clover");
end;
private.get_clover_beg = function()
  ObjDelete("gfx_doll_clover")
end;
private.get_clover_end = function()
  if common_impl.ZzCompleteCheck("get_clover") then ObjSet( common_impl.hint["get_clover"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_doll_anm", {animfunc = "use_plaquebelt", frame = 0 } );
  ObjSet( "spr_nearpub_tr_hand", {visible = 0, active=0} );
end;

cmn.AddSubscriber( "get_clover_inv", private.get_clover_inv );
cmn.AddSubscriber( "get_clover_beg", private.get_clover_beg, private.room_objname );
cmn.AddSubscriber( "get_clover_end", private.get_clover_end, private.room_objname );
cmn.AddSubscriber( "get_clover_end", private.get_clover_logic );
cmn.AddSubscriber( "get_clover", private.get_clover_inv );
cmn.AddSubscriber( "get_clover", private.get_clover_beg, private.room_objname );
cmn.AddSubscriber( "get_clover", private.get_clover_end, private.room_objname );
cmn.AddSubscriber( "get_clover", private.get_clover_logic );
--------------------------------------------------------------------
function public.get_clover()
  local func_end = function()
    ld.Lock(0);
    cmn.SetEventDone( "get_clover" );
    cmn.CallEventHandler( "get_clover_end" );
    if common_impl.ZzCompleteCheck("get_clover") then ld.CloseSubRoom() end;
  end;  
  
  ld.Lock(1);
  --ObjSet( "anm_doll_anm", {animfunc = "hand", frame = 0 } );
  ObjSet( "spr_doll_clover", {visible = 1} );
  cmn.CallEventHandler( "get_clover_inv" );
  cmn.CallEventHandler( "get_clover_beg" );
  ld.AnimPlay( "anm_doll_anm", "hand", func_end )
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_plaquebelt_zone_clk()
  local func_end = function() 
    ld.Lock(0);
    common_impl.ShowBbt( 'need_plaquebelt' )
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_doll_belt" )
  ld.AnimPlay( "anm_doll_anm", "idle_belt", func_end )
end;  

common_impl.hint[ "use_plaquebelt" ] = { type = "use", inv_obj = "inv_plaquebelt", use_place = "gfx_doll_plaquebelt_zone", room = "rm_nearpub", zz = "zz_doll", zz_gate = "gzz_nearpub_doll" };

private.use_plaquebelt_logic = function()
  ObjSet( "spr_doll_bullring", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_doll_clk_dollscarf_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_plaquebelt_inv = function()
  common_impl.ProcessMultiUseAll("plaquebelt", "plaquebelt")
end;
private.use_plaquebelt_beg = function()
  ObjDelete( "gfx_doll_plaquebelt_zone" );
end;
private.use_plaquebelt_end = function()
  if common_impl.ZzCompleteCheck("use_plaquebelt") then ObjSet( common_impl.hint["use_plaquebelt"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_doll_anm", {animfunc = "click_scarf", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_plaquebelt", private.use_plaquebelt_inv );
cmn.AddSubscriber( "use_plaquebelt", private.use_plaquebelt_beg, private.room_objname );
cmn.AddSubscriber( "use_plaquebelt", private.use_plaquebelt_end, private.room_objname );
cmn.AddSubscriber( "use_plaquebelt", private.use_plaquebelt_logic );
cmn.AddSubscriber( "use_plaquebelt_inv", private.use_plaquebelt_inv, private.room_objname );
cmn.AddSubscriber( "use_plaquebelt_beg", private.use_plaquebelt_beg, private.room_objname );
cmn.AddSubscriber( "use_plaquebelt_end", private.use_plaquebelt_end, private.room_objname );
cmn.AddSubscriber( "use_plaquebelt_end", private.use_plaquebelt_logic );
--------------------------------------------------------------------------------------------
function public.use_plaquebelt( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_plaquebelt" );
    cmn.CallEventHandler( "use_plaquebelt_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_plaquebelt") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_plaquebelt_inv" );
  cmn.CallEventHandler( "use_plaquebelt_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doll_anm", "use_plaquebelt", func_end );
  SoundSfx( "aud_use_buckle_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bullring" ] = { type = "get", get_obj = "spr_doll_bullring", room = "rm_nearpub", zz = "zz_doll", zz_gate = "gzz_nearpub_doll" };

private.get_bullring_logic = function()
  
end;
private.get_bullring_inv = function()
  interface.InventoryItemAdd("inv_bullring","spr_doll_bullring");
end;
private.get_bullring_beg = function()
  ObjDelete("gfx_doll_bullring")
end;
private.get_bullring_end = function()
  if common_impl.ZzCompleteCheck("get_bullring") then ObjSet( common_impl.hint["get_bullring"].zz_gate, { visible = 0, input = 0 } ); end;
  -- ObjSet( "anm_doll_anm", {animfunc = "click_scarf", frame = 0 } );
  ObjDelete("spr_doll_sh_bullring");
end;

cmn.AddSubscriber( "get_bullring", private.get_bullring_inv );
cmn.AddSubscriber( "get_bullring", private.get_bullring_beg, private.room_objname );
cmn.AddSubscriber( "get_bullring", private.get_bullring_end, private.room_objname );
cmn.AddSubscriber( "get_bullring", private.get_bullring_logic );
--------------------------------------------------------------------
function public.get_bullring()
  --  ObjSet( "spr_doll_bullring", {visible = 1} );
  cmn.SetEventDone( "get_bullring" );
  cmn.CallEventHandler( "get_bullring" );
  if common_impl.ZzCompleteCheck("get_bullring") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_dollscarf" ] = { type = "click", use_place = "gfx_doll_clk_dollscarf_zone", room = "rm_nearpub", zz = "zz_doll", zz_gate = "gzz_nearpub_doll" };

private.clk_dollscarf_logic = function()
   ObjSet( "gfx_doll_scarf_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_dollscarf_beg = function()
  ObjDelete( "gfx_doll_clk_dollscarf_zone" );
end;
private.clk_dollscarf_end = function()
  if common_impl.ZzCompleteCheck("clk_dollscarf") then ObjSet( common_impl.hint["clk_dollscarf"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_doll_anm", {animfunc = "use_scarf", frame = 0 } );
  ObjDelete("spr_nearpub_tr_scarf2");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_dollscarf", private.clk_dollscarf_beg, private.room_objname );
cmn.AddSubscriber( "clk_dollscarf", private.clk_dollscarf_end, private.room_objname );
cmn.AddSubscriber( "clk_dollscarf", private.clk_dollscarf_logic );
cmn.AddSubscriber( "clk_dollscarf_beg", private.clk_dollscarf_beg, private.room_objname );
cmn.AddSubscriber( "clk_dollscarf_end", private.clk_dollscarf_end, private.room_objname );
cmn.AddSubscriber( "clk_dollscarf_end", private.clk_dollscarf_logic );
--------------------------------------------------------------------------------------------
function public.clk_dollscarf()

  local func_end = function()
    cmn.SetEventDone( "clk_dollscarf" );
    cmn.CallEventHandler( "clk_dollscarf_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_dollscarf") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_dollscarf_beg" );
  common_impl.Lock(1);
  
  ld.AnimPlay( "anm_doll_anm", "click_scarf", func_end );
  SoundSfx( "aud_touch_doll_clothes" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scarf" ] = { type = "use", inv_obj = "inv_scarf", use_place = "gfx_doll_scarf_zone", room = "rm_nearpub", zz = "zz_doll", zz_gate = "gzz_nearpub_doll" };

private.use_scarf_logic = function()
  ObjSet( "spr_doll_hook", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_doll_hook", { active = 1, visible = 1} );
end;
private.use_scarf_inv = function()
  common_impl.ProcessMultiUseAll("scarf", "scarf")
end;
private.use_scarf_beg = function()
  ObjDelete( "gfx_doll_scarf_zone" );
end;
private.use_scarf_end = function()
  if common_impl.ZzCompleteCheck("use_scarf") then ObjSet( common_impl.hint["use_scarf"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_doll_anm", {animfunc = "use_scarf", frame = 999 } );
  ObjSet("spr_nearpub_tr_scarf",{visible=1, active=1})
  ObjSet( "spr_nearpub_tr_hand", {visible = 1, active=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scarf", private.use_scarf_inv );
cmn.AddSubscriber( "use_scarf", private.use_scarf_beg, private.room_objname );
cmn.AddSubscriber( "use_scarf", private.use_scarf_end, private.room_objname );
cmn.AddSubscriber( "use_scarf", private.use_scarf_logic );
cmn.AddSubscriber( "use_scarf_inv", private.use_scarf_inv, private.room_objname );
cmn.AddSubscriber( "use_scarf_beg", private.use_scarf_beg, private.room_objname );
cmn.AddSubscriber( "use_scarf_end", private.use_scarf_end, private.room_objname );
cmn.AddSubscriber( "use_scarf_end", private.use_scarf_logic );
--------------------------------------------------------------------------------------------
function public.use_scarf( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scarf" );
    cmn.CallEventHandler( "use_scarf_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_scarf") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scarf_inv" );
  cmn.CallEventHandler( "use_scarf_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doll_anm", "use_scarf", func_end );
  SoundSfx( "aud_use_scarf_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hook" ] = { type = "get", get_obj = "spr_doll_hook", room = "rm_nearpub", zz = "zz_doll", zz_gate = "gzz_nearpub_doll" };

private.get_hook_logic = function()
  
end;
private.get_hook_inv = function()
  interface.InventoryItemAdd("inv_hook","spr_doll_hook");
end;
private.get_hook_beg = function()
  ObjDelete("gfx_doll_hook")
end;
private.get_hook_end = function()
  if common_impl.ZzCompleteCheck("get_hook") then ObjSet( common_impl.hint["get_hook"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_nearpub_tr_hand", {visible = 0, active=0} );
end;

cmn.AddSubscriber( "get_hook_inv", private.get_hook_inv );
cmn.AddSubscriber( "get_hook_beg", private.get_hook_beg, private.room_objname );
cmn.AddSubscriber( "get_hook_end", private.get_hook_end, private.room_objname );
cmn.AddSubscriber( "get_hook_end", private.get_hook_logic );
cmn.AddSubscriber( "get_hook", private.get_hook_inv );
cmn.AddSubscriber( "get_hook", private.get_hook_beg, private.room_objname );
cmn.AddSubscriber( "get_hook", private.get_hook_end, private.room_objname );
cmn.AddSubscriber( "get_hook", private.get_hook_logic );
--------------------------------------------------------------------
function public.get_hook()
  local func_end = function()
      ld.Lock(0);
      cmn.SetEventDone( "get_hook" );
      cmn.CallEventHandler( "get_hook_end" );
      if common_impl.ZzCompleteCheck("get_hook") then ld.CloseSubRoom() end;
  end;
  
  ld.Lock(1);
  ObjSet( "spr_doll_hook", {visible = 1} );
  cmn.CallEventHandler( "get_hook_inv" );
  cmn.CallEventHandler( "get_hook_beg" );
  ld.AnimPlay( "anm_doll_anm", "hand2", func_end )
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_gate *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_bell1" ] = { type = "get", get_obj = "spr_gate_bell1", room = "rm_nearpub", zz = "zz_gate", zz_gate = "gzz_nearpub_gate" };

private.get_bell1_logic = function()
  
end;
private.get_bell1_inv = function()
  interface.InventoryItemAdd("inv_bell1","spr_gate_bell1");
end;
private.get_bell1_beg = function()
  ObjDelete("gfx_gate_bell1")
end;
private.get_bell1_end = function()
  if common_impl.ZzCompleteCheck("get_bell1") then ObjSet( common_impl.hint["get_bell1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_gate_sh_bell1");
  ObjDelete("spr_nearpub_tr_bell3");
end;

cmn.AddSubscriber( "get_bell1", private.get_bell1_inv );
cmn.AddSubscriber( "get_bell1", private.get_bell1_beg, private.room_objname );
cmn.AddSubscriber( "get_bell1", private.get_bell1_end, private.room_objname );
cmn.AddSubscriber( "get_bell1", private.get_bell1_logic );
--------------------------------------------------------------------
function public.get_bell1()
  cmn.SetEventDone( "get_bell1" );
  cmn.CallEventHandler( "get_bell1" );
  if common_impl.ZzCompleteCheck("get_bell1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_stone" ] = { type = "get", get_obj = "spr_gate_stone", room = "rm_nearpub", zz = "zz_gate", zz_gate = "gzz_nearpub_gate" };

private.get_stone_logic = function()
  
end;
private.get_stone_inv = function()
  interface.InventoryItemAdd("inv_stone","spr_gate_stone");
end;
private.get_stone_beg = function()
  ObjDelete("gfx_gate_stone")
end;
private.get_stone_end = function()
  if common_impl.ZzCompleteCheck("get_stone") then ObjSet( common_impl.hint["get_stone"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_gate_sh_stone");
  ObjDelete("spr_gate_tr_stone");
  ObjDelete("spr_nearpub_tr_stone");
end;

cmn.AddSubscriber( "get_stone", private.get_stone_inv );
cmn.AddSubscriber( "get_stone", private.get_stone_beg, private.room_objname );
cmn.AddSubscriber( "get_stone", private.get_stone_end, private.room_objname );
cmn.AddSubscriber( "get_stone", private.get_stone_logic );
--------------------------------------------------------------------
function public.get_stone()
  cmn.SetEventDone( "get_stone" );
  cmn.CallEventHandler( "get_stone" );
  if common_impl.ZzCompleteCheck("get_stone") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_bigkey_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_bigkey' )
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_lock_nearpub" );
  ld.AnimPlay( "anm_gate_anim_gate", "idle_door", func_end )
end;  


common_impl.hint[ "use_bigkey" ] = { type = "use", inv_obj = "inv_bigkey", use_place = "gfx_gate_bigkey_zone", room = "rm_nearpub", zz = "zz_gate", zz_gate = "gzz_nearpub_gate" };

private.use_bigkey_logic = function()
   ObjSet( "gfx_gate_clk_bigkey_zone", {input = 1, visible = 1, active = 1} );
end;
private.use_bigkey_inv = function()
  common_impl.ProcessMultiUseAll("bigkey", "bigkey")
end;
private.use_bigkey_beg = function()
  ObjDelete( "gfx_gate_bigkey_zone" );
end;
private.use_bigkey_end = function()
  if common_impl.ZzCompleteCheck("use_bigkey") then ObjSet( common_impl.hint["use_bigkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_gate_anim_gate", {animfunc = "use_key1", frame = 0 } );
  ObjSet( "spr_nearpub_tr_key", {active=1,visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bigkey", private.use_bigkey_inv );
cmn.AddSubscriber( "use_bigkey", private.use_bigkey_beg, private.room_objname );
cmn.AddSubscriber( "use_bigkey", private.use_bigkey_end, private.room_objname );
cmn.AddSubscriber( "use_bigkey", private.use_bigkey_logic );
cmn.AddSubscriber( "use_bigkey_inv", private.use_bigkey_inv, private.room_objname );
cmn.AddSubscriber( "use_bigkey_beg", private.use_bigkey_beg, private.room_objname );
cmn.AddSubscriber( "use_bigkey_end", private.use_bigkey_end, private.room_objname );
cmn.AddSubscriber( "use_bigkey_end", private.use_bigkey_logic );
--------------------------------------------------------------------------------------------
function public.use_bigkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bigkey" );
    cmn.CallEventHandler( "use_bigkey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bigkey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bigkey_inv" );
  cmn.CallEventHandler( "use_bigkey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_gate_anim_gate", "use_key", func_end );
  SoundSfx( "aud_use_key_lock_nearpub" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_bigkey" ] = { type = "click", use_place = "gfx_gate_clk_bigkey_zone", room = "rm_nearpub", zz = "zz_gate", zz_gate = "gzz_nearpub_gate" };

private.clk_bigkey_logic = function()
   ObjSet( "gmg_nearpub_gatemg", { visible = 1, input = 1, active = 1 } )
   ObjSet( "spr_gate_paper", {input = 0} );
   ObjSet( "gzz_nearpub_gate", {active = 0, input = 0, visible=0} );
end;
private.clk_bigkey_beg = function()
  ObjDelete( "gfx_gate_clk_bigkey_zone" );
end;
private.clk_bigkey_end = function()
  if common_impl.ZzCompleteCheck("clk_bigkey") then ObjSet( common_impl.hint["clk_bigkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_gate_anim_gate")
  ObjDelete("spr_nearpub_tr_door1")
  ObjDelete("spr_nearpub_tr_door2")
  ObjDelete("spr_nearpub_tr_key");
  ObjDelete("spr_nearpub_tr_paper_1");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_bigkey", private.clk_bigkey_beg, private.room_objname );
cmn.AddSubscriber( "clk_bigkey", private.clk_bigkey_end, private.room_objname );
cmn.AddSubscriber( "clk_bigkey", private.clk_bigkey_logic );
cmn.AddSubscriber( "clk_bigkey_beg", private.clk_bigkey_beg, private.room_objname );
cmn.AddSubscriber( "clk_bigkey_end", private.clk_bigkey_end, private.room_objname );
cmn.AddSubscriber( "clk_bigkey_end", private.clk_bigkey_logic );
--------------------------------------------------------------------------------------------
function public.clk_bigkey()

  local func_end = function()
    cmn.SetEventDone( "clk_bigkey" );
    cmn.CallEventHandler( "clk_bigkey_end" );
    common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("clk_bigkey") then ld.CloseSubRoom() end;
    ld.CloseSubRoom()
    cmn.GotoRoom("mg_gatemg");
  end;

  cmn.CallEventHandler( "clk_bigkey_beg" );
  common_impl.Lock(1);
  
  ld.AnimPlay( "anm_gate_anim_gate", "use_key1", func_end );
  SoundSfx( "aud_touch_key_lock_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_coach *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_raggeddress" ] = { type = "click", use_place = "gfx_coach_clk_raggeddress_zone", room = "rm_nearpub", zz = "zz_coach", zz_gate = "gzz_nearpub_coach" };

private.clk_raggeddress_logic = function()
--  ObjSet( "spr_coach_raggeddress", { visible = 1, input = 1, active = 1 } )

end;
private.clk_raggeddress_beg = function()
  ObjDelete( "gfx_coach_clk_raggeddress_zone" );
end;
private.clk_raggeddress_end = function()
  if common_impl.ZzCompleteCheck("clk_raggeddress") then ObjSet( common_impl.hint["clk_raggeddress"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_coach_anm_coach_raggeddress",{animfunc="use_ragged", frame=999});
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_raggeddress", private.clk_raggeddress_beg, private.room_objname );
cmn.AddSubscriber( "clk_raggeddress", private.clk_raggeddress_end, private.room_objname );
cmn.AddSubscriber( "clk_raggeddress", private.clk_raggeddress_logic );
cmn.AddSubscriber( "clk_raggeddress_beg", private.clk_raggeddress_beg, private.room_objname );
cmn.AddSubscriber( "clk_raggeddress_end", private.clk_raggeddress_end, private.room_objname );
cmn.AddSubscriber( "clk_raggeddress_end", private.clk_raggeddress_logic );
--------------------------------------------------------------------------------------------
function public.clk_raggeddress()

  local func_end = function()
    ObjSet( "spr_coach_raggeddress", {active=1,input=1,visible=1} );
    cmn.SetEventDone( "clk_raggeddress" );
    cmn.CallEventHandler( "clk_raggeddress_end" );
    cmn.SetEventDone( "get_raggeddress" );
    cmn.CallEventHandler( "get_raggeddress" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_raggeddress") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_raggeddress_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_coach_anm_coach_raggeddress", "use_ragged", func_end );
  SoundSfx( "aud_touch_dress_nearpub" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_raggeddress" ] = { type = "get", get_obj = "spr_coach_raggeddress", room = "rm_nearpub", zz = "zz_coach", zz_gate = "gzz_nearpub_coach" };

private.get_raggeddress_logic = function()
  
end;
private.get_raggeddress_inv = function()
  interface.InventoryItemAdd("inv_raggeddress","spr_coach_raggeddress");
  ObjSet( "inv_raggeddress", { drag = 0 } );
end;
private.get_raggeddress_beg = function()
  ObjDelete("gfx_coach_raggeddress")
end;
private.get_raggeddress_end = function()
  if common_impl.ZzCompleteCheck("get_raggeddress") then ObjSet( common_impl.hint["get_raggeddress"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_coach_sh_ragged");
end;

cmn.AddSubscriber( "get_raggeddress", private.get_raggeddress_inv );
cmn.AddSubscriber( "get_raggeddress", private.get_raggeddress_beg, private.room_objname );
cmn.AddSubscriber( "get_raggeddress", private.get_raggeddress_end, private.room_objname );
cmn.AddSubscriber( "get_raggeddress", private.get_raggeddress_logic );
--------------------------------------------------------------------
function public.get_raggeddress()
  cmn.SetEventDone( "get_raggeddress" );
  cmn.CallEventHandler( "get_raggeddress" );
  if common_impl.ZzCompleteCheck("get_raggeddress") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bigkey" ] = { type = "get", get_obj = "spr_coach_bigkey", room = "rm_nearpub", zz = "zz_coach", zz_gate = "gzz_nearpub_coach" };

private.get_bigkey_logic = function()
  ObjSet( "gfx_coach_cone_zone", {active=1, input=1, visible = 1} );
end;
private.get_bigkey_inv = function()
  interface.InventoryItemAdd("inv_bigkey","spr_coach_bigkey");
end;
private.get_bigkey_beg = function()
  ObjDelete("gfx_coach_bigkey")
end;
private.get_bigkey_end = function()
  if common_impl.ZzCompleteCheck("get_bigkey") then ObjSet( common_impl.hint["get_bigkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_coach_sh_bigkey");
  ObjDelete("spr_coach_tr_door");
  --ObjDelete("spr_nearpub_tr_bigkey");
end;

cmn.AddSubscriber( "get_bigkey", private.get_bigkey_inv );
cmn.AddSubscriber( "get_bigkey", private.get_bigkey_beg, private.room_objname );
cmn.AddSubscriber( "get_bigkey", private.get_bigkey_end, private.room_objname );
cmn.AddSubscriber( "get_bigkey", private.get_bigkey_logic );
--------------------------------------------------------------------
function public.get_bigkey()
  cmn.SetEventDone( "get_bigkey" );
  cmn.CallEventHandler( "get_bigkey" );
  if common_impl.ZzCompleteCheck("get_bigkey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_frame_zone_clk()
  local func_end = function()
     ld.Lock(0);   
     common_impl.ShowBbt( 'need_frame' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_mirror_nearpub" );
  ld.AnimPlay( "anm_coach_anm_coach_frame", "idle_mirror", func_end );
end;  



common_impl.hint[ "use_frame" ] = { type = "use", inv_obj = "inv_frame", use_place = "gfx_coach_frame_zone", room = "rm_nearpub", zz = "zz_coach", zz_gate = "gzz_nearpub_coach" };

private.use_frame_logic = function()
  ObjSet( "spr_coach_birdclaw", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_coach_birdclaw", {active = 1, visible = 1} );
end;
private.use_frame_inv = function()
  common_impl.ProcessMultiUseAll("frame", "frame")
end;
private.use_frame_beg = function()
  ObjDelete( "gfx_coach_frame_zone" );
end;
private.use_frame_end = function()
  if common_impl.ZzCompleteCheck("use_frame") then ObjSet( common_impl.hint["use_frame"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_coach_anm_coach_frame", {animfunc = "end_frame", frame = 0 } );
  ObjDelete("spr_nearpub_tr_mirrow");
  ObjSet( "spr_nearpub_tr_frame", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_frame", private.use_frame_inv );
cmn.AddSubscriber( "use_frame", private.use_frame_beg, private.room_objname );
cmn.AddSubscriber( "use_frame", private.use_frame_end, private.room_objname );
cmn.AddSubscriber( "use_frame", private.use_frame_logic );
cmn.AddSubscriber( "use_frame_inv", private.use_frame_inv, private.room_objname );
cmn.AddSubscriber( "use_frame_beg", private.use_frame_beg, private.room_objname );
cmn.AddSubscriber( "use_frame_end", private.use_frame_end, private.room_objname );
cmn.AddSubscriber( "use_frame_end", private.use_frame_logic );
--------------------------------------------------------------------------------------------
function public.use_frame( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_frame" );
    cmn.CallEventHandler( "use_frame_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_frame") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_frame_inv" );
  cmn.CallEventHandler( "use_frame_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_coach_anm_coach_frame", "use_frame", func_end );
  SoundSfx( "aud_use_frame_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_birdclaw" ] = { type = "get", get_obj = "spr_coach_birdclaw", room = "rm_nearpub", zz = "zz_coach", zz_gate = "gzz_nearpub_coach" };

private.get_birdclaw_logic = function()
  
end;
private.get_birdclaw_inv = function()
  interface.InventoryItemAdd("inv_birdclaw","spr_coach_birdclaw");
end;
private.get_birdclaw_beg = function()
  ObjDelete("gfx_coach_birdclaw")
end;
private.get_birdclaw_end = function()
  if common_impl.ZzCompleteCheck("get_birdclaw") then ObjSet( common_impl.hint["get_birdclaw"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_coach_sh_birdclaw");
end;

cmn.AddSubscriber( "get_birdclaw", private.get_birdclaw_inv );
cmn.AddSubscriber( "get_birdclaw", private.get_birdclaw_beg, private.room_objname );
cmn.AddSubscriber( "get_birdclaw", private.get_birdclaw_end, private.room_objname );
cmn.AddSubscriber( "get_birdclaw", private.get_birdclaw_logic );
--------------------------------------------------------------------
function public.get_birdclaw()
  cmn.SetEventDone( "get_birdclaw" );
  cmn.CallEventHandler( "get_birdclaw" );
  if common_impl.ZzCompleteCheck("get_birdclaw") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_cone_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_cone' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_stash_nearpub" );
  ld.AnimPlay( "anm_coach_anm_coach_cone", "idle_close", func_end )
end;  


common_impl.hint[ "use_cone" ] = { type = "use", inv_obj = "inv_cone", use_place = "gfx_coach_cone_zone", room = "rm_nearpub", zz = "zz_coach", zz_gate = "gzz_nearpub_coach" };

private.use_cone_logic = function()
  ObjSet( "gfx_coach_clk_coach1_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_cone_inv = function()
  common_impl.ProcessMultiUseAll("cone", "cone")
end;
private.use_cone_beg = function()
  ObjDelete( "gfx_coach_cone_zone" );
end;
private.use_cone_end = function()
  if common_impl.ZzCompleteCheck("use_cone") then ObjSet( common_impl.hint["use_cone"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_coach_anm_coach_cone", {animfunc = "use_cone1", frame = 0 } );
  --  ObjSet( "spr_nearpub_tr_open", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cone", private.use_cone_inv );
cmn.AddSubscriber( "use_cone", private.use_cone_beg, private.room_objname );
cmn.AddSubscriber( "use_cone", private.use_cone_end, private.room_objname );
cmn.AddSubscriber( "use_cone", private.use_cone_logic );
cmn.AddSubscriber( "use_cone_inv", private.use_cone_inv, private.room_objname );
cmn.AddSubscriber( "use_cone_beg", private.use_cone_beg, private.room_objname );
cmn.AddSubscriber( "use_cone_end", private.use_cone_end, private.room_objname );
cmn.AddSubscriber( "use_cone_end", private.use_cone_logic );
--------------------------------------------------------------------------------------------
function public.use_cone( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cone" );
    cmn.CallEventHandler( "use_cone_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cone") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cone_inv" );
  cmn.CallEventHandler( "use_cone_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_coach_anm_coach_cone", "use_cone", func_end );
  SoundSfx( "aud_use_cones_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_coach1" ] = { type = "click", use_place = "gfx_coach_clk_coach1_zone", room = "rm_nearpub", zz = "zz_coach", zz_gate = "gzz_nearpub_coach" };

private.clk_coach1_logic = function()
  ObjSet( "gfx_coach_clk_coach2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_coach1_beg = function()
  ObjDelete( "gfx_coach_clk_coach1_zone" );
end;
private.clk_coach1_end = function()
  if common_impl.ZzCompleteCheck("clk_coach1") then ObjSet( common_impl.hint["clk_coach1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_coach_anm_coach_cone", {animfunc = "use_cone2", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_coach1", private.clk_coach1_beg, private.room_objname );
cmn.AddSubscriber( "clk_coach1", private.clk_coach1_end, private.room_objname );
cmn.AddSubscriber( "clk_coach1", private.clk_coach1_logic );
cmn.AddSubscriber( "clk_coach1_beg", private.clk_coach1_beg, private.room_objname );
cmn.AddSubscriber( "clk_coach1_end", private.clk_coach1_end, private.room_objname );
cmn.AddSubscriber( "clk_coach1_end", private.clk_coach1_logic );
--------------------------------------------------------------------------------------------
function public.clk_coach1()

  local func_end = function()
    cmn.SetEventDone( "clk_coach1" );
    cmn.CallEventHandler( "clk_coach1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_coach1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_coach1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_coach_anm_coach_cone", "use_cone1", func_end );
  SoundSfx( "aud_touch_clothes_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_coach2" ] = { type = "click", use_place = "gfx_coach_clk_coach2_zone", room = "rm_nearpub", zz = "zz_coach", zz_gate = "gzz_nearpub_coach" };

private.clk_coach2_logic = function()
  ObjSet( "gfx_coach_clk_coach3_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_coach2_beg = function()
  ObjDelete( "gfx_coach_clk_coach2_zone" );
end;
private.clk_coach2_end = function()
  if common_impl.ZzCompleteCheck("clk_coach2") then ObjSet( common_impl.hint["clk_coach2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_coach_anm_coach_cone", {animfunc = "use_cone3", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_coach2", private.clk_coach2_beg, private.room_objname );
cmn.AddSubscriber( "clk_coach2", private.clk_coach2_end, private.room_objname );
cmn.AddSubscriber( "clk_coach2", private.clk_coach2_logic );
cmn.AddSubscriber( "clk_coach2_beg", private.clk_coach2_beg, private.room_objname );
cmn.AddSubscriber( "clk_coach2_end", private.clk_coach2_end, private.room_objname );
cmn.AddSubscriber( "clk_coach2_end", private.clk_coach2_logic );
--------------------------------------------------------------------------------------------
function public.clk_coach2()

  local func_end = function()
    cmn.SetEventDone( "clk_coach2" );
    cmn.CallEventHandler( "clk_coach2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_coach2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_coach2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_coach_anm_coach_cone", "use_cone2", func_end );
  SoundSfx( "aud_touch_clothes_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_coach3" ] = { type = "click", use_place = "gfx_coach_clk_coach3_zone", room = "rm_nearpub", zz = "zz_coach", zz_gate = "gzz_nearpub_coach" };

private.clk_coach3_logic = function()
  ObjSet( "spr_coach_bluecrystal", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_coach_bluecrystal", {active = 1, visible = 1} );
end;
private.clk_coach3_beg = function()
  ObjDelete( "gfx_coach_clk_coach3_zone" );
end;
private.clk_coach3_end = function()
  if common_impl.ZzCompleteCheck("clk_coach3") then ObjSet( common_impl.hint["clk_coach3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_coach_anm_coach_cone", {animfunc = "use_cone3", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_coach3", private.clk_coach3_beg, private.room_objname );
cmn.AddSubscriber( "clk_coach3", private.clk_coach3_end, private.room_objname );
cmn.AddSubscriber( "clk_coach3", private.clk_coach3_logic );
cmn.AddSubscriber( "clk_coach3_beg", private.clk_coach3_beg, private.room_objname );
cmn.AddSubscriber( "clk_coach3_end", private.clk_coach3_end, private.room_objname );
cmn.AddSubscriber( "clk_coach3_end", private.clk_coach3_logic );
--------------------------------------------------------------------------------------------
function public.clk_coach3()

  local func_end = function()
    cmn.SetEventDone( "clk_coach3" );
    cmn.CallEventHandler( "clk_coach3_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_coach3") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_coach3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_coach_anm_coach_cone", "use_cone3", func_end );
  SoundSfx( "aud_touch_clothes_nearpub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bluecrystal" ] = { type = "get", get_obj = "spr_coach_bluecrystal", room = "rm_nearpub", zz = "zz_coach", zz_gate = "gzz_nearpub_coach" };

private.get_bluecrystal_logic = function()
  
end;
private.get_bluecrystal_inv = function()
  interface.InventoryItemAdd("inv_bluecrystal","spr_coach_bluecrystal");
end;
private.get_bluecrystal_beg = function()
  ObjDelete("gfx_coach_bluecrystal")
end;
private.get_bluecrystal_end = function()
  if common_impl.ZzCompleteCheck("get_bluecrystal") then ObjSet( common_impl.hint["get_bluecrystal"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_coach_anm_coach_cone", {animfunc = "end_cristal", frame = 0 } );
end;

cmn.AddSubscriber( "get_bluecrystal", private.get_bluecrystal_inv );
cmn.AddSubscriber( "get_bluecrystal", private.get_bluecrystal_beg, private.room_objname );
cmn.AddSubscriber( "get_bluecrystal", private.get_bluecrystal_end, private.room_objname );
cmn.AddSubscriber( "get_bluecrystal", private.get_bluecrystal_logic );
--------------------------------------------------------------------
function public.get_bluecrystal()
  ObjSet( "spr_coach_bluecrystal", {visible = 1} );
  cmn.SetEventDone( "get_bluecrystal" );
  cmn.CallEventHandler( "get_bluecrystal" );
  if common_impl.ZzCompleteCheck("get_bluecrystal") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_gatemg_for_nearpub = function()
    if ld.CheckRequirements( {"win_gatemg"} ) then
      ObjSet( "gmg_nearpub_gatemg", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_gatemg", win_gatemg_for_nearpub, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_nearpub();
  if cmn.IsEventDone("win_gatemg") and not cmn.IsEventDone("clk_gatemgfornearpub") then 
    public.clk_gatemgfornearpub();
  end;  
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_nearpub_env" );
 if cmn.IsEventDone("get_carretkey") and not cmn.IsEventDone("clk_raidfornearpub") then 
     public.clk_raidfornearpub();
 end;  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_coach" );
  function zz_coach.Open()
  end;
  function zz_coach.PreOpen()
  end;
  function zz_coach.PreClose()
  end;
  function zz_coach.Close()
  end;

  subroom.Define( "zz_gate" );
  function zz_gate.Open()
  end;
  function zz_gate.PreOpen()
  end;
  function zz_gate.PreClose()
  end;
  function zz_gate.Close()
  end;

  subroom.Define( "zz_doll" );
  function zz_doll.Open()
  end;
  function zz_doll.PreOpen()
  end;
  function zz_doll.PreClose()
  end;
  function zz_doll.Close()
  end;

  subroom.Define( "zz_pubdoor" );
  function zz_pubdoor.Open()
  end;
  function zz_pubdoor.PreOpen()
  end;
  function zz_pubdoor.PreClose()
  end;
  function zz_pubdoor.Close()
  end;
  
end;
--*********************************************************************************************************************