-- name=rm_pond
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_pond";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_pond()
  if not ( cmn.IsEventDone( "opn_pond" ) ) then
    --   cmn.SetEventDone( "opn_pond" );
    -- cmn.CallEventHandler( "opn_pond" )
    public.clk_escape();
  end;
end;
--------------------------------------------------------------------
local opn_pond = function() end;
local opn_pond_logic = function() end;
cmn.AddSubscriber( "opn_pond", opn_pond_logic )
cmn.AddSubscriber( "opn_pond", opn_pond, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_escape" ] = { type = "click", use_place = "gfx_pond_clk_escape_zone", room = "rm_pond" };

private.clk_escape_logic = function()
  ObjSet( "gzz_pond_water", { visible = 1, input = 1 } )
  ObjSet( "gzz_pond_flowers", { visible = 1, input = 1 } )
  ObjSet( "gzz_pond_bridge", {input = 1, visible = 1} );
end;
private.clk_escape_beg = function()
  ObjDelete( "gfx_pond_clk_escape_zone" );
end;
private.clk_escape_end = function()
  ObjDelete("vid_pond_vid_bridge_destruction_198");
  ObjSet( "spr_pond_tr_broukenbridg", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_escape", private.clk_escape_beg, private.room_objname );
cmn.AddSubscriber( "clk_escape", private.clk_escape_end, private.room_objname );
cmn.AddSubscriber( "clk_escape", private.clk_escape_logic );
cmn.AddSubscriber( "clk_escape_beg", private.clk_escape_beg, private.room_objname );
cmn.AddSubscriber( "clk_escape_end", private.clk_escape_end, private.room_objname );
cmn.AddSubscriber( "clk_escape_end", private.clk_escape_logic );
--------------------------------------------------------------------------------------------
function public.clk_escape()

  local func_end = function()
    SoundTheme( "aud_danger2_mus" );
    cmn.SetEventDone( "opn_pond" );
    cmn.CallEventHandler( "opn_pond" )
    cmn.SetEventDone( "clk_escape" );
    cmn.CallEventHandler( "clk_escape_end" );
    --    common_impl.Lock(1);
    ld.ShowBbt("after_pond_escape")
    --  SoundVoice("aud_pc_7_voc");
    common_impl.Lock(0);
    --  ld.StartTimer( 3, function() common_impl.Lock(0); end )
  end;

  cmn.CallEventHandler( "clk_escape_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()
   ld.StartTimer( 0.5, function() SoundSfx( "aud_bridge_destruction_198" ); VidPlay("vid_pond_vid_bridge_destruction_198",func_end)   end )
   ld.StartTimer(2,  function()  ObjSet( "spr_pond_tr_broukenbridg", {visible = 1} ); end)
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_water *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_glassshard2" ] = { type = "get", get_obj = "spr_water_glassshard2", room = "rm_pond", zz = "zz_water", zz_gate = "gzz_pond_water" };

private.get_glassshard2_logic = function()
  
end;
private.get_glassshard2_inv = function()
  interface.InventoryItemAdd("inv_glassshard","spr_water_glassshard2",function() level_inv.ProcessGetGlassshardAll( "get_glassshard2" ) end);
end;
private.get_glassshard2_beg = function()
  ObjDelete("gfx_water_glassshard2")
end;
private.get_glassshard2_end = function()
  if common_impl.ZzCompleteCheck("get_glassshard2") then ObjSet( common_impl.hint["get_glassshard2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_water_sh_glassshard2");
  ObjDelete("spr_pond_tr_glassshard2");
end;

cmn.AddSubscriber( "get_glassshard2", private.get_glassshard2_inv );
cmn.AddSubscriber( "get_glassshard2", private.get_glassshard2_beg, private.room_objname );
cmn.AddSubscriber( "get_glassshard2", private.get_glassshard2_end, private.room_objname );
cmn.AddSubscriber( "get_glassshard2", private.get_glassshard2_logic );
--------------------------------------------------------------------
function public.get_glassshard2()
  cmn.SetEventDone( "get_glassshard2" );
  cmn.CallEventHandler( "get_glassshard2" );
  if common_impl.ZzCompleteCheck("get_glassshard2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wateringcan" ] = { type = "use", inv_obj = "inv_wateringcan", use_place = "gfx_water_wateringcan_zone", room = "rm_pond", zz = "zz_water", zz_gate = "gzz_pond_water" };

private.use_wateringcan_logic = function()
  ObjSet( "spr_water_fullwateringcan", { visible = 1, input = 1 } )
  ObjSet( "gfx_water_net_zone", {input = 1, visible = 1} );
end;
private.use_wateringcan_inv = function()
  common_impl.ProcessMultiUseAll("wateringcan", "wateringcan")
end;
private.use_wateringcan_beg = function()
  ObjDelete( "gfx_water_wateringcan_zone" );
end;
private.use_wateringcan_end = function()
  if common_impl.ZzCompleteCheck("use_wateringcan") then ObjSet( common_impl.hint["use_wateringcan"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_water_anm", {animfunc = "use_networks", frame = 0 } );
  ObjSet( "spr_pond_tr_shellfish", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wateringcan", private.use_wateringcan_inv );
cmn.AddSubscriber( "use_wateringcan", private.use_wateringcan_beg, private.room_objname );
cmn.AddSubscriber( "use_wateringcan", private.use_wateringcan_end, private.room_objname );
cmn.AddSubscriber( "use_wateringcan", private.use_wateringcan_logic );
cmn.AddSubscriber( "use_wateringcan_inv", private.use_wateringcan_inv, private.room_objname );
cmn.AddSubscriber( "use_wateringcan_beg", private.use_wateringcan_beg, private.room_objname );
cmn.AddSubscriber( "use_wateringcan_end", private.use_wateringcan_end, private.room_objname );
cmn.AddSubscriber( "use_wateringcan_end", private.use_wateringcan_logic );
--------------------------------------------------------------------------------------------
function public.use_wateringcan( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wateringcan" );
    cmn.CallEventHandler( "use_wateringcan_end" );
    ObjSet( "spr_water_fullwateringcan", { visible = 1} );
    cmn.SetEventDone( "get_fullwateringcan" );
    cmn.CallEventHandler( "get_fullwateringcan" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wateringcan") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wateringcan_inv" );
  cmn.CallEventHandler( "use_wateringcan_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_water_anm", "use_wateringcan", func_end );
  SoundSfx( "aud_use_watering_can_water" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fullwateringcan" ] = { type = "get", get_obj = "spr_water_fullwateringcan", room = "rm_pond", zz = "zz_water", zz_gate = "gzz_pond_water" };

private.get_fullwateringcan_logic = function()
  
end;
private.get_fullwateringcan_inv = function()
  interface.InventoryItemAdd("inv_fullwateringcan","spr_water_fullwateringcan");
end;
private.get_fullwateringcan_beg = function()
  ObjDelete("gfx_water_fullwateringcan")
end;
private.get_fullwateringcan_end = function()
  if common_impl.ZzCompleteCheck("get_fullwateringcan") then ObjSet( common_impl.hint["get_fullwateringcan"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_fullwateringcan", private.get_fullwateringcan_inv );
cmn.AddSubscriber( "get_fullwateringcan", private.get_fullwateringcan_beg, private.room_objname );
cmn.AddSubscriber( "get_fullwateringcan", private.get_fullwateringcan_end, private.room_objname );
cmn.AddSubscriber( "get_fullwateringcan", private.get_fullwateringcan_logic );
--------------------------------------------------------------------
function public.get_fullwateringcan()
  cmn.SetEventDone( "get_fullwateringcan" );
  cmn.CallEventHandler( "get_fullwateringcan" );
  if common_impl.ZzCompleteCheck("get_fullwateringcan") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_net_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_net' )
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_shell_water" );
  ld.AnimPlay( "anm_water_anm", "idle_shellfish", func_end )
end;  



common_impl.hint[ "use_net" ] = { type = "use", inv_obj = "inv_net", use_place = "gfx_water_net_zone", room = "rm_pond", zz = "zz_water", zz_gate = "gzz_pond_water" };

private.use_net_logic = function()
  ObjSet( "spr_water_shellfish", { visible = 1, input = 1 } )

end;
private.use_net_inv = function()
  common_impl.ProcessMultiUseAll("net", "net")
end;
private.use_net_beg = function()
  ObjDelete( "gfx_water_net_zone" );
end;
private.use_net_end = function()
  if common_impl.ZzCompleteCheck("use_net") then ObjSet( common_impl.hint["use_net"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_water_anm", {animfunc = "use_networks1", frame = 0 } );
  ObjSet( "spr_water_sh_shellfish", {visible=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_net", private.use_net_inv );
cmn.AddSubscriber( "use_net", private.use_net_beg, private.room_objname );
cmn.AddSubscriber( "use_net", private.use_net_end, private.room_objname );
cmn.AddSubscriber( "use_net", private.use_net_logic );
cmn.AddSubscriber( "use_net_inv", private.use_net_inv, private.room_objname );
cmn.AddSubscriber( "use_net_beg", private.use_net_beg, private.room_objname );
cmn.AddSubscriber( "use_net_end", private.use_net_end, private.room_objname );
cmn.AddSubscriber( "use_net_end", private.use_net_logic );
--------------------------------------------------------------------------------------------
function public.use_net( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_net" );
    cmn.CallEventHandler( "use_net_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_net") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_net_inv" );
  cmn.CallEventHandler( "use_net_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_water_anm", "use_networks", func_end );
  SoundSfx( "aud_use_net_water" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_shellfish" ] = { type = "get", get_obj = "spr_water_shellfish", room = "rm_pond", zz = "zz_water", zz_gate = "gzz_pond_water" };

private.get_shellfish_logic = function()
  
end;
private.get_shellfish_inv = function()
  interface.InventoryItemAdd("inv_shellfish","spr_water_shellfish");
  ObjSet( "inv_shellfish", { drag = 0 } );
end;
private.get_shellfish_beg = function()
  ObjDelete("gfx_water_shellfish");
  ObjDelete("spr_water_sh_shellfish");
end;
private.get_shellfish_end = function()
  if common_impl.ZzCompleteCheck("get_shellfish") then ObjSet( common_impl.hint["get_shellfish"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_water_anm");
  ObjDelete("spr_pond_tr_shellfish");
end;



cmn.AddSubscriber( "get_shellfish_inv", private.get_shellfish_inv );
cmn.AddSubscriber( "get_shellfish_beg", private.get_shellfish_beg, private.room_objname );
cmn.AddSubscriber( "get_shellfish_end", private.get_shellfish_end, private.room_objname );
cmn.AddSubscriber( "get_shellfish_end", private.get_shellfish_logic );
cmn.AddSubscriber( "get_shellfish", private.get_shellfish_inv );
cmn.AddSubscriber( "get_shellfish", private.get_shellfish_beg, private.room_objname );
cmn.AddSubscriber( "get_shellfish", private.get_shellfish_end, private.room_objname );
cmn.AddSubscriber( "get_shellfish", private.get_shellfish_logic );
--------------------------------------------------------------------
function public.get_shellfish()
  local func_end = function()
      ld.Lock(0);
      cmn.SetEventDone( "get_shellfish" );
      cmn.CallEventHandler( "get_shellfish_end" );
      if common_impl.ZzCompleteCheck("get_shellfish") then ld.CloseSubRoom() end;
  end;
    
  ld.Lock(1);
  cmn.CallEventHandler( "get_shellfish_inv" );
  cmn.CallEventHandler( "get_shellfish_beg" );  
  
  SoundSfx( "aud_get_net_water" )
  ld.AnimPlay( "anm_water_anm", "use_networks1", func_end )
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_flowers *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_fullwateringcan_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_fullwateringcan' )
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_flowers_water" );
  ld.AnimPlay("anm_flowers_anm","idle_dryleaves", func_end);
end;  




common_impl.hint[ "use_fullwateringcan" ] = { type = "use", inv_obj = "inv_fullwateringcan", use_place = "gfx_flowers_fullwateringcan_zone", room = "rm_pond", zz = "zz_flowers", zz_gate = "gzz_pond_flowers" };

private.use_fullwateringcan_logic = function()
  ObjSet( "spr_flowers_amuletfeather2", { visible = 1, input = 1 } )

end;
private.use_fullwateringcan_inv = function()
  common_impl.ProcessMultiUseAll("fullwateringcan", "fullwateringcan")
end;
private.use_fullwateringcan_beg = function()
  ObjDelete( "gfx_flowers_fullwateringcan_zone" );
end;
private.use_fullwateringcan_end = function()
  if common_impl.ZzCompleteCheck("use_fullwateringcan") then ObjSet( common_impl.hint["use_fullwateringcan"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_flowers_anm", {animfunc = "end_wateringcan", frame = 0 } );
  ObjSet( "spr_flowers_amulet_feather2sh", {visible = 1} );
  ObjSet( "spr_pond_tr_flowers", {visible = 1} );
  ObjSet( "spr_pond_tr_amuletfeather2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fullwateringcan", private.use_fullwateringcan_inv );
cmn.AddSubscriber( "use_fullwateringcan", private.use_fullwateringcan_beg, private.room_objname );
cmn.AddSubscriber( "use_fullwateringcan", private.use_fullwateringcan_end, private.room_objname );
cmn.AddSubscriber( "use_fullwateringcan", private.use_fullwateringcan_logic );
cmn.AddSubscriber( "use_fullwateringcan_inv", private.use_fullwateringcan_inv, private.room_objname );
cmn.AddSubscriber( "use_fullwateringcan_beg", private.use_fullwateringcan_beg, private.room_objname );
cmn.AddSubscriber( "use_fullwateringcan_end", private.use_fullwateringcan_end, private.room_objname );
cmn.AddSubscriber( "use_fullwateringcan_end", private.use_fullwateringcan_logic );
--------------------------------------------------------------------------------------------
function public.use_fullwateringcan( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fullwateringcan" );
    cmn.CallEventHandler( "use_fullwateringcan_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_fullwateringcan") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fullwateringcan_inv" );
  cmn.CallEventHandler( "use_fullwateringcan_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_flowers_anm", "use_wateringcan", func_end );
  SoundSfx( "aud_use_watering_can_floser" );
  --func_end()
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletfeather2" ] = { type = "get", get_obj = "spr_flowers_amuletfeather2", room = "rm_pond", zz = "zz_flowers", zz_gate = "gzz_pond_flowers" };

private.get_amuletfeather2_logic = function()
  
end;
private.get_amuletfeather2_inv = function()
  interface.InventoryItemAdd("inv_amuletfeather2","spr_flowers_amuletfeather2");
end;
private.get_amuletfeather2_beg = function()
  ObjDelete("gfx_flowers_amuletfeather2")
end;
private.get_amuletfeather2_end = function()
  if common_impl.ZzCompleteCheck("get_amuletfeather2") then ObjSet( common_impl.hint["get_amuletfeather2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_flowers_amulet_feather2sh");
  ObjDelete("spr_pond_tr_amuletfeather2");
end;

cmn.AddSubscriber( "get_amuletfeather2", private.get_amuletfeather2_inv );
cmn.AddSubscriber( "get_amuletfeather2", private.get_amuletfeather2_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletfeather2", private.get_amuletfeather2_end, private.room_objname );
cmn.AddSubscriber( "get_amuletfeather2", private.get_amuletfeather2_logic );
--------------------------------------------------------------------
function public.get_amuletfeather2()
  cmn.SetEventDone( "get_amuletfeather2" );
  cmn.CallEventHandler( "get_amuletfeather2" );
  if common_impl.ZzCompleteCheck("get_amuletfeather2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_rosary_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_rosary' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_figure_water" );
  ld.AnimPlay( "anm_flowers_anm_gnom", "idl_gnom", func_end ) 
end;
  

common_impl.hint[ "use_rosary" ] = { type = "use", inv_obj = "inv_rosary", use_place = "gfx_flowers_rosary_zone", room = "rm_pond", zz = "zz_flowers", zz_gate = "gzz_pond_flowers" };

private.use_rosary_logic = function()
--  ObjSet( "gfx_flowers_clk_plate_zone", { visible = 1, input = 1 } )

end;
private.use_rosary_inv = function()
  common_impl.ProcessMultiUseAll("rosary", "rosary")
end;
private.use_rosary_beg = function()
  ObjDelete( "gfx_flowers_rosary_zone" );
end;
private.use_rosary_end = function()
  if common_impl.ZzCompleteCheck("use_rosary") then ObjSet( common_impl.hint["use_rosary"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_flowers_anm_gnom", {animfunc = "end_cap", frame = 0 } );
  ObjSet( "spr_pond_tr_cap", {visible=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rosary", private.use_rosary_inv );
cmn.AddSubscriber( "use_rosary", private.use_rosary_beg, private.room_objname );
cmn.AddSubscriber( "use_rosary", private.use_rosary_end, private.room_objname );
cmn.AddSubscriber( "use_rosary", private.use_rosary_logic );
cmn.AddSubscriber( "use_rosary_inv", private.use_rosary_inv, private.room_objname );
cmn.AddSubscriber( "use_rosary_beg", private.use_rosary_beg, private.room_objname );
cmn.AddSubscriber( "use_rosary_end", private.use_rosary_end, private.room_objname );
cmn.AddSubscriber( "use_rosary_end", private.use_rosary_logic );
--------------------------------------------------------------------------------------------
function public.use_rosary( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_rosary" );
    cmn.CallEventHandler( "use_rosary_end" );
    ObjSet( "spr_flowers_haft", {visible = 1} );
    cmn.SetEventDone( "get_haft" );
    cmn.CallEventHandler( "get_haft" );
    if port.isPortable()==1 then
      iOS_RateMe();
    end;
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rosary") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rosary_inv" );
  cmn.CallEventHandler( "use_rosary_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_flowers_anm_gnom", "use_cap",function() ld.StartTimer( 0.7, func_end ) end);
  SoundSfx( "aud_use_cap_water" );
  -- func_end()

end;
--------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_plate" ] = { type = "click", use_place = "gfx_flowers_clk_plate_zone", room = "rm_pond", zz = "zz_flowers", zz_gate = "gzz_pond_flowers" };
--
--private.clk_plate_logic = function()
--  ObjSet( "spr_flowers_haft", { visible = 0, input = 1 } )
--  ObjSet( "gfx_flowers_haft", {visible = 1} );
--end;
--private.clk_plate_beg = function()
--  ObjDelete( "gfx_flowers_clk_plate_zone" );
--end;
--private.clk_plate_end = function()
--  if common_impl.ZzCompleteCheck("clk_plate") then ObjSet( common_impl.hint["clk_plate"].zz_gate, { visible = 0, input = 0 } ); end;
--  ObjSet( "anm_flowers_anm_gnom", {animfunc = "click_board", frame = 999 } );
--  ObjDelete("spr_pond_tr_board_1");
--  ObjSet( "spr_pond_tr_board", {visible = 1} );
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_plate", private.clk_plate_beg, private.room_objname );
--cmn.AddSubscriber( "clk_plate", private.clk_plate_end, private.room_objname );
--cmn.AddSubscriber( "clk_plate", private.clk_plate_logic );
--cmn.AddSubscriber( "clk_plate_beg", private.clk_plate_beg, private.room_objname );
--cmn.AddSubscriber( "clk_plate_end", private.clk_plate_end, private.room_objname );
--cmn.AddSubscriber( "clk_plate_end", private.clk_plate_logic );
----------------------------------------------------------------------------------------------
--function public.clk_plate()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_plate" );
--    cmn.CallEventHandler( "clk_plate_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("clk_plate") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "clk_plate_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_flowers_anm_gnom", "click_board", func_end );
--  --SoundSfx( 0 )
--  --func_end()
--
--end;
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------
common_impl.hint[ "get_haft" ] = { type = "get", get_obj = "spr_flowers_haft", room = "rm_pond", zz = "zz_flowers", zz_gate = "gzz_pond_flowers" };

private.get_haft_logic = function()
  
end;
private.get_haft_inv = function()
  interface.InventoryItemAdd("inv_haft","spr_flowers_haft");
end;
private.get_haft_beg = function()
  ObjDelete("gfx_flowers_haft")
end;
private.get_haft_end = function()
  if common_impl.ZzCompleteCheck("get_haft") then ObjSet( common_impl.hint["get_haft"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjSet( "anm_flowers_anm_gnom", {animfunc = "end_beads", frame = 0 } );
   ObjDelete("spr_pond_tr_stick");
end;

cmn.AddSubscriber( "get_haft", private.get_haft_inv );
cmn.AddSubscriber( "get_haft", private.get_haft_beg, private.room_objname );
cmn.AddSubscriber( "get_haft", private.get_haft_end, private.room_objname );
cmn.AddSubscriber( "get_haft", private.get_haft_logic );
--------------------------------------------------------------------
function public.get_haft()
  ObjSet( "spr_flowers_haft", {visible = 1} );
  cmn.SetEventDone( "get_haft" );
  cmn.CallEventHandler( "get_haft" );
  if port.isPortable()==1 then
    iOS_RateMe();
  end;
  if common_impl.ZzCompleteCheck("get_haft") then ld.CloseSubRoom() end;
end
----------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bridge *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_tube4" ] = { type = "get", get_obj = "spr_bridge_tube4", room = "rm_pond", zz = "zz_bridge", zz_gate = "gzz_pond_bridge" };

private.get_tube4_logic = function()
  
end;
private.get_tube4_inv = function()
  interface.InventoryItemAdd("inv_tube","spr_bridge_tube4",function() level_inv.ProcessGetTubeAll( "get_tube4" ) end);
end;
private.get_tube4_beg = function()
  ObjDelete("gfx_bridge_tube4")
end;
private.get_tube4_end = function()
  if common_impl.ZzCompleteCheck("get_tube4") then ObjSet( common_impl.hint["get_tube4"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_bridge_sh_tube4");
end;

cmn.AddSubscriber( "get_tube4", private.get_tube4_inv );
cmn.AddSubscriber( "get_tube4", private.get_tube4_beg, private.room_objname );
cmn.AddSubscriber( "get_tube4", private.get_tube4_end, private.room_objname );
cmn.AddSubscriber( "get_tube4", private.get_tube4_logic );
--------------------------------------------------------------------
function public.get_tube4()
  cmn.SetEventDone( "get_tube4" );
  cmn.CallEventHandler( "get_tube4" );
  if common_impl.ZzCompleteCheck("get_tube4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_boards" ] = { type = "use", inv_obj = "inv_boards", use_place = "gfx_bridge_boards_zone", room = "rm_pond", zz = "zz_bridge", zz_gate = "gzz_pond_bridge" };

private.use_boards_logic = function()
  ObjSet( "obj_bridge_boards_root", { active=1, visible = 1, input = 1 } )

end;
private.use_boards_inv = function()
  common_impl.ProcessMultiUseAll("boards", "boards")
end;
private.use_boards_beg = function()
  ObjDelete( "gfx_bridge_boards_zone" );
end;
private.use_boards_end = function()
  if common_impl.ZzCompleteCheck("use_boards") then ObjSet( common_impl.hint["use_boards"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_bridge_anm",{animfunc="use_d", frame=0});
  ObjSet( "obj_bridge_idle_2_zone", {pos_z=0} );
  ObjSet( "obj_bridge_idle_1_zone", {pos_z=0} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_boards", private.use_boards_inv );
cmn.AddSubscriber( "use_boards", private.use_boards_beg, private.room_objname );
cmn.AddSubscriber( "use_boards", private.use_boards_end, private.room_objname );
cmn.AddSubscriber( "use_boards", private.use_boards_logic );
cmn.AddSubscriber( "use_boards_inv", private.use_boards_inv, private.room_objname );
cmn.AddSubscriber( "use_boards_beg", private.use_boards_beg, private.room_objname );
cmn.AddSubscriber( "use_boards_end", private.use_boards_end, private.room_objname );
cmn.AddSubscriber( "use_boards_end", private.use_boards_logic );
--------------------------------------------------------------------------------------------
function public.use_boards( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_boards" );
    cmn.CallEventHandler( "use_boards_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_boards") then ld.CloseSubRoom() end;
    public.init_win_boards(first_start);
    cmn.MiniGameShow( "boards" );
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_boards_inv" );
  cmn.CallEventHandler( "use_boards_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bridge_anm", "use_d", func_end );
  SoundSfx( "aud_use_logs_bridge" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
local pond_bridge_boards_trash_coord1={{200,354},{186,358},{169,365},{153,372},{136,377}};

common_impl.hint[ "win_boards" ] = { type = "click", use_place = "obj_bridge_boards_root", room = "rm_pond", zz = "zz_bridge", zz_gate = "gzz_pond_bridge" };

private.win_boards_logic = function()
  if cmn.IsEventDone("win_boards") then
    ObjSet( "grm_pond_neartower", { visible = 1, input = 1 } );
    ObjSet( "gzz_pond_chapeldoor", { visible = 1, input = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_pond_neartower_focus");
    end;
  end;
end;
private.win_boards_beg = function()
  --ObjDelete( "gfx_bridge_win_boards_zone" );
end;
private.win_boards_end = function()
  if cmn.IsEventDone("win_boards") then
    if common_impl.ZzCompleteCheck("win_boards") then ObjSet( common_impl.hint["win_boards"].zz_gate, { visible = 0, input = 0 } ); end;
    --ObjDelete( "spr_pond_tr_broukenbridg");
    for i=1,5,1 do 
       ObjSet( "spr_pond_dr_"..i, {visible = 1, pos_x=pond_bridge_boards_trash_coord1[i][1], pos_y=pond_bridge_boards_trash_coord1[i][2]} );
    end;  
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_boards", private.win_boards_beg, private.room_objname );
cmn.AddSubscriber( "win_boards", private.win_boards_end, private.room_objname );
cmn.AddSubscriber( "win_boards", private.win_boards_logic );
cmn.AddSubscriber( "win_boards_beg", private.win_boards_beg, private.room_objname );
cmn.AddSubscriber( "win_boards_end", private.win_boards_end, private.room_objname );
cmn.AddSubscriber( "win_boards_end", private.win_boards_logic );
--------------------------------------------------------------------------------------------
function public.win_boards()

  local func_end = function()
    cmn.SetEventDone( "win_boards" );
    cmn.CallEventHandler( "win_boards_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_boards") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_boards_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;

---------------------------------------------------------------------------------------------
function public.init_win_boards(first_start)
  ObjAttach("anm_bridge_anm","obj_bridge_boards_root")
   if not (cmn.IsEventStart("win_boards")) or first_start==1 then
     private.win_boards_on_first_pos();
   else 
     if ld.CheckRequirements( {"use_boards"} ) then
        private.win_boards_stand_on_pos()
     end
   end  
      --!!!!!!!!!!!!!!!!!!!!
      --private.win_lasso_part_move_start()
      --!!!!!!!!!!!!!!!!!!!!!!
end
--------------------------------------------------------------------------------------------------------------------

local bridge_boards_fp_array={};
local bridge_positions_coord_array={{182,-51},{109,-28},{27,-2},{-43,30},{-147,55}}    
    
function private.win_boards_get_first_pos()
  local obj="";
  for i=1,5,1 do 
    obj = ObjGet("spr_bridge_d"..i);
    bridge_boards_fp_array[i]={obj.pos_x, obj.pos_y, obj.pos_z};
    ObjSet( "spr_bridge_d"..i, {input=0, drag=0, event_startdrag="rm_pond.win_boards_start_drag("..i..")", event_dragdrop="rm_pond.win_boards_stop_drag("..i..")", event_menter="ld.SetCursor(CURSOR_GET)", event_mleave="ld.SetCursor(CURSOR_DEFAULT)"} );
    
    ObjCreate("obj_bridge_boards_pos_"..i,"obj"); --places on bridge
    ObjAttach("obj_bridge_boards_pos_"..i,"obj_bridge_boards_root")
    ObjSet( "obj_bridge_boards_pos_"..i, {input=0, pos_x=bridge_positions_coord_array[i][1], pos_y=bridge_positions_coord_array[i][2], inputrect_init=1, inputrect_w=50, inputrect_h=50, inputrect_x=-25, inputrect_y=-25} );
    
    ObjCreate("obj_bridge_on_boards_pos_"..i,"obj"); --places on boards
    ObjAttach("obj_bridge_on_boards_pos_"..i,"spr_bridge_d"..i)
    ObjSet( "obj_bridge_on_boards_pos_"..i, {input=0, inputrect_init=1, inputrect_w=20, inputrect_h=20, inputrect_x=-10, inputrect_y=-10} );
    
  end;  
end;  

private.win_boards_pos_sound_array={0,0,0,0,0};
private.win_boards_pos_sound_array_loaded=0;
 
function private.win_boards_on_first_pos()
  private.win_boards_pos_sound_array_loaded=0;
  private.win_boards_pos_sound_array={0,0,0,0,0};
  ng_global.progress[ "std" ][ "win_boards" ].state={0,0,0,0,0}
  for i=1,5,1 do
    ObjSet( "spr_bridge_light_d"..i, {alp=0, color_r=0, color_g=0, color_b=0} );
    ObjSet( "spr_bridge_d"..i, {pos_x=bridge_boards_fp_array[i][1], pos_y=bridge_boards_fp_array[i][2], pos_z=bridge_boards_fp_array[i][3], input=0} );
  end;  
  private.win_boards_stand_on_pos()
end;  

function private.win_boards_search_on_state(num)
  for i=1,5,1 do 
    if ng_global.progress[ "std" ][ "win_boards" ].state[i]==num then return i; end;
  end;
  return 0;  
end;  

function private.win_boards_search_empty_pos()
  local count=0;
  for i=1,5,1 do
    if ng_global.progress[ "std" ][ "win_boards" ].state[i]==0 then count=count+1; end;
  end;  
  return count;
end;  

function private.win_boards_stand_on_pos()
  for i=1,5,1 do 
    local pos=private.win_boards_search_on_state(i)
    if pos~=0 then 
      ObjSet( "spr_bridge_d"..i, {pos_x=bridge_positions_coord_array[pos][1],pos_y=bridge_positions_coord_array[pos][2], pos_z=i-6, input=1, drag=1} );
      if pos==i then ObjSet( "spr_bridge_light_d"..i, {alp=1, color_r=0, color_g=1, color_b=0} ); else ObjSet( "spr_bridge_light_d"..i, {alp=1, color_r=1, color_g=0, color_b=0} ); end;
      if private.win_boards_pos_sound_array_loaded==1 and pos==i and private.win_boards_pos_sound_array[i]==0 then 
          SoundSfx( "aud_mg_bridge_true" )
      end;
       if pos==i then 
         private.win_boards_pos_sound_array[i]=1;
       else 
         private.win_boards_pos_sound_array[i]=0;
       end;  
 
      if pos==5 and i~=5 then ObjSet( "anm_bridge_anm", {pos_z=-10} ); ObjSet( "spr_bridge_light_d5_2", {alp=0} ); elseif pos==5 and i==5 then ObjSet( "anm_bridge_anm", {pos_z=5} ); ObjSet( "spr_bridge_light_d5_2", {alp=1} ); end;
    else 
      ObjSet( "spr_bridge_d"..i, {pos_x=bridge_boards_fp_array[i][1],pos_y=bridge_boards_fp_array[i][2], pos_z=bridge_boards_fp_array[i][3], input=0, drag=0} );
      ObjSet( "spr_bridge_light_d"..i, {alp=0, color_r=0, color_g=0, color_b=0} );
    end;  
  end;  
  ObjSet( "spr_bridge_d5", {input=1, drag=1} );
  for i=1,4,1 do 
    if private.win_boards_search_on_state(i+1)~=0 then ObjSet( "spr_bridge_d"..i, {input=1, drag=1} ); end;
  end; 
  private.pond_bridge_dr_stand_on_pos() 
  private.win_boards_win_ver();
  
  private.win_boards_pos_sound_array_loaded=1;
end;  

function public.win_boards_start_drag(num)
  SoundSfx( "aud_mg_bridge_get" );
  
  if num==5 then ObjSet( "spr_bridge_light_d5_2", {alp=0} ); end;
  ld.SetCursor( CURSOR_DEFAULT );
  ObjSet( "spr_bridge_light_d"..num, {alp=1, color_r=0, color_g=0, color_b=1} );
  ObjSet( "spr_bridge_d"..num,{pos_z=15});
  if private.win_boards_search_on_state(num)~=0 then 
      ng_global.progress[ "std" ][ "win_boards" ].state[ private.win_boards_search_on_state(num)]=0;
  end;  
end;      

function public.win_boards_stop_drag(num)
  SoundSfx( "aud_mg_bridge_release" );
  for i=1,5,1 do 
    local buf = private.win_boards_search_empty_pos();
    if ApplyObj("obj_bridge_on_boards_pos_"..num,"obj_bridge_boards_pos_"..i) then -- and (i~=5 or (i==5 and buf==1 )) then
       ObjSet( "spr_bridge_d"..num, {pos_x=bridge_positions_coord_array[i][1],pos_x=bridge_positions_coord_array[i][2], pos_z=0} );
       ng_global.progress[ "std" ][ "win_boards" ].state[i]=num;
     else
       ObjSet( "spr_bridge_d"..num, {pos_z=bridge_boards_fp_array[num][3]} );
     end;
  end;  
  private.win_boards_stand_on_pos() 
end;  


function private.win_boards_win_ver()
  local count=0;
  for i=1,5,1 do 
    if ng_global.progress[ "std" ][ "win_boards" ].state[i]==i then count=count+1; end;
  end;  
  if count==5 then private.WinAnim_win_boards(); end;
end;  


function private.win_boards_skip_anim()
  local func_end=function()
    private.WinAnim_win_boards()
  end;
  
  local func_prepreend = function()
     ObjSet( "anm_bridge_anm", {pos_z=5} );
     for i=1,5,1 do 
        ObjSet( "spr_bridge_light_d"..i, {color_r=0, color_g=1, color_b=0} );
        ObjAnimate( "spr_bridge_light_d"..i, 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );
     end;  
     ObjAnimate( "spr_bridge_light_d5_2", 8, 0, 0, function() end, {0,0,0, 0.3,0,1} ); 
      ld.StartTimer( 0.3, func_end )
  end;


  local func_preend = function()
     for i=1,5,1 do 
       obj = ObjGet("spr_bridge_d"..i);
       if obj.pos_x==bridge_positions_coord_array[i][1] then ObjSet( "spr_bridge_d"..i, {pos_z=i-6} ); else ObjSet( "spr_bridge_d"..i, {pos_z=i-1} ); end;
       ObjAnimate( "spr_bridge_d"..i, 3, 0, 0, function() ObjSet( "spr_bridge_d"..i, {pos_z=i-6} ); end, {0,0,obj.pos_x,obj.pos_y, 0.5,0,bridge_positions_coord_array[i][1],bridge_positions_coord_array[i][2]} );
     end;  
     SoundSfx( "aud_mg_bridge_release" )
     ld.StartTimer( 0.7, func_prepreend )
  end;


  ld.Lock(1);
   ObjSet( "anm_bridge_anm", {pos_z=-10} );
  for i=1,5,1 do 
    ObjAnimate( "spr_bridge_light_d"..i, 8, 0, 0, function() end, {0,0,ObjGet("spr_bridge_light_d"..i).alp, 0.3,0,0} );
  end; 
  ObjAnimate( "spr_bridge_light_d5_2", 8, 0, 0, function() end, {0,0,ObjGet("spr_bridge_light_d5_2").alp, 0.3,0,0} ); 
  ld.StartTimer( 0.3, func_preend )
end;  

function private.win_boards_reset_anim()
  local func_end = function()
     private.win_boards_on_first_pos();
     for i=1,5,1 do 
       ObjAnimate( "spr_bridge_d"..i, 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );
     end;  
     ld.StartTimer( 0.3,function() ld.Lock(0) end)
  end;
  
  local func_preend = function()
     for i=1,5,1 do 
       ObjAnimate( "spr_bridge_d"..i, 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
     end;  
     ld.StartTimer( 0.3, func_end )
  end;
  
  ld.Lock(1);
  for i=1,5,1 do 
    ObjAnimate( "spr_bridge_light_d"..i, 8, 0, 0, function() end, {0,0,ObjGet("spr_bridge_light_d"..i).alp, 0.3,0,0} );
  end; 
  ObjAnimate( "spr_bridge_light_d5_2", 8, 0, 0, function() end, {0,0,ObjGet("spr_bridge_light_d5_2").alp, 0.3,0,0} ); 
  ld.StartTimer( 0.3, func_preend )
end;  

--*********************************************************************************************************************
function private.WinAnim_win_boards()

      local func_end = function ()
      private.Win_win_boards();
      end;

      common_impl.Lock(1);
      --func_end();      
      cmn.MiniGameHide("boards", true); 
      for i=1,5,1 do 
        ObjAnimate( "spr_bridge_light_d"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
      end;  
      ObjAnimate( "spr_bridge_light_d5_2", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
      ld.StartTimer( 0.5, func_end );
   end;

    function private.Win_win_boards()
      local func_end=function()
        common_impl.Lock(0);
        cmn.SetEventDone("win_boards");
        cmn.CallEventHandler( "win_boards_end" );
        if common_impl.ZzCompleteCheck("win_boards") then ld.CloseSubRoom() end;  
      end;

     ld.StartTimer( 0.5, func_end )
    end;
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_chapeldoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lasso" ] = { type = "use", inv_obj = "inv_lasso", use_place = "gfx_chapeldoor_lasso_zone", room = "rm_pond", zz = "zz_chapeldoor", zz_gate = "gzz_pond_chapeldoor" };

private.use_lasso_logic = function()
  ObjSet( "gfx_chapeldoor_win_lasso_zone", { visible = 1, input = 1 } )

end;
private.use_lasso_inv = function()
  common_impl.ProcessMultiUseAll("lasso", "lasso")
end;
private.use_lasso_beg = function()
  ObjDelete( "gfx_chapeldoor_lasso_zone" );
end;
private.use_lasso_end = function()
  if common_impl.ZzCompleteCheck("use_lasso") then ObjSet( common_impl.hint["use_lasso"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "obj_chapeldoor_mmg_lasso_root", {visible=1, alp=1, input=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lasso", private.use_lasso_inv );
cmn.AddSubscriber( "use_lasso", private.use_lasso_beg, private.room_objname );
cmn.AddSubscriber( "use_lasso", private.use_lasso_end, private.room_objname );
cmn.AddSubscriber( "use_lasso", private.use_lasso_logic );
cmn.AddSubscriber( "use_lasso_inv", private.use_lasso_inv, private.room_objname );
cmn.AddSubscriber( "use_lasso_beg", private.use_lasso_beg, private.room_objname );
cmn.AddSubscriber( "use_lasso_end", private.use_lasso_end, private.room_objname );
cmn.AddSubscriber( "use_lasso_end", private.use_lasso_logic );
--------------------------------------------------------------------------------------------
function public.use_lasso( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
   
    public.init_win_lasso(first_start);
    cmn.MiniGameShow( "lasso" );
    ObjSet( "obj_chapeldoor_mmg_lasso_root", {visible=1, alp=0} );
    ObjAnimate( "obj_chapeldoor_mmg_lasso_root", 8, 0, 0, function()
       common_impl.Lock(0);
       cmn.SetEventDone( "use_lasso" );
       cmn.CallEventHandler( "use_lasso_end" );
       if common_impl.ZzCompleteCheck("use_lasso") then ld.CloseSubRoom() end;
    end, {0,0,0, 0.5,0,1} );
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lasso_inv" );
  cmn.CallEventHandler( "use_lasso_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_lasso" ] = { type = "click", use_place = "obj_chapeldoor_mmg_lasso_root", room = "rm_pond", zz = "zz_chapeldoor", zz_gate = "gzz_pond_chapeldoor" };

private.win_lasso_logic = function()
  if cmn.IsEventDone("win_lasso") then 
    ObjSet( "grm_pond_chapel", { visible = 1, input = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_pond_chapel_focus");
    end;
  end;
end;
private.win_lasso_beg = function()
  if cmn.IsEventDone("win_lasso") then 
    --  ObjDelete( "gfx_chapeldoor_win_lasso_zone" );
  end;  
end;
private.win_lasso_end = function()
  if cmn.IsEventDone("win_lasso") then 
    --ObjSet( "spr_pond_tr_rope", {alp = 1} );
   if common_impl.ZzCompleteCheck("win_lasso") then ObjSet( common_impl.hint["win_lasso"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjSet( "anm_pond_anim_rope", {animfunc = "anim_rope", frame = 0, playing = 1, visible=1 } ); 
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_lasso", private.win_lasso_beg, private.room_objname );
cmn.AddSubscriber( "win_lasso", private.win_lasso_end, private.room_objname );
cmn.AddSubscriber( "win_lasso", private.win_lasso_logic );
cmn.AddSubscriber( "win_lasso_beg", private.win_lasso_beg, private.room_objname );
cmn.AddSubscriber( "win_lasso_end", private.win_lasso_end, private.room_objname );
cmn.AddSubscriber( "win_lasso_end", private.win_lasso_logic );
--------------------------------------------------------------------------------------------
function public.win_lasso()

  local func_end = function()
    cmn.SetEventDone( "win_lasso" );
    cmn.CallEventHandler( "win_lasso_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_lasso") then ld.CloseSubRoom() end;
    
  end;

  cmn.CallEventHandler( "win_lasso_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;





---------------------------------------------------------------------------------------------
function public.init_win_lasso(first_start)
   local func_end = function()
       ld.Lock(0);
       private.win_lasso_stand_on_pos()
   end;   
  
  
   if not (cmn.IsEventStart("win_lasso")) or first_start==1 then
     ng_global.progress[ "std" ][ "win_lasso" ].state=1;
     --private.win_lasso_on_first_pos();
   else 
     if ld.CheckRequirements( {"use_lasso"} ) then
      -- private.win_lasso_stand_on_pos()
     end
   end  
      --!!!!!!!!!!!!!!!!!!!!
      --private.win_lasso_part_move_start()
      --!!!!!!!!!!!!!!!!!!!!!!
    if first_start==1 then
      ld.Lock(1); 
      ld.StartTimer( 1.5, func_end )    
    else
       func_end()
    end;    
end
--------------------------------------------------------------------------------------------     
local win_lasso_part_gr=150; 
local win_lasso_part_move_time=3; --for 1 lvl
local win_lasso_true_array={60,40,20};
local win_lasso_move_flag=0;
local win_lasso_motion_znak=-1;

function private.win_lasso_part_move_start()
   win_lasso_move_flag=1;
   private.win_lasso_part_move(1);
   ld.Lock(1);
   ld.StartTimer( win_lasso_part_move_time/3, function() ld.Lock(0);  end )
end;  

function private.win_lasso_part_move_stop()
   win_lasso_move_flag=0;
   private.win_lasso_part_move(2);
end;  
 
function private.win_lasso_part_move(flag) --1 start, 2 - stop
  if flag==1 then 
    local time = win_lasso_part_move_time/2;
    win_lasso_motion_znak = win_lasso_motion_znak* (-1);
    local  current_color_step = win_lasso_true_array[ng_global.progress[ "std" ][ "win_lasso" ].state]/win_lasso_part_gr;
    ObjStopAnimate("spr_chapeldoor_scale1", 1);
    ObjStopAnimate("spr_chapeldoor_lig", 12);
    ObjAnimate( "spr_chapeldoor_scale1", 1, 0, 0, function() if win_lasso_move_flag==1 then private.win_lasso_part_move(1); end end, {0,0,0, time*0.5,0,win_lasso_motion_znak*win_lasso_part_gr, time,0,0} );
    ObjAnimate( "spr_chapeldoor_lig", 12, 0, 0, function() end, {0,0,0,1,0, (current_color_step*time*0.5-0.01),0,0,1,0, (current_color_step*time*0.5),0,1,0,0, (time-current_color_step*time*0.5+0.01), 0, 1,0,0, (time-current_color_step*time*0.5), 0, 0,1,0, time, 0, 0,1,0 } );
  else 
    ObjStopAnimate("spr_chapeldoor_scale1", 1);
    ObjStopAnimate("spr_chapeldoor_lig", 12);
    ObjSet( "spr_chapeldoor_scale1", {pos_y=0} );
    ObjSet( "spr_chapeldoor_lig", {color_r=0, color_g=1, color_b=0} );
  end;  
end;  
--------------------------------------------------------
function public.win_lasso_mdown()
   local func_end = function()
     ld.Lock(0);
     private.win_lasso_stand_on_pos();
   end;
  
  
   local func_preend = function()
     private.win_lasso_part_move_stop();
     ObjAnimate( "spr_chapeldoor_scale1", 8, 0, 0, func_end, {0,0,0, 0.75,0,1, 1,0,1} );
   end;
  
--   ld.LogTrace( "Predel = "..win_lasso_true_array[ng_global.progress[ "std" ][ "win_lasso" ].state] );
--   ld.LogTrace( "pos_y = "..ObjGet("spr_chapeldoor_scale1").pos_y );
   
   ld.Lock(1);
   ObjStopAnimate("spr_chapeldoor_scale1", 1);
   ObjStopAnimate("spr_chapeldoor_lig", 12);
   if math.abs(ObjGet("spr_chapeldoor_scale1").pos_y )<=win_lasso_true_array[ng_global.progress[ "std" ][ "win_lasso" ].state] then
     SoundSfx( "aud_mg_rope_true" );
     ObjSet( "spr_chapeldoor_rov1_"..ng_global.progress[ "std" ][ "win_lasso" ].state, {visible = 1, alp=0} );
     ObjAnimate( "spr_chapeldoor_rov1_"..ng_global.progress[ "std" ][ "win_lasso" ].state, 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
     ng_global.progress[ "std" ][ "win_lasso" ].state=ng_global.progress[ "std" ][ "win_lasso" ].state+1;
     if  ng_global.progress[ "std" ][ "win_lasso" ].state<4 then 
       ObjAnimate( "spr_chapeldoor_scale1", 8, 0, 0, func_preend, {0,0,1, 0.75,0,1, 1,0,0} );
     else 
       ld.StartTimer(1,func_end);
     end;  
   else 
     SoundSfx( "aud_mg_rope_wrong" );
     ObjSet( "spr_chapeldoor_rov2_"..ng_global.progress[ "std" ][ "win_lasso" ].state, {visible = 1, alp=0} );
     ObjAnimate( "spr_chapeldoor_rov2_"..ng_global.progress[ "std" ][ "win_lasso" ].state, 8, 0, 0, function() end, {0,0,0, 0.5,0,1, 1,0,0} );
     ObjAnimate( "spr_chapeldoor_scale1", 8, 0, 0, func_preend, {0,0,1, 0.75,0,1, 1,0,0} );
   end;  
  
end;  
-----------------------------------------------------------------
function private.win_lasso_stand_on_pos()
  if ng_global.progress[ "std" ][ "win_lasso" ].state==4 then  private.WinAnim_win_lasso(); return; end;
  
  
  win_lasso_part_move_time = 3 - 0.5*ng_global.progress[ "std" ][ "win_lasso" ].state;

  for i=1,3,1 do 
     ObjSet( "spr_chapeldoor_rov1_"..i, {visible = 0, alp=1} );
     ObjSet( "spr_chapeldoor_rov2_"..i, {visible = 0, alp=1} );
  end;  
  
  for i=1,ng_global.progress[ "std" ][ "win_lasso" ].state-1,1 do 
    ObjSet( "spr_chapeldoor_rov1_"..i, {visible = 1} );
  end;  

  if ng_global.progress[ "std" ][ "win_lasso" ].state>0 and ng_global.progress[ "std" ][ "win_lasso" ].state<4 then 
    if win_lasso_move_flag==0 then private.win_lasso_part_move_start() end;
  else 
    private.win_lasso_part_move_stop()   
  end;  
  
end;  
 
------------------------------------------------------------------
function private.win_lasso_reset()
  local func_end = function()
   --  ld.LogTrace( "end of reset" );
     ng_global.progress[ "std" ][ "win_lasso" ].state=1;
     win_lasso_move_flag=0;
     private.win_lasso_part_move_stop()
     ObjAnimate( "spr_chapeldoor_scale1", 8, 0, 0, function()
        ld.Lock(0);
        private.win_lasso_stand_on_pos()
     end, {0,0,0, 0.5,0,1} );
  end;

  ld.Lock(1);
  ObjStopAnimate("spr_chapeldoor_scale1", 1);
  ObjStopAnimate("spr_chapeldoor_lig", 12);
  ObjAnimate( "spr_chapeldoor_scale1", 8, 0, 0, func_end, {0,0,1, 1,0,1, 1.2,0,0} );
  for i=1,3,1 do 
    ObjAnimate( "spr_chapeldoor_rov1_"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
    ObjAnimate( "spr_chapeldoor_rov2_"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  end;  
end;   
-------------------------------------------------------------------
    
--*********************************************************************************************************************
function private.WinAnim_win_lasso()

      local func_end = function ()
         private.Win_win_lasso();
      end;

      common_impl.Lock(1);
      --func_end();      
      cmn.MiniGameHide("lasso", true); 
      SoundSfx( "aud_mg_rope_win" );
      ObjAnimate( "obj_chapeldoor_mmg_lasso_root", 8, 0, 0, function() private.win_lasso_part_move_stop(); ld.AnimPlay( "anm_chapeldoor_anim_chapeldoor", "rope", func_end ) end, {0,0,1, 0.5,0,0} );
   end;

    function private.Win_win_lasso()
      local func_end=function()
        common_impl.Lock(0);
        cmn.SetEventDone("win_lasso");
        cmn.CallEventHandler( "win_lasso_end" );
        if common_impl.ZzCompleteCheck("win_lasso") then ld.CloseSubRoom() end;  
      end;

     ld.StartTimer( 0.5, func_end )
    end;
--------------------------------------------------------------------------------------------------------------
function public.Skip()
  --  ld.LogTrace( "Skip" );
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_chapeldoor" ) then    
    private.WinAnim_win_lasso()
  end;

  if ( mg_name == "zz_bridge" ) then    
    private.win_boards_skip_anim()
  end;
end;
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_chapeldoor" ) then  
    private.win_lasso_reset();
  end;

  if ( mg_name == "zz_bridge" ) then  
     private.win_boards_reset_anim();
  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
  private.win_boards_get_first_pos(); --for mmg win_boards
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_pond();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_pond_env" );
  if not ld.CheckRequirements( {"clk_escape"} ) then
     ObjAttach("vid_pond_vid_bridge_destruction_198","rm_pond");
  end;  
   private.pond_bridge_dr_stand_on_pos(); 
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_chapeldoor" );
  function zz_chapeldoor.Open()
  end;
  function zz_chapeldoor.PreOpen()
     if cmn.IsEventStart("win_lasso") and not cmn.IsEventDone("win_lasso") then 
       cmn.MiniGameShow( "lasso" ); 
       public.init_win_lasso();
     end;  
  end;
  function zz_chapeldoor.PreClose()
  end;
  function zz_chapeldoor.Close()
     if cmn.IsEventStart("win_lasso") and not cmn.IsEventDone("win_lasso") then 
       cmn.MiniGameHide( "lasso" ); 
     end;  
  end;

  subroom.Define( "zz_bridge" );
  function zz_bridge.Open()
  end;
  function zz_bridge.PreOpen()
     if cmn.IsEventStart("win_boards") and not cmn.IsEventDone("win_boards") then 
       cmn.MiniGameShow( "boards" ); 
       public.init_win_boards();
     end;  
  end;
  function zz_bridge.PreClose()
  end;
  function zz_bridge.Close()
     if cmn.IsEventStart("win_boards") and not cmn.IsEventDone("win_boards") then 
       cmn.MiniGameHide( "boards" ); 
     end;  
  end;

  subroom.Define( "zz_flowers" );
  function zz_flowers.Open()
  end;
  function zz_flowers.PreOpen()
  end;
  function zz_flowers.PreClose()
  end;
  function zz_flowers.Close()
  end;

  subroom.Define( "zz_water" );
  function zz_water.Open()
  end;
  function zz_water.PreOpen()
  end;
  function zz_water.PreClose()
  end;
  function zz_water.Close()
  end;
  
end;
--*********************************************************************************************************************
function public.pond_frog_clk(num)  --rm_pond.pond_frog_clk();
  local func_end = function()
     ObjSet( "obj_pond_anim_frog_"..num.."_clk_zone", {input = 1} );
  end;

  local frogs_array={"","_2","_3"};
  local sound_num_arr={3,2,1}
  
  ObjSet( "obj_pond_anim_frog_"..num.."_clk_zone", {input = 0} );
  SoundSfx( "aud_touch_frog_pond_"..sound_num_arr[num]);
  ld.AnimPlay( "anm_pond_anim_frog_"..num, "anim_frog"..frogs_array[num], func_end )
end; 
--*********************************************************************************************************************
function public.idle_1_zone_clk()
  local func_end = function()
    ObjSet( "obj_bridge_idle_1_zone", {input = 1} );
  end;
  
  SoundSfx( "aud_touch_boards_bridge" )
  ObjSet( "obj_bridge_idle_1_zone", {input = 0} );
  ld.AnimPlay( "anm_bridge_anm_idle_1", "idle", func_end )
end;  

--*********************************************************************************************************************
function public.idle_2_zone_clk()
  local func_end = function()
    ObjSet( "obj_bridge_idle_2_zone", {input = 1} );
  end;
  
  ObjSet( "obj_bridge_idle_2_zone", {input = 0} );
  SoundSfx( "aud_touch_boards_bridge" )
  ld.AnimPlay( "anm_bridge_anm_idle_2", "idle1", func_end )
end;  
--------------------------------------------------------------------------------------------------
local pond_bridge_boards_trash_coord={{200,354},{186,358},{169,365},{153,372},{136,377}};

function private.pond_bridge_dr_stand_on_pos()
  --local pond_bridge_boards_trash_coord={{136,377},{153,372},{169,365},{186,358},{200,354}};
  if cmn.IsEventStart("win_boards") and not cmn.IsEventDone("win_boards") then 
    for i=1,5,1 do 
       if private.win_boards_search_on_state(i)~=0 then
          ObjSet( "spr_pond_dr_"..i, {pos_x=pond_bridge_boards_trash_coord[private.win_boards_search_on_state(i)][1], pos_y=pond_bridge_boards_trash_coord[private.win_boards_search_on_state(i)][2], visible=1} );
       else 
          ObjSet( "spr_pond_dr_"..i,{visible=0});
       end;
    end;  
  end;  
end;  