-- name=rm_pub
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_pub";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  ----------------------------------------------------
function private.opn_pub()
  if not ( cmn.IsEventDone( "opn_pub" ) ) then
    cmn.SetEventDone( "opn_pub" );
    cmn.CallEventHandler( "opn_pub" )
    ld.ShowBbt("opn_pub");
    SoundTheme( "aud_adventure2_mus" );
  end;
end;
--------------------------------------------------------------------
local opn_pub = function() end;
local opn_pub_logic = function() end;
cmn.AddSubscriber( "opn_pub", opn_pub_logic )
cmn.AddSubscriber( "opn_pub", opn_pub, private.room_objname )
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "elizabeth3" then
    if count_txt == 1 then
      ld.Lock(1);
      ObjSet( "anm_pub_elizabeth3_character", {animfunc = "hand", frame = 0, playing=0 } );
      ld.StartTimer( 0.5, function() ld.AnimPlay( "anm_pub_elizabeth3_character", "hand", function() ld.Lock(0); end ); SoundSfx( "aud_get_to_us" );  end )     
    elseif count_txt == 2 then      
      ObjSet( "spr_pub_brooch1", {visible = 1} );
      ld.AnimPlay( "anm_pub_elizabeth3_character", "hand1", "" )
      cmn.CallEventHandler( "get_brooch1" )
    end;  
  end

  if dlg_name == "william4" then
    if count_txt == 1 then
      
    elseif count_txt == 2 then     
      common_impl.continue_visible = true
      ld.Lock(1);
      ld.AnimPlay( "anm_pub_william4_character", "give1", function() ld.Lock(0); end )
      SoundSfx( "aud_get_to_us" );
    elseif count_txt == 3 then    
      common_impl.continue_visible = true
      -- ld.Lock(1);
      
      ld.AnimPlay( "anm_pub_william4_character", "hand", function() ld.Lock(0); end )   
      ObjSet( "spr_pub_carretkey", {visible = 1} );
      cmn.CallEventHandler( "get_carretkey" );
    end;  
  end
  
end;
common_impl.hint[ "dlg_pub_elizabeth3" ] = { type = "click", use_place = "gfx_pub_dlg_pub_elizabeth3_zone", room = "rm_pub" };

private.dlg_pub_elizabeth3_logic = function()
  ObjSet( "gzz_pub_barrels", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_pub_bar", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_pub_storeroom", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_pub_windowhole", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_pub_brooch1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "grm_pub_nearpub2", {active=1, input = 1, visible = 1} );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_pub_nearpub2_focus");
    end;
end;
private.dlg_pub_elizabeth3_beg = function()
  ObjDelete( "gfx_pub_dlg_pub_elizabeth3_zone" );
end;
private.dlg_pub_elizabeth3_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_pub_elizabeth3", private.dlg_pub_elizabeth3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_pub_elizabeth3", private.dlg_pub_elizabeth3_end, private.room_objname );
cmn.AddSubscriber( "dlg_pub_elizabeth3", private.dlg_pub_elizabeth3_logic );
cmn.AddSubscriber( "dlg_pub_elizabeth3_beg", private.dlg_pub_elizabeth3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_pub_elizabeth3_end", private.dlg_pub_elizabeth3_end, private.room_objname );
cmn.AddSubscriber( "dlg_pub_elizabeth3_end", private.dlg_pub_elizabeth3_logic );
--------------------------------------------------------------------------------------------
function public.dlg_pub_elizabeth3( obj )
  
    common_impl.dialog_character_loc = ""
    common_impl.continue_visible = false
    cmn.CallEventHandler( "dlg_pub_elizabeth3_beg" );
    --common_impl.dialog_character_loc =  "anm_pub_anm_elizabeth_anm"
    ld.VidStaticHide( private.vid_pub_elizabeth_root,0.3 );
    common_impl.Start( "elizabeth3", 2, nil, nil, true, "dlg_pub_elizabeth3_end", {"aud_elizabeth_3_voc"} );
    
  end;
private.dlg_pub_elizabeth3_end = function()
  cmn.SetEventDone( "dlg_pub_elizabeth3" );
  cmn.CallEventHandler( "dlg_pub_elizabeth3_end" );
  cmn.SetEventDone( "get_brooch1" );
  ld.ShowBbt("after_dlg_elizabeth3");
end;
function public.dlg_pub_elizabeth3_end()
  ld.VidStaticShow( private.vid_pub_elizabeth_root , 0.3 ); 
  ObjSet( "dlg_pub_elizabeth3", {bake=1} );
     if ObjGetRelations( "inv_brooch" ).parent == "level_inv_hub" then
     ObjSet( "spr_pub_brooch1", {visible = 1} );
     cmn.CallEventHandler( "get_brooch1");      
   end
    private.dlg_pub_elizabeth3_end()
end
  
  
--local fuckin_array = {{900       ,622.0464 },
--{34.0992   ,-286.4464},
--{-136.8968 ,16.0188  },
--{-17.8618  ,87.1896  },
--{-2.006    ,64.4822  },
--{14.0707   ,7.9148   }}
--
--function private.show_fuckin_count()
--  local count1, count2=0,0;
--  for i=1,6,1 do 
--    count1=count1+fuckin_array[i][1];
--    count2=count2+fuckin_array[i][2];
--  end; 
--  ld.LogTrace( "x="..(count1-171).." y="..count2 );
--end;  
--
--private.show_fuckin_count()
--------------------------------------------------------------------
common_impl.hint[ "get_brooch1" ] = { type = "get", get_obj = "spr_pub_brooch1", room = "rm_pub" };

private.get_brooch1_logic = function()
  
end;
private.get_brooch1_inv = function()
  interface.InventoryItemAdd("inv_brooch","spr_pub_brooch1",function() level_inv.ProcessGetBroochAll( "get_brooch1" ) end);
end;
private.get_brooch1_beg = function()
  ObjDelete("gfx_pub_brooch1")
end;
private.get_brooch1_end = function()
  
end;

cmn.AddSubscriber( "get_brooch1", private.get_brooch1_inv );
cmn.AddSubscriber( "get_brooch1", private.get_brooch1_beg, private.room_objname );
cmn.AddSubscriber( "get_brooch1", private.get_brooch1_end, private.room_objname );
cmn.AddSubscriber( "get_brooch1", private.get_brooch1_logic );
--------------------------------------------------------------------
function public.get_brooch1()
  cmn.SetEventDone( "get_brooch1" );
  cmn.CallEventHandler( "get_brooch1" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pubkey_pub" ] = { type = "use", inv_obj = "inv_pubkey", use_place = "gfx_pub_pubkey_pub_zone", room = "rm_pub" };

private.use_pubkey_pub_logic = function()
  ObjSet( "gfx_pub_clk_clavecin_zone", { visible = 1, input = 1, active = 1 } )
  --  ObjSet( "grm_pub_nearpub", {active = 0, visible = 0, input = 0} );
  ObjSet( "grm_pub_nearpub2", {active = 0, visible = 0, input = 0} );
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_pub_nearpub2_focus");
    end;
end;
private.use_pubkey_pub_inv = function()
  common_impl.ProcessMultiUseAll("pubkey", "pubkey_pub")
end;
private.use_pubkey_pub_beg = function()
  ObjDelete( "gfx_pub_pubkey_pub_zone" );
end;
private.use_pubkey_pub_end = function()
  ObjSet( "anm_pub_anm_clk_door", {animfunc = "cklick_door", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pubkey_pub", private.use_pubkey_pub_inv );
cmn.AddSubscriber( "use_pubkey_pub", private.use_pubkey_pub_beg, private.room_objname );
cmn.AddSubscriber( "use_pubkey_pub", private.use_pubkey_pub_end, private.room_objname );
cmn.AddSubscriber( "use_pubkey_pub", private.use_pubkey_pub_logic );
cmn.AddSubscriber( "use_pubkey_pub_inv", private.use_pubkey_pub_inv, private.room_objname );
cmn.AddSubscriber( "use_pubkey_pub_beg", private.use_pubkey_pub_beg, private.room_objname );
cmn.AddSubscriber( "use_pubkey_pub_end", private.use_pubkey_pub_end, private.room_objname );
cmn.AddSubscriber( "use_pubkey_pub_end", private.use_pubkey_pub_logic );
--------------------------------------------------------------------------------------------
function public.use_pubkey_pub( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pubkey_pub" );
    cmn.CallEventHandler( "use_pubkey_pub_end" );
    common_impl.Lock(0);
    ld.ShowBbt("pub_after_use_pubkey_pub");
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pubkey_pub_inv" );
  cmn.CallEventHandler( "use_pubkey_pub_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pub_anm_clk_door", "cklick_door", func_end );
  SoundSfx( "aud_use_key_pub" )
  --func_end()
  interface.WidgetSetInput( InterfaceWidget_BtnMap, false );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_clavecin" ] = { type = "click", use_place = "gfx_pub_clk_clavecin_zone", room = "rm_pub" };

private.clk_clavecin_logic = function()
  ObjSet( "gfx_pub_clk_raid_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_clavecin_beg = function()
  ObjDelete( "gfx_pub_clk_clavecin_zone" );
end;
private.clk_clavecin_end = function()
  ObjSet( "anm_pub_anm_clk_bear", {animfunc = "cklick_bear", frame = 999 } );  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_clavecin", private.clk_clavecin_beg, private.room_objname );
cmn.AddSubscriber( "clk_clavecin", private.clk_clavecin_end, private.room_objname );
cmn.AddSubscriber( "clk_clavecin", private.clk_clavecin_logic );
cmn.AddSubscriber( "clk_clavecin_beg", private.clk_clavecin_beg, private.room_objname );
cmn.AddSubscriber( "clk_clavecin_end", private.clk_clavecin_end, private.room_objname );
cmn.AddSubscriber( "clk_clavecin_end", private.clk_clavecin_logic );
--------------------------------------------------------------------------------------------
function public.clk_clavecin()

  local func_end = function()
    cmn.SetEventDone( "clk_clavecin" );
    cmn.CallEventHandler( "clk_clavecin_end" );
    common_impl.Lock(0);
    public.clk_raid();
  end;

  cmn.CallEventHandler( "clk_clavecin_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pub_anm_clk_bear", "cklick_bear", func_end );
  SoundSfx( "aud_touch_bear_pub" )
  --func_end()
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_raid" ] = { type = "click", use_place = "gfx_pub_clk_raid_zone", room = "rm_pub" };

private.clk_raid_logic = function()
  ObjSet( "gfx_pub_dlg_pub_william4_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_pub_bar", {active=0, input = 0, visible = 0} );
  ObjSet( "gzz_pub_barrels", {active=0, input = 0, visible = 0} );
end;
private.clk_raid_beg = function()
  ObjDelete( "gfx_pub_clk_raid_zone" );
end;
private.clk_raid_end = function()
  ObjDelete("vid_pub_vid_elizabeth_51")
  ObjDelete("spr_pub_barell_b");
  ObjDelete("spr_pub_wind2");
  ObjSet( "obj_pub_windowhople_gloss_root", {active=1, visible = 1} );
  ObjSet( "spr_pub_wind1", {active=1, visible = 1} );
  ObjDelete("vid_pub_vid_raid_418");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_raid", private.clk_raid_beg, private.room_objname );
cmn.AddSubscriber( "clk_raid", private.clk_raid_end, private.room_objname );
cmn.AddSubscriber( "clk_raid", private.clk_raid_logic );
cmn.AddSubscriber( "clk_raid_beg", private.clk_raid_beg, private.room_objname );
cmn.AddSubscriber( "clk_raid_end", private.clk_raid_end, private.room_objname );
cmn.AddSubscriber( "clk_raid_end", private.clk_raid_logic );
--------------------------------------------------------------------------------------------
function public.clk_raid()

  local func_end = function()
    cmn.SetEventDone( "clk_raid" );
    cmn.CallEventHandler( "clk_raid_end" );
    ld.Lock(0);
    ld.ShowBbt("after_clk_raid");
    SoundTheme( "aud_danger1_mus" );
    interface.WidgetSetInput( InterfaceWidget_BtnMap, true );
  end;
  
  local func_preend = function()
    SoundVoice( 0 );
    SoundEnv( "aud_pub_env" );
    int.DialogVideoHide();
    ld.Lock(1);
    ObjSet( "spr_pub_barell_b", {visible = 0} );
    ObjSet( "spr_pub_wind2", {visible = 0} );
    ObjSet( "obj_pub_windowhople_gloss_root", {active=1, visible = 1} );
    ObjSet( "spr_pub_wind1", {active=1, visible = 1} );
    ld.VidStaticShow( private.vid_pub_william_root,0.3 );
    ld.StartTimer( 0.6, func_end )
  end;

  ld.VidStaticHide( private.vid_pub_elizabeth_root, 0.3 );
  ld.VidStaticHide( private.vid_pub_william_root,0.3 );  
  ld.StartTimer( 0.4, function() ld.VidStaticDetach(  private.vid_pub_elizabeth_root );  end ) 
  
  cmn.CallEventHandler( "clk_raid_beg" );
  -- common_impl.Lock(1);

  SoundEnv(0);
  ObjAttach("vid_pub_vid_raid_418","rm_pub");
  SoundVid("aud_raid_418");
  VidPlay("vid_pub_vid_raid_418",func_preend);
  --SoundVoice("aud_outro_voc");
  
  int.DialogVideoShow( "vid_pub_vid_raid_418", 1, func_preend, 1 ); 
  
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_pub_william4" ] = { type = "click", use_place = "gfx_pub_dlg_pub_william4_zone", room = "rm_pub" };

private.dlg_pub_william4_logic = function()
  --  ObjSet( "gzz_nearpub_coach", {active = 1, visible = 1,input=1} );
  -- ObjSet( "grm_pub_nearpub", {active = 1, visible = 1, input = 1} );
  ObjSet( "grm_pub_nearpub2", {active = 1, visible = 1, input = 1, pos_x=300, pos_y=226, inputrect_init=1, inputrect_w=260, inputrect_h=186, inputrect_x=-123, inputrect_y=-93} );  
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_pub_nearpub2_focus");
    end;
  ObjSet( "gzz_pub_barrels", {active=1, input = 1, visible = 1} );
  ObjSet( "gzz_pub_bar", {active=1, input = 1, visible = 1} );
  ObjSet( "spr_pub_carretkey", {active=1, input = 1, visible = 1} );
end;
private.dlg_pub_william4_beg = function()
  ObjDelete( "gfx_pub_dlg_pub_william4_zone" );
end;
private.dlg_pub_william4_end = function()
  ObjDelete("spr_pub_grm_rm_nearpub")
  ObjSet( "spr_pub_grm_rm_nearpub_2", {active=1; visible = 1} );
  ObjDelete("vid_pub_vid_william_51")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_pub_william4", private.dlg_pub_william4_beg, private.room_objname );
cmn.AddSubscriber( "dlg_pub_william4", private.dlg_pub_william4_end, private.room_objname );
cmn.AddSubscriber( "dlg_pub_william4", private.dlg_pub_william4_logic );
cmn.AddSubscriber( "dlg_pub_william4_beg", private.dlg_pub_william4_beg, private.room_objname );
cmn.AddSubscriber( "dlg_pub_william4_end", private.dlg_pub_william4_end, private.room_objname );
cmn.AddSubscriber( "dlg_pub_william4_end", private.dlg_pub_william4_logic );
--------------------------------------------------------------------------------------------
--function public.dlg_pub_william4( obj )
--
--  local func_end = function()
--    cmn.SetEventDone( "dlg_pub_william4" );
--    cmn.CallEventHandler( "dlg_pub_william4_end" );
--    common_impl.Lock(0);
--  end;
--
--  cmn.CallEventHandler( "dlg_pub_william4_beg" );
--  common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  --SoundSfx( 0 )
--  func_end()
--
--end;
--
function public.dlg_pub_william4( obj )
 
  cmn.CallEventHandler( "dlg_pub_william4_beg" );
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --  common_impl.dialog_character_loc =  ""
  ld.VidStaticHide( private.vid_pub_william_root,0.3 );
  common_impl.Start( "william4", 3, nil, nil, true, "dlg_pub_william4_end", {"aud_william_6_voc","aud_william_7_voc"} );

end;
private.dlg_pub_william4_end = function()
  ld.VidStaticDetach(  private.vid_pub_william_root )
  ObjSet( "dlg_pub_william4", {bake=1} );
  cmn.SetEventDone( "dlg_pub_william4" );
  cmn.CallEventHandler( "dlg_pub_william4_end" );
  cmn.SetEventDone( "get_carretkey" );
  --ld.ShowBbt("after_dlg_william3");
end;
function public.dlg_pub_william4_end()
   ObjSet( "dlg_pub_william4", {bake=1} );
   if ObjGetRelations( "inv_carretkey" ).parent == "level_inv_hub" then
     ObjSet( "spr_pub_carretkey", {visible = 1} );
     cmn.CallEventHandler( "get_carretkey");      
   end
   private.dlg_pub_william4_end()
end

--------------------------------------------------------------------------------------------
common_impl.hint[ "get_carretkey" ] = { type = "get", get_obj = "spr_pub_carretkey", room = "rm_pub" };

private.get_carretkey_logic = function()
  
end;
private.get_carretkey_inv = function()
  interface.InventoryItemAdd("inv_carretkey","spr_pub_carretkey");
end;
private.get_carretkey_beg = function()
  ObjDelete("gfx_pub_carretkey")
end;
private.get_carretkey_end = function()
 
end;

cmn.AddSubscriber( "get_carretkey", private.get_carretkey_inv );
cmn.AddSubscriber( "get_carretkey", private.get_carretkey_beg, private.room_objname );
cmn.AddSubscriber( "get_carretkey", private.get_carretkey_end, private.room_objname );
cmn.AddSubscriber( "get_carretkey", private.get_carretkey_logic );

function public.get_carretkey()
  cmn.SetEventDone( "get_carretkey" );
  cmn.CallEventHandler( "get_carretkey" );
end
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bar *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
function public.clk_cover()

  local func_end = function()
    ObjSet( "obj_bar_coverclk_zone", {input = 1} );
  end;
  
  ObjSet( "obj_bar_coverclk_zone", {input = 0} );
  ld.AnimPlay( "anm_bar_anm_cover", "idle", func_end );
  SoundSfx( "aud_touch_drawer_pub" );
end;
--------------------------------------------------------------------

common_impl.hint[ "get_redcrystal" ] = { type = "get", get_obj = "spr_bar_redcrystal", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.get_redcrystal_logic = function()
  
end;
private.get_redcrystal_inv = function()
  interface.InventoryItemAdd("inv_redcrystal","spr_bar_redcrystal");
end;
private.get_redcrystal_beg = function()
  ObjDelete("gfx_bar_redcrystal")
end;
private.get_redcrystal_end = function()
  if common_impl.ZzCompleteCheck("get_redcrystal") then ObjSet( common_impl.hint["get_redcrystal"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_bar_redcrystal_sh");
  ObjDelete("spr_pub_redcrystal_tr");
end;

cmn.AddSubscriber( "get_redcrystal", private.get_redcrystal_inv );
cmn.AddSubscriber( "get_redcrystal", private.get_redcrystal_beg, private.room_objname );
cmn.AddSubscriber( "get_redcrystal", private.get_redcrystal_end, private.room_objname );
cmn.AddSubscriber( "get_redcrystal", private.get_redcrystal_logic );
--------------------------------------------------------------------
function public.get_redcrystal()
  cmn.SetEventDone( "get_redcrystal" );
  cmn.CallEventHandler( "get_redcrystal" );
  if common_impl.ZzCompleteCheck("get_redcrystal") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fishingline" ] = { type = "get", get_obj = "spr_bar_fishingline", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.get_fishingline_logic = function()
  
end;
private.get_fishingline_inv = function()
  interface.InventoryItemAdd("inv_fishingline","spr_bar_fishingline");
end;
private.get_fishingline_beg = function()
  ObjDelete("gfx_bar_fishingline")
end;
private.get_fishingline_end = function()
  if common_impl.ZzCompleteCheck("get_fishingline") then ObjSet( common_impl.hint["get_fishingline"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_bar_fishingline_sh");
  ObjDelete("spr_pub_fishingline_tr");
end;

cmn.AddSubscriber( "get_fishingline", private.get_fishingline_inv );
cmn.AddSubscriber( "get_fishingline", private.get_fishingline_beg, private.room_objname );
cmn.AddSubscriber( "get_fishingline", private.get_fishingline_end, private.room_objname );
cmn.AddSubscriber( "get_fishingline", private.get_fishingline_logic );
--------------------------------------------------------------------
function public.get_fishingline()
  cmn.SetEventDone( "get_fishingline" );
  cmn.CallEventHandler( "get_fishingline" );
  if common_impl.ZzCompleteCheck("get_fishingline") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_saltcellar" ] = { type = "use", inv_obj = "inv_saltcellar", use_place = "gfx_bar_saltcellar_zone", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.use_saltcellar_logic = function()
  --ObjSet( "gfx_bar_clk_seasonings_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "obj_mmg_seasonings", {input = 1} );
end;
private.use_saltcellar_inv = function()
  common_impl.ProcessMultiUseAll("saltcellar", "saltcellar")
end;
private.use_saltcellar_beg = function()
  ObjDelete( "gfx_bar_saltcellar_zone" );
end;
private.use_saltcellar_end = function()
  if common_impl.ZzCompleteCheck("use_saltcellar") then ObjSet( common_impl.hint["use_saltcellar"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_bar_anm_salt", {animfunc = "end_s", frame = 0 } );
  ObjDelete("spr_bar_spice");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_saltcellar", private.use_saltcellar_inv );
cmn.AddSubscriber( "use_saltcellar", private.use_saltcellar_beg, private.room_objname );
cmn.AddSubscriber( "use_saltcellar", private.use_saltcellar_end, private.room_objname );
cmn.AddSubscriber( "use_saltcellar", private.use_saltcellar_logic );
cmn.AddSubscriber( "use_saltcellar_inv", private.use_saltcellar_inv, private.room_objname );
cmn.AddSubscriber( "use_saltcellar_beg", private.use_saltcellar_beg, private.room_objname );
cmn.AddSubscriber( "use_saltcellar_end", private.use_saltcellar_end, private.room_objname );
cmn.AddSubscriber( "use_saltcellar_end", private.use_saltcellar_logic );
--------------------------------------------------------------------------------------------
function public.use_saltcellar( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_saltcellar" );
    cmn.CallEventHandler( "use_saltcellar_end" );
    common_impl.Lock(0);
    cmn.MiniGameShow( "seasonings" );
    public.win_seasonings_load(); 
    if common_impl.ZzCompleteCheck("use_saltcellar") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_saltcellar_inv" );
  cmn.CallEventHandler( "use_saltcellar_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bar_anm_salt", "use_s", func_end );
  SoundSfx( "aud_use_salt_pub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_seasonings" ] = { type = "click", use_place = "obj_mmg_seasonings", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.win_seasonings_logic = function()
  if ( cmn.IsEventDone( "win_seasonings" ) ) then
    ObjSet( "spr_bar_talisman", { visible = 0, input = 1, active = 1 } )
    ObjSet( "gfx_bar_talisman", {active=1, visible=1} );
  end
end;
private.win_seasonings_beg = function()
  --ObjDelete( "gfx_bar_win_seasonings_zone" );
end;
private.win_seasonings_end = function()
  if common_impl.ZzCompleteCheck("win_seasonings") then ObjSet( common_impl.hint["win_seasonings"].zz_gate, { visible = 0, input = 0 } ); end;
  if ( cmn.IsEventDone( "win_seasonings" ) ) then
    ObjDelete( "obj_bar_coverclk_zone" );
    ObjSet( "anm_bar_anm_cover", {animfunc = "open_cover", frame = 999 } );
    --ObjSet( "obj_mmg_seasonings", {input = 0, alp = 1} );
    ObjDelete( "obj_mmg_seasonings" );
    ObjDelete("anm_bar_anm_salt");
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_seasonings", private.win_seasonings_beg, private.room_objname );
cmn.AddSubscriber( "win_seasonings", private.win_seasonings_end, private.room_objname );
cmn.AddSubscriber( "win_seasonings", private.win_seasonings_logic );
cmn.AddSubscriber( "win_seasonings_beg", private.win_seasonings_beg, private.room_objname );
cmn.AddSubscriber( "win_seasonings_end", private.win_seasonings_end, private.room_objname );
cmn.AddSubscriber( "win_seasonings_end", private.win_seasonings_logic );
--------------------------------------------------------------------------------------------
function public.win_seasonings()

  local func_end = function()
    cmn.SetEventDone( "win_seasonings" );
    cmn.CallEventHandler( "win_seasonings_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_seasonings") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_seasonings_beg" );
  common_impl.Lock(1);
  cmn.MiniGameHide( "seasonings", true );
  
  ObjSet( "anm_bar_anm_salt", {visible = 0} );
  ld.AnimPlay( "anm_bar_anm_cover", "open_cover", func_end );
  -- SoundSfx( "aud_mg_bar_win" );

  --func_end()

end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------

local obj_pos = {{-10,64},{43,-8},{-88,-17},{-196,-23},{-169,-154},{-137,67},{-112,-177}};
local current_obj = 0;

function public.win_seasonings_load(fast) 
  if not ng_global.progress[ "std" ][ "win_seasonings" ].state then
    ng_global.progress[ "std" ][ "win_seasonings" ].state = {2,7,6,1,4,3,5};        
  end
  private.win_seasonings_before_check();
  public.win_seasonings_check();  
  for i = 1, #ng_global.progress[ "std" ][ "win_seasonings" ].state do
    ObjSet( "spr_bar_label"..ng_global.progress[ "std" ][ "win_seasonings" ].state[i], {pos_x = obj_pos[i][1], pos_y = obj_pos[i][2]} );
  end
  ObjAnimate( "obj_mmg_seasonings", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
end

function public.win_seasonings_hand(num)  
  ld.SetCursor( CURSOR_HAND );
  ObjSet( "spr_bar_lig"..num, { alp = 1} ); 
end

function public.win_seasonings_hand_defoult(num)  
  ld.SetCursor( CURSOR_DEFAULT ); 
  if num ~= current_obj then
    ObjSet( "spr_bar_lig"..num, { alp = 0} ); 
  end
end 

function private.win_seasonings_obj_move(num,current_obj)
  local obj_pos_x = ObjGet("spr_bar_label"..num).pos_x;
  local obj_pos_y = ObjGet("spr_bar_label"..num).pos_y;
  local current_obj_pos_x = ObjGet("spr_bar_label"..current_obj).pos_x;
  local current_obj_pos_y = ObjGet("spr_bar_label"..current_obj).pos_y;
  ObjSet( "spr_bar_lig"..num, { alp = 0} ); 
  ObjSet( "spr_bar_lig"..current_obj, { alp = 0} );
  ObjSet( "spr_bar_label"..num, {pos_z=30} ); 
  ObjSet( "spr_bar_label"..current_obj, {pos_z=30} ); 
  if num~= current_obj then  SoundSfx( "aud_mg_bar_move" ); end;
  ObjAnimate( "spr_bar_label"..num, 3, 0, 0, function() ObjSet( "spr_bar_label"..num, {pos_z=0} );  end,{0,0,obj_pos_x, obj_pos_y, 0.5,0,current_obj_pos_x,current_obj_pos_y} );
  ObjAnimate( "spr_bar_label"..current_obj, 3, 0, 0, function() ObjSet( "spr_bar_label"..current_obj, {pos_z=0} );  end,{0,0,current_obj_pos_x,current_obj_pos_y, 0.5,0,obj_pos_x,obj_pos_y} );
end

function public.win_seasonings_clik(num)
  SoundSfx( "aud_mg_bar_select" );
  local obj_index;
  local current_obj_index;
  if current_obj == 0 then
    current_obj = num;  
  else
    ld.Lock(1);
    for i = 1,7 do
      if num == ng_global.progress[ "std" ][ "win_seasonings" ].state[i] then
        obj_index = i;
      end
      if current_obj == ng_global.progress[ "std" ][ "win_seasonings" ].state[i] then
        current_obj_index = i;
      end
    end
    private.win_seasonings_obj_move(num, current_obj);
    private.win_seasonings_before_check();
    ng_global.progress[ "std" ][ "win_seasonings" ].state[obj_index] = current_obj;
    ng_global.progress[ "std" ][ "win_seasonings" ].state[current_obj_index] = num;
    current_obj = 0;
    ld.StartTimer( 0.5, function() ld.Lock(0); public.win_seasonings_check(); end )
  end
end


local win_seasonings_check_count=0;

function private.win_seasonings_before_check()
   win_seasonings_check_count=0;
   for  i = 1, #ng_global.progress[ "std" ][ "win_seasonings" ].state do
     if ng_global.progress[ "std" ][ "win_seasonings" ].state[i] == i then
       win_seasonings_check_count=win_seasonings_check_count+1;
     end
   end; 
  -- ld.LogTrace( "win_seasonings_check_count = "..win_seasonings_check_count ); 
end;  

 function public.win_seasonings_check()
   local my_count=0;
   for  i = 1, #ng_global.progress[ "std" ][ "win_seasonings" ].state do
    if ng_global.progress[ "std" ][ "win_seasonings" ].state[i] == i then
      ObjSet( "spr_bar_lig"..ng_global.progress[ "std" ][ "win_seasonings" ].state[i], { alp = 1} ); 
      ObjSet( "spr_bar_label"..ng_global.progress[ "std" ][ "win_seasonings" ].state[i], { input = 0} );
      my_count=my_count+1;
    end
  end
  ------------------------FOR SFX
  local dif=my_count-win_seasonings_check_count;
--  ld.LogTrace( " check_count = "..my_count.." before count = "..win_seasonings_check_count );
  if dif>0 then 
     for i=1,dif,1 do
        SoundSfx( "aud_mg_bar_set" )
     end;
  end;

  --------------------------- 
  for  i = 1, #ng_global.progress[ "std" ][ "win_seasonings" ].state do
    if ng_global.progress[ "std" ][ "win_seasonings" ].state[i] ~= i then
      return;
    end
  end
  ld.Lock(1);
  public.win_seasonings_skip();
end

    
function public.win_seasonings_skip(fast)
  if ng_global.progress[ "std" ][ "win_seasonings" ].state then
    ng_global.progress[ "std" ][ "win_seasonings" ].state = {2,7,6,1,4,3,5};
  end
  current_obj = 0; 
  local func_end = function()
    for i = 1,7 do 
      ObjAnimate( "spr_bar_lig"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
    end 
    SoundSfx( "aud_mg_bar_win" );
    ld.StartTimer( 0.5, function() ld.Lock(0); public.win_seasonings(); end )  
  end;
  for i = 1,7 do 
    ObjAnimate( "spr_bar_lig"..i, 8, 0, 0, function() end, {0,0,ObjGet("spr_bar_lig"..i).alp, 0.5,0,1} );
  end
  --SoundSfx( "" );
  ld.StartTimer( 0.5, function() func_end(); end ) 
end

function public.win_seasonings_reset()
  ld.Lock(1);
  if ng_global.progress[ "std" ][ "win_seasonings" ].state then
    ng_global.progress[ "std" ][ "win_seasonings" ].state = {2,7,6,1,4,3,5};
  end  
  for i = 1,7 do
     ObjSet( "spr_bar_label"..i, {input = 1} );
     ObjSet( "spr_bar_lig"..i, {alp = 0} );
     ObjAnimate( "spr_bar_label"..ng_global.progress[ "std" ][ "win_seasonings" ].state[i], 3, 0, 0, function() end, {0,0,ObjGet("spr_bar_label"..ng_global.progress[ "std" ][ "win_seasonings" ].state[i]).pos_x, ObjGet("spr_bar_label"..ng_global.progress[ "std" ][ "win_seasonings" ].state[i]).pos_y, 0.7,0,obj_pos[i][1],obj_pos[i][2]} );
  end
  current_obj = 0;
  ld.StartTimer( 0.7, function() ld.Lock(0); end )
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_talisman" ] = { type = "get", get_obj = "spr_bar_talisman", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.get_talisman_logic = function()
  
end;
private.get_talisman_inv = function()
  interface.InventoryItemAdd("inv_talisman","spr_bar_talisman");
end;
private.get_talisman_beg = function()
  ObjDelete("gfx_bar_talisman")
end;
private.get_talisman_end = function()
  if common_impl.ZzCompleteCheck("get_talisman") then ObjSet( common_impl.hint["get_talisman"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_bar_anm_cover", {animfunc = "end_cover", frame = 0 } );
end;

cmn.AddSubscriber( "get_talisman", private.get_talisman_inv );
cmn.AddSubscriber( "get_talisman", private.get_talisman_beg, private.room_objname );
cmn.AddSubscriber( "get_talisman", private.get_talisman_end, private.room_objname );
cmn.AddSubscriber( "get_talisman", private.get_talisman_logic );
--------------------------------------------------------------------
function public.get_talisman()
  ObjSet( "spr_bar_talisman", {visible = 1} );
  cmn.SetEventDone( "get_talisman" );
  cmn.CallEventHandler( "get_talisman" );
  if common_impl.ZzCompleteCheck("get_talisman") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_birdclaw" ] = { type = "use", inv_obj = "inv_birdclaw", use_place = "gfx_bar_birdclaw_zone", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.use_birdclaw_logic = function()
  ObjSet( "spr_bar_brooch4", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_bar_brooch4", {active = 1, visible = 1} );
end;
private.use_birdclaw_inv = function()
  common_impl.ProcessMultiUseAll("birdclaw", "birdclaw")
end;
private.use_birdclaw_beg = function()
  ObjDelete( "gfx_bar_birdclaw_zone" );
end;
private.use_birdclaw_end = function()
  if common_impl.ZzCompleteCheck("use_birdclaw") then ObjSet( common_impl.hint["use_birdclaw"].zz_gate, { visible = 0, input = 0 } ); end;
  -- ObjDelete( "anm_bar_anm_leg" );
  ObjSet( "anm_bar_anm_leg", {animfunc = "use_leg", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_birdclaw", private.use_birdclaw_inv );
cmn.AddSubscriber( "use_birdclaw", private.use_birdclaw_beg, private.room_objname );
cmn.AddSubscriber( "use_birdclaw", private.use_birdclaw_end, private.room_objname );
cmn.AddSubscriber( "use_birdclaw", private.use_birdclaw_logic );
cmn.AddSubscriber( "use_birdclaw_inv", private.use_birdclaw_inv, private.room_objname );
cmn.AddSubscriber( "use_birdclaw_beg", private.use_birdclaw_beg, private.room_objname );
cmn.AddSubscriber( "use_birdclaw_end", private.use_birdclaw_end, private.room_objname );
cmn.AddSubscriber( "use_birdclaw_end", private.use_birdclaw_logic );
--------------------------------------------------------------------------------------------
function public.use_birdclaw( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_birdclaw" );
    cmn.CallEventHandler( "use_birdclaw_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_birdclaw") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_birdclaw_inv" );
  cmn.CallEventHandler( "use_birdclaw_beg" );
  common_impl.Lock(1);
  --  ObjSet( "anm_bar_anm_leg", {pos_z = 8} );
  ld.AnimPlay( "anm_bar_anm_leg", "use_leg", func_end );
  SoundSfx( "aud_use_chicken_foot_pub" );
  --func_end()

end;

function public.clk_birdclaw()

  local func_end = function()
    common_impl.ShowBbt( 'need_birdclaw' );
    ld.Lock(0);
  end;
  ld.Lock(1);
  ld.AnimPlay( "anm_bar_anm_leg", "idle_1", func_end );
  SoundSfx( "aud_touch_chicken_foot_pub" );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_brooch4" ] = { type = "get", get_obj = "spr_bar_brooch4", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.get_brooch4_logic = function()
  
end;
private.get_brooch4_inv = function()
  interface.InventoryItemAdd("inv_brooch","spr_bar_brooch4",function() level_inv.ProcessGetBroochAll( "get_brooch4" ) end);
end;
private.get_brooch4_beg = function()
  ObjDelete("gfx_bar_brooch4")
end;
private.get_brooch4_end = function()
  if common_impl.ZzCompleteCheck("get_brooch4") then ObjSet( common_impl.hint["get_brooch4"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete( "anm_bar_anm_leg" );
end;

cmn.AddSubscriber( "get_brooch4", private.get_brooch4_inv );
cmn.AddSubscriber( "get_brooch4", private.get_brooch4_beg, private.room_objname );
cmn.AddSubscriber( "get_brooch4", private.get_brooch4_end, private.room_objname );
cmn.AddSubscriber( "get_brooch4", private.get_brooch4_logic );
--------------------------------------------------------------------
function public.get_brooch4()
  ObjSet( "spr_bar_brooch4", {visible = 1} );
  cmn.SetEventDone( "get_brooch4" );
  cmn.CallEventHandler( "get_brooch4" );
  if common_impl.ZzCompleteCheck("get_brooch4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_storeroom *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
function public.clk_cover_storeroom()
  local func_end = function()
     ld.Lock(0);
  end;
   if ld.CheckRequirements( { "get_plaquebelt" } ) and not ld.CheckRequirements( {"use_clover"} ) and not ld.CheckRequirements( {"use_esdoornblad"} )  then  
    ld.Lock(1);
    SoundSfx( "aud_touch_door_pub" );
    ld.AnimPlay( "anm_storeroom_anm_cover", "idle_cover", func_end );
  end
end;

--------------------------------------------------------------------
common_impl.hint[ "get_plaquebelt" ] = { type = "get", get_obj = "spr_storeroom_plaquebelt", room = "rm_pub", zz = "zz_storeroom", zz_gate = "gzz_pub_storeroom" };

private.get_plaquebelt_logic = function()
  
end;
private.get_plaquebelt_inv = function()
  interface.InventoryItemAdd("inv_plaquebelt","spr_storeroom_plaquebelt");
end;
private.get_plaquebelt_beg = function()
  ObjDelete("gfx_storeroom_plaquebelt")
end;
private.get_plaquebelt_end = function()
  if common_impl.ZzCompleteCheck("get_plaquebelt") then ObjSet( common_impl.hint["get_plaquebelt"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_storeroom_plaquebelt_sh");
  ObjDelete("spr_pub_plaquebelt");
end;

cmn.AddSubscriber( "get_plaquebelt", private.get_plaquebelt_inv );
cmn.AddSubscriber( "get_plaquebelt", private.get_plaquebelt_beg, private.room_objname );
cmn.AddSubscriber( "get_plaquebelt", private.get_plaquebelt_end, private.room_objname );
cmn.AddSubscriber( "get_plaquebelt", private.get_plaquebelt_logic );
--------------------------------------------------------------------
function public.get_plaquebelt()
  cmn.SetEventDone( "get_plaquebelt" );
  cmn.CallEventHandler( "get_plaquebelt" );
  if common_impl.ZzCompleteCheck("get_plaquebelt") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_clover" ] = { type = "use", inv_obj = "inv_clover", use_place = "gfx_storeroom_clover_zone", room = "rm_pub", zz = "zz_storeroom", zz_gate = "gzz_pub_storeroom" };

private.use_clover_logic = function()
  if ld.CheckRequirements( {"use_clover","use_esdoornblad"} ) then
    ObjSet( "obj_clovers_mmg", { input = 1 } )
  end;

end;
private.use_clover_inv = function()
  common_impl.ProcessMultiUseAll("clover", "clover")
end;
private.use_clover_beg = function()
  ObjDelete( "gfx_storeroom_clover_zone" );
end;
private.use_clover_end = function()
  if common_impl.ZzCompleteCheck("use_clover") then ObjSet( common_impl.hint["use_clover"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_storeroom_anm_clover", {animfunc = "use_clover", frame = 999, pos_z=5 } );
  --  ObjDelete("obj_storeroom_coverclk_zone");
  if ld.CheckRequirements( {"use_esdoornblad","use_clover"} ) then
    
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_clover", private.use_clover_inv );
cmn.AddSubscriber( "use_clover", private.use_clover_beg, private.room_objname );
cmn.AddSubscriber( "use_clover", private.use_clover_end, private.room_objname );
cmn.AddSubscriber( "use_clover", private.use_clover_logic );
cmn.AddSubscriber( "use_clover_inv", private.use_clover_inv, private.room_objname );
cmn.AddSubscriber( "use_clover_beg", private.use_clover_beg, private.room_objname );
cmn.AddSubscriber( "use_clover_end", private.use_clover_end, private.room_objname );
cmn.AddSubscriber( "use_clover_end", private.use_clover_logic );
--------------------------------------------------------------------------------------------
function public.use_clover( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_clover" );
    cmn.CallEventHandler( "use_clover_end" );
    common_impl.Lock(0);
    if ld.CheckRequirements( {"use_esdoornblad","use_clover"} ) then
       common_impl.Lock(1);
      cmn.MiniGameShow( "clovers" );
      ld.StartTimer( 0.5, function()  common_impl.Lock(0); public.win_clovers_load();  end )-- public.win_clovers_load(); 
    end
    if common_impl.ZzCompleteCheck("use_clover") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_clover_inv" );
  cmn.CallEventHandler( "use_clover_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_storeroom_anm_clover", {pos_z=32} );
  ld.AnimPlay( "anm_storeroom_anm_clover", "use_clover", func_end );
  SoundSfx( "aud_use_four_leaf" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_esdoornblad" ] = { type = "use", inv_obj = "inv_esdoornblad", use_place = "gfx_storeroom_esdoornblad_zone", room = "rm_pub", zz = "zz_storeroom", zz_gate = "gzz_pub_storeroom" };

private.use_esdoornblad_logic = function()
  if ld.CheckRequirements( {"use_esdoornblad","use_clover"} ) then
    ObjSet( "obj_clovers_mmg", { input = 1 } )
  end;

end;
private.use_esdoornblad_inv = function()
  common_impl.ProcessMultiUseAll("esdoornblad", "esdoornblad")
end;
private.use_esdoornblad_beg = function()
  ObjDelete( "gfx_storeroom_esdoornblad_zone" );
end;
private.use_esdoornblad_end = function()
  if common_impl.ZzCompleteCheck("use_esdoornblad") then ObjSet( common_impl.hint["use_esdoornblad"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_storeroom_anm_esdoornblad", {animfunc = "use_esdoornblad2", frame = 999, pos_z=5 } );
  --  ObjDelete("obj_storeroom_coverclk_zone");
  if ld.CheckRequirements( {"use_esdoornblad","use_clover"} ) then
    
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_esdoornblad", private.use_esdoornblad_inv );
cmn.AddSubscriber( "use_esdoornblad", private.use_esdoornblad_beg, private.room_objname );
cmn.AddSubscriber( "use_esdoornblad", private.use_esdoornblad_end, private.room_objname );
cmn.AddSubscriber( "use_esdoornblad", private.use_esdoornblad_logic );
cmn.AddSubscriber( "use_esdoornblad_inv", private.use_esdoornblad_inv, private.room_objname );
cmn.AddSubscriber( "use_esdoornblad_beg", private.use_esdoornblad_beg, private.room_objname );
cmn.AddSubscriber( "use_esdoornblad_end", private.use_esdoornblad_end, private.room_objname );
cmn.AddSubscriber( "use_esdoornblad_end", private.use_esdoornblad_logic );
--------------------------------------------------------------------------------------------
function public.use_esdoornblad( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_esdoornblad" );
    cmn.CallEventHandler( "use_esdoornblad_end" );
    common_impl.Lock(0);
    if ld.CheckRequirements( {"use_esdoornblad","use_clover"} ) then
      cmn.MiniGameShow( "clovers" );
      common_impl.Lock(1);
       ld.StartTimer( 0.5, function() common_impl.Lock(0); public.win_clovers_load();  end )--public.win_clovers_load(); 
    end
    if common_impl.ZzCompleteCheck("use_esdoornblad") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_esdoornblad_inv" );
  cmn.CallEventHandler( "use_esdoornblad_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_storeroom_anm_esdoornblad", {pos_z=32} );
  ld.AnimPlay( "anm_storeroom_anm_esdoornblad", "use_esdoornblad2", func_end );
  SoundSfx( "aud_use_maple_leaf" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_clovers" ] = { type = "click", use_place = "obj_clovers_mmg", room = "rm_pub", zz = "zz_storeroom", zz_gate = "gzz_pub_storeroom" };

private.win_clovers_logic = function()
  if ( cmn.IsEventDone( "win_clovers" ) ) then
    ObjSet( "gho_pub_pantry", { visible = 1, input = 1, active = 1 } )
  end

end;
private.win_clovers_beg = function()
  
end;
private.win_clovers_end = function()
  if common_impl.ZzCompleteCheck("win_clovers") then ObjSet( common_impl.hint["win_clovers"].zz_gate, { visible = 0, input = 0 } ); end;
  if ( cmn.IsEventDone( "win_clovers" ) ) then
    ObjDelete("obj_clovers_mmg");
    ObjDelete("spr_pub_door_tr");
    ObjSet( "spr_pub_door_ho", {visible = 1} );
    ObjSet( "spr_pub_door_ho1", {active=1, visible = 1} );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_clovers", private.win_clovers_beg, private.room_objname );
cmn.AddSubscriber( "win_clovers", private.win_clovers_end, private.room_objname );
cmn.AddSubscriber( "win_clovers", private.win_clovers_logic );
cmn.AddSubscriber( "win_clovers_beg", private.win_clovers_beg, private.room_objname );
cmn.AddSubscriber( "win_clovers_end", private.win_clovers_end, private.room_objname );
cmn.AddSubscriber( "win_clovers_end", private.win_clovers_logic );
--------------------------------------------------------------------------------------------
function public.win_clovers()

  local func_end = function()
    cmn.SetEventDone( "win_clovers" );
    cmn.CallEventHandler( "win_clovers_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_clovers") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_clovers_beg" );
  common_impl.Lock(1);
  cmn.MiniGameHide( "clovers", true );
  
  ld.StartTimer( 0.5, function()  
      --ld.AnimPlay( "", "", func_end );
      ObjAnimate( "obj_clovers_mmg", 8, 0, 0, function() func_end() end, {0,0,1, 1,0,0} );
      SoundSfx( "aud_mg_leaves_win" );
      --func_end()
  end )

end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
local win_clk = {5,2,3,1,4};    

function public.win_clovers_load(fast) 
  if not ng_global.progress[ "std" ][ "win_clovers" ].state then
    ng_global.progress[ "std" ][ "win_clovers" ].state = 0;        
  end
  if ng_global.progress[ "std" ][ "win_clovers" ].state ~= 0 then
      for i = 1, ng_global.progress[ "std" ][ "win_clovers" ].state do
        ObjSet( "spr_storeroom_light_"..win_clk[i], {alp = 1, input = 0} );
        ObjSet( "spr_storeroom_light_small_"..win_clk[i], {alp = 1} );
      end  
  end
  
  if fast~=1 then 
      ld.Lock(1);
      SoundSfx( "aud_mg_leaves_show" );
      for i = ng_global.progress[ "std" ][ "win_clovers" ].state + 1 , 5 do
        ObjAnimate( "spr_storeroom_light_small_"..win_clk[i], 8, 0, 0, function() ld.StartTimer( 1, function() ObjAnimate( "spr_storeroom_light_small_"..win_clk[i], 8, 0, 0, function() end, {0,0,1, 0.5,0,0} ); end); end, {0,0,0, 0.5,0,1} );
      end
      ld.StartTimer( 2, function() ld.Lock(0); end )
  else 
      
  end;  
    
end

function public.win_clovers_hand(num)  
  ld.SetCursor( CURSOR_HAND );
  ObjSet( "spr_storeroom_light_"..num, { alp = 1} ); 
end

function public.win_clovers_hand_defoult(num)  
  ld.SetCursor( CURSOR_DEFAULT ); 
  ObjSet( "spr_storeroom_light_"..num, { alp = 0} ); 
end 

function public.win_clovers_clik(num)
  ng_global.progress[ "std" ][ "win_clovers" ].state = ng_global.progress[ "std" ][ "win_clovers" ].state + 1;
  SoundSfx( "aud_mg_leaves_click" );
  
    if win_clk[ng_global.progress[ "std" ][ "win_clovers" ].state] == num then
      SoundSfx( "aud_mg_leaves_true" );
      ld.Lock(1);
      ObjSet( "spr_storeroom_light_"..num, {input = 0} );
      ObjAnimate( "spr_storeroom_light_small_"..num, 8, 0, 0, function() ObjSet( "spr_storeroom_light_"..num, {alp = 1} ); public.win_clovers_check(); end, {0,0,0, 0.5,0,1} );  
    else
      SoundSfx( "aud_mg_leaves_wrong" );
      public.win_clovers_reset();    
    end
end

function public.win_clovers_check()
  if  ng_global.progress[ "std" ][ "win_clovers" ].state == 5 then
    ld.StartTimer( 0.5, function() public.win_clovers(); end )
  else
    ld.Lock(0);  
  end
end
    
function public.win_clovers_skip()
  local time = 0;
  local func_end = function()
    if ng_global.progress[ "std" ][ "win_clovers" ].state then
      ng_global.progress[ "std" ][ "win_clovers" ].state = 0;
    end
    ld.StartTimer( 0.1, function() public.win_clovers(); end )   
  end
  local obj_animate_light = function(num)
    SoundSfx( "aud_mg_leaves_true" );
    ObjAnimate( "spr_storeroom_light_"..num, 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
    ObjAnimate( "spr_storeroom_light_small_"..num, 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
  end
  for i =  ng_global.progress[ "std" ][ "win_clovers" ].state + 1, 5 do
    ld.StartTimer( time, function() obj_animate_light(win_clk[i]) end );
    time = time + 0.5;
  end
  ld.StartTimer( time + 1, function() func_end(); end )
end

function public.win_clovers_reset()
  ld.Lock(1);
  if ng_global.progress[ "std" ][ "win_clovers" ].state then
    ng_global.progress[ "std" ][ "win_clovers" ].state = 0;
  end  
  for i = 1,5 do
     ObjSet( "spr_storeroom_light_"..i, {input = 1} );
     ObjAnimate( "spr_storeroom_light_"..i, 8, 0, 0, function() end, {0,0,ObjGet("spr_storeroom_light_"..i).alp, 0.5,0,0} );
     ObjAnimate( "spr_storeroom_light_small_"..i, 8, 0, 0, function() end, {0,0,ObjGet("spr_storeroom_light_small_"..i).alp, 0.5,0,0} );  
  end
  ld.StartTimer( 0.5, function() ld.Lock(0); public.win_clovers_load(); end )
end

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_barrels *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_barrel3" ] = { type = "get", get_obj = "spr_barrels_barrel3", room = "rm_pub", zz = "zz_barrels", zz_gate = "gzz_pub_barrels" };

private.get_barrel3_logic = function()
  
end;
private.get_barrel3_inv = function()
  interface.InventoryItemAdd("inv_barrel","spr_barrels_barrel3",function() level_inv.ProcessGetBarrelAll( "get_barrel3" ) end);
end;
private.get_barrel3_beg = function()
  ObjDelete("gfx_barrels_barrel3")
end;
private.get_barrel3_end = function()
  if common_impl.ZzCompleteCheck("get_barrel3") then ObjSet( common_impl.hint["get_barrel3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barrels_sh_barrel");
  ObjDelete("spr_pub_barrel");
end;

cmn.AddSubscriber( "get_barrel3", private.get_barrel3_inv );
cmn.AddSubscriber( "get_barrel3", private.get_barrel3_beg, private.room_objname );
cmn.AddSubscriber( "get_barrel3", private.get_barrel3_end, private.room_objname );
cmn.AddSubscriber( "get_barrel3", private.get_barrel3_logic );
--------------------------------------------------------------------
function public.get_barrel3()
  cmn.SetEventDone( "get_barrel3" );
  cmn.CallEventHandler( "get_barrel3" );
  if common_impl.ZzCompleteCheck("get_barrel3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_axe_zone()

  local func_end = function()
    common_impl.ShowBbt( 'need_axe' );
    ld.Lock(0);
  end;
  ld.Lock(1);
  ld.AnimPlay( "anm_barrels_anm", "idle_box", func_end );
  SoundSfx( "aud_touch_box_pub" );
end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_axe" ] = { type = "use", inv_obj = "inv_axe", use_place = "gfx_barrels_axe_zone", room = "rm_pub", zz = "zz_barrels", zz_gate = "gzz_pub_barrels" };

private.use_axe_logic = function()
  --ObjSet( "gfx_barrels_clk_barrelsho_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "obj_barrels_ho_root", { visible = 1, input = 1, alp = 1 } )
end;
private.use_axe_inv = function()
  common_impl.ProcessMultiUseAll("axe", "axe")
end;
private.use_axe_beg = function()
  ObjDelete( "gfx_barrels_axe_zone" );
end;
private.use_axe_end = function()
  if common_impl.ZzCompleteCheck("use_axe") then ObjSet( common_impl.hint["use_axe"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_barrels_anm", {animfunc = "end_mho", frame = 0 } );
  ObjSet( "spr_pub_box_tr", {visible = 1} );
  ObjDelete("spr_pub_box_cover");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_axe", private.use_axe_inv );
cmn.AddSubscriber( "use_axe", private.use_axe_beg, private.room_objname );
cmn.AddSubscriber( "use_axe", private.use_axe_end, private.room_objname );
cmn.AddSubscriber( "use_axe", private.use_axe_logic );
cmn.AddSubscriber( "use_axe_inv", private.use_axe_inv, private.room_objname );
cmn.AddSubscriber( "use_axe_beg", private.use_axe_beg, private.room_objname );
cmn.AddSubscriber( "use_axe_end", private.use_axe_end, private.room_objname );
cmn.AddSubscriber( "use_axe_end", private.use_axe_logic );
--------------------------------------------------------------------------------------------
function public.use_axe( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_axe" );
    cmn.CallEventHandler( "use_axe_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_axe") then ld.CloseSubRoom() end;
    private.win_barrels_gm.task_panel_show()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_axe_inv" );
  cmn.CallEventHandler( "use_axe_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_barrels_anm", "us_ax", func_end );
  SoundSfx( "aud_use_axe_pub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_barrelsho" ] = { type = "click", use_place = "gfx_barrels_clk_barrelsho_zone", room = "rm_pub", zz = "zz_barrels", zz_gate = "gzz_pub_barrels" };
--
--private.clk_barrelsho_logic = function()
--  --ObjSet( "spr_barrels_ladle", { visible = 1, input = 1, active = 1 } )
--
--end;
--private.clk_barrelsho_beg = function()
--  ObjDelete( "gfx_barrels_clk_barrelsho_zone" );
--end;
--private.clk_barrelsho_end = function()
--  if common_impl.ZzCompleteCheck("clk_barrelsho") then ObjSet( common_impl.hint["clk_barrelsho"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_barrelsho", private.clk_barrelsho_beg, private.room_objname );
--cmn.AddSubscriber( "clk_barrelsho", private.clk_barrelsho_end, private.room_objname );
--cmn.AddSubscriber( "clk_barrelsho", private.clk_barrelsho_logic );
--cmn.AddSubscriber( "clk_barrelsho_beg", private.clk_barrelsho_beg, private.room_objname );
--cmn.AddSubscriber( "clk_barrelsho_end", private.clk_barrelsho_end, private.room_objname );
--cmn.AddSubscriber( "clk_barrelsho_end", private.clk_barrelsho_logic );
----------------------------------------------------------------------------------------------
--function public.clk_barrelsho()
--  
--  ld.LogTrace( "clk_barrelsho" );
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_barrelsho" );
--    cmn.CallEventHandler( "clk_barrelsho_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("clk_barrelsho") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "clk_barrelsho_beg" );
--  common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  --SoundSfx( 0 )
--  func_end()
--
--end;
--
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
private.win_barrels_hint = function() 
  local gm = private.win_barrels_gm;
  for i = 1, #gm.tasks do
    for j = 1, #gm.tasks[i] do
      if not ng_global.progress["std"]["win_barrels"].state.find[ gm.tasks[i][j] ] then
        common_impl.HintShowAnm( "spr_barrels_"..gm.tasks[i][j] )
        return
      end;
    end
  end
end

common_impl.hint[ "win_barrels" ] = { type = "click", use_place = "obj_barrels_ho_root", room = "rm_pub", zz = "zz_barrels", zz_gate = "gzz_pub_barrels", hint = private.win_barrels_hint };

private.win_barrels_logic = function()
  interface.InventoryItemAdd("inv_ladle","spr_barrels_ladle");
  
end;
private.win_barrels_beg = function()
  --ObjDelete( "obj_barrels_ho_root" );
  ObjSet( "spr_barrels_ladle", { visible = 1, input = 1  } )
  
end;
private.win_barrels_end = function()
  if common_impl.ZzCompleteCheck("win_barrels") then ObjSet( common_impl.hint["win_barrels"].zz_gate, { visible = 0, input = 0 } ); end;
 
  if  ( cmn.IsEventDone( "win_barrels" ) ) then
    ObjDelete("spr_pub_rabbit_tr");
    ObjDelete("spr_pub_sleighbell_tr");
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_barrels", private.win_barrels_beg, private.room_objname );
cmn.AddSubscriber( "win_barrels", private.win_barrels_end, private.room_objname );
cmn.AddSubscriber( "win_barrels", private.win_barrels_logic );
cmn.AddSubscriber( "win_barrels_beg", private.win_barrels_beg, private.room_objname );
cmn.AddSubscriber( "win_barrels_end", private.win_barrels_end, private.room_objname );
cmn.AddSubscriber( "win_barrels_end", private.win_barrels_logic );
--------------------------------------------------------------------------------------------
function public.win_barrels()

  local func_end = function()
    cmn.SetEventDone( "win_barrels" );
    cmn.CallEventHandler( "win_barrels_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_barrels") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_barrels_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;

function private.win_barrels_load()
  if not private.win_barrels_gm then
    private.win_barrels_gm = {}
    local gm = private.win_barrels_gm;

    gm.tasks = {
      {"mask","pendant","ladleho","sleighbell","rabbit","bow"};
    }

    function gm.save()
      ng_global.progress["std"]["win_barrels"].state = ld.TableCopy( gm.state )
    end;

    gm.state = {}

    if ld.CheckRequirements( { "win_barrels" } ) then
      ng_global.progress["std"]["win_barrels"].state = {}
      ng_global.progress["std"]["win_barrels"].state.lvl = 1
      ng_global.progress["std"]["win_barrels"].state.find = {}
      for i = 1, #gm.tasks do
        for j = 1, #gm.tasks[i] do
          ng_global.progress["std"]["win_barrels"].state.find[ gm.tasks[i][j] ] = true;
        end
      end
    end

    if not ng_global.progress["std"]["win_barrels"].state then
      gm.state.lvl = 1
      gm.state.find = {}
      gm.save()
    else
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_barrels"].state )
      
    end;

    function gm.task_find( task )
      local o = ObjGet( "txt_barrels_task_"..ld.TableContains( gm.tasks[gm.state.lvl], task, true ) )
      local clr = int_taskpanel_impl.GetTaskCompletedColors()
      ObjAnimate( o.name, 12,0,0, _, { 0,0,o.color_r,o.color_g,o.color_b, 0.35,0,clr.color_r,clr.color_g,clr.color_b } )

      common_impl.FxAnmObj( "spr_barrels_"..task )

    end;

    function gm.task_panel_show( func )
      ObjAttach( "spr_barrels_task_panel", "int_frame_subroom_impl" )
      ObjSet( "spr_barrels_task_panel", { alp = 0, pos_y = 225 } )
      ObjAnimate( "spr_barrels_task_panel", 8,0,0, func, { 0,0,0, 0.35,0,1 } )
    end

    function gm.task_panel_hide( func )
      ObjAnimate( "spr_barrels_task_panel", 8,0,0, function() 
        ObjDetach( "spr_barrels_task_panel" )
        if func then
          func()
        end;
      end, { 0,0,1, 0.35,0,0 } )
    end

    function gm.task_panel_hide_fast()
      ObjDetach( "spr_barrels_task_panel" )
    end
      
    function gm.event_mdown( task )
      gm.state.find[ task ] = true

      gm.task_find( task )

      local win = true
      for i = 1, #gm.tasks[gm.state.lvl] do
        if not gm.state.find[gm.tasks[ gm.state.lvl][i] ] then
          win = false
          break
        end;
      end;
      
      if win then
        if gm.state.lvl == #gm.tasks then
          gm.task_panel_hide()
          ld.CloseSubRoom()
          ObjDelete( "gfx_barrels_ladle" )
          --     SoundSfx( "aud_ho_win" )
          int_dialog_ho.Show( "spr_barrels_ladle" )
          --int_dialog_ho.Show( "spr_barrels_cone" )
          cmn.SetEventDone( "win_barrels" );
          --public.win_barrels()

        else
          gm.state.lvl = gm.state.lvl + 1
          gm.task_panel_hide( function() 
            gm.restore()
            gm.task_panel_show()
          end )
        end;
      end;
      gm.save()
    end;

    function gm.restore()
      for i = 1, #gm.tasks do
        for j = 1, #gm.tasks[i] do
          local input = true;
          if input then
            input = i == gm.state.lvl
          end;
          if input then
            ObjSet( "txt_barrels_task_"..j, { text = "tsk_barrels_"..gm.tasks[i][j] } )
            input = not gm.state.find[ gm.tasks[i][j] ]

            local o = ObjGet( "txt_barrels_task_"..j )
            local clr = input and int_taskpanel_impl.GetTaskColors() or int_taskpanel_impl.GetTaskCompletedColors()
            ObjAnimate( o.name, 12,0,0, _, { 0,0,o.color_r,o.color_g,o.color_b, 0.35,0,clr.color_r,clr.color_g,clr.color_b } )
          end;
          ObjSet( "spr_barrels_"..gm.tasks[i][j], { 
            event_mdown = function() gm.event_mdown( gm.tasks[i][j] ); end;
            input = input;
            alp = gm.state.find[ gm.tasks[i][j] ] and 0 or 1;
          } )
        end;
      end;
    end;
    gm.restore();

  end

  if ld.CheckRequirements( { "use_axe" } )  then
    private.win_barrels_gm.task_panel_show()
  end;

end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
--common_impl.hint[ "get_ladle" ] = { type = "get", get_obj = "spr_barrels_ladle", room = "rm_pub", zz = "zz_barrels", zz_gate = "gzz_pub_barrels" };

--private.get_ladle_logic = function()
  
--end;
--private.get_ladle_inv = function()
  --  interface.InventoryItemAdd("inv_ladle","spr_barrels_ladle");
--end;
--private.get_ladle_beg = function()
  --  ObjDelete("gfx_barrels_ladle")
--end;
--private.get_ladle_end = function()
  -- if common_impl.ZzCompleteCheck("get_ladle") then ObjSet( common_impl.hint["get_ladle"].zz_gate, { visible = 0, input = 0 } ); end;
--end;

--cmn.AddSubscriber( "get_ladle", private.get_ladle_inv );
--cmn.AddSubscriber( "get_ladle", private.get_ladle_beg, private.room_objname );
--cmn.AddSubscriber( "get_ladle", private.get_ladle_end, private.room_objname );
--cmn.AddSubscriber( "get_ladle", private.get_ladle_logic );
--------------------------------------------------------------------
--function public.get_ladle()
  --  cmn.SetEventDone( "get_ladle" );
  --  cmn.CallEventHandler( "get_ladle" );
  --  if common_impl.ZzCompleteCheck("get_ladle") then ld.CloseSubRoom() end;
  --end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_windowhole *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_box" ] = { type = "click", use_place = "gfx_windowhole_clk_box_zone", room = "rm_pub", zz = "zz_windowhole", zz_gate = "gzz_pub_windowhole" };

private.clk_box_logic = function()
  ObjSet( "spr_windowhole_esdoornblad", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_windowhole_scarf", { visible = 1, input = 1, active = 1 } )

end;
private.clk_box_beg = function()
  ObjDelete( "gfx_windowhole_clk_box_zone" );
end;
private.clk_box_end = function()
  if common_impl.ZzCompleteCheck("clk_box") then ObjSet( common_impl.hint["clk_box"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_windowhole_anm_ring", {animfunc = "end_ring", frame = 0 } );
  ObjSet( "spr_windowhole_tr_box", {visible = 1} );
  ObjSet( "spr_windowhole_sh_scarf", {visible = 1} );
  ObjSet( "spr_pub_chest", {visible = 1} );
  ObjDelete("spr_pub_chest2");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_box", private.clk_box_beg, private.room_objname );
cmn.AddSubscriber( "clk_box", private.clk_box_end, private.room_objname );
cmn.AddSubscriber( "clk_box", private.clk_box_logic );
cmn.AddSubscriber( "clk_box_beg", private.clk_box_beg, private.room_objname );
cmn.AddSubscriber( "clk_box_end", private.clk_box_end, private.room_objname );
cmn.AddSubscriber( "clk_box_end", private.clk_box_logic );
--------------------------------------------------------------------------------------------
function public.clk_box()

  local func_end = function()
    cmn.SetEventDone( "clk_box" );
    cmn.CallEventHandler( "clk_box_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_box") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_box_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_windowhole_anm_ring", "open_cover", func_end );
  SoundSfx( "aud_touch_basket_pub" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_esdoornblad" ] = { type = "get", get_obj = "spr_windowhole_esdoornblad", room = "rm_pub", zz = "zz_windowhole", zz_gate = "gzz_pub_windowhole" };

private.get_esdoornblad_logic = function()
  
end;
private.get_esdoornblad_inv = function()
  interface.InventoryItemAdd("inv_esdoornblad","spr_windowhole_esdoornblad");
end;
private.get_esdoornblad_beg = function()
  ObjDelete("gfx_windowhole_esdoornblad")
end;
private.get_esdoornblad_end = function()
  if common_impl.ZzCompleteCheck("get_esdoornblad") then ObjSet( common_impl.hint["get_esdoornblad"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_esdoornblad", private.get_esdoornblad_inv );
cmn.AddSubscriber( "get_esdoornblad", private.get_esdoornblad_beg, private.room_objname );
cmn.AddSubscriber( "get_esdoornblad", private.get_esdoornblad_end, private.room_objname );
cmn.AddSubscriber( "get_esdoornblad", private.get_esdoornblad_logic );
--------------------------------------------------------------------
function public.get_esdoornblad()
  cmn.SetEventDone( "get_esdoornblad" );
  cmn.CallEventHandler( "get_esdoornblad" );
  if common_impl.ZzCompleteCheck("get_esdoornblad") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scarf" ] = { type = "get", get_obj = "spr_windowhole_scarf", room = "rm_pub", zz = "zz_windowhole", zz_gate = "gzz_pub_windowhole" };

private.get_scarf_logic = function()
  
end;
private.get_scarf_inv = function()
  interface.InventoryItemAdd("inv_scarf","spr_windowhole_scarf");
end;
private.get_scarf_beg = function()
  ObjDelete("gfx_windowhole_scarf")
end;
private.get_scarf_end = function()
  if common_impl.ZzCompleteCheck("get_scarf") then ObjSet( common_impl.hint["get_scarf"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_windowhole_sh_scarf");
end;

cmn.AddSubscriber( "get_scarf", private.get_scarf_inv );
cmn.AddSubscriber( "get_scarf", private.get_scarf_beg, private.room_objname );
cmn.AddSubscriber( "get_scarf", private.get_scarf_end, private.room_objname );
cmn.AddSubscriber( "get_scarf", private.get_scarf_logic );
--------------------------------------------------------------------
function public.get_scarf()
  cmn.SetEventDone( "get_scarf" );
  cmn.CallEventHandler( "get_scarf" );
  if common_impl.ZzCompleteCheck("get_scarf") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_window" ] = { type = "click", use_place = "gfx_windowhole_clk_window_zone", room = "rm_pub", zz = "zz_windowhole", zz_gate = "gzz_pub_windowhole" };

private.clk_window_logic = function()
  ObjSet( "gfx_windowhole_barrel_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_window_beg = function()
  ObjDelete( "gfx_windowhole_clk_window_zone" );
end;
private.clk_window_end = function()
  if common_impl.ZzCompleteCheck("clk_window") then ObjSet( common_impl.hint["clk_window"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_windowhole_anm_barrel", {animfunc = "default2", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_window", private.clk_window_beg, private.room_objname );
cmn.AddSubscriber( "clk_window", private.clk_window_end, private.room_objname );
cmn.AddSubscriber( "clk_window", private.clk_window_logic );
cmn.AddSubscriber( "clk_window_beg", private.clk_window_beg, private.room_objname );
cmn.AddSubscriber( "clk_window_end", private.clk_window_end, private.room_objname );
cmn.AddSubscriber( "clk_window_end", private.clk_window_logic );
--------------------------------------------------------------------------------------------
function public.clk_window()

  local func_end = function()
    cmn.SetEventDone( "clk_window" );
    cmn.CallEventHandler( "clk_window_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_window") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_window_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_windowhole_anm_barrel", "cklik_bolt", func_end );
  SoundSfx( "aud_touch_latch_pub" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_barrel" ] = { type = "use", inv_obj = "inv_barrel", use_place = "gfx_windowhole_barrel_zone", room = "rm_pub", zz = "zz_windowhole", zz_gate = "gzz_pub_windowhole" };

private.use_barrel_logic = function()
  ObjSet( "gfx_pub_pubkey_pub_zone", {active = 1, visible = 1, input = 1} );
  ObjSet( "grm_pub_nearpub2", {active=0, visible=0, input=0} );
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_pub_nearpub2_focus");
    end;
end;
private.use_barrel_inv = function()
  common_impl.ProcessMultiUseAll("barrel", "barrel")
end;
private.use_barrel_beg = function()
  ObjDelete( "gfx_windowhole_barrel_zone" );
end;
private.use_barrel_end = function()
  if common_impl.ZzCompleteCheck("use_barrel") then ObjSet( common_impl.hint["use_barrel"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_windowhole_anm_barrel", {animfunc = "default2", frame =999 } );
  ObjSet( "spr_pub_barell_b", {active=1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_barrel", private.use_barrel_inv );
cmn.AddSubscriber( "use_barrel", private.use_barrel_beg, private.room_objname );
cmn.AddSubscriber( "use_barrel", private.use_barrel_end, private.room_objname );
cmn.AddSubscriber( "use_barrel", private.use_barrel_logic );
cmn.AddSubscriber( "use_barrel_inv", private.use_barrel_inv, private.room_objname );
cmn.AddSubscriber( "use_barrel_beg", private.use_barrel_beg, private.room_objname );
cmn.AddSubscriber( "use_barrel_end", private.use_barrel_end, private.room_objname );
cmn.AddSubscriber( "use_barrel_end", private.use_barrel_logic );
--------------------------------------------------------------------------------------------
function public.use_barrel( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_barrel" );
    cmn.CallEventHandler( "use_barrel_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_barrel") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_barrel_inv" );
  cmn.CallEventHandler( "use_barrel_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_windowhole_anm_barrel", "default2", func_end );
  SoundSfx( "aud_use_barrels" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_pantry_for_pub = function()
    if ld.CheckRequirements( {"win_pantry"} ) then
      ObjSet( "gho_pub_pantry", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_pantry", win_pantry_for_pub, private.room_objname )
  
  function public.Skip()
    ld.LogTrace( "Skip" );
    local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

    if ( mg_name == "zz_bar" ) and not ld.CheckRequirements( { "win_seasonings" } ) then
      ld.Lock(1); 
      if ng_global.progress[ "std" ][ "win_seasonings" ].state then
        ng_global.progress[ "std" ][ "win_seasonings" ].state = {1,2,3,4,5,6,7};
      end 
      SoundSfx( "aud_mg_bar_move" );
      for i = 1,7 do
        ObjSet( "spr_bar_lig"..i, {alp = 0} );
        ObjAnimate( "spr_bar_label"..ng_global.progress[ "std" ][ "win_seasonings" ].state[i], 3, 0, 0, function()  end, {0,0,ObjGet("spr_bar_label"..ng_global.progress[ "std" ][ "win_seasonings" ].state[i]).pos_x, ObjGet("spr_bar_label"..ng_global.progress[ "std" ][ "win_seasonings" ].state[i]).pos_y, 0.5,0,obj_pos[i][1],obj_pos[i][2]} );
      end    
      SoundSfx( "aud_mg_bar_set" );
      ld.StartTimer( 0.5, function() public.win_seasonings_skip(); end ) 
    end;
      
    if ( mg_name == "zz_storeroom" ) and not ld.CheckRequirements( { "win_clovers" } ) then
      ld.Lock(1); 
      public.win_clovers_skip(); 
    end;

end;
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_bar" ) and not ld.CheckRequirements( { "win_seasonings" } ) then  
    ld.Lock(1);    
    public.win_seasonings_reset();
  end;
  if ( mg_name == "zz_storeroom" ) and not ld.CheckRequirements( { "win_clovers" } ) then  
    public.win_clovers_reset();
  end;

end;
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_pub();
end;
--*********************************************************************************************************************
--local vid_pub_elizabeth_root =  {"vid_pub_vid_elizabeth_51"};
function public.PreOpen()
  SoundEnv( "aud_pub_env" );
  if not private.VidStaticInit_elizabeth and not ld.CheckRequirements({"clk_raid"}) then
    private.VidStaticInit_elizabeth = true
    private.vid_pub_elizabeth_root =  {"vid_pub_vid_elizabeth_51"};
    --ObjAttach()
    ld.VidStaticInit( 
         private.vid_pub_elizabeth_root,                                                        --оъект видео
        { "rm_pub", "zz_windowhole", "zz_barrels", "zz_storeroom","zz_bar"}, --к чему относится объект
        {false},        --SFX
        { 7, 10 },                                                                            --рандом запуска от до
        false,                                                              --прогрес по которому статика будет играть
        {"clk_raid"},      --прогресс по которому статика перестаёт играть  
        "rm_pub"
    );
    ld.VidStaticPlay( private.vid_pub_elizabeth_root)
  end;  
  if not private.VidStaticInit_william and not ld.CheckRequirements({"dlg_pub_william4"}) then
    private.VidStaticInit_william = true
    private.vid_pub_william_root =  {"vid_pub_vid_william_51"};
    --ObjAttach()
    ld.VidStaticInit( 
         private.vid_pub_william_root,                                                        --оъект видео
        { "rm_pub", "zz_windowhole", "zz_barrels", "zz_storeroom","zz_bar"}, --к чему относится объект
        {false},        --SFX
        { 3, 7 },                                                                            --рандом запуска от до
        false,                                                              --прогрес по которому статика будет играть
        {"dlg_pub_william4"},      --прогресс по которому статика перестаёт играть  
        "rm_pub"
    );
    ld.VidStaticPlay( private.vid_pub_william_root)
  end;  
  
  if ld.CheckRequirements({"use_pubkey_pub"}) and not ld.CheckRequirements({"clk_raid"}) then
    interface.WidgetSetInput( InterfaceWidget_BtnMap, false );
  end
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_windowhole" );
  function zz_windowhole.Open()
  end;
  function zz_windowhole.PreOpen()
  end;
  function zz_windowhole.PreClose()
  end;
  function zz_windowhole.Close()
  end;

  subroom.Define( "zz_barrels" );
  function zz_barrels.Open()
  end;
  function zz_barrels.PreOpen()
    private.win_barrels_load()
  end;
  function zz_barrels.PreClose()
  end;
  function zz_barrels.Close()
    if ld.CheckRequirements( { "use_axe" } )  then
      ObjDetach( "spr_barrels_task_panel" )
    end;

  end;

  subroom.Define( "zz_storeroom" );
  function zz_storeroom.Open()
    if ld.CheckRequirements( {"use_esdoornblad","use_clover"} ) and not ld.CheckRequirements( {"win_clovers"} ) then
      cmn.MiniGameShow( "clovers" );
    end
  end;
  function zz_storeroom.PreOpen()
    if  not cmn.IsEventDone( "win_clovers" )  and cmn.IsEventStart( "win_clovers" ) and cmn.IsEventDone( "use_esdoornblad" ) and cmn.IsEventDone( "use_clover" ) then
      public.win_clovers_load(1);   
    end
  end;
  function zz_storeroom.PreClose()
    if ld.CheckRequirements( {"use_esdoornblad","use_clover"} ) and not ld.CheckRequirements( {"win_clovers"} ) then
      cmn.MiniGameHide( "clovers" );
    end
  end;
  function zz_storeroom.Close()
  end;

  subroom.Define( "zz_bar" );
  function zz_bar.Open()
    if ld.CheckRequirements( {"use_saltcellar"} ) and not ld.CheckRequirements( {"win_seasonings"} ) then
      cmn.MiniGameShow( "seasonings" );
    end
  end;
  function zz_bar.PreOpen()
    if  not cmn.IsEventDone( "win_seasonings" )  and cmn.IsEventStart( "win_seasonings" ) and cmn.IsEventDone( "use_saltcellar" ) then
       public.win_seasonings_load(1);   
    end
  end;
  function zz_bar.PreClose()
    if ld.CheckRequirements( {"use_saltcellar"} ) and not ld.CheckRequirements( {"win_seasonings"} ) then
      cmn.MiniGameHide( "seasonings" );
    end
  end;
  function zz_bar.Close()
  end;
  
end;
--*********************************************************************************************************************
--OTHER function
function public.pub_grm_nearpub_menter()
   ObjSet( "grm_pub_nearpub_focus", {visible = 0} );
     if port.isPortable() == 1 then
       port.GrmEventLightOff("grm_pub_nearpub_focus");
    end;
--   ObjSet( "grm_pub_nearpub2_focus", {alp=1} );
   local o = ObjGet( "grm_pub_nearpub2_focus" )
   ObjAnimate( "grm_pub_nearpub2_focus", 8,0,0, "", { 0,0,o.alp, (1-o.alp)/3,0,1 } )
end;
 
function public.pub_grm_nearpub_mleave()
    
    --   ObjSet( "grm_pub_nearpub2_focus", {alp=0} );
    local o = ObjGet( "grm_pub_nearpub2_focus" )
    ObjAnimate( "grm_pub_nearpub2_focus", 8,0,0, function() 
      ObjSet( "grm_pub_nearpub_focus", {visible = 1} );   
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_pub_nearpub_focus");
      end;
    end, { 0,0,o.alp, (o.alp)/3,0,0 } ) 
end;
  
-------------------------clk anims 
function public.pub_clk_anim(num)
  local func_end = function()
    ObjSet( "obj_pub_anm_click_"..num.."_zone", {input = 1} );
  end;
  
  SoundSfx( "aud_touch_herbs" );
  ObjSet( "obj_pub_anm_click_"..num.."_zone", {input = 0} );
  ld.AnimPlay( "anm_pub_anm_cklick_"..num, "cklick_"..num, func_end )
end;  
 