-- name=rm_ruralhouse
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_ruralhouse";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  private.ruralhouse_shelves_paper_voice = false;
  private.ruralhouse_shelves_paper_voice_func = function()
      if not private.ruralhouse_shelves_paper_voice then 
        --  ld.Lock(1); 
          ld.ShowBbt("ruralhouse_picture0");
          --  SoundVoice("aud_pc_4_voc");
          --  ld.StartTimer( 3, function() ld.Lock(0); end )
          private.ruralhouse_shelves_paper_voice = true;
          ld.Lock(0);
      else
          ld.ShowBbt( "ruralhouse_picture0" );ld.Lock( 0 )
      end;
  end;
  ld.NoteInit("spr_shelves_paper_small","spr_shelves_paper_big",  private.ruralhouse_shelves_paper_voice_func);
  --------------------------------------------------------------------------------------------
  
function private.opn_ruralhouse()
  if not ( cmn.IsEventDone( "opn_ruralhouse" ) ) then
    cmn.SetEventDone( "opn_ruralhouse" );
    cmn.CallEventHandler( "opn_ruralhouse" )
    ld.ShowBbt("opn_ruralhouse")
    SoundTheme( "aud_adventure1_mus" );
  end;
end;
--------------------------------------------------------------------
local opn_ruralhouse = function() end;
local opn_ruralhouse_logic = function() end;
cmn.AddSubscriber( "opn_ruralhouse", opn_ruralhouse_logic )
cmn.AddSubscriber( "opn_ruralhouse", opn_ruralhouse, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------
--------------------------------------------------------------------
function public.umbrella_clk()
 local func_end = function()
    ObjSet( "obj_unbrella_clk_zone", {input = 1} );
  end;
  ObjSet( "obj_unbrella_clk_zone", {input = 0} );
  SoundSfx( "aud_touch_umbrella_ruralhouse" );
  ld.AnimPlay( "anm_ruralhouse_anim_umbrella", "anim_umbrella", func_end );
end;

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bed *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_thread" ] = { type = "get", get_obj = "spr_bed_thread", room = "rm_ruralhouse", zz = "zz_bed", zz_gate = "gzz_ruralhouse_bed" };

private.get_thread_logic = function()
  
end;
private.get_thread_inv = function()
  interface.InventoryItemAdd("inv_thread","spr_bed_thread");
end;
private.get_thread_beg = function()
  ObjDelete("gfx_bed_thread")
end;
private.get_thread_end = function()
  if common_impl.ZzCompleteCheck("get_thread") then ObjSet( common_impl.hint["get_thread"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_bed_sh_thread");
  ObjDelete("spr_ruralhouse_tr_thread");
end;

cmn.AddSubscriber( "get_thread", private.get_thread_inv );
cmn.AddSubscriber( "get_thread", private.get_thread_beg, private.room_objname );
cmn.AddSubscriber( "get_thread", private.get_thread_end, private.room_objname );
cmn.AddSubscriber( "get_thread", private.get_thread_logic );
--------------------------------------------------------------------
function public.get_thread()
  cmn.SetEventDone( "get_thread" );
  cmn.CallEventHandler( "get_thread" );
  if common_impl.ZzCompleteCheck("get_thread") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_brokenbagpipe" ] = { type = "get", get_obj = "spr_bed_brokenbagpipe", room = "rm_ruralhouse", zz = "zz_bed", zz_gate = "gzz_ruralhouse_bed" };

private.get_brokenbagpipe_logic = function()
  
end;
private.get_brokenbagpipe_inv = function()
  interface.InventoryItemAdd("inv_brokenbagpipe","spr_bed_brokenbagpipe");
  ObjSet( "inv_brokenbagpipe", { drag = 0 } );
end;
private.get_brokenbagpipe_beg = function()
  ObjDelete("gfx_bed_brokenbagpipe")
end;
private.get_brokenbagpipe_end = function()
  if common_impl.ZzCompleteCheck("get_brokenbagpipe") then ObjSet( common_impl.hint["get_brokenbagpipe"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_bed_anm");
  ObjDelete("spr_ruralhouse_tr_brokenbagpipe");
end;

cmn.AddSubscriber( "get_brokenbagpipe", private.get_brokenbagpipe_inv );
cmn.AddSubscriber( "get_brokenbagpipe", private.get_brokenbagpipe_beg, private.room_objname );
cmn.AddSubscriber( "get_brokenbagpipe", private.get_brokenbagpipe_end, private.room_objname );
cmn.AddSubscriber( "get_brokenbagpipe", private.get_brokenbagpipe_logic );
--------------------------------------------------------------------
function public.get_brokenbagpipe()
  ObjSet( "spr_bed_brokenbagpipe", {visible = 1} );
  cmn.SetEventDone( "get_brokenbagpipe" );
  cmn.CallEventHandler( "get_brokenbagpipe" );
  if common_impl.ZzCompleteCheck("get_brokenbagpipe") then ld.CloseSubRoom() end;
end

--------------------------------------------------------------------
--------------------------------------------------------------------

function public.idle_clk()
  local func_end = function()
    ObjSet( "obj_bed_idle_clk_zone", {input = 1} );
    ObjSet( "obj_bed_idle1_clk_zone", {input = 1} ); 
  end;
  ObjSet( "obj_bed_idle_clk_zone", {input = 0} );
  ObjSet( "obj_bed_idle1_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_bed_anm_idle", "idle", func_end );
  SoundSfx( "aud_touch_pillow_bed" )
end;

function public.idle1_clk()
  local func_end = function()
    ObjSet( "obj_bed_idle_clk_zone", {input = 1} );
    ObjSet( "obj_bed_idle1_clk_zone", {input = 1} ); 
  end;
  ObjSet( "obj_bed_idle_clk_zone", {input = 0} );
  ObjSet( "obj_bed_idle1_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_bed_anm_idle", "idle1", func_end );
  SoundSfx( "aud_touch_pillow_bed" )
end;
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_distaff *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_knittingneedles" ] = { type = "get", get_obj = "spr_distaff_knittingneedles", room = "rm_ruralhouse", zz = "zz_distaff", zz_gate = "gzz_ruralhouse_distaff" };

private.get_knittingneedles_logic = function()
  
end;
private.get_knittingneedles_inv = function()
  interface.InventoryItemAdd("inv_knittingneedles","spr_distaff_knittingneedles");
end;
private.get_knittingneedles_beg = function()
  ObjDelete("gfx_distaff_knittingneedles")
end;
private.get_knittingneedles_end = function()
  if common_impl.ZzCompleteCheck("get_knittingneedles") then ObjSet( common_impl.hint["get_knittingneedles"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_ruralhouse_tr_knittingneedles");
end;

cmn.AddSubscriber( "get_knittingneedles", private.get_knittingneedles_inv );
cmn.AddSubscriber( "get_knittingneedles", private.get_knittingneedles_beg, private.room_objname );
cmn.AddSubscriber( "get_knittingneedles", private.get_knittingneedles_end, private.room_objname );
cmn.AddSubscriber( "get_knittingneedles", private.get_knittingneedles_logic );
--------------------------------------------------------------------
function public.get_knittingneedles()
  cmn.SetEventDone( "get_knittingneedles" );
  cmn.CallEventHandler( "get_knittingneedles" );
  if common_impl.ZzCompleteCheck("get_knittingneedles") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wheeldistaff" ] = { type = "use", inv_obj = "inv_wheeldistaff", use_place = "gfx_distaff_wheeldistaff_zone", room = "rm_ruralhouse", zz = "zz_distaff", zz_gate = "gzz_ruralhouse_distaff" };

private.use_wheeldistaff_logic = function()
    ObjSet( "gfx_distaff_wool_zone", { visible = 1, input = 1 } );
end;
private.use_wheeldistaff_inv = function()
  common_impl.ProcessMultiUseAll("wheeldistaff", "wheeldistaff")
end;
private.use_wheeldistaff_beg = function()
  ObjDelete( "gfx_distaff_wheeldistaff_zone" );
end;
private.use_wheeldistaff_end = function()
  if common_impl.ZzCompleteCheck("use_wheeldistaff") then ObjSet( common_impl.hint["use_wheeldistaff"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_distaff_anm", {animfunc = "clik_wheel1", frame = 0 } );
  ObjSet( "spr_ruralhouse_tr_wheel", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wheeldistaff", private.use_wheeldistaff_inv );
cmn.AddSubscriber( "use_wheeldistaff", private.use_wheeldistaff_beg, private.room_objname );
cmn.AddSubscriber( "use_wheeldistaff", private.use_wheeldistaff_end, private.room_objname );
cmn.AddSubscriber( "use_wheeldistaff", private.use_wheeldistaff_logic );
cmn.AddSubscriber( "use_wheeldistaff_inv", private.use_wheeldistaff_inv, private.room_objname );
cmn.AddSubscriber( "use_wheeldistaff_beg", private.use_wheeldistaff_beg, private.room_objname );
cmn.AddSubscriber( "use_wheeldistaff_end", private.use_wheeldistaff_end, private.room_objname );
cmn.AddSubscriber( "use_wheeldistaff_end", private.use_wheeldistaff_logic );
--------------------------------------------------------------------------------------------
function public.use_wheeldistaff( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wheeldistaff" );
    cmn.CallEventHandler( "use_wheeldistaff_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wheeldistaff") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wheeldistaff_inv" );
  cmn.CallEventHandler( "use_wheeldistaff_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_distaff_anm", "use_wheel", func_end );
  SoundSfx( "aud_use_wheel_distaff" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_wheeldistaff()

  local func_end = function()
    common_impl.ShowBbt( 'need_wool' );
    ld.Lock(0);
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_wheel_distaff" );
  ld.AnimPlay( "anm_distaff_anm", "clik_wheel1", func_end );
end;

--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wool" ] = { type = "use", inv_obj = "inv_wool", use_place = "gfx_distaff_wool_zone", room = "rm_ruralhouse", zz = "zz_distaff", zz_gate = "gzz_ruralhouse_distaff" };

private.use_wool_logic = function()
  ObjSet( "gfx_distaff_clk_wool_zone", { visible = 1, input = 1 } )
end;
private.use_wool_inv = function()
  common_impl.ProcessMultiUseAll("wool", "wool")
end;
private.use_wool_beg = function()
  ObjDelete( "gfx_distaff_wool_zone" );
end;
private.use_wool_end = function()
  if common_impl.ZzCompleteCheck("use_wool") then ObjSet( common_impl.hint["use_wool"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_distaff_anm", {animfunc = "use_yarn1", frame = 0 } );
  ObjSet( "spr_ruralhouse_tr_wool", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wool", private.use_wool_inv );
cmn.AddSubscriber( "use_wool", private.use_wool_beg, private.room_objname );
cmn.AddSubscriber( "use_wool", private.use_wool_end, private.room_objname );
cmn.AddSubscriber( "use_wool", private.use_wool_logic );
cmn.AddSubscriber( "use_wool_inv", private.use_wool_inv, private.room_objname );
cmn.AddSubscriber( "use_wool_beg", private.use_wool_beg, private.room_objname );
cmn.AddSubscriber( "use_wool_end", private.use_wool_end, private.room_objname );
cmn.AddSubscriber( "use_wool_end", private.use_wool_logic );
--------------------------------------------------------------------------------------------
function public.use_wool( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wool" );
    cmn.CallEventHandler( "use_wool_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wool") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wool_inv" );
  cmn.CallEventHandler( "use_wool_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_distaff_anm", "use_yarn", func_end );
  SoundSfx( "aud_use_wool_distaff" )
  --func_end()

end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_wool" ] = { type = "click", use_place = "gfx_distaff_clk_wool_zone", room = "rm_ruralhouse", zz = "zz_distaff", zz_gate = "gzz_ruralhouse_distaff"  };

private.clk_wool_logic = function()
  ObjSet( "spr_distaff_yarn", { input = 1 } )
end;
private.clk_wool_beg = function()
  ObjDelete( "gfx_distaff_clk_wool_zone" );
end;
private.clk_wool_end = function()
  if common_impl.ZzCompleteCheck("clk_wool") then ObjSet( common_impl.hint["clk_wool"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "gfx_distaff_yarn", {visible = 1} );  
  ObjSet( "anm_distaff_anm", {animfunc = "use_yarn1", frame = 999 } );
  ObjSet( "spr_ruralhouse_tr_yarn", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_wool", private.clk_wool_beg, private.room_objname );
cmn.AddSubscriber( "clk_wool", private.clk_wool_end, private.room_objname );
cmn.AddSubscriber( "clk_wool", private.clk_wool_logic );
cmn.AddSubscriber( "clk_wool_beg", private.clk_wool_beg, private.room_objname );
cmn.AddSubscriber( "clk_wool_end", private.clk_wool_end, private.room_objname );
cmn.AddSubscriber( "clk_wool_end", private.clk_wool_logic );
--------------------------------------------------------------------------------------------
function public.clk_wool()
  
  local func_end = function()
    cmn.SetEventDone( "clk_wool" );
    cmn.CallEventHandler( "clk_wool_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_wool") then ld.CloseSubRoom() end;
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "clk_wool_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_distaff_anm", "use_yarn1", func_end );
  SoundSfx( "aud_touch_distaff" );
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_yarn" ] = { type = "get", get_obj = "spr_distaff_yarn", room = "rm_ruralhouse", zz = "zz_distaff", zz_gate = "gzz_ruralhouse_distaff" };

private.get_yarn_logic = function()
  
end;
private.get_yarn_inv = function()
  interface.InventoryItemAdd("inv_yarn","spr_distaff_yarn");
end;
private.get_yarn_beg = function()
  ObjDelete("gfx_distaff_yarn")
end;
private.get_yarn_end = function()
  if common_impl.ZzCompleteCheck("get_yarn") then ObjSet( common_impl.hint["get_yarn"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_distaff_anm", {animfunc = "end_yarn", frame = 0 } );
  ObjDelete("spr_ruralhouse_tr_yarn");
end;

cmn.AddSubscriber( "get_yarn", private.get_yarn_inv );
cmn.AddSubscriber( "get_yarn", private.get_yarn_beg, private.room_objname );
cmn.AddSubscriber( "get_yarn", private.get_yarn_end, private.room_objname );
cmn.AddSubscriber( "get_yarn", private.get_yarn_logic );
--------------------------------------------------------------------
function public.get_yarn()
  ObjSet( "spr_distaff_yarn", {visible = 1} );
  cmn.SetEventDone( "get_yarn" );
  cmn.CallEventHandler( "get_yarn" );
  if common_impl.ZzCompleteCheck("get_yarn") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_shelves *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------

common_impl.hint[ "use_pearl" ] = { type = "use", inv_obj = "inv_pearl", use_place = "gfx_shelves_pearl_zone", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves" };

private.use_pearl_logic = function()
  ObjSet( "gfx_shelves_clk_pearldoor_zone", { visible = 1, input = 1 } )  
end;
private.use_pearl_inv = function()
  common_impl.ProcessMultiUseAll("pearl", "pearl")
end;
private.use_pearl_beg = function()
  ObjDelete( "gfx_shelves_pearl_zone" );
end;
private.use_pearl_end = function()
  if common_impl.ZzCompleteCheck("use_pearl") then ObjSet( common_impl.hint["use_pearl"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_shelves_anm_p", {animfunc = "open_door_p", frame = 0 } );
  ObjSet( "spr_ruralhouse_tr_pearl", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pearl", private.use_pearl_inv );
cmn.AddSubscriber( "use_pearl", private.use_pearl_beg, private.room_objname );
cmn.AddSubscriber( "use_pearl", private.use_pearl_end, private.room_objname );
cmn.AddSubscriber( "use_pearl", private.use_pearl_logic );
cmn.AddSubscriber( "use_pearl_inv", private.use_pearl_inv, private.room_objname );
cmn.AddSubscriber( "use_pearl_beg", private.use_pearl_beg, private.room_objname );
cmn.AddSubscriber( "use_pearl_end", private.use_pearl_end, private.room_objname );
cmn.AddSubscriber( "use_pearl_end", private.use_pearl_logic );
--------------------------------------------------------------------------------------------
function public.use_pearl( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pearl" );
    cmn.CallEventHandler( "use_pearl_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pearl") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pearl_inv" );
  cmn.CallEventHandler( "use_pearl_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shelves_anm_p", "use_pearl", func_end );
  SoundSfx( "aud_use_item_shelves" )
  --func_end()

end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_pearldoor" ] = { type = "click", use_place = "gfx_shelves_clk_pearldoor_zone", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves"  };

private.clk_pearldoor_logic = function()
  ObjSet( "spr_shelves_scissors", { input = 1 } )
end;
private.clk_pearldoor_beg = function()
  ObjDelete( "gfx_shelves_clk_pearldoor_zone" );
end;
private.clk_pearldoor_end = function()
  if common_impl.ZzCompleteCheck("clk_pearldoor") then ObjSet( common_impl.hint["clk_pearldoor"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "gfx_shelves_scissors", {visible = 1} );
  ObjSet( "gfx_shelves_tube3", {visible = 1} );   
  ObjSet( "anm_shelves_anm_p", {animfunc = "end_door_p", frame = 0 } );
  ObjDelete("spr_ruralhouse_tr_pearl");
  ObjSet( "spr_ruralhouse_open_door_3", {visible = 1} );
  ObjSet( "spr_ruralhouse_tr_tube", {visible = 1} );
  ObjSet( "spr_ruralhouse_tr_scissors", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_pearldoor", private.clk_pearldoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_pearldoor", private.clk_pearldoor_end, private.room_objname );
cmn.AddSubscriber( "clk_pearldoor", private.clk_pearldoor_logic );
cmn.AddSubscriber( "clk_pearldoor_beg", private.clk_pearldoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_pearldoor_end", private.clk_pearldoor_end, private.room_objname );
cmn.AddSubscriber( "clk_pearldoor_end", private.clk_pearldoor_logic );
--------------------------------------------------------------------------------------------
function public.clk_pearldoor()
  
  local func_end = function()
    cmn.SetEventDone( "clk_pearldoor" );
    cmn.CallEventHandler( "clk_pearldoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_pearldoor") then ld.CloseSubRoom() end;
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "clk_pearldoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shelves_anm_p", "open_door_p", func_end );
  SoundSfx( "aud_touch_door_shelves" );
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scissors" ] = { type = "get", get_obj = "spr_shelves_scissors", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves" };

private.get_scissors_logic = function()
  ObjSet( "spr_shelves_tube3", { visible = 1, input = 1 } )  
end;
private.get_scissors_inv = function()
  interface.InventoryItemAdd("inv_scissors","spr_shelves_scissors");
end;
private.get_scissors_beg = function()
  ObjDelete("gfx_shelves_scissors")
end;
private.get_scissors_end = function()
  if common_impl.ZzCompleteCheck("get_scissors") then ObjSet( common_impl.hint["get_scissors"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjSet( "anm_shelves_anm_p", {animfunc = "end_scissors", frame = 0 } );
  ObjDelete("anm_shelves_anm_p");
  ObjSet( "spr_shelves_sh_tube3", {visible = 1} );
  ObjDelete("spr_ruralhouse_tr_scissors");
end;

cmn.AddSubscriber( "get_scissors", private.get_scissors_inv );
cmn.AddSubscriber( "get_scissors", private.get_scissors_beg, private.room_objname );
cmn.AddSubscriber( "get_scissors", private.get_scissors_end, private.room_objname );
cmn.AddSubscriber( "get_scissors", private.get_scissors_logic );
--------------------------------------------------------------------
function public.get_scissors()
  ObjSet( "spr_shelves_scissors", {visible = 1} );
  cmn.SetEventDone( "get_scissors" );
  cmn.CallEventHandler( "get_scissors" );
  if common_impl.ZzCompleteCheck("get_scissors") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tube3" ] = { type = "get", get_obj = "spr_shelves_tube3", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves" };

private.get_tube3_logic = function()
  
end;
private.get_tube3_inv = function()
  interface.InventoryItemAdd("inv_tube","spr_shelves_tube3",function() level_inv.ProcessGetTubeAll( "get_tube3" ) end);
end;
private.get_tube3_beg = function()
  ObjDelete("gfx_shelves_tube3")
end;
private.get_tube3_end = function()
  if common_impl.ZzCompleteCheck("get_tube3") then ObjSet( common_impl.hint["get_tube3"].zz_gate, { visible = 0, input = 0 } ); end;
  -- ObjSet( "anm_shelves_anm_p", {animfunc = "end_tube", frame = 0 } );
  ObjDelete("spr_ruralhouse_tr_tube");
  ObjDelete("spr_shelves_sh_tube3");
end;

cmn.AddSubscriber( "get_tube3", private.get_tube3_inv );
cmn.AddSubscriber( "get_tube3", private.get_tube3_beg, private.room_objname );
cmn.AddSubscriber( "get_tube3", private.get_tube3_end, private.room_objname );
cmn.AddSubscriber( "get_tube3", private.get_tube3_logic );
--------------------------------------------------------------------
function public.get_tube3()
  ObjSet( "spr_shelves_tube3", {visible = 1} );
  cmn.SetEventDone( "get_tube3" );
  cmn.CallEventHandler( "get_tube3" );
  if common_impl.ZzCompleteCheck("get_tube3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletmouse" ] = { type = "use", inv_obj = "inv_amuletmouse", use_place = "gfx_shelves_amuletmouse_zone", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves" };

private.use_amuletmouse_logic = function()
  ObjSet( "gfx_shelves_clk_amuletmousedoor_zone", { visible = 1, input = 1 } )
end;
private.use_amuletmouse_inv = function()
  common_impl.ProcessMultiUseAll("amuletmouse", "amuletmouse")
end;
private.use_amuletmouse_beg = function()
  ObjDelete( "gfx_shelves_amuletmouse_zone" );
end;
private.use_amuletmouse_end = function()
  if common_impl.ZzCompleteCheck("use_amuletmouse") then ObjSet( common_impl.hint["use_amuletmouse"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_shelves_anm_m", {animfunc = "open_door_m", frame = 0 } );
  ObjSet( "spr_ruralhouse_tr_amulet_mouse", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletmouse", private.use_amuletmouse_inv );
cmn.AddSubscriber( "use_amuletmouse", private.use_amuletmouse_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletmouse", private.use_amuletmouse_end, private.room_objname );
cmn.AddSubscriber( "use_amuletmouse", private.use_amuletmouse_logic );
cmn.AddSubscriber( "use_amuletmouse_inv", private.use_amuletmouse_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletmouse_beg", private.use_amuletmouse_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletmouse_end", private.use_amuletmouse_end, private.room_objname );
cmn.AddSubscriber( "use_amuletmouse_end", private.use_amuletmouse_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletmouse( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletmouse" );
    cmn.CallEventHandler( "use_amuletmouse_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletmouse") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletmouse_inv" );
  cmn.CallEventHandler( "use_amuletmouse_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shelves_anm_m", "use_am_mouse", func_end );
  SoundSfx( "aud_use_item_shelves" )
  --func_end()

end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_amuletmousedoor" ] = { type = "click", use_place = "gfx_shelves_clk_amuletmousedoor_zone", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves"  };

private.clk_amuletmousedoor_logic = function()
  ObjSet( "spr_shelves_roundkey", { input = 1 } )
  
end;
private.clk_amuletmousedoor_beg = function()
  ObjDelete( "gfx_shelves_clk_amuletmousedoor_zone" );
end;
private.clk_amuletmousedoor_end = function()
  if common_impl.ZzCompleteCheck("clk_amuletmousedoor") then ObjSet( common_impl.hint["clk_amuletmousedoor"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "gfx_shelves_roundkey", {visible = 1} );  
  ObjSet( "anm_shelves_anm_m", {animfunc = "end_door_m", frame = 0 } );
  ObjDelete("spr_ruralhouse_tr_amulet_mouse");
  ObjSet( "spr_ruralhouse_open_door_1", {visible = 1} );
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_amuletmousedoor", private.clk_amuletmousedoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_amuletmousedoor", private.clk_amuletmousedoor_end, private.room_objname );
cmn.AddSubscriber( "clk_amuletmousedoor", private.clk_amuletmousedoor_logic );
cmn.AddSubscriber( "clk_amuletmousedoor_beg", private.clk_amuletmousedoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_amuletmousedoor_end", private.clk_amuletmousedoor_end, private.room_objname );
cmn.AddSubscriber( "clk_amuletmousedoor_end", private.clk_amuletmousedoor_logic );
--------------------------------------------------------------------------------------------
function public.clk_amuletmousedoor()
  
  local func_end = function()
    cmn.SetEventDone( "clk_amuletmousedoor" );
    cmn.CallEventHandler( "clk_amuletmousedoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_amuletmousedoor") then ld.CloseSubRoom() end;
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "clk_amuletmousedoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shelves_anm_m", "open_door_m", func_end );
  SoundSfx( "aud_touch_door_shelves" );
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_roundkey" ] = { type = "get", get_obj = "spr_shelves_roundkey", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves" };

private.get_roundkey_logic = function()
  
end;
private.get_roundkey_inv = function()
  interface.InventoryItemAdd("inv_roundkey","spr_shelves_roundkey");
end;
private.get_roundkey_beg = function()
  ObjDelete("gfx_shelves_roundkey")
end;
private.get_roundkey_end = function()
  if common_impl.ZzCompleteCheck("get_roundkey") then ObjSet( common_impl.hint["get_roundkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_shelves_anm_m", {animfunc = "end_key", frame = 0 } );
end;

cmn.AddSubscriber( "get_roundkey", private.get_roundkey_inv );
cmn.AddSubscriber( "get_roundkey", private.get_roundkey_beg, private.room_objname );
cmn.AddSubscriber( "get_roundkey", private.get_roundkey_end, private.room_objname );
cmn.AddSubscriber( "get_roundkey", private.get_roundkey_logic );
--------------------------------------------------------------------
function public.get_roundkey()
  ObjSet( "spr_shelves_roundkey", {visible = 1} );
  cmn.SetEventDone( "get_roundkey" );
  cmn.CallEventHandler( "get_roundkey" );
  if common_impl.ZzCompleteCheck("get_roundkey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_flowerkey" ] = { type = "use", inv_obj = "inv_flowerkey", use_place = "gfx_shelves_flowerkey_zone", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves" };

private.use_flowerkey_logic = function()
  ObjSet( "gfx_shelves_clk_flowerkeydoor_zone", { visible = 1, input = 1 } )
end;
private.use_flowerkey_inv = function()
  common_impl.ProcessMultiUseAll("flowerkey", "flowerkey")
end;
private.use_flowerkey_beg = function()
  ObjDelete( "gfx_shelves_flowerkey_zone" );
end;
private.use_flowerkey_end = function()
  if common_impl.ZzCompleteCheck("use_flowerkey") then ObjSet( common_impl.hint["use_flowerkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_shelves_anm_f", {animfunc = "open_door_f", frame = 0 } );
  ObjSet( "spr_ruralhouse_tr_amulet_flower", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_flowerkey", private.use_flowerkey_inv );
cmn.AddSubscriber( "use_flowerkey", private.use_flowerkey_beg, private.room_objname );
cmn.AddSubscriber( "use_flowerkey", private.use_flowerkey_end, private.room_objname );
cmn.AddSubscriber( "use_flowerkey", private.use_flowerkey_logic );
cmn.AddSubscriber( "use_flowerkey_inv", private.use_flowerkey_inv, private.room_objname );
cmn.AddSubscriber( "use_flowerkey_beg", private.use_flowerkey_beg, private.room_objname );
cmn.AddSubscriber( "use_flowerkey_end", private.use_flowerkey_end, private.room_objname );
cmn.AddSubscriber( "use_flowerkey_end", private.use_flowerkey_logic );
--------------------------------------------------------------------------------------------
function public.use_flowerkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_flowerkey" );
    cmn.CallEventHandler( "use_flowerkey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_flowerkey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_flowerkey_inv" );
  cmn.CallEventHandler( "use_flowerkey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shelves_anm_f", "use_am_flower", func_end );
  SoundSfx( "aud_use_item_shelves" )
  --func_end()

end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_flowerkeydoor" ] = { type = "click", use_place = "gfx_shelves_clk_flowerkeydoor_zone", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves"  };

private.clk_flowerkeydoor_logic = function()
  ObjSet( "spr_shelves_rope", {  input = 1, visible = 1 } )
  ObjSet( "spr_shelves_scheme", {input = 1, visible = 1} );
  ObjSet( "spr_shelves_paper_small", {input = 1, visible = 1} );
end;
private.clk_flowerkeydoor_beg = function()
  ObjDelete( "gfx_shelves_clk_flowerkeydoor_zone" );
end;
private.clk_flowerkeydoor_end = function()
  if common_impl.ZzCompleteCheck("clk_flowerkeydoor") then ObjSet( common_impl.hint["clk_flowerkeydoor"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "gfx_shelves_rope", {visible = 1} );  
  -- ObjSet( "anm_shelves_anm_f", {animfunc = "end_door_f", frame = 0 } );
  ObjSet( "anm_shelves_anm_f", {animfunc = "end_list", frame = 0 } );
  --ObjDelete("anm_shelves_anm_f");
  ObjDelete("spr_ruralhouse_tr_amulet_flower");
  ObjSet( "spr_ruralhouse_open_door_2", {visible = 1} );
  ObjSet( "spr_ruralhouse_tr_rope", {visible = 1} );
  ObjSet( "spr_shelves_sh_scheme", {visible = 1} );
  ObjSet( "spr_shelves_sh_rope", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_flowerkeydoor", private.clk_flowerkeydoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_flowerkeydoor", private.clk_flowerkeydoor_end, private.room_objname );
cmn.AddSubscriber( "clk_flowerkeydoor", private.clk_flowerkeydoor_logic );
cmn.AddSubscriber( "clk_flowerkeydoor_beg", private.clk_flowerkeydoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_flowerkeydoor_end", private.clk_flowerkeydoor_end, private.room_objname );
cmn.AddSubscriber( "clk_flowerkeydoor_end", private.clk_flowerkeydoor_logic );
--------------------------------------------------------------------------------------------
function public.clk_flowerkeydoor()
  
  local func_end = function()
    cmn.SetEventDone( "clk_flowerkeydoor" );
    cmn.CallEventHandler( "clk_flowerkeydoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_flowerkeydoor") then ld.CloseSubRoom() end;
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "clk_flowerkeydoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shelves_anm_f", "open_door_f", func_end );
  SoundSfx( "aud_touch_door_shelves" );
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_rope" ] = { type = "get", get_obj = "spr_shelves_rope", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves" };

private.get_rope_logic = function()
  
end;
private.get_rope_inv = function()
  interface.InventoryItemAdd("inv_rope","spr_shelves_rope");
  ObjSet( "inv_rope", { drag = 0 } );
end;
private.get_rope_beg = function()
  ObjDelete("gfx_shelves_rope")
end;
private.get_rope_end = function()
  if common_impl.ZzCompleteCheck("get_rope") then ObjSet( common_impl.hint["get_rope"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjSet( "anm_shelves_anm_f", {animfunc = "end_rope", frame = 0 } );
  ObjDelete("spr_ruralhouse_tr_rope");
  ObjDelete("spr_shelves_sh_rope");
end;

cmn.AddSubscriber( "get_rope", private.get_rope_inv );
cmn.AddSubscriber( "get_rope", private.get_rope_beg, private.room_objname );
cmn.AddSubscriber( "get_rope", private.get_rope_end, private.room_objname );
cmn.AddSubscriber( "get_rope", private.get_rope_logic );
--------------------------------------------------------------------
function public.get_rope()
  --ObjSet( "spr_shelves_rope", {visible = 1} );
  cmn.SetEventDone( "get_rope" );
  cmn.CallEventHandler( "get_rope" );
  if common_impl.ZzCompleteCheck("get_rope") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scheme" ] = { type = "get", get_obj = "spr_shelves_scheme", room = "rm_ruralhouse", zz = "zz_shelves", zz_gate = "gzz_ruralhouse_shelves" };

private.get_scheme_logic = function()
  
end;
private.get_scheme_inv = function()
  interface.InventoryItemAdd("inv_scheme","spr_shelves_scheme");
end;
private.get_scheme_beg = function()
  ObjDelete("gfx_shelves_scheme")
end;
private.get_scheme_end = function()
  if common_impl.ZzCompleteCheck("get_scheme") then ObjSet( common_impl.hint["get_scheme"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_shelves_sh_scheme");
end;

cmn.AddSubscriber( "get_scheme", private.get_scheme_inv );
cmn.AddSubscriber( "get_scheme", private.get_scheme_beg, private.room_objname );
cmn.AddSubscriber( "get_scheme", private.get_scheme_end, private.room_objname );
cmn.AddSubscriber( "get_scheme", private.get_scheme_logic );
--------------------------------------------------------------------
function public.get_scheme()
  cmn.SetEventDone( "get_scheme" );
  cmn.CallEventHandler( "get_scheme" );
  if common_impl.ZzCompleteCheck("get_scheme") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_amuletmouse()

  local func_end = function()
    common_impl.ShowBbt( 'need_amuletmouse' )
    ld.Lock(0);
  end;
  
  ld.Lock(1);
  ld.AnimPlay( "anm_shelves_anm_m", "idle_door_m", func_end );
  SoundSfx( "aud_touch_shelves" );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_pearl()

  local func_end = function()
    common_impl.ShowBbt( 'need_pearl' )
    ld.Lock(0);
  end;
  
  ld.Lock(1);
  ld.AnimPlay( "anm_shelves_anm_p", "idle_door_p", func_end );
  SoundSfx( "aud_touch_shelves" );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_flowerkey()

  local func_end = function()
    common_impl.ShowBbt( 'need_flowerkey' )
    ld.Lock(0);
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_shelves" );
  ld.AnimPlay( "anm_shelves_anm_f", "idle_door_f", func_end );
end;

--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_stairs *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.bagpipe_clk_rat()

  local func_end = function()
    ld.Lock(0);
    ld.AnimPlay( "anm_stairs_anim_rat", "static_rat", func_end );
    common_impl.ShowBbt( 'need_bagpipe' );
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_rats_stairs" )
  ld.AnimPlay( "anm_stairs_anim_rat", "idle_rat1", func_end );
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bagpipe" ] = { type = "use", inv_obj = "inv_bagpipe", use_place = "gfx_stairs_bagpipe_zone", room = "rm_ruralhouse", zz = "zz_stairs", zz_gate = "gzz_ruralhouse_stairs" };

private.use_bagpipe_logic = function()
  ObjSet( "obj_stairs_bagpipemmg", {input = 1} );
end;
private.use_bagpipe_inv = function()
  common_impl.ProcessMultiUseAll("bagpipe", "bagpipe")
end;
private.use_bagpipe_beg = function()
  ObjDelete( "gfx_stairs_bagpipe_zone" );
end;
private.use_bagpipe_end = function()
  if common_impl.ZzCompleteCheck("use_bagpipe") then ObjSet( common_impl.hint["use_bagpipe"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "obj_stairs_bagpipemmg", {alp = 1} );
  ObjDelete("obj_stairs_scheme_bbt_zone");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bagpipe", private.use_bagpipe_inv );
cmn.AddSubscriber( "use_bagpipe", private.use_bagpipe_beg, private.room_objname );
cmn.AddSubscriber( "use_bagpipe", private.use_bagpipe_end, private.room_objname );
cmn.AddSubscriber( "use_bagpipe", private.use_bagpipe_logic );
cmn.AddSubscriber( "use_bagpipe_inv", private.use_bagpipe_inv, private.room_objname );
cmn.AddSubscriber( "use_bagpipe_beg", private.use_bagpipe_beg, private.room_objname );
cmn.AddSubscriber( "use_bagpipe_end", private.use_bagpipe_end, private.room_objname );
cmn.AddSubscriber( "use_bagpipe_end", private.use_bagpipe_logic );
--------------------------------------------------------------------------------------------
function public.use_bagpipe( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bagpipe" );
    cmn.CallEventHandler( "use_bagpipe_end" );
    if ld.CheckRequirements( {"use_bagpipe"} ) then  
      cmn.MiniGameShow( "bagpipe" );
      ld.StartTimer( 0.5, function()  public.win_bagpipe_load();  end )
    end;
    
    if common_impl.ZzCompleteCheck("use_bagpipe") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bagpipe_inv" );
  cmn.CallEventHandler( "use_bagpipe_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  ObjAnimate( "obj_stairs_bagpipemmg", 8, 0, 0, function() func_end() end, {0,0,0, 0.5,0,1} );
  SoundSfx( "aud_mg_stairs_begin" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_bagpipe" ] = { type = "click", use_place = "obj_stairs_bagpipemmg", room = "rm_ruralhouse", zz = "zz_stairs", zz_gate = "gzz_ruralhouse_stairs" };

private.win_bagpipe_logic = function()
  if ( cmn.IsEventDone( "win_bagpipe" ) ) then
    ObjSet( "grm_ruralhouse_cellar", { visible = 1, input = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_ruralhouse_cellar_focus");
    end;
  end

end;
private.win_bagpipe_beg = function()
  
end;
private.win_bagpipe_end = function()
  if common_impl.ZzCompleteCheck("win_bagpipe") then ObjSet( common_impl.hint["win_bagpipe"].zz_gate, { visible = 0, input = 0 } ); end;
  if ( cmn.IsEventDone( "win_bagpipe" ) ) then
    ObjDelete("obj_stairs_bagpipemmg");
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_bagpipe", private.win_bagpipe_beg, private.room_objname );
cmn.AddSubscriber( "win_bagpipe", private.win_bagpipe_end, private.room_objname );
cmn.AddSubscriber( "win_bagpipe", private.win_bagpipe_logic );
cmn.AddSubscriber( "win_bagpipe_beg", private.win_bagpipe_beg, private.room_objname );
cmn.AddSubscriber( "win_bagpipe_end", private.win_bagpipe_end, private.room_objname );
cmn.AddSubscriber( "win_bagpipe_end", private.win_bagpipe_logic );
--------------------------------------------------------------------------------------------
function public.win_bagpipe()

  local func_end = function()
    cmn.SetEventDone( "win_bagpipe" );
    cmn.CallEventHandler( "win_bagpipe_end" );
    if common_impl.ZzCompleteCheck("win_bagpipe") then ld.CloseSubRoom() end;
    --------------- for First Play ---------------------------
    if false then   -- if true goto on rm_outro
      ld.StartTimer( 0.5, function() cmn.GotoRoom("rm_outro");  common_impl.Lock(0); end ) 
    else 
      common_impl.Lock(0);
    end;
    ------------------------------------------------------------
  end;

  cmn.CallEventHandler( "win_bagpipe_beg" );
  --common_impl.Lock(1);
  
  cmn.MiniGameHide( "bagpipe", true );
  ld.AnimPlay( "anm_stairs_anim_rat", "go", func_end );
  SoundSfx( "aud_mg_stairs_win" );
  --func_end()

end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
local count_click = 0; -- счетчик кликов
local bagpipe_win = {3,1,2,0,4} -- массив победной комбинации

------------------------------------------for sound ------------------
private.win_bagpipe_level_sound = {0,0,0};
--private.win_bagpipe_level_sound_second_use = 0;

function private.win_bagpipe_level_sound_play(num)
   local aud_mg_stairs_root = {"first","second","third"};
   
   if private.win_bagpipe_level_sound[num]==0 then 
      SoundSfx( "aud_mg_stairs_"..aud_mg_stairs_root[num] );
   end;   
end;  

--------------------------------------------------------

function public.win_bagpipe_load(fast) 
  local time_load = 3; -- время в начале загрузки
  
  if not ng_global.progress[ "std" ][ "win_bagpipe" ].state then
    ng_global.progress[ "std" ][ "win_bagpipe" ].state = {1,0,0}        
  end
  count_click = 0;
  for i = 1,3 do
    if ng_global.progress[ "std" ][ "win_bagpipe" ].state[i] == 1 then
      if i == 1 then 
        bagpipe_win = {3,1,2,0,4} 
        private.win_bagpipe_level_sound = {0,0,0};
      elseif i == 2 then
        bagpipe_win = {2,4,3,5,1} 
        ObjSet( "anm_stairs_anim_mmg1", {animfunc = "trub1", playing = 1 } );
        private.win_bagpipe_level_sound = {1,0,0};
      elseif i == 3 then
        bagpipe_win = {1,3,5,2,4}  
        time_load = 2;
        ObjSet( "anm_stairs_anim_mmg1", {animfunc = "trub1", playing = 1 } );
        ObjSet( "anm_stairs_anim_mmg2", {animfunc = "trub2", playing = 1 } );
        private.win_bagpipe_level_sound = {1,1,0};
      end 
    end
  end
  ld.Lock(1);
  for i = 1, 5 do
    ObjSet( "spr_stairs_lig"..i, {color_r = 1, color_g = 1, color_b = 1, alp = 0} );
    if bagpipe_win[i] ~= 0 then
      ObjSet( "spr_stairs_"..i, {res = "assets/levels/level/rm_ruralhouse/zz_stairs/"..bagpipe_win[i]} );
      ObjAnimate( "spr_stairs_"..i, 8, 0, 0, function() ld.StartTimer( time_load, function() ObjAnimate( "spr_stairs_"..i, 8, 0, 0, function() end, {0,0,ObjGet("spr_stairs_"..i).alp, 0.5,0,0} ); end ) end, {0,0,0, 0.5,0,0.8} );
      ObjAnimate( "spr_stairs_lig"..i, 8, 0, 0, function() ld.StartTimer( time_load, function() ObjAnimate( "spr_stairs_lig"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} ); end ) end, {0,0,0, 0.5,0,1} );
    end
  end
  SoundSfx( "aud_mg_stairs_show" );
  ld.StartTimer( time_load + 1, function() ld.Lock(0); end )
end

function public.win_bagpipe_hand(num)  
  ld.SetCursor( CURSOR_HAND );  
  ObjSet( "spr_stairs_lig"..num, {alp = 1} );
end

function public.win_bagpipe_hand_defoult(num)  
  ld.SetCursor( CURSOR_DEFAULT ); 
  if ObjGet("spr_stairs_lig"..num).color_b == 1 then
    ObjSet( "spr_stairs_lig"..num, {alp = 0} );
  end
end 

function public.win_bagpipe_clik(num)
  
  count_click = count_click + 1; 
  ld.Lock(1);
  if bagpipe_win[num] == count_click then
    SoundSfx( "aud_mg_stairs_true" );
    ObjAnimate( "spr_stairs_lig"..num, 12, 0, 0, function() ld.Lock(0); public.win_bagpipe_check(); end, {0,0,ObjGet("spr_stairs_lig"..num).color_r,ObjGet("spr_stairs_lig"..num).color_g,ObjGet("spr_stairs_lig"..num).color_b, 0.5,0,0.6,1,0.5} );    
  else
    SoundSfx( "aud_mg_stairs_false" );
    ObjAnimate( "spr_stairs_lig"..num, 12, 0, 0, function() public.win_bagpipe_reset(); end, {0,0,ObjGet("spr_stairs_lig"..num).color_r,ObjGet("spr_stairs_lig"..num).color_g,ObjGet("spr_stairs_lig"..num).color_b, 0.5,0,1,0.2,0.2} );  
  end
end


function public.win_bagpipe_check()
  local max_click = 0;
  for i = 1,5 do
    if max_click < bagpipe_win[i] then
      max_click = bagpipe_win[i];
    end   
  end 
  local func_end = function()
  for i = 1,3 do
      if ng_global.progress[ "std" ][ "win_bagpipe" ].state[i] == 1 then
        ng_global.progress[ "std" ][ "win_bagpipe" ].state[i] = 0;
        private.win_bagpipe_level_sound_play(i) -- for sound
        if i ~= 3 then
          ng_global.progress[ "std" ][ "win_bagpipe" ].state[i + 1] = 1;
          ld.StartTimer( 1.5, function() public.win_bagpipe_load();  end ) 
          break;  
        else
          ng_global.progress[ "std" ][ "win_bagpipe" ].state[1] = 1;
          ObjSet( "anm_stairs_anim_mmg3", {animfunc = "trub3", playing = 1 } );
          ld.Lock(1);
          ld.StartTimer( 1.5, function() public.win_bagpipe_skip(1); end ); 
        end               
      end
    end  
  end
  
  if count_click == max_click then
    ld.Lock(1);
    for i = 1,5 do
      ObjAnimate( "spr_stairs_lig"..i, 8, 0, 0, function() ObjSet( "spr_stairs_lig"..i, {color_r = 1, color_g = 1, color_b = 1} );   end, {0,0,ObjGet("spr_stairs_lig"..i).alp, 0.5,0,0} );
    end
    ld.StartTimer( 0.5, function() ld.Lock(0); func_end(); end )
  end 
end

function private.end_bagpipe_skip()
  ld.StartTimer( 1.5, function() ObjAnimate( "obj_stairs_bagpipemmg", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );   end ) 
  if ng_global.progress[ "std" ][ "win_bagpipe" ].state then
    ng_global.progress[ "std" ][ "win_bagpipe" ].state = {1,0,0}        
  end
  for j = 1,3 do
    if ObjGet("anm_stairs_anim_mmg"..j).playing == false then
      ObjSet( "anm_stairs_anim_mmg"..j, {animfunc = "trub"..j, playing = 1 } );
    end 
  end 
 --if without_sound~=1 then 
 --    SoundSfx( "aud_mg_stairs_first" )
 --    ld.StartTimer( 1.5 , function() SoundSfx( "aud_mg_stairs_second" ) end );
 --    ld.StartTimer( 3, function()  SoundSfx( "aud_mg_stairs_third" ) end );
 --end;
 ld.StartTimer( 2, function()  public.win_bagpipe(); end )
end

function private.next_lig(step)
  local count_lig = 4;
  if ng_global.progress[ "std" ][ "win_bagpipe" ].state[1] == 0 then
    count_lig = 5;    
  end
  for i = 1,5 do
    if step ==  bagpipe_win[i] then
      SoundSfx( "aud_mg_stairs_true" )
      ObjAnimate( "spr_stairs_lig"..i, 8, 0, 0, function() 
                                                  if step < count_lig + 1 then 
                                                     private.next_lig(step); 
                                                  else 
                                                    private.end_bagpipe_skip();   
                                                  end 
                                                end, {0,0,ObjGet("spr_stairs_lig"..i).alp, 0.5,0,1} ); 
      ObjAnimate( "spr_stairs_"..i, 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
    end
  end 
  step = step + 1; 
end

    
function public.win_bagpipe_skip(fast)
   ld.Lock(1);
   local step = 1;
   for i = 1,5 do 
     ObjSet( "spr_stairs_lig"..i, {color_r = 0.6, color_g = 1, color_b = 0.5} );
   end
   
   if not fast then 
     private.next_lig(step)
   else
     private.end_bagpipe_skip();
   end
end

function public.win_bagpipe_reset()
  for i = 1,5 do
    ObjAnimate( "spr_stairs_lig"..i, 8, 0, 0, function() ObjSet( "spr_stairs_lig"..i, {color_r = 1, color_g = 1, color_b = 1} ); end, {0,0,ObjGet("spr_stairs_lig"..i).alp, 0.5,0,0} );
  end 
  ld.StartTimer( 0.5, function() ld.Lock(0); public.win_bagpipe_load();  end )
  count_click = 0;
  
end

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
function public.Skip()
  ld.LogTrace( "Skip" );
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_stairs" ) and not ld.CheckRequirements( { "win_bagpipe" } ) then    
    public.win_bagpipe_skip();
  end;

end;
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_stairs" ) and not ld.CheckRequirements( { "win_bagpipe" } ) then  
    ld.Lock(1);    
    public.win_bagpipe_reset();
  end;

end;
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_ruralhouse();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_ruralhouse_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_stairs" );
  function zz_stairs.Open()
    if not ld.CheckRequirements( {"win_bagpipe"} ) then
      ObjSet( "anm_stairs_anim_rat", {animfunc = "static_rat", frame = 0, playing = 1 } );
    end
    if ld.CheckRequirements( {"use_bagpipe"} ) and not ld.CheckRequirements( {"win_bagpipe"} ) then
      
      cmn.MiniGameShow( "bagpipe" );
    end
  end;
  function zz_stairs.PreOpen()
    if  not cmn.IsEventDone( "win_bagpipe" )  and cmn.IsEventStart( "win_bagpipe" ) and cmn.IsEventDone( "use_bagpipe" )  then
       public.win_bagpipe_load(1);   
    end
  end;
  function zz_stairs.PreClose()
    if not ld.CheckRequirements( {"win_bagpipe"} ) then
      ObjSet( "anm_stairs_anim_rat", {animfunc = "static_rat", frame = 0, playing = 0 } );
    end
    if ld.CheckRequirements( {"use_bagpipe"} ) and not ld.CheckRequirements( {"win_bagpipe"} ) then
      if not ng_global.progress[ "std" ][ "win_bagpipe" ].state then
        for i = 1,3 do
          if ng_global.progress[ "std" ][ "win_bagpipe" ].state[i] == 1 then
            if i == 1 then 
            elseif i == 2 then
              ObjSet( "anm_stairs_anim_mmg1", {animfunc = "trub1", playing = 0 } );
            elseif i == 3 then
              ObjSet( "anm_stairs_anim_mmg1", {animfunc = "trub1", playing = 0 } );
              ObjSet( "anm_stairs_anim_mmg2", {animfunc = "trub2", playing = 0 } );
            end 
          end
        end
      end
      cmn.MiniGameHide( "bagpipe" );
    end
  end;
  function zz_stairs.Close()
  end;

  subroom.Define( "zz_shelves" );
  function zz_shelves.Open()
  end;
  function zz_shelves.PreOpen()
  end;
  function zz_shelves.PreClose()
  end;
  function zz_shelves.Close()
  end;

  subroom.Define( "zz_distaff" );
  function zz_distaff.Open()
  end;
  function zz_distaff.PreOpen()
  end;
  function zz_distaff.PreClose()
  end;
  function zz_distaff.Close()
  end;

  subroom.Define( "zz_bed" );
  function zz_bed.Open()
  end;
  function zz_bed.PreOpen()
  end;
  function zz_bed.PreClose()
  end;
  function zz_bed.Close()
  end;
  
end;
--*********************************************************************************************************************