-- name=rm_ruralroad
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_ruralroad";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------

  --{"clk_outrolvl1"}
  --------------------------------------------------------------------------------------------
function private.opn_ruralroad()
  if not ( cmn.IsEventDone( "opn_ruralroad" ) ) then
    cmn.SetEventDone( "opn_ruralroad" );
    cmn.CallEventHandler( "opn_ruralroad" )
    ld.ShowBbt("opn_ruralroad")
    -- ld.Lock(1);
    -- SoundVoice("aud_pc_3_voc");
    ld.StartTimer( 2, function()  ld.Lock(0); SoundTheme( "aud_danger_moment2_mus" ); end )
  end;
end;

--------------------------------------------------------------------
local opn_ruralroad = function() end;
local opn_ruralroad_logic = function()end;
cmn.AddSubscriber( "opn_ruralroad", opn_ruralroad_logic )
cmn.AddSubscriber( "opn_ruralroad", opn_ruralroad, private.room_objname )
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------

function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "elizabeth1" then
    if count_txt == 1 then
      --ld.AnimPlay( "anm_ruralroad_elizabeth1", "static", "" )
      common_impl.continue_visible = true
    end
  elseif dlg_name == "william1" then
    if count_txt == 1 then
      
      
    elseif count_txt == 2 then      
      common_impl.continue_visible = true
      ld.Lock(1);
      ld.AnimPlay( "anm_ruralroad_william1_character", "give", function() ld.Lock(0); end )
      SoundSfx( "aud_get_to_us" );
    elseif count_txt == 3 then      
      common_impl.continue_visible = true
      ld.Lock(1);
      
      ld.AnimPlay( "anm_ruralroad_william1_character", "hand", function() ld.Lock(0); end )  
      ObjSet( "spr_ruralroad_dagger", {visible = 1} );  
      cmn.CallEventHandler( "get_dagger" )  
    end   
  elseif dlg_name == "elizabeth2" then
    if count_txt == 1 then
      --ld.AnimPlay( "anm_ruralroad_elizabeth2", "static", "" )
      common_impl.continue_visible = true
    end    
  elseif dlg_name == "william2" then
    if count_txt == 1 then
      --ld.AnimPlay( "anm_ruralroad_elizabeth2", "static", "" )
      common_impl.continue_visible = true
    end      
  end

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_ruralroad_elizabeth1" ] = { type = "click", use_place = "gfx_ruralroad_dlg_ruralroad_elizabeth1_zone", room = "rm_ruralroad" };

private.dlg_ruralroad_elizabeth1_logic = function()
  ObjSet( "gfx_ruralroad_clk_attack_zone", { visible = 1, input = 1 } )

end;
private.dlg_ruralroad_elizabeth1_beg = function()
  ObjDelete( "gfx_ruralroad_dlg_ruralroad_elizabeth1_zone" );
end;
private.dlg_ruralroad_elizabeth1_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_ruralroad_elizabeth1", private.dlg_ruralroad_elizabeth1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_elizabeth1", private.dlg_ruralroad_elizabeth1_end, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_elizabeth1", private.dlg_ruralroad_elizabeth1_logic );
cmn.AddSubscriber( "dlg_ruralroad_elizabeth1_beg", private.dlg_ruralroad_elizabeth1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_elizabeth1_end", private.dlg_ruralroad_elizabeth1_end, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_elizabeth1_end", private.dlg_ruralroad_elizabeth1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_ruralroad_elizabeth1( obj )

  cmn.CallEventHandler( "dlg_ruralroad_elizabeth1_beg" );
  --common_impl.Lock(1);
  common_impl.dialog_character_loc = "anm_ruralroad_anm_elisabet_loc_anm"
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  common_impl.Start( "elizabeth1", 2, nil, nil, true, "dlg_ruralroad_elizabeth1_end", {"aud_elizabeth_1_voc"} );

end;

private.dlg_ruralroad_elizabeth1_end = function()
  ObjSet( "dlg_ruralroad_elizabeth1", {bake=1} );
  ld.Lock(1);
  cmn.SetEventDone( "dlg_ruralroad_elizabeth1" );
  cmn.CallEventHandler( "dlg_ruralroad_elizabeth1_end" );
  ld.StartTimer( 0.5, function()  public.clk_attack(); ld.Lock(0) end )
  --common_impl.Lock(0);
  --common_impl.Lock(0);
  --ld.ShowBbt("after_dlg_elizabeth1")
end;
function public.dlg_ruralroad_elizabeth1_end()
  private.dlg_ruralroad_elizabeth1_end()
end

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_attack" ] = { type = "click", use_place = "gfx_ruralroad_clk_attack_zone", room = "rm_ruralroad" };

private.clk_attack_logic = function()
  ObjSet( "gzz_ruralroad_bush", { visible = 1, input = 1 } )
  ObjSet( "gzz_ruralroad_frontcarriage", { visible = 1, input = 1 } )
  ObjSet( "gzz_ruralroad_baggage", { visible = 1, input = 1 } )
  ObjSet( "gfx_ruralroad_medicine_zone", { visible = 1, input = 1 } )
  ObjSet( "gfx_ruralroad_plaid_zone", {input = 1, visible = 1} );
end;
private.clk_attack_beg = function()
  ObjDelete( "gfx_ruralroad_clk_attack_zone" );
end;
private.clk_attack_end = function()
  ObjSet("anm_ruralroad_anm_elisabet_loc_anm",{visible=0,active=0});
  ObjSet( "anm_ruralroad_anm_willyam_loc_anm",{visible=0,active=0});
  ObjSet( "obj_rurlaroad_fire_anim_root", {visible = 1} );
  ObjSet( "anm_ruralroad_anim_fire", {playing=1} );
  ObjDelete("vid_ruralroad_vid_attack");
  ObjSet( "spr_ruralroad_willliam_1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_attack", private.clk_attack_beg, private.room_objname );
cmn.AddSubscriber( "clk_attack", private.clk_attack_end, private.room_objname );
cmn.AddSubscriber( "clk_attack", private.clk_attack_logic );
cmn.AddSubscriber( "clk_attack_beg", private.clk_attack_beg, private.room_objname );
cmn.AddSubscriber( "clk_attack_end", private.clk_attack_end, private.room_objname );
cmn.AddSubscriber( "clk_attack_end", private.clk_attack_logic );
--------------------------------------------------------------------------------------------
function public.clk_attack()

  local func_end = function()
    cmn.SetEventDone( "clk_attack" );
    cmn.CallEventHandler( "clk_attack_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_attack")
    SoundTheme( "aud_danger1_mus" );
  end;

  local func_preend = function()
    SoundVoice( 0 );
    int.DialogVideoHide();
    ld.Lock(1);
    ObjSet( "anm_ruralroad_anm_elisabet_loc_anm", {visible = 0} );
    ObjSet( "anm_ruralroad_anm_willyam_loc_anm", {visible = 0} );
    ObjSet( "obj_rurlaroad_fire_anim_root", {visible = 1} );
    ObjSet( "anm_ruralroad_anim_fire", {playing=1} );
    ObjSet( "spr_ruralroad_willliam_1", {visible = 1} );
    ld.StartTimer( 0.5, func_end )
    SoundEnv("aud_ruralroad_env");
    SoundEnv("aud_ruralroad_fire_env",1);
    ld.VidStaticPlay( private.vid_ruralroad_horse_root )
  end;
  
  cmn.CallEventHandler( "clk_attack_beg" );
  --common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()
  ld.VidStaticPause(  private.vid_ruralroad_horse_root )
  SoundEnv(0);
  ObjAttach("vid_ruralroad_vid_attack","rm_ruralroad");
  VidPlay("vid_ruralroad_vid_attack",func_preend);
  SoundVid("aud_abduction_411");
  SoundVoice( "aud_abduction_411_voc" )
  int.DialogVideoShow( "vid_ruralroad_vid_attack", 1, func_preend, 1 ); 
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_medicine" ] = { type = "use", inv_obj = "inv_medicine", use_place = "gfx_ruralroad_medicine_zone", room = "rm_ruralroad" };

private.use_medicine_logic = function()
  ObjSet( "gfx_ruralroad_dlg_ruralroad_william1_zone", { visible = 1, input = 1 } )

end;
private.use_medicine_inv = function()
  common_impl.ProcessMultiUseAll("medicine", "medicine")
end;
private.use_medicine_beg = function()
  ObjDelete( "gfx_ruralroad_medicine_zone" );
end;
private.use_medicine_end = function()
 -- ObjSet( "anm_ruralroad_anm_willyam_loc_anm", {visible = 1, playing=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_medicine", private.use_medicine_inv );
cmn.AddSubscriber( "use_medicine", private.use_medicine_beg, private.room_objname );
cmn.AddSubscriber( "use_medicine", private.use_medicine_end, private.room_objname );
cmn.AddSubscriber( "use_medicine", private.use_medicine_logic );
cmn.AddSubscriber( "use_medicine_inv", private.use_medicine_inv, private.room_objname );
cmn.AddSubscriber( "use_medicine_beg", private.use_medicine_beg, private.room_objname );
cmn.AddSubscriber( "use_medicine_end", private.use_medicine_end, private.room_objname );
cmn.AddSubscriber( "use_medicine_end", private.use_medicine_logic );
--------------------------------------------------------------------------------------------
function public.use_medicine( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    --  cmn.SetEventDone( "use_medicine" );
    --cmn.CallEventHandler( "use_medicine_end" );
    common_impl.Lock(0);
    public.dlg_ruralroad_william1()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_medicine_inv" );
  cmn.CallEventHandler( "use_medicine_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_medicine_william" );
  ld.StartTimer( 1, function() func_end() end )
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_ruralroad_william1" ] = { type = "click", use_place = "gfx_ruralroad_dlg_ruralroad_william1_zone", room = "rm_ruralroad" };

private.dlg_ruralroad_william1_logic = function()
  ObjSet( "spr_ruralroad_dagger", { visible = 1, input = 1 } )
  ObjSet( "gfx_ruralroad_clk_williamgoaway_zone", { visible = 1, input = 1 } )

end;
private.dlg_ruralroad_william1_beg = function()
  ObjDelete( "gfx_ruralroad_dlg_ruralroad_william1_zone" );
end;
private.dlg_ruralroad_william1_end = function()
  ObjDelete("spr_ruralroad_willliam_1");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_ruralroad_william1", private.dlg_ruralroad_william1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_william1", private.dlg_ruralroad_william1_end, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_william1", private.dlg_ruralroad_william1_logic );
cmn.AddSubscriber( "dlg_ruralroad_william1_beg", private.dlg_ruralroad_william1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_william1_end", private.dlg_ruralroad_william1_end, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_william1_end", private.dlg_ruralroad_william1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_ruralroad_william1( obj )
 
  cmn.CallEventHandler( "dlg_ruralroad_william1_beg" );
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  ld.Lock(1);
  ObjAnimate( "spr_ruralroad_willliam_1", 8, 0, 0, function() ld.Lock(0); end, {0,0,1, 0.3,0,0} );
  common_impl.dialog_character_loc =  ""
  common_impl.Start( "william1", 3, nil, nil, true, "dlg_ruralroad_william1_end", {"aud_william_1_voc","aud_william_2_voc"} );

end;
private.dlg_ruralroad_william1_end = function()
  ObjSet( "dlg_ruralroad_william1", {bake=1} );
  cmn.SetEventDone( "use_medicine" );
  cmn.CallEventHandler( "use_medicine_end" );
  cmn.SetEventDone( "dlg_ruralroad_william1" );
  cmn.CallEventHandler( "dlg_ruralroad_william1_end" );
  --  public.get_dagger()
  public.clk_williamgoaway()
  cmn.SetEventDone( "get_dagger" );
end;
function public.dlg_ruralroad_william1_end()
  if ObjGetRelations( "inv_dagger" ).parent == "level_inv_hub" then
    ObjSet( "spr_ruralroad_dagger", {visible = 1} );
    cmn.CallEventHandler( "get_dagger");      
  end
  private.dlg_ruralroad_william1_end()
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_dagger" ] = { type = "get", get_obj = "spr_ruralroad_dagger", room = "rm_ruralroad" };

private.get_dagger_logic = function()
  
end;
private.get_dagger_inv = function()
  interface.InventoryItemAdd("inv_dagger","spr_ruralroad_dagger");
end;
private.get_dagger_beg = function()
  ObjDelete("gfx_ruralroad_dagger")
end;
private.get_dagger_end = function()
  
end;

cmn.AddSubscriber( "get_dagger", private.get_dagger_inv );
cmn.AddSubscriber( "get_dagger", private.get_dagger_beg, private.room_objname );
cmn.AddSubscriber( "get_dagger", private.get_dagger_end, private.room_objname );
cmn.AddSubscriber( "get_dagger", private.get_dagger_logic );
--------------------------------------------------------------------
function public.get_dagger()
  cmn.SetEventDone( "get_dagger" );
  cmn.CallEventHandler( "get_dagger" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_williamgoaway" ] = { type = "click", use_place = "gfx_ruralroad_clk_williamgoaway_zone", room = "rm_ruralroad" };

private.clk_williamgoaway_logic = function()

end;
private.clk_williamgoaway_beg = function()
  ObjDelete( "gfx_ruralroad_clk_williamgoaway_zone" );
end;
private.clk_williamgoaway_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_williamgoaway", private.clk_williamgoaway_beg, private.room_objname );
cmn.AddSubscriber( "clk_williamgoaway", private.clk_williamgoaway_end, private.room_objname );
cmn.AddSubscriber( "clk_williamgoaway", private.clk_williamgoaway_logic );
cmn.AddSubscriber( "clk_williamgoaway_beg", private.clk_williamgoaway_beg, private.room_objname );
cmn.AddSubscriber( "clk_williamgoaway_end", private.clk_williamgoaway_end, private.room_objname );
cmn.AddSubscriber( "clk_williamgoaway_end", private.clk_williamgoaway_logic );
--------------------------------------------------------------------------------------------
function public.clk_williamgoaway()

  local func_end = function()
    cmn.SetEventDone( "clk_williamgoaway" );
    cmn.CallEventHandler( "clk_williamgoaway_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_williamgoaway")
  end;

  cmn.CallEventHandler( "clk_williamgoaway_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_plaid" ] = { type = "use", inv_obj = "inv_plaid", use_place = "gfx_ruralroad_plaid_zone", room = "rm_ruralroad" };

private.use_plaid_logic = function()
  ObjSet( "grm_ruralroad_farm", { visible = 1, input = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_ruralroad_farm_focus");
    end;
end;
private.use_plaid_inv = function()
  common_impl.ProcessMultiUseAll("plaid", "plaid")
end;
private.use_plaid_beg = function()
  ObjDelete( "gfx_ruralroad_plaid_zone" );
end;
private.use_plaid_end = function()
  ObjSet( "anm_ruralroad_anim_pled", {animfunc = "anim_pled_end", frame = 0 } );
  ObjDelete("anm_ruralroad_anim_doski");
  ObjDelete("anm_ruralroad_anim_fire");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_plaid", private.use_plaid_inv );
cmn.AddSubscriber( "use_plaid", private.use_plaid_beg, private.room_objname );
cmn.AddSubscriber( "use_plaid", private.use_plaid_end, private.room_objname );
cmn.AddSubscriber( "use_plaid", private.use_plaid_logic );
cmn.AddSubscriber( "use_plaid_inv", private.use_plaid_inv, private.room_objname );
cmn.AddSubscriber( "use_plaid_beg", private.use_plaid_beg, private.room_objname );
cmn.AddSubscriber( "use_plaid_end", private.use_plaid_end, private.room_objname );
cmn.AddSubscriber( "use_plaid_end", private.use_plaid_logic );
--------------------------------------------------------------------------------------------
function public.use_plaid( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_plaid" );
    cmn.CallEventHandler( "use_plaid_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_plaid_inv" );
  cmn.CallEventHandler( "use_plaid_beg" );
  common_impl.Lock(1);

  SoundEnv("aud_ruralroad_fire_env",0);
  ObjAnimate( "anm_ruralroad_anim_fire", 8, 0, 0, function() end, {0,0,1, 3,0,1, 3.5,0,0} );  
  ld.AnimPlay( "anm_ruralroad_anim_pled", "anim_pled", func_end );
  SoundSfx( "aud_use_plaid" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmcoach1" ] = { type = "click", use_place = "gfx_ruralroad_clk_anmcoach1_zone", room = "rm_ruralroad" };

private.clk_anmcoach1_logic = function()
  ObjSet( "gfx_ruralroad_dlg_ruralroad_elizabeth2_zone", { visible = 1, input = 1, active = 1 } )
  
  int_map_impl.map_rooms["ruralroad"] = {2,0,2,{"opn_ruralroad" }}  
  ObjAttach("spr_map_impl_screen_block_2_zone","obj_map_impl_screen_2_root")
end;
private.clk_anmcoach1_beg = function()
  ObjDelete( "gfx_ruralroad_clk_anmcoach1_zone" );
      ObjDelete("obj_ruralroad_frontcarriage_tr_root")
      ObjDelete("obj_ruralroad_bush_tr_root")
      ObjDelete("obj_rurlaroad_fire_anim_root")
      ObjDelete("obj_ruralroad_baggage_tr_root")
      ObjDelete("spr_ruralroad_coach")
      ObjDelete("pfx_ruralroad_rm_roadlamp_pm")
      ObjSet("spr_ruralroad_barrel2",{alp=1})   
end;
private.clk_anmcoach1_end = function()
  --ObjDelete("vid_ruralroad_vid_coach_stop")
  ObjSet("spr_ruralroad_coach2",{alp=1})  
  ObjSet("anm_ruralroad_anm_elisabet_loc_anm",{visible=1,active=1});
  ObjSet( "anm_ruralroad_anm_willyam_loc_anm",{visible=1,active=1});     
 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmcoach1", private.clk_anmcoach1_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmcoach1", private.clk_anmcoach1_end, private.room_objname );
cmn.AddSubscriber( "clk_anmcoach1", private.clk_anmcoach1_logic );
cmn.AddSubscriber( "clk_anmcoach1_beg", private.clk_anmcoach1_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmcoach1_end", private.clk_anmcoach1_end, private.room_objname );
cmn.AddSubscriber( "clk_anmcoach1_end", private.clk_anmcoach1_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmcoach1()
  local widget_settings = 
     {
       InterfaceWidget_Inventory,
       InterfaceWidget_BtnHint,
       InterfaceWidget_BtnGuide,
       InterfaceWidget_BtnMenu,
       InterfaceWidget_BtnMap,
     }
     
  local func_end = function()
    cmn.SetEventDone( "clk_anmcoach1" );
    cmn.CallEventHandler( "clk_anmcoach1_end" );
    common_impl.Lock(0);
    -- ld.ShowBbt("after_clk_anmcoach1");
    SoundTheme( "aud_danger_moment1_mus" );
  end;

  local func_preend = function()
    SoundVoice( 0 );
    ObjSet("spr_ruralroad_coach2",{alp=1})
    ObjSet("anm_ruralroad_anm_elisabet_loc_anm",{visible=1,active=1});
    ObjSet( "anm_ruralroad_anm_willyam_loc_anm",{visible=1,active=1});   
    for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], 1, true );
    end;     
    ObjSet("rm_ruralroad",{color_r=1,color_g=1,color_b=1})
    --VidPause("vid_ruralroad_vid_coach_stop",1)
    --ObjAnimate( "vid_ruralroad_vid_coach_stop", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
    int.DialogVideoHide();
    ld.Lock(1);
    ld.StartTimer( 0.5, func_end )
    SoundEnv( "aud_ruralroad_env" )
  end;
  
  cmn.CallEventHandler( "clk_anmcoach1_beg" );
  --common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()
  SoundEnv(0);
  --ObjAttach("vid_ruralroad_vid_coach_stop","rm_ruralroad");
  SoundVid("aud_coach_stop_217");
  -- SoundVoice( "aud_abduction_411_voc" )
  VidPlay("vid_ruralroad_vid_coach_stop",func_preend);


  for i = 1, #widget_settings do
    interface.WidgetSetVisible( widget_settings[i], 0, false );
  end;  
  int.DialogVideoShow( "vid_ruralroad_vid_coach_stop", 1, func_preend, 1 ); 

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_ruralroad_elizabeth2" ] = { type = "click", use_place = "gfx_ruralroad_dlg_ruralroad_elizabeth2_zone", room = "rm_ruralroad" };

private.dlg_ruralroad_elizabeth2_logic = function()
  ObjSet( "gfx_ruralroad_dlg_ruralroad_william2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_ruralroad_elizabeth2_beg = function()
  ObjDelete( "gfx_ruralroad_dlg_ruralroad_elizabeth2_zone" );
end;
private.dlg_ruralroad_elizabeth2_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_ruralroad_elizabeth2", private.dlg_ruralroad_elizabeth2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_elizabeth2", private.dlg_ruralroad_elizabeth2_end, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_elizabeth2", private.dlg_ruralroad_elizabeth2_logic );
cmn.AddSubscriber( "dlg_ruralroad_elizabeth2_beg", private.dlg_ruralroad_elizabeth2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_elizabeth2_end", private.dlg_ruralroad_elizabeth2_end, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_elizabeth2_end", private.dlg_ruralroad_elizabeth2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_ruralroad_elizabeth2( obj )

  cmn.CallEventHandler( "dlg_ruralroad_elizabeth2_beg" );
  --common_impl.Lock(1);
  common_impl.dialog_character_loc = "anm_ruralroad_anm_elisabet_loc_anm"
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  common_impl.Start( "elizabeth2", 2, nil, nil, true, "dlg_ruralroad_elizabeth2_end", {"aud_elizabeth_2_voc"} );

end;

private.dlg_ruralroad_elizabeth2_end = function()
  ObjSet( "dlg_ruralroad_elizabeth2", {bake=1} );
  cmn.SetEventDone( "dlg_ruralroad_elizabeth2" );
  cmn.CallEventHandler( "dlg_ruralroad_elizabeth2_end" );
  --common_impl.Lock(0);
  --common_impl.Lock(0);
  ld.ShowBbt("after_dlg_elizabeth2")
end;
function public.dlg_ruralroad_elizabeth2_end()
  private.dlg_ruralroad_elizabeth2_end()
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_ruralroad_william2" ] = { type = "click", use_place = "gfx_ruralroad_dlg_ruralroad_william2_zone", room = "rm_ruralroad" };

private.dlg_ruralroad_william2_logic = function()
  ObjSet( "gfx_ruralroad_clk_anmcoach2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_ruralroad_william2_beg = function()
  ObjDelete( "gfx_ruralroad_dlg_ruralroad_william2_zone" );
end;
private.dlg_ruralroad_william2_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_ruralroad_william2", private.dlg_ruralroad_william2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_william2", private.dlg_ruralroad_william2_end, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_william2", private.dlg_ruralroad_william2_logic );
cmn.AddSubscriber( "dlg_ruralroad_william2_beg", private.dlg_ruralroad_william2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_william2_end", private.dlg_ruralroad_william2_end, private.room_objname );
cmn.AddSubscriber( "dlg_ruralroad_william2_end", private.dlg_ruralroad_william2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_ruralroad_william2( obj )

  cmn.CallEventHandler( "dlg_ruralroad_william2_beg" );
  --common_impl.Lock(1);
  common_impl.dialog_character_loc = "anm_ruralroad_anm_willyam_loc_anm"
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  common_impl.Start( "william2", 3, nil, nil, true, "dlg_ruralroad_william2_end", {"aud_william_3_voc","aud_william_4_voc"} );

end;

private.dlg_ruralroad_william2_end = function()
  ObjSet( "dlg_ruralroad_william2", {bake=1} );
  cmn.SetEventDone( "dlg_ruralroad_william2" );
  cmn.CallEventHandler( "dlg_ruralroad_william2_end" );
  --common_impl.Lock(0);
  --common_impl.Lock(0);
  ld.ShowBbt("after_dlg_william2")
end;
function public.dlg_ruralroad_william2_end()
  private.dlg_ruralroad_william2_end()
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmcoach2" ] = { type = "click", use_place = "gfx_ruralroad_clk_anmcoach2_zone", room = "rm_ruralroad" };

private.clk_anmcoach2_logic = function()
  ObjSet( "grm_ruralroad_nearpub", { visible = 1, input = 1, active = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_ruralroad_nearpub_focus");
    end;
  ObjSet( "gzz_ruralroad_ravine", { active = 1, input = 1, visible = 1} );
  ObjSet( "gzz_ruralroad_brickwork", { active = 1, input = 1, visible = 1} );
  
end;
private.clk_anmcoach2_beg = function()
  ObjDelete( "gfx_ruralroad_clk_anmcoach2_zone" );
  
end;
private.clk_anmcoach2_end = function()
  ObjDelete("spr_ruralroad_coach2")  
  ObjDelete("vid_ruralroad_vid_coach_leaves")
  ObjDelete("anm_ruralroad_anm_willyam_loc_anm")
  ObjDelete("anm_ruralroad_anm_elisabet_loc_anm")  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmcoach2", private.clk_anmcoach2_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmcoach2", private.clk_anmcoach2_end, private.room_objname );
cmn.AddSubscriber( "clk_anmcoach2", private.clk_anmcoach2_logic );
cmn.AddSubscriber( "clk_anmcoach2_beg", private.clk_anmcoach2_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmcoach2_end", private.clk_anmcoach2_end, private.room_objname );
cmn.AddSubscriber( "clk_anmcoach2_end", private.clk_anmcoach2_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmcoach2()

  local func_end = function()
    cmn.SetEventDone( "clk_anmcoach2" );
    cmn.CallEventHandler( "clk_anmcoach2_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_clk_anmcoach1");
    SoundTheme( "aud_adventure1_mus" );
  end;
  local func_step = function ()
    ObjAttach("vid_ruralroad_vid_coach_leaves","rm_ruralroad")
    ObjDelete("spr_ruralroad_coach2")    
    VidPlay("vid_ruralroad_vid_coach_leaves",func_end)    
    SoundSfx( "aud_coach_leaves_241" );
  end
  cmn.CallEventHandler( "clk_anmcoach2_beg" );
  common_impl.Lock(1);

  
  --SoundSfx( 0 )
  ObjAnimate( "anm_ruralroad_anm_willyam_loc_anm", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
  ObjAnimate( "anm_ruralroad_anm_elisabet_loc_anm", 8, 0, 0, func_step, {0,0,1, 0.5,0,0} );
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_baggage *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_handbag" ] = { type = "get", get_obj = "spr_baggage_handbag", room = "rm_ruralroad", zz = "zz_baggage", zz_gate = "gzz_ruralroad_baggage" };

private.get_handbag_logic = function()
  
end;
private.get_handbag_inv = function()
  interface.InventoryItemAdd("inv_handbag","spr_baggage_handbag");
  ObjSet( "inv_handbag", { drag = 0 } );
end;
private.get_handbag_beg = function()
  ObjDelete("gfx_baggage_handbag")
end;
private.get_handbag_end = function()
  ObjDelete("spr_baggage_handbag_sh")
  if common_impl.ZzCompleteCheck("get_handbag") then ObjSet( common_impl.hint["get_handbag"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_ruralroad_tr_handbag");
end;

cmn.AddSubscriber( "get_handbag", private.get_handbag_inv );
cmn.AddSubscriber( "get_handbag", private.get_handbag_beg, private.room_objname );
cmn.AddSubscriber( "get_handbag", private.get_handbag_end, private.room_objname );
cmn.AddSubscriber( "get_handbag", private.get_handbag_logic );
--------------------------------------------------------------------
function public.get_handbag()
  cmn.SetEventDone( "get_handbag" );
  cmn.CallEventHandler( "get_handbag" );
  if common_impl.ZzCompleteCheck("get_handbag") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletfeather1" ] = { type = "use", inv_obj = "inv_amuletfeather1", use_place = "gfx_baggage_amuletfeather1_zone", room = "rm_ruralroad", zz = "zz_baggage", zz_gate = "gzz_ruralroad_baggage" };

private.use_amuletfeather1_logic = function()
  if ld.CheckRequirements( {"use_amuletfeather1","use_amuletfeather2"} ) then
    ObjSet( "gfx_baggage_clk_baggageho_zone", { visible = 1, input = 1 } )
  end;

end;
private.use_amuletfeather1_inv = function()
  common_impl.ProcessMultiUseAll("amuletfeather1", "amuletfeather1")
end;
private.use_amuletfeather1_beg = function()
  ObjDelete( "gfx_baggage_amuletfeather1_zone" );
end;
private.use_amuletfeather1_end = function()
  ObjSet( "anm_baggage_amulet1", {animfunc="end_amulet1"} );
  if common_impl.ZzCompleteCheck("use_amuletfeather1") then ObjSet( common_impl.hint["use_amuletfeather1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletfeather1", private.use_amuletfeather1_inv );
cmn.AddSubscriber( "use_amuletfeather1", private.use_amuletfeather1_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletfeather1", private.use_amuletfeather1_end, private.room_objname );
cmn.AddSubscriber( "use_amuletfeather1", private.use_amuletfeather1_logic );
cmn.AddSubscriber( "use_amuletfeather1_inv", private.use_amuletfeather1_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletfeather1_beg", private.use_amuletfeather1_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletfeather1_end", private.use_amuletfeather1_end, private.room_objname );
cmn.AddSubscriber( "use_amuletfeather1_end", private.use_amuletfeather1_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletfeather1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletfeather1" );
    cmn.CallEventHandler( "use_amuletfeather1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletfeather1") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletfeather1_inv" );
  cmn.CallEventHandler( "use_amuletfeather1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_baggage_amulet1", "use_amulet1", func_end );
  SoundSfx( "aud_use_feather_baggage" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletfeather2" ] = { type = "use", inv_obj = "inv_amuletfeather2", use_place = "gfx_baggage_amuletfeather2_zone", room = "rm_ruralroad", zz = "zz_baggage", zz_gate = "gzz_ruralroad_baggage" };

private.use_amuletfeather2_logic = function()
  if ld.CheckRequirements( {"use_amuletfeather2","use_amuletfeather1"} ) then
    ObjSet( "gfx_baggage_clk_baggageho_zone", { visible = 1, input = 1 } )
  end;

end;
private.use_amuletfeather2_inv = function()
  common_impl.ProcessMultiUseAll("amuletfeather2", "amuletfeather2")
end;
private.use_amuletfeather2_beg = function()
  ObjDelete( "gfx_baggage_amuletfeather2_zone" );
end;
private.use_amuletfeather2_end = function()
  ObjSet( "anm_baggage_amulet2", {animfunc="end_amulet2"} );
  if common_impl.ZzCompleteCheck("use_amuletfeather2") then ObjSet( common_impl.hint["use_amuletfeather2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletfeather2", private.use_amuletfeather2_inv );
cmn.AddSubscriber( "use_amuletfeather2", private.use_amuletfeather2_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletfeather2", private.use_amuletfeather2_end, private.room_objname );
cmn.AddSubscriber( "use_amuletfeather2", private.use_amuletfeather2_logic );
cmn.AddSubscriber( "use_amuletfeather2_inv", private.use_amuletfeather2_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletfeather2_beg", private.use_amuletfeather2_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletfeather2_end", private.use_amuletfeather2_end, private.room_objname );
cmn.AddSubscriber( "use_amuletfeather2_end", private.use_amuletfeather2_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletfeather2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletfeather2" );
    cmn.CallEventHandler( "use_amuletfeather2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletfeather2") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletfeather2_inv" );
  cmn.CallEventHandler( "use_amuletfeather2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_baggage_amulet2", "use_amulet2", func_end );
  SoundSfx( "aud_use_feather_baggage" );


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_baggageho" ] = { type = "click", use_place = "gfx_baggage_clk_baggageho_zone", room = "rm_ruralroad", zz = "zz_baggage", zz_gate = "gzz_ruralroad_baggage" };

private.clk_baggageho_logic = function()
  ObjSet( "obj_baggage_ho_root", { visible = 1, input = 1, alp = 1 } )
end;
private.clk_baggageho_beg = function()
  ObjDelete( "gfx_baggage_clk_baggageho_zone" );
  ObjDelete("anm_baggage_amulet1")
  ObjDelete("anm_baggage_amulet2")  
end;
private.clk_baggageho_end = function()
  ObjSet( "anm_baggage_cover", {animfunc="ho_end"} );
  ObjDelete("spr_ruralroad_close")
  ObjSet( "spr_ruralroad_open", {visible = 1} );
  if common_impl.ZzCompleteCheck("clk_baggageho") then ObjSet( common_impl.hint["clk_baggageho"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_baggageho", private.clk_baggageho_beg, private.room_objname );
cmn.AddSubscriber( "clk_baggageho", private.clk_baggageho_end, private.room_objname );
cmn.AddSubscriber( "clk_baggageho", private.clk_baggageho_logic );
cmn.AddSubscriber( "clk_baggageho_beg", private.clk_baggageho_beg, private.room_objname );
cmn.AddSubscriber( "clk_baggageho_end", private.clk_baggageho_end, private.room_objname );
cmn.AddSubscriber( "clk_baggageho_end", private.clk_baggageho_logic );
--------------------------------------------------------------------------------------------
function public.clk_baggageho()

  local func_end = function()
    cmn.SetEventDone( "clk_baggageho" );
    cmn.CallEventHandler( "clk_baggageho_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_baggageho") then ld.CloseSubRoom() end;
    private.win_baggage_gm.task_panel_show()
  end;

  cmn.CallEventHandler( "clk_baggageho_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_baggage_cover", "open_cover", func_end );
  SoundSfx( "aud_touch_baggage" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
private.win_baggage_hint = function() 
  local gm = private.win_baggage_gm;
  for i = 1, #gm.tasks do
    for j = 1, #gm.tasks[i] do
      if not ng_global.progress["std"]["win_baggage"].state.find[ gm.tasks[i][j] ] then
        common_impl.HintShowAnm( "spr_baggage_"..gm.tasks[i][j] )
        return
      end;
    end
  end
end
common_impl.hint[ "win_baggage" ] = { type = "click", use_place = "obj_baggage_ho_root", room = "rm_ruralroad", zz = "zz_baggage", zz_gate = "gzz_ruralroad_baggage", hint = private.win_baggage_hint };

private.win_baggage_logic = function()
  interface.InventoryItemAdd("inv_cane","spr_baggage_cane");
end;
private.win_baggage_beg = function()
  --ObjDelete( "obj_baggage_ho_root" );
  ObjSet( "spr_baggage_cane", { visible = 1, input = 1 } )
end;
private.win_baggage_end = function()
  if common_impl.ZzCompleteCheck("win_baggage") then ObjSet( common_impl.hint["win_baggage"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_baggage", private.win_baggage_beg, private.room_objname );
cmn.AddSubscriber( "win_baggage", private.win_baggage_end, private.room_objname );
cmn.AddSubscriber( "win_baggage", private.win_baggage_logic );
cmn.AddSubscriber( "win_baggage_beg", private.win_baggage_beg, private.room_objname );
cmn.AddSubscriber( "win_baggage_end", private.win_baggage_end, private.room_objname );
cmn.AddSubscriber( "win_baggage_end", private.win_baggage_logic );
--------------------------------------------------------------------------------------------
function public.win_baggage()

  local func_end = function()
    cmn.SetEventDone( "win_baggage" );
    cmn.CallEventHandler( "win_baggage_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_baggage") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_baggage_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;
function private.win_baggage_load()
  
  
  if not private.win_baggage_gm then
    private.win_baggage_gm = {}
    local gm = private.win_baggage_gm;

    gm.tasks = {
      {"bead","butterfly","caneho","flute","mask","shell"};
    }

    function gm.save()
      ng_global.progress["std"]["win_baggage"].state = ld.TableCopy( gm.state )
    end;

    gm.state = {}

    if ld.CheckRequirements( { "win_baggage" } ) then
      ng_global.progress["std"]["win_baggage"].state = {}
      ng_global.progress["std"]["win_baggage"].state.lvl = 1
      ng_global.progress["std"]["win_baggage"].state.find = {}
      for i = 1, #gm.tasks do
        for j = 1, #gm.tasks[i] do
          ng_global.progress["std"]["win_baggage"].state.find[ gm.tasks[i][j] ] = true;
        end
      end
    end

    if not ng_global.progress["std"]["win_baggage"].state then
      gm.state.lvl = 1
      gm.state.find = {}
      gm.save()
    else
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_baggage"].state )
      
    end;

    function gm.task_find( task )
      local o = ObjGet( "txt_baggage_task_"..ld.TableContains( gm.tasks[gm.state.lvl], task, true ) )
      local clr = int_taskpanel_impl.GetTaskCompletedColors()
      ObjAnimate( o.name, 12,0,0, _, { 0,0,o.color_r,o.color_g,o.color_b, 0.35,0,clr.color_r,clr.color_g,clr.color_b } )

      common_impl.FxAnmObj( "spr_baggage_"..task )

    end;

    function gm.task_panel_show( func )
      ObjAttach( "spr_baggage_task_panel", "int_frame_subroom_impl" )
      ObjSet( "spr_baggage_task_panel", { alp = 0, pos_y = 225 } )
      ObjAnimate( "spr_baggage_task_panel", 8,0,0, func, { 0,0,0, 0.35,0,1 } )
    end

    function gm.task_panel_hide( func )
      ObjAnimate( "spr_baggage_task_panel", 8,0,0, function() 
        ObjDetach( "spr_baggage_task_panel" )
        if func then
          func()
        end;
      end, { 0,0,1, 0.35,0,0 } )
    end

    function gm.task_panel_hide_fast()
      ObjDetach( "spr_baggage_task_panel" )
    end
      
    function gm.event_mdown( task )
      gm.state.find[ task ] = true

      gm.task_find( task )

      local win = true
      for i = 1, #gm.tasks[gm.state.lvl] do
        if not gm.state.find[gm.tasks[ gm.state.lvl][i] ] then
          win = false
          break
        end;
      end;
      
      if win then
        if gm.state.lvl == #gm.tasks then
          gm.task_panel_hide()
          ld.CloseSubRoom()
          ObjDelete( "gfx_baggage_cane" )
          --     SoundSfx( "aud_ho_win" )
          int_dialog_ho.Show( "spr_baggage_cane" )
          cmn.SetEventDone( "win_baggage" );
        else
          gm.state.lvl = gm.state.lvl + 1
          gm.task_panel_hide( function() 
            gm.restore()
            gm.task_panel_show()
          end )
        end;
      end;
      gm.save()
    end;

    function gm.restore()
      for i = 1, #gm.tasks do
        for j = 1, #gm.tasks[i] do
          local input = true;
          if input then
            input = i == gm.state.lvl
          end;
          if input then
            ObjSet( "txt_baggage_task_"..j, { text = "tsk_baggage_"..gm.tasks[i][j] } )
            input = not gm.state.find[ gm.tasks[i][j] ]

            local o = ObjGet( "txt_baggage_task_"..j )
            local clr = input and int_taskpanel_impl.GetTaskColors() or int_taskpanel_impl.GetTaskCompletedColors()
            ObjAnimate( o.name, 12,0,0, _, { 0,0,o.color_r,o.color_g,o.color_b, 0.35,0,clr.color_r,clr.color_g,clr.color_b } )
          end;
          ObjSet( "spr_baggage_"..gm.tasks[i][j], { 
            event_mdown = function() gm.event_mdown( gm.tasks[i][j] ); end;
            input = input;
            alp = gm.state.find[ gm.tasks[i][j] ] and 0 or 1;
          } )
        end;
      end;
    end;
    gm.restore();

  end

  if ld.CheckRequirements( { "clk_baggageho" } )  then
    private.win_baggage_gm.task_panel_show()
  end;

end
--------------------------------------------------------------------
--common_impl.hint[ "get_cane" ] = { type = "get", get_obj = "spr_baggage_cane", room = "rm_ruralroad", zz = "zz_baggage", zz_gate = "gzz_ruralroad_baggage" };
--
--private.get_cane_logic = function()
--  
--end;
--private.get_cane_inv = function()
--  interface.InventoryItemAdd("inv_cane","spr_baggage_cane");
--end;
--private.get_cane_beg = function()
--  ObjDelete("gfx_baggage_cane")
--end;
--private.get_cane_end = function()
--  if common_impl.ZzCompleteCheck("get_cane") then ObjSet( common_impl.hint["get_cane"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
--
--cmn.AddSubscriber( "get_cane", private.get_cane_inv );
--cmn.AddSubscriber( "get_cane", private.get_cane_beg, private.room_objname );
--cmn.AddSubscriber( "get_cane", private.get_cane_end, private.room_objname );
--cmn.AddSubscriber( "get_cane", private.get_cane_logic );
----------------------------------------------------------------------
--function public.get_cane()
--  cmn.SetEventDone( "get_cane" );
--  cmn.CallEventHandler( "get_cane" );
--  if common_impl.ZzCompleteCheck("get_cane") then ld.CloseSubRoom() end;
--end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bush *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_tube1" ] = { type = "get", get_obj = "spr_bush_tube1", room = "rm_ruralroad", zz = "zz_bush", zz_gate = "gzz_ruralroad_bush" };

private.get_tube1_logic = function()
  
end;
private.get_tube1_inv = function()
  interface.InventoryItemAdd("inv_tube","spr_bush_tube1",function() level_inv.ProcessGetTubeAll( "get_tube1" ) end);
end;
private.get_tube1_beg = function()
  ObjDelete("gfx_bush_tube1")
end;
private.get_tube1_end = function()
  ObjDelete("spr_bush_sh_tube1")
  ObjDelete("spr_ruralroad_tube1")
  if common_impl.ZzCompleteCheck("get_tube1") then ObjSet( common_impl.hint["get_tube1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_tube1", private.get_tube1_inv );
cmn.AddSubscriber( "get_tube1", private.get_tube1_beg, private.room_objname );
cmn.AddSubscriber( "get_tube1", private.get_tube1_end, private.room_objname );
cmn.AddSubscriber( "get_tube1", private.get_tube1_logic );
--------------------------------------------------------------------
function public.get_tube1()
  cmn.SetEventDone( "get_tube1" );
  cmn.CallEventHandler( "get_tube1" );
  if common_impl.ZzCompleteCheck("get_tube1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pruner" ] = { type = "use", inv_obj = "inv_pruner", use_place = "gfx_bush_pruner_zone", room = "rm_ruralroad", zz = "zz_bush", zz_gate = "gzz_ruralroad_bush" };

private.use_pruner_logic = function()
  ObjSet( "spr_bush_puzzlepiece2", { input = 1 } )

end;
private.use_pruner_inv = function()
  common_impl.ProcessMultiUseAll("pruner", "pruner")
end;
private.use_pruner_beg = function()
  ObjDelete( "gfx_bush_pruner_zone" );
end;
private.use_pruner_end = function()
  ObjSet( "gfx_bush_puzzlepiece2", {visible = 1} );
  ObjSet( "anm_bush_anm", {animfunc="end_pruner"} );
  if common_impl.ZzCompleteCheck("use_pruner") then ObjSet( common_impl.hint["use_pruner"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pruner", private.use_pruner_inv );
cmn.AddSubscriber( "use_pruner", private.use_pruner_beg, private.room_objname );
cmn.AddSubscriber( "use_pruner", private.use_pruner_end, private.room_objname );
cmn.AddSubscriber( "use_pruner", private.use_pruner_logic );
cmn.AddSubscriber( "use_pruner_inv", private.use_pruner_inv, private.room_objname );
cmn.AddSubscriber( "use_pruner_beg", private.use_pruner_beg, private.room_objname );
cmn.AddSubscriber( "use_pruner_end", private.use_pruner_end, private.room_objname );
cmn.AddSubscriber( "use_pruner_end", private.use_pruner_logic );
--------------------------------------------------------------------------------------------
function public.use_pruner( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pruner" );
    cmn.CallEventHandler( "use_pruner_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pruner") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pruner_inv" );
  cmn.CallEventHandler( "use_pruner_beg" );
  common_impl.Lock(1);

  if ld.CheckRequirements( {"get_tube1"} ) then
     ld.AnimPlay( "anm_bush_anm", "use_pruner", func_end );
  else 
    ObjSet( "spr_bush_sh_tube1", {visible = 0} );
    ObjSet( "spr_bush_tube1", {visible = 0} );
    ld.AnimPlay( "anm_bush_anm", "use_pruner1",function()
       ObjSet( "spr_bush_sh_tube1", {visible = 1} );
       ObjSet( "spr_bush_tube1", {visible = 1} );
       func_end();
    end);
  end;   
     
  SoundSfx( "aud_use_pruner_bushes" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_puzzlepiece2" ] = { type = "get", get_obj = "spr_bush_puzzlepiece2", room = "rm_ruralroad", zz = "zz_bush", zz_gate = "gzz_ruralroad_bush" };

private.get_puzzlepiece2_logic = function()
  
end;
private.get_puzzlepiece2_inv = function()
  interface.InventoryItemAdd("inv_puzzlepiece2","spr_bush_puzzlepiece2");
end;
private.get_puzzlepiece2_beg = function()
  ObjSet( "spr_bush_puzzlepiece2", {visible = 1} );
  ObjDelete("gfx_bush_puzzlepiece2")
end;
private.get_puzzlepiece2_end = function()
  ObjSet( "anm_bush_anm", {animfunc="end_puzzle"} );
  if common_impl.ZzCompleteCheck("get_puzzlepiece2") then ObjSet( common_impl.hint["get_puzzlepiece2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_ruralroad_tr_puzzlepiece2");
end;

cmn.AddSubscriber( "get_puzzlepiece2", private.get_puzzlepiece2_inv );
cmn.AddSubscriber( "get_puzzlepiece2", private.get_puzzlepiece2_beg, private.room_objname );
cmn.AddSubscriber( "get_puzzlepiece2", private.get_puzzlepiece2_end, private.room_objname );
cmn.AddSubscriber( "get_puzzlepiece2", private.get_puzzlepiece2_logic );
--------------------------------------------------------------------
function public.get_puzzlepiece2()
  cmn.SetEventDone( "get_puzzlepiece2" );
  cmn.CallEventHandler( "get_puzzlepiece2" );
  if common_impl.ZzCompleteCheck("get_puzzlepiece2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_frontcarriage *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_medicine" ] = { type = "get", get_obj = "spr_frontcarriage_medicine", room = "rm_ruralroad", zz = "zz_frontcarriage", zz_gate = "gzz_ruralroad_frontcarriage" };

private.get_medicine_logic = function()
  if ld.CheckRequirements( {"get_medicine","get_glassshard1"} ) then
    ObjSet( "gfx_frontcarriage_dagger_zone", {input = 1, visible = 1} );
  end
end;
private.get_medicine_inv = function()
  interface.InventoryItemAdd("inv_medicine","spr_frontcarriage_medicine");
end;
private.get_medicine_beg = function()
  ObjDelete("gfx_frontcarriage_medicine")
end;
private.get_medicine_end = function()
  ObjDelete("spr_frontcarriage_sh_medicine")
  if common_impl.ZzCompleteCheck("get_medicine") then ObjSet( common_impl.hint["get_medicine"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_medicine", private.get_medicine_inv );
cmn.AddSubscriber( "get_medicine", private.get_medicine_beg, private.room_objname );
cmn.AddSubscriber( "get_medicine", private.get_medicine_end, private.room_objname );
cmn.AddSubscriber( "get_medicine", private.get_medicine_logic );
--------------------------------------------------------------------
function public.get_medicine()
  cmn.SetEventDone( "get_medicine" );
  cmn.CallEventHandler( "get_medicine" );
  if common_impl.ZzCompleteCheck("get_medicine") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_glassshard1" ] = { type = "get", get_obj = "spr_frontcarriage_glassshard1", room = "rm_ruralroad", zz = "zz_frontcarriage", zz_gate = "gzz_ruralroad_frontcarriage" };

private.get_glassshard1_logic = function()
  if ld.CheckRequirements( {"get_medicine","get_glassshard1"} ) then
    ObjSet( "gfx_frontcarriage_dagger_zone", {input = 1, visible = 1} );
  end  
end;
private.get_glassshard1_inv = function()
  interface.InventoryItemAdd("inv_glassshard","spr_frontcarriage_glassshard1",function() level_inv.ProcessGetGlassshardAll( "get_glassshard1" ) end);
end;
private.get_glassshard1_beg = function()
  ObjDelete("gfx_frontcarriage_glassshard1")
end;
private.get_glassshard1_end = function()
  ObjDelete("spr_frontcarriage_sh_glassshard1")
  if common_impl.ZzCompleteCheck("get_glassshard1") then ObjSet( common_impl.hint["get_glassshard1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_glassshard1", private.get_glassshard1_inv );
cmn.AddSubscriber( "get_glassshard1", private.get_glassshard1_beg, private.room_objname );
cmn.AddSubscriber( "get_glassshard1", private.get_glassshard1_end, private.room_objname );
cmn.AddSubscriber( "get_glassshard1", private.get_glassshard1_logic );
--------------------------------------------------------------------
function public.get_glassshard1()
  cmn.SetEventDone( "get_glassshard1" );
  cmn.CallEventHandler( "get_glassshard1" );
  if common_impl.ZzCompleteCheck("get_glassshard1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dagger" ] = { type = "use", inv_obj = "inv_dagger", use_place = "gfx_frontcarriage_dagger_zone", room = "rm_ruralroad", zz = "zz_frontcarriage", zz_gate = "gzz_ruralroad_frontcarriage" };

private.use_dagger_logic = function()
  ObjSet( "spr_frontcarriage_plaid", { input = 1 } )

end;
private.use_dagger_inv = function()
  common_impl.ProcessMultiUseAll("dagger", "dagger")
end;
private.use_dagger_beg = function()
  ObjDelete( "gfx_frontcarriage_dagger_zone" );
end;
private.use_dagger_end = function()
  ObjSet( "gfx_frontcarriage_plaid", {visible = 1} );
  ObjSet( "anm_frontcarriage_plaid", {animfunc="end_dirk"} );
  if common_impl.ZzCompleteCheck("use_dagger") then ObjSet( common_impl.hint["use_dagger"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dagger", private.use_dagger_inv );
cmn.AddSubscriber( "use_dagger", private.use_dagger_beg, private.room_objname );
cmn.AddSubscriber( "use_dagger", private.use_dagger_end, private.room_objname );
cmn.AddSubscriber( "use_dagger", private.use_dagger_logic );
cmn.AddSubscriber( "use_dagger_inv", private.use_dagger_inv, private.room_objname );
cmn.AddSubscriber( "use_dagger_beg", private.use_dagger_beg, private.room_objname );
cmn.AddSubscriber( "use_dagger_end", private.use_dagger_end, private.room_objname );
cmn.AddSubscriber( "use_dagger_end", private.use_dagger_logic );
--------------------------------------------------------------------------------------------
function public.use_dagger( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dagger" );
    cmn.CallEventHandler( "use_dagger_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dagger") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dagger_inv" );
  cmn.CallEventHandler( "use_dagger_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_frontcarriage_plaid", "use_dirk", func_end );
  SoundSfx( "aud_use_knife_plaid" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_plaid" ] = { type = "get", get_obj = "spr_frontcarriage_plaid", room = "rm_ruralroad", zz = "zz_frontcarriage", zz_gate = "gzz_ruralroad_frontcarriage" };

private.get_plaid_logic = function()
  
end;
private.get_plaid_inv = function()
  interface.InventoryItemAdd("inv_plaid","spr_frontcarriage_plaid");
end;
private.get_plaid_beg = function()
  ObjSet( "spr_frontcarriage_plaid", {visible = 1} );
  ObjDelete("gfx_frontcarriage_plaid")
end;
private.get_plaid_end = function()
  ObjDelete("anm_frontcarriage_plaid")
  if common_impl.ZzCompleteCheck("get_plaid") then ObjSet( common_impl.hint["get_plaid"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_plaid", private.get_plaid_inv );
cmn.AddSubscriber( "get_plaid", private.get_plaid_beg, private.room_objname );
cmn.AddSubscriber( "get_plaid", private.get_plaid_end, private.room_objname );
cmn.AddSubscriber( "get_plaid", private.get_plaid_logic );
--------------------------------------------------------------------
function public.get_plaid()
  cmn.SetEventDone( "get_plaid" );
  cmn.CallEventHandler( "get_plaid" );
  if common_impl.ZzCompleteCheck("get_plaid") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_rivet1" ] = { type = "use", inv_obj = "inv_rivet1", use_place = "gfx_frontcarriage_rivet1_zone", room = "rm_ruralroad", zz = "zz_frontcarriage", zz_gate = "gzz_ruralroad_frontcarriage" };

private.use_rivet1_logic = function()
  if ld.CheckRequirements( {"use_rivet1","use_rivet2"} ) then
    ObjSet( "spr_frontcarriage_coin", { input = 1 } )
  end;

end;
private.use_rivet1_inv = function()
  common_impl.ProcessMultiUseAll("rivet1", "rivet1")
end;
private.use_rivet1_beg = function()
  ObjDelete( "gfx_frontcarriage_rivet1_zone" );
end;
private.use_rivet1_end = function()
  if ld.CheckRequirements( {"use_rivet1","use_rivet2"} ) then
    ObjSet( "gfx_frontcarriage_coin", {visible=1} );
    ObjSet( "anm_frontcarriage_idle_pocket", { animfunc="end_rivet" } )
    ObjDelete("anm_frontcarriage_use_rivet_1")
    ObjDelete("anm_frontcarriage_use_rivet_2")
    ObjDelete("spr_ruralroad_tr_rivet1");
    ObjDelete("spr_ruralroad_tr_rivet2");
    ObjDelete("spr_ruralroad_tr_pocket");
    ObjSet( "spr_ruralroad_tr_pocket_open", {visible = 1} );
    ObjSet( "spr_ruralroad_tr_coin", {visible = 1} );
  else 
    ObjSet( "anm_frontcarriage_use_rivet_1", {frame=999,animfunc="use_rivet"} );
    ObjSet( "spr_ruralroad_tr_rivet1", {visible = 1} );
  end;

  if common_impl.ZzCompleteCheck("use_rivet1") then ObjSet( common_impl.hint["use_rivet1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rivet1", private.use_rivet1_inv );
cmn.AddSubscriber( "use_rivet1", private.use_rivet1_beg, private.room_objname );
cmn.AddSubscriber( "use_rivet1", private.use_rivet1_end, private.room_objname );
cmn.AddSubscriber( "use_rivet1", private.use_rivet1_logic );
cmn.AddSubscriber( "use_rivet1_inv", private.use_rivet1_inv, private.room_objname );
cmn.AddSubscriber( "use_rivet1_beg", private.use_rivet1_beg, private.room_objname );
cmn.AddSubscriber( "use_rivet1_end", private.use_rivet1_end, private.room_objname );
cmn.AddSubscriber( "use_rivet1_end", private.use_rivet1_logic );
--------------------------------------------------------------------------------------------
function public.use_rivet1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_rivet1" );
    cmn.CallEventHandler( "use_rivet1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rivet1") then ld.CloseSubRoom() end;
  end;

  local f_step = function ()
    if ld.CheckRequirements( {"use_rivet2"} ) then
      ObjDelete("anm_frontcarriage_use_rivet_1")
      ObjDelete("anm_frontcarriage_use_rivet_2")    
      SoundSfx( "aud_jacket_pocket_open" );  
      ld.AnimPlay( "anm_frontcarriage_idle_pocket", "use_rivet2", func_end );
    else 
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rivet1_inv" );
  cmn.CallEventHandler( "use_rivet1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_frontcarriage_use_rivet_1", "use_rivet", f_step );
  SoundSfx( "aud_use_button" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_rivet2" ] = { type = "use", inv_obj = "inv_rivet2", use_place = "gfx_frontcarriage_rivet2_zone", room = "rm_ruralroad", zz = "zz_frontcarriage", zz_gate = "gzz_ruralroad_frontcarriage" };

private.use_rivet2_logic = function()
  if ld.CheckRequirements( {"use_rivet2","use_rivet1"} ) then
    ObjSet( "spr_frontcarriage_coin", { input = 1 } )
  end;

end;
private.use_rivet2_inv = function()
  common_impl.ProcessMultiUseAll("rivet2", "rivet2")
end;
private.use_rivet2_beg = function()
  ObjDelete( "gfx_frontcarriage_rivet2_zone" );
end;
private.use_rivet2_end = function()
  if ld.CheckRequirements( {"use_rivet1","use_rivet2"} ) then
    ObjSet( "gfx_frontcarriage_coin", {visible=1} );
    ObjSet( "anm_frontcarriage_idle_pocket", { animfunc="end_rivet" } )
    ObjDelete("anm_frontcarriage_use_rivet_1")
    ObjDelete("anm_frontcarriage_use_rivet_2")
    ObjDelete("spr_ruralroad_tr_rivet1");
    ObjDelete("spr_ruralroad_tr_rivet2");
    ObjDelete("spr_ruralroad_tr_pocket");
    ObjSet( "spr_ruralroad_tr_pocket_open", {visible = 1} );
    ObjSet( "spr_ruralroad_tr_coin", {visible = 1} );
  else 
    ObjSet( "anm_frontcarriage_use_rivet_1", {frame=999,animfunc="use_rivet1"} ); 
    ObjSet( "spr_ruralroad_tr_rivet2", {visible = 1} );   
  end;
  if common_impl.ZzCompleteCheck("use_rivet2") then ObjSet( common_impl.hint["use_rivet2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rivet2", private.use_rivet2_inv );
cmn.AddSubscriber( "use_rivet2", private.use_rivet2_beg, private.room_objname );
cmn.AddSubscriber( "use_rivet2", private.use_rivet2_end, private.room_objname );
cmn.AddSubscriber( "use_rivet2", private.use_rivet2_logic );
cmn.AddSubscriber( "use_rivet2_inv", private.use_rivet2_inv, private.room_objname );
cmn.AddSubscriber( "use_rivet2_beg", private.use_rivet2_beg, private.room_objname );
cmn.AddSubscriber( "use_rivet2_end", private.use_rivet2_end, private.room_objname );
cmn.AddSubscriber( "use_rivet2_end", private.use_rivet2_logic );
--------------------------------------------------------------------------------------------
function public.use_rivet2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_rivet2" );
    cmn.CallEventHandler( "use_rivet2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rivet2") then ld.CloseSubRoom() end;
  end;
  local f_step = function ()
  if ld.CheckRequirements( {"use_rivet1"} ) then
      ObjDelete("anm_frontcarriage_use_rivet_1")
      ObjDelete("anm_frontcarriage_use_rivet_2")
      SoundSfx( "aud_jacket_pocket_open" );  
      ld.AnimPlay( "anm_frontcarriage_idle_pocket", "use_rivet2", func_end );
    else 
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rivet2_inv" );
  cmn.CallEventHandler( "use_rivet2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_frontcarriage_use_rivet_2", "use_rivet1", f_step );
  SoundSfx( "aud_use_button" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coin" ] = { type = "get", get_obj = "spr_frontcarriage_coin", room = "rm_ruralroad", zz = "zz_frontcarriage", zz_gate = "gzz_ruralroad_frontcarriage" };

private.get_coin_logic = function()
  
end;
private.get_coin_inv = function()
  interface.InventoryItemAdd("inv_coin","spr_frontcarriage_coin");
end;
private.get_coin_beg = function()
  ObjSet( "spr_frontcarriage_coin", {visible = 1} );
  ObjDelete("gfx_frontcarriage_coin")
end;
private.get_coin_end = function()
  ObjSet( "anm_frontcarriage_idle_pocket", { animfunc="end_coin" } )
  if common_impl.ZzCompleteCheck("get_coin") then ObjSet( common_impl.hint["get_coin"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_ruralroad_tr_coin");
end;

cmn.AddSubscriber( "get_coin", private.get_coin_inv );
cmn.AddSubscriber( "get_coin", private.get_coin_beg, private.room_objname );
cmn.AddSubscriber( "get_coin", private.get_coin_end, private.room_objname );
cmn.AddSubscriber( "get_coin", private.get_coin_logic );
--------------------------------------------------------------------
function public.get_coin()
  cmn.SetEventDone( "get_coin" );
  cmn.CallEventHandler( "get_coin" );
  if common_impl.ZzCompleteCheck("get_coin") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_brickwork *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_barrel1" ] = { type = "get", get_obj = "spr_brickwork_barrel1", room = "rm_ruralroad", zz = "zz_brickwork", zz_gate = "gzz_ruralroad_brickwork" };

private.get_barrel1_logic = function()
  ObjSet( "gfx_brickwork_stone_zone", {input = 1, visible = 1} );
end;
private.get_barrel1_inv = function()
  interface.InventoryItemAdd("inv_barrel","spr_brickwork_barrel1",function() level_inv.ProcessGetBarrelAll( "get_barrel1" ) end);
end;
private.get_barrel1_beg = function()
  ObjDelete("gfx_brickwork_barrel1")
end;
private.get_barrel1_end = function()
  ObjDelete("spr_brickwork_sh_barrel_1")
  ObjDelete("spr_brickwork_sh_barrel_2")  
  ObjDelete("spr_brickwork_grass")
  ObjDelete("spr_ruralroad_barrel2")
  if common_impl.ZzCompleteCheck("get_barrel1") then ObjSet( common_impl.hint["get_barrel1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_barrel1", private.get_barrel1_inv );
cmn.AddSubscriber( "get_barrel1", private.get_barrel1_beg, private.room_objname );
cmn.AddSubscriber( "get_barrel1", private.get_barrel1_end, private.room_objname );
cmn.AddSubscriber( "get_barrel1", private.get_barrel1_logic );
--------------------------------------------------------------------
function public.get_barrel1()
  cmn.SetEventDone( "get_barrel1" );
  cmn.CallEventHandler( "get_barrel1" );
  if common_impl.ZzCompleteCheck("get_barrel1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_stone" ] = { type = "use", inv_obj = "inv_stone", use_place = "gfx_brickwork_stone_zone", room = "rm_ruralroad", zz = "zz_brickwork", zz_gate = "gzz_ruralroad_brickwork" };

private.use_stone_logic = function()
  ObjSet( "gfx_brickwork_win_stones_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_stone_inv = function()
  common_impl.ProcessMultiUseAll("stone", "stone")
end;
private.use_stone_beg = function()
  ObjDelete( "gfx_brickwork_stone_zone" );
end;
private.use_stone_end = function()
  ObjSet( "obj_brickwork_stonesmmg_root", {alp = 1,input=1} );
  ObjSet("anm_brickwork_anm",{animfunc="use_stone_2",frame=0})
  ObjSet("spr_ruralroad_stone_1",{alp=1})
  if common_impl.ZzCompleteCheck("use_stone") then ObjSet( common_impl.hint["use_stone"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stone", private.use_stone_inv );
cmn.AddSubscriber( "use_stone", private.use_stone_beg, private.room_objname );
cmn.AddSubscriber( "use_stone", private.use_stone_end, private.room_objname );
cmn.AddSubscriber( "use_stone", private.use_stone_logic );
cmn.AddSubscriber( "use_stone_inv", private.use_stone_inv, private.room_objname );
cmn.AddSubscriber( "use_stone_beg", private.use_stone_beg, private.room_objname );
cmn.AddSubscriber( "use_stone_end", private.use_stone_end, private.room_objname );
cmn.AddSubscriber( "use_stone_end", private.use_stone_logic );
--------------------------------------------------------------------------------------------
function public.use_stone( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    private.init_stones()
    cmn.MiniGameShow( "stones" );
    
    cmn.SetEventDone( "use_stone" );
    cmn.CallEventHandler( "use_stone_end" );
    
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stone") then ld.CloseSubRoom() end;

  end;
  local f_step = function ()
    ObjAnimate( "obj_brickwork_stonesmmg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stone_inv" );
  cmn.CallEventHandler( "use_stone_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_brickwork_anm", "use_stone_1", f_step );
  SoundSfx( "aud_use_wall_piece_ruralroad" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_stones" ] = { type = "click", use_place = "gfx_brickwork_win_stones_zone", room = "rm_ruralroad", zz = "zz_brickwork", zz_gate = "gzz_ruralroad_brickwork" };

private.win_stones_logic = function()
  if cmn.IsEventDone("win_stones") then
    ObjSet( "gfx_brickwork_clk_opnstones_zone", {active = 1,input = 1, visible = 1} );
    ObjDelete("obj_brickwork_stonesmmg_root")  
  end
end;
private.win_stones_beg = function()
  if cmn.IsEventDone("win_stones") then
    ObjDelete( "gfx_brickwork_win_stones_zone" );
  end
end;
private.win_stones_end = function()
  if cmn.IsEventDone("win_stones") then  
    ObjDelete("spr_ruralroad_stone_2")
  end
  if common_impl.ZzCompleteCheck("win_stones") then ObjSet( common_impl.hint["win_stones"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_stones", private.win_stones_beg, private.room_objname );
cmn.AddSubscriber( "win_stones", private.win_stones_end, private.room_objname );
cmn.AddSubscriber( "win_stones", private.win_stones_logic );
cmn.AddSubscriber( "win_stones_beg", private.win_stones_beg, private.room_objname );
cmn.AddSubscriber( "win_stones_end", private.win_stones_end, private.room_objname );
cmn.AddSubscriber( "win_stones_end", private.win_stones_logic );
--------------------------------------------------------------------------------------------
function public.win_stones()

  local func_end = function()
    cmn.SetEventDone( "win_stones" );
    cmn.CallEventHandler( "win_stones_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_stones") then ld.CloseSubRoom() end;
    public.clk_opnstones()
  end;
  cmn.MiniGameHide( "stones" );   
  cmn.SetEventDone( "win_stones" );
  cmn.CallEventHandler( "win_stones_beg" );
  common_impl.Lock(1);
  --SoundSfx( 0 )

  ObjAnimate( "obj_brickwork_stonesmmg_root", 8, 0, 0, func_end, {0,0,1, 0.5,0,0} );
  

end;
--------------------------------------------------------------------------------------------
function private.init_stones()
  if not (cmn.IsEventStart("win_stones")) then
    ng_global.progress["std"]["win_stones"].state = {0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0}
  end
end

private.stones = {13,14,12,11,10,9,16,15,6,5,4,3,1,2,8,7}
private.cur_stone = nil

function public.clk_stones(num)
  ld.Lock(1)
  num = tonumber( num )
  local obj = "spr_brickwork_s_"..num
  ObjSet( obj, {input = 0} );   
  ObjAnimate( obj, 8, 0, 0, function() private.check_stones(num) end, {0,0,0, 0.5,0,1} );
  SoundSfx( "aud_mg_wall_click" );
end
function private.check_stones(num)
  local f_check = function ()
    local sum = 0
    for i=1,#ng_global.progress["std"]["win_stones"].state do
      sum=sum+ng_global.progress["std"]["win_stones"].state[i]
    end
    if sum==#ng_global.progress["std"]["win_stones"].state then
      public.win_stones()
    else 
      ld.Lock(0)
    end
  end
  
  if not private.cur_stone then
    private.cur_stone = num
    ld.Lock(0);
  elseif private.stones[private.cur_stone]==num then
    SoundSfx( "aud_mg_wall_true" );
    local obj1 = "spr_brickwork_s_"..private.cur_stone
    local obj2 = "spr_brickwork_s_"..num

    
    ObjAnimate( obj1, 8, 0, 0, function()f_check()end, {0,0,1, 0.15,0,0,0.3,0,1,0.45,0,0,0.6,0,1} );
    ObjAnimate( obj2, 8, 0, 0, "", {0,0,1, 0.15,0,0,0.3,0,1,0.45,0,0,0.6,0,1} );
    
    ObjAnimate( obj1, 9, 0, 0,"",{0,0,1,0.5,0,0})
    ObjAnimate( obj1, 11, 0, 0,"",{0,0,1,0.5,0,0})

    ObjAnimate( obj2, 9, 0, 0,"",{0,0,1,0.5,0,0})
    ObjAnimate( obj2, 11, 0, 0,"",{0,0,1,0.5,0,0})
    
    ObjSet( obj1, {input = 0} );    
    ObjSet( obj2, {input = 0} );        
    
    ng_global.progress["std"]["win_stones"].state[private.cur_stone]=1
    ng_global.progress["std"]["win_stones"].state[num]=1  
    private.cur_stone = nil  
  --elseif private.cur_stone == num then
  --  local obj1 = "spr_brickwork_s_"..private.cur_stone
  --  local obj2 = "spr_brickwork_s_"..num
  --  ld.LogTrace( obj1,obj2 );
  --  ObjAnimate( obj1, 8, 0, 0, "", {0,0,1, 0.5,0,0} );
  --  ObjAnimate( obj2, 8, 0, 0, "", {0,0,1, 0.5,0,0} );
  --  ObjSet( obj1, {input = 1} );    
  --  ObjSet( obj2, {input = 1} ); 
  --  private.cur_stone = nil    
  else 

    SoundSfx( "aud_mg_wall_wrong" );
    local obj1 = "spr_brickwork_s_"..private.cur_stone
    local obj2 = "spr_brickwork_s_"..num  
    
    ObjAnimate( obj1, 8, 0, 0, function()ld.Lock(0)end, {0,0,1, 0.5,0,0} );  
    ObjAnimate( obj2, 8, 0, 0, "", {0,0,1, 0.5,0,0} );    
    ObjSet( obj1, {input = 1} );      
    ObjSet( obj2, {input = 1} );      
    private.cur_stone = nil
  end 
end

function private.load_stones()
    if ng_global.progress["std"]["win_stones"].state then
      local sum = 0      
      for i=1,#ng_global.progress["std"]["win_stones"].state do
        if ng_global.progress["std"]["win_stones"].state[i] == 1 then
          sum=sum+ng_global.progress["std"]["win_stones"].state[i]
          ObjSet( "spr_brickwork_s_"..i, {alp = 1,color_r=0,color_b=0,input=0} );
        else 
          ObjSet( "spr_brickwork_s_"..i, {alp = 0,color_r=1,color_b=1,input=1} );
        end
      end
      if sum==#ng_global.progress["std"]["win_stones"].state then
        public.win_stones()
      end 
    end 
end
--------------------------------------------------------------------
function private.win_stones_reset()
  private.cur_stone = nil
  for i=1,16 do
    local param = ObjGet("spr_brickwork_s_"..i)
    ng_global.progress["std"]["win_stones"].state[i] = 0
    ObjSet( param.name, {input = 1} );
    ObjAnimate(param.name, 9, 0, 0, "", {0, 0, param.color_r, 0.5, 0, 1});
    ObjAnimate(param.name, 11, 0, 0, "", {0, 0, param.color_b, 0.5, 0, 1});
    ObjAnimate(param.name, 8, 0, 0, "", {0, 0, param.alp    , 0.5, 0, 0});
  end  
  ld.Lock(1)
  ld.StartTimer( 0.5, function()ld.Lock(0);end )  
end
--------------------------------------------------------------------
function private.win_stones_skip()
  for i=1,16 do
    local param = ObjGet("spr_brickwork_s_"..i)
    ng_global.progress["std"]["win_stones"].state[i] = 1
    ObjSet( param.name, {input = 0} );
    ObjAnimate(param.name, 9, 0, 0, "", {0, 0, param.color_r, 0.5, 0, 0});
    ObjAnimate(param.name, 11, 0, 0, "", {0, 0, param.color_b, 0.5, 0, 0});
    ObjAnimate(param.name, 8, 0, 0, "", {0, 0, param.alp    , 0.5, 0, 1});
  end
  ld.Lock(1)
  ld.StartTimer( 0.7, function()ld.Lock(0);public.win_stones()end )
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_opnstones" ] = { type = "click", use_place = "gfx_brickwork_clk_opnstones_zone", room = "rm_ruralroad", zz = "zz_brickwork", zz_gate = "gzz_ruralroad_brickwork" };

private.clk_opnstones_logic = function()
  ObjSet( "spr_brickwork_bell2", { visible = 1, input = 1, active = 1 } )
end;
private.clk_opnstones_beg = function()
  ObjDelete( "gfx_brickwork_clk_opnstones_zone" );

end;
private.clk_opnstones_end = function()
  ObjSet("anm_brickwork_anm",{animfunc="end_stone_2",frame=0})
  ObjSet( "spr_brickwork_sh_bell2", {visible = 1} );
  if common_impl.ZzCompleteCheck("clk_opnstones") then ObjSet( common_impl.hint["clk_opnstones"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_opnstones", private.clk_opnstones_beg, private.room_objname );
cmn.AddSubscriber( "clk_opnstones", private.clk_opnstones_end, private.room_objname );
cmn.AddSubscriber( "clk_opnstones", private.clk_opnstones_logic );
cmn.AddSubscriber( "clk_opnstones_beg", private.clk_opnstones_beg, private.room_objname );
cmn.AddSubscriber( "clk_opnstones_end", private.clk_opnstones_end, private.room_objname );
cmn.AddSubscriber( "clk_opnstones_end", private.clk_opnstones_logic );
--------------------------------------------------------------------------------------------
function public.clk_opnstones()

  local func_end = function()
    cmn.SetEventDone( "clk_opnstones" );
    cmn.CallEventHandler( "clk_opnstones_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_opnstones") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_opnstones_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_mg_wall_win" );
  ld.AnimPlay( "anm_brickwork_anm", "use_stone_2", func_end );
  

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "get_bell2" ] = { type = "get", get_obj = "spr_brickwork_bell2", room = "rm_ruralroad", zz = "zz_brickwork", zz_gate = "gzz_ruralroad_brickwork" };

private.get_bell2_logic = function()
  
end;
private.get_bell2_inv = function()
  interface.InventoryItemAdd("inv_bell2","spr_brickwork_bell2");
end;
private.get_bell2_beg = function()
  ObjDelete("gfx_brickwork_bell2")
end;
private.get_bell2_end = function()
  ObjDelete("spr_ruralroad_bell2")
  if common_impl.ZzCompleteCheck("get_bell2") then ObjSet( common_impl.hint["get_bell2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bell2", private.get_bell2_inv );
cmn.AddSubscriber( "get_bell2", private.get_bell2_beg, private.room_objname );
cmn.AddSubscriber( "get_bell2", private.get_bell2_end, private.room_objname );
cmn.AddSubscriber( "get_bell2", private.get_bell2_logic );
--------------------------------------------------------------------
function public.get_bell2()
  cmn.SetEventDone( "get_bell2" );
  cmn.CallEventHandler( "get_bell2" );
  if common_impl.ZzCompleteCheck("get_bell2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_ravine *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_rod" ] = { type = "use", inv_obj = "inv_rod", use_place = "gfx_ravine_rod_zone", room = "rm_ruralroad", zz = "zz_ravine", zz_gate = "gzz_ruralroad_ravine" };

private.use_rod_logic = function()
  ObjSet( "spr_ravine_barrel4", { visible = 1, input = 1, active = 1 } )

end;
private.use_rod_inv = function()
  common_impl.ProcessMultiUseAll("rod", "rod")
end;
private.use_rod_beg = function()
  ObjDelete( "gfx_ravine_rod_zone" );
end;
private.use_rod_end = function()
  ObjDelete("anm_ravine_use_brokenrod")
  if common_impl.ZzCompleteCheck("use_rod") then ObjSet( common_impl.hint["use_rod"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rod", private.use_rod_inv );
cmn.AddSubscriber( "use_rod", private.use_rod_beg, private.room_objname );
cmn.AddSubscriber( "use_rod", private.use_rod_end, private.room_objname );
cmn.AddSubscriber( "use_rod", private.use_rod_logic );
cmn.AddSubscriber( "use_rod_inv", private.use_rod_inv, private.room_objname );
cmn.AddSubscriber( "use_rod_beg", private.use_rod_beg, private.room_objname );
cmn.AddSubscriber( "use_rod_end", private.use_rod_end, private.room_objname );
cmn.AddSubscriber( "use_rod_end", private.use_rod_logic );
--------------------------------------------------------------------------------------------
function public.use_rod( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    public.get_barrel4()
    cmn.SetEventDone( "use_rod" );
    cmn.CallEventHandler( "use_rod_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rod") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rod_inv" );
  cmn.CallEventHandler( "use_rod_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ravine_use_brokenrod", "use_brokenrod", func_end );
  SoundSfx( "aud_use_fishing_rod_ruralroad" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_barrel4" ] = { type = "get", get_obj = "spr_ravine_barrel4", room = "rm_ruralroad", zz = "zz_ravine", zz_gate = "gzz_ruralroad_ravine" };

private.get_barrel4_logic = function()
  
end;
private.get_barrel4_inv = function()
  interface.InventoryItemAdd("inv_barrel","spr_ravine_barrel4",function() level_inv.ProcessGetBarrelAll( "get_barrel4" ) end);
end;
private.get_barrel4_beg = function()
  ObjDelete("gfx_ravine_barrel4")
end;
private.get_barrel4_end = function()
  ObjDelete("spr_ruralroad_barrel1")
  if common_impl.ZzCompleteCheck("get_barrel4") then ObjSet( common_impl.hint["get_barrel4"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_barrel4", private.get_barrel4_inv );
cmn.AddSubscriber( "get_barrel4", private.get_barrel4_beg, private.room_objname );
cmn.AddSubscriber( "get_barrel4", private.get_barrel4_end, private.room_objname );
cmn.AddSubscriber( "get_barrel4", private.get_barrel4_logic );
--------------------------------------------------------------------
function public.get_barrel4()
  cmn.SetEventDone( "get_barrel4" );
  cmn.CallEventHandler( "get_barrel4" );
  if common_impl.ZzCompleteCheck("get_barrel4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local clk_outrolvl1_for_ruralroad = function()
    if ld.CheckRequirements( {"clk_outrolvl1"} ) then

    end
  end;
  cmn.AddSubscriber("clk_outrolvl1", clk_outrolvl1_for_ruralroad, private.room_objname )
end;
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_brickwork" ) and not ld.CheckRequirements( { "win_stones" } ) then  
    private.win_stones_reset();
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_brickwork" ) and not ld.CheckRequirements( { "win_stones" } ) then
    private.win_stones_skip();
  end;
  
end
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  --private.opn_ruralroad();
  if ld.CheckRequirements({"clk_outrolvl1"}) and not ld.CheckRequirements({"clk_anmcoach1"}) then
    public.clk_anmcoach1()
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not private.VidStaticInit and not ld.CheckRequirements({"clk_outrolvl1"}) then
    private.VidStaticInit = true
    private.vid_ruralroad_horse_root =  {"vid_ruralroad_horse_static_1","vid_ruralroad_horse_static_2","vid_ruralroad_horse_static_3"};
    --ObjAttach()
    ld.VidStaticInit( 
        private.vid_ruralroad_horse_root,                                                        --оъект видео
        { "rm_ruralroad", "zz_frontcarriage", "zz_bush", "zz_baggage"}, --к чему относится объект
        {"aud_horse_static_1_75","aud_horse_static_2_34","aud_horse_static_3_44"},        --SFX
        { 3, 6 },                                                                            --рандом запуска от до
        false,                                                              --прогрес по которому статика будет играть
        {"clk_outrolvl1"},      --прогресс по которому статика перестаёт играть  
        "rm_ruralroad"
    );
    ld.VidStaticPlay(private.vid_ruralroad_horse_root)
  end
  
  
  if ld.CheckRequirements({"clk_outrolvl1"}) and not ld.CheckRequirements({"clk_anmcoach1"}) then
    for i=1,3 do
      ObjDetach("vid_ruralroad_horse_static_"..i)
    end
  end
  
  SoundEnv( "aud_ruralroad_env" )
  if cmn.IsEventDone("clk_attack") and not cmn.IsEventDone("use_plaid") then
     SoundEnv("aud_ruralroad_fire_env",1);
  end;  
  if ld.CheckRequirements({"clk_outrolvl1"}) and not ld.CheckRequirements({"clk_anmcoach1"}) then
    ObjSet("rm_ruralroad",{color_r=0,color_g=0,color_b=0})
  end
  if not ld.CheckRequirements( {"opn_ruralroad"} ) then
    --  ObjAttach("vid_ruralroad_vid_opn_ruralroad","rm_ruralroad")
  end;  
  private.opn_ruralroad();  
  --  private.horse_static()
--  ld.VidStaticPlay( private.vid_ruralroad_horse_root )
end;
--*********************************************************************************************************************
function public.Close()
  --  ObjSet("tmr_ruralroad_horse",{playing=0})
  --VidStop(private.horse_cur)
--  ld.VidStaticPause(  private.vid_ruralroad_horse_root )
end;
--*********************************************************************************************************************
function public.PreClose()
  
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_ravine" );
  function zz_ravine.Open()
  end;
  function zz_ravine.PreOpen()
  end;
  function zz_ravine.PreClose()
  end;
  function zz_ravine.Close()
  end;

  subroom.Define( "zz_brickwork" );
  function zz_brickwork.Open()
  end;
  function zz_brickwork.PreOpen()
     if cmn.IsEventStart("win_stones") and not cmn.IsEventDone("win_stones") then 
       cmn.MiniGameShow( "stones" ); 
       private.init_stones()
       private.load_stones()
     end;     
  end;
  function zz_brickwork.PreClose()
  end;
  function zz_brickwork.Close()
     --if cmn.IsEventStart("win_stones") and not cmn.IsEventDone("win_stones") then 
     --  cmn.MiniGameHide( "stones" ); 
     --end;      
    private.cur_stone = nil
  end;

  subroom.Define( "zz_frontcarriage" );
  function zz_frontcarriage.Open()
  end;
  function zz_frontcarriage.PreOpen()
  end;
  function zz_frontcarriage.PreClose()
  end;
  function zz_frontcarriage.Close()
  end;

  subroom.Define( "zz_bush" );
  function zz_bush.Open()
  end;
  function zz_bush.PreOpen()
  end;
  function zz_bush.PreClose()
  end;
  function zz_bush.Close()
  end;

  subroom.Define( "zz_baggage" );
  function zz_baggage.Open()
  end;
  function zz_baggage.PreOpen()
    private.win_baggage_load()
  end;
  function zz_baggage.PreClose()
  end;
  function zz_baggage.Close()
    if ld.CheckRequirements( { "clk_baggageho" } )  then
      ObjDetach( "spr_baggage_task_panel" )
   end;    
    
  end;
  
end;
--*********************************************************************************************************************
--private.horse_cur = ""
--function private.horse_static()
--  local f_end = function ()
--    ObjSet("tmr_ruralroad_horse",{endtrig=function()private.horse_static()end,playing=1,time=math.random(3,6)})
--  end
--  local r=math.random(3)
--  for i=1,3 do
--    ObjDetach("vid_ruralroad_horse_static_"..i)
--  end
--    private.horse_cur = "vid_ruralroad_horse_static_"..r
--    ObjAttach(private.horse_cur,"rm_ruralroad")
--    VidPlay(private.horse_cur,f_end)
--end
--