-- name=rm_swamp
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_swamp";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_swamp()
  if not ( cmn.IsEventDone( "opn_swamp" ) ) then
    -- cmn.SetEventDone( "opn_swamp" );
    -- cmn.CallEventHandler( "opn_swamp" )
     public.clk_anmboat()
  end;
end;
--------------------------------------------------------------------
local opn_swamp = function() end;
local opn_swamp_logic = function() end;
cmn.AddSubscriber( "opn_swamp", opn_swamp_logic )
cmn.AddSubscriber( "opn_swamp", opn_swamp, private.room_objname )
--------------------------------------------------------------------------------------------
  local win_crossingforswamp_logic = function()
    if ld.CheckRequirements( {"win_crossing"} ) then
      ObjSet( "grm_swamp_beyondtower", {active = 1, visible = 1, input = 1} );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_swamp_beyondtower_focus");
      end;
      ObjDelete("gmg_swamp_crossing");
    end
  end;
  local win_crossingforswamp = function()
    if ld.CheckRequirements( {"win_crossing"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_crossing", win_crossingforswamp, private.room_objname )
  cmn.AddSubscriber("win_crossing", win_crossingforswamp_logic )



--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmboat" ] = { type = "click", use_place = "gfx_swamp_clk_anmboat_zone", room = "rm_swamp" };

private.clk_anmboat_logic = function()
  ObjSet( "gzz_swamp_hollowtree", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_swamp_boat", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_swamp_hut", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_swamp_bog", { visible = 1, input = 1, active = 1 } )

end;
private.clk_anmboat_beg = function()
  ObjDelete( "gfx_swamp_clk_anmboat_zone" );
end;
private.clk_anmboat_end = function()
  ObjDelete("vid_swamp_vid_boat_121");  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmboat", private.clk_anmboat_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmboat", private.clk_anmboat_end, private.room_objname );
cmn.AddSubscriber( "clk_anmboat", private.clk_anmboat_logic );
cmn.AddSubscriber( "clk_anmboat_beg", private.clk_anmboat_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmboat_end", private.clk_anmboat_end, private.room_objname );
cmn.AddSubscriber( "clk_anmboat_end", private.clk_anmboat_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmboat()

  local func_end = function()
    cmn.SetEventDone( "opn_swamp" );
    cmn.CallEventHandler( "opn_swamp" )
    cmn.SetEventDone( "clk_anmboat" );
    cmn.CallEventHandler( "clk_anmboat_end" );
    ld.ShowBbt("after_clk_anmboat");
    common_impl.Lock(0);
    SoundTheme( "aud_danger_moment2_mus" );
  end;

  cmn.CallEventHandler( "clk_anmboat_beg" );
  common_impl.Lock(1);
  
  ld.StartTimer( 0.5, function()  SoundSfx( "aud_boat_121" ); VidPlay("vid_swamp_vid_boat_121",func_end)   end )
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()

end;

function public.lamp_clk()
  local func_end = function()
    ObjSet( "obj_swamp_lamp_clk_zone", {input = 1} );
  end;
  ObjSet( "obj_swamp_lamp_clk_zone", {input = 0} );

  ld.AnimPlay( "anm_swamp_anm_lamp", "lamp_clic", func_end );
  SoundSfx( "aud_touch_lantern_swamp" )
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_hollowtree *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_hollow" ] = { type = "click", use_place = "gfx_hollowtree_clk_hollow_zone", room = "rm_swamp", zz = "zz_hollowtree", zz_gate = "gzz_swamp_hollowtree" };

private.clk_hollow_logic = function()
  ObjSet( "gfx_hollowtree_talisman_zone", { visible = 1, input = 1, active = 1 } )
end;
private.clk_hollow_beg = function()
  ObjDelete( "gfx_hollowtree_clk_hollow_zone" );
end;
private.clk_hollow_end = function()
  if common_impl.ZzCompleteCheck("clk_hollow") then ObjSet( common_impl.hint["clk_hollow"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hollowtree_anm_hollow", {animfunc = "box_idle", frame = 0 } );
  ObjDelete("spr_swamp_bark");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_hollow", private.clk_hollow_beg, private.room_objname );
cmn.AddSubscriber( "clk_hollow", private.clk_hollow_end, private.room_objname );
cmn.AddSubscriber( "clk_hollow", private.clk_hollow_logic );
cmn.AddSubscriber( "clk_hollow_beg", private.clk_hollow_beg, private.room_objname );
cmn.AddSubscriber( "clk_hollow_end", private.clk_hollow_end, private.room_objname );
cmn.AddSubscriber( "clk_hollow_end", private.clk_hollow_logic );
--------------------------------------------------------------------------------------------
function public.clk_hollow()

  local func_end = function()
    cmn.SetEventDone( "clk_hollow" );
    cmn.CallEventHandler( "clk_hollow_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_hollow") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_hollow_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hollowtree_anm_hollow", "open_hollow", func_end );
  SoundSfx( "aud_touch_hollow_swamp" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
function public.clk_box()

  local func_end = function()
    common_impl.ShowBbt( 'need_talisman' )
    ld.Lock(0);
  end;
  ld.Lock(1);
  ld.AnimPlay( "anm_hollowtree_anm_hollow", "box_idle", func_end );
  SoundSfx( "aud_touch_box_swamp" );
end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_talisman" ] = { type = "use", inv_obj = "inv_talisman", use_place = "gfx_hollowtree_talisman_zone", room = "rm_swamp", zz = "zz_hollowtree", zz_gate = "gzz_swamp_hollowtree" };

private.use_talisman_logic = function()
  ObjSet( "spr_hollowtree_brooch2", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_hollowtree_purse", { visible = 1, input = 1, active = 1 } )

end;
private.use_talisman_inv = function()
  common_impl.ProcessMultiUseAll("talisman", "talisman")
end;
private.use_talisman_beg = function()
  ObjDelete( "gfx_hollowtree_talisman_zone" );
end;
private.use_talisman_end = function()
  if common_impl.ZzCompleteCheck("use_talisman") then ObjSet( common_impl.hint["use_talisman"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hollowtree_anm_hollow", {animfunc = "box_open_static", frame = 0 } );
  ObjSet( "spr_hollowtree_purse_shadow", {visible = 1} );
  ObjSet( "spr_hollowtree_brooch2_shadow", {visible = 1} );
  ObjSet( "spr_hollowtree_box_trash", {visible = 1} );
  ObjDelete("spr_swamp_box");
  ObjSet( "spr_swamp_box_open", {active=1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_talisman", private.use_talisman_inv );
cmn.AddSubscriber( "use_talisman", private.use_talisman_beg, private.room_objname );
cmn.AddSubscriber( "use_talisman", private.use_talisman_end, private.room_objname );
cmn.AddSubscriber( "use_talisman", private.use_talisman_logic );
cmn.AddSubscriber( "use_talisman_inv", private.use_talisman_inv, private.room_objname );
cmn.AddSubscriber( "use_talisman_beg", private.use_talisman_beg, private.room_objname );
cmn.AddSubscriber( "use_talisman_end", private.use_talisman_end, private.room_objname );
cmn.AddSubscriber( "use_talisman_end", private.use_talisman_logic );
--------------------------------------------------------------------------------------------
function public.use_talisman( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_talisman" );
    cmn.CallEventHandler( "use_talisman_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_talisman") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_talisman_inv" );
  cmn.CallEventHandler( "use_talisman_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hollowtree_anm_hollow", "use_amulet", function()  ld.AnimPlay( "anm_hollowtree_anm_hollow", "box_open", func_end ); end );
  SoundSfx( "aud_use_talisman_swamp" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_brooch2" ] = { type = "get", get_obj = "spr_hollowtree_brooch2", room = "rm_swamp", zz = "zz_hollowtree", zz_gate = "gzz_swamp_hollowtree" };

private.get_brooch2_logic = function()
  
end;
private.get_brooch2_inv = function()
  interface.InventoryItemAdd("inv_brooch","spr_hollowtree_brooch2",function() level_inv.ProcessGetBroochAll( "get_brooch2" ) end);
end;
private.get_brooch2_beg = function()
  ObjDelete("gfx_hollowtree_brooch2")
end;
private.get_brooch2_end = function()
  if common_impl.ZzCompleteCheck("get_brooch2") then ObjSet( common_impl.hint["get_brooch2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hollowtree_brooch2_shadow");
end;

cmn.AddSubscriber( "get_brooch2", private.get_brooch2_inv );
cmn.AddSubscriber( "get_brooch2", private.get_brooch2_beg, private.room_objname );
cmn.AddSubscriber( "get_brooch2", private.get_brooch2_end, private.room_objname );
cmn.AddSubscriber( "get_brooch2", private.get_brooch2_logic );
--------------------------------------------------------------------
function public.get_brooch2()
  cmn.SetEventDone( "get_brooch2" );
  cmn.CallEventHandler( "get_brooch2" );
  if common_impl.ZzCompleteCheck("get_brooch2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
----------------------------------------------------------------------
--common_impl.hint[ "clk_bird" ] = { type = "click", use_place = "gfx_hollowtree_clk_bird_zone", room = "rm_swamp", zz = "zz_hollowtree", zz_gate = "gzz_swamp_hollowtree" };
--
--private.clk_bird_logic = function()
--  ObjSet( "gfx_hollowtree_seed_zone", { visible = 1, input = 1, active = 1 } )
--end;
--private.clk_bird_beg = function()
--  ObjDelete( "gfx_hollowtree_clk_bird_zone" );
--end;
--private.clk_bird_end = function()
--  if common_impl.ZzCompleteCheck("clk_bird") then ObjSet( common_impl.hint["clk_bird"].zz_gate, { visible = 0, input = 0 } ); end;
--  ObjSet( "anm_hollowtree_anm_bird", {animfunc = "bird_static1", frame = 0 } );
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_bird", private.clk_bird_beg, private.room_objname );
--cmn.AddSubscriber( "clk_bird", private.clk_bird_end, private.room_objname );
--cmn.AddSubscriber( "clk_bird", private.clk_bird_logic );
--cmn.AddSubscriber( "clk_bird_beg", private.clk_bird_beg, private.room_objname );
--cmn.AddSubscriber( "clk_bird_end", private.clk_bird_end, private.room_objname );
--cmn.AddSubscriber( "clk_bird_end", private.clk_bird_logic );
----------------------------------------------------------------------------------------------
--function public.clk_bird()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_bird" );
--    cmn.CallEventHandler( "clk_bird_end" );
--    common_impl.Lock(0);
--    ld.AnimPlay( "anm_hollowtree_anm_bird", "bird_static1", "" );
--    if common_impl.ZzCompleteCheck("clk_bird") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "clk_bird_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_hollowtree_anm_bird", "bird_idle1", func_end );
--  --SoundSfx( 0 )
--  --func_end()
--
--end;
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_purse" ] = { type = "get", get_obj = "spr_hollowtree_purse", room = "rm_swamp", zz = "zz_hollowtree", zz_gate = "gzz_swamp_hollowtree" };

private.get_purse_logic = function()
  
end;
private.get_purse_inv = function()
  interface.InventoryItemAdd("inv_purse","spr_hollowtree_purse");
  ObjSet( "inv_purse", { drag = 0 } );
end;
private.get_purse_beg = function()
  ObjDelete("gfx_hollowtree_purse")
end;
private.get_purse_end = function()
  if common_impl.ZzCompleteCheck("get_purse") then ObjSet( common_impl.hint["get_purse"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hollowtree_purse_shadow");
end;

cmn.AddSubscriber( "get_purse", private.get_purse_inv );
cmn.AddSubscriber( "get_purse", private.get_purse_beg, private.room_objname );
cmn.AddSubscriber( "get_purse", private.get_purse_end, private.room_objname );
cmn.AddSubscriber( "get_purse", private.get_purse_logic );
--------------------------------------------------------------------
function public.get_purse()
  cmn.SetEventDone( "get_purse" );
  cmn.CallEventHandler( "get_purse" );
  if common_impl.ZzCompleteCheck("get_purse") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_bird_idle()

  local func_end = function()
    common_impl.ShowBbt( 'need_seed' )
    ld.Lock(0);
    ld.AnimPlay( "anm_hollowtree_anm_bird", "bird_static1", "" );
  end;
  ld.Lock(1);
  ld.AnimPlay( "anm_hollowtree_anm_bird", "bird_idle2", func_end );
  SoundSfx( "aud_touch_crow_swamp" );
end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_seed" ] = { type = "use", inv_obj = "inv_seed", use_place = "gfx_hollowtree_seed_zone", room = "rm_swamp", zz = "zz_hollowtree", zz_gate = "gzz_swamp_hollowtree" };

private.use_seed_logic = function()
  ObjSet( "spr_hollowtree_cone3", { visible = 1, input = 1, active = 1 } )

end;
private.use_seed_inv = function()
  common_impl.ProcessMultiUseAll("seed", "seed")
end;
private.use_seed_beg = function()
  ObjDelete( "gfx_hollowtree_seed_zone" );
end;
private.use_seed_end = function()
  if common_impl.ZzCompleteCheck("use_seed") then ObjSet( common_impl.hint["use_seed"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hollowtree_anm_bird", {animfunc = "bird_sleep_static2", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_seed", private.use_seed_inv );
cmn.AddSubscriber( "use_seed", private.use_seed_beg, private.room_objname );
cmn.AddSubscriber( "use_seed", private.use_seed_end, private.room_objname );
cmn.AddSubscriber( "use_seed", private.use_seed_logic );
cmn.AddSubscriber( "use_seed_inv", private.use_seed_inv, private.room_objname );
cmn.AddSubscriber( "use_seed_beg", private.use_seed_beg, private.room_objname );
cmn.AddSubscriber( "use_seed_end", private.use_seed_end, private.room_objname );
cmn.AddSubscriber( "use_seed_end", private.use_seed_logic );
--------------------------------------------------------------------------------------------
function public.use_seed( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_seed" );
    cmn.CallEventHandler( "use_seed_end" );
    common_impl.Lock(0);
    ld.AnimPlay( "anm_hollowtree_anm_bird", "bird_sleep_static2", "" );
    if common_impl.ZzCompleteCheck("use_seed") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_seed_inv" );
  cmn.CallEventHandler( "use_seed_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hollowtree_anm_bird", "use_corn", function() ld.AnimPlay( "anm_hollowtree_anm_bird", "use_corn2", function() ld.AnimPlay( "anm_hollowtree_anm_bird", "use_corn_end", func_end ); end ); end);
  SoundSfx( "aud_use_seeds_swamp" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cone3" ] = { type = "get", get_obj = "spr_hollowtree_cone3", room = "rm_swamp", zz = "zz_hollowtree", zz_gate = "gzz_swamp_hollowtree" };

private.get_cone3_logic = function()
  
end;
private.get_cone3_inv = function()
  interface.InventoryItemAdd("inv_cone","spr_hollowtree_cone3",function() level_inv.ProcessGetConeAll( "get_cone3" ) end);
end;
private.get_cone3_beg = function()
  ObjDelete("gfx_hollowtree_cone3")
end;
private.get_cone3_end = function()
  if common_impl.ZzCompleteCheck("get_cone3") then ObjSet( common_impl.hint["get_cone3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_cone3", private.get_cone3_inv );
cmn.AddSubscriber( "get_cone3", private.get_cone3_beg, private.room_objname );
cmn.AddSubscriber( "get_cone3", private.get_cone3_end, private.room_objname );
cmn.AddSubscriber( "get_cone3", private.get_cone3_logic );
--------------------------------------------------------------------
function public.get_cone3()
  cmn.SetEventDone( "get_cone3" );
  cmn.CallEventHandler( "get_cone3" );
  if common_impl.ZzCompleteCheck("get_cone3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bog *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
function public.idle_frog_clk()
  local func_end = function()
    ObjSet( "obj_bog_frog_clk_zone", {input = 1} );
  end;
  ObjSet( "obj_bog_frog_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_bog_anm_clk_frog", "anim_frog", func_end );
  SoundSfx( "aud_touch_frog_swamp" );
end;
--------------------------------------------------------------------
common_impl.hint[ "get_boot" ] = { type = "get", get_obj = "spr_bog_boot", room = "rm_swamp", zz = "zz_bog", zz_gate = "gzz_swamp_bog" };

private.get_boot_logic = function()
  
end;
private.get_boot_inv = function()
  interface.InventoryItemAdd("inv_boot","spr_bog_boot");
  ObjSet( "inv_boot", { drag = 0 } );
end;
private.get_boot_beg = function()
  ObjDelete("gfx_bog_boot")
end;
private.get_boot_end = function()
  if common_impl.ZzCompleteCheck("get_boot") then ObjSet( common_impl.hint["get_boot"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_bog_tr_boot");
  ObjDelete("spr_swamp_boot");
end;

cmn.AddSubscriber( "get_boot", private.get_boot_inv );
cmn.AddSubscriber( "get_boot", private.get_boot_beg, private.room_objname );
cmn.AddSubscriber( "get_boot", private.get_boot_end, private.room_objname );
cmn.AddSubscriber( "get_boot", private.get_boot_logic );
--------------------------------------------------------------------
function public.get_boot()
  ObjSet( "spr_bog_tr_boot", {visible = 0} );
  ObjSet( "spr_bog_boot", {visible = 1} );
  cmn.SetEventDone( "get_boot" );
  cmn.CallEventHandler( "get_boot" );
  if common_impl.ZzCompleteCheck("get_boot") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
local swamp_win_frogs_frog_on_back_pos = {{135,511},{200,521},{206,500},{175,476},{244,478},{211,471}};

common_impl.hint[ "use_frog" ] = { type = "use", inv_obj = "inv_frog", use_place = "gfx_bog_frog_zone", room = "rm_swamp", zz = "zz_bog", zz_gate = "gzz_swamp_bog" };

private.use_frog_logic = function()
  ObjSet( "obj_mmg_frogs_root", { input = 1 } )

end;
private.use_frog_inv = function()
  common_impl.ProcessMultiUseAll("frog", "frog")
end;
private.use_frog_beg = function()
  ObjDelete( "gfx_bog_frog_zone" );
end;
private.use_frog_end = function()
  if common_impl.ZzCompleteCheck("use_frog") then ObjSet( common_impl.hint["use_frog"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("obj_bog_frog", {alp = 1});
  ObjSet( "spr_swamp_frog2", {active = 1, visible = 1, pos_x = swamp_win_frogs_frog_on_back_pos[1][1], pos_y = swamp_win_frogs_frog_on_back_pos[1][2] } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_frog", private.use_frog_inv );
cmn.AddSubscriber( "use_frog", private.use_frog_beg, private.room_objname );
cmn.AddSubscriber( "use_frog", private.use_frog_end, private.room_objname );
cmn.AddSubscriber( "use_frog", private.use_frog_logic );
cmn.AddSubscriber( "use_frog_inv", private.use_frog_inv, private.room_objname );
cmn.AddSubscriber( "use_frog_beg", private.use_frog_beg, private.room_objname );
cmn.AddSubscriber( "use_frog_end", private.use_frog_end, private.room_objname );
cmn.AddSubscriber( "use_frog_end", private.use_frog_logic );
--------------------------------------------------------------------------------------------
function public.use_frog( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_frog" );
    cmn.CallEventHandler( "use_frog_end" );
    common_impl.Lock(0);
    cmn.MiniGameShow( "frogs" );
    public.win_frogs_load(1); 
    if common_impl.ZzCompleteCheck("use_frog") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_frog_inv" );
  cmn.CallEventHandler( "use_frog_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  ObjAnimate( "obj_bog_frog", 8, 0, 0, function() func_end(); end, {0,0,0, 0.5,0,1} );
  SoundSfx( "aud_use_toad_swamp" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_frogs" ] = { type = "click", use_place = "obj_mmg_frogs_root", room = "rm_swamp", zz = "zz_bog", zz_gate = "gzz_swamp_bog" };

private.win_frogs_logic = function()
  if ( cmn.IsEventDone( "win_frogs" ) ) then
    ObjSet( "spr_bog_lily2", { input = 1} );
  end

end;
private.win_frogs_beg = function()

end;
private.win_frogs_end = function()
  if common_impl.ZzCompleteCheck("win_frogs") then ObjSet( common_impl.hint["win_frogs"].zz_gate, { visible = 0, input = 0 } ); end;
  if ( cmn.IsEventDone( "win_frogs" ) ) then
    ObjSet( "gfx_bog_lily2", {visible = 1} );
    ObjSet( "obj_bog_frog", {pos_x = 77 , pos_y = -205, alp = 1} );
    ObjDelete("obj_mmg_frogs_root");
    ObjSet( "spr_swamp_frog2", {active = 1, visible = 1, pos_x = swamp_win_frogs_frog_on_back_pos[6][1], pos_y = swamp_win_frogs_frog_on_back_pos[6][2] } );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_frogs", private.win_frogs_beg, private.room_objname );
cmn.AddSubscriber( "win_frogs", private.win_frogs_end, private.room_objname );
cmn.AddSubscriber( "win_frogs", private.win_frogs_logic );
cmn.AddSubscriber( "win_frogs_beg", private.win_frogs_beg, private.room_objname );
cmn.AddSubscriber( "win_frogs_end", private.win_frogs_end, private.room_objname );
cmn.AddSubscriber( "win_frogs_end", private.win_frogs_logic );
--------------------------------------------------------------------------------------------
function public.win_frogs()

  local func_end = function()
    cmn.SetEventDone( "win_frogs" );
    cmn.CallEventHandler( "win_frogs_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_frogs") then ld.CloseSubRoom() end;
  end;
  
  local func_preend = function()
    ObjSet( "obj_bog_frog", {pos_x = 77 , pos_y = -205} );
    ObjAnimate( "obj_bog_frog", 8, 0, 0, function() func_end() end, {0,0,0, 0.5,0,1} );   
  end
  
  cmn.CallEventHandler( "win_frogs_beg" );
  common_impl.Lock(1);
  cmn.MiniGameHide( "frogs", true );
  
  ObjAnimate( "obj_mmg_frogs_root", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  ObjAnimate( "obj_bog_frog", 8, 0, 0, function() func_preend() end, {0,0,1, 0.5,0,0} );  
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lily2" ] = { type = "get", get_obj = "spr_bog_lily2", room = "rm_swamp", zz = "zz_bog", zz_gate = "gzz_swamp_bog" };

private.get_lily2_logic = function()
  
end;
private.get_lily2_inv = function()
  interface.InventoryItemAdd("inv_lily2","spr_bog_lily2");
end;
private.get_lily2_beg = function()
  ObjDelete("gfx_bog_lily2")
end;
private.get_lily2_end = function()
  if common_impl.ZzCompleteCheck("get_lily2") then ObjSet( common_impl.hint["get_lily2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_bog_sh_lily2");
end;

cmn.AddSubscriber( "get_lily2", private.get_lily2_inv );
cmn.AddSubscriber( "get_lily2", private.get_lily2_beg, private.room_objname );
cmn.AddSubscriber( "get_lily2", private.get_lily2_end, private.room_objname );
cmn.AddSubscriber( "get_lily2", private.get_lily2_logic );
--------------------------------------------------------------------
function public.get_lily2()
  cmn.SetEventDone( "get_lily2" );
  cmn.CallEventHandler( "get_lily2" );
  if common_impl.ZzCompleteCheck("get_lily2") then ld.CloseSubRoom() end;
end

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
local frog_pos = {{-157,74},{32,106},{61,2},{-47,-110},{188,-109},{68,-146}};

function public.win_frogs_load(fast) 
  if not ng_global.progress[ "std" ][ "win_frogs" ].state then
    ng_global.progress[ "std" ][ "win_frogs" ].state = 1;        
  end
  ObjSet( "obj_bog_frog", {pos_x = frog_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][1],pos_y = frog_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][2],
                           scale_x= private.win_frogs_set_scale(ng_global.progress[ "std" ][ "win_frogs" ].state)} ); 
  if ng_global.progress[ "std" ][ "win_frogs" ].state ~= 0 then
      for i = 1, ng_global.progress[ "std" ][ "win_frogs" ].state do
        ObjSet( "spr_bog_light"..i, {alp = 1, input = 0} );
      end  
  end
  if not fast then
    ld.Lock(1);
    ObjAnimate( "obj_bog_frog", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.5,0,1} );
  else
    ObjSet( "obj_bog_frog", {alp = 1} );
  end
  ObjSet( "spr_swamp_frog2", {pos_x=swamp_win_frogs_frog_on_back_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][1], pos_y=swamp_win_frogs_frog_on_back_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][2],  scale_x= private.win_frogs_set_scale(ng_global.progress[ "std" ][ "win_frogs" ].state)} );
  public.win_frogs_check();
end

function public.win_frogs_hand(num)  
  ld.SetCursor( CURSOR_HAND );
  ObjSet( "spr_bog_light"..num, { alp = 1} ); 
end

function public.win_frogs_hand_defoult(num)  
  ld.SetCursor( CURSOR_DEFAULT ); 
  ObjSet( "spr_bog_light"..num, { alp = 0} ); 
end 

function private.win_frogs_set_scale(num)
   if num==2 or num==3 or num==5 then return -1; else return 1 end; 
end;  

function public.win_frogs_clik(num)
    ng_global.progress[ "std" ][ "win_frogs" ].state = ng_global.progress[ "std" ][ "win_frogs" ].state + 1;
    ObjSet( "spr_swamp_frog2", {pos_x=swamp_win_frogs_frog_on_back_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][1], pos_y=swamp_win_frogs_frog_on_back_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][2],  scale_x= private.win_frogs_set_scale(ng_global.progress[ "std" ][ "win_frogs" ].state)} );

    ld.Lock(1);
    if ng_global.progress[ "std" ][ "win_frogs" ].state == num then
      SoundSfx( "aud_mg_toad_click" );
      ObjAnimate( "obj_bog_frog", 8, 0, 0, function() ObjSet( "obj_bog_frog", {pos_x = frog_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][1],pos_y = frog_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][2],  scale_x= private.win_frogs_set_scale(ng_global.progress[ "std" ][ "win_frogs" ].state)} ); ObjAnimate( "obj_bog_frog", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} ); end, {0,0,1, 0.5,0,0} );
      ObjSet( "spr_bog_light"..num, {input = 0} );
      ObjAnimate( "spr_bog_light"..num, 8, 0, 0, function() ld.Lock(0); public.win_frogs_check(); end, {0,0,0, 1,0,1} );  
    else
      SoundSfx( "aud_mg_toad_wrong" );
      ld.AnimPlay( "anm_bog_anm_clk_lilyleaf"..num, "click_lilyleaf"..num, function() ld.Lock(0); public.win_frogs_reset(); end );
    end
end

function public.win_frogs_check()
  if  ng_global.progress[ "std" ][ "win_frogs" ].state == 6 then
    ld.Lock(1); ld.StartTimer( 1, function() public.win_frogs(); end )
  end
end

function private.obj_animate_light(num)
   local func_end = function()
    if ng_global.progress[ "std" ][ "win_frogs" ].state then
      ng_global.progress[ "std" ][ "win_frogs" ].state = 1;
    end
    ld.StartTimer( 0.5, function() public.win_frogs(); end )   
  end
  
    local obj_light_end = function()
    ObjSet( "obj_bog_frog", {pos_x = frog_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][1],pos_y = frog_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][2], scale_x= private.win_frogs_set_scale(ng_global.progress[ "std" ][ "win_frogs" ].state)} );  
       ObjAnimate( "obj_bog_frog", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
       ObjAnimate( "spr_bog_light"..num, 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
       ld.StartTimer( 0.5, function() 
                              ng_global.progress[ "std" ][ "win_frogs" ].state = ng_global.progress[ "std" ][ "win_frogs" ].state + 1;
                              if ( ng_global.progress[ "std" ][ "win_frogs" ].state <= 6 ) then
                                private.obj_animate_light(ng_global.progress[ "std" ][ "win_frogs" ].state) ; 
                              else
                                func_end();  
                              end;
                           end )
    end
    
    SoundSfx( "aud_mg_toad_click" );                      
    ObjSet( "spr_bog_light"..num, {input = 0} );
    ObjAnimate( "obj_bog_frog", 8, 0, 0, function() obj_light_end() end, {0,0,1, 0.5,0,0} );
  
end 
   
function public.win_frogs_skip()
  local time = 0;
  local func_end = function()
    if ng_global.progress[ "std" ][ "win_frogs" ].state then
      ng_global.progress[ "std" ][ "win_frogs" ].state = 1;
    end
    ld.StartTimer( 0.5, function() public.win_frogs(); end )   
  end
  ng_global.progress[ "std" ][ "win_frogs" ].state = ng_global.progress[ "std" ][ "win_frogs" ].state + 1;
  private.obj_animate_light(ng_global.progress[ "std" ][ "win_frogs" ].state);
end

function public.win_frogs_reset()
  if ng_global.progress[ "std" ][ "win_frogs" ].state ~= 1 then
    
    if ng_global.progress[ "std" ][ "win_frogs" ].state then
      ng_global.progress[ "std" ][ "win_frogs" ].state = 1;
    end  
    if ObjGet("obj_bog_frog").pos_x ~= frog_pos[1][1] then
      ld.Lock(1);
      for i = 1,6 do
         ObjSet( "spr_bog_light"..i, {input = 1} );
         ObjAnimate( "spr_bog_light"..i, 8, 0, 0, function() end, {0,0,ObjGet("spr_bog_light"..i).alp, 0.5,0,0} );
      end
      ObjAnimate( "obj_bog_frog", 8, 0, 0, function()  end, {0,0,1, 0.5,0,0} );
      ld.StartTimer( 0.5, function() ld.Lock(0); public.win_frogs_load(); end )
    end
  end
end

--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_hut *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_axe" ] = { type = "get", get_obj = "spr_hut_axe", room = "rm_swamp", zz = "zz_hut", zz_gate = "gzz_swamp_hut" };

private.get_axe_logic = function()
  
end;
private.get_axe_inv = function()
  interface.InventoryItemAdd("inv_axe","spr_hut_axe");
end;
private.get_axe_beg = function()
  ObjDelete("gfx_hut_axe")
end;
private.get_axe_end = function()
  if common_impl.ZzCompleteCheck("get_axe") then ObjSet( common_impl.hint["get_axe"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hut_axe_shadow");
  ObjDelete("spr_swamp_axe");
end;

cmn.AddSubscriber( "get_axe", private.get_axe_inv );
cmn.AddSubscriber( "get_axe", private.get_axe_beg, private.room_objname );
cmn.AddSubscriber( "get_axe", private.get_axe_end, private.room_objname );
cmn.AddSubscriber( "get_axe", private.get_axe_logic );
--------------------------------------------------------------------
function public.get_axe()
  cmn.SetEventDone( "get_axe" );
  cmn.CallEventHandler( "get_axe" );
  if common_impl.ZzCompleteCheck("get_axe") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------

function public.clk_door_zone()

  local func_end = function()
    common_impl.ShowBbt( 'need_keystar' )
    ld.Lock(0);
  end;
  ld.Lock(1);
  ld.AnimPlay( "anm_hut_anm_door", "door_idle", func_end );
  SoundSfx( "aud_touch_lattice_swamp" );
end;
--------------------------------------------------------------------------------------------

common_impl.hint[ "use_keystar" ] = { type = "use", inv_obj = "inv_keystar", use_place = "gfx_hut_keystar_zone", room = "rm_swamp", zz = "zz_hut", zz_gate = "gzz_swamp_hut" };

private.use_keystar_logic = function()
  ObjSet( "gfx_hut_clk_door_zone", { visible = 1, input = 1, active = 1 } )  

end;
private.use_keystar_inv = function()
  common_impl.ProcessMultiUseAll("keystar", "keystar")
end;
private.use_keystar_beg = function()
  ObjDelete( "gfx_hut_keystar_zone" );
end;
private.use_keystar_end = function()
  if common_impl.ZzCompleteCheck("use_keystar") then ObjSet( common_impl.hint["use_keystar"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hut_anm_door", {animfunc = "open_door", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_keystar", private.use_keystar_inv );
cmn.AddSubscriber( "use_keystar", private.use_keystar_beg, private.room_objname );
cmn.AddSubscriber( "use_keystar", private.use_keystar_end, private.room_objname );
cmn.AddSubscriber( "use_keystar", private.use_keystar_logic );
cmn.AddSubscriber( "use_keystar_inv", private.use_keystar_inv, private.room_objname );
cmn.AddSubscriber( "use_keystar_beg", private.use_keystar_beg, private.room_objname );
cmn.AddSubscriber( "use_keystar_end", private.use_keystar_end, private.room_objname );
cmn.AddSubscriber( "use_keystar_end", private.use_keystar_logic );
--------------------------------------------------------------------------------------------
function public.use_keystar( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_keystar" );
    cmn.CallEventHandler( "use_keystar_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_keystar") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_keystar_inv" );
  cmn.CallEventHandler( "use_keystar_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hut_anm_door", "use_key", func_end );
  SoundSfx( "aud_use_star_key_swamp" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "clk_door" ] = { type = "click", use_place = "gfx_hut_clk_door_zone", room = "rm_swamp", zz = "zz_hut", zz_gate = "gzz_swamp_hut" };

private.clk_door_logic = function()
  ObjSet( "spr_hut_paddle", { visible = 1, input = 1, active = 1 } )

end;
private.clk_door_beg = function()
  ObjDelete( "gfx_hut_clk_door_zone" );
end;
private.clk_door_end = function()
  if common_impl.ZzCompleteCheck("clk_door") then ObjSet( common_impl.hint["clk_door"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hut_anm_door", {animfunc = "open_door_static", frame = 0 } );
  ObjSet( "spr_hut_paddle_sh1", {visible = 1} );
  ObjSet( "spr_hut_paddle_sh2", {visible = 1} );
  ObjDelete("spr_swamp_door");
  ObjSet( "spr_swamp_door_open", {active=1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_door", private.clk_door_beg, private.room_objname );
cmn.AddSubscriber( "clk_door", private.clk_door_end, private.room_objname );
cmn.AddSubscriber( "clk_door", private.clk_door_logic );
cmn.AddSubscriber( "clk_door_beg", private.clk_door_beg, private.room_objname );
cmn.AddSubscriber( "clk_door_end", private.clk_door_end, private.room_objname );
cmn.AddSubscriber( "clk_door_end", private.clk_door_logic );
--------------------------------------------------------------------------------------------
function public.clk_door()

  local func_end = function()
    cmn.SetEventDone( "clk_door" );
    cmn.CallEventHandler( "clk_door_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_door") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_door_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hut_anm_door", "open_door", func_end );
  SoundSfx( "aud_open_lattice_swamp" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "get_paddle" ] = { type = "get", get_obj = "spr_hut_paddle", room = "rm_swamp", zz = "zz_hut", zz_gate = "gzz_swamp_hut" };

private.get_paddle_logic = function()
  
end;
private.get_paddle_inv = function()
  interface.InventoryItemAdd("inv_paddle","spr_hut_paddle");
end;
private.get_paddle_beg = function()
  ObjDelete("gfx_hut_paddle")
end;
private.get_paddle_end = function()
  if common_impl.ZzCompleteCheck("get_paddle") then ObjSet( common_impl.hint["get_paddle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete( "spr_hut_paddle_sh1");
  ObjDelete( "spr_hut_paddle_sh2");
end;

cmn.AddSubscriber( "get_paddle", private.get_paddle_inv );
cmn.AddSubscriber( "get_paddle", private.get_paddle_beg, private.room_objname );
cmn.AddSubscriber( "get_paddle", private.get_paddle_end, private.room_objname );
cmn.AddSubscriber( "get_paddle", private.get_paddle_logic );
--------------------------------------------------------------------
function public.get_paddle()
  cmn.SetEventDone( "get_paddle" );
  cmn.CallEventHandler( "get_paddle" );
  if common_impl.ZzCompleteCheck("get_paddle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_boat *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ladle" ] = { type = "use", inv_obj = "inv_ladle", use_place = "obj_boat_hint_zone", room = "rm_swamp", zz = "zz_boat", zz_gate = "gzz_swamp_boat" };

private.use_ladle_logic = function()
  ObjSet( "spr_boat_handle", {  input = 1  } )
  ObjSet( "spr_boat_screwdriver", { input = 1} )
  ObjSet( "spr_boat_cone2", { input = 1 } )
  ObjSet( "gfx_boat_paddle_zone", { visible = 1, input = 1, active = 1 } )
   ObjDelete("obj_boat_ladle_hint_zone")
end;
private.use_ladle_inv = function()
  common_impl.ProcessMultiUseAll("ladle", "ladle")
end;
private.use_ladle_beg = function()
  ObjDelete( "gfx_boat_ladle_zone" );
  ObjDelete( "gfx_boat_ladle_clk_second_zone" );
  ObjDelete( "gfx_boat_ladle_clk_third_zone" );
end;
private.use_ladle_end = function()
  if common_impl.ZzCompleteCheck("use_ladle") then ObjSet( common_impl.hint["use_ladle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boat_anm_boat", {animfunc = "use_paddle", frame = 0 } );
  ObjSet( "gfx_boat_handle", {visible = 1} );
  ObjSet( "gfx_boat_cone2", {visible = 1} );
  ObjSet( "gfx_boat_screwdriver", {visible = 1} );
  ObjDelete("spr_swamp_water");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ladle", private.use_ladle_inv );
cmn.AddSubscriber( "use_ladle", private.use_ladle_beg, private.room_objname );
cmn.AddSubscriber( "use_ladle", private.use_ladle_end, private.room_objname );
cmn.AddSubscriber( "use_ladle", private.use_ladle_logic );
cmn.AddSubscriber( "use_ladle_inv", private.use_ladle_inv, private.room_objname );
cmn.AddSubscriber( "use_ladle_beg", private.use_ladle_beg, private.room_objname );
cmn.AddSubscriber( "use_ladle_end", private.use_ladle_end, private.room_objname );
cmn.AddSubscriber( "use_ladle_end", private.use_ladle_logic );
--------------------------------------------------------------------------------------------
function public.use_ladle( obj )

  local func_end = function()
    
    ObjSet( "gfx_boat_ladle_zone", {input = 0, visible = 0} );
    ObjSet( "gfx_boat_ladle_clk_second_zone", {input = 1, visible = 1} );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boat_anm_boat", "use_ladle", func_end );
  SoundSfx( "aud_use_ladle_swamp_1" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
function public.use_first_ladle( obj )
  local func_end = function()
    common_impl.Lock(0);
    ObjSet( "gfx_boat_ladle_clk_second_zone", {input = 0, visible = 0} );
    ObjSet( "gfx_boat_ladle_clk_third_zone", {input = 1, visible = 1} );
  end
  
  common_impl.Lock(1);
  ld.AnimPlay( "anm_boat_anm_boat", "use_ladle1", func_end );  
  SoundSfx( "aud_use_ladle_swamp_2" );
end

function public.use_second_ladle( obj )
  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ladle" );
    cmn.CallEventHandler( "use_ladle_end" );
    common_impl.Lock(0);
    ObjSet( "gfx_boat_ladle_clk_third_zone", {input = 0, visible = 0} );
    if common_impl.ZzCompleteCheck("use_ladle") then ld.CloseSubRoom() end;
  end
  
  cmn.CallEventHandler( "use_ladle_inv" );
  cmn.CallEventHandler( "use_ladle_beg" );
  common_impl.Lock(1);
  ld.AnimPlay( "anm_boat_anm_boat", "use_ladle2", func_end );  
  SoundSfx( "aud_use_ladle_swamp_3" );
end


--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_handle" ] = { type = "get", get_obj = "spr_boat_handle", room = "rm_swamp", zz = "zz_boat", zz_gate = "gzz_swamp_boat" };

private.get_handle_logic = function()
  
end;
private.get_handle_inv = function()
  interface.InventoryItemAdd("inv_handle","spr_boat_handle");
end;
private.get_handle_beg = function()
  ObjDelete("gfx_boat_handle")
end;
private.get_handle_end = function()
  if common_impl.ZzCompleteCheck("get_handle") then ObjSet( common_impl.hint["get_handle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boat_sh_handle");
end;

cmn.AddSubscriber( "get_handle", private.get_handle_inv );
cmn.AddSubscriber( "get_handle", private.get_handle_beg, private.room_objname );
cmn.AddSubscriber( "get_handle", private.get_handle_end, private.room_objname );
cmn.AddSubscriber( "get_handle", private.get_handle_logic );
--------------------------------------------------------------------
function public.get_handle()
  cmn.SetEventDone( "get_handle" );
  cmn.CallEventHandler( "get_handle" );
  if common_impl.ZzCompleteCheck("get_handle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_screwdriver" ] = { type = "get", get_obj = "spr_boat_screwdriver", room = "rm_swamp", zz = "zz_boat", zz_gate = "gzz_swamp_boat" };

private.get_screwdriver_logic = function()
  
end;
private.get_screwdriver_inv = function()
  interface.InventoryItemAdd("inv_screwdriver","spr_boat_screwdriver");
end;
private.get_screwdriver_beg = function()
  ObjDelete("gfx_boat_screwdriver")
end;
private.get_screwdriver_end = function()
  if common_impl.ZzCompleteCheck("get_screwdriver") then ObjSet( common_impl.hint["get_screwdriver"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boat_sh_screwdriver");
end;

cmn.AddSubscriber( "get_screwdriver", private.get_screwdriver_inv );
cmn.AddSubscriber( "get_screwdriver", private.get_screwdriver_beg, private.room_objname );
cmn.AddSubscriber( "get_screwdriver", private.get_screwdriver_end, private.room_objname );
cmn.AddSubscriber( "get_screwdriver", private.get_screwdriver_logic );
--------------------------------------------------------------------
function public.get_screwdriver()
  cmn.SetEventDone( "get_screwdriver" );
  cmn.CallEventHandler( "get_screwdriver" );
  if common_impl.ZzCompleteCheck("get_screwdriver") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cone2" ] = { type = "get", get_obj = "spr_boat_cone2", room = "rm_swamp", zz = "zz_boat", zz_gate = "gzz_swamp_boat" };

private.get_cone2_logic = function()
  
end;
private.get_cone2_inv = function()
  interface.InventoryItemAdd("inv_cone","spr_boat_cone2",function() level_inv.ProcessGetConeAll( "get_cone2" ) end);
end;
private.get_cone2_beg = function()
  ObjDelete("gfx_boat_cone2")
end;
private.get_cone2_end = function()
  if common_impl.ZzCompleteCheck("get_cone2") then ObjSet( common_impl.hint["get_cone2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boat_sh_cone2");
end;

cmn.AddSubscriber( "get_cone2", private.get_cone2_inv );
cmn.AddSubscriber( "get_cone2", private.get_cone2_beg, private.room_objname );
cmn.AddSubscriber( "get_cone2", private.get_cone2_end, private.room_objname );
cmn.AddSubscriber( "get_cone2", private.get_cone2_logic );
--------------------------------------------------------------------
function public.get_cone2()
  cmn.SetEventDone( "get_cone2" );
  cmn.CallEventHandler( "get_cone2" );
  if common_impl.ZzCompleteCheck("get_cone2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_paddle" ] = { type = "use", inv_obj = "inv_paddle", use_place = "gfx_boat_paddle_zone", room = "rm_swamp", zz = "zz_boat", zz_gate = "gzz_swamp_boat" };

private.use_paddle_logic = function()
  ObjSet( "gmg_swamp_crossing", { visible = 1, input = 1, active = 1 } )

end;
private.use_paddle_inv = function()
  common_impl.ProcessMultiUseAll("paddle", "paddle")
end;
private.use_paddle_beg = function()
  ObjDelete( "gfx_boat_paddle_zone" );
end;
private.use_paddle_end = function()
  if common_impl.ZzCompleteCheck("use_paddle") then ObjSet( common_impl.hint["use_paddle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boat_anm_boat", {animfunc = "use_paddle", frame = 999 } );
    ObjSet( "spr_swamp_paddle", {active=1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_paddle", private.use_paddle_inv );
cmn.AddSubscriber( "use_paddle", private.use_paddle_beg, private.room_objname );
cmn.AddSubscriber( "use_paddle", private.use_paddle_end, private.room_objname );
cmn.AddSubscriber( "use_paddle", private.use_paddle_logic );
cmn.AddSubscriber( "use_paddle_inv", private.use_paddle_inv, private.room_objname );
cmn.AddSubscriber( "use_paddle_beg", private.use_paddle_beg, private.room_objname );
cmn.AddSubscriber( "use_paddle_end", private.use_paddle_end, private.room_objname );
cmn.AddSubscriber( "use_paddle_end", private.use_paddle_logic );
--------------------------------------------------------------------------------------------
function public.use_paddle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_paddle" );
    cmn.CallEventHandler( "use_paddle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_paddle") then ld.CloseSubRoom() end;
     cmn.GotoRoom("mg_crossing");
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_paddle_inv" );
  cmn.CallEventHandler( "use_paddle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boat_anm_boat", "use_paddle", func_end );
  SoundSfx( "aud_use_paddles" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_crossing_for_swamp = function()
    if ld.CheckRequirements( {"win_crossing"} ) then
      --ObjSet( "gmg_swamp_crossing", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_crossing", win_crossing_for_swamp, private.room_objname )

function public.Skip()
    local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
    if ( mg_name == "zz_bog" ) and not ld.CheckRequirements( { "win_frogs" } ) then
      ld.Lock(1); 
      public.win_frogs_skip(); 
    end;

end;
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  if ( mg_name == "zz_bog" ) and not ld.CheckRequirements( { "win_frogs" } ) then  
    public.win_frogs_reset();
  end;

end;  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_swamp();
 
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_swamp_env" );
  if not ld.CheckRequirements( {"clk_anmboat"} ) then
    ObjAttach("vid_swamp_vid_boat_121","rm_swamp");
  end;
  ObjSet( "anm_swamp_anm_tree1", {playing = 1 } );
  ObjSet( "anm_swamp_anm_tree2", {playing = 1 } );
  ObjSet( "anm_swamp_anm_tree3", {playing = 1 } );
  ObjSet( "anm_swamp_anm_bubble", {playing = 1 } );
  ObjSet( "anm_swamp_anm_frog", {playing = 1 } );
  
  local swamp_win_frogs_frog_on_back_pos = {{135,511},{200,521},{206,500},{175,476},{244,478},{211,471}};
  if cmn.IsEventStart("win_frogs") and not cmn.IsEventDone("win_frogs") then 
     ObjSet( "spr_swamp_frog2", {pos_x=swamp_win_frogs_frog_on_back_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][1], pos_y=swamp_win_frogs_frog_on_back_pos[ng_global.progress[ "std" ][ "win_frogs" ].state][2],scale_x = private.win_frogs_set_scale(ng_global.progress[ "std" ][ "win_frogs" ].state)} );
  end;  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  ObjSet( "anm_swamp_anm_tree1", {playing = 0 } );  
  ObjSet( "anm_swamp_anm_tree2", {playing = 0 } );  
  ObjSet( "anm_swamp_anm_tree3", {playing = 0 } );  
  ObjSet( "anm_swamp_anm_bubble", {playing = 0 } ); 
  ObjSet( "anm_swamp_anm_frog", {playing = 0 } );   
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_boat" );
  function zz_boat.Open()
  end;
  function zz_boat.PreOpen()
  end;
  function zz_boat.PreClose()
  end;
  function zz_boat.Close()
  end;

  subroom.Define( "zz_hut" );
  function zz_hut.Open()
  end;
  function zz_hut.PreOpen()
  end;
  function zz_hut.PreClose()
  end;
  function zz_hut.Close()
  end;

  subroom.Define( "zz_bog" );
  function zz_bog.Open()
    if ld.CheckRequirements( {"use_frog"} ) and not ld.CheckRequirements( {"win_frogs"} ) then
      cmn.MiniGameShow( "frogs" );
    end
    ObjSet( "anm_bog_anm_flower", {animfunc = "anim_flower", frame = 0, playing = 1 } );
  end;
  function zz_bog.PreOpen()
    if  not cmn.IsEventDone( "win_frogs" )  and cmn.IsEventStart( "win_frogs" ) and cmn.IsEventDone( "use_frog" ) then
       public.win_frogs_load(1);   
    end
  end;
  function zz_bog.PreClose()
    if ld.CheckRequirements( {"use_frog"} ) and not ld.CheckRequirements( {"win_frogs"} ) then
      cmn.MiniGameHide( "frogs" );
    end
    ObjSet( "anm_bog_anm_flower", {animfunc = "anim_flower", frame = 0, playing = 0 } );
  end;
  function zz_bog.Close()
  end;

  subroom.Define( "zz_hollowtree" );
  function zz_hollowtree.Open()
    if not ld.CheckRequirements( {"clk_bird"} ) then
      ObjSet( "anm_hollowtree_anm_bird", {animfunc = "bird_sleep_static", frame = 0, playing = 1 } );
    else
      if not ld.CheckRequirements( {"use_seed"} ) then
        ObjSet( "anm_hollowtree_anm_bird", {animfunc = "bird_static1", frame = 0, playing = 1 } );
      else
        ObjSet( "anm_hollowtree_anm_bird", {animfunc = "bird_sleep_static2", frame = 0, playing = 1 } );  
      end
    end
  end;
  function zz_hollowtree.PreOpen()
  end;
  function zz_hollowtree.PreClose()
    if not ld.CheckRequirements( {"clk_bird"} ) then
      ObjSet( "anm_hollowtree_anm_bird", {animfunc = "bird_sleep_static", playing = 0 } );
    else
      if not ld.CheckRequirements( {"use_seed"} ) then
        ObjSet( "anm_hollowtree_anm_bird", {animfunc = "bird_static1", playing = 0 } );
      else
        ObjSet( "anm_hollowtree_anm_bird", {animfunc = "bird_sleep_static2", playing = 0 } );  
      end
    end
  end;
  function zz_hollowtree.Close()
  end;
  
end;
--*********************************************************************************************************************