-- name=rm_tower
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_tower";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
--  private.tower_vid_tower_conflict_array = {"vid_tower_conflict","vid_tower_conflict","vid_tower_conflict","vid_tower_conflict"};
--  
--  ld.VidStaticInit( 
--      private.tower_vid_tower_conflict_array,                                                        --оъект видео
--      { "rm_tower", "zz_lantern", "zz_wall", "zz_laddergrille"}, --к чему относится объект
--      {"aud_conflict_136","aud_conflict_136","aud_conflict_136","aud_conflict_136"},        --SFX
--      { 3, 5 },                                                                            --рандом запуска от до
--      false,                                                              --прогрес по которому статика будет играть
--      false,      --прогресс по которому статика перестаёт играть  
--      {"aud_conflict_136_voc","aud_conflict_136_2_voc","aud_conflict_136_3_voc","aud_conflict_136_4_voc"},
--      "rm_tower"
--  );
  --------------------------------------------------------------------------------------------
  private.tower_wall_paper_voice = false;
  private.tower_wall_paper_voice_func = function()
      if not private.tower_wall_paper_voice then 
        --  ld.Lock(1); 
          ld.ShowBbt("tower_wall_note_clk");
          --  SoundVoice("aud_pc_9_voc");
          -- ld.StartTimer( 2, function() ld.Lock(0); end )
          ld.Lock( 0 )
          private.tower_wall_paper_voice = true;
      else
          ld.ShowBbt( "tower_wall_note_clk" );ld.Lock( 0 )
      end;
  end;
  ld.NoteInit("spr_wall_note","spr_wall_note_big", private.tower_wall_paper_voice_func);
  --------------------------------------------------------------------------------------------
function private.opn_tower()
  local func_end = function()
    common_impl.Lock(0);
    cmn.SetEventDone( "opn_tower" );
    cmn.CallEventHandler( "opn_tower" );
  end;
  
  if not ( cmn.IsEventDone( "opn_tower" ) ) then
    SoundTheme( "aud_danger1_mus" );
    --   cmn.SetEventDone( "opn_tower" );
    --  cmn.CallEventHandler( "opn_tower" )
    ld.Lock(1);
    -- ld.VidStaticPause( private.tower_vid_tower_conflict_array );
    ld.ShowBbt("opn_tower");
    --SoundVoice("aud_pc_8_voc"); 
    -- ld.StartTimer( 2, function() ld.VidStaticPlay( private.tower_vid_tower_conflict_array ); common_impl.Lock(0); end )
    ld.StartTimer( 0.5, function()
       VidPlay("vid_tower_conflict", func_end);
       SoundVid("aud_conflict_136");
       SoundVoice("aud_conflict_136_voc");
    end )
  end;
end;
--------------------------------------------------------------------
local opn_tower = function()
  ObjDelete("vid_tower_conflict");
end;
local opn_tower_logic = function() end;
cmn.AddSubscriber( "opn_tower", opn_tower_logic )
cmn.AddSubscriber( "opn_tower", opn_tower, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_grileopn" ] = { type = "click", use_place = "gfx_tower_clk_grileopn_zone", room = "rm_tower" };

private.clk_grileopn_logic = function()
  ObjSet( "gfx_tower_clk_outrolvl1_zone", {input = 1, visible = 1} );
end;
private.clk_grileopn_beg = function()
  ObjDelete( "gfx_tower_clk_grileopn_zone" );
end;
private.clk_grileopn_end = function()
  ObjSet("anm_tower_anim_open_door",{animfunc="anim_open_door_end",frame=0})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_grileopn", private.clk_grileopn_beg, private.room_objname );
cmn.AddSubscriber( "clk_grileopn", private.clk_grileopn_end, private.room_objname );
cmn.AddSubscriber( "clk_grileopn", private.clk_grileopn_logic );
cmn.AddSubscriber( "clk_grileopn_beg", private.clk_grileopn_beg, private.room_objname );
cmn.AddSubscriber( "clk_grileopn_end", private.clk_grileopn_end, private.room_objname );
cmn.AddSubscriber( "clk_grileopn_end", private.clk_grileopn_logic );
--------------------------------------------------------------------------------------------
function public.clk_grileopn()

  local func_end = function()
    cmn.SetEventDone( "clk_grileopn" );
    cmn.CallEventHandler( "clk_grileopn_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_grileopn_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tower_anim_open_door", "anim_open_door", func_end );
  SoundSfx( "aud_touch_grille_tower" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_outrolvl1" ] = { type = "click", use_place = "gfx_tower_clk_outrolvl1_zone", room = "rm_tower" };

private.clk_outrolvl1_logic = function()
  ObjSet( "gfx_ruralroad_clk_anmcoach1_zone", {active = 1, visible = 1,input = 1} );
  ObjSet( "grm_ruralroad_farm", {active = 0, visible = 0,input=0} );
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_ruralroad_farm_focus");
    end;
end;
private.clk_outrolvl1_beg = function()
  ObjDelete( "gfx_tower_clk_outrolvl1_zone" );
end;
private.clk_outrolvl1_end = function()
  ObjDelete("vid_tower_vid_outrolvl1")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_outrolvl1", private.clk_outrolvl1_beg, private.room_objname );
cmn.AddSubscriber( "clk_outrolvl1", private.clk_outrolvl1_end, private.room_objname );
cmn.AddSubscriber( "clk_outrolvl1", private.clk_outrolvl1_logic );
cmn.AddSubscriber( "clk_outrolvl1_beg", private.clk_outrolvl1_beg, private.room_objname );
cmn.AddSubscriber( "clk_outrolvl1_end", private.clk_outrolvl1_end, private.room_objname );
cmn.AddSubscriber( "clk_outrolvl1_end", private.clk_outrolvl1_logic );
--------------------------------------------------------------------------------------------
function public.clk_outrolvl1()

  local func_end = function()
    SoundVoice(0);
    --ld.LogTrace( "clk_outrolvl1  func_end" );
    cmn.SetEventDone( "clk_outrolvl1" );
    cmn.CallEventHandler( "clk_outrolvl1_end" );
    --common_impl.Lock(0);

       ObjSet("rm_tower",{color_r=0,color_g=0,color_b=0})
--       local widget_settings = 
--          {
--            InterfaceWidget_Inventory,
--            InterfaceWidget_BtnHint,
--            InterfaceWidget_BtnGuide,
--            InterfaceWidget_BtnMenu,
--            InterfaceWidget_BtnMap,
--          }
--
--       for i = 1, #widget_settings do
--          interface.WidgetSetVisible( widget_settings[i], 0, false );
--       end;
      VidPause("vid_tower_vid_outrolvl1",1)
      ObjAnimate( "vid_tower_vid_outrolvl1", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
      int.DialogVideoHide();
      if (iOS_IsBought() == 0) then
        iOS_LogEvents(1);
        cmn.LevelSwitch("menu","unlock");
      else
        cmn.GotoRoom("rm_ruralroad");
      end;
      --[[
      if  IsDemoEdition() then --IsSurveyEdition() or
        --int.DialogVideoHide();
        cmn.GotoRoom("rm_outro");
      else
        cmn.GotoRoom("rm_ruralroad");
      end;
      ]]
  end;

  cmn.CallEventHandler( "clk_outrolvl1_beg" );
  --common_impl.Lock(1);

  --SoundSfx( 0 )
  SoundEnv(0);
  --  ld.VidStaticPause( private.tower_vid_tower_conflict_array ); 
  ObjAttach("vid_tower_vid_outrolvl1","rm_tower");
  SoundVid("aud_outro");
  VidPlay("vid_tower_vid_outrolvl1",func_end);
  SoundVoice("aud_outro_voc");
  
       local widget_settings = 
          {
            InterfaceWidget_Inventory,
            InterfaceWidget_BtnHint,
            InterfaceWidget_BtnGuide,
            InterfaceWidget_BtnMenu,
            InterfaceWidget_BtnMap,
          }

       for i = 1, #widget_settings do
         interface.WidgetSetVisible( widget_settings[i], 0, false );
       end;  
  
  int.DialogVideoShow( "", 1, func_end, 1 ); 

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_lantern *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_veil" ] = { type = "use", inv_obj = "inv_veil", use_place = "gfx_lantern_veil_zone", room = "rm_tower", zz = "zz_lantern", zz_gate = "gzz_tower_lantern" };

private.use_veil_logic = function()
-- if ld.CheckRequirements( {"use_veil","use_lightedcandle"} ) then
--   ObjSet( "gfx_tower_clk_anmconflict_zone", {input = 1,visible=1} );
-- end;
   ObjSet( "gfx_lantern_lightedcandle_zone", {input = 1, visible = 1} );
end;
private.use_veil_inv = function()
  common_impl.ProcessMultiUseAll("veil", "veil")
end;
private.use_veil_beg = function()
  ObjDelete( "gfx_lantern_veil_zone" );
end;
private.use_veil_end = function()
  if common_impl.ZzCompleteCheck("use_veil") then ObjSet( common_impl.hint["use_veil"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_lantern_anm", {animfunc = "use_candel", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_veil", private.use_veil_inv );
cmn.AddSubscriber( "use_veil", private.use_veil_beg, private.room_objname );
cmn.AddSubscriber( "use_veil", private.use_veil_end, private.room_objname );
cmn.AddSubscriber( "use_veil", private.use_veil_logic );
cmn.AddSubscriber( "use_veil_inv", private.use_veil_inv, private.room_objname );
cmn.AddSubscriber( "use_veil_beg", private.use_veil_beg, private.room_objname );
cmn.AddSubscriber( "use_veil_end", private.use_veil_end, private.room_objname );
cmn.AddSubscriber( "use_veil_end", private.use_veil_logic );
--------------------------------------------------------------------------------------------
function public.use_veil( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_veil" );
    cmn.CallEventHandler( "use_veil_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_veil") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_veil_inv" );
  cmn.CallEventHandler( "use_veil_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_lantern_anm", "use_veil", func_end );
  SoundSfx( "aud_use_rag_lantern" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lightedcandle" ] = { type = "use", inv_obj = "inv_lightedcandle", use_place = "gfx_lantern_lightedcandle_zone", room = "rm_tower", zz = "zz_lantern", zz_gate = "gzz_tower_lantern" };

private.use_lightedcandle_logic = function()
  if ld.CheckRequirements( {"use_lightedcandle","use_veil"} ) then
    ObjSet( "gzz_tower_laddergrille", { visible = 1, input = 1 } )
    ObjSet( "gzz_tower_wall", { visible = 1, input = 1 } )
  end;

end;
private.use_lightedcandle_inv = function()
  common_impl.ProcessMultiUseAll("lightedcandle", "lightedcandle")
end;
private.use_lightedcandle_beg = function()
  ObjDelete( "gfx_lantern_lightedcandle_zone" );
end;
private.use_lightedcandle_end = function()
  if common_impl.ZzCompleteCheck("use_lightedcandle") then ObjSet( common_impl.hint["use_lightedcandle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_lantern_anm", {animfunc = "end_candel1", frame = 0 } );
   ObjDelete("spr_tower_dark");
  ObjSet( "spr_tower_tr_light", {visible = 1} );
  ObjSet( "spr_tower_tr_candle", {visible = 1} );
  ObjSet( "obj_tower_door_clk_zone", {input = 1} );
  ObjDelete("spr_tower_door_open_tr");
  ObjSet( "spr_tower_door_open_tr_light", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lightedcandle", private.use_lightedcandle_inv );
cmn.AddSubscriber( "use_lightedcandle", private.use_lightedcandle_beg, private.room_objname );
cmn.AddSubscriber( "use_lightedcandle", private.use_lightedcandle_end, private.room_objname );
cmn.AddSubscriber( "use_lightedcandle", private.use_lightedcandle_logic );
cmn.AddSubscriber( "use_lightedcandle_inv", private.use_lightedcandle_inv, private.room_objname );
cmn.AddSubscriber( "use_lightedcandle_beg", private.use_lightedcandle_beg, private.room_objname );
cmn.AddSubscriber( "use_lightedcandle_end", private.use_lightedcandle_end, private.room_objname );
cmn.AddSubscriber( "use_lightedcandle_end", private.use_lightedcandle_logic );
--------------------------------------------------------------------------------------------
function public.use_lightedcandle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lightedcandle" );
    cmn.CallEventHandler( "use_lightedcandle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lightedcandle") then ld.CloseSubRoom() end;
    ld.ShowBbt("after_lightedcandle");
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lightedcandle_inv" );
  cmn.CallEventHandler( "use_lightedcandle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_lantern_anm", "use_candel", function() ld.StartTimer( 0.5, func_end); end);
  SoundSfx( "aud_use_candle_lantern" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_wall *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_flowerkey" ] = { type = "get", get_obj = "spr_wall_flowerkey", room = "rm_tower", zz = "zz_wall", zz_gate = "gzz_tower_wall" };

private.get_flowerkey_logic = function()
  ObjSet( "gfx_wall_scottishstatue2_zone", {input = 1, visible = 1} );
  ObjSet( "gfx_wall_scottishstatue1_zone", {input = 1, visible = 1} );
end;
private.get_flowerkey_inv = function()
  interface.InventoryItemAdd("inv_flowerkey","spr_wall_flowerkey");
end;
private.get_flowerkey_beg = function()
  ObjDelete("gfx_wall_flowerkey")
end;
private.get_flowerkey_end = function()
  if common_impl.ZzCompleteCheck("get_flowerkey") then ObjSet( common_impl.hint["get_flowerkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_tower_tr_flowerkey");
  
end;

cmn.AddSubscriber( "get_flowerkey", private.get_flowerkey_inv );
cmn.AddSubscriber( "get_flowerkey", private.get_flowerkey_beg, private.room_objname );
cmn.AddSubscriber( "get_flowerkey", private.get_flowerkey_end, private.room_objname );
cmn.AddSubscriber( "get_flowerkey", private.get_flowerkey_logic );
--------------------------------------------------------------------
function public.get_flowerkey()
  cmn.SetEventDone( "get_flowerkey" );
  cmn.CallEventHandler( "get_flowerkey" );
  if common_impl.ZzCompleteCheck("get_flowerkey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_scottishstatue_zone_clk(num)
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_scottishstatue'..num )
  end;

  if not ld.CheckRequirements( {"use_scottishstatue1"} ) and not ld.CheckRequirements( {"use_scottishstatue2"} ) then
    ld.Lock(1);
    SoundSfx( "aud_touch_stone_wall" );
    ld.AnimPlay( "anm_wall_anm_stone", "idle", func_end )
  else 
    func_end();
  end;  
end;  




common_impl.hint[ "use_scottishstatue1" ] = { type = "use", inv_obj = "inv_scottishstatue1", use_place = "gfx_wall_scottishstatue1_zone", room = "rm_tower", zz = "zz_wall", zz_gate = "gzz_tower_wall" };

private.use_scottishstatue1_logic = function()
  if ld.CheckRequirements( {"use_scottishstatue1","use_scottishstatue2"} ) then
    ObjSet( "gfx_wall_clk_wallstone_zone", { visible = 1, input = 1 } )
  end;

end;
private.use_scottishstatue1_inv = function()
  common_impl.ProcessMultiUseAll("scottishstatue1", "scottishstatue1")
end;
private.use_scottishstatue1_beg = function()
  ObjDelete( "gfx_wall_scottishstatue1_zone" );
end;
private.use_scottishstatue1_end = function()
  if common_impl.ZzCompleteCheck("use_scottishstatue1") then ObjSet( common_impl.hint["use_scottishstatue1"].zz_gate, { visible = 0, input = 0 } ); end;
  
  if ld.CheckRequirements( {"use_scottishstatue1","use_scottishstatue2"} ) then
     ObjDelete("anm_wall_anm_dog1");
     ObjDelete("anm_wall_anm_dog2");
     ObjSet( "anm_wall_anm_stone", {animfunc = "stone", frame = 999 } );
  else 
     ObjSet( "anm_wall_anm_dog1", {pos_z=21, frame=999} );
     
  end;  
   ObjSet( "spr_tower_tr_dog", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scottishstatue1", private.use_scottishstatue1_inv );
cmn.AddSubscriber( "use_scottishstatue1", private.use_scottishstatue1_beg, private.room_objname );
cmn.AddSubscriber( "use_scottishstatue1", private.use_scottishstatue1_end, private.room_objname );
cmn.AddSubscriber( "use_scottishstatue1", private.use_scottishstatue1_logic );
cmn.AddSubscriber( "use_scottishstatue1_inv", private.use_scottishstatue1_inv, private.room_objname );
cmn.AddSubscriber( "use_scottishstatue1_beg", private.use_scottishstatue1_beg, private.room_objname );
cmn.AddSubscriber( "use_scottishstatue1_end", private.use_scottishstatue1_end, private.room_objname );
cmn.AddSubscriber( "use_scottishstatue1_end", private.use_scottishstatue1_logic );
--------------------------------------------------------------------------------------------
function public.use_scottishstatue1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scottishstatue1" );
    cmn.CallEventHandler( "use_scottishstatue1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_scottishstatue1") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
     if ld.CheckRequirements( {"use_scottishstatue2"} ) then
        ObjSet( "anm_wall_anm_dog1", {visible = 0} );
        ObjSet( "anm_wall_anm_dog2", {visible = 0} );
        SoundSfx( "aud_touch_dog_move_wall" );
        ld.AnimPlay( "anm_wall_anm_stone", "stone", func_end )
     else 
        func_end();
     end;  
  end;
  
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scottishstatue1_inv" );
  cmn.CallEventHandler( "use_scottishstatue1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wall_anm_dog1", "use_dog", func_preend );
  SoundSfx( "aud_use_dog_part_wall" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scottishstatue2" ] = { type = "use", inv_obj = "inv_scottishstatue2", use_place = "gfx_wall_scottishstatue2_zone", room = "rm_tower", zz = "zz_wall", zz_gate = "gzz_tower_wall" };

private.use_scottishstatue2_logic = function()
  if ld.CheckRequirements( {"use_scottishstatue2","use_scottishstatue1"} ) then
    ObjSet( "gfx_wall_clk_wallstone_zone", { visible = 1, input = 1 } )
  end;

end;
private.use_scottishstatue2_inv = function()
  common_impl.ProcessMultiUseAll("scottishstatue2", "scottishstatue2")
end;
private.use_scottishstatue2_beg = function()
  ObjDelete( "gfx_wall_scottishstatue2_zone" );
end;
private.use_scottishstatue2_end = function()
  if common_impl.ZzCompleteCheck("use_scottishstatue2") then ObjSet( common_impl.hint["use_scottishstatue2"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_scottishstatue1","use_scottishstatue2"} ) then
     ObjDelete("anm_wall_anm_dog1");
     ObjDelete("anm_wall_anm_dog2");
     ObjSet( "anm_wall_anm_stone", {animfunc = "stone", frame = 999 } );
  else 
     ObjSet( "anm_wall_anm_dog2", {pos_z=25, frame=999} );
  end;  
   ObjSet( "spr_tower_tr_dog_1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scottishstatue2", private.use_scottishstatue2_inv );
cmn.AddSubscriber( "use_scottishstatue2", private.use_scottishstatue2_beg, private.room_objname );
cmn.AddSubscriber( "use_scottishstatue2", private.use_scottishstatue2_end, private.room_objname );
cmn.AddSubscriber( "use_scottishstatue2", private.use_scottishstatue2_logic );
cmn.AddSubscriber( "use_scottishstatue2_inv", private.use_scottishstatue2_inv, private.room_objname );
cmn.AddSubscriber( "use_scottishstatue2_beg", private.use_scottishstatue2_beg, private.room_objname );
cmn.AddSubscriber( "use_scottishstatue2_end", private.use_scottishstatue2_end, private.room_objname );
cmn.AddSubscriber( "use_scottishstatue2_end", private.use_scottishstatue2_logic );
--------------------------------------------------------------------------------------------
function public.use_scottishstatue2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scottishstatue2" );
    cmn.CallEventHandler( "use_scottishstatue2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_scottishstatue2") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    if ld.CheckRequirements( {"use_scottishstatue1"} ) then
        ObjSet( "anm_wall_anm_dog1", {visible = 0} );
        ObjSet( "anm_wall_anm_dog2", {visible = 0} );
        SoundSfx( "aud_touch_dog_move_wall" );
        ld.AnimPlay( "anm_wall_anm_stone", "stone", func_end )
     else 
        func_end();
     end;  
  end;
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scottishstatue2_inv" );
  cmn.CallEventHandler( "use_scottishstatue2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wall_anm_dog2", "use_dog1", func_preend );
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_dog_part_wall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_wallstone" ] = { type = "click", use_place = "gfx_wall_clk_wallstone_zone", room = "rm_tower",  zz = "zz_wall", zz_gate = "gzz_tower_wall" };

private.clk_wallstone_logic = function()
  ObjSet( "spr_wall_squarekey", { visible = 1, input = 1 } )
  --  ObjSet( "gfx_wall_clk_wallnote1_zone", {input = 1, visible = 1} );
end;
private.clk_wallstone_beg = function()
  ObjDelete( "gfx_wall_clk_wallstone_zone" );
end;
private.clk_wallstone_end = function()
  if common_impl.ZzCompleteCheck("clk_wallstone") then ObjSet( common_impl.hint["clk_wallstone"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_wall_anm_stone",{animfunc="stone1", frame=999});
  ObjDelete("spr_tower_tr_dog");
  ObjDelete("spr_tower_tr_dog_1");
  ObjDelete("spr_tower_tr_stone");
  ObjSet( "spr_tower_tr_squarekey", {visible = 1} );
  ObjSet( "spr_wall_note", {input=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_wallstone", private.clk_wallstone_beg, private.room_objname );
cmn.AddSubscriber( "clk_wallstone", private.clk_wallstone_end, private.room_objname );
cmn.AddSubscriber( "clk_wallstone", private.clk_wallstone_logic );
cmn.AddSubscriber( "clk_wallstone_beg", private.clk_wallstone_beg, private.room_objname );
cmn.AddSubscriber( "clk_wallstone_end", private.clk_wallstone_end, private.room_objname );
cmn.AddSubscriber( "clk_wallstone_end", private.clk_wallstone_logic );
--------------------------------------------------------------------------------------------
function public.clk_wallstone()

  local func_end = function()
    cmn.SetEventDone( "clk_wallstone" );
    cmn.CallEventHandler( "clk_wallstone_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_wallstone_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wall_anm_stone", "stone1", func_end )
  SoundSfx( "aud_touch_dog_remove_wall" );
  --func_end()

end;
--------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_wallnote1" ] = { type = "click", use_place = "gfx_wall_clk_wallnote1_zone", room = "rm_tower",  zz = "zz_wall", zz_gate = "gzz_tower_wall" };
--
--private.clk_wallnote1_logic = function()
--  ObjSet( "gfx_wall_clk_wallnote2_zone", {input = 1, visible = 1} );
--end;
--private.clk_wallnote1_beg = function()
--  ObjDelete( "gfx_wall_clk_wallnote1_zone" );
--end;
--private.clk_wallnote1_end = function()
--  if common_impl.ZzCompleteCheck("clk_wallnote1") then ObjSet( common_impl.hint["clk_wallnote1"].zz_gate, { visible = 0, input = 0 } ); end;
--  ObjSet( "anm_wall_anm_note", {animfunc = "note1", frame = 0, pos_z=50 } );
--  --ObjSet( "spr_wall_note", {input = 1} );
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_wallnote1", private.clk_wallnote1_beg, private.room_objname );
--cmn.AddSubscriber( "clk_wallnote1", private.clk_wallnote1_end, private.room_objname );
--cmn.AddSubscriber( "clk_wallnote1", private.clk_wallnote1_logic );
--cmn.AddSubscriber( "clk_wallnote1_beg", private.clk_wallnote1_beg, private.room_objname );
--cmn.AddSubscriber( "clk_wallnote1_end", private.clk_wallnote1_end, private.room_objname );
--cmn.AddSubscriber( "clk_wallnote1_end", private.clk_wallnote1_logic );
----------------------------------------------------------------------------------------------
--function public.clk_wallnote1()
--
--  local func_end = function()
--    
--    cmn.CallEventHandler( "clk_wallnote1_end" );
--    common_impl.Lock(0);
--  end;
--
--  cmn.CallEventHandler( "clk_wallnote1_beg" );
--  common_impl.Lock(1);
--
--  ObjSet( "anm_wall_anm_note", {pos_z=50} );
--  ld.AnimPlay( "anm_wall_anm_note", "note", func_end )
--  --SoundSfx( 0 )
--  --func_end()
--
--end;
----------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_wallnote2" ] = { type = "click", use_place = "gfx_wall_clk_wallnote2_zone", room = "rm_tower",  zz = "zz_wall", zz_gate = "gzz_tower_wall" };
--
--private.clk_wallnote2_logic = function()
-- 
--end;
--private.clk_wallnote2_beg = function()
--  ObjDelete( "gfx_wall_clk_wallnote2_zone" );
--end;
--private.clk_wallnote2_end = function()
--  if common_impl.ZzCompleteCheck("clk_wallnote2") then ObjSet( common_impl.hint["clk_wallnote2"].zz_gate, { visible = 0, input = 0 } ); end;
--  ObjDelete( "anm_wall_anm_note");
--  ObjSet( "spr_wall_note", {input = 1, visible = 1} );
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_wallnote2", private.clk_wallnote2_beg, private.room_objname );
--cmn.AddSubscriber( "clk_wallnote2", private.clk_wallnote2_end, private.room_objname );
--cmn.AddSubscriber( "clk_wallnote2", private.clk_wallnote2_logic );
--cmn.AddSubscriber( "clk_wallnote2_beg", private.clk_wallnote2_beg, private.room_objname );
--cmn.AddSubscriber( "clk_wallnote2_end", private.clk_wallnote2_end, private.room_objname );
--cmn.AddSubscriber( "clk_wallnote2_end", private.clk_wallnote2_logic );
----------------------------------------------------------------------------------------------
--function public.clk_wallnote2()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_wallnote1" );
--    cmn.SetEventDone( "clk_wallnote2" );
--    cmn.CallEventHandler( "clk_wallnote2_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("clk_wallnote2") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "clk_wallnote2_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_wall_anm_note", "note1", func_end )
--  --SoundSfx( 0 )
--  --func_end()
--
--end;
----------------------------------------------------------------------
common_impl.hint[ "get_squarekey" ] = { type = "get", get_obj = "spr_wall_squarekey", room = "rm_tower", zz = "zz_wall", zz_gate = "gzz_tower_wall" };

private.get_squarekey_logic = function()
  
end;
private.get_squarekey_inv = function()
  interface.InventoryItemAdd("inv_squarekey","spr_wall_squarekey");
end;
private.get_squarekey_beg = function()
  ObjDelete("gfx_wall_squarekey")
end;
private.get_squarekey_end = function()
  if common_impl.ZzCompleteCheck("get_squarekey") then ObjSet( common_impl.hint["get_squarekey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_wall_sh_squarekey");
  ObjDelete("spr_tower_tr_squarekey");
end;

cmn.AddSubscriber( "get_squarekey", private.get_squarekey_inv );
cmn.AddSubscriber( "get_squarekey", private.get_squarekey_beg, private.room_objname );
cmn.AddSubscriber( "get_squarekey", private.get_squarekey_end, private.room_objname );
cmn.AddSubscriber( "get_squarekey", private.get_squarekey_logic );
--------------------------------------------------------------------
function public.get_squarekey()
  cmn.SetEventDone( "get_squarekey" );
  cmn.CallEventHandler( "get_squarekey" );
  if common_impl.ZzCompleteCheck("get_squarekey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_laddergrille *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_amuletcross" ] = { type = "get", get_obj = "spr_laddergrille_amuletcross", room = "rm_tower", zz = "zz_laddergrille", zz_gate = "gzz_tower_laddergrille" };

private.get_amuletcross_logic = function()
   if ld.CheckRequirements( {"get_amuletcross","get_mitten"} ) then
      ObjSet( "gfx_laddergrille_amulethorse_zone", {input = 1, visible = 1} );
   end;  
end;
private.get_amuletcross_inv = function()
  interface.InventoryItemAdd("inv_amuletcross","spr_laddergrille_amuletcross");
end;
private.get_amuletcross_beg = function()
  ObjDelete("gfx_laddergrille_amuletcross")
end;
private.get_amuletcross_end = function()
  if common_impl.ZzCompleteCheck("get_amuletcross") then ObjSet( common_impl.hint["get_amuletcross"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_laddergrille_sh_amuletcross");
end;

cmn.AddSubscriber( "get_amuletcross", private.get_amuletcross_inv );
cmn.AddSubscriber( "get_amuletcross", private.get_amuletcross_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletcross", private.get_amuletcross_end, private.room_objname );
cmn.AddSubscriber( "get_amuletcross", private.get_amuletcross_logic );
--------------------------------------------------------------------
function public.get_amuletcross()
  cmn.SetEventDone( "get_amuletcross" );
  cmn.CallEventHandler( "get_amuletcross" );
  if common_impl.ZzCompleteCheck("get_amuletcross") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mitten" ] = { type = "get", get_obj = "spr_laddergrille_mitten", room = "rm_tower", zz = "zz_laddergrille", zz_gate = "gzz_tower_laddergrille" };

private.get_mitten_logic = function()
   if ld.CheckRequirements( {"get_amuletcross","get_mitten"} ) then
      ObjSet( "gfx_laddergrille_amulethorse_zone", {input = 1, visible = 1} );
   end;  
end;
private.get_mitten_inv = function()
  interface.InventoryItemAdd("inv_mitten","spr_laddergrille_mitten");
end;
private.get_mitten_beg = function()
  ObjDelete("gfx_laddergrille_mitten")
end;
private.get_mitten_end = function()
  if common_impl.ZzCompleteCheck("get_mitten") then ObjSet( common_impl.hint["get_mitten"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_laddergrille_sh_mitten");
end;

cmn.AddSubscriber( "get_mitten", private.get_mitten_inv );
cmn.AddSubscriber( "get_mitten", private.get_mitten_beg, private.room_objname );
cmn.AddSubscriber( "get_mitten", private.get_mitten_end, private.room_objname );
cmn.AddSubscriber( "get_mitten", private.get_mitten_logic );
--------------------------------------------------------------------
function public.get_mitten()
  cmn.SetEventDone( "get_mitten" );
  cmn.CallEventHandler( "get_mitten" );
  if common_impl.ZzCompleteCheck("get_mitten") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_amulethorse_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_amulethorse' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_emblem_laddergrille" );
  ld.AnimPlay( "anm_laddergrille_anm_laddergrille", "idle_p", func_end )
end;  


common_impl.hint[ "use_amulethorse" ] = { type = "use", inv_obj = "inv_amulethorse", use_place = "gfx_laddergrille_amulethorse_zone", room = "rm_tower", zz = "zz_laddergrille", zz_gate = "gzz_tower_laddergrille" };

private.use_amulethorse_logic = function()
  ObjSet( "gmg_tower_grillemg", { visible = 1, input = 1 } )

end;
private.use_amulethorse_inv = function()
  common_impl.ProcessMultiUseAll("amulethorse", "amulethorse")
end;
private.use_amulethorse_beg = function()
  ObjDelete( "gfx_laddergrille_amulethorse_zone" );
end;
private.use_amulethorse_end = function()
  ObjSet( "spr_laddergrille_list", {input=0} );
  -- if common_impl.ZzCompleteCheck("use_amulethorse") then
  ObjSet( common_impl.hint["use_amulethorse"].zz_gate, { visible = 0, input = 0 } );
  -- end;
  ObjDelete("anm_laddergrille_anm_laddergrille");
  ObjDelete("spr_tower_tr_horseamulet");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amulethorse", private.use_amulethorse_inv );
cmn.AddSubscriber( "use_amulethorse", private.use_amulethorse_beg, private.room_objname );
cmn.AddSubscriber( "use_amulethorse", private.use_amulethorse_end, private.room_objname );
cmn.AddSubscriber( "use_amulethorse", private.use_amulethorse_logic );
cmn.AddSubscriber( "use_amulethorse_inv", private.use_amulethorse_inv, private.room_objname );
cmn.AddSubscriber( "use_amulethorse_beg", private.use_amulethorse_beg, private.room_objname );
cmn.AddSubscriber( "use_amulethorse_end", private.use_amulethorse_end, private.room_objname );
cmn.AddSubscriber( "use_amulethorse_end", private.use_amulethorse_logic );
--------------------------------------------------------------------------------------------
function public.use_amulethorse( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amulethorse" );
    cmn.CallEventHandler( "use_amulethorse_end" );
    common_impl.Lock(0);
    --  if common_impl.ZzCompleteCheck("use_amulethorse") then
     ld.CloseSubRoom() 
    --end;
     cmn.GotoRoom("mg_grillemg");
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amulethorse_inv" );
  cmn.CallEventHandler( "use_amulethorse_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_laddergrille_anm_laddergrille", "use_d", func_end )
  SoundSfx( "aud_use_emblem_laddergrille" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_grillemg_for_tower_logic = function()
    if ld.CheckRequirements( {"win_grillemg"} ) then
      ObjDelete( "gmg_tower_grillemg");
      ObjSet( "gfx_tower_clk_grileopn_zone", {input=1, visible = 1} );
    end
  end;
  local win_grillemg_for_tower = function()
   
  end;
  cmn.AddSubscriber("win_grillemg", win_grillemg_for_tower_logic )
  cmn.AddSubscriber("win_grillemg", win_grillemg_for_tower, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_tower();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_tower_env" );
  if not cmn.IsEventDone("opn_tower") then 
     ObjAttach("vid_tower_conflict","rm_tower");
  end;  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_laddergrille" );
  function zz_laddergrille.Open()
  end;
  function zz_laddergrille.PreOpen()
  end;
  function zz_laddergrille.PreClose()
  end;
  function zz_laddergrille.Close()
  end;

  subroom.Define( "zz_wall" );
  function zz_wall.Open()
  end;
  function zz_wall.PreOpen()
  end;
  function zz_wall.PreClose()
  end;
  function zz_wall.Close()
  end;

  subroom.Define( "zz_lantern" );
  function zz_lantern.Open()
  end;
  function zz_lantern.PreOpen()
  end;
  function zz_lantern.PreClose()
  end;
  function zz_lantern.Close()
  end;
  
end;
--*********************************************************************************************************************