-- name=ho_sweetsext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "sweetsext" );
  game.relations[ "ho_sweetsext" ].exitroom = "rm_mallext";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_sweetsext" ] = { type = "win", room = "rm_mallext", zz = "ho_sweetsext", zz_gate = "gho_mallext_sweetsext" };
 
  local win_sweetsext_func = function ()

    if ( cmn.IsEventDone( "win_sweetsext" ) ) then
      interface.InventoryItemAdd( "inv_ringsext", "spr_sweetsext_win" );
      ObjDelete( "gho_mallext_sweetsext" );
    end;

  end;
  cmn.AddSubscriber( "win_sweetsext", win_sweetsext_func );
  
  local start_sweetsext_func = function ()
  if not cmn.IsEventDone("win_sweetsext") then
  
  end
  end;
  cmn.AddSubscriber( "win_sweetsext", start_sweetsext_func, "ho_sweetsext" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_mallext_env" )

  if ( not cmn.IsEventDone( "opn_sweetsext" ) ) then

    cmn.InitHo( "sweetsext" );

    cmn.SetEventDone( "opn_sweetsext" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          2, 0, { { "spr_sweetsext_aaa_1","spr_sweetsext_aaa_2" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          2, 0, { { "spr_sweetsext_bbb_1","spr_sweetsext_bbb_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          2, 0, { { "spr_sweetsext_ccc_1","spr_sweetsext_ccc_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          2, 0, { { "spr_sweetsext_ddd_1","spr_sweetsext_ddd_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          2, 0, { { "spr_sweetsext_eee_1","spr_sweetsext_eee_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          2, 0, { { "spr_sweetsext_fff_1","spr_sweetsext_fff_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          2, 0, { { "spr_sweetsext_ggg_1","spr_sweetsext_ggg_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          2, 0, { { "spr_sweetsext_hhh_1","spr_sweetsext_hhh_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          2, 0, { { "spr_sweetsext_iii_1","spr_sweetsext_iii_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          2, 0, { { "spr_sweetsext_jjj_1","spr_sweetsext_jjj_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          2, 0, { { "spr_sweetsext_kkk_1","spr_sweetsext_kkk_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          2, 0, { { "spr_sweetsext_lll_1","spr_sweetsext_lll_2" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["ext"]["win_sweetsext"].found do

    local name = tostring( ng_global.progress["ext"]["win_sweetsext"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_sweetsext_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_sweetsext_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
private.cur_item = ""
function public.ClkItem(obj)
  local func_end
  local task = ld.StringDivide(obj)[3]
  if private.cur_item == "" then
    func_end = function()
    private.cur_item = obj
    ObjSet( obj, { input = 0 } )
    ld.Lock(0)
    end
  elseif task == ld.StringDivide(private.cur_item)[3] then
    func_end = function() 
      ld.Lock(0)   
      ObjAnimate( obj.."_light",12, 0, 0,"", {0,0,1,1,1, 0.3, 0,1,0} );
      ObjAnimate( private.cur_item.."_light",12, 0, 0, "", {0,0,1,1,1, 0.3,0, 0,1,0} );   
      
      ObjSet( private.cur_item, { pos_z = 1 } );cmn.HoTaskFind( private.cur_item, task );    
      ObjSet( obj, { pos_z = 1 } );cmn.HoTaskFind( obj, task );
      private.cur_item = ""    
    end
  else 
    func_end = function()   
      SoundSfx( "aud_ho_sweetsext_wrong" );
      ObjAnimate( obj.."_light",12, 0, 0,"", {0,0,1,1,1, 0.3,0, 1,0,0} );
      ObjAnimate( private.cur_item.."_light",12, 0, 0, "", {0,0,1,1,1, 0.3,0, 1,0,0} );    
      
      ObjAnimate( obj.."_light",8, 0, 0,function()ld.Lock(0)end, {0,0,1,0.3,0,1,0.6,0,0} );
      ObjAnimate( private.cur_item.."_light", 8, 0, 0, "", {0,0,1,0.3,0,1,0.6,0,0} );  
      ObjSet( obj, {input = 1} );
      ObjSet( private.cur_item, {input = 1} );    
      private.cur_item = ""
    end
  end
  ld.Lock(1)
  
  SoundSfx( "aud_ho_sweetsext_click" );
  ObjSet( obj.."_light", {color_g=1,color_b=1} );
  ObjAnimate( obj.."_light", 8, 0, 0, func_end, {0,0,0,0.3,0,1} );
end


function public.ClkHint()
  
  if private.cur_item == "" then
    interface.TaskPanelHoHintShow();
  else 
    local obj
    ld.LogTrace( private.cur_item );
    if ld.StringDivide(private.cur_item)[4]=="1" then
      obj = "spr_sweetsext_"..ld.StringDivide(private.cur_item)[3].."_2"
    else
      obj = "spr_sweetsext_"..ld.StringDivide(private.cur_item)[3].."_1"      
    end
    ld.LogTrace( obj );
    local hint_param = {{}}
    hint_param[1]={["pos_x"]=ObjGet(obj).pos_x,["pos_y"]=ObjGet(obj).pos_y,["obj_name"]=obj}
    MsgSend(Command_Effect_ShowHoHint,{hint = hint_param})
    --ld.LogTrace( hint_param );
  end
end
