-- name=mg_mechanismext
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_mechanismext";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mechanismext" ] = {type = "win", use_place = "mg_mechanismext", room = "rm_mallext", zz = "mg_mechanismext", zz_gate = "gmg_mallext_mechanismext" };

  local win_mechanismext_logic = function()
    if ld.CheckRequirements( {"win_mechanismext"} ) then
      
    end
  end;
  local win_mechanismext = function()
    if ld.CheckRequirements( {"win_mechanismext"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_mechanismext", win_mechanismext, private.room_objname )
  cmn.AddSubscriber("win_mechanismext", win_mechanismext_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
------------------------------------------------------------------------------------
private.mechanismext_way_points={}
private.mechanismext_way_points[1] = {{427,127},{267,127},{267,307},{145,546},{457,546},{457,404}};
private.mechanismext_way_points[2] = {{579,127},{739,127},{740,306},{861,546},{548,546},{548,404}};

private.mechanismext_ways = {{2},{1,3},{2,4,6},{3,5},{4,6},{3,5}};

private.mechanismext_parts_fpoint={5,5};
-----------------------------------------------
private.mechanismext_parts_init_flag = false;
function private.mechanismext_parts_init()
  if private.mechanismext_parts_init_flag == false then 
    for i=1,#private.mechanismext_ways,1 do 
      for j=1,#private.mechanismext_ways[i],1 do 
        ObjCreate("spr_mechanismext_armor_l"..i.."_"..private.mechanismext_ways[i][j].."_light","spr")
        ObjSet( "spr_mechanismext_armor_l"..i.."_"..private.mechanismext_ways[i][j].."_light", {res="assets/levels/levelext/mg_mechanismext/lig_armor", input=0, visible=1, alp=0} );
        ObjAttach("spr_mechanismext_armor_l"..i.."_"..private.mechanismext_ways[i][j].."_light","spr_mechanismext_armor_l"..i.."_"..private.mechanismext_ways[i][j]);
      
        ObjSet( "spr_mechanismext_armor_l"..i.."_"..private.mechanismext_ways[i][j], {inputrect_init=1, inputrect_w=102, inputrect_h=42, inputrect_x=-51, inputrect_y=-21,
            event_mdown="mg_mechanismext.mechanismext_arrow_mdown(1,"..i..","..private.mechanismext_ways[i][j]..");", event_menter = "mg_mechanismext.mechanismext_arrow_menter(1,"..i..","..private.mechanismext_ways[i][j]..");", 
            event_mleave = "mg_mechanismext.mechanismext_arrow_mleave(1,"..i..","..private.mechanismext_ways[i][j]..");"} );
        
        
        ObjCreate("spr_mechanismext_armor_r"..i.."_"..private.mechanismext_ways[i][j].."_light","spr")
        ObjSet( "spr_mechanismext_armor_r"..i.."_"..private.mechanismext_ways[i][j].."_light", {res="assets/levels/levelext/mg_mechanismext/lig_armor", input=0, visible=1, alp=0} );
        ObjAttach("spr_mechanismext_armor_r"..i.."_"..private.mechanismext_ways[i][j].."_light","spr_mechanismext_armor_r"..i.."_"..private.mechanismext_ways[i][j]);
        
        ObjSet( "spr_mechanismext_armor_r"..i.."_"..private.mechanismext_ways[i][j], {inputrect_init=1, inputrect_w=102, inputrect_h=42, inputrect_x=-51, inputrect_y=-21,
          event_mdown="mg_mechanismext.mechanismext_arrow_mdown(2,"..i..","..private.mechanismext_ways[i][j]..");" , event_menter = "mg_mechanismext.mechanismext_arrow_menter(2,"..i..","..private.mechanismext_ways[i][j]..");", 
           event_mleave = "mg_mechanismext.mechanismext_arrow_mleave(2,"..i..","..private.mechanismext_ways[i][j]..");"} );

      end;  
    end;  
  end;
  
 private.mechanismext_parts_init_flag = true;  
end;  


function private.mechanismext_show_points()
  for i=1,#private.mechanismext_ways,1 do 
      ObjSet( "obj_mechanismext_left_p"..i, {input=0, visible=0} );
      ObjSet( "obj_mechanismext_right_p"..i, {input=0, visible=0} );
      for j=1,#private.mechanismext_ways[i],1 do 
        ObjSet( "spr_mechanismext_armor_l"..i.."_"..private.mechanismext_ways[i][j],{visible=1, input=1});
        ObjSet( "spr_mechanismext_armor_r"..i.."_"..private.mechanismext_ways[i][j],{visible=1, input=1});
        ObjSet( "spr_mechanismext_armor_r"..i.."_"..private.mechanismext_ways[i][j].."_light", {alp=0} );
        ObjSet( "spr_mechanismext_armor_l"..i.."_"..private.mechanismext_ways[i][j].."_light", {alp=0} );
      end;
  end; 
 
  ObjSet( "obj_mechanismext_left_p"..gm.state[1][1], {input=1, visible=1} );   
  ObjSet( "obj_mechanismext_right_p"..gm.state[1][2], {input=1, visible=1} ); 

  if gm.state[1][1]==2 and math.floor(ObjGet("spr_mechanismext_b2").ang)~=0 and math.floor(ObjGet("spr_mechanismext_b2").ang)~=3 and math.floor(ObjGet("spr_mechanismext_b2").ang)~=6 then
    ObjSet( "spr_mechanismext_armor_l2_3", {input = 0, visible = 0} );
  end;  
  if gm.state[1][1]==3 and math.floor(ObjGet("spr_mechanismext_b2").ang)~=0 and math.floor(ObjGet("spr_mechanismext_b2").ang)~=3 and math.floor(ObjGet("spr_mechanismext_b2").ang)~=6 then
    ObjSet( "spr_mechanismext_armor_l3_2", {input = 0, visible = 0} );
  end;
  if gm.state[1][1]==5 and math.floor(ObjGet("spr_mechanismext_b1").ang)~=0 and math.floor(ObjGet("spr_mechanismext_b1").ang)~=3 and math.floor(ObjGet("spr_mechanismext_b1").ang)~=6 then  
    ObjSet( "spr_mechanismext_armor_l5_4", {input = 0, visible = 0} );
  end;
  if gm.state[1][1]==4 and math.floor(ObjGet("spr_mechanismext_b1").ang)~=0 and math.floor(ObjGet("spr_mechanismext_b1").ang)~=3 and math.floor(ObjGet("spr_mechanismext_b1").ang)~=6 then  
    ObjSet( "spr_mechanismext_armor_l4_5", {input = 0, visible = 0} );  
  end;
  if gm.state[1][2]==3 and math.floor(ObjGet("spr_mechanismext_c1").ang)~=0 and math.floor(ObjGet("spr_mechanismext_c1").ang)~=6 then  
    ObjSet( "spr_mechanismext_armor_r3_6", {input = 0, visible = 0} );
  end;
  if gm.state[1][2]==3 and math.floor(ObjGet("spr_mechanismext_d1").ang)~=0 and math.floor(ObjGet("spr_mechanismext_d1").ang)~=6 and math.floor(ObjGet("spr_mechanismext_d1").ang)~=3 then  
    ObjSet( "spr_mechanismext_armor_r3_4", {input = 0, visible = 0} );
  end;
  if gm.state[1][2]==4 and math.floor(ObjGet("spr_mechanismext_d1").ang)~=0 and math.floor(ObjGet("spr_mechanismext_d1").ang)~=6 and math.floor(ObjGet("spr_mechanismext_d1").ang)~=3 then  
    ObjSet( "spr_mechanismext_armor_r4_3", {input = 0, visible = 0} );
  end;
  if gm.state[1][2]==6 and math.floor(ObjGet("spr_mechanismext_c1").ang)~=0 and math.floor(ObjGet("spr_mechanismext_c1").ang)~=6 then  
    ObjSet( "spr_mechanismext_armor_r6_3", {input = 0, visible = 0} );
  end;
  if gm.state[1][2]==6 and math.floor(ObjGet("spr_mechanismext_c1").ang)~=0 and math.floor(ObjGet("spr_mechanismext_c1").ang)~=6 then  
    ObjSet( "spr_mechanismext_armor_r6_5", {input = 0, visible = 0} );
  end;
  if gm.state[1][2]==5 and math.floor(ObjGet("spr_mechanismext_c1").ang)~=0 and math.floor(ObjGet("spr_mechanismext_c1").ang)~=6 then  
    ObjSet( "spr_mechanismext_armor_r5_6", {input = 0, visible = 0} );
  end;  
end;  


function private.mechanismext_stand_on_pos()
  ObjSet( "spr_mechanismext_carrot", {pos_x=private.mechanismext_way_points[1][gm.state[1][1] ][1], pos_y = private.mechanismext_way_points[1][gm.state[1][1] ][2] } );
  ObjSet( "spr_mechanismext_hare", {pos_x=private.mechanismext_way_points[2][gm.state[1][2] ][1], pos_y = private.mechanismext_way_points[2][gm.state[1][2] ][2] } );  
  ObjSet( "spr_mechanismext_a1_1", {ang = gm.state[2][1][1]} );
  ObjSet( "spr_mechanismext_a2_1", {ang = gm.state[2][2][1]} );
  ObjSet( "spr_mechanismext_a2_2", {ang = gm.state[2][2][2]} );
  
  private.mechanismext_stand_other_rot();
  private.mechanismext_show_points(); 
  private.mechanismext_win_ver();
end; 
------------------------------------------------------------------------------------------------------------
function private.mechanismext_win_ver()
  if gm.state[1][1]==1 and gm.state[1][2]==1 then 
    private.Win();
  end;  
end;  
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
function public.mechanismext_arrow_menter(side,num,next_num)
  local sides_array={"left","right"};
  local sides_array2={"l","r"};
  local sides_fig = {"carrot","hare"}
  
  ObjSet( "spr_mechanismext_lig_"..sides_fig[side], {alp=1} );
  ObjSet( "spr_mechanismext_armor_"..sides_array2[side]..num.."_"..next_num.."_light", {alp=1} );
  
  ld.SetCursor(CURSOR_HAND);
end;  
-----------------------------------------------------------------------------------------------------------
function public.mechanismext_arrow_mleave(side,num,next_num)
  local sides_array={"left","right"};
  local sides_fig = {"carrot","hare"}
  local sides_array2={"l","r"};
  
  ObjSet( "spr_mechanismext_lig_"..sides_fig[side], {alp=0} );
  ObjSet( "spr_mechanismext_armor_"..sides_array2[side]..num.."_"..next_num.."_light", {alp=0} );
  
  ld.SetCursor(CURSOR_DEFAULT);
end;  

------------------------------------------------------------------------------------------------------------
function public.mechanismext_arrow_mdown(side,num,next_num)
  local sides_array={"left","right"};
  local sides_fig = {"carrot","hare"}
  ObjSet( "obj_mechanismext_"..sides_array[side].."_p"..gm.state[1][side], {input=0, visible=0} );
  
  local func_end = function()
     gm.state[1][side] = next_num;
     ld.Lock(0);
     private.mechanismext_stand_on_pos()
  end;  
 
  
  ld.Lock(1);
  local obj = ObjGet("spr_mechanismext_"..sides_fig[side]);
  local cur_pos = {obj.pos_x, obj.pos_y};
  local next_pos = {private.mechanismext_way_points[side][next_num][1],private.mechanismext_way_points[side][next_num][2]}
  SoundSfx( "aud_mg_mechanismext_move" )
  ObjAnimate( "spr_mechanismext_"..sides_fig[side], 3, 0, 0, func_end, {0,0,cur_pos[1],cur_pos[2], 0.5,0,next_pos[1],next_pos[2]} ); 
  private.mechanismext_rotate(side,num,next_num)
end;  
-------------------------------------------------------------------------------------------

local mechanismext_rotate_way_array={}
mechanismext_rotate_way_array[1]={{5,6,{{"c1",-1},{"b2",1}}}};   ---left
mechanismext_rotate_way_array[2]={{3,6,{{"d1",-1}}},{4,5,{{"b1",1}}}}; --right

private.mechanismext_rotate_fp_array={{0.5*math.pi},{0.5*math.pi,0.5*math.pi}};

function private.mechanismext_rotate(side,num,next_num)
  local func_end = function()
  
  end;  
  
  if side==1 then 
    if (num==5 and next_num==6) or (num==6 and next_num==5) then
      local cur_ang = gm.state[2][1][1];
      local zn=-1;
      if num==6 then zn=1 end;
      local next_ang = cur_ang + zn*0.5*math.pi;
      private.mechanismext_anim_other_root(side,1,(next_ang - cur_ang));
      SoundSfx( "aud_mg_mechanismext_gear" )
      ObjAnimate( "spr_mechanismext_a1_1", 7, 0, 0, function() next_ang = math.fmod(next_ang+2*math.pi,2*math.pi); gm.state[2][1][1]=next_ang; end, {0,0,cur_ang, 0.5,0,next_ang} );
    end;  
  else 
    if (num==3 and next_num==6) or (num==6 and next_num==3) then 
      local cur_ang = gm.state[2][2][1];
      local zn=1;
      if num==6 then zn=-1 end;
      local next_ang =  cur_ang + zn*0.5*math.pi
      private.mechanismext_anim_other_root(side,1,(next_ang - cur_ang));
      SoundSfx( "aud_mg_mechanismext_gear" )
      ObjAnimate( "spr_mechanismext_a2_1", 7, 0, 0, function() next_ang = math.fmod(next_ang+2*math.pi,2*math.pi);  gm.state[2][2][1]=next_ang; end, {0,0,cur_ang, 0.5,0,next_ang} );
    elseif (num==4 and next_num==5) or (num==5 and next_num==4) then 
      local cur_ang = gm.state[2][2][2];
      local zn=1;
      if num==5 then zn=-1 end;
      local next_ang = cur_ang + zn*0.5*math.pi
      private.mechanismext_anim_other_root(side,2,(next_ang - cur_ang));
      SoundSfx( "aud_mg_mechanismext_gear" )
      ObjAnimate( "spr_mechanismext_a2_2", 7, 0, 0, function() next_ang = math.fmod(next_ang+2*math.pi,2*math.pi);  gm.state[2][2][2]=next_ang; end, {0,0,cur_ang, 0.5,0,next_ang} );
    end;  
  end;  
end;  
  
---------------------------------------------------------------  
function private.mechanismext_anim_other_root(side,i1,new_ang_dif)
  for i=1,#mechanismext_rotate_way_array[side][i1][3],1 do 
    local cur_ang = ObjGet("spr_mechanismext_"..mechanismext_rotate_way_array[side][i1][3][i][1]).ang;
    local my_new_ang =  cur_ang + new_ang_dif*mechanismext_rotate_way_array[side][i1][3][i][2];
    ObjAnimate( "spr_mechanismext_"..mechanismext_rotate_way_array[side][i1][3][i][1], 7, 0, 0, function()
          my_new_ang = math.fmod(my_new_ang+2*math.pi,2*math.pi); ObjSet( "spr_mechanismext_"..mechanismext_rotate_way_array[side][i1][3][i][1], {ang = my_new_ang} );  end,
          {0,0,cur_ang, 0.5,0,my_new_ang} ); 
    if side==1 then 
       if new_ang_dif>0 then  
         ld.AnimPlay( "anm_mechanismext_anm_mehan_1", "a1", function() end )
       else 
         ld.AnimPlay( "anm_mechanismext_anm_mehan_1", "a2", function() end )
       end;  
       elseif side==2 and i1==2 then 
       if new_ang_dif>0 then  
         ld.AnimPlay( "anm_mechanismext_anm_mehan_2", "b1", function() end )
       else 
           ld.AnimPlay( "anm_mechanismext_anm_mehan_2", "b2", function() end )
       end;  
    end;        
  end;  
  
end;  

function private.mechanismext_stand_other_rot()
   local new_ang = math.fmod(gm.state[2][1][1]*mechanismext_rotate_way_array[1][1][3][1][2] +4*math.pi+math.pi,2*math.pi);
   ObjSet( "spr_mechanismext_c1", {ang = new_ang} );
   
   new_ang = math.fmod(gm.state[2][1][1]*mechanismext_rotate_way_array[1][1][3][2][2] +4*math.pi+0.5*math.pi,2*math.pi)
   ObjSet( "spr_mechanismext_b2", {ang = new_ang} );
   
   new_ang = math.fmod(gm.state[2][2][1]*mechanismext_rotate_way_array[2][1][3][1][2] +4*math.pi,2*math.pi)
   ObjSet( "spr_mechanismext_d1", {ang = new_ang} );
   
   new_ang = math.fmod(gm.state[2][2][2]*mechanismext_rotate_way_array[2][2][3][1][2] +4*math.pi,2*math.pi)
   ObjSet( "spr_mechanismext_b1", {ang = new_ang} );
end;  
  
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_mechanismext"} ) then
    cmn.MiniGameShow( "mechanismext" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_mallext_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_mechanismext"} ) then
    cmn.MiniGameHide( "mechanismext" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function()
      gm.state={}
      gm.state[1] = ld.TableCopy(private.mechanismext_parts_fpoint);
      gm.state[2] = ld.TableCopy(private.mechanismext_rotate_fp_array);
      ng_global.progress["ext"]["win_mechanismext"].state =  gm.state;
      private.mechanismext_stand_on_pos();
      ObjAnimate( "obj_mechanismext_mg_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.5,0,1} );
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_mechanismext_mg_root", 8, 0, 0, func_end, {0,0,1, 0.5,0,0} );
  
end;
--*********************************************************************************************************************
function public.Skip()
   local func_end = function()
      gm.state={}
      gm.state[1] = {1,1};
      gm.state[2] = ld.TableCopy(private.mechanismext_rotate_fp_array);
      ng_global.progress["ext"]["win_mechanismext"].state =  gm.state;
      private.mechanismext_stand_on_pos();
      ObjAnimate( "obj_mechanismext_mg_root", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_mechanismext_mg_root", 8, 0, 0, func_end, {0,0,1, 0.5,0,0} );
  
end;
--*********************************************************************************************************************
function private.WinEnd()
  SoundSfx( "aud_open_door_mallext" );
  ld.Lock(0);
  cmn.SetEventDone( "win_mechanismext" );
  cmn.CallEventHandler( "win_mechanismext" );
  if common_impl.ZzCompleteCheck( "win_mechanismext" ) then cmn.GotoRoom( "rm_mallext" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundSfx( "aud_mg_mechanismext_win" )
  ObjAnimate( "obj_mechanismext_right_p1", 8, 0, 0, function() end, {0,0,1, 0.25,0,0} );
  ObjAnimate( "obj_mechanismext_left_p1", 8, 0, 0, function() end, {0,0,1, 0.25,0,0} );  
  ld.StartTimer( 1, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  private.mechanismext_parts_init();
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["ext"]["win_mechanismext"].state then
      gm.state =  ng_global.progress["ext"]["win_mechanismext"].state 
    else  
      gm.state={}
      gm.state[1] = ld.TableCopy(private.mechanismext_parts_fpoint);
      gm.state[2] = ld.TableCopy(private.mechanismext_rotate_fp_array);
      ng_global.progress["ext"]["win_mechanismext"].state =  gm.state;
    end
  
    gm.loaded  = true;
  else
  
  end;
  private.mechanismext_stand_on_pos();
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["ext"]["win_mechanismext"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;