-- name=levelext

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 13 );
  interface.WidgetAdd( InterfaceWidget_BtnGuide, 12 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 11 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 9 );

  interface.WidgetAdd( InterfaceWidget_Effects );



  interface.WidgetAdd( InterfaceWidget_DialogHo,30 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  interface.WidgetAdd( InterfaceWidget_ItemPanel,9 );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog,30 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo,30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory,30 );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 30 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide,30 );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial,30 );
  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );
  interface.WidgetAdd( InterfaceWidget_Map, 16  );

  interface.PanelNotificationAdd(10);


  --interface.DeployInvAdd(7);
  interface.ComplexInvAdd( 9 )
  interface.DialogHintAdd(20);
  --interface.Btn_DiaryAdd(12)
  --interface.InvestigationButtonAdd( 17 );
  --interface.DiaryAdd( 18 );
  --interface.DiaryDcnAdd( 31 );

  interface.PanelhopairAdd(9)

  interface.ButtonTaskAdd(20)
  interface.DialogTaskAdd(1000)

  private.Init();



  ModLoad( "assets/levels/levelext/mod_levelext_inv" );
  levelext_inv.Init()

  --private.TutorInit()--тутор
  --

  interface.ArrCards()
  interface.ArrPuzzles()

  common.LevelLoad( "levelext", "ext", "rm_inhouseext", param );
  --ModLoad( "assets/interface/map/mod_map" );

  interface.ArrInvPlus()  -- проверка состояния плюсика для деплойных инв предметов
  --public.init_diary_analysis()  ---клики для дневника

  interface.KeyUpdate();

  --временно залочена кнопка SG
  --interface.WidgetSetInput(InterfaceWidget_BtnGuide, 0)

  ObjSet( "txt_int_dialog_character", {param0 = GetCurrentProfile()} );
  --автоподствновка имени игрока в диалоги

  interface.CheckPuzzles()
  interface.CheckMorphing()
  interface.CheckCards()
end;

function public.MapAdd() 
  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );
end
--function public.SimonAdd() -- get_simon
--  interface.SimonAdd(10)
-- -- int_simon.LoadAnotherPrg()
--end

function private.Init ()

  game = {};
  game.room_names =
  {
   "rm_houseext"

--[[AUTO]]  ,"rm_ruralroadext"
--[[AUTO]]  ,"rm_inhouseext"
--[[AUTO]]  ,"ho_rootshoext"
--[[AUTO]]  ,"rm_farmext"
--[[AUTO]]  ,"rm_barnext"
--[[AUTO]]  ,"ho_innerporchhoext"
--[[AUTO]]  ,"rm_pondext"
--[[AUTO]]  ,"rm_nearpubext"
--[[AUTO]]  ,"rm_pubext"
--[[AUTO]]  ,"ho_bombthreeext"
--[[AUTO]]  ,"rm_mallext"
--[[AUTO]]  ,"ho_sweetsext"
--[[AUTO]]  ,"rm_staffonlyext"
--[[AUTO]]  ,"mg_gatespondext"
--[[AUTO]]  ,"mg_mechanismext"
--[[AUTO]]  ,"mg_pubmgext"
            ,"mg_bomboneext"
  };

  game.progress_names =
  {
--[[AUTO]]  "opn_inhouseext"
--[[AUTO]]  ,"get_batteryext2"
            ,"opn_houseext"


--[[AUTO]]  ,"get_flashlightoffext"
--[[AUTO]]  ,"opn_ruralroadext"
--[[AUTO]]  ,"get_ladybugext"

--[[AUTO]]  ,"use_ladybugext"
--[[AUTO]]  ,"get_batteryext1"
--[[AUTO]]  ,"get_backpackext"

--[[AUTO]]  ,"use_batteryext1"
--[[AUTO]]  ,"use_batteryext2"
            ,"clk_batteryexttest"
--[[AUTO]]  ,"get_flashlightonext"
--[[AUTO]]  ,"use_flashlightonext"
--[[AUTO]]  ,"get_axeext"
--[[AUTO]]  ,"get_childkeyext"
--[[AUTO]]  ,"use_axeext"
--[[AUTO]]  ,"opn_rootshoext"
--[[AUTO]]  ,"win_rootshoext"
--[[AUTO]]  ,"use_childkeyext"
--[[AUTO]]  ,"clk_diaryopnext"
--[[AUTO]]  ,"get_codeext"
--[[AUTO]]  ,"use_codeext"
--[[AUTO]]  ,"clk_diarycodeext"
            ,"clk_diarycodeext2"
--[[AUTO]]  ,"get_pocketknifeext"
--[[AUTO]]  ,"use_pocketknifeext_kioskext"
--[[AUTO]]  ,"get_handlerhombusext"
--[[AUTO]]  ,"use_handlerhombusext"
--[[AUTO]]  ,"get_nippersext"
--[[AUTO]]  ,"use_nippersext"
--[[AUTO]]  ,"opn_farmext"
--[[AUTO]]  ,"get_pouchext"
--[[AUTO]]  ,"get_handlecircleext"
--[[AUTO]]  ,"use_handlecircleext"
--[[AUTO]]  ,"get_partswitchext1"
--[[AUTO]] -- ,"get_bombmapext"
--[[AUTO]]  ,"use_pocketknifeext_harvesterext"
--[[AUTO]]  ,"get_greenwireext"
--[[AUTO]]  ,"use_pocketknifeext_exittopondext"
--[[AUTO]]  ,"get_petalext1"
--[[AUTO]]  ,"clk_opnpouchext"
--[[AUTO]]  ,"get_bluewireext"
--[[AUTO]]  ,"get_decorpartext1"
--[[AUTO]]  ,"get_handlesquareext"
--[[AUTO]]  ,"use_handlesquareext"
--[[AUTO]]  ,"get_magnetext"
--[[AUTO]]  ,"get_partswitchext2"
--[[AUTO]]  ,"use_magnetext"
--[[AUTO]]  ,"get_leverext"
--[[AUTO]]  ,"use_leverext"
--[[AUTO]] -- ,"get_parcelext"
--[[AUTO]]--  ,"clk_opnparcelext"
           -- ,"clk_opnparcelext2"
           --  ,"clk_readletterext
--[[AUTO]] -- ,"clk_readletterext2"
--[[AUTO]]  ,"get_yellowwireext"
--[[AUTO]]  ,"use_greenwireext"
--[[AUTO]]  ,"use_bluewireext"
--[[AUTO]]  ,"use_yellowwireext"
--[[AUTO]]  ,"win_bomboneext"
            ,"clk_bomboneextlist"
            ,"clk_bomboneextlist2"
--[[AUTO]]  ,"get_partswitchext3"
--[[AUTO]]  ,"get_bombmapext"
            ,"clk_opnbombmapext"
--[[AUTO]]  ,"clk_anmbombext1"
--[[AUTO]]  ,"use_partswitchext"
            ,"clk_partswitchext1"
            ,"clk_partswitchext2"
            ,"clk_partswitchext3"
--[[AUTO]]  ,"get_hookext"
--[[AUTO]]  ,"use_hookext"
--[[AUTO]] -- ,"clk_wellhookext"
--[[AUTO]]  ,"get_kioskplateext"
--[[AUTO]]  ,"use_kioskplateext"
--[[AUTO]]  ,"get_petalext2"
--[[AUTO]]  ,"use_petalext1"
--[[AUTO]]  ,"use_petalext2"
--[[AUTO]]  ,"win_flowersext"
--[[AUTO]]  ,"use_pocketknifeext_sackext"
--[[AUTO]]  ,"get_cigarcaseext"
--[[AUTO]]  ,"get_amuletcockerelext"
--[[AUTO]]  ,"use_amuletcockerelext"
--[[AUTO]]  ,"get_decorpartext2"
--[[AUTO]]  ,"get_sickleext"
--[[AUTO]]  ,"use_sickleext"
--[[AUTO]]  ,"get_innerporchkeyext"
--[[AUTO]]  ,"opn_barnext"
--[[AUTO]]  ,"use_innerporchkeyext"
--[[AUTO]]  ,"opn_innerporchhoext"
--[[AUTO]]  ,"win_innerporchhoext"
--[[AUTO]]  ,"use_amuletanchorext"
            ,"clk_cigarcaseext"
--[[AUTO]]  ,"get_stapleext"
--[[AUTO]]  ,"use_stapleext"
--[[AUTO]]  ,"get_pliersext"
--[[AUTO]]  ,"use_pliersext"
--[[AUTO]]  ,"get_decorpartext3"
--[[AUTO]]  ,"use_decorpartext"
--[[AUTO]]  ,"get_crowbarext"
--[[AUTO]]  ,"use_crowbarext"
--[[AUTO]]  ,"get_velvetboxext"
--[[AUTO]]  ,"get_scoopext"
--[[AUTO]]  ,"use_scoopext"
--[[AUTO]]  ,"get_tridentext"
--[[AUTO]]  ,"use_tridentext"
--[[AUTO]]  ,"win_gatespondext"
            ,"win_gatespondextinfarmext"
--[[AUTO]]  ,"opn_pondext"
--[[AUTO]]  ,"get_amuleteagleext1"
--[[AUTO]]  ,"get_cornext"
--[[AUTO]]  ,"use_cornext"
--[[AUTO]]  ,"get_regulatorext"
--[[AUTO]]  ,"use_regulatorext"
--[[AUTO]]  ,"win_bombext2"
--[[AUTO]]  ,"get_keyboothext"
--[[AUTO]]  ,"clk_anmbombext2"
--[[AUTO]]  ,"use_keyboothext"
            ,"clk_keyboothext"
--[[AUTO]]  ,"get_rudderext"
--[[AUTO]]  ,"use_rudderext"
--[[AUTO]]  ,"get_hacksawext"
--[[AUTO]]  ,"get_cannedext"
--[[AUTO]]  ,"use_hacksawext"
--[[AUTO]]  ,"get_metaltwigext"
--[[AUTO]]  ,"use_metaltwigext"
--[[AUTO]]  ,"get_amuleteagleext2"
--[[AUTO]]  ,"use_amuleteagleext1"
--[[AUTO]]  ,"use_amuleteagleext2"
            ,"clk_velvetboxopnext"
--[[AUTO]]  ,"get_keytrunkext"
--[[AUTO]]  ,"use_keytrunkext"
--[[AUTO]]  ,"clk_opntrunkext"
--[[AUTO]]  ,"get_amuletsailext"
--[[AUTO]]  ,"use_amuletsailext"
--[[AUTO]]  ,"get_openerext"
--[[AUTO]]  ,"get_thistleext"
--[[AUTO]]  ,"use_openerext"
--[[AUTO]]  ,"get_opencannedext"
--[[AUTO]]  ,"use_opencannedext"
--[[AUTO]]  ,"opn_nearpubext"
--[[AUTO]]  ,"get_coinext1"
--[[AUTO]]  ,"get_pubemblemext1"
--[[AUTO]]  ,"get_leatherbagext"
--[[AUTO]]  ,"use_thistleext"
--[[AUTO]]  ,"get_earofwheatext"
--[[AUTO]]  ,"use_earofwheatext"
--[[AUTO]]  ,"get_threepointedstarext"
--[[AUTO]]  ,"use_threepointedstarext"
            ,"clk_leatherbagopnext1"
--[[AUTO]]  ,"get_coinext2"
--[[AUTO]]  ,"get_compassext"
--[[AUTO]]  ,"use_compassext"
--[[AUTO]]  ,"get_tokenext"
--[[AUTO]]  ,"use_tokenext"
--[[AUTO]]  ,"get_letterbext"
--[[AUTO]]  ,"use_letterbext"
--[[AUTO]]  ,"get_stampext"
--[[AUTO]]  ,"use_stampext"
--[[AUTO]]  ,"get_matchesext"
--[[AUTO]]  ,"use_matchesext"
--[[AUTO]]  ,"win_pubmgext"
            ,"win_pubmgextinnearpubext"
--[[AUTO]]  ,"opn_pubext"
--[[AUTO]]  ,"clk_anmringext"
--[[AUTO]] -- ,"clk_uphandsetext"
--[[AUTO]]  ,"dlg_pubext_stormext3"
--[[AUTO]] -- ,"clk_downhandsetext"
--[[AUTO]]  ,"get_coinext3"
--[[AUTO]]  ,"get_twothistleext"
--[[AUTO]]  ,"get_fourpointedstarext"
--[[AUTO]]  ,"use_fourpointedstarext"
            ,"clk_leatherbagopnext2"
--[[AUTO]]  ,"get_lumberroomkeyext"
--[[AUTO]]  ,"use_lumberroomkeyext"
            ,"clk_storeroomext1"
            ,"clk_storeroomext2"
--[[AUTO]]  ,"dlg_pubext_innkeeperext1"
--[[AUTO]]  ,"get_videotapeext"
--[[AUTO]]  ,"use_videotapeext"
--[[AUTO]]  ,"clk_anmcameraext"
            ,"get_buttonext2"
--[[AUTO]]  ,"use_pocketknifeext_divanext"
--[[AUTO]]  ,"get_pubemblemext2"
--[[AUTO]]  ,"use_twothistleext"
--[[AUTO]]  ,"get_pubemblemext3"
--[[AUTO]]  ,"get_screwdriverext"
--[[AUTO]]  ,"use_screwdriverext"
--[[AUTO]]  ,"get_martletext"
--[[AUTO]]  ,"use_martletext"
--[[AUTO]]  ,"get_divanhandleext"
--[[AUTO]]  ,"get_noteext1"
--[[AUTO]]  ,"use_divanhandleext"
--[[AUTO]]  ,"opn_bombthreeext"
--[[AUTO]]  ,"win_bombthreeext"
--[[AUTO]]  ,"clk_anmbombext3"
--[[AUTO]]  ,"use_threethistleext"
--[[AUTO]]  ,"get_maracasext"
--[[AUTO]]  ,"use_maracasext"
--[[AUTO]]  ,"get_korzhext"
--[[AUTO]]  ,"use_korzhext"
--[[AUTO]]  ,"get_pubemblemext4"
--[[AUTO]]  ,"use_pubemblemext"
--[[AUTO]]  ,"get_coinext4"
--[[AUTO]]  ,"get_noteext2"
--[[AUTO]]  ,"use_noteext1"
--[[AUTO]]  ,"use_noteext2"
--[[AUTO]]  ,"get_keycompartmentext"
--[[AUTO]]  ,"use_keycompartmentext"
--[[AUTO]]  ,"get_whiskeyext"
--[[AUTO]]  ,"use_whiskeyext"
--[[AUTO]]  ,"get_coinext5"
--[[AUTO]]  ,"use_coinext"
--[[AUTO]]  ,"opn_mallext"
--[[AUTO]]  ,"get_gearext1"
--[[AUTO]]  ,"get_musicboxext"
--[[AUTO]]  ,"get_skittleext1"
--[[AUTO]]  ,"get_glasscutterext"
--[[AUTO]]  ,"use_glasscutterext"
--[[AUTO]]  ,"get_alarmkeyfobext"
--[[AUTO]]  ,"use_alarmkeyfobext"
--[[AUTO]]  ,"get_ringsinwaterext"
--[[AUTO]]  ,"get_hairpinext"
--[[AUTO]]  ,"use_hairpinext"
--[[AUTO]]  ,"opn_sweetsext"
--[[AUTO]]  ,"win_sweetsext"
--[[AUTO]]  ,"use_ringsext"
--[[AUTO]]  ,"win_ringsinwaterext"
--[[AUTO]]  ,"get_beermugext"
--[[AUTO]]  ,"use_beermugext"
--[[AUTO]]  ,"get_albumext"
--[[AUTO]]  ,"get_ballerinaext"
--[[AUTO]]  ,"use_albumext"
--[[AUTO]]  ,"dlg_pubext_innkeeperext2"
--[[AUTO]]  ,"get_crownext"
--[[AUTO]]  ,"use_crownext"
--[[AUTO]]  ,"get_fivepointedstarext"
--[[AUTO]]  ,"use_fivepointedstarext"
            ,"clk_leatherbagopnext3"
--[[AUTO]]  ,"get_wineglassext"
--[[AUTO]]  ,"use_wineglassext"
--[[AUTO]]  ,"get_buttonext"
--[[AUTO]]  ,"use_buttonext"
            ,"use_buttonext2"
            ,"clk_bombext4"
--[[AUTO]]  ,"win_bombext4"
--[[AUTO]]  ,"get_keyboxext"
--[[AUTO]]  ,"clk_anmbombext4"
--[[AUTO]]  ,"use_ballerinaext"
--[[AUTO]]  ,"use_keyboxext"
--[[AUTO]]  ,"get_amuletguitarext"
--[[AUTO]]  ,"use_amuletguitarext"
--[[AUTO]]  ,"get_gearext2"
--[[AUTO]]  ,"use_gearext1"
--[[AUTO]]  ,"use_gearext2"
--[[AUTO]]  ,"win_mechanismext"
--[[AUTO]]  ,"opn_staffonlyext"
--[[AUTO]]  ,"get_skittleext2"
--[[AUTO]]  ,"get_bottleext1"
--[[AUTO]]  ,"get_servicecardext"
--[[AUTO]]  ,"use_servicecardext"
--[[AUTO]]  ,"get_bottleext2"
--[[AUTO]]  ,"use_bottleext1"
--[[AUTO]]  ,"use_bottleext2"
--[[AUTO]]  ,"get_skittleext3"
--[[AUTO]]  ,"use_skittleext"
--[[AUTO]]  ,"win_bowlingext"
--[[AUTO]]  ,"get_badgelightningext"
--[[AUTO]]  ,"clk_anmbombext5"
            ,"clk_anmbombext6"
--[[AUTO]]  ,"use_badgelightningext"
--[[AUTO]]  ,"get_keylatticeext"
--[[AUTO]]  ,"use_keylatticeext"
--[[AUTO]]  ,"clk_gagext"
--[[AUTO]]  ,"dlg_staffonlyext_gloriaext"
--[[AUTO]]  ,"get_plugwireext"
--[[AUTO]]  ,"use_plugwireext"
            ,"clk_plugwireext"
--[[AUTO]]  ,"clk_phoneext911"
--[[AUTO]]  ,"clk_outroext"



  };

  game.relations = {};

  game.level_tasks = {
    "opn_inhouseext";
    "get_bombmapext";
    "clk_anmbombext1";
    "clk_anmbombext2";
    "clk_anmbombext3";
    "clk_anmbombext4";
    "clk_anmbombext5";
    "get_plugwireext";   

  
};

end;

function Test ()

  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;


--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------tutorial----------------------------------------------

function private.TutorInit()


end