-- name=rm_barnext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_barnext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_barnext()
  if not ( cmn.IsEventDone( "opn_barnext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_barnext" );
      cmn.CallEventHandler( "opn_barnext" )
      -- ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opnbarnext");
      SoundTheme( "aud_danger_moment2_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_barnext = function() end;
local opn_barnext_logic = function() end;
cmn.AddSubscriber( "opn_barnext", opn_barnext_logic )
cmn.AddSubscriber( "opn_barnext", opn_barnext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_innerporchext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_innerporchkeyext_zone_clk()  --rm_barnext.use_innerporchkeyext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_innerporchkeyext' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_handle_barnext" );
  ld.AnimPlay( "anm_innerporchext_anm", "idle_pen", func_end )
end;  


common_impl.hint[ "use_innerporchkeyext" ] = { type = "use", inv_obj = "inv_innerporchkeyext", use_place = "gfx_innerporchext_innerporchkeyext_zone", room = "rm_barnext", zz = "zz_innerporchext", zz_gate = "gzz_barnext_innerporchext" };

private.use_innerporchkeyext_logic = function()
  ObjSet( "gho_barnext_innerporchhoext", { visible = 1, input = 1, active = 1 } )

end;
private.use_innerporchkeyext_inv = function()
  common_impl.ProcessMultiUseAll("innerporchkeyext", "innerporchkeyext")
end;
private.use_innerporchkeyext_beg = function()
  ObjDelete( "gfx_innerporchext_innerporchkeyext_zone" );
end;
private.use_innerporchkeyext_end = function()
  if common_impl.ZzCompleteCheck("use_innerporchkeyext") then ObjSet( common_impl.hint["use_innerporchkeyext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_innerporchext_anm", {animfunc = "use_key", frame = 999 } );
  ObjSet( "spr_barnext_open_door", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_innerporchkeyext", private.use_innerporchkeyext_inv );
cmn.AddSubscriber( "use_innerporchkeyext", private.use_innerporchkeyext_beg, private.room_objname );
cmn.AddSubscriber( "use_innerporchkeyext", private.use_innerporchkeyext_end, private.room_objname );
cmn.AddSubscriber( "use_innerporchkeyext", private.use_innerporchkeyext_logic );
cmn.AddSubscriber( "use_innerporchkeyext_inv", private.use_innerporchkeyext_inv, private.room_objname );
cmn.AddSubscriber( "use_innerporchkeyext_beg", private.use_innerporchkeyext_beg, private.room_objname );
cmn.AddSubscriber( "use_innerporchkeyext_end", private.use_innerporchkeyext_end, private.room_objname );
cmn.AddSubscriber( "use_innerporchkeyext_end", private.use_innerporchkeyext_logic );
--------------------------------------------------------------------------------------------
function public.use_innerporchkeyext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_innerporchkeyext" );
    cmn.CallEventHandler( "use_innerporchkeyext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_innerporchkeyext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_innerporchkeyext_inv" );
  cmn.CallEventHandler( "use_innerporchkeyext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_innerporchext_anm", "use_key", func_end );
  SoundSfx( "aud_use_innerporchkeyext_barnext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_walldoorsext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_walldoorsext_stapleext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_stapleext' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_walldoorsext_anm_door1", "idle_door", func_end );
end; 
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_stapleext" ] = { type = "use", inv_obj = "inv_stapleext", use_place = "gfx_walldoorsext_stapleext_zone", room = "rm_barnext", zz = "zz_walldoorsext", zz_gate = "gzz_barnext_walldoorsext" };

private.use_stapleext_logic = function()
  ObjSet( "spr_walldoorsext_pliersext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_walldoorsext_metaltwigext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_stapleext_inv = function()
  common_impl.ProcessMultiUseAll("stapleext", "stapleext")
end;
private.use_stapleext_beg = function()
  ObjDelete( "gfx_walldoorsext_stapleext_zone" );
end;
private.use_stapleext_end = function()
  if common_impl.ZzCompleteCheck("use_stapleext") then ObjSet( common_impl.hint["use_stapleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_walldoorsext_anm_door1", {animfunc = "use_metaltwig", frame = 0 } );
  ObjSet( "spr_walldoorsext_sh_pliersext", {visible = 1} );
  ObjSet( "spr_barnext_openwall2", {visible = 1} );
  ObjSet( "spr_barnext_pliersext", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stapleext", private.use_stapleext_inv );
cmn.AddSubscriber( "use_stapleext", private.use_stapleext_beg, private.room_objname );
cmn.AddSubscriber( "use_stapleext", private.use_stapleext_end, private.room_objname );
cmn.AddSubscriber( "use_stapleext", private.use_stapleext_logic );
cmn.AddSubscriber( "use_stapleext_inv", private.use_stapleext_inv, private.room_objname );
cmn.AddSubscriber( "use_stapleext_beg", private.use_stapleext_beg, private.room_objname );
cmn.AddSubscriber( "use_stapleext_end", private.use_stapleext_end, private.room_objname );
cmn.AddSubscriber( "use_stapleext_end", private.use_stapleext_logic );
--------------------------------------------------------------------------------------------
function public.use_stapleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_stapleext" );
    cmn.CallEventHandler( "use_stapleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stapleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stapleext_inv" );
  cmn.CallEventHandler( "use_stapleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_walldoorsext_anm_door1", "use_clip", func_end );
  SoundSfx( "aud_use_stapleext_barnext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pliersext" ] = { type = "get", get_obj = "spr_walldoorsext_pliersext", room = "rm_barnext", zz = "zz_walldoorsext", zz_gate = "gzz_barnext_walldoorsext" };

private.get_pliersext_logic = function()
  
end;
private.get_pliersext_inv = function()
  interface.InventoryItemAdd("inv_pliersext","spr_walldoorsext_pliersext");
end;
private.get_pliersext_beg = function()
  ObjDelete("gfx_walldoorsext_pliersext");
  ObjDelete("spr_walldoorsext_sh_pliersext");
end;
private.get_pliersext_end = function()
  if common_impl.ZzCompleteCheck("get_pliersext") then ObjSet( common_impl.hint["get_pliersext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnext_pliersext");
end;

cmn.AddSubscriber( "get_pliersext", private.get_pliersext_inv );
cmn.AddSubscriber( "get_pliersext", private.get_pliersext_beg, private.room_objname );
cmn.AddSubscriber( "get_pliersext", private.get_pliersext_end, private.room_objname );
cmn.AddSubscriber( "get_pliersext", private.get_pliersext_logic );
--------------------------------------------------------------------
function public.get_pliersext()
  cmn.SetEventDone( "get_pliersext" );
  cmn.CallEventHandler( "get_pliersext" );
  if common_impl.ZzCompleteCheck("get_pliersext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_walldoorsext_cornext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_cornext' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_walldoorsext_anm_door2", "idle_door1", func_end );
end; 
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cornext" ] = { type = "use", inv_obj = "inv_cornext", use_place = "gfx_walldoorsext_cornext_zone", room = "rm_barnext", zz = "zz_walldoorsext", zz_gate = "gzz_barnext_walldoorsext" };

private.use_cornext_logic = function()
  ObjSet( "spr_walldoorsext_regulatorext", { visible = 1, input = 1, active = 1 } )
  
end;
private.use_cornext_inv = function()
  common_impl.ProcessMultiUseAll("cornext", "cornext")
end;
private.use_cornext_beg = function()
  ObjDelete( "gfx_walldoorsext_cornext_zone" );
end;
private.use_cornext_end = function()
  if common_impl.ZzCompleteCheck("use_cornext") then ObjSet( common_impl.hint["use_cornext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_walldoorsext_anm_door2", {animfunc = "click_car", frame = 0 } );
  ObjSet( "anm_walldoorsext_anm_web", {visible = 1} );
  ObjSet( "spr_walldoorsext_sh_regulatorext", {visible = 1} );
  ObjSet( "obj_walldoorsex_clk_car", {input = 1, visible = 1,activ = 1} );
  ObjSet( "obj_walldoorsex_clk_web", {input = 1, visible = 1,activ = 1} );
  ObjSet( "spr_barnext_openwall1", {visible = 1} );
  ObjSet( "spr_barnext_regulatorext", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cornext", private.use_cornext_inv );
cmn.AddSubscriber( "use_cornext", private.use_cornext_beg, private.room_objname );
cmn.AddSubscriber( "use_cornext", private.use_cornext_end, private.room_objname );
cmn.AddSubscriber( "use_cornext", private.use_cornext_logic );
cmn.AddSubscriber( "use_cornext_inv", private.use_cornext_inv, private.room_objname );
cmn.AddSubscriber( "use_cornext_beg", private.use_cornext_beg, private.room_objname );
cmn.AddSubscriber( "use_cornext_end", private.use_cornext_end, private.room_objname );
cmn.AddSubscriber( "use_cornext_end", private.use_cornext_logic );
--------------------------------------------------------------------------------------------
function public.use_cornext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cornext" );
    cmn.CallEventHandler( "use_cornext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cornext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cornext_inv" );
  cmn.CallEventHandler( "use_cornext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_walldoorsext_anm_door2", "use_corn", func_end );
  SoundSfx( "aud_use_cornext_barnext" )
  --func_end()

end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_walldoorsext_car()

  local func_end = function()
    ObjSet( "obj_walldoorsex_clk_car", {input = 1, visible = 1,activ = 1} );
    
  end;
  
  ObjSet( "obj_walldoorsex_clk_car", {input = 0, visible = 0,activ = 0} );
  SoundSfx( "aud_touch_wooden_car_pondext" );
  ld.AnimPlay( "anm_walldoorsext_anm_door2", "click_car", func_end );end; 

--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_walldoorsext_web()

  local func_end = function()
    ObjSet( "obj_walldoorsex_clk_web", {input = 1, visible = 1,activ = 1} );
    
  end;
  
  ObjSet( "obj_walldoorsex_clk_web", {input = 0, visible = 0,activ = 0} );
  SoundSfx( "aud_touch_weed" );
  ld.AnimPlay( "anm_walldoorsext_anm_web", "click_web", func_end );end; 

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_regulatorext" ] = { type = "get", get_obj = "spr_walldoorsext_regulatorext", room = "rm_barnext", zz = "zz_walldoorsext", zz_gate = "gzz_barnext_walldoorsext" };

private.get_regulatorext_logic = function()
  
end;
private.get_regulatorext_inv = function()
  interface.InventoryItemAdd("inv_regulatorext","spr_walldoorsext_regulatorext");
end;
private.get_regulatorext_beg = function()
  ObjDelete("gfx_walldoorsext_regulatorext");
  ObjDelete("spr_walldoorsext_sh_regulatorext");
end;
private.get_regulatorext_end = function()
  if common_impl.ZzCompleteCheck("get_regulatorext") then ObjSet( common_impl.hint["get_regulatorext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnext_regulatorext")
end;

cmn.AddSubscriber( "get_regulatorext", private.get_regulatorext_inv );
cmn.AddSubscriber( "get_regulatorext", private.get_regulatorext_beg, private.room_objname );
cmn.AddSubscriber( "get_regulatorext", private.get_regulatorext_end, private.room_objname );
cmn.AddSubscriber( "get_regulatorext", private.get_regulatorext_logic );
--------------------------------------------------------------------
function public.get_regulatorext()
  cmn.SetEventDone( "get_regulatorext" );
  cmn.CallEventHandler( "get_regulatorext" );
  if common_impl.ZzCompleteCheck("get_regulatorext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_walldoorsext_metaltwigext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_metaltwigext' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_plastic" );
  ld.AnimPlay( "anm_walldoorsext_anm_door1", "use_metaltwig1", func_end );
end; 
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------

common_impl.hint[ "use_metaltwigext" ] = { type = "use", inv_obj = "inv_metaltwigext", use_place = "gfx_walldoorsext_metaltwigext_zone", room = "rm_barnext", zz = "zz_walldoorsext", zz_gate = "gzz_barnext_walldoorsext" };

private.use_metaltwigext_logic = function()
  ObjSet( "spr_walldoorsext_amuleteagleext2", { visible = 1, input = 1, active = 1 } )

end;
private.use_metaltwigext_inv = function()
  common_impl.ProcessMultiUseAll("metaltwigext", "metaltwigext")
end;
private.use_metaltwigext_beg = function()
  ObjDelete( "gfx_walldoorsext_metaltwigext_zone" );
end;
private.use_metaltwigext_end = function()
  if common_impl.ZzCompleteCheck("use_metaltwigext") then ObjSet( common_impl.hint["use_metaltwigext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_walldoorsext_anm_door1", {animfunc = "end", frame = 0 } );
  ObjSet( "spr_walldoorsext_sh_amuleteagleext2", {visible = 1} );
  ObjSet( "spr_barnext_amuleteagleext2", {visible = 1} );
  ObjSet( "spr_barnext_tr_amuleteagleext2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_metaltwigext", private.use_metaltwigext_inv );
cmn.AddSubscriber( "use_metaltwigext", private.use_metaltwigext_beg, private.room_objname );
cmn.AddSubscriber( "use_metaltwigext", private.use_metaltwigext_end, private.room_objname );
cmn.AddSubscriber( "use_metaltwigext", private.use_metaltwigext_logic );
cmn.AddSubscriber( "use_metaltwigext_inv", private.use_metaltwigext_inv, private.room_objname );
cmn.AddSubscriber( "use_metaltwigext_beg", private.use_metaltwigext_beg, private.room_objname );
cmn.AddSubscriber( "use_metaltwigext_end", private.use_metaltwigext_end, private.room_objname );
cmn.AddSubscriber( "use_metaltwigext_end", private.use_metaltwigext_logic );
--------------------------------------------------------------------------------------------
function public.use_metaltwigext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_metaltwigext" );
    cmn.CallEventHandler( "use_metaltwigext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_metaltwigext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_metaltwigext_inv" );
  cmn.CallEventHandler( "use_metaltwigext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_walldoorsext_anm_door1", "use_metaltwig", func_end );
  SoundSfx( "aud_use_metaltwigext_barnext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuleteagleext2" ] = { type = "get", get_obj = "spr_walldoorsext_amuleteagleext2", room = "rm_barnext", zz = "zz_walldoorsext", zz_gate = "gzz_barnext_walldoorsext" };

private.get_amuleteagleext2_logic = function()
  
end;
private.get_amuleteagleext2_inv = function()
  interface.InventoryItemAdd("inv_amuleteagleext2","spr_walldoorsext_amuleteagleext2");
end;
private.get_amuleteagleext2_beg = function()
  ObjDelete("gfx_walldoorsext_amuleteagleext2");
  ObjDelete("spr_walldoorsext_sh_amuleteagleext2");
end;
private.get_amuleteagleext2_end = function()
  if common_impl.ZzCompleteCheck("get_amuleteagleext2") then ObjSet( common_impl.hint["get_amuleteagleext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnext_amuleteagleext2")
end;

cmn.AddSubscriber( "get_amuleteagleext2", private.get_amuleteagleext2_inv );
cmn.AddSubscriber( "get_amuleteagleext2", private.get_amuleteagleext2_beg, private.room_objname );
cmn.AddSubscriber( "get_amuleteagleext2", private.get_amuleteagleext2_end, private.room_objname );
cmn.AddSubscriber( "get_amuleteagleext2", private.get_amuleteagleext2_logic );
--------------------------------------------------------------------
function public.get_amuleteagleext2()
  cmn.SetEventDone( "get_amuleteagleext2" );
  cmn.CallEventHandler( "get_amuleteagleext2" );
  if common_impl.ZzCompleteCheck("get_amuleteagleext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_floorboardext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------

function public.clk_floorboardext_crowbarext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_crowbarext' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_door" );
  ld.AnimPlay( "anm_floorboardext_anm", "idle_floorboard", func_end );
end; 
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_crowbarext" ] = { type = "use", inv_obj = "inv_crowbarext", use_place = "gfx_floorboardext_crowbarext_zone", room = "rm_barnext", zz = "zz_floorboardext", zz_gate = "gzz_barnext_floorboardext" };

private.use_crowbarext_logic = function()
  ObjSet( "spr_floorboardext_velvetboxext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_floorboardext_scoopext", { visible = 1, input = 1, active = 1 } )
  
end;
private.use_crowbarext_inv = function()
  common_impl.ProcessMultiUseAll("crowbarext", "crowbarext")
end;
private.use_crowbarext_beg = function()
  ObjDelete( "gfx_floorboardext_crowbarext_zone" );
end;
private.use_crowbarext_end = function()
  if common_impl.ZzCompleteCheck("use_crowbarext") then ObjSet( common_impl.hint["use_crowbarext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_floorboardext_anm", {animfunc = "use_ear", frame = 0 } );
  ObjSet( "spr_floorboardext_sh_velvetboxext", {visible = 1} );
  ObjSet( "spr_floorboardext_sh_scoopext", {visible = 1} );
  ObjDelete("spr_barnext_wood1");
  ObjSet( "spr_barnext_wood2", {visible = 1} );
  ObjSet( "spr_barnext_velvetboxext", {visible = 1} );
  ObjSet( "spr_barnext_scoopext", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_crowbarext", private.use_crowbarext_inv );
cmn.AddSubscriber( "use_crowbarext", private.use_crowbarext_beg, private.room_objname );
cmn.AddSubscriber( "use_crowbarext", private.use_crowbarext_end, private.room_objname );
cmn.AddSubscriber( "use_crowbarext", private.use_crowbarext_logic );
cmn.AddSubscriber( "use_crowbarext_inv", private.use_crowbarext_inv, private.room_objname );
cmn.AddSubscriber( "use_crowbarext_beg", private.use_crowbarext_beg, private.room_objname );
cmn.AddSubscriber( "use_crowbarext_end", private.use_crowbarext_end, private.room_objname );
cmn.AddSubscriber( "use_crowbarext_end", private.use_crowbarext_logic );
--------------------------------------------------------------------------------------------
function public.use_crowbarext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_crowbarext" );
    cmn.CallEventHandler( "use_crowbarext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_crowbarext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_crowbarext_inv" );
  cmn.CallEventHandler( "use_crowbarext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_floorboardext_anm", "use_scrap", func_end );
  SoundSfx( "aud_use_crowbarext_barnext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_velvetboxext" ] = { type = "get", get_obj = "spr_floorboardext_velvetboxext", room = "rm_barnext", zz = "zz_floorboardext", zz_gate = "gzz_barnext_floorboardext" };

private.get_velvetboxext_logic = function()
  if ld.CheckRequirements( {"get_scoopext"} ) then
    ObjSet( "gfx_floorboardext_earofwheatext_zone", { visible = 1, input = 1, active = 1 } )  
  end  
end;
private.get_velvetboxext_inv = function()
  interface.InventoryItemAdd("inv_velvetboxext","spr_floorboardext_velvetboxext");
  ObjSet( "inv_velvetboxext", { drag = 0 } );
end;
private.get_velvetboxext_beg = function()
  ObjDelete("gfx_floorboardext_velvetboxext");
  ObjDelete("spr_floorboardext_sh_velvetboxext");
end;
private.get_velvetboxext_end = function()
  if common_impl.ZzCompleteCheck("get_velvetboxext") then ObjSet( common_impl.hint["get_velvetboxext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnext_velvetboxext");
end;

cmn.AddSubscriber( "get_velvetboxext", private.get_velvetboxext_inv );
cmn.AddSubscriber( "get_velvetboxext", private.get_velvetboxext_beg, private.room_objname );
cmn.AddSubscriber( "get_velvetboxext", private.get_velvetboxext_end, private.room_objname );
cmn.AddSubscriber( "get_velvetboxext", private.get_velvetboxext_logic );
--------------------------------------------------------------------
function public.get_velvetboxext()
  cmn.SetEventDone( "get_velvetboxext" );
  cmn.CallEventHandler( "get_velvetboxext" );
  if common_impl.ZzCompleteCheck("get_velvetboxext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scoopext" ] = { type = "get", get_obj = "spr_floorboardext_scoopext", room = "rm_barnext", zz = "zz_floorboardext", zz_gate = "gzz_barnext_floorboardext" };

private.get_scoopext_logic = function()
  if ld.CheckRequirements( {"get_velvetboxext"} ) then
    ObjSet( "gfx_floorboardext_earofwheatext_zone", { visible = 1, input = 1, active = 1 } )  
  end  
end;
private.get_scoopext_inv = function()
  interface.InventoryItemAdd("inv_scoopext","spr_floorboardext_scoopext");
end;
private.get_scoopext_beg = function()
  ObjDelete("gfx_floorboardext_scoopext");
  ObjDelete("spr_floorboardext_sh_scoopext");
end;
private.get_scoopext_end = function()
  if common_impl.ZzCompleteCheck("get_scoopext") then ObjSet( common_impl.hint["get_scoopext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnext_scoopext")
end;

cmn.AddSubscriber( "get_scoopext", private.get_scoopext_inv );
cmn.AddSubscriber( "get_scoopext", private.get_scoopext_beg, private.room_objname );
cmn.AddSubscriber( "get_scoopext", private.get_scoopext_end, private.room_objname );
cmn.AddSubscriber( "get_scoopext", private.get_scoopext_logic );
--------------------------------------------------------------------
function public.get_scoopext()
  cmn.SetEventDone( "get_scoopext" );
  cmn.CallEventHandler( "get_scoopext" );
  if common_impl.ZzCompleteCheck("get_scoopext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_floorboardext_earofwheatext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_earofwheatext' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_floorboardext_anm", "idle_cache", func_end );
end; 
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_earofwheatext" ] = { type = "use", inv_obj = "inv_earofwheatext", use_place = "gfx_floorboardext_earofwheatext_zone", room = "rm_barnext", zz = "zz_floorboardext", zz_gate = "gzz_barnext_floorboardext" };

private.use_earofwheatext_logic = function()
  ObjSet( "spr_floorboardext_threepointedstarext", { visible = 1, input = 1, active = 1 } )

end;
private.use_earofwheatext_inv = function()
  common_impl.ProcessMultiUseAll("earofwheatext", "earofwheatext")
end;
private.use_earofwheatext_beg = function()
  ObjDelete( "gfx_floorboardext_earofwheatext_zone" );
end;
private.use_earofwheatext_end = function()
  if common_impl.ZzCompleteCheck("use_earofwheatext") then ObjSet( common_impl.hint["use_earofwheatext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_floorboardext_anm", {animfunc = "use_cache", frame = 0 } );
  ObjSet( "spr_floorboardext_sh_threepointedstarext", {visible = 1} );
  -- ObjDelete("spr_barnext_wood2");
  ObjSet( "spr_barnext_wood3", {visible = 1} );
  ObjSet( "spr_barnext_threepointedstarext", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_earofwheatext", private.use_earofwheatext_inv );
cmn.AddSubscriber( "use_earofwheatext", private.use_earofwheatext_beg, private.room_objname );
cmn.AddSubscriber( "use_earofwheatext", private.use_earofwheatext_end, private.room_objname );
cmn.AddSubscriber( "use_earofwheatext", private.use_earofwheatext_logic );
cmn.AddSubscriber( "use_earofwheatext_inv", private.use_earofwheatext_inv, private.room_objname );
cmn.AddSubscriber( "use_earofwheatext_beg", private.use_earofwheatext_beg, private.room_objname );
cmn.AddSubscriber( "use_earofwheatext_end", private.use_earofwheatext_end, private.room_objname );
cmn.AddSubscriber( "use_earofwheatext_end", private.use_earofwheatext_logic );
--------------------------------------------------------------------------------------------
function public.use_earofwheatext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_earofwheatext" );
    cmn.CallEventHandler( "use_earofwheatext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_earofwheatext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_earofwheatext_inv" );
  cmn.CallEventHandler( "use_earofwheatext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_floorboardext_anm", "use_ear", func_end );
  SoundSfx( "aud_use_earofwheatext_barnext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_threepointedstarext" ] = { type = "get", get_obj = "spr_floorboardext_threepointedstarext", room = "rm_barnext", zz = "zz_floorboardext", zz_gate = "gzz_barnext_floorboardext" };

private.get_threepointedstarext_logic = function()
  
end;
private.get_threepointedstarext_inv = function()
  interface.InventoryItemAdd("inv_threepointedstarext","spr_floorboardext_threepointedstarext");
end;
private.get_threepointedstarext_beg = function()
  ObjDelete("gfx_floorboardext_threepointedstarext");
  ObjDelete("spr_floorboardext_sh_threepointedstarext");
end;
private.get_threepointedstarext_end = function()
  if common_impl.ZzCompleteCheck("get_threepointedstarext") then ObjSet( common_impl.hint["get_threepointedstarext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnext_threepointedstarext")
end;

cmn.AddSubscriber( "get_threepointedstarext", private.get_threepointedstarext_inv );
cmn.AddSubscriber( "get_threepointedstarext", private.get_threepointedstarext_beg, private.room_objname );
cmn.AddSubscriber( "get_threepointedstarext", private.get_threepointedstarext_end, private.room_objname );
cmn.AddSubscriber( "get_threepointedstarext", private.get_threepointedstarext_logic );
--------------------------------------------------------------------
function public.get_threepointedstarext()
  cmn.SetEventDone( "get_threepointedstarext" );
  cmn.CallEventHandler( "get_threepointedstarext" );
  if common_impl.ZzCompleteCheck("get_threepointedstarext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_sackext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pocketknifeext_sackext" ] = { type = "use", inv_obj = "inv_pocketknifeext", use_place = "gfx_sackext_pocketknifeext_sackext_zone", room = "rm_barnext", zz = "zz_sackext", zz_gate = "gzz_barnext_sackext" };

private.use_pocketknifeext_sackext_logic = function()
  ObjSet( "spr_sackext_cigarcaseext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_sackext_amuletcockerelext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_sackext_stampext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_pocketknifeext_sackext_inv = function()
  common_impl.ProcessMultiUseAll("pocketknifeext", "pocketknifeext_sackext")
end;
private.use_pocketknifeext_sackext_beg = function()
  ObjDelete( "gfx_sackext_pocketknifeext_sackext_zone" );
end;
private.use_pocketknifeext_sackext_end = function()
  if common_impl.ZzCompleteCheck("use_pocketknifeext_sackext") then ObjSet( common_impl.hint["use_pocketknifeext_sackext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_sackext_anm_knife", {animfunc = "use_stamp", frame = 0, pos_z = 5 } );
  ObjSet( "spr_sackext_sh_amuletcockerel", {visible = 1} );
  ObjSet( "spr_sackext_sh_cigarcase", {visible = 1} );
  ObjSet( "spr_barnext_open", {visible = 1} );
  ObjSet( "spr_barnext_box", {visible = 1} );
  ObjSet( "spr_barnext_cigarcaseext", {visible = 1} );
  ObjSet( "spr_barnext_amuletcockerelext", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pocketknifeext_sackext", private.use_pocketknifeext_sackext_inv );
cmn.AddSubscriber( "use_pocketknifeext_sackext", private.use_pocketknifeext_sackext_beg );
cmn.AddSubscriber( "use_pocketknifeext_sackext", private.use_pocketknifeext_sackext_end );
cmn.AddSubscriber( "use_pocketknifeext_sackext", private.use_pocketknifeext_sackext_logic );
cmn.AddSubscriber( "use_pocketknifeext_sackext_inv", private.use_pocketknifeext_sackext_inv );
cmn.AddSubscriber( "use_pocketknifeext_sackext_beg", private.use_pocketknifeext_sackext_beg );
cmn.AddSubscriber( "use_pocketknifeext_sackext_end", private.use_pocketknifeext_sackext_end );
cmn.AddSubscriber( "use_pocketknifeext_sackext_end", private.use_pocketknifeext_sackext_logic );
--------------------------------------------------------------------------------------------
function public.use_pocketknifeext_sackext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pocketknifeext_sackext" );
    cmn.CallEventHandler( "use_pocketknifeext_sackext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pocketknifeext_sackext_inv" );
  cmn.CallEventHandler( "use_pocketknifeext_sackext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_pocketknifeext_sackext" )
  ObjSet( "anm_sackext_anm_knife", {pos_z = 7} );
  ld.AnimPlay( "anm_sackext_anm_knife", "use_pocketknife", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cigarcaseext" ] = { type = "get", get_obj = "spr_sackext_cigarcaseext", room = "rm_barnext", zz = "zz_sackext", zz_gate = "gzz_barnext_sackext" };

private.get_cigarcaseext_logic = function()
  
end;
private.get_cigarcaseext_inv = function()
  interface.InventoryItemAdd("inv_cigarcaseext","spr_sackext_cigarcaseext");
  ObjSet( "inv_cigarcaseext", { drag = 0 } );
end;
private.get_cigarcaseext_beg = function()
  ObjDelete("gfx_sackext_cigarcaseext");
  ObjDelete("spr_sackext_sh_cigarcase");
end;
private.get_cigarcaseext_end = function()
  if common_impl.ZzCompleteCheck("get_cigarcaseext") then ObjSet( common_impl.hint["get_cigarcaseext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnext_cigarcaseext");
end;

cmn.AddSubscriber( "get_cigarcaseext", private.get_cigarcaseext_inv );
cmn.AddSubscriber( "get_cigarcaseext", private.get_cigarcaseext_beg );
cmn.AddSubscriber( "get_cigarcaseext", private.get_cigarcaseext_end );
cmn.AddSubscriber( "get_cigarcaseext", private.get_cigarcaseext_logic );
--------------------------------------------------------------------
function public.get_cigarcaseext()
  cmn.SetEventDone( "get_cigarcaseext" );
  cmn.CallEventHandler( "get_cigarcaseext" );
  if common_impl.ZzCompleteCheck("get_cigarcaseext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletcockerelext" ] = { type = "get", get_obj = "spr_sackext_amuletcockerelext", room = "rm_barnext", zz = "zz_sackext", zz_gate = "gzz_barnext_sackext" };

private.get_amuletcockerelext_logic = function()
  
end;
private.get_amuletcockerelext_inv = function()
  interface.InventoryItemAdd("inv_amuletcockerelext","spr_sackext_amuletcockerelext");
end;
private.get_amuletcockerelext_beg = function()
  ObjDelete("gfx_sackext_amuletcockerelext");
   ObjDelete("spr_sackext_sh_amuletcockerel");
end;
private.get_amuletcockerelext_end = function()
  if common_impl.ZzCompleteCheck("get_amuletcockerelext") then ObjSet( common_impl.hint["get_amuletcockerelext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnext_amuletcockerelext")
end;

cmn.AddSubscriber( "get_amuletcockerelext", private.get_amuletcockerelext_inv );
cmn.AddSubscriber( "get_amuletcockerelext", private.get_amuletcockerelext_beg );
cmn.AddSubscriber( "get_amuletcockerelext", private.get_amuletcockerelext_end );
cmn.AddSubscriber( "get_amuletcockerelext", private.get_amuletcockerelext_logic );
--------------------------------------------------------------------
function public.get_amuletcockerelext()
  cmn.SetEventDone( "get_amuletcockerelext" );
  cmn.CallEventHandler( "get_amuletcockerelext" );
  if common_impl.ZzCompleteCheck("get_amuletcockerelext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------------------------------

common_impl.hint[ "use_scoopext" ] = { type = "use", inv_obj = "inv_scoopext", use_place = "gfx_sackext_scoopext_zone", room = "rm_barnext", zz = "zz_sackext", zz_gate = "gzz_barnext_sackext" };

private.use_scoopext_logic = function()
  ObjSet( "spr_sackext_tridentext", { visible = 1, input = 1, active = 1 } )

end;
private.use_scoopext_inv = function()
  common_impl.ProcessMultiUseAll("scoopext", "scoopext")
end;
private.use_scoopext_beg = function()
  ObjDelete( "gfx_sackext_scoopext_zone" );
end;
private.use_scoopext_end = function()
  if common_impl.ZzCompleteCheck("use_scoopext") then ObjSet( common_impl.hint["use_scoopext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_sackext_anm_scoop");
  ObjSet( "spr_sackext_sh_trident", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scoopext", private.use_scoopext_inv );
cmn.AddSubscriber( "use_scoopext", private.use_scoopext_beg, private.room_objname );
cmn.AddSubscriber( "use_scoopext", private.use_scoopext_end, private.room_objname );
cmn.AddSubscriber( "use_scoopext", private.use_scoopext_logic );
cmn.AddSubscriber( "use_scoopext_inv", private.use_scoopext_inv, private.room_objname );
cmn.AddSubscriber( "use_scoopext_beg", private.use_scoopext_beg, private.room_objname );
cmn.AddSubscriber( "use_scoopext_end", private.use_scoopext_end, private.room_objname );
cmn.AddSubscriber( "use_scoopext_end", private.use_scoopext_logic );
--------------------------------------------------------------------------------------------
function public.use_scoopext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scoopext" );
    cmn.CallEventHandler( "use_scoopext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_scoopext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scoopext_inv" );
  cmn.CallEventHandler( "use_scoopext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sackext_anm_scoop", "use_scoop", func_end );
  SoundSfx( "aud_use_scoopext_barnext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tridentext" ] = { type = "get", get_obj = "spr_sackext_tridentext", room = "rm_barnext", zz = "zz_sackext", zz_gate = "gzz_barnext_sackext" };

private.get_tridentext_logic = function()
  
end;
private.get_tridentext_inv = function()
  interface.InventoryItemAdd("inv_tridentext","spr_sackext_tridentext");
end;
private.get_tridentext_beg = function()
  ObjDelete("gfx_sackext_tridentext");
  ObjDelete("spr_sackext_sh_trident");
end;
private.get_tridentext_end = function()
  if common_impl.ZzCompleteCheck("get_tridentext") then ObjSet( common_impl.hint["get_tridentext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnext_tridentext")
end;

cmn.AddSubscriber( "get_tridentext", private.get_tridentext_inv );
cmn.AddSubscriber( "get_tridentext", private.get_tridentext_beg, private.room_objname );
cmn.AddSubscriber( "get_tridentext", private.get_tridentext_end, private.room_objname );
cmn.AddSubscriber( "get_tridentext", private.get_tridentext_logic );
--------------------------------------------------------------------
function public.get_tridentext()
  cmn.SetEventDone( "get_tridentext" );
  cmn.CallEventHandler( "get_tridentext" );
  if common_impl.ZzCompleteCheck("get_tridentext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_sackext_stampext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_stampext' );
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_plastic" );
  ld.AnimPlay( "anm_sackext_anm_knife", "idle_casket", func_end );
end; 
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_stampext" ] = { type = "use", inv_obj = "inv_stampext", use_place = "gfx_sackext_stampext_zone", room = "rm_barnext", zz = "zz_sackext", zz_gate = "gzz_barnext_sackext" };

private.use_stampext_logic = function()
  ObjSet( "spr_sackext_matchesext", { visible = 1, input = 1, active = 1 } )

end;
private.use_stampext_inv = function()
  common_impl.ProcessMultiUseAll("stampext", "stampext")
end;
private.use_stampext_beg = function()
  ObjDelete( "gfx_sackext_stampext_zone" );
end;
private.use_stampext_end = function()
  if common_impl.ZzCompleteCheck("use_stampext") then ObjSet( common_impl.hint["use_stampext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_sackext_anm_knife", {animfunc = "end_casket", frame = 0 } );
  ObjSet( "spr_sackext_sh_matches", {visible = 1} );
  ObjSet( "spr_barnext_open_box", {visible = 1} );
  ObjSet( "spr_barnext_matchesext", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stampext", private.use_stampext_inv );
cmn.AddSubscriber( "use_stampext", private.use_stampext_beg, private.room_objname );
cmn.AddSubscriber( "use_stampext", private.use_stampext_end, private.room_objname );
cmn.AddSubscriber( "use_stampext", private.use_stampext_logic );
cmn.AddSubscriber( "use_stampext_inv", private.use_stampext_inv, private.room_objname );
cmn.AddSubscriber( "use_stampext_beg", private.use_stampext_beg, private.room_objname );
cmn.AddSubscriber( "use_stampext_end", private.use_stampext_end, private.room_objname );
cmn.AddSubscriber( "use_stampext_end", private.use_stampext_logic );
--------------------------------------------------------------------------------------------
function public.use_stampext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_stampext" );
    cmn.CallEventHandler( "use_stampext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stampext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stampext_inv" );
  cmn.CallEventHandler( "use_stampext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sackext_anm_knife", "use_stamp", func_end );
  SoundSfx( "aud_use_stampext_barnext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_matchesext" ] = { type = "get", get_obj = "spr_sackext_matchesext", room = "rm_barnext", zz = "zz_sackext", zz_gate = "gzz_barnext_sackext" };

private.get_matchesext_logic = function()
  
end;
private.get_matchesext_inv = function()
  interface.InventoryItemAdd("inv_matchesext","spr_sackext_matchesext");
end;
private.get_matchesext_beg = function()
  ObjDelete("gfx_sackext_matchesext");
  ObjDelete("spr_sackext_sh_matches");
end;
private.get_matchesext_end = function()
  if common_impl.ZzCompleteCheck("get_matchesext") then ObjSet( common_impl.hint["get_matchesext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnext_matchesext");
end;

cmn.AddSubscriber( "get_matchesext", private.get_matchesext_inv );
cmn.AddSubscriber( "get_matchesext", private.get_matchesext_beg, private.room_objname );
cmn.AddSubscriber( "get_matchesext", private.get_matchesext_end, private.room_objname );
cmn.AddSubscriber( "get_matchesext", private.get_matchesext_logic );
--------------------------------------------------------------------
function public.get_matchesext()
  cmn.SetEventDone( "get_matchesext" );
  cmn.CallEventHandler( "get_matchesext" );
  if common_impl.ZzCompleteCheck("get_matchesext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_innerporchhoext_for_barnext = function()
    if ld.CheckRequirements( {"win_innerporchhoext"} ) then
      ObjSet( "gho_barnext_innerporchhoext", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_innerporchhoext", win_innerporchhoext_for_barnext, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_barnext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_barnext_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_sackext" );
  function zz_sackext.Open()
  end;
  function zz_sackext.PreOpen()
  end;
  function zz_sackext.PreClose()
  end;
  function zz_sackext.Close()
  end;

  subroom.Define( "zz_floorboardext" );
  function zz_floorboardext.Open()
  end;
  function zz_floorboardext.PreOpen()
  end;
  function zz_floorboardext.PreClose()
  end;
  function zz_floorboardext.Close()
  end;

  subroom.Define( "zz_walldoorsext" );
  function zz_walldoorsext.Open()
  end;
  function zz_walldoorsext.PreOpen()
  end;
  function zz_walldoorsext.PreClose()
  end;
  function zz_walldoorsext.Close()
  end;

  subroom.Define( "zz_innerporchext" );
  function zz_innerporchext.Open()
  end;
  function zz_innerporchext.PreOpen()
  end;
  function zz_innerporchext.PreClose()
  end;
  function zz_innerporchext.Close()
  end;
  
end;
--*********************************************************************************************************************
function public.barnext_dog_zone_clk()
  local func_end = function()
      ObjSet( "obj_barnext_dog_clk_zone", {input = 1} );
  end;
  
  SoundSfx( "aud_touch_clothes" );  
  ObjSet( "obj_barnext_dog_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_barnext_anm_back_dog", "dog", func_end )
end;
--------------------------------
function public.barnext_pelvis_zone_clk()
  local func_end = function()
      ObjSet( "obj_barnext_pelvis_clk_zone", {input = 1} );
  end;
  
  SoundSfx( "aud_touch_big_plastic" );
  ObjSet( "obj_barnext_pelvis_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_barnext_anm_back_pelvis", "pelvis", func_end )
end;
-----------------------------------------------
function public.barnext_wateringcan_zone_clk()
  local func_end = function()
      ObjSet( "obj_barnext_wateringcan_clk_zone", {input = 1} );
  end;
  
  SoundSfx( "aud_touch_small_plastic" );  
  ObjSet( "obj_barnext_wateringcan_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_barnext_anm_back_wateringcan", "wateringcan", func_end )
end;

-----------------------------------------------