-- name=rm_farmext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_farmext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_farmext()
  if not ( cmn.IsEventDone( "opn_farmext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_farmext" );
      cmn.CallEventHandler( "opn_farmext" )
      -- ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opnfarmext");
      SoundTheme( "aud_adventure1_mus" )
  end;
  func_end()
  end;

  if cmn.IsEventDone("win_gatespondext") and not cmn.IsEventDone("win_gatespondextinfarmext") then
    public.win_gatespondextinfarmext();
  end;  
end;
--------------------------------------------------------------------
local opn_farmext = function() end;
local opn_farmext_logic = function() end;
cmn.AddSubscriber( "opn_farmext", opn_farmext_logic )
cmn.AddSubscriber( "opn_farmext", opn_farmext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_wellext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_pouchext" ] = { type = "get", get_obj = "spr_wellext_pouchext", room = "rm_farmext", zz = "zz_wellext", zz_gate = "gzz_farmext_wellext" };

private.get_pouchext_logic = function()
  
end;
private.get_pouchext_inv = function()
  interface.InventoryItemAdd("inv_pouchext","spr_wellext_pouchext");
  ObjSet( "inv_pouchext", { drag = 0 } );
end;
private.get_pouchext_beg = function()
  ObjDelete("gfx_wellext_pouchext")
end;
private.get_pouchext_end = function()
  if common_impl.ZzCompleteCheck("get_pouchext") then ObjSet( common_impl.hint["get_pouchext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_farmext_pouchext");
  ObjDelete("spr_wellext_sh_pouchext");
end;

cmn.AddSubscriber( "get_pouchext", private.get_pouchext_inv );
cmn.AddSubscriber( "get_pouchext", private.get_pouchext_beg, private.room_objname );
cmn.AddSubscriber( "get_pouchext", private.get_pouchext_end, private.room_objname );
cmn.AddSubscriber( "get_pouchext", private.get_pouchext_logic );
--------------------------------------------------------------------
function public.get_pouchext()
  cmn.SetEventDone( "get_pouchext" );
  cmn.CallEventHandler( "get_pouchext" );
  if common_impl.ZzCompleteCheck("get_pouchext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_magnetext_zone_clk()  --rm_farmext.use_magnetext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_magnetext' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_well_farmext" );
  ld.AnimPlay( "anm_wellext_anm_well_lever", "idle_leverext", func_end )
end;  


common_impl.hint[ "use_magnetext" ] = { type = "use", inv_obj = "inv_magnetext", use_place = "gfx_wellext_magnetext_zone", room = "rm_farmext", zz = "zz_wellext", zz_gate = "gzz_farmext_wellext" };

private.use_magnetext_logic = function()
  ObjSet( "spr_wellext_leverext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_wellext_leverext", {active=1, visible=1} ); 
end;
private.use_magnetext_inv = function()
  common_impl.ProcessMultiUseAll("magnetext", "magnetext")
end;
private.use_magnetext_beg = function()
  ObjDelete( "gfx_wellext_magnetext_zone" );
end;
private.use_magnetext_end = function()
  if common_impl.ZzCompleteCheck("use_magnetext") then ObjSet( common_impl.hint["use_magnetext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_wellext_anm_well_lever", {animfunc = "end_leverext", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_magnetext", private.use_magnetext_inv );
cmn.AddSubscriber( "use_magnetext", private.use_magnetext_beg, private.room_objname );
cmn.AddSubscriber( "use_magnetext", private.use_magnetext_end, private.room_objname );
cmn.AddSubscriber( "use_magnetext", private.use_magnetext_logic );
cmn.AddSubscriber( "use_magnetext_inv", private.use_magnetext_inv, private.room_objname );
cmn.AddSubscriber( "use_magnetext_beg", private.use_magnetext_beg, private.room_objname );
cmn.AddSubscriber( "use_magnetext_end", private.use_magnetext_end, private.room_objname );
cmn.AddSubscriber( "use_magnetext_end", private.use_magnetext_logic );
--------------------------------------------------------------------------------------------
function public.use_magnetext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    -- cmn.SetEventDone( "use_magnetext" );
    cmn.CallEventHandler( "use_magnetext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_magnetext") then ld.CloseSubRoom() end;
    public.get_leverext();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_magnetext_inv" );
  cmn.CallEventHandler( "use_magnetext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wellext_anm_well_lever", "use_magnet", func_end );
  SoundSfx( "aud_use_magnetext_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_leverext" ] = { type = "get", get_obj = "spr_wellext_leverext", room = "rm_farmext", zz = "zz_wellext", zz_gate = "gzz_farmext_wellext" };

private.get_leverext_logic = function()
  
end;
private.get_leverext_inv = function()
  interface.InventoryItemAdd("inv_leverext","spr_wellext_leverext");
end;
private.get_leverext_beg = function()
  ObjDelete("gfx_wellext_leverext")
end;
private.get_leverext_end = function()
  if common_impl.ZzCompleteCheck("get_leverext") then ObjSet( common_impl.hint["get_leverext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_wellext_anm_well_lever");
end;

cmn.AddSubscriber( "get_leverext", private.get_leverext_inv );
cmn.AddSubscriber( "get_leverext", private.get_leverext_beg, private.room_objname );
cmn.AddSubscriber( "get_leverext", private.get_leverext_end, private.room_objname );
cmn.AddSubscriber( "get_leverext", private.get_leverext_logic );
--------------------------------------------------------------------
function public.get_leverext()
  ObjSet( "spr_wellext_leverext", {visible = 1} );
  cmn.SetEventDone( "use_magnetext" );
  cmn.SetEventDone( "get_leverext" );
  cmn.CallEventHandler( "get_leverext" );
  if common_impl.ZzCompleteCheck("get_leverext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_hookext_zone_clk() --rm_farmext.use_hookext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_hookext' );
  end;  
  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_well_farmext" );
  ld.AnimPlay( "anm_wellext_anm_well_rope", "idle_kioskplateext", func_end )
end;  


common_impl.hint[ "use_hookext" ] = { type = "use", inv_obj = "inv_hookext", use_place = "gfx_wellext_hookext_zone", room = "rm_farmext", zz = "zz_wellext", zz_gate = "gzz_farmext_wellext" };

private.use_hookext_logic = function()
  --  ObjSet( "gfx_wellext_clk_wellhookext_zone", { visible = 1, input = 1, active = 1 } )
   ObjSet( "spr_wellext_kioskplateext", { visible = 1, input = 1, active = 1 } )
end;
private.use_hookext_inv = function()
  common_impl.ProcessMultiUseAll("hookext", "hookext")
end;
private.use_hookext_beg = function()
  ObjDelete( "gfx_wellext_hookext_zone" );
end;
private.use_hookext_end = function()
  if common_impl.ZzCompleteCheck("use_hookext") then ObjSet( common_impl.hint["use_hookext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_wellext_anm_well_rope");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hookext", private.use_hookext_inv );
cmn.AddSubscriber( "use_hookext", private.use_hookext_beg, private.room_objname );
cmn.AddSubscriber( "use_hookext", private.use_hookext_end, private.room_objname );
cmn.AddSubscriber( "use_hookext", private.use_hookext_logic );
cmn.AddSubscriber( "use_hookext_inv", private.use_hookext_inv, private.room_objname );
cmn.AddSubscriber( "use_hookext_beg", private.use_hookext_beg, private.room_objname );
cmn.AddSubscriber( "use_hookext_end", private.use_hookext_end, private.room_objname );
cmn.AddSubscriber( "use_hookext_end", private.use_hookext_logic );
--------------------------------------------------------------------------------------------
function public.use_hookext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    -- cmn.SetEventDone( "use_hookext" );
    cmn.CallEventHandler( "use_hookext_end" );
    public.get_kioskplateext();
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hookext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hookext_inv" );
  cmn.CallEventHandler( "use_hookext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wellext_anm_well_rope", "use_rope", func_end );
  SoundSfx( "aud_use_hookext_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_wellhookext" ] = { type = "click", use_place = "gfx_wellext_clk_wellhookext_zone", room = "rm_farmext", zz = "zz_wellext", zz_gate = "gzz_farmext_wellext" };
--
--private.clk_wellhookext_logic = function()
--  ObjSet( "spr_wellext_kioskplateext", { visible = 1, input = 1, active = 1 } )
--
--end;
--private.clk_wellhookext_beg = function()
--  ObjDelete( "gfx_wellext_clk_wellhookext_zone" );
--end;
--private.clk_wellhookext_end = function()
--  if common_impl.ZzCompleteCheck("clk_wellhookext") then ObjSet( common_impl.hint["clk_wellhookext"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_wellhookext", private.clk_wellhookext_beg, private.room_objname );
--cmn.AddSubscriber( "clk_wellhookext", private.clk_wellhookext_end, private.room_objname );
--cmn.AddSubscriber( "clk_wellhookext", private.clk_wellhookext_logic );
--cmn.AddSubscriber( "clk_wellhookext_beg", private.clk_wellhookext_beg, private.room_objname );
--cmn.AddSubscriber( "clk_wellhookext_end", private.clk_wellhookext_end, private.room_objname );
--cmn.AddSubscriber( "clk_wellhookext_end", private.clk_wellhookext_logic );
----------------------------------------------------------------------------------------------
--function public.clk_wellhookext()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_wellhookext" );
--    cmn.CallEventHandler( "clk_wellhookext_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("clk_wellhookext") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "clk_wellhookext_beg" );
--  common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  SoundSfx( "aud_clk_wellhookext" )
--  func_end()
--
--end;
----------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_kioskplateext" ] = { type = "get", get_obj = "spr_wellext_kioskplateext", room = "rm_farmext", zz = "zz_wellext", zz_gate = "gzz_farmext_wellext" };

private.get_kioskplateext_logic = function()
  
end;
private.get_kioskplateext_inv = function()
  interface.InventoryItemAdd("inv_kioskplateext","spr_wellext_kioskplateext");
end;
private.get_kioskplateext_beg = function()
  ObjDelete("gfx_wellext_kioskplateext")
end;
private.get_kioskplateext_end = function()
  if common_impl.ZzCompleteCheck("get_kioskplateext") then ObjSet( common_impl.hint["get_kioskplateext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_kioskplateext", private.get_kioskplateext_inv );
cmn.AddSubscriber( "get_kioskplateext", private.get_kioskplateext_beg, private.room_objname );
cmn.AddSubscriber( "get_kioskplateext", private.get_kioskplateext_end, private.room_objname );
cmn.AddSubscriber( "get_kioskplateext", private.get_kioskplateext_logic );
--------------------------------------------------------------------
function public.get_kioskplateext()
  cmn.SetEventDone( "use_hookext" );
  cmn.SetEventDone( "get_kioskplateext" );
  cmn.CallEventHandler( "get_kioskplateext" );
  if common_impl.ZzCompleteCheck("get_kioskplateext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_sickleext_zone_clk()  --rm_farmext.use_sickleext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_sickleext' );
  end;  

  ld.Lock(1);
  SoundSfx( "aud_touch_small_stone" );
  ld.AnimPlay( "anm_wellext_anm_well_serp", "idle_close", func_end )
end;  

common_impl.hint[ "use_sickleext" ] = { type = "use", inv_obj = "inv_sickleext", use_place = "gfx_wellext_sickleext_zone", room = "rm_farmext", zz = "zz_wellext", zz_gate = "gzz_farmext_wellext" };

private.use_sickleext_logic = function()
  ObjSet( "spr_wellext_innerporchkeyext", { visible = 1, input = 1, active = 1 } )

end;
private.use_sickleext_inv = function()
  common_impl.ProcessMultiUseAll("sickleext", "sickleext")
end;
private.use_sickleext_beg = function()
  ObjDelete( "gfx_wellext_sickleext_zone" );
end;
private.use_sickleext_end = function()
  if common_impl.ZzCompleteCheck("use_sickleext") then ObjSet( common_impl.hint["use_sickleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_wellext_anm_well_serp");
  ObjDelete("spr_farmext_close_door");
  ObjSet( "spr_farmext_tr_key", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sickleext", private.use_sickleext_inv );
cmn.AddSubscriber( "use_sickleext", private.use_sickleext_beg, private.room_objname );
cmn.AddSubscriber( "use_sickleext", private.use_sickleext_end, private.room_objname );
cmn.AddSubscriber( "use_sickleext", private.use_sickleext_logic );
cmn.AddSubscriber( "use_sickleext_inv", private.use_sickleext_inv, private.room_objname );
cmn.AddSubscriber( "use_sickleext_beg", private.use_sickleext_beg, private.room_objname );
cmn.AddSubscriber( "use_sickleext_end", private.use_sickleext_end, private.room_objname );
cmn.AddSubscriber( "use_sickleext_end", private.use_sickleext_logic );
--------------------------------------------------------------------------------------------
function public.use_sickleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sickleext" );
    cmn.CallEventHandler( "use_sickleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sickleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sickleext_inv" );
  cmn.CallEventHandler( "use_sickleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wellext_anm_well_serp", "use_serp", func_end );
  SoundSfx( "aud_use_sickleext_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_innerporchkeyext" ] = { type = "get", get_obj = "spr_wellext_innerporchkeyext", room = "rm_farmext", zz = "zz_wellext", zz_gate = "gzz_farmext_wellext" };

private.get_innerporchkeyext_logic = function()
  
end;
private.get_innerporchkeyext_inv = function()
  interface.InventoryItemAdd("inv_innerporchkeyext","spr_wellext_innerporchkeyext");
end;
private.get_innerporchkeyext_beg = function()
  ObjDelete("gfx_wellext_innerporchkeyext")
end;
private.get_innerporchkeyext_end = function()
  if common_impl.ZzCompleteCheck("get_innerporchkeyext") then ObjSet( common_impl.hint["get_innerporchkeyext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_farmext_tr_key");
  ObjDelete("spr_wellext_sh_innerporchkeyext");
end;

cmn.AddSubscriber( "get_innerporchkeyext", private.get_innerporchkeyext_inv );
cmn.AddSubscriber( "get_innerporchkeyext", private.get_innerporchkeyext_beg, private.room_objname );
cmn.AddSubscriber( "get_innerporchkeyext", private.get_innerporchkeyext_end, private.room_objname );
cmn.AddSubscriber( "get_innerporchkeyext", private.get_innerporchkeyext_logic );
--------------------------------------------------------------------
function public.get_innerporchkeyext()
  cmn.SetEventDone( "get_innerporchkeyext" );
  cmn.CallEventHandler( "get_innerporchkeyext" );
  if common_impl.ZzCompleteCheck("get_innerporchkeyext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_exittopondext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_handlecircleext" ] = { type = "get", get_obj = "spr_exittopondext_handlecircleext", room = "rm_farmext", zz = "zz_exittopondext", zz_gate = "gzz_farmext_exittopondext" };

private.get_handlecircleext_logic = function()
  
end;
private.get_handlecircleext_inv = function()
  interface.InventoryItemAdd("inv_handlecircleext","spr_exittopondext_handlecircleext");
end;
private.get_handlecircleext_beg = function()
  ObjDelete("gfx_exittopondext_handlecircleext")
end;
private.get_handlecircleext_end = function()
  if common_impl.ZzCompleteCheck("get_handlecircleext") then ObjSet( common_impl.hint["get_handlecircleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_exittopondext_sh_handlecircleext");
  ObjDelete("spr_farmext_handlecircleext");
end;

cmn.AddSubscriber( "get_handlecircleext", private.get_handlecircleext_inv );
cmn.AddSubscriber( "get_handlecircleext", private.get_handlecircleext_beg, private.room_objname );
cmn.AddSubscriber( "get_handlecircleext", private.get_handlecircleext_end, private.room_objname );
cmn.AddSubscriber( "get_handlecircleext", private.get_handlecircleext_logic );
--------------------------------------------------------------------
function public.get_handlecircleext()
  cmn.SetEventDone( "get_handlecircleext" );
  cmn.CallEventHandler( "get_handlecircleext" );
  if common_impl.ZzCompleteCheck("get_handlecircleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_pocketknifeext_exittopondext_zone_clk()  --rm_farmext.use_pocketknifeext_exittopondext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_pocketknifeext_exittopondext' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_clothes" );
  ld.AnimPlay( "anm_exittopondext_anm_pond_knife", "idle_petal", func_end )
end;  


common_impl.hint[ "use_pocketknifeext_exittopondext" ] = { type = "use", inv_obj = "inv_pocketknifeext", use_place = "gfx_exittopondext_pocketknifeext_exittopondext_zone", room = "rm_farmext", zz = "zz_exittopondext", zz_gate = "gzz_farmext_exittopondext" };

private.use_pocketknifeext_exittopondext_logic = function()
  ObjSet( "spr_exittopondext_petalext1", { visible = 1, input = 1, active = 1 } )

end;
private.use_pocketknifeext_exittopondext_inv = function()
  common_impl.ProcessMultiUseAll("pocketknifeext", "pocketknifeext_exittopondext")
end;
private.use_pocketknifeext_exittopondext_beg = function()
  ObjDelete( "gfx_exittopondext_pocketknifeext_exittopondext_zone" );
end;
private.use_pocketknifeext_exittopondext_end = function()
  if common_impl.ZzCompleteCheck("use_pocketknifeext_exittopondext") then ObjSet( common_impl.hint["use_pocketknifeext_exittopondext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_exittopondext_anm_pond_knife");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pocketknifeext_exittopondext", private.use_pocketknifeext_exittopondext_inv );
cmn.AddSubscriber( "use_pocketknifeext_exittopondext", private.use_pocketknifeext_exittopondext_beg, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_exittopondext", private.use_pocketknifeext_exittopondext_end, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_exittopondext", private.use_pocketknifeext_exittopondext_logic );
cmn.AddSubscriber( "use_pocketknifeext_exittopondext_inv", private.use_pocketknifeext_exittopondext_inv, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_exittopondext_beg", private.use_pocketknifeext_exittopondext_beg, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_exittopondext_end", private.use_pocketknifeext_exittopondext_end, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_exittopondext_end", private.use_pocketknifeext_exittopondext_logic );
--------------------------------------------------------------------------------------------
function public.use_pocketknifeext_exittopondext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pocketknifeext_exittopondext" );
    cmn.CallEventHandler( "use_pocketknifeext_exittopondext_end" );
    public.get_petalext1();
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pocketknifeext_exittopondext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pocketknifeext_exittopondext_inv" );
  cmn.CallEventHandler( "use_pocketknifeext_exittopondext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_exittopondext_anm_pond_knife", "use_knife", func_end );
  SoundSfx( "aud_use_pocketknifeext_exittopondext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_petalext1" ] = { type = "get", get_obj = "spr_exittopondext_petalext1", room = "rm_farmext", zz = "zz_exittopondext", zz_gate = "gzz_farmext_exittopondext" };

private.get_petalext1_logic = function()
  
end;
private.get_petalext1_inv = function()
  interface.InventoryItemAdd("inv_petalext1","spr_exittopondext_petalext1");
end;
private.get_petalext1_beg = function()
  ObjDelete("gfx_exittopondext_petalext1")
end;
private.get_petalext1_end = function()
  if common_impl.ZzCompleteCheck("get_petalext1") then ObjSet( common_impl.hint["get_petalext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_farmext_petalext1");
end;

cmn.AddSubscriber( "get_petalext1", private.get_petalext1_inv );
cmn.AddSubscriber( "get_petalext1", private.get_petalext1_beg, private.room_objname );
cmn.AddSubscriber( "get_petalext1", private.get_petalext1_end, private.room_objname );
cmn.AddSubscriber( "get_petalext1", private.get_petalext1_logic );
--------------------------------------------------------------------
function public.get_petalext1()
  cmn.SetEventDone( "get_petalext1" );
  cmn.CallEventHandler( "get_petalext1" );
  if common_impl.ZzCompleteCheck("get_petalext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_tridentext_zone_clk()  --rm_farmext.use_tridentext_zone_clk() 
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_tridentext' )
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_big_metal" );
  ld.AnimPlay( "anm_exittopondext_anm_pond_door", "idle_door", func_end )
end;  


common_impl.hint[ "use_tridentext" ] = { type = "use", inv_obj = "inv_tridentext", use_place = "gfx_exittopondext_tridentext_zone", room = "rm_farmext", zz = "zz_exittopondext", zz_gate = "gzz_farmext_exittopondext" };

private.use_tridentext_logic = function()
  ObjSet( "gmg_farmext_gatespondext", { visible = 1, input = 1, active = 1 } )

end;
private.use_tridentext_inv = function()
  common_impl.ProcessMultiUseAll("tridentext", "tridentext")
end;
private.use_tridentext_beg = function()
  ObjDelete( "gfx_exittopondext_tridentext_zone" );
end;
private.use_tridentext_end = function()
  if common_impl.ZzCompleteCheck("use_tridentext") then ObjSet( common_impl.hint["use_tridentext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_exittopondext_anm_pond_door");
  ObjDelete("spr_farmext_door1");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tridentext", private.use_tridentext_inv );
cmn.AddSubscriber( "use_tridentext", private.use_tridentext_beg, private.room_objname );
cmn.AddSubscriber( "use_tridentext", private.use_tridentext_end, private.room_objname );
cmn.AddSubscriber( "use_tridentext", private.use_tridentext_logic );
cmn.AddSubscriber( "use_tridentext_inv", private.use_tridentext_inv, private.room_objname );
cmn.AddSubscriber( "use_tridentext_beg", private.use_tridentext_beg, private.room_objname );
cmn.AddSubscriber( "use_tridentext_end", private.use_tridentext_end, private.room_objname );
cmn.AddSubscriber( "use_tridentext_end", private.use_tridentext_logic );
--------------------------------------------------------------------------------------------
function public.use_tridentext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tridentext" );
    cmn.CallEventHandler( "use_tridentext_end" );
    --  common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_tridentext") then ld.CloseSubRoom() end;
    ld.StartTimer( 0.5, function() ld.Lock(0); cmn.GotoRoom("mg_gatespondext") end )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tridentext_inv" );
  cmn.CallEventHandler( "use_tridentext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_exittopondext_anm_pond_door", "use_trez", func_end );
  SoundSfx( "aud_use_tridentext_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_harvesterext *** () end
--*********************************************************************************************************************
-----------------------------------------------------------------------  
--common_impl.hint[ "get_bombmapext" ] = { type = "get", get_obj = "spr_harvesterext_bombmapext", room = "rm_farmext", zz = "zz_harvesterext", zz_gate = "gzz_farmext_harvesterext" };
--
--private.get_bombmapext_logic = function()
--  
--end;
--private.get_bombmapext_inv = function()
--  interface.InventoryItemAdd("inv_bombmapext","spr_harvesterext_bombmapext");
--  ObjSet( "inv_bombmapext", { drag = 0 } );
--end;
--private.get_bombmapext_beg = function()
--  ObjDelete("gfx_harvesterext_bombmapext")
--end;
--private.get_bombmapext_end = function()
--  if common_impl.ZzCompleteCheck("get_bombmapext") then ObjSet( common_impl.hint["get_bombmapext"].zz_gate, { visible = 0, input = 0 } ); end;
--  ObjDelete("spr_harvesterext_sh_bombmapext");
--  ObjDelete("spr_farmext_bombmapext");
--end;
--
--cmn.AddSubscriber( "get_bombmapext", private.get_bombmapext_inv );
--cmn.AddSubscriber( "get_bombmapext", private.get_bombmapext_beg, private.room_objname );
--cmn.AddSubscriber( "get_bombmapext", private.get_bombmapext_end, private.room_objname );
--cmn.AddSubscriber( "get_bombmapext", private.get_bombmapext_logic );
----------------------------------------------------------------------
--function public.get_bombmapext()
--  cmn.SetEventDone( "get_bombmapext" );
--  cmn.CallEventHandler( "get_bombmapext" );
--  if common_impl.ZzCompleteCheck("get_bombmapext") then cmn.GotoRoom( "rm_farmext" ); end;
--end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_pocketknifeext_harvesterext_zone_clk() -- rm_farmext.use_pocketknifeext_harvesterext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_pocketknifeext_harvesterext' );  
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_weed" );
  ld.AnimPlay( "anm_harvesterext_anim_tracror", "idle_wire", func_end )
end;  


common_impl.hint[ "use_pocketknifeext_harvesterext" ] = { type = "use", inv_obj = "inv_pocketknifeext", use_place = "gfx_harvesterext_pocketknifeext_harvesterext_zone", room = "rm_farmext", zz = "zz_harvesterext", zz_gate = "gzz_farmext_harvesterext" };

private.use_pocketknifeext_harvesterext_logic = function()
  ObjSet( "spr_harvesterext_greenwireext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_harvesterext_greenwireext", {active=1, visible = 1} );
end;
private.use_pocketknifeext_harvesterext_inv = function()
  common_impl.ProcessMultiUseAll("pocketknifeext", "pocketknifeext_harvesterext")
end;
private.use_pocketknifeext_harvesterext_beg = function()
  ObjDelete( "gfx_harvesterext_pocketknifeext_harvesterext_zone" );
end;
private.use_pocketknifeext_harvesterext_end = function()
  if common_impl.ZzCompleteCheck("use_pocketknifeext_harvesterext") then ObjSet( common_impl.hint["use_pocketknifeext_harvesterext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_harvesterext_anim_tracror", {animfunc = "end_wire", frame = 0 } );
  ObjDelete("spr_farmext_greenwireext")
  ObjSet( "spr_farmext_greenwireext2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pocketknifeext_harvesterext", private.use_pocketknifeext_harvesterext_inv );
cmn.AddSubscriber( "use_pocketknifeext_harvesterext", private.use_pocketknifeext_harvesterext_beg, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_harvesterext", private.use_pocketknifeext_harvesterext_end, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_harvesterext", private.use_pocketknifeext_harvesterext_logic );
cmn.AddSubscriber( "use_pocketknifeext_harvesterext_inv", private.use_pocketknifeext_harvesterext_inv, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_harvesterext_beg", private.use_pocketknifeext_harvesterext_beg, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_harvesterext_end", private.use_pocketknifeext_harvesterext_end, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_harvesterext_end", private.use_pocketknifeext_harvesterext_logic );
--------------------------------------------------------------------------------------------
function public.use_pocketknifeext_harvesterext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pocketknifeext_harvesterext" );
    cmn.CallEventHandler( "use_pocketknifeext_harvesterext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pocketknifeext_harvesterext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pocketknifeext_harvesterext_inv" );
  cmn.CallEventHandler( "use_pocketknifeext_harvesterext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_harvesterext_anim_tracror", "use_knife", func_end )
  SoundSfx( "aud_use_pocketknifeext_harvesterext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_greenwireext" ] = { type = "get", get_obj = "spr_harvesterext_greenwireext", room = "rm_farmext", zz = "zz_harvesterext", zz_gate = "gzz_farmext_harvesterext" };

private.get_greenwireext_logic = function()
  
end;
private.get_greenwireext_inv = function()
  interface.InventoryItemAdd("inv_greenwireext","spr_harvesterext_greenwireext");
end;
private.get_greenwireext_beg = function()
  ObjDelete("gfx_harvesterext_greenwireext")
end;
private.get_greenwireext_end = function()
  if common_impl.ZzCompleteCheck("get_greenwireext") then ObjSet( common_impl.hint["get_greenwireext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_harvesterext_anim_tracror");
  ObjDelete("spr_farmext_greenwireext2");
end;

cmn.AddSubscriber( "get_greenwireext", private.get_greenwireext_inv );
cmn.AddSubscriber( "get_greenwireext", private.get_greenwireext_beg, private.room_objname );
cmn.AddSubscriber( "get_greenwireext", private.get_greenwireext_end, private.room_objname );
cmn.AddSubscriber( "get_greenwireext", private.get_greenwireext_logic );
--------------------------------------------------------------------
function public.get_greenwireext()
  ObjSet( "spr_harvesterext_greenwireext", {visible = 1} );
  cmn.SetEventDone( "get_greenwireext" );
  cmn.CallEventHandler( "get_greenwireext" );
  if common_impl.ZzCompleteCheck("get_greenwireext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_greenwireext" ] = { type = "use", inv_obj = "inv_greenwireext", use_place = "gfx_harvesterext_greenwireext_zone", room = "rm_farmext", zz = "zz_harvesterext", zz_gate = "gzz_farmext_harvesterext" };

private.use_greenwireext_logic = function()
  if ld.CheckRequirements( {"use_greenwireext","use_bluewireext","use_yellowwireext"} ) then
    ObjSet( "gmg_farmext_bomboneext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_greenwireext_inv = function()
  common_impl.ProcessMultiUseAll("greenwireext", "greenwireext")
end;
private.use_greenwireext_beg = function()
  ObjDelete( "gfx_harvesterext_greenwireext_zone" );
end;
private.use_greenwireext_end = function()
  if common_impl.ZzCompleteCheck("use_greenwireext") then ObjSet( common_impl.hint["use_greenwireext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_harvesterext_anim_tracror_wire1", {animfunc="use_wire1", frame=999, pos_z=1} );
  ObjSet( "spr_farmext_c_wire1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_greenwireext", private.use_greenwireext_inv );
cmn.AddSubscriber( "use_greenwireext", private.use_greenwireext_beg, private.room_objname );
cmn.AddSubscriber( "use_greenwireext", private.use_greenwireext_end, private.room_objname );
cmn.AddSubscriber( "use_greenwireext", private.use_greenwireext_logic );
cmn.AddSubscriber( "use_greenwireext_inv", private.use_greenwireext_inv, private.room_objname );
cmn.AddSubscriber( "use_greenwireext_beg", private.use_greenwireext_beg, private.room_objname );
cmn.AddSubscriber( "use_greenwireext_end", private.use_greenwireext_end, private.room_objname );
cmn.AddSubscriber( "use_greenwireext_end", private.use_greenwireext_logic );
--------------------------------------------------------------------------------------------
function public.use_greenwireext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_greenwireext" );
    cmn.CallEventHandler( "use_greenwireext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_greenwireext") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_greenwireext","use_bluewireext","use_yellowwireext"} ) then
        cmn.GotoRoom( "mg_bomboneext" );
    end;  
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_greenwireext_inv" );
  cmn.CallEventHandler( "use_greenwireext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_harvesterext_anim_tracror_wire1", "use_wire1", func_end );
  SoundSfx( "aud_use_wire_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bluewireext" ] = { type = "use", inv_obj = "inv_bluewireext", use_place = "gfx_harvesterext_bluewireext_zone", room = "rm_farmext", zz = "zz_harvesterext", zz_gate = "gzz_farmext_harvesterext" };

private.use_bluewireext_logic = function()
  if ld.CheckRequirements( {"use_bluewireext","use_greenwireext","use_yellowwireext"} ) then
    ObjSet( "gmg_farmext_bomboneext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_bluewireext_inv = function()
  common_impl.ProcessMultiUseAll("bluewireext", "bluewireext")
end;
private.use_bluewireext_beg = function()
  ObjDelete( "gfx_harvesterext_bluewireext_zone" );
end;
private.use_bluewireext_end = function()
  if common_impl.ZzCompleteCheck("use_bluewireext") then ObjSet( common_impl.hint["use_bluewireext"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjSet( "anm_harvesterext_anim_tracror_wire2", {animfunc="use_wire2", frame=999, pos_z=1} );
   ObjSet( "spr_farmext_c_wire2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bluewireext", private.use_bluewireext_inv );
cmn.AddSubscriber( "use_bluewireext", private.use_bluewireext_beg, private.room_objname );
cmn.AddSubscriber( "use_bluewireext", private.use_bluewireext_end, private.room_objname );
cmn.AddSubscriber( "use_bluewireext", private.use_bluewireext_logic );
cmn.AddSubscriber( "use_bluewireext_inv", private.use_bluewireext_inv, private.room_objname );
cmn.AddSubscriber( "use_bluewireext_beg", private.use_bluewireext_beg, private.room_objname );
cmn.AddSubscriber( "use_bluewireext_end", private.use_bluewireext_end, private.room_objname );
cmn.AddSubscriber( "use_bluewireext_end", private.use_bluewireext_logic );
--------------------------------------------------------------------------------------------
function public.use_bluewireext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bluewireext" );
    cmn.CallEventHandler( "use_bluewireext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bluewireext") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_greenwireext","use_bluewireext","use_yellowwireext"} ) then
        cmn.GotoRoom( "mg_bomboneext" );
    end; 
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bluewireext_inv" );
  cmn.CallEventHandler( "use_bluewireext_beg" );
  common_impl.Lock(1);
  
  ld.AnimPlay( "anm_harvesterext_anim_tracror_wire2", "use_wire2", func_end );
  SoundSfx( "aud_use_wire_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_yellowwireext" ] = { type = "use", inv_obj = "inv_yellowwireext", use_place = "gfx_harvesterext_yellowwireext_zone", room = "rm_farmext", zz = "zz_harvesterext", zz_gate = "gzz_farmext_harvesterext" };

private.use_yellowwireext_logic = function()
  if ld.CheckRequirements( {"use_yellowwireext","use_greenwireext","use_bluewireext"} ) then
    ObjSet( "gmg_farmext_bomboneext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_yellowwireext_inv = function()
  common_impl.ProcessMultiUseAll("yellowwireext", "yellowwireext")
end;
private.use_yellowwireext_beg = function()
  ObjDelete( "gfx_harvesterext_yellowwireext_zone" );
end;
private.use_yellowwireext_end = function()
  if common_impl.ZzCompleteCheck("use_yellowwireext") then ObjSet( common_impl.hint["use_yellowwireext"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjSet( "anm_harvesterext_anim_tracror_wire4", {animfunc="use_wire4", frame=999, pos_z=1} );
   ObjSet( "spr_farmext_c_wire4", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_yellowwireext", private.use_yellowwireext_inv );
cmn.AddSubscriber( "use_yellowwireext", private.use_yellowwireext_beg, private.room_objname );
cmn.AddSubscriber( "use_yellowwireext", private.use_yellowwireext_end, private.room_objname );
cmn.AddSubscriber( "use_yellowwireext", private.use_yellowwireext_logic );
cmn.AddSubscriber( "use_yellowwireext_inv", private.use_yellowwireext_inv, private.room_objname );
cmn.AddSubscriber( "use_yellowwireext_beg", private.use_yellowwireext_beg, private.room_objname );
cmn.AddSubscriber( "use_yellowwireext_end", private.use_yellowwireext_end, private.room_objname );
cmn.AddSubscriber( "use_yellowwireext_end", private.use_yellowwireext_logic );
--------------------------------------------------------------------------------------------
function public.use_yellowwireext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_yellowwireext" );
    cmn.CallEventHandler( "use_yellowwireext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_yellowwireext") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_greenwireext","use_bluewireext","use_yellowwireext"} ) then
        cmn.GotoRoom( "mg_bomboneext" );
    end; 
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_yellowwireext_inv" );
  cmn.CallEventHandler( "use_yellowwireext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_harvesterext_anim_tracror_wire4", "use_wire4", func_end );
  SoundSfx( "aud_use_wire_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_barnentranceext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_partswitchext_zone_clk()   --rm_farmext.use_partswitchext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_partswitchext' );
  end;

  ld.Lock(1);
  ld.AnimPlay( "anm_barnentranceext_anm_bran_box", "idle_close", func_end )  
  SoundSfx( "aud_touch_small_plastic" )
end;  
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_partswitchext" ] = { type = "use", inv_obj = "inv_partswitchext", use_place = "gfx_barnentranceext_partswitchext_zone", room = "rm_farmext", zz = "zz_barnentranceext", zz_gate = "gzz_farmext_barnentranceext" };

private.use_partswitchext_logic = function()
  --  ObjSet( "spr_barnentranceext_hookext", { visible = 1, input = 1, active = 1 } )
    ObjSet( "gfx_barnentranceext_clk_partswitchext1_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_partswitchext_inv = function()
  common_impl.ProcessMultiUseAll("partswitchext", "partswitchext")
end;
private.use_partswitchext_beg = function()
  ObjDelete( "gfx_barnentranceext_partswitchext_zone" );
end;
private.use_partswitchext_end = function()
  if common_impl.ZzCompleteCheck("use_partswitchext") then ObjSet( common_impl.hint["use_partswitchext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_barnentranceext_anm_bran_witch", {animfunc = "idle_a1", frame = 0 } );
  ObjDelete("anm_barnentranceext_anm_bran_box");
  ObjSet( "spr_farmext_a", {visible = 1} );
  ObjSet( "spr_farmext_b", {visible = 1} );
  ObjSet( "spr_farmext_c", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_partswitchext", private.use_partswitchext_inv );
cmn.AddSubscriber( "use_partswitchext", private.use_partswitchext_beg, private.room_objname );
cmn.AddSubscriber( "use_partswitchext", private.use_partswitchext_end, private.room_objname );
cmn.AddSubscriber( "use_partswitchext", private.use_partswitchext_logic );
cmn.AddSubscriber( "use_partswitchext_inv", private.use_partswitchext_inv, private.room_objname );
cmn.AddSubscriber( "use_partswitchext_beg", private.use_partswitchext_beg, private.room_objname );
cmn.AddSubscriber( "use_partswitchext_end", private.use_partswitchext_end, private.room_objname );
cmn.AddSubscriber( "use_partswitchext_end", private.use_partswitchext_logic );
--------------------------------------------------------------------------------------------
function public.use_partswitchext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_partswitchext" );
    cmn.CallEventHandler( "use_partswitchext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_partswitchext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_partswitchext_inv" );
  cmn.CallEventHandler( "use_partswitchext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_barnentranceext_anm_bran_witch", "use_a", func_end );
  SoundSfx( "aud_use_partswitchext_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
common_impl.hint[ "clk_partswitchext1" ] = { type = "click", use_place = "gfx_barnentranceext_clk_partswitchext1_zone", room = "rm_farmext", zz = "zz_barnentranceext", zz_gate = "gzz_farmext_barnentranceext" };

private.clk_partswitchext1_logic = function()
  ObjSet( "gfx_barnentranceext_clk_partswitchext2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_partswitchext1_beg = function()
  ObjDelete( "gfx_barnentranceext_clk_partswitchext1_zone" );
end;
private.clk_partswitchext1_end = function()
  if common_impl.ZzCompleteCheck("clk_partswitchext1") then ObjSet( common_impl.hint["clk_partswitchext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_barnentranceext_anm_bran_witch", {animfunc = "idle_a2", frame = 0 } );
  ObjSet( "spr_farmext_close", {pos_x=226} );
  ObjSet( "spr_farmext_a", {scale_y=-1, pos_y=427} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_partswitchext1", private.clk_partswitchext1_beg, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext1", private.clk_partswitchext1_end, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext1", private.clk_partswitchext1_logic );
cmn.AddSubscriber( "clk_partswitchext1_beg", private.clk_partswitchext1_beg, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext1_end", private.clk_partswitchext1_end, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext1_end", private.clk_partswitchext1_logic );
--------------------------------------------------------------------------------------------
function public.clk_partswitchext1()

  local func_end = function()
    cmn.SetEventDone( "clk_partswitchext1" );
    cmn.CallEventHandler( "clk_partswitchext1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_partswitchext1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_partswitchext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_barnentranceext_anm_bran_witch", "idle_a1", func_end );
  SoundSfx( "aud_touch_partswitchext_farmext" )
  --func_end()

end;
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
common_impl.hint[ "clk_partswitchext2" ] = { type = "click", use_place = "gfx_barnentranceext_clk_partswitchext2_zone", room = "rm_farmext", zz = "zz_barnentranceext", zz_gate = "gzz_farmext_barnentranceext" };

private.clk_partswitchext2_logic = function()
  ObjSet( "gfx_barnentranceext_clk_partswitchext3_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_partswitchext2_beg = function()
  ObjDelete( "gfx_barnentranceext_clk_partswitchext2_zone" );
end;
private.clk_partswitchext2_end = function()
  if common_impl.ZzCompleteCheck("clk_partswitchext2") then ObjSet( common_impl.hint["clk_partswitchext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_barnentranceext_anm_bran_witch", {animfunc = "idle_a3", frame = 0 } );
  ObjSet( "spr_farmext_close", {pos_x=233} );
  ObjSet( "spr_farmext_b", {scale_y=-1, pos_y=426} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_partswitchext2", private.clk_partswitchext2_beg, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext2", private.clk_partswitchext2_end, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext2", private.clk_partswitchext2_logic );
cmn.AddSubscriber( "clk_partswitchext2_beg", private.clk_partswitchext2_beg, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext2_end", private.clk_partswitchext2_end, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext2_end", private.clk_partswitchext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_partswitchext2()

  local func_end = function()
    cmn.SetEventDone( "clk_partswitchext2" );
    cmn.CallEventHandler( "clk_partswitchext2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_partswitchext2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_partswitchext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_barnentranceext_anm_bran_witch", "idle_a2", func_end );
  SoundSfx( "aud_touch_partswitchext_farmext" )
  --func_end()

end;
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
common_impl.hint[ "clk_partswitchext3" ] = { type = "click", use_place = "gfx_barnentranceext_clk_partswitchext3_zone", room = "rm_farmext", zz = "zz_barnentranceext", zz_gate = "gzz_farmext_barnentranceext" };

private.clk_partswitchext3_logic = function()
  ObjSet( "spr_barnentranceext_hookext", { visible = 1, input = 1, active = 1 } )
end;
private.clk_partswitchext3_beg = function()
  ObjDelete( "gfx_barnentranceext_clk_partswitchext3_zone" );
end;
private.clk_partswitchext3_end = function()
  if common_impl.ZzCompleteCheck("clk_partswitchext3") then ObjSet( common_impl.hint["clk_partswitchext3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_barnentranceext_anm_bran_witch", {animfunc = "idle_a3", frame = 999 } );
  ObjSet( "spr_farmext_close", {pos_x=240} );
  ObjSet( "spr_farmext_c", {scale_y=-1, pos_y=426} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_partswitchext3", private.clk_partswitchext3_beg, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext3", private.clk_partswitchext3_end, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext3", private.clk_partswitchext3_logic );
cmn.AddSubscriber( "clk_partswitchext3_beg", private.clk_partswitchext3_beg, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext3_end", private.clk_partswitchext3_end, private.room_objname );
cmn.AddSubscriber( "clk_partswitchext3_end", private.clk_partswitchext3_logic );
--------------------------------------------------------------------------------------------
function public.clk_partswitchext3()

  local func_end = function()
    cmn.SetEventDone( "clk_partswitchext3" );
    cmn.CallEventHandler( "clk_partswitchext3_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_partswitchext3") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_partswitchext3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_barnentranceext_anm_bran_witch", "idle_a3", func_end );
  SoundSfx( "aud_touch_partswitchext_farmext" )
  --func_end()

end;
----------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hookext" ] = { type = "get", get_obj = "spr_barnentranceext_hookext", room = "rm_farmext", zz = "zz_barnentranceext", zz_gate = "gzz_farmext_barnentranceext" };

private.get_hookext_logic = function()
  
end;
private.get_hookext_inv = function()
  interface.InventoryItemAdd("inv_hookext","spr_barnentranceext_hookext");
end;
private.get_hookext_beg = function()
  ObjDelete("gfx_barnentranceext_hookext")
end;
private.get_hookext_end = function()
  if common_impl.ZzCompleteCheck("get_hookext") then ObjSet( common_impl.hint["get_hookext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_barnentranceext_sh_hookext");
  ObjDelete("spr_farmext_hookext");
end;

cmn.AddSubscriber( "get_hookext", private.get_hookext_inv );
cmn.AddSubscriber( "get_hookext", private.get_hookext_beg, private.room_objname );
cmn.AddSubscriber( "get_hookext", private.get_hookext_end, private.room_objname );
cmn.AddSubscriber( "get_hookext", private.get_hookext_logic );
--------------------------------------------------------------------
function public.get_hookext()
  cmn.SetEventDone( "get_hookext" );
  cmn.CallEventHandler( "get_hookext" );
  if common_impl.ZzCompleteCheck("get_hookext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_petalext1" ] = { type = "use", inv_obj = "inv_petalext1", use_place = "gfx_barnentranceext_petalext1_zone", room = "rm_farmext", zz = "zz_barnentranceext", zz_gate = "gzz_farmext_barnentranceext" };

private.use_petalext1_logic = function()
  if ld.CheckRequirements( {"use_petalext1","use_petalext2"} ) then
    ObjSet( "obj_barnentranceext_mmg_root", { visible = 1, input = 1, active = 1, alp=1 } )
  end;

end;
private.use_petalext1_inv = function()
  common_impl.ProcessMultiUseAll("petalext1", "petalext1")
end;
private.use_petalext1_beg = function()
  ObjDelete( "gfx_barnentranceext_petalext1_zone" );
end;
private.use_petalext1_end = function()
  if common_impl.ZzCompleteCheck("use_petalext1") then ObjSet( common_impl.hint["use_petalext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_barnentranceext_anm_bran_petal1", {animfunc = "use_tr_mmg1", frame = 999 } );
  ObjSet( "spr_farmext_tr_mmg1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_petalext1", private.use_petalext1_inv );
cmn.AddSubscriber( "use_petalext1", private.use_petalext1_beg, private.room_objname );
cmn.AddSubscriber( "use_petalext1", private.use_petalext1_end, private.room_objname );
cmn.AddSubscriber( "use_petalext1", private.use_petalext1_logic );
cmn.AddSubscriber( "use_petalext1_inv", private.use_petalext1_inv, private.room_objname );
cmn.AddSubscriber( "use_petalext1_beg", private.use_petalext1_beg, private.room_objname );
cmn.AddSubscriber( "use_petalext1_end", private.use_petalext1_end, private.room_objname );
cmn.AddSubscriber( "use_petalext1_end", private.use_petalext1_logic );
--------------------------------------------------------------------------------------------
function public.use_petalext1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_petalext1" );
    -- cmn.CallEventHandler( "use_petalext1_end" );
    --common_impl.Lock(0);
    if ld.CheckRequirements( {"use_petalext1","use_petalext2"} ) then
      private.init_flowersext();
      cmn.MiniGameShow( "flowersext" ); 
      ObjAnimate( "obj_barnentranceext_mmg_root", 8, 0, 0, function() cmn.CallEventHandler( "use_petalext1_end" );ld.Lock(0);  end, {0,0,0, 0.5,0,1} );
    else
      common_impl.Lock(0);
      cmn.CallEventHandler( "use_petalext1_end" );
    end;    
    
    if common_impl.ZzCompleteCheck("use_petalext1") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_petalext1_inv" );
  cmn.CallEventHandler( "use_petalext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_barnentranceext_anm_bran_petal1", "use_tr_mmg1", func_end );
  SoundSfx( "aud_use_petalext1_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_petalext2" ] = { type = "use", inv_obj = "inv_petalext2", use_place = "gfx_barnentranceext_petalext2_zone", room = "rm_farmext", zz = "zz_barnentranceext", zz_gate = "gzz_farmext_barnentranceext" };

private.use_petalext2_logic = function()
   if ld.CheckRequirements( {"use_petalext1","use_petalext2"} ) then
    ObjSet( "obj_barnentranceext_mmg_root", { visible = 1, input = 1, active = 1, alp=1 } )
  end;

end;
private.use_petalext2_inv = function()
  common_impl.ProcessMultiUseAll("petalext2", "petalext2")
end;
private.use_petalext2_beg = function()
  ObjDelete( "gfx_barnentranceext_petalext2_zone" );
end;
private.use_petalext2_end = function()
  if common_impl.ZzCompleteCheck("use_petalext2") then ObjSet( common_impl.hint["use_petalext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_barnentranceext_anm_bran_petal2", {animfunc = "use_tr_mmg2", frame = 999 } );
  ObjSet( "spr_farmext_tr_mmg2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_petalext2", private.use_petalext2_inv );
cmn.AddSubscriber( "use_petalext2", private.use_petalext2_beg, private.room_objname );
cmn.AddSubscriber( "use_petalext2", private.use_petalext2_end, private.room_objname );
cmn.AddSubscriber( "use_petalext2", private.use_petalext2_logic );
cmn.AddSubscriber( "use_petalext2_inv", private.use_petalext2_inv, private.room_objname );
cmn.AddSubscriber( "use_petalext2_beg", private.use_petalext2_beg, private.room_objname );
cmn.AddSubscriber( "use_petalext2_end", private.use_petalext2_end, private.room_objname );
cmn.AddSubscriber( "use_petalext2_end", private.use_petalext2_logic );
--------------------------------------------------------------------------------------------
function public.use_petalext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_petalext2" );
    -- cmn.CallEventHandler( "use_petalext2_end" );
    
    if ld.CheckRequirements( {"use_petalext1","use_petalext2"} ) then
      private.init_flowersext();
      cmn.MiniGameShow( "flowersext" ); 
      ObjAnimate( "obj_barnentranceext_mmg_root", 8, 0, 0, function() cmn.CallEventHandler( "use_petalext2_end" );ld.Lock(0);  end, {0,0,0, 0.5,0,1} );
    else
      common_impl.Lock(0);
      cmn.CallEventHandler( "use_petalext2_end" );
    end;  
    if common_impl.ZzCompleteCheck("use_petalext2") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_petalext2_inv" );
  cmn.CallEventHandler( "use_petalext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_barnentranceext_anm_bran_petal2", "use_tr_mmg2", func_end );
  SoundSfx( "aud_use_petalext2_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_flowersext" ] = { type = "click", use_place = "obj_barnentranceext_mmg_root", room = "rm_farmext", zz = "zz_barnentranceext", zz_gate = "gzz_farmext_barnentranceext" };

private.win_flowersext_logic = function()
  if cmn.IsEventDone("win_flowersext") then 
     ObjSet( "grm_farmext_barnext", { visible = 1, input = 1, active = 1 } )
     if port.isPortable() == 1 then
       port.GrmEventLightOn("grm_farmext_barnext_focus");
     end;
   end;
end;
private.win_flowersext_beg = function()
  --ObjDelete( "gfx_barnentranceext_win_flowersext_zone" );
end;
private.win_flowersext_end = function()
  if cmn.IsEventDone("win_flowersext") then 
    -- if common_impl.ZzCompleteCheck("win_flowersext") then ObjSet( common_impl.hint["win_flowersext"].zz_gate, { visible = 0, input = 0 } ); end;
     ObjDelete("spr_farmext_door_mmg");
     --  ObjSet( "spr_farmext_door_openmmg", {visible = 1} );
     ObjDelete("spr_farmext_tr_mmg2");
     ObjDelete("spr_farmext_tr_mmg1");
     ObjSet( common_impl.hint["win_flowersext"].zz_gate, { visible = 0, input = 0 } );
     ObjSet( "anm_farmext_anm_farm_open_barn", {animfunc = "open_barn", frame = 999, visible=1 } );
   end;   
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_flowersext", private.win_flowersext_beg, private.room_objname );
cmn.AddSubscriber( "win_flowersext", private.win_flowersext_end, private.room_objname );
cmn.AddSubscriber( "win_flowersext", private.win_flowersext_logic );
cmn.AddSubscriber( "win_flowersext_beg", private.win_flowersext_beg, private.room_objname );
cmn.AddSubscriber( "win_flowersext_end", private.win_flowersext_end, private.room_objname );
cmn.AddSubscriber( "win_flowersext_end", private.win_flowersext_logic );
--------------------------------------------------------------------------------------------
function public.win_flowersext()

  local func_end = function()
    cmn.SetEventDone( "win_flowersext" );
    cmn.CallEventHandler( "win_flowersext_end" );
    common_impl.Lock(0);
    --  if common_impl.ZzCompleteCheck("win_flowersext") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    ld.CloseSubRoom();
    ObjSet( "spr_farmext_tr_mmg1", {visible = 0} );
    ObjSet( "spr_farmext_tr_mmg2", {visible = 0} );
    ObjSet( "spr_farmext_door_mmg", {visible = 0} );
    ObjSet( "anm_farmext_anm_farm_open_barn", {visible = 1} );
    ld.StartTimer( 0.5, function() SoundSfx( "aud_open_door_farmext" ); ld.AnimPlay( "anm_farmext_anm_farm_open_barn", "open_barn", func_end )  end )
  end;  
  
  cmn.CallEventHandler( "win_flowersext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  
  cmn.MiniGameHide( "flowersext",true ); 
  ld.StartTimer( 0.5, func_preend);
end;
-------------------------------------------------------------------------------------------
private.win_flowers_get_first_pos_flag = false;
local win_flowers_fp_array = {}
local win_wlowers_fuck_array = {1,0,0,0,0,2,3,4,5,6};

function public.win_flowers_fl_menter()
  ld.SetCursor(CURSOR_HAND);
end;  

function public.win_flowers_fl_mleave()
  ld.SetCursor(CURSOR_DEFAULT);
end;  
---------- part drag ---------------------
function public.win_flowers_start_drag(num1)
  ld.SetCursor(CURSOR_HAND);
  ObjSet( "spr_barnentranceext_lig_a"..num1,{alp=1, color_r=1, color_g=1, color_b=1});
  ObjSet( "spr_barnentranceext_a"..num1.."_"..win_wlowers_fuck_array[num1], {pos_z=30} );
  SoundSfx( "aud_mg_petals_get" );
end; 


function public.win_flowers_drag(num1)
  if not ApplyObj("spr_barnentranceext_a"..num1.."_"..win_wlowers_fuck_array[num1],"spr_barnentranceext_back_mmg") then 
    local cursor = GetZoomCursorPos();
    ObjSet( "spr_barnentranceext_a"..num1.."_"..win_wlowers_fuck_array[num1], {pos_x=cursor[1]-512, pos_y=cursor[2]-350} );
    ObjStopDrag("spr_barnentranceext_a"..num1.."_"..win_wlowers_fuck_array[num1]);
  end;  
end;  

local win_flowers_reset_anim_flag=false;
function public.win_flowers_stopdrag(num1)
   local func_end = function()
      ld.Lock(0);
      private.win_flowers_stand_on_pos();   
   end;  
  
  local else_func = function()
      if win_flowers_reset_anim_flag==false then 
         SoundSfx( "aud_mg_petals_wrong" );
         win_flowers_reset_anim_flag=true; 
         ld.Lock(1);
         local cursor = GetZoomCursorPos();
         local lp=ld.TableCopy(win_flowers_fp_array[num1]);
         ObjAnimate( "spr_barnentranceext_a"..num1.."_"..win_wlowers_fuck_array[num1], 3, 0, 0, function() func_end(); win_flowers_reset_anim_flag=false; end , {0,0,cursor[1]-512,cursor[2]-350, 0.3,0,lp[1],lp[2]} ); 
      end;
  end;  
    
    
   ObjSet( "spr_barnentranceext_a"..num1.."_"..win_wlowers_fuck_array[num1], {pos_z=0} );
   ld.SetCursor(CURSOR_DEFAULT);
   if win_wlowers_fuck_array[num1]~=0 then 
      if ApplyObj("spr_barnentranceext_a"..num1.."_"..win_wlowers_fuck_array[num1], "obj_barnentrabceext_flowers_apply"..win_wlowers_fuck_array[num1]) then 
         SoundSfx( "aud_mg_petals_set" );
         private.win_flowersext_state[win_wlowers_fuck_array[num1] ]=1; 
         func_end();
      else   
         else_func();   
      end;      
   else   
     else_func();
   end; 
  
end;  

-------------------------------------------------------
function private.win_flowers_get_first_pos()
  if private.win_flowers_get_first_pos_flag==false then 
    for i=1,10,1 do 
      local obj = ObjGet("spr_barnentranceext_a"..i.."_"..win_wlowers_fuck_array[i]);
      win_flowers_fp_array[i]={obj.pos_x, obj.pos_y};
      ObjSet( "spr_barnentranceext_lig_a"..i, {inputrect_init=0, inputrect_w=10, inputrect_h=10, inputrect_x=-5, inputrect_y=-5, input=1} );
      ObjSet( "spr_barnentranceext_a"..i.."_"..win_wlowers_fuck_array[i],{event_menter="rm_farmext.win_flowers_fl_menter()", event_mleave="rm_farmext.win_flowers_fl_mleave()", 
         event_startdrag="rm_farmext.win_flowers_start_drag("..i..");", event_drag="rm_farmext.win_flowers_drag("..i..");", event_dragdrop="rm_farmext.win_flowers_stopdrag("..i..");"});
      ObjSet( "obj_barnentrabceext_flowers_apply"..i, {inputrect_init=1, inputrect_w=20, inputrect_h=20, inputrect_x=-10, inputrect_y=-10} );
    end;  
  end;

  private.win_flowers_get_first_pos_flag = true;  
end;  

-------------------------------------------------------------------------------------------

private.win_flowersext_fp_state_array={0,0,0,0,0,0};
private.win_flowersext_state = {};

function private.win_flowers_show_state()
-- local my_str="";
-- for i=1,#private.win_flowersext_state,1 do 
--    my_str=my_str.." "..private.win_flowersext_state[i];
-- end;  
-- ld.LogTrace( my_str ); 
end;  

function private.init_flowersext()
  if not (cmn.IsEventStart("win_flowersext")) then
    -- private.win_hidingplace_fp_array_modificator();
    ng_global.progress["ext"]["win_flowersext"].state = {}
    private.win_flowersext_state= ld.TableCopy(private.win_flowersext_fp_state_array);
    ng_global.progress["ext"]["win_flowersext"].state =  private.win_flowersext_state;
   -- private.win_flowersext_state=ng_global.progress["ext"]["win_flowersext"].state;
  else  
    
    private.win_flowersext_state=ng_global.progress["ext"]["win_flowersext"].state;
  end
  
  private.win_flowers_show_state();
  private.win_flowers_stand_on_pos();  
end
---------------------------------------------------------------------------------
function private.win_flowers_stand_on_pos()
  for i=1,10,1 do
    if win_wlowers_fuck_array[i]~=0 then 
      if  private.win_flowersext_state[win_wlowers_fuck_array[i] ]~=0 then
        local set_obj=ObjGet("obj_barnentrabceext_flowers_apply"..win_wlowers_fuck_array[i]);
        ObjSet( "spr_barnentranceext_a"..i.."_"..win_wlowers_fuck_array[i], {pos_x=set_obj.pos_x, pos_y=set_obj.pos_y, input=0, drag=0} );
        ObjSet( "spr_barnentranceext_lig_a"..i, {alp=1, input=0, visible=1, color_r=0, color_g=1, color_b=0} );
      else  
        ObjSet( "spr_barnentranceext_a"..i.."_"..win_wlowers_fuck_array[i], {pos_x=win_flowers_fp_array[i][1], pos_y=win_flowers_fp_array[i][2], input=1, drag=1} ); 
        ObjSet( "spr_barnentranceext_lig_a"..i, {alp=0, input=0, visible=1, color_r=1, color_g=1, color_b=1} );
      end;
    else
       ObjSet( "spr_barnentranceext_a"..i.."_"..win_wlowers_fuck_array[i], {pos_x=win_flowers_fp_array[i][1], pos_y=win_flowers_fp_array[i][2], input=1, drag=1} ); 
       ObjSet( "spr_barnentranceext_lig_a"..i, {alp=0, input=0, visible=1, color_r=1, color_g=1, color_b=1} );
    end;  
  end;
  private.win_flowers_win_ver();  
end;  
-------------------------------------------------------------------------------- 

function private.win_flowers_win_ver()
   local count=0;
   for i=1,6,1 do 
     if private.win_flowersext_state[i]~=0 then count=count+1; end;
   end;  
   
   if count==6 then public.win_flowersext(); end;
end;  
 
 
---------------------------------------------------------------------------------
--*********************************************************************************************************************
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_barnentranceext" ) and not ld.CheckRequirements( { "win_flowersext" } ) then  
    local func_end = function() 
       ng_global.progress["ext"]["win_flowersext"].state = {}
       private.win_flowersext_state= ld.TableCopy(private.win_flowersext_fp_state_array);
       ng_global.progress["ext"]["win_flowersext"].state =  private.win_flowersext_state;
       private.win_flowers_stand_on_pos(); 
       ObjAnimate( "obj_barnentranceext_mmg_anim_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.3,0,1} );
    end;
    
    ld.Lock(1);
    ObjAnimate( "obj_barnentranceext_mmg_anim_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_barnentranceext" ) and not ld.CheckRequirements( { "win_flowersext" } ) then
    local func_end = function() 
       ng_global.progress["ext"]["win_flowersext"].state = {}
       private.win_flowersext_state= {1,1,1,1,1,1};
       ng_global.progress["ext"]["win_flowersext"].state =  private.win_flowersext_state;
       private.win_flowers_stand_on_pos(); 
       ObjAnimate( "obj_barnentranceext_mmg_anim_root", 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );
    end;
    
    ld.Lock(1);
    ObjAnimate( "obj_barnentranceext_mmg_anim_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
  end;
  
end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_exittopubext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_opencannedext_zone_clk()  --rm_farmext.use_opencannedext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_opencannedext' );
    ObjSet( "anm_exittopubext_anm_tavern", {animfunc = "static_dog", frame = 0, playing=1 } );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_dog_farmext" )
  ld.AnimPlay( "anm_exittopubext_anm_tavern", "idle_dog", func_end )
end;  


common_impl.hint[ "use_opencannedext" ] = { type = "use", inv_obj = "inv_opencannedext", use_place = "gfx_exittopubext_opencannedext_zone", room = "rm_farmext", zz = "zz_exittopubext", zz_gate = "gzz_farmext_exittopubext" };

private.use_opencannedext_logic = function()
  ObjSet( "grm_farmext_nearpubext", { visible = 1, input = 1, active = 1 } )
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_farmext_nearpubext_focus");
    end;
end;
private.use_opencannedext_inv = function()
  common_impl.ProcessMultiUseAll("opencannedext", "opencannedext")
end;
private.use_opencannedext_beg = function()
  ObjDelete( "gfx_exittopubext_opencannedext_zone" );
end;
private.use_opencannedext_end = function()
  if common_impl.ZzCompleteCheck("use_opencannedext") then ObjSet( common_impl.hint["use_opencannedext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_exittopubext_anm_tavern");
  ObjDelete("spr_farmext_leg1");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_opencannedext", private.use_opencannedext_inv );
cmn.AddSubscriber( "use_opencannedext", private.use_opencannedext_beg, private.room_objname );
cmn.AddSubscriber( "use_opencannedext", private.use_opencannedext_end, private.room_objname );
cmn.AddSubscriber( "use_opencannedext", private.use_opencannedext_logic );
cmn.AddSubscriber( "use_opencannedext_inv", private.use_opencannedext_inv, private.room_objname );
cmn.AddSubscriber( "use_opencannedext_beg", private.use_opencannedext_beg, private.room_objname );
cmn.AddSubscriber( "use_opencannedext_end", private.use_opencannedext_end, private.room_objname );
cmn.AddSubscriber( "use_opencannedext_end", private.use_opencannedext_logic );
--------------------------------------------------------------------------------------------
function public.use_opencannedext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_opencannedext" );
    cmn.CallEventHandler( "use_opencannedext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_opencannedext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_opencannedext_inv" );
  cmn.CallEventHandler( "use_opencannedext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_exittopubext_anm_tavern", "use_meath", func_end )
  SoundSfx( "aud_use_opencannedext_farmext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_gatespondext_for_farmext = function()
    if ld.CheckRequirements( {"win_gatespondext"} ) then
      ObjSet( "gmg_farmext_gatespondext", {input = 0, visible = 0} );
      ObjSet( "grm_farmext_pondext", {input = 1,active = 1, visible = 1} );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_farmext_pondext_focus");
      end;
    end
  end;
  cmn.AddSubscriber("win_gatespondext", win_gatespondext_for_farmext, private.room_objname )
----------------------------------------------------------------  
  local win_gatespondextinfarmext = function()
    ObjSet( "anm_farmext_anm_farm_open_pond", {animfunc = "open_pond", frame = 999 } );
  end;
  cmn.AddSubscriber("win_gatespondextinfarmext", win_gatespondextinfarmext, private.room_objname )
  
  function public.win_gatespondextinfarmext()
    local func_end = function()
      ld.Lock(0);
      cmn.SetEventDone( "win_gatespondextinfarmext" );
      cmn.CallEventHandler( "win_gatespondextinfarmext" );
    end;  
    
    ld.Lock(1);
    SoundSfx( "aud_open_gate_gatespondext" );
    ld.AnimPlay( "anm_farmext_anm_farm_open_pond", "open_pond", func_end )
  end;  
-----------------------------------------------------------------  
  

  local win_bomboneext_for_farmext = function()
    if ld.CheckRequirements( {"win_bomboneext","get_partswitchext3","get_bombmapext"} ) then
      ObjSet( "gmg_farmext_bomboneext", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_gatespondext", win_bomboneext_for_farmext, private.room_objname )
  cmn.AddSubscriber("get_partswitchext3", win_bomboneext_for_farmext, private.room_objname )
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_farmext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_farmext_env" )
  
  if cmn.IsEventDone("get_bombmapext") and not cmn.IsEventDone("clk_anmbombext1") then 
     levelext_inv.opnbombmapext_win_open();
  end;  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_exittopubext" );
  function zz_exittopubext.Open()
  end;
  function zz_exittopubext.PreOpen()
  end;
  function zz_exittopubext.PreClose()
  end;
  function zz_exittopubext.Close()
  end;

  subroom.Define( "zz_barnentranceext" );
  function zz_barnentranceext.Open()
  end;
  function zz_barnentranceext.PreOpen()
     private.win_flowers_get_first_pos();
     if cmn.IsEventStart("win_flowersext") and not cmn.IsEventDone("win_flowersext") then 
        cmn.MiniGameShow( "flowersext" ); 
        private.init_flowersext();
     end;  
  end;
  function zz_barnentranceext.PreClose()
  end;
  function zz_barnentranceext.Close()
    if cmn.IsEventStart("win_flowersext") and not cmn.IsEventDone("win_flowersext") then 
       cmn.MiniGameHide( "flowersext" ); 
    end; 
  end;

  subroom.Define( "zz_harvesterext" );
  function zz_harvesterext.Open()
  end;
  function zz_harvesterext.PreOpen()
  end;
  function zz_harvesterext.PreClose()
  end;
  function zz_harvesterext.Close()
  end;

  subroom.Define( "zz_exittopondext" );
  function zz_exittopondext.Open()
  end;
  function zz_exittopondext.PreOpen()
  end;
  function zz_exittopondext.PreClose()
  end;
  function zz_exittopondext.Close()
  end;

  subroom.Define( "zz_wellext" );
  function zz_wellext.Open()
  end;
  function zz_wellext.PreOpen()
  end;
  function zz_wellext.PreClose()
  end;
  function zz_wellext.Close()
  end;
  
end;
--*********************************************************************************************************************
------------------------------ other funcs ---------------------------------------------
function public.farmext_click_zone_clk()
  local func_end = function()
    ObjSet( "obj_farmext_click_zone", {input = 1} );  
  end;

  SoundSfx( "aud_touch_antenn_farmext" );
  ObjSet( "obj_farmext_click_zone", {input = 0} );  
  ld.AnimPlay( "anm_farmext_anm_farm_click", "click", func_end )
end;  