-- name=rm_inhouseext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_inhouseext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_inhouseext()
  local func_end = function()
      SoundVoice( 0 );
      cmn.SetEventDone( "opn_inhouseext" );
      cmn.CallEventHandler( "opn_inhouseext" )
    ObjSet( "rm_inhouseext", {color_r = 1, color_g = 1, color_b = 1} );
    local widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu,
      InterfaceWidget_BtnMap
      
    }

    for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], true, 1 );
    end;
    int.DialogVideoHide();
    ld.ShowBbt("afterintro");
     SoundEnv( "aud_inhouseext_env" )
     SoundEnv("aud_inhouseext_tv_env",1)
    SoundTheme( "aud_danger_moment2_mus" ) 
    --interface.KeyTaskAdd( "leveltask_ce_1", true, function () end );
  end;
  if not ( cmn.IsEventDone( "opn_inhouseext" ) ) then
    int.DialogVideoShow( "vid_inhouseext_vid_intro", 1, func_end );
    SoundVid( "aud_intro_ext" )
    VidPlay("vid_inhouseext_vid_intro",func_end)
    SoundVoice( "aud_intro_ext_voc" );
  end;
end;
--------------------------------------------------------------------
local opn_inhouseext = function() end;
local opn_inhouseext_logic = function() end;
cmn.AddSubscriber( "opn_inhouseext", opn_inhouseext_logic )
cmn.AddSubscriber( "opn_inhouseext", opn_inhouseext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_nightstandext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_nightstandext_doorext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_ladybugext' ); 
  end;
  
  ld.Lock(1);
   SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_nightstandext_anm_doorext", "idle_door", func_end );
end; 
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "use_ladybugext" ] = { type = "use", inv_obj = "inv_ladybugext", use_place = "gfx_nightstandext_ladybugext_zone", room = "rm_inhouseext", zz = "zz_nightstandext", zz_gate = "gzz_inhouseext_nightstandext" };

private.use_ladybugext_logic = function()
  ObjSet( "spr_nightstandext_batteryext1", { input = 1, active = 1,visible = 1 } )

end;
private.use_ladybugext_inv = function()
  common_impl.ProcessMultiUseAll("ladybugext", "ladybugext")
end;
private.use_ladybugext_beg = function()
  ObjDelete( "gfx_nightstandext_ladybugext_zone" );
end;
private.use_ladybugext_end = function()
  if common_impl.ZzCompleteCheck("use_ladybugext") then ObjSet( common_impl.hint["use_ladybugext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_nightstandext_anm_doorext", {animfunc = "end_door2", frame = 0 } );
  --  ObjDelete("anm_nightstandext_anm_use_bugext");
  
  ObjSet( "spr_nightstandext_batteryext1_sh", {visible = 1} );
  ObjDelete("spr_inhouseext_tr_16");
  ObjSet( "spr_inhouseext_tr_15", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ladybugext", private.use_ladybugext_inv );
cmn.AddSubscriber( "use_ladybugext", private.use_ladybugext_beg, private.room_objname );
cmn.AddSubscriber( "use_ladybugext", private.use_ladybugext_end, private.room_objname );
cmn.AddSubscriber( "use_ladybugext", private.use_ladybugext_logic );
cmn.AddSubscriber( "use_ladybugext_inv", private.use_ladybugext_inv, private.room_objname );
cmn.AddSubscriber( "use_ladybugext_beg", private.use_ladybugext_beg, private.room_objname );
cmn.AddSubscriber( "use_ladybugext_end", private.use_ladybugext_end, private.room_objname );
cmn.AddSubscriber( "use_ladybugext_end", private.use_ladybugext_logic );
--------------------------------------------------------------------------------------------
function public.use_ladybugext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ladybugext" );
    cmn.CallEventHandler( "use_ladybugext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_ladybugext") then ld.CloseSubRoom() end;
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ladybugext_inv" );
  cmn.CallEventHandler( "use_ladybugext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_nightstandext_anm_doorext", "open_door", func_end );
  SoundSfx( "aud_use_ladybugext_inhouseext" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_batteryext1" ] = { type = "get", get_obj = "spr_nightstandext_batteryext1", room = "rm_inhouseext", zz = "zz_nightstandext", zz_gate = "gzz_inhouseext_nightstandext" };

private.get_batteryext1_logic = function()
  
end;
private.get_batteryext1_inv = function()
  interface.InventoryItemAdd("inv_batteryext1","spr_nightstandext_batteryext1");
end;
private.get_batteryext1_beg = function()
  ObjDelete("gfx_nightstandext_batteryext1");
  ObjDelete("spr_nightstandext_batteryext1_sh");
end;
private.get_batteryext1_end = function()
  if common_impl.ZzCompleteCheck("get_batteryext1") then ObjSet( common_impl.hint["get_batteryext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_inhouseext_tr_22");
end;

cmn.AddSubscriber( "get_batteryext1", private.get_batteryext1_inv );
cmn.AddSubscriber( "get_batteryext1", private.get_batteryext1_beg, private.room_objname );
cmn.AddSubscriber( "get_batteryext1", private.get_batteryext1_end, private.room_objname );
cmn.AddSubscriber( "get_batteryext1", private.get_batteryext1_logic );
--------------------------------------------------------------------
function public.get_batteryext1()
  cmn.SetEventDone( "get_batteryext1" );
  cmn.CallEventHandler( "get_batteryext1" );
  if common_impl.ZzCompleteCheck("get_batteryext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_nightstandext_boxext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_decorpartext' ); 
  end;
  
  ld.Lock(1);
   SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_nightstandext_anm_boxext", "idle_door1", func_end );
end; 
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "use_decorpartext" ] = { type = "use", inv_obj = "inv_decorpartext", use_place = "gfx_nightstandext_decorpartext_zone", room = "rm_inhouseext", zz = "zz_nightstandext", zz_gate = "gzz_inhouseext_nightstandext" };

private.use_decorpartext_logic = function()
  ObjSet( "spr_nightstandext_crowbarext", {  input = 1, active = 1, visible = 1 } )

end;
private.use_decorpartext_inv = function()
  common_impl.ProcessMultiUseAll("decorpartext", "decorpartext")
end;
private.use_decorpartext_beg = function()
  ObjDelete( "gfx_nightstandext_decorpartext_zone" );
end;
private.use_decorpartext_end = function()
  if common_impl.ZzCompleteCheck("use_decorpartext") then ObjSet( common_impl.hint["use_decorpartext"].zz_gate, { visible = 0, input = 0 } ); end;
  -- ObjDelete("obj_anm_decorpartext");
  ObjSet( "anm_nightstandext_anm_boxext", {animfunc = "end_door1", frame = 0 } );
  ObjSet( "spr_nightstandext_crowbarext_sh", {visible = 1} );
  ObjDelete("spr_inhouseext_tr_14");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_decorpartext", private.use_decorpartext_inv );
cmn.AddSubscriber( "use_decorpartext", private.use_decorpartext_beg, private.room_objname );
cmn.AddSubscriber( "use_decorpartext", private.use_decorpartext_end, private.room_objname );
cmn.AddSubscriber( "use_decorpartext", private.use_decorpartext_logic );
cmn.AddSubscriber( "use_decorpartext_inv", private.use_decorpartext_inv, private.room_objname );
cmn.AddSubscriber( "use_decorpartext_beg", private.use_decorpartext_beg, private.room_objname );
cmn.AddSubscriber( "use_decorpartext_end", private.use_decorpartext_end, private.room_objname );
cmn.AddSubscriber( "use_decorpartext_end", private.use_decorpartext_logic );
--------------------------------------------------------------------------------------------
function public.use_decorpartext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_decorpartext" );
    cmn.CallEventHandler( "use_decorpartext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_decorpartext") then ld.CloseSubRoom() end;
  end;
  
  local func_preend = function()
    ObjSet( "obj_anm_decorpartext", {visible = 0} ); 
    ld.AnimPlay( "anm_nightstandext_anm_boxext", "open_door1", func_end );
    
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_decorpartext_inv" );
  cmn.CallEventHandler( "use_decorpartext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_nightstandext_anm_boxext", "use_am1", func_preend );
  SoundSfx( "aud_use_decorpartext_inhouseext" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_crowbarext" ] = { type = "get", get_obj = "spr_nightstandext_crowbarext", room = "rm_inhouseext", zz = "zz_nightstandext", zz_gate = "gzz_inhouseext_nightstandext" };

private.get_crowbarext_logic = function()
  
end;
private.get_crowbarext_inv = function()
  interface.InventoryItemAdd("inv_crowbarext","spr_nightstandext_crowbarext");
end;
private.get_crowbarext_beg = function()
  ObjDelete("gfx_nightstandext_crowbarext");
  ObjDelete("spr_nightstandext_crowbarext_sh");
end;
private.get_crowbarext_end = function()
  if common_impl.ZzCompleteCheck("get_crowbarext") then ObjSet( common_impl.hint["get_crowbarext"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjSet( "anm_nightstandext_anm_boxext", {animfunc = "end_door1", frame = 0 } );
  ObjDelete("spr_inhouseext_tr_21");
end;

cmn.AddSubscriber( "get_crowbarext", private.get_crowbarext_inv );
cmn.AddSubscriber( "get_crowbarext", private.get_crowbarext_beg, private.room_objname );
cmn.AddSubscriber( "get_crowbarext", private.get_crowbarext_end, private.room_objname );
cmn.AddSubscriber( "get_crowbarext", private.get_crowbarext_logic );
--------------------------------------------------------------------
function public.get_crowbarext()
  --ObjSet( "anm_nightstandext_anm_boxext", {animfunc = "end_door1", frame = 0 } );
  cmn.SetEventDone( "get_crowbarext" );
  cmn.CallEventHandler( "get_crowbarext" );
  if common_impl.ZzCompleteCheck("get_crowbarext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_entresolext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_batteryext2" ] = { type = "get", get_obj = "spr_entresolext_batteryext2", room = "rm_inhouseext", zz = "zz_entresolext", zz_gate = "gzz_inhouseext_entresolext" };

private.get_batteryext2_logic = function()
  
end;
private.get_batteryext2_inv = function()
  interface.InventoryItemAdd("inv_batteryext2","spr_entresolext_batteryext2");
end;
private.get_batteryext2_beg = function()
  ObjDelete("gfx_entresolext_batteryext2");
  ObjDelete("spr_entresolext_batteryext2_sh");
end;
private.get_batteryext2_end = function()
  if common_impl.ZzCompleteCheck("get_batteryext2") then ObjSet( common_impl.hint["get_batteryext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_inhouseext_tr_4");
end;

cmn.AddSubscriber( "get_batteryext2", private.get_batteryext2_inv );
cmn.AddSubscriber( "get_batteryext2", private.get_batteryext2_beg, private.room_objname );
cmn.AddSubscriber( "get_batteryext2", private.get_batteryext2_end, private.room_objname );
cmn.AddSubscriber( "get_batteryext2", private.get_batteryext2_logic );
--------------------------------------------------------------------
function public.get_batteryext2()
  cmn.SetEventDone( "get_batteryext2" );
  cmn.CallEventHandler( "get_batteryext2" );
  if common_impl.ZzCompleteCheck("get_batteryext2") then ld.CloseSubRoom() end;
end

--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_entresolext_handlerhombusext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_handlerhombusext' ); 
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_entresolext_handlerhombusext_anm", "idle_cover3", func_end );
end; 
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "use_handlerhombusext" ] = { type = "use", inv_obj = "inv_handlerhombusext", use_place = "gfx_entresolext_handlerhombusext_zone", room = "rm_inhouseext", zz = "zz_entresolext", zz_gate = "gzz_inhouseext_entresolext" };

private.use_handlerhombusext_logic = function()
  ObjSet( "spr_entresolext_nippersext", { visible = 1, input = 1, active = 1 } )

end;
private.use_handlerhombusext_inv = function()
  common_impl.ProcessMultiUseAll("handlerhombusext", "handlerhombusext")
end;
private.use_handlerhombusext_beg = function()
  ObjDelete( "gfx_entresolext_handlerhombusext_zone" );
end;
private.use_handlerhombusext_end = function()
  if common_impl.ZzCompleteCheck("use_handlerhombusext") then ObjSet( common_impl.hint["use_handlerhombusext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_entresolext_handlerhombusext_anm", {animfunc = "end3", frame = 0 } );
  ObjSet( "spr_entresolext_nippersext_sh", {visible = 1} );
  ObjDelete("spr_inhouseext_tr_9")
  ObjSet( "spr_inhouseext_tr_6", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_handlerhombusext", private.use_handlerhombusext_inv );
cmn.AddSubscriber( "use_handlerhombusext", private.use_handlerhombusext_beg, private.room_objname );
cmn.AddSubscriber( "use_handlerhombusext", private.use_handlerhombusext_end, private.room_objname );
cmn.AddSubscriber( "use_handlerhombusext", private.use_handlerhombusext_logic );
cmn.AddSubscriber( "use_handlerhombusext_inv", private.use_handlerhombusext_inv, private.room_objname );
cmn.AddSubscriber( "use_handlerhombusext_beg", private.use_handlerhombusext_beg, private.room_objname );
cmn.AddSubscriber( "use_handlerhombusext_end", private.use_handlerhombusext_end, private.room_objname );
cmn.AddSubscriber( "use_handlerhombusext_end", private.use_handlerhombusext_logic );
--------------------------------------------------------------------------------------------
function public.use_handlerhombusext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_handlerhombusext" );
    cmn.CallEventHandler( "use_handlerhombusext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_handlerhombusext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_handlerhombusext_inv" );
  cmn.CallEventHandler( "use_handlerhombusext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_entresolext_handlerhombusext_anm", "use_key3", func_end );
  SoundSfx( "aud_use_handle_inhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_nippersext" ] = { type = "get", get_obj = "spr_entresolext_nippersext", room = "rm_inhouseext", zz = "zz_entresolext", zz_gate = "gzz_inhouseext_entresolext" };

private.get_nippersext_logic = function()
  
end;
private.get_nippersext_inv = function()
  interface.InventoryItemAdd("inv_nippersext","spr_entresolext_nippersext");
end;
private.get_nippersext_beg = function()
  ObjDelete("gfx_entresolext_nippersext");
  ObjDelete("spr_entresolext_nippersext_sh");
end;
private.get_nippersext_end = function()
  if common_impl.ZzCompleteCheck("get_nippersext") then ObjSet( common_impl.hint["get_nippersext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_inhouseext_tr_3")
end;

cmn.AddSubscriber( "get_nippersext", private.get_nippersext_inv );
cmn.AddSubscriber( "get_nippersext", private.get_nippersext_beg, private.room_objname );
cmn.AddSubscriber( "get_nippersext", private.get_nippersext_end, private.room_objname );
cmn.AddSubscriber( "get_nippersext", private.get_nippersext_logic );
--------------------------------------------------------------------
function public.get_nippersext()
  cmn.SetEventDone( "get_nippersext" );
  cmn.CallEventHandler( "get_nippersext" );
  if common_impl.ZzCompleteCheck("get_nippersext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_entresolext_handlecircleext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_handlecircleext' ); 
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_entresolext_handlecircleext_anm", "idle_cover2", func_end );
end; 
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------

common_impl.hint[ "use_handlecircleext" ] = { type = "use", inv_obj = "inv_handlecircleext", use_place = "gfx_entresolext_handlecircleext_zone", room = "rm_inhouseext", zz = "zz_entresolext", zz_gate = "gzz_inhouseext_entresolext" };

private.use_handlecircleext_logic = function()
  ObjSet( "spr_entresolext_partswitchext1", { visible = 1, input = 1, active = 1 } )

end;
private.use_handlecircleext_inv = function()
  common_impl.ProcessMultiUseAll("handlecircleext", "handlecircleext")
end;
private.use_handlecircleext_beg = function()
  ObjDelete( "gfx_entresolext_handlecircleext_zone" );
end;
private.use_handlecircleext_end = function()
  if common_impl.ZzCompleteCheck("use_handlecircleext") then ObjSet( common_impl.hint["use_handlecircleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_entresolext_handlecircleext_anm", {animfunc = "end2", frame = 0 } );
  ObjSet( "spr_entresolext_partswitchext1_sh", {visible = 1} );
  ObjDelete("spr_inhouseext_tr_10");
  ObjSet( "spr_inhouseext_tr_7", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_handlecircleext", private.use_handlecircleext_inv );
cmn.AddSubscriber( "use_handlecircleext", private.use_handlecircleext_beg, private.room_objname );
cmn.AddSubscriber( "use_handlecircleext", private.use_handlecircleext_end, private.room_objname );
cmn.AddSubscriber( "use_handlecircleext", private.use_handlecircleext_logic );
cmn.AddSubscriber( "use_handlecircleext_inv", private.use_handlecircleext_inv, private.room_objname );
cmn.AddSubscriber( "use_handlecircleext_beg", private.use_handlecircleext_beg, private.room_objname );
cmn.AddSubscriber( "use_handlecircleext_end", private.use_handlecircleext_end, private.room_objname );
cmn.AddSubscriber( "use_handlecircleext_end", private.use_handlecircleext_logic );
--------------------------------------------------------------------------------------------
function public.use_handlecircleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_handlecircleext" );
    cmn.CallEventHandler( "use_handlecircleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_handlecircleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_handlecircleext_inv" );
  cmn.CallEventHandler( "use_handlecircleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_entresolext_handlecircleext_anm", "use_key2", func_end );
  SoundSfx( "aud_use_handle_inhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_partswitchext1" ] = { type = "get", get_obj = "spr_entresolext_partswitchext1", room = "rm_inhouseext", zz = "zz_entresolext", zz_gate = "gzz_inhouseext_entresolext" };

private.get_partswitchext1_logic = function()
  
end;
private.get_partswitchext1_inv = function()
  interface.InventoryItemAdd("inv_partswitchext","spr_entresolext_partswitchext1",function() level_inv.ProcessGetPartswitchextAll( "get_partswitchext1" ) end);
end;
private.get_partswitchext1_beg = function()
  ObjDelete("gfx_entresolext_partswitchext1");
  ObjDelete("spr_entresolext_partswitchext1_sh");
end;
private.get_partswitchext1_end = function()
  if common_impl.ZzCompleteCheck("get_partswitchext1") then ObjSet( common_impl.hint["get_partswitchext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_inhouseext_tr_1")
end;

cmn.AddSubscriber( "get_partswitchext1", private.get_partswitchext1_inv );
cmn.AddSubscriber( "get_partswitchext1", private.get_partswitchext1_beg, private.room_objname );
cmn.AddSubscriber( "get_partswitchext1", private.get_partswitchext1_end, private.room_objname );
cmn.AddSubscriber( "get_partswitchext1", private.get_partswitchext1_logic );
--------------------------------------------------------------------
function public.get_partswitchext1()
  cmn.SetEventDone( "get_partswitchext1" );
  cmn.CallEventHandler( "get_partswitchext1" );
  if common_impl.ZzCompleteCheck("get_partswitchext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_entresolext_handlesquareext_idle()

  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_handlesquareext' ); 
  end;
  
  ld.Lock(1);
   SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_entresolext_handlesquareext_anm", "idle_cover1", func_end );
end; 
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_handlesquareext" ] = { type = "use", inv_obj = "inv_handlesquareext", use_place = "gfx_entresolext_handlesquareext_zone", room = "rm_inhouseext", zz = "zz_entresolext", zz_gate = "gzz_inhouseext_entresolext" };

private.use_handlesquareext_logic = function()
  ObjSet( "spr_entresolext_magnetext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_entresolext_partswitchext2", { visible = 1, input = 1, active = 1 } )

end;
private.use_handlesquareext_inv = function()
  common_impl.ProcessMultiUseAll("handlesquareext", "handlesquareext")
end;
private.use_handlesquareext_beg = function()
  ObjDelete( "gfx_entresolext_handlesquareext_zone" );
end;
private.use_handlesquareext_end = function()
  if common_impl.ZzCompleteCheck("use_handlesquareext") then ObjSet( common_impl.hint["use_handlesquareext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_entresolext_handlesquareext_anm", {animfunc = "end1", frame = 0 } );
  ObjSet( "spr_entresolext_magnetext_sh", {visible = 1} );
  ObjSet( "spr_entresolext_partswitchext2_sh", {visible = 1} );
  ObjDelete("spr_inhouseext_tr_11");
  ObjSet("spr_inhouseext_tr_8",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_handlesquareext", private.use_handlesquareext_inv );
cmn.AddSubscriber( "use_handlesquareext", private.use_handlesquareext_beg, private.room_objname );
cmn.AddSubscriber( "use_handlesquareext", private.use_handlesquareext_end, private.room_objname );
cmn.AddSubscriber( "use_handlesquareext", private.use_handlesquareext_logic );
cmn.AddSubscriber( "use_handlesquareext_inv", private.use_handlesquareext_inv, private.room_objname );
cmn.AddSubscriber( "use_handlesquareext_beg", private.use_handlesquareext_beg, private.room_objname );
cmn.AddSubscriber( "use_handlesquareext_end", private.use_handlesquareext_end, private.room_objname );
cmn.AddSubscriber( "use_handlesquareext_end", private.use_handlesquareext_logic );
--------------------------------------------------------------------------------------------
function public.use_handlesquareext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_handlesquareext" );
    cmn.CallEventHandler( "use_handlesquareext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_handlesquareext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_handlesquareext_inv" );
  cmn.CallEventHandler( "use_handlesquareext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_entresolext_handlesquareext_anm", "use_key1", func_end );
  SoundSfx( "aud_use_handle_inhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_magnetext" ] = { type = "get", get_obj = "spr_entresolext_magnetext", room = "rm_inhouseext", zz = "zz_entresolext", zz_gate = "gzz_inhouseext_entresolext" };

private.get_magnetext_logic = function()
  
end;
private.get_magnetext_inv = function()
  interface.InventoryItemAdd("inv_magnetext","spr_entresolext_magnetext");
end;
private.get_magnetext_beg = function()
  ObjDelete("gfx_entresolext_magnetext");
  ObjDelete("spr_entresolext_magnetext_sh");
end;
private.get_magnetext_end = function()
  if common_impl.ZzCompleteCheck("get_magnetext") then ObjSet( common_impl.hint["get_magnetext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_inhouseext_tr_5");
end;

cmn.AddSubscriber( "get_magnetext", private.get_magnetext_inv );
cmn.AddSubscriber( "get_magnetext", private.get_magnetext_beg, private.room_objname );
cmn.AddSubscriber( "get_magnetext", private.get_magnetext_end, private.room_objname );
cmn.AddSubscriber( "get_magnetext", private.get_magnetext_logic );
--------------------------------------------------------------------
function public.get_magnetext()
  cmn.SetEventDone( "get_magnetext" );
  cmn.CallEventHandler( "get_magnetext" );
  if common_impl.ZzCompleteCheck("get_magnetext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_partswitchext2" ] = { type = "get", get_obj = "spr_entresolext_partswitchext2", room = "rm_inhouseext", zz = "zz_entresolext", zz_gate = "gzz_inhouseext_entresolext" };

private.get_partswitchext2_logic = function()
  
end;
private.get_partswitchext2_inv = function()
  interface.InventoryItemAdd("inv_partswitchext","spr_entresolext_partswitchext2",function() level_inv.ProcessGetPartswitchextAll( "get_partswitchext2" ) end);
end;
private.get_partswitchext2_beg = function()
  ObjDelete("gfx_entresolext_partswitchext2");
  ObjDelete("spr_entresolext_partswitchext2_sh");
end;
private.get_partswitchext2_end = function()
  if common_impl.ZzCompleteCheck("get_partswitchext2") then ObjSet( common_impl.hint["get_partswitchext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_inhouseext_tr_2");
end;

cmn.AddSubscriber( "get_partswitchext2", private.get_partswitchext2_inv );
cmn.AddSubscriber( "get_partswitchext2", private.get_partswitchext2_beg, private.room_objname );
cmn.AddSubscriber( "get_partswitchext2", private.get_partswitchext2_end, private.room_objname );
cmn.AddSubscriber( "get_partswitchext2", private.get_partswitchext2_logic );
--------------------------------------------------------------------
function public.get_partswitchext2()
  cmn.SetEventDone( "get_partswitchext2" );
  cmn.CallEventHandler( "get_partswitchext2" );
  if common_impl.ZzCompleteCheck("get_partswitchext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_undersofaext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_flashlightonext" ] = { type = "use", inv_obj = "inv_flashlightonext", use_place = "gfx_undersofaext_flashlightonext_zone", room = "rm_inhouseext", zz = "zz_undersofaext", zz_gate = "gzz_inhouseext_undersofaext" };

private.use_flashlightonext_logic = function()
  ObjSet( "spr_undersofaext_axeext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_undersofaext_childkeyext", { visible = 1, input = 1, active = 1 } )

end;
private.use_flashlightonext_inv = function()
  common_impl.ProcessMultiUseAll("flashlightonext", "flashlightonext")
end;
private.use_flashlightonext_beg = function()
  ObjDelete( "gfx_undersofaext_flashlightonext_zone" );
end;
private.use_flashlightonext_end = function()
  if common_impl.ZzCompleteCheck("use_flashlightonext") then ObjSet( common_impl.hint["use_flashlightonext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_undersofaext_flashlightonext_anm", {animfunc = "end_lamp", frame = 0 } );
  ObjSet( "spr_undersofaext_childkeyext_sh", {visible = 1} );
  ObjSet( "spr_undersofaext_axeext_sh", {visible = 1} );
  ObjSet( "spr_inhouseext_tr_20", {visible = 1} );
  ObjDelete("spr_inhouseext_tr_12")
  ObjSet( "spr_inhouseext_tr_17", {visible = 1} );
  ObjSet( "spr_inhouseext_tr_18", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_flashlightonext", private.use_flashlightonext_inv );
cmn.AddSubscriber( "use_flashlightonext", private.use_flashlightonext_beg, private.room_objname );
cmn.AddSubscriber( "use_flashlightonext", private.use_flashlightonext_end, private.room_objname );
cmn.AddSubscriber( "use_flashlightonext", private.use_flashlightonext_logic );
cmn.AddSubscriber( "use_flashlightonext_inv", private.use_flashlightonext_inv, private.room_objname );
cmn.AddSubscriber( "use_flashlightonext_beg", private.use_flashlightonext_beg, private.room_objname );
cmn.AddSubscriber( "use_flashlightonext_end", private.use_flashlightonext_end, private.room_objname );
cmn.AddSubscriber( "use_flashlightonext_end", private.use_flashlightonext_logic );
--------------------------------------------------------------------------------------------
function public.use_flashlightonext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_flashlightonext" );
    cmn.CallEventHandler( "use_flashlightonext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_flashlightonext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_flashlightonext_inv" );
  cmn.CallEventHandler( "use_flashlightonext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_undersofaext_flashlightonext_anm", "use_lamp", func_end );
  SoundSfx( "aud_use_flashlightonext_inhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_axeext" ] = { type = "get", get_obj = "spr_undersofaext_axeext", room = "rm_inhouseext", zz = "zz_undersofaext", zz_gate = "gzz_inhouseext_undersofaext" };

private.get_axeext_logic = function()
  
end;
private.get_axeext_inv = function()
  interface.InventoryItemAdd("inv_axeext","spr_undersofaext_axeext");
end;
private.get_axeext_beg = function()
  ObjDelete("gfx_undersofaext_axeext")
end;
private.get_axeext_end = function()
  if common_impl.ZzCompleteCheck("get_axeext") then ObjSet( common_impl.hint["get_axeext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_undersofaext_axeext_sh");
  ObjDelete("spr_inhouseext_tr_18");
end;

cmn.AddSubscriber( "get_axeext", private.get_axeext_inv );
cmn.AddSubscriber( "get_axeext", private.get_axeext_beg, private.room_objname );
cmn.AddSubscriber( "get_axeext", private.get_axeext_end, private.room_objname );
cmn.AddSubscriber( "get_axeext", private.get_axeext_logic );
--------------------------------------------------------------------
function public.get_axeext()
  cmn.SetEventDone( "get_axeext" );
  cmn.CallEventHandler( "get_axeext" );
  if common_impl.ZzCompleteCheck("get_axeext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_childkeyext" ] = { type = "get", get_obj = "spr_undersofaext_childkeyext", room = "rm_inhouseext", zz = "zz_undersofaext", zz_gate = "gzz_inhouseext_undersofaext" };

private.get_childkeyext_logic = function()
  
end;
private.get_childkeyext_inv = function()
  interface.InventoryItemAdd("inv_childkeyext","spr_undersofaext_childkeyext");
end;
private.get_childkeyext_beg = function()
  ObjDelete("gfx_undersofaext_childkeyext")
end;
private.get_childkeyext_end = function()
  if common_impl.ZzCompleteCheck("get_childkeyext") then ObjSet( common_impl.hint["get_childkeyext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_undersofaext_childkeyext_sh");
  ObjDelete("spr_inhouseext_tr_17")
end;

cmn.AddSubscriber( "get_childkeyext", private.get_childkeyext_inv );
cmn.AddSubscriber( "get_childkeyext", private.get_childkeyext_beg, private.room_objname );
cmn.AddSubscriber( "get_childkeyext", private.get_childkeyext_end, private.room_objname );
cmn.AddSubscriber( "get_childkeyext", private.get_childkeyext_logic );
--------------------------------------------------------------------
function public.get_childkeyext()
  cmn.SetEventDone( "get_childkeyext" );
  cmn.CallEventHandler( "get_childkeyext" );
  if common_impl.ZzCompleteCheck("get_childkeyext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pliersext" ] = { type = "use", inv_obj = "inv_pliersext", use_place = "gfx_undersofaext_pliersext_zone", room = "rm_inhouseext", zz = "zz_undersofaext", zz_gate = "gzz_inhouseext_undersofaext" };

private.use_pliersext_logic = function()
  ObjSet( "spr_undersofaext_decorpartext3", { visible = 1, input = 1, active = 1 } )

end;
private.use_pliersext_inv = function()
  common_impl.ProcessMultiUseAll("pliersext", "pliersext")
end;
private.use_pliersext_beg = function()
  ObjDelete( "gfx_undersofaext_pliersext_zone" );
end;
private.use_pliersext_end = function()
  if common_impl.ZzCompleteCheck("use_pliersext") then ObjSet( common_impl.hint["use_pliersext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_undersofaext_pliersext_anm", {animfunc = "cover_end", frame = 0 } );
  ObjSet( "spr_undersofaext_decorpartext3_sh", {visible = 1} );
  ObjDelete("spr_inhouseext_tr_13")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pliersext", private.use_pliersext_inv );
cmn.AddSubscriber( "use_pliersext", private.use_pliersext_beg, private.room_objname );
cmn.AddSubscriber( "use_pliersext", private.use_pliersext_end, private.room_objname );
cmn.AddSubscriber( "use_pliersext", private.use_pliersext_logic );
cmn.AddSubscriber( "use_pliersext_inv", private.use_pliersext_inv, private.room_objname );
cmn.AddSubscriber( "use_pliersext_beg", private.use_pliersext_beg, private.room_objname );
cmn.AddSubscriber( "use_pliersext_end", private.use_pliersext_end, private.room_objname );
cmn.AddSubscriber( "use_pliersext_end", private.use_pliersext_logic );
--------------------------------------------------------------------------------------------
function public.use_pliersext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pliersext" );
    cmn.CallEventHandler( "use_pliersext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pliersext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pliersext_inv" );
  cmn.CallEventHandler( "use_pliersext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_undersofaext_pliersext_anm", "use_pliers", function() ld.AnimPlay( "anm_undersofaext_pliersext_anm", "cover_open", func_end ); end );
  SoundSfx( "aud_use_pliersext_inhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_decorpartext3" ] = { type = "get", get_obj = "spr_undersofaext_decorpartext3", room = "rm_inhouseext", zz = "zz_undersofaext", zz_gate = "gzz_inhouseext_undersofaext" };

private.get_decorpartext3_logic = function()
  
end;
private.get_decorpartext3_inv = function()
  interface.InventoryItemAdd("inv_decorpartext","spr_undersofaext_decorpartext3",function() level_inv.ProcessGetDecorpartextAll( "get_decorpartext3" ) end);
end;
private.get_decorpartext3_beg = function()
  ObjDelete("gfx_undersofaext_decorpartext3")
end;
private.get_decorpartext3_end = function()
  if common_impl.ZzCompleteCheck("get_decorpartext3") then ObjSet( common_impl.hint["get_decorpartext3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_undersofaext_decorpartext3_sh")
  ObjDelete("spr_inhouseext_tr_19")
end;

cmn.AddSubscriber( "get_decorpartext3", private.get_decorpartext3_inv );
cmn.AddSubscriber( "get_decorpartext3", private.get_decorpartext3_beg, private.room_objname );
cmn.AddSubscriber( "get_decorpartext3", private.get_decorpartext3_end, private.room_objname );
cmn.AddSubscriber( "get_decorpartext3", private.get_decorpartext3_logic );
--------------------------------------------------------------------
function public.get_decorpartext3()
  cmn.SetEventDone( "get_decorpartext3" );
  cmn.CallEventHandler( "get_decorpartext3" );
  if common_impl.ZzCompleteCheck("get_decorpartext3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_inhouseext();
end;
--*********************************************************************************************************************
local inhouse_tv_sost=0;  
function public.PreOpen()
  
  ObjSet( "rm_inhouseext", {color_r = 1, color_g = 1, color_b = 1} );
  if not ld.CheckRequirements( {"opn_inhouseext"} ) then
    --levelext.SimonAdd();
    --interface.SimonGet();
    ObjSet( "rm_inhouseext", {color_r = 0, color_g = 0, color_b = 0} );
    local widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu,
      InterfaceWidget_BtnMap
    }

    for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], 0 );
    end;
  else 
    SoundEnv( "aud_inhouseext_env" )
    if inhouse_tv_sost==0 then SoundEnv("aud_inhouseext_tv_env",1) else SoundEnv("aud_inhouseext_tv_env",0) end;
  end  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_undersofaext" );
  function zz_undersofaext.Open()
  end;
  function zz_undersofaext.PreOpen()
  end;
  function zz_undersofaext.PreClose()
  end;
  function zz_undersofaext.Close()
  end;

  subroom.Define( "zz_entresolext" );
  function zz_entresolext.Open()
  end;
  function zz_entresolext.PreOpen()
  end;
  function zz_entresolext.PreClose()
  end;
  function zz_entresolext.Close()
  end;

  subroom.Define( "zz_nightstandext" );
  function zz_nightstandext.Open()
  end;
  function zz_nightstandext.PreOpen()
  end;
  function zz_nightstandext.PreClose()
  end;
  function zz_nightstandext.Close()
  end;
  
end;
--*********************************************************************************************************************
------------------------------------------------------other functions --------------------------------------------------------------
  --local inhouse_tv_sost=0;  
function public.inhouseext_tv_zone_clk()
  local func_end = function()
     ObjSet( "obj_inhpuseext_tv_clk_zone", {input = 1} );  
  end;

  ObjSet( "obj_inhpuseext_tv_clk_zone", {input = 0} );  
  if inhouse_tv_sost==0 then 
    ObjSet( "anm_inhouseext_anm_tv", {animfunc = "off_tv", frame = 0, playing=0 } );
    ld.AnimPlay( "anm_inhouseext_anm_tv", "off_tv", func_end )
    inhouse_tv_sost=1;
    SoundEnv("aud_inhouseext_tv_env",0)
    SoundSfx( "aud_tv_on_inhouseext" )
  else  
    SoundEnv("aud_inhouseext_tv_env",1)
    ObjSet( "anm_inhouseext_anm_tv", {animfunc = "cklik_tv", frame = 0, playing=1 } );
    inhouse_tv_sost=0;
    SoundSfx( "aud_tv_off_inhouseext" )
    func_end();
  end;  
end;  

-----------------------------------------------------------------------------------------------------
function public.inhouseext_right_cat_zone_clk()
  local func_end = function()
    ObjSet( "anm_inhouseext_anm_right_cat", {animfunc = "cat_rad_statick", frame = 0, playing=1 } );
    ObjSet( "obj_inhpuseext_right_cat_clk_zone", {input = 1} );
  end;  
  
  SoundSfx( "aud_touch_red_cat_inhouseext" );
  ObjSet( "obj_inhpuseext_right_cat_clk_zone", {input = 0} );
  ObjSet( "anm_inhouseext_anm_right_cat", {animfunc = "cat_rad_cklik", frame = 0, playing=0 } );
  ld.AnimPlay( "anm_inhouseext_anm_right_cat", "cat_rad_cklik", func_end )
end;  
-----------------------------------------------------------------------------------------------------
function public.inhouseext_left_cat_zone_clk()
  local func_end = function()
    ObjSet( "anm_inhouseext_anm_left_cat", {animfunc = "cat_blak_statik", frame = 0, playing=1 } );
    ObjSet( "obj_inhpuseext_left_cat_clk_zone", {input = 1} );
  end;  
  
  SoundSfx( "aud_touch_black_cat_inhouseext" );
  ObjSet( "obj_inhpuseext_left_cat_clk_zone", {input = 0} );
  ObjSet( "anm_inhouseext_anm_left_cat", {animfunc = "cat_blak_cklik", frame = 0, playing=0 } );
  ld.AnimPlay( "anm_inhouseext_anm_left_cat", "cat_blak_cklik", func_end )
end;  