-- name=rm_mallext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_mallext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_mallext()
  if not ( cmn.IsEventDone( "opn_mallext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_mallext" );
      cmn.CallEventHandler( "opn_mallext" )
      -- ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opnmallext");
      SoundTheme( "aud_danger_moment2_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_mallext = function() end;
local opn_mallext_logic = function() end;
cmn.AddSubscriber( "opn_mallext", opn_mallext_logic )
cmn.AddSubscriber( "opn_mallext", opn_mallext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_machinedrinksext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_gearext1" ] = { type = "get", get_obj = "spr_machinedrinksext_gearext1", room = "rm_mallext", zz = "zz_machinedrinksext", zz_gate = "gzz_mallext_machinedrinksext" };

private.get_gearext1_logic = function()
  ObjSet( "gfx_machinedrinksext_glasscutterext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_gearext1_inv = function()
  interface.InventoryItemAdd("inv_gearext1","spr_machinedrinksext_gearext1");
end;
private.get_gearext1_beg = function()
  ObjDelete("gfx_machinedrinksext_gearext1")
end;
private.get_gearext1_end = function()
  ObjDelete("spr_machinedrinksext_sh_gearext1")
  ObjDelete("spr_mallext_tr_cogwheel")
  if common_impl.ZzCompleteCheck("get_gearext1") then ObjSet( common_impl.hint["get_gearext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_gearext1", private.get_gearext1_inv );
cmn.AddSubscriber( "get_gearext1", private.get_gearext1_beg, private.room_objname );
cmn.AddSubscriber( "get_gearext1", private.get_gearext1_end, private.room_objname );
cmn.AddSubscriber( "get_gearext1", private.get_gearext1_logic );
--------------------------------------------------------------------
function public.get_gearext1()
  cmn.SetEventDone( "get_gearext1" );
  cmn.CallEventHandler( "get_gearext1" );
  if common_impl.ZzCompleteCheck("get_gearext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_glasscutterext" ] = { type = "use", inv_obj = "inv_glasscutterext", use_place = "gfx_machinedrinksext_glasscutterext_zone", room = "rm_mallext", zz = "zz_machinedrinksext", zz_gate = "gzz_mallext_machinedrinksext" };

private.use_glasscutterext_logic = function()
  ObjSet( "spr_machinedrinksext_alarmkeyfobext", { visible = 1, input = 1, active = 1 } )

end;
private.use_glasscutterext_inv = function()
  common_impl.ProcessMultiUseAll("glasscutterext", "glasscutterext")
end;
private.use_glasscutterext_beg = function()
  ObjDelete( "gfx_machinedrinksext_glasscutterext_zone" );
end;
private.use_glasscutterext_end = function()
  ObjSet( "spr_machinedrinksext_sh_alarmkeyfobext", {alp = 1} );
  ObjSet("anm_machinedrinksext_use_glasscutter",{animfunc="use_glasscutter1",frame=0})
  ObjSet( "anm_machinedrinksext_use_hairpin", {pos_z=7} );
  ObjSet( "spr_mallext_tr2_glass", {alp = 1} );
  ObjDelete("spr_mallext_tr1_glass")
  if common_impl.ZzCompleteCheck("use_glasscutterext") then ObjSet( common_impl.hint["use_glasscutterext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_glasscutterext", private.use_glasscutterext_inv );
cmn.AddSubscriber( "use_glasscutterext", private.use_glasscutterext_beg, private.room_objname );
cmn.AddSubscriber( "use_glasscutterext", private.use_glasscutterext_end, private.room_objname );
cmn.AddSubscriber( "use_glasscutterext", private.use_glasscutterext_logic );
cmn.AddSubscriber( "use_glasscutterext_inv", private.use_glasscutterext_inv, private.room_objname );
cmn.AddSubscriber( "use_glasscutterext_beg", private.use_glasscutterext_beg, private.room_objname );
cmn.AddSubscriber( "use_glasscutterext_end", private.use_glasscutterext_end, private.room_objname );
cmn.AddSubscriber( "use_glasscutterext_end", private.use_glasscutterext_logic );
--------------------------------------------------------------------------------------------
function public.use_glasscutterext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_glasscutterext" );
    cmn.CallEventHandler( "use_glasscutterext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_glasscutterext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_glasscutterext_inv" );
  cmn.CallEventHandler( "use_glasscutterext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_machinedrinksext_use_glasscutter", "use_glasscutter", func_end );
  SoundSfx( "aud_use_glasscutterext_mallext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_alarmkeyfobext" ] = { type = "get", get_obj = "spr_machinedrinksext_alarmkeyfobext", room = "rm_mallext", zz = "zz_machinedrinksext", zz_gate = "gzz_mallext_machinedrinksext" };

private.get_alarmkeyfobext_logic = function()
  
end;
private.get_alarmkeyfobext_inv = function()
  interface.InventoryItemAdd("inv_alarmkeyfobext","spr_machinedrinksext_alarmkeyfobext");
end;
private.get_alarmkeyfobext_beg = function()
  ObjDelete("gfx_machinedrinksext_alarmkeyfobext")
end;
private.get_alarmkeyfobext_end = function()
  ObjDelete("spr_machinedrinksext_sh_alarmkeyfobext")
  ObjDelete("spr_mallext_signaling")
  if common_impl.ZzCompleteCheck("get_alarmkeyfobext") then ObjSet( common_impl.hint["get_alarmkeyfobext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_alarmkeyfobext", private.get_alarmkeyfobext_inv );
cmn.AddSubscriber( "get_alarmkeyfobext", private.get_alarmkeyfobext_beg, private.room_objname );
cmn.AddSubscriber( "get_alarmkeyfobext", private.get_alarmkeyfobext_end, private.room_objname );
cmn.AddSubscriber( "get_alarmkeyfobext", private.get_alarmkeyfobext_logic );
--------------------------------------------------------------------
function public.get_alarmkeyfobext()
  cmn.SetEventDone( "get_alarmkeyfobext" );
  cmn.CallEventHandler( "get_alarmkeyfobext" );
  if common_impl.ZzCompleteCheck("get_alarmkeyfobext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hairpinext" ] = { type = "use", inv_obj = "inv_hairpinext", use_place = "gfx_machinedrinksext_hairpinext_zone", room = "rm_mallext", zz = "zz_machinedrinksext", zz_gate = "gzz_mallext_machinedrinksext" };

private.use_hairpinext_logic = function()
  ObjSet( "gho_mallext_sweetsext", { visible = 1, input = 1, active = 1 } )

end;
private.use_hairpinext_inv = function()
  common_impl.ProcessMultiUseAll("hairpinext", "hairpinext")
end;
private.use_hairpinext_beg = function()
  ObjDelete( "gfx_machinedrinksext_hairpinext_zone" );
end;
private.use_hairpinext_end = function()
  ObjSet( "anm_machinedrinksext_use_hairpin", {animfunc="use_hairpin1",frame=0} );
  ObjSet( "spr_mallext_tr_opendooravt", {alp = 1} );
  ObjDelete("spr_mallext_tr_closedooravt")
  if common_impl.ZzCompleteCheck("use_hairpinext") then ObjSet( common_impl.hint["use_hairpinext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hairpinext", private.use_hairpinext_inv );
cmn.AddSubscriber( "use_hairpinext", private.use_hairpinext_beg, private.room_objname );
cmn.AddSubscriber( "use_hairpinext", private.use_hairpinext_end, private.room_objname );
cmn.AddSubscriber( "use_hairpinext", private.use_hairpinext_logic );
cmn.AddSubscriber( "use_hairpinext_inv", private.use_hairpinext_inv, private.room_objname );
cmn.AddSubscriber( "use_hairpinext_beg", private.use_hairpinext_beg, private.room_objname );
cmn.AddSubscriber( "use_hairpinext_end", private.use_hairpinext_end, private.room_objname );
cmn.AddSubscriber( "use_hairpinext_end", private.use_hairpinext_logic );
--------------------------------------------------------------------------------------------
function public.use_hairpinext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hairpinext" );
    cmn.CallEventHandler( "use_hairpinext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hairpinext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hairpinext_inv" );
  cmn.CallEventHandler( "use_hairpinext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_machinedrinksext_use_hairpin", "use_hairpin", func_end );
  SoundSfx( "aud_use_hairpinext_mallext" )


end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bowlingext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_musicboxext" ] = { type = "get", get_obj = "spr_bowlingext_musicboxext", room = "rm_mallext", zz = "zz_bowlingext", zz_gate = "gzz_mallext_bowlingext" };

private.get_musicboxext_logic = function()
  ObjSet( "gfx_bowlingext_skittleext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_musicboxext_inv = function()
  interface.InventoryItemAdd("inv_musicboxext","spr_bowlingext_musicboxext");
  ObjSet( "inv_musicboxext", { drag = 0 } );
end;
private.get_musicboxext_beg = function()
  ObjDelete("gfx_bowlingext_musicboxext")
end;
private.get_musicboxext_end = function()
  ObjDelete("spr_bowlingext_musicboxext_sh")
  ObjDelete("spr_mallext_casket")
  if common_impl.ZzCompleteCheck("get_musicboxext") then ObjSet( common_impl.hint["get_musicboxext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_musicboxext", private.get_musicboxext_inv );
cmn.AddSubscriber( "get_musicboxext", private.get_musicboxext_beg, private.room_objname );
cmn.AddSubscriber( "get_musicboxext", private.get_musicboxext_end, private.room_objname );
cmn.AddSubscriber( "get_musicboxext", private.get_musicboxext_logic );
--------------------------------------------------------------------
function public.get_musicboxext()
  cmn.SetEventDone( "get_musicboxext" );
  cmn.CallEventHandler( "get_musicboxext" );
  if common_impl.ZzCompleteCheck("get_musicboxext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_skittleext" ] = { type = "use", inv_obj = "inv_skittleext", use_place = "gfx_bowlingext_skittleext_zone", room = "rm_mallext", zz = "zz_bowlingext", zz_gate = "gzz_mallext_bowlingext" };

private.use_skittleext_logic = function()
  ObjSet( "gfx_bowlingext_win_bowlingext_zone", { input = 1, active = 1 } )

end;
private.use_skittleext_inv = function()
  common_impl.ProcessMultiUseAll("skittleext", "skittleext")
end;
private.use_skittleext_beg = function()
  ObjDelete( "gfx_bowlingext_skittleext_zone" );
end;
private.use_skittleext_end = function()
  ObjSet("anm_bowlingext_anm",{animfunc="get_badgelightning1",frame=0})
  ObjSet( "obj_bowlingext_mmg_root", {alp = 1,input=1} );
  if common_impl.ZzCompleteCheck("use_skittleext") then ObjSet( common_impl.hint["use_skittleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_skittleext", private.use_skittleext_inv );
cmn.AddSubscriber( "use_skittleext", private.use_skittleext_beg, private.room_objname );
cmn.AddSubscriber( "use_skittleext", private.use_skittleext_end, private.room_objname );
cmn.AddSubscriber( "use_skittleext", private.use_skittleext_logic );
cmn.AddSubscriber( "use_skittleext_inv", private.use_skittleext_inv, private.room_objname );
cmn.AddSubscriber( "use_skittleext_beg", private.use_skittleext_beg, private.room_objname );
cmn.AddSubscriber( "use_skittleext_end", private.use_skittleext_end, private.room_objname );
cmn.AddSubscriber( "use_skittleext_end", private.use_skittleext_logic );
--------------------------------------------------------------------------------------------
function public.use_skittleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    private.init_bowlingext()
    cmn.MiniGameShow( "bowlingext" );    
    cmn.SetEventDone( "use_skittleext" );
    cmn.CallEventHandler( "use_skittleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_skittleext") then ld.CloseSubRoom() end;
  end;
  local f_step = function ()
    ObjAnimate( "obj_bowlingext_mmg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_skittleext_inv" );
  cmn.CallEventHandler( "use_skittleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bowlingext_anm", "use_skittle", f_step );
  SoundSfx( "aud_use_skittleext_mallext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_bowlingext" ] = { type = "click", use_place = "gfx_bowlingext_win_bowlingext_zone", room = "rm_mallext", zz = "zz_bowlingext", zz_gate = "gzz_mallext_bowlingext" };

private.win_bowlingext_logic = function()
  if cmn.IsEventDone("win_bowlingext") then
    ObjSet( "spr_bowlingext_badgelightningext", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_bowlingext_beg = function()
  if cmn.IsEventDone("win_bowlingext") then  
    ObjDelete( "gfx_bowlingext_win_bowlingext_zone" );
  end
end;
private.win_bowlingext_end = function()
  if cmn.IsEventDone("win_bowlingext") then
    ObjSet("anm_bowlingext_anm",{animfunc="get_badgelightning_end",frame=0})
    ObjSet( "anm_bowlingext_light_bomb", {animfunc="light_bomb_victory",playing=1} );
    ObjDelete("obj_bowlingext_mmg_root")
    ObjSet( "spr_bowlingext_badgelightning_sh", {alp = 1} );
    for i=1,3 do
      ObjSet("spr_bowlingext_light_"..i,{alp=1})
    end
    if common_impl.ZzCompleteCheck("win_bowlingext") then ObjSet( common_impl.hint["win_bowlingext"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
  
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_bowlingext", private.win_bowlingext_beg, private.room_objname );
cmn.AddSubscriber( "win_bowlingext", private.win_bowlingext_end, private.room_objname );
cmn.AddSubscriber( "win_bowlingext", private.win_bowlingext_logic );
cmn.AddSubscriber( "win_bowlingext_beg", private.win_bowlingext_beg, private.room_objname );
cmn.AddSubscriber( "win_bowlingext_end", private.win_bowlingext_end, private.room_objname );
cmn.AddSubscriber( "win_bowlingext_end", private.win_bowlingext_logic );
--------------------------------------------------------------------------------------------
function public.win_bowlingext()

  local func_end = function()
    cmn.SetEventDone( "win_bowlingext" );
    cmn.CallEventHandler( "win_bowlingext_beg" );
    cmn.CallEventHandler( "win_bowlingext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_bowlingext") then ld.CloseSubRoom() end;
    --  levelext_inv.opnbombmapext_win_open();
    SoundTheme( "aud_danger_moment1_mus" );
  end;

  cmn.CallEventHandler( "win_bowlingext_beg" );
  common_impl.Lock(1);
  ld.StartTimer( 0.5, function() cmn.MiniGameHide( "bowlingext",true );  end ) 
  ld.AnimPlay( "anm_bowlingext_anm", "get_badgelightning", func_end );
  SoundSfx( "aud_mg_bowlingext_strike" )  
  

end;
--------------------------------------------------------------------------------------------
function private.init_bowlingext()
  if not (cmn.IsEventStart("win_bowlingext")) then
    ng_global.progress["ext"]["win_bowlingext"].state = 0
  end
  private.load_bowlingext()
end
function public.clk_ball()
  private.start_anim = false 
  ObjAnimate( "spr_bowlingext_mmg_root_scale", 8, 0, 0, function()ObjSet("spr_bowlingext_ball_scale",{pos_x=-150})end, {0,0,1, 0.5,0,0} );
  ObjStopAnimate("spr_bowlingext_ball_scale","pos_x")
  local s = ng_global.progress["ext"]["win_bowlingext"].state
  ld.LogTrace(s)
  local x = ObjGet("spr_bowlingext_ball_scale").pos_x
  ld.Lock(1)
  ld.StartTimer( 0.8, function() SoundSfx( "aud_mg_bowlingext_mechanism" );  end )
  if x<-50 then
    SoundSfx( "aud_mg_bowlingext_spare" )
    ld.AnimPlay( "anm_bowlingext_anm", "left",function()ld.Lock(0);ObjAnimate( "spr_bowlingext_mmg_root_scale", 8, 0, 0, private.start_bowlingext, {0,0,0, 0.5,0,1} );end  );
  elseif x>50 then
    SoundSfx( "aud_mg_bowlingext_spare" )  
    ld.AnimPlay( "anm_bowlingext_anm", "right", function()ld.Lock(0);ObjAnimate( "spr_bowlingext_mmg_root_scale", 8, 0, 0, private.start_bowlingext, {0,0,0, 0.5,0,1} );end  );
  else 
    if s==2 then
      public.win_bowlingext()
      ObjAnimate( "spr_bowlingext_light_3", 8, 0, 0, "", {0,0,0, 0.5,0,1} );
      --ld.AnimPlay( "anm_bowlingext_anm", "get_badgelightning", function()ld.Lock(0);ld.LogTrace( "WIN" );end );
    else 
      
      SoundSfx( "aud_mg_bowlingext_strike" )  
      ng_global.progress["ext"]["win_bowlingext"].state = ng_global.progress["ext"]["win_bowlingext"].state + 1
      ObjAnimate( "spr_bowlingext_light_"..ng_global.progress["ext"]["win_bowlingext"].state, 8, 0, 0, "", {0,0,0, 0.5,0,1} );
      ld.AnimPlay( "anm_bowlingext_anm", "get_badgelightning1", function()ld.Lock(0); ObjAnimate( "spr_bowlingext_mmg_root_scale", 8, 0, 0, private.start_bowlingext, {0,0,0, 0.5,0,1} );end  );
    end
  end
end
function private.load_bowlingext()
  for i=1,ng_global.progress["ext"]["win_bowlingext"].state do
    ObjSet( "spr_bowlingext_light_"..i, {alp = 1} );
  end
  private.start_bowlingext()
end
function private.start_bowlingext()
  if not private.start_anim then
    private.start_anim = true
    ObjAnimate("spr_bowlingext_ball_scale","pos_x",1,0,"",{0,0,-150, 1,0,150,2,0,-150})
  end
end
function private.win_bowlingext_reset()
  ng_global.progress["ext"]["win_bowlingext"].state = 0
  for i=1,3 do
    ObjSet("spr_bowlingext_light_"..i,{alp=0})
  end
end
function private.win_bowlingext_skip()
  ObjAnimate( "spr_bowlingext_mmg_root_scale", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
  public.win_bowlingext()
end
--------------------------------------------------------------------
common_impl.hint[ "get_badgelightningext" ] = { type = "get", get_obj = "spr_bowlingext_badgelightningext", room = "rm_mallext", zz = "zz_bowlingext", zz_gate = "gzz_mallext_bowlingext" };

private.get_badgelightningext_logic = function()
  
end;
private.get_badgelightningext_inv = function()
  interface.InventoryItemAdd("inv_badgelightningext","spr_bowlingext_badgelightningext");
end;
private.get_badgelightningext_beg = function()
  ObjDelete("gfx_bowlingext_badgelightningext")
end;
private.get_badgelightningext_end = function()
  ObjDelete("spr_bowlingext_badgelightning_sh")
  if common_impl.ZzCompleteCheck("get_badgelightningext") then ObjSet( common_impl.hint["get_badgelightningext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_badgelightningext", private.get_badgelightningext_inv );
cmn.AddSubscriber( "get_badgelightningext", private.get_badgelightningext_beg, private.room_objname );
cmn.AddSubscriber( "get_badgelightningext", private.get_badgelightningext_end, private.room_objname );
cmn.AddSubscriber( "get_badgelightningext", private.get_badgelightningext_logic );
--------------------------------------------------------------------
function public.get_badgelightningext()
  cmn.SetEventDone( "get_badgelightningext" );
  cmn.CallEventHandler( "get_badgelightningext" );
  if common_impl.ZzCompleteCheck("get_badgelightningext") then ld.CloseSubRoom() end;
  levelext_inv.opnbombmapext_win_open();
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_serviceexitext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
function public.serviceexitext_handle_zone_clk()
  local func_end = function() 
    ld.Lock(0);
    ObjSet( "obj_serviceexitext_handle_clk_zone", {input=1} );
  end;  
  
  SoundSfx( "aud_touch_handle_mallext" );
  ObjSet( "obj_serviceexitext_handle_clk_zone", {input=0} );
  ld.AnimPlay( "anm_serviceexitext_anim_handle", "anim_handle", func_end )
end;
-------------------------------------------------------------------
common_impl.hint[ "get_skittleext1" ] = { type = "get", get_obj = "spr_serviceexitext_skittleext1", room = "rm_mallext", zz = "zz_serviceexitext", zz_gate = "gzz_mallext_serviceexitext" };

private.get_skittleext1_logic = function()
  
end;
private.get_skittleext1_inv = function()
  interface.InventoryItemAdd("inv_skittleext","spr_serviceexitext_skittleext1",function() level_inv.ProcessGetSkittleextAll( "get_skittleext1" ) end);
end;
private.get_skittleext1_beg = function()
  ObjDelete("gfx_serviceexitext_skittleext1")
end;
private.get_skittleext1_end = function()
  if common_impl.ZzCompleteCheck("get_skittleext1") then ObjSet( common_impl.hint["get_skittleext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_serviceexitext_skittleext1_shadow");
  ObjDelete("spr_mallext_tr_skittle");
  if cmn.IsEventDone("win_mechanismext") and cmn.IsEventDone("get_skittleext1") and ObjGet("spr_mallext_close_roomservice") then
    ObjSet( "grm_mallext_staffonlyext", {visible = 1, input = 1, active = 1} );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_mallext_staffonlyext_focus");
    end;
    ObjDelete("spr_mallext_close_roomservice");
    ObjSet( "spr_mallext_open_roomservice", {alp = 1} );
  end;
end;


cmn.AddSubscriber( "get_skittleext1", private.get_skittleext1_inv );
cmn.AddSubscriber( "get_skittleext1", private.get_skittleext1_beg, private.room_objname );
cmn.AddSubscriber( "get_skittleext1", private.get_skittleext1_end, private.room_objname );
cmn.AddSubscriber( "get_skittleext1", private.get_skittleext1_logic );
--------------------------------------------------------------------
function public.get_skittleext1()
  cmn.SetEventDone( "get_skittleext1" );
  cmn.CallEventHandler( "get_skittleext1" );
  if common_impl.ZzCompleteCheck("get_skittleext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_alarmkeyfobext" ] = { type = "use", inv_obj = "inv_alarmkeyfobext", use_place = "gfx_serviceexitext_alarmkeyfobext_zone", room = "rm_mallext", zz = "zz_serviceexitext", zz_gate = "gzz_mallext_serviceexitext" };

private.use_alarmkeyfobext_logic = function()
  ObjSet( "spr_serviceexitext_ringsinwaterext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_serviceexitext_hairpinext", { visible = 1, input = 1, active = 1 } )

end;
private.use_alarmkeyfobext_inv = function()
  common_impl.ProcessMultiUseAll("alarmkeyfobext", "alarmkeyfobext")
end;
private.use_alarmkeyfobext_beg = function()
  ObjDelete( "gfx_serviceexitext_alarmkeyfobext_zone" );
end;
private.use_alarmkeyfobext_end = function()
  ObjDelete("spr_mallext_tr1_signaling")
  if common_impl.ZzCompleteCheck("use_alarmkeyfobext") then ObjSet( common_impl.hint["use_alarmkeyfobext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_serviceexitext_anim_light", {animfunc = "anim_pult_end", frame = 0, playing=0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_alarmkeyfobext", private.use_alarmkeyfobext_inv );
cmn.AddSubscriber( "use_alarmkeyfobext", private.use_alarmkeyfobext_beg, private.room_objname );
cmn.AddSubscriber( "use_alarmkeyfobext", private.use_alarmkeyfobext_end, private.room_objname );
cmn.AddSubscriber( "use_alarmkeyfobext", private.use_alarmkeyfobext_logic );
cmn.AddSubscriber( "use_alarmkeyfobext_inv", private.use_alarmkeyfobext_inv, private.room_objname );
cmn.AddSubscriber( "use_alarmkeyfobext_beg", private.use_alarmkeyfobext_beg, private.room_objname );
cmn.AddSubscriber( "use_alarmkeyfobext_end", private.use_alarmkeyfobext_end, private.room_objname );
cmn.AddSubscriber( "use_alarmkeyfobext_end", private.use_alarmkeyfobext_logic );
--------------------------------------------------------------------------------------------
function public.use_alarmkeyfobext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_alarmkeyfobext" );
    cmn.CallEventHandler( "use_alarmkeyfobext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_alarmkeyfobext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_alarmkeyfobext_inv" );
  cmn.CallEventHandler( "use_alarmkeyfobext_beg" );
  common_impl.Lock(1);

  SoundEnv("aud_alarm_zz_mallext",0);
  ld.AnimPlay( "anm_serviceexitext_anim_light", "anim_pult", func_end );
  SoundSfx( "aud_use_alarmkeyfobext_mallext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ringsinwaterext" ] = { type = "get", get_obj = "spr_serviceexitext_ringsinwaterext", room = "rm_mallext", zz = "zz_serviceexitext", zz_gate = "gzz_mallext_serviceexitext" };

private.get_ringsinwaterext_logic = function()
  
end;
private.get_ringsinwaterext_inv = function()
  interface.InventoryItemAdd("inv_ringsinwaterext","spr_serviceexitext_ringsinwaterext");
  ObjSet( "inv_ringsinwaterext", { drag = 0 } );
end;
private.get_ringsinwaterext_beg = function()
  ObjDelete("gfx_serviceexitext_ringsinwaterext")
end;
private.get_ringsinwaterext_end = function()
  if common_impl.ZzCompleteCheck("get_ringsinwaterext") then ObjSet( common_impl.hint["get_ringsinwaterext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_serviceexitext_ringsinwaterext_shadow")
  ObjDelete("spr_mallext_ringwater")
end;

cmn.AddSubscriber( "get_ringsinwaterext", private.get_ringsinwaterext_inv );
cmn.AddSubscriber( "get_ringsinwaterext", private.get_ringsinwaterext_beg, private.room_objname );
cmn.AddSubscriber( "get_ringsinwaterext", private.get_ringsinwaterext_end, private.room_objname );
cmn.AddSubscriber( "get_ringsinwaterext", private.get_ringsinwaterext_logic );
--------------------------------------------------------------------
function public.get_ringsinwaterext()
  cmn.SetEventDone( "get_ringsinwaterext" );
  cmn.CallEventHandler( "get_ringsinwaterext" );
  if common_impl.ZzCompleteCheck("get_ringsinwaterext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hairpinext" ] = { type = "get", get_obj = "spr_serviceexitext_hairpinext", room = "rm_mallext", zz = "zz_serviceexitext", zz_gate = "gzz_mallext_serviceexitext" };

private.get_hairpinext_logic = function()
  
end;
private.get_hairpinext_inv = function()
  interface.InventoryItemAdd("inv_hairpinext","spr_serviceexitext_hairpinext");
end;
private.get_hairpinext_beg = function()
  ObjDelete("gfx_serviceexitext_hairpinext")
end;
private.get_hairpinext_end = function()
  if common_impl.ZzCompleteCheck("get_hairpinext") then ObjSet( common_impl.hint["get_hairpinext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_serviceexitext_hairpinext_shadow")
end;

cmn.AddSubscriber( "get_hairpinext", private.get_hairpinext_inv );
cmn.AddSubscriber( "get_hairpinext", private.get_hairpinext_beg, private.room_objname );
cmn.AddSubscriber( "get_hairpinext", private.get_hairpinext_end, private.room_objname );
cmn.AddSubscriber( "get_hairpinext", private.get_hairpinext_logic );
--------------------------------------------------------------------
function public.get_hairpinext()
  cmn.SetEventDone( "get_hairpinext" );
  cmn.CallEventHandler( "get_hairpinext" );
  if common_impl.ZzCompleteCheck("get_hairpinext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_gearext1" ] = { type = "use", inv_obj = "inv_gearext1", use_place = "gfx_serviceexitext_gearext1_zone", room = "rm_mallext", zz = "zz_serviceexitext", zz_gate = "gzz_mallext_serviceexitext" };

private.use_gearext1_logic = function()
  if ld.CheckRequirements( {"use_gearext1","use_gearext2"} ) then
    ObjSet( "gmg_mallext_mechanismext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_gearext1_inv = function()
  common_impl.ProcessMultiUseAll("gearext1", "gearext1")
end;
private.use_gearext1_beg = function()
  ObjDelete( "gfx_serviceexitext_gearext1_zone" );
end;
private.use_gearext1_end = function()
  if common_impl.ZzCompleteCheck("use_gearext1") then ObjSet( common_impl.hint["use_gearext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_serviceexitext_anim_cogwheel1", {animfunc = "anim_cogwheel1_end", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_gearext1", private.use_gearext1_inv );
cmn.AddSubscriber( "use_gearext1", private.use_gearext1_beg, private.room_objname );
cmn.AddSubscriber( "use_gearext1", private.use_gearext1_end, private.room_objname );
cmn.AddSubscriber( "use_gearext1", private.use_gearext1_logic );
cmn.AddSubscriber( "use_gearext1_inv", private.use_gearext1_inv, private.room_objname );
cmn.AddSubscriber( "use_gearext1_beg", private.use_gearext1_beg, private.room_objname );
cmn.AddSubscriber( "use_gearext1_end", private.use_gearext1_end, private.room_objname );
cmn.AddSubscriber( "use_gearext1_end", private.use_gearext1_logic );
--------------------------------------------------------------------------------------------
function public.use_gearext1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_gearext1" );
    cmn.CallEventHandler( "use_gearext1_end" );
    --common_impl.Lock(0);
    -- if common_impl.ZzCompleteCheck("use_gearext1") then ld.CloseSubRoom() end;
     if ld.CheckRequirements( {"use_gearext2","use_gearext1"} ) then
      ld.CloseSubRoom(); ld.StartTimer( 0.5, function()  ld.Lock(0); cmn.GotoRoom('mg_mechanismext');  end ) 
    else  
       common_impl.Lock(0);
    end;  
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_gearext1_inv" );
  cmn.CallEventHandler( "use_gearext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_serviceexitext_anim_cogwheel1", "anim_cogwheel1", func_end );
  SoundSfx( "aud_use_gearext1_mallext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_gearext2" ] = { type = "use", inv_obj = "inv_gearext2", use_place = "gfx_serviceexitext_gearext2_zone", room = "rm_mallext", zz = "zz_serviceexitext", zz_gate = "gzz_mallext_serviceexitext" };

private.use_gearext2_logic = function()
  if ld.CheckRequirements( {"use_gearext2","use_gearext1"} ) then
  ObjSet( "gmg_mallext_mechanismext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_gearext2_inv = function()
  common_impl.ProcessMultiUseAll("gearext2", "gearext2")
end;
private.use_gearext2_beg = function()
  ObjDelete( "gfx_serviceexitext_gearext2_zone" );
end;
private.use_gearext2_end = function()
  if common_impl.ZzCompleteCheck("use_gearext2") then ObjSet( common_impl.hint["use_gearext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_serviceexitext_anim_cogwheel2", {animfunc = "anim_cogwheel2_end", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_gearext2", private.use_gearext2_inv );
cmn.AddSubscriber( "use_gearext2", private.use_gearext2_beg, private.room_objname );
cmn.AddSubscriber( "use_gearext2", private.use_gearext2_end, private.room_objname );
cmn.AddSubscriber( "use_gearext2", private.use_gearext2_logic );
cmn.AddSubscriber( "use_gearext2_inv", private.use_gearext2_inv, private.room_objname );
cmn.AddSubscriber( "use_gearext2_beg", private.use_gearext2_beg, private.room_objname );
cmn.AddSubscriber( "use_gearext2_end", private.use_gearext2_end, private.room_objname );
cmn.AddSubscriber( "use_gearext2_end", private.use_gearext2_logic );
--------------------------------------------------------------------------------------------
function public.use_gearext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_gearext2" );
    cmn.CallEventHandler( "use_gearext2_end" );
   -- if common_impl.ZzCompleteCheck("use_gearext2") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_gearext2","use_gearext1"} ) then
      ld.CloseSubRoom(); ld.StartTimer( 0.5, function()  ld.Lock(0); cmn.GotoRoom('mg_mechanismext');  end ) 
    else  
       common_impl.Lock(0);
    end;  
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_gearext2_inv" );
  cmn.CallEventHandler( "use_gearext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_serviceexitext_anim_cogwheel2", "anim_cogwheel2", func_end );
  SoundSfx( "aud_use_gearext2_mallext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cashboxext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_glasscutterext" ] = { type = "get", get_obj = "spr_cashboxext_glasscutterext", room = "rm_mallext", zz = "zz_cashboxext", zz_gate = "gzz_mallext_cashboxext" };

private.get_glasscutterext_logic = function()
  
end;
private.get_glasscutterext_inv = function()
  interface.InventoryItemAdd("inv_glasscutterext","spr_cashboxext_glasscutterext");
end;
private.get_glasscutterext_beg = function()
  ObjDelete("gfx_cashboxext_glasscutterext")
end;
private.get_glasscutterext_end = function()
  if common_impl.ZzCompleteCheck("get_glasscutterext") then ObjSet( common_impl.hint["get_glasscutterext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cashboxext_glasscutterext_shadow")
  ObjDelete("spr_mallext_glasscutter")
end;

cmn.AddSubscriber( "get_glasscutterext", private.get_glasscutterext_inv );
cmn.AddSubscriber( "get_glasscutterext", private.get_glasscutterext_beg, private.room_objname );
cmn.AddSubscriber( "get_glasscutterext", private.get_glasscutterext_end, private.room_objname );
cmn.AddSubscriber( "get_glasscutterext", private.get_glasscutterext_logic );
--------------------------------------------------------------------
function public.get_glasscutterext()
  cmn.SetEventDone( "get_glasscutterext" );
  cmn.CallEventHandler( "get_glasscutterext" );
  if common_impl.ZzCompleteCheck("get_glasscutterext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_crownext" ] = { type = "use", inv_obj = "inv_crownext", use_place = "gfx_cashboxext_crownext_zone", room = "rm_mallext", zz = "zz_cashboxext", zz_gate = "gzz_mallext_cashboxext" };

private.use_crownext_logic = function()
  ObjSet( "spr_cashboxext_fivepointedstarext", { visible = 1, input = 1, active = 1 } )

end;
private.use_crownext_inv = function()
  common_impl.ProcessMultiUseAll("crownext", "crownext")
end;
private.use_crownext_beg = function()
  ObjDelete( "gfx_cashboxext_crownext_zone" );
end;
private.use_crownext_end = function()
  if common_impl.ZzCompleteCheck("use_crownext") then ObjSet( common_impl.hint["use_crownext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cashboxext_anm_crown", {animfunc = "use_crown", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_crownext", private.use_crownext_inv );
cmn.AddSubscriber( "use_crownext", private.use_crownext_beg, private.room_objname );
cmn.AddSubscriber( "use_crownext", private.use_crownext_end, private.room_objname );
cmn.AddSubscriber( "use_crownext", private.use_crownext_logic );
cmn.AddSubscriber( "use_crownext_inv", private.use_crownext_inv, private.room_objname );
cmn.AddSubscriber( "use_crownext_beg", private.use_crownext_beg, private.room_objname );
cmn.AddSubscriber( "use_crownext_end", private.use_crownext_end, private.room_objname );
cmn.AddSubscriber( "use_crownext_end", private.use_crownext_logic );
--------------------------------------------------------------------------------------------
function public.use_crownext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_crownext" );
    cmn.CallEventHandler( "use_crownext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_crownext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_crownext_inv" );
  cmn.CallEventHandler( "use_crownext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cashboxext_anm_crown", "use_crown", func_end );
  SoundSfx( "aud_use_crownext_mallext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fivepointedstarext" ] = { type = "get", get_obj = "spr_cashboxext_fivepointedstarext", room = "rm_mallext", zz = "zz_cashboxext", zz_gate = "gzz_mallext_cashboxext" };

private.get_fivepointedstarext_logic = function()
  
end;
private.get_fivepointedstarext_inv = function()
  interface.InventoryItemAdd("inv_fivepointedstarext","spr_cashboxext_fivepointedstarext");
end;
private.get_fivepointedstarext_beg = function()
  ObjDelete("gfx_cashboxext_fivepointedstarext")
end;
private.get_fivepointedstarext_end = function()
  if common_impl.ZzCompleteCheck("get_fivepointedstarext") then ObjSet( common_impl.hint["get_fivepointedstarext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cashboxext_fivepointedstarext_shadow")
  ObjDelete("spr_cashboxext_shadow_on_star")
end;

cmn.AddSubscriber( "get_fivepointedstarext", private.get_fivepointedstarext_inv );
cmn.AddSubscriber( "get_fivepointedstarext", private.get_fivepointedstarext_beg, private.room_objname );
cmn.AddSubscriber( "get_fivepointedstarext", private.get_fivepointedstarext_end, private.room_objname );
cmn.AddSubscriber( "get_fivepointedstarext", private.get_fivepointedstarext_logic );
--------------------------------------------------------------------
function public.get_fivepointedstarext()
  cmn.SetEventDone( "get_fivepointedstarext" );
  cmn.CallEventHandler( "get_fivepointedstarext" );
  if common_impl.ZzCompleteCheck("get_fivepointedstarext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_buttonext" ] = { type = "use", inv_obj = "inv_buttonext", use_place = "gfx_cashboxext_buttonext_zone", room = "rm_mallext", zz = "zz_cashboxext", zz_gate = "gzz_mallext_cashboxext" };

private.use_buttonext_logic = function()
  if ld.CheckRequirements( {"use_buttonext","use_buttonext2"} ) then  
    ObjSet( "gfx_cashboxext_clk_bombext4_zone", { visible = 1, input = 1, active = 1 } )
  end
end;
private.use_buttonext_inv = function()
  common_impl.ProcessMultiUseAll("buttonext", "buttonext")
end;
private.use_buttonext_beg = function()
  ObjDelete( "gfx_cashboxext_buttonext_zone" );
end;
private.use_buttonext_end = function()
  if common_impl.ZzCompleteCheck("use_buttonext") then ObjSet( common_impl.hint["use_buttonext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cashboxext_anm_button1", {animfunc = "use_button1", frame = 999 } );
  if ld.CheckRequirements( {"use_buttonext","use_buttonext2"} ) then  
    ObjSet( "anm_cashboxext_anm_bomb", {animfunc = "take_bomb", frame = 0 } );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_buttonext", private.use_buttonext_inv );
cmn.AddSubscriber( "use_buttonext", private.use_buttonext_beg, private.room_objname );
cmn.AddSubscriber( "use_buttonext", private.use_buttonext_end, private.room_objname );
cmn.AddSubscriber( "use_buttonext", private.use_buttonext_logic );
cmn.AddSubscriber( "use_buttonext_inv", private.use_buttonext_inv, private.room_objname );
cmn.AddSubscriber( "use_buttonext_beg", private.use_buttonext_beg, private.room_objname );
cmn.AddSubscriber( "use_buttonext_end", private.use_buttonext_end, private.room_objname );
cmn.AddSubscriber( "use_buttonext_end", private.use_buttonext_logic );
--------------------------------------------------------------------------------------------
function public.use_buttonext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_buttonext" );
    cmn.CallEventHandler( "use_buttonext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_buttonext") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    if ld.CheckRequirements( {"use_buttonext2"} ) then
      SoundSfx( "aud_open_cash_mallext" )
      ld.AnimPlay( "anm_cashboxext_anm_bomb", "open_box", func_end )
    else 
      func_end();
    end;  
  end;  
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_buttonext_inv" );
  cmn.CallEventHandler( "use_buttonext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cashboxext_anm_button1", "use_button1", func_preend );
  SoundSfx( "aud_use_buttonext_mallext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_buttonext2" ] = { type = "use", inv_obj = "inv_buttonext2", use_place = "gfx_cashboxext_buttonext2_zone", room = "rm_mallext", zz = "zz_cashboxext", zz_gate = "gzz_mallext_cashboxext" };

private.use_buttonext2_logic = function()
  if ld.CheckRequirements( {"use_buttonext","use_buttonext2"} ) then  
    ObjSet( "gfx_cashboxext_clk_bombext4_zone", { visible = 1, input = 1, active = 1 } )
  end
end;
private.use_buttonext2_inv = function()
  common_impl.ProcessMultiUseAll("buttonext2", "buttonext2")
end;
private.use_buttonext2_beg = function()
  ObjDelete( "gfx_cashboxext_buttonext2_zone" );
end;
private.use_buttonext2_end = function()
  if common_impl.ZzCompleteCheck("use_buttonext2") then ObjSet( common_impl.hint["use_buttonext2"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjSet( "anm_cashboxext_anm_button2", {animfunc = "use_button2", frame = 999 } );
  if ld.CheckRequirements( {"use_buttonext","use_buttonext2"} ) then  
    ObjSet( "anm_cashboxext_anm_bomb", {animfunc = "take_bomb", frame = 0 } );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_buttonext2", private.use_buttonext2_inv );
cmn.AddSubscriber( "use_buttonext2", private.use_buttonext2_beg, private.room_objname );
cmn.AddSubscriber( "use_buttonext2", private.use_buttonext2_end, private.room_objname );
cmn.AddSubscriber( "use_buttonext2", private.use_buttonext2_logic );
cmn.AddSubscriber( "use_buttonext2_inv", private.use_buttonext2_inv, private.room_objname );
cmn.AddSubscriber( "use_buttonext2_beg", private.use_buttonext2_beg, private.room_objname );
cmn.AddSubscriber( "use_buttonext2_end", private.use_buttonext2_end, private.room_objname );
cmn.AddSubscriber( "use_buttonext2_end", private.use_buttonext2_logic );
--------------------------------------------------------------------------------------------
function public.use_buttonext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_buttonext2" );
    cmn.CallEventHandler( "use_buttonext2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_buttonext2") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    if ld.CheckRequirements( {"use_buttonext"} ) then
      SoundSfx( "aud_open_cash_mallext" )
      ld.AnimPlay( "anm_cashboxext_anm_bomb", "open_box", func_end )
    else 
      func_end();
    end;  
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_buttonext2_inv" );
  cmn.CallEventHandler( "use_buttonext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cashboxext_anm_button2", "use_button2", func_preend );
  SoundSfx( "aud_use_buttonext_mallext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_bombext4" ] = { type = "click", use_place = "gfx_cashboxext_clk_bombext4_zone", room = "rm_mallext", zz = "zz_cashboxext", zz_gate = "gzz_mallext_cashboxext" };

private.clk_bombext4_logic = function()
  -- ObjSet( "spr_cashboxext_keyboxext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "obj_cashboxext_bombext4_root", {input = 1, visible = 1, active=1, alp=1} );
end;
private.clk_bombext4_beg = function()
  ObjDelete( "gfx_cashboxext_clk_bombext4_zone" );
end;
private.clk_bombext4_end = function()
  if common_impl.ZzCompleteCheck("clk_bombext4") then ObjSet( common_impl.hint["clk_bombext4"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cashboxext_anm_bomb", {animfunc = "bomb_static", frame = 0, playing=1 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_bombext4", private.clk_bombext4_beg, private.room_objname );
cmn.AddSubscriber( "clk_bombext4", private.clk_bombext4_end, private.room_objname );
cmn.AddSubscriber( "clk_bombext4", private.clk_bombext4_logic );
cmn.AddSubscriber( "clk_bombext4_beg", private.clk_bombext4_beg, private.room_objname );
cmn.AddSubscriber( "clk_bombext4_end", private.clk_bombext4_end, private.room_objname );
cmn.AddSubscriber( "clk_bombext4_end", private.clk_bombext4_logic );
--------------------------------------------------------------------------------------------
function public.clk_bombext4()

  local func_end = function()
    ObjSet( "anm_cashboxext_anm_bomb", {animfunc = "bomb_static", frame = 0, playing=1 } );
   --  common_impl.Lock(0);
    private.init_bombext4();
    ObjAnimate( "obj_cashboxext_bombext4_root", 8, 0, 0, function() 
         common_impl.Lock(0); 
         cmn.SetEventDone( "clk_bombext4" );
         cmn.CallEventHandler( "clk_bombext4_end" );
         cmn.MiniGameShow( "bombext4" );
    end,{0,0,0, 0.5,0,1} );  
    if common_impl.ZzCompleteCheck("clk_bombext4") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_bombext4_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cashboxext_anm_bomb", "take_bomb", func_end );
  SoundSfx( "aud_touch_bomb4_mallext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_bombext4" ] = { type = "click", use_place = "obj_cashboxext_bombext4_root", room = "rm_mallext", zz = "zz_cashboxext", zz_gate = "gzz_mallext_cashboxext" };

private.win_bombext4_logic = function()
  if cmn.IsEventDone("win_bombext4") then 
     ObjSet( "spr_cashboxext_keyboxext", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.win_bombext4_beg = function()
  
end;
private.win_bombext4_end = function()
  if cmn.IsEventDone("win_bombext4") then 
     if common_impl.ZzCompleteCheck("win_bombext4") then ObjSet( common_impl.hint["win_bombext4"].zz_gate, { visible = 0, input = 0 } ); end;
     ObjDelete("obj_cashboxext_bombext4_root")
     ObjSet( "anm_cashboxext_anm_bomb", {animfunc = "win_mmg", frame = 999 } );
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_bombext4", private.win_bombext4_beg, private.room_objname );
cmn.AddSubscriber( "win_bombext4", private.win_bombext4_end, private.room_objname );
cmn.AddSubscriber( "win_bombext4", private.win_bombext4_logic );
cmn.AddSubscriber( "win_bombext4_beg", private.win_bombext4_beg, private.room_objname );
cmn.AddSubscriber( "win_bombext4_end", private.win_bombext4_end, private.room_objname );
cmn.AddSubscriber( "win_bombext4_end", private.win_bombext4_logic );
--------------------------------------------------------------------------------------------
function public.win_bombext4()

  local func_end = function()
    cmn.SetEventDone( "win_bombext4" );
    cmn.CallEventHandler( "win_bombext4_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_bombext4") then ld.CloseSubRoom() end;
    --  levelext_inv.opnbombmapext_win_open();
    SoundTheme( "aud_danger_moment1_mus" );
  end;

  local func_preend = function()
     SoundSfx( "aud_bomb4_defused" )
     ld.AnimPlay( "anm_cashboxext_anm_bomb", "win_mmg", func_end )
  end;
    
  cmn.MiniGameHide( "bombext4",true ); 
  cmn.CallEventHandler( "win_bombext4_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_mg_bomb4_win" )
  --func_end()
  ObjAnimate( "obj_cashboxext_bombext4_root", 8, 0, 0, func_preend, {0,0,1, 0.5,0,1, 1,0,0} );
end;
---------------------------------------
private.win_bombext4_state = 0;
private.win_bombext4_parts_fp = {};
-------------------------------------1-----2------3----------4------5---6---------7--------------8------------9----------10------11--------12-----------------13------------14---------15-----------16------------17---------18------------19-------------20--------21-----------22----------23--------24----------25-----26-finish
private.bombext4_points_way_array={{2,6},{1,3},{2,4,7,8},{3,5,8},{4,9,26},{1,7},{3,6,11,12},{3,4,9,12,13,14},{5,8,10,14},{9,14},{7,12,16},{7,8,11,13,16},{8,12,17,18,19},{8,9,10,15},{14,19,20},{11,12,17,21},{13,16,21,22},{13,22,24},{13,15,20,24,25},{15,19,25},{16,17,22},{17,18,21,23},{22,24},{18,19,23,25},{19,20,24},{5}}
private.bombext4_points_array={{-168 , -143},
{-90  , -137},
{-28  , -153},
{65   , -148},
{147  , -139},
{-165 , -64 },
{-92  , -75 },
{-16  , -91 },
{86   , -85 },
{ 164 , -65 },
{ -193, -6  },
{ -85 , -2  },
{ -13 , 4   },
{ 87  , -19 },
{ 179 , 5   },
{-230 , 54  },
{-148 , 78  },
{ -39 , 81  },
{ 74  , 69  },
{ 156 , 64  },
{-206 , 129 },
{-115 , 160 },
{ -30 , 147 },
{ 55  , 145 },
{ 161 , 127 },
{220 , -122}}

function private.init_bombext4()
  if not (cmn.IsEventStart("win_bombext4")) then
   ng_global.progress["ext"]["win_bombext4"].state = {}
   private.win_bombext4_state= ld.TableCopy(private.win_bombext4_parts_fp);
   ng_global.progress["ext"]["win_bombext4"].state =  private.win_bombext4_state;
  else  
    
   private.win_bombext4_state=ng_global.progress["ext"]["win_bombext4"].state;
  end
  private.win_bombext4_stand_pos();  
end;  
------------
 private.bombext4_parts_init_flag = false;
function private.bombext4_parts_init()
  if  private.bombext4_parts_init_flag==false then 
      ld.LogTrace( "bombext4_parts_init" );
      for i=1,26,1 do 
        ObjCreate("obj_cashboxext_part"..i,"obj")
        ObjAttach("obj_cashboxext_part"..i,"obj_cashboxext_second_mmg_root");
        ObjSet( "obj_cashboxext_part"..i, {input=1, inputrect_init=1, inputrect_w=60, inputrect_h=60, inputrect_x=-30, inputrect_y=-30, pos_x=private.bombext4_points_array[i][1], pos_y=private.bombext4_points_array[i][2], 
           event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_mdown="rm_mallext.win_bombext_part_mdown("..i..");" } );
      
        ObjCreate("spr_cashboxext_part_light_gr"..i,"spr");
        ObjAttach("spr_cashboxext_part_light_gr"..i,"obj_cashboxext_part"..i)
        if i~=26 then 
           ObjSet( "spr_cashboxext_part_light_gr"..i, {input=0, alp=0, res="assets/levels/levelext/rm_mallext/zz_cashboxext/1"} );
        else 
           ObjSet( "spr_cashboxext_part_light_gr"..i, {input=0, alp=0, res="assets/levels/levelext/rm_mallext/zz_cashboxext/finish"} );
        end;   
           
      
        ObjCreate("spr_cashboxext_part_light_red"..i,"spr");
        ObjAttach("spr_cashboxext_part_light_red"..i,"obj_cashboxext_part"..i)
        if i~=26 then 
           ObjSet( "spr_cashboxext_part_light_red"..i, {input=0, alp=0, res="assets/levels/levelext/rm_mallext/zz_cashboxext/1_red"} );
        else   
           ObjSet( "spr_cashboxext_part_light_red"..i, {input=0, alp=0, res="assets/levels/levelext/rm_mallext/zz_cashboxext/red_glow"} );
        end;   
      end;  
  end;

   for i=1,26,1 do 
      private.win_bombext4_parts_fp[i]=0;
   end; 
    private.win_bombext4_parts_fp[23]=1; 
    
    private.bombext4_parts_init_flag = true;
end;  
----------------------------

function private.win_bombext4_stand_pos(without_win_ver)
  for i=1,26,1 do 
    if ng_global.progress["ext"]["win_bombext4"].state[i]==1 then 
      ObjSet( "spr_cashboxext_part_light_gr"..i, {alp = 1} );
    else 
      ObjSet( "spr_cashboxext_part_light_gr"..i, {alp = 0} );
    end;  
  end;  
  private.win_bombext4_show_lines();
  if without_win_ver~=1 and  ng_global.progress["ext"]["win_bombext4"].state[26]==1 then public.win_bombext4(); end;
end;  
--------------------------------------
function private.win_bombext4_show_lines()
  for i=1,26,1 do 
    if ng_global.progress["ext"]["win_bombext4"].state[i]==1  then 
       for j=1,#private.bombext4_points_way_array[i],1 do 
         local f_point = i;
         local n_point = private.bombext4_points_way_array[i][j];
         
         if i>j then f_point, n_point = n_point,f_point; end;
         
         if ng_global.progress["ext"]["win_bombext4"].state[private.bombext4_points_way_array[i][j] ]==1 then 
        --   ld.LogTrace( "spr_cashboxext_"..f_point.."_"..n_point.." true" );
           ObjSet( "spr_cashboxext_"..f_point.."_"..n_point, {visible = 1} );
         else 
         --  ld.LogTrace( "spr_cashboxext_"..f_point.."_"..n_point.." false" );
           ObjSet( "spr_cashboxext_"..f_point.."_"..n_point, {visible = 0} );
         end;  
       end;  
    end; 
    
    if  ng_global.progress["ext"]["win_bombext4"].state[i]==0 then 
       for j=1,#private.bombext4_points_way_array[i],1 do 
          local f_point = i;
          local n_point = private.bombext4_points_way_array[i][j];
          if i>j then f_point, n_point = n_point,f_point; end;
          ObjSet( "spr_cashboxext_"..f_point.."_"..n_point, {visible = 0} );
       end;  
    end;  
  end;  
end;  
--------------------------------------

function public.win_bombext_part_mdown(num)
  -- search last active part 
  local active_last_flag=false;
  for i=1,#private.bombext4_points_way_array[num],1 do 
    if ng_global.progress["ext"]["win_bombext4"].state[private.bombext4_points_way_array[num] [i] ]==1 then active_last_flag=true; end;
  end;  
  ---------
  if active_last_flag==true then 
    ng_global.progress["ext"]["win_bombext4"].state[num]=1;
    SoundSfx( "aud_mg_bomb4_true" );
  else 
    ld.Lock(1);
    SoundSfx( "aud_mg_bomb4_wrong" )
    ObjAnimate(  "spr_cashboxext_part_light_red"..num, 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1, 0.5,0,0} );
  end;  
  private.win_bombext4_stand_pos();  
end;  
--------------------------------------------------------------------
function public.win_bombext4_skip()
  local func_end = function()
    for i=1,26,1 do 
      ng_global.progress["ext"]["win_bombext4"].state[i]=1;
    end;  
    private.win_bombext4_stand_pos(1);
    ObjAnimate( "obj_cashboxext_second_mmg_root", 8, 0, 0, function() private.win_bombext4_stand_pos(); end, {0,0,0, 0.3,0,1} );

  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_cashboxext_second_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  

----------------------------------------------------
function public.win_bombext4_reset()
  local func_end = function()
    for i=1,26,1 do 
      ng_global.progress["ext"]["win_bombext4"].state[i]=0;
    end;  
    ng_global.progress["ext"]["win_bombext4"].state[23]=1;
    private.win_bombext4_stand_pos();
    ObjAnimate( "obj_cashboxext_second_mmg_root", 8, 0, 0, function()  private.win_bombext4_stand_pos(); ld.Lock(0); end, {0,0,0, 0.3,0,1} );
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_cashboxext_second_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_keyboxext" ] = { type = "get", get_obj = "spr_cashboxext_keyboxext", room = "rm_mallext", zz = "zz_cashboxext", zz_gate = "gzz_mallext_cashboxext" };

private.get_keyboxext_logic = function()
  
end;
private.get_keyboxext_inv = function()
  interface.InventoryItemAdd("inv_keyboxext","spr_cashboxext_keyboxext");
end;
private.get_keyboxext_beg = function()
  ObjDelete("gfx_cashboxext_keyboxext")
end;
private.get_keyboxext_end = function()
  if common_impl.ZzCompleteCheck("get_keyboxext") then ObjSet( common_impl.hint["get_keyboxext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cashboxext_keyboxext_shadow");
end;

cmn.AddSubscriber( "get_keyboxext", private.get_keyboxext_inv );
cmn.AddSubscriber( "get_keyboxext", private.get_keyboxext_beg, private.room_objname );
cmn.AddSubscriber( "get_keyboxext", private.get_keyboxext_end, private.room_objname );
cmn.AddSubscriber( "get_keyboxext", private.get_keyboxext_logic );
--------------------------------------------------------------------
function public.get_keyboxext()
  cmn.SetEventDone( "get_keyboxext" );
  cmn.CallEventHandler( "get_keyboxext" );
  if common_impl.ZzCompleteCheck("get_keyboxext") then ld.CloseSubRoom() end;
  levelext_inv.opnbombmapext_win_open();
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_mechanismext_for_mallext = function()
    if ld.CheckRequirements( {"win_mechanismext"} ) then
      ObjSet( "gmg_mallext_mechanismext", {input = 0, visible = 0} );
      if (cmn.IsEventDone("get_skittleext1")) then
        ObjSet( "grm_mallext_staffonlyext", {visible = 1, input = 1, active = 1} );
        if port.isPortable() == 1 then
          port.GrmEventLightOn("grm_mallext_staffonlyext_focus");
        end;
        ObjDelete("spr_mallext_close_roomservice");
        ObjSet( "spr_mallext_open_roomservice", {alp = 1} );
      end;
    end
  end;
  cmn.AddSubscriber("win_mechanismext", win_mechanismext_for_mallext, private.room_objname )
  local win_sweetsext_for_mallext = function()
    if ld.CheckRequirements( {"win_sweetsext"} ) then
      ObjSet( "gho_mallext_sweetsext", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_sweetsext", win_sweetsext_for_mallext, private.room_objname )

end;
--*********************************************************************************************************************
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_cashboxext" ) and not ld.CheckRequirements( { "win_bombext4" } ) then  
    public.win_bombext4_reset()
  elseif ( mg_name == "zz_bowlingext" ) and not ld.CheckRequirements( { "win_bowlingext" } ) then  
    private.win_bowlingext_reset()
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_cashboxext" ) and not ld.CheckRequirements( { "win_bombext4" } ) then
    public.win_bombext4_skip();
  elseif ( mg_name == "zz_bowlingext" ) and not ld.CheckRequirements( { "win_bowlingext" } ) then
    private.win_bowlingext_skip();
  end;
  
end

function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_mallext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_mallext_env" )
  if not cmn.IsEventDone("use_alarmkeyfobext") then 
    SoundEnv("aud_alarm_loc_mallext",1);
  end;  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_cashboxext" );
  function zz_cashboxext.Open()
  end;
  function zz_cashboxext.PreOpen()
     if not cmn.IsEventDone("win_bombext4") then 
        private.bombext4_parts_init();
     end;  
    
      if cmn.IsEventStart("win_bombext4") and not cmn.IsEventDone("win_bombext4") then 
        cmn.MiniGameShow( "bombext4" ); 
        private.init_bombext4();
     end;  
  end;
  function zz_cashboxext.PreClose()
  end;
  function zz_cashboxext.Close()
    --if cmn.IsEventStart("win_bombext4") and not cmn.IsEventDone("win_bombext4") then 
    --  cmn.MiniGameHide( "bombext4" ); 
    --end; 
  end;

  subroom.Define( "zz_serviceexitext" );
  function zz_serviceexitext.Open()
  end;
  function zz_serviceexitext.PreOpen()
     if not cmn.IsEventDone("use_alarmkeyfobext") then 
       SoundEnv("aud_alarm_loc_mallext",0);
       SoundEnv("aud_alarm_zz_mallext",1)
     end; 
  end;
  function zz_serviceexitext.PreClose()
    if not cmn.IsEventDone("use_alarmkeyfobext") then 
      SoundEnv("aud_alarm_loc_mallext",1);
      SoundEnv("aud_alarm_zz_mallext",0)
    end; 
  end;
  function zz_serviceexitext.Close()
    
  end;

  subroom.Define( "zz_bowlingext" );
  function zz_bowlingext.Open()
     if cmn.IsEventStart("win_bowlingext") and not cmn.IsEventDone("win_bowlingext") then 
       cmn.MiniGameShow( "bowlingext" ); 
       private.init_bowlingext()
     end;     
  end;
  function zz_bowlingext.PreOpen()
  end;
  function zz_bowlingext.PreClose()
  end;
  function zz_bowlingext.Close()
  end;

  subroom.Define( "zz_machinedrinksext" );
  function zz_machinedrinksext.Open()
  end;
  function zz_machinedrinksext.PreOpen()
  end;
  function zz_machinedrinksext.PreClose()
  end;
  function zz_machinedrinksext.Close()
  end;
  
end;
--*********************************************************************************************************************