-- name=rm_nearpubext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearpubext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  
  ld.NoteInit("spr_cellarext_paper","spr_cellarext_paper_big");
  --------------------------------------------------------------------------------------------
function private.opn_nearpubext()
  if not ( cmn.IsEventDone( "opn_nearpubext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_nearpubext" );
      cmn.CallEventHandler( "opn_nearpubext" )
      --  ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opnpubext");
      SoundTheme( "aud_danger_moment2_mus" );
  end;
  func_end()
  end;

  if cmn.IsEventDone("win_pubmgext") and not cmn.IsEventDone("win_pubmgextinnearpubext") then
    public.win_pubmgextinnearpubext();
  end;  
end;
--------------------------------------------------------------------
local opn_nearpubext = function() end;
local opn_nearpubext_logic = function() end;
cmn.AddSubscriber( "opn_nearpubext", opn_nearpubext_logic )
cmn.AddSubscriber( "opn_nearpubext", opn_nearpubext, private.room_objname )
--------------------------------------------------------------------------------------------
--
--  local win_pubmgext_for_nearpub_logic = function()
--    if ld.CheckRequirements( {"win_pubmgext"} ) then
--    
--    end
--  end;
--  local win_pubmgext_for_nearpub = function()
--    if ld.CheckRequirements( {"win_pubmgext"} ) then
--        ObjSet( "obj_nearpubext_pubdoor_tr_tr_root", {visible = 0} );
--      
--    end
--  end;
--  cmn.AddSubscriber("win_pubmgext", win_pubmgext_for_nearpub, private.room_objname )
--  cmn.AddSubscriber("win_pubmgext", win_pubmgext_for_nearpub_logic )
--
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_signext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_coinext1" ] = { type = "get", get_obj = "spr_signext_coinext1", room = "rm_nearpubext", zz = "zz_signext", zz_gate = "gzz_nearpubext_signext" };

private.get_coinext1_logic = function()
  
end;
private.get_coinext1_inv = function()
  interface.InventoryItemAdd("inv_coinext","spr_signext_coinext1",function() level_inv.ProcessGetCoinextAll( "get_coinext1" ) end);
end;
private.get_coinext1_beg = function()
  ObjDelete("gfx_signext_coinext1")
end;
private.get_coinext1_end = function()
  if common_impl.ZzCompleteCheck("get_coinext1") then ObjSet( common_impl.hint["get_coinext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_signext_sh_coinext1");
  ObjDelete("spr_nearpubext_coinext1");
end;

cmn.AddSubscriber( "get_coinext1", private.get_coinext1_inv );
cmn.AddSubscriber( "get_coinext1", private.get_coinext1_beg, private.room_objname );
cmn.AddSubscriber( "get_coinext1", private.get_coinext1_end, private.room_objname );
cmn.AddSubscriber( "get_coinext1", private.get_coinext1_logic );
--------------------------------------------------------------------
function public.get_coinext1()
  cmn.SetEventDone( "get_coinext1" );
  cmn.CallEventHandler( "get_coinext1" );
  if common_impl.ZzCompleteCheck("get_coinext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.signext_idle_clk()  --rm_nearpubext.signext_idle_clk()
  local func_end = function()
    ld.Lock(0);
    ObjSet( "anm_signext_anm_emblem", {visible = 1} );
    ObjSet( "anm_signext_anm_letter", {visible = 1} );
    ObjSet( "anm_signext_anm", {animfunc = "idle_end", frame = 0 } );
  end;  
  
  if cmn.IsEventDone("get_coinext1") and not cmn.IsEventDone("use_letterbext") and not cmn.IsEventDone("use_pubemblemext") then 
    ObjSet( "anm_signext_anm_emblem", {visible = 0} );
    ObjSet( "anm_signext_anm_letter", {visible = 0} );
    ld.Lock(1)
    ObjSet( "anm_signext_anm", {animfunc = "idle", frame = 0 } );
    ld.AnimPlay( "anm_signext_anm", "idle", func_end )
    SoundSfx( "aud_touch_small_door" )
  end;  
end;  
---------------------------------------------------------------------------------------------

function public.use_letter_zone_clk()  -- rm_nearpubext.use_letter_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_letterbext' )
  end;  
  
  SoundSfx( "aud_touch_small_wood" );
  ld.Lock(1);
  ld.AnimPlay( "anm_signext_anm_letter", "idle_2", func_end )
end;  


common_impl.hint[ "use_letterbext" ] = { type = "use", inv_obj = "inv_letterbext", use_place = "gfx_signext_letterbext_zone", room = "rm_nearpubext", zz = "zz_signext", zz_gate = "gzz_nearpubext_signext" };

private.use_letterbext_logic = function()
  ObjSet( "spr_signext_stampext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_signext_stampext", {active=1, visible=1} );
end;
private.use_letterbext_inv = function()
  common_impl.ProcessMultiUseAll("letterbext", "letterbext")
end;
private.use_letterbext_beg = function()
  ObjDelete( "gfx_signext_letterbext_zone" );
end;
private.use_letterbext_end = function()
  if common_impl.ZzCompleteCheck("use_letterbext") then ObjSet( common_impl.hint["use_letterbext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_signext_anm_letter", {animfunc="use_letter", frame=999} );
  ObjDelete("spr_nearpubext_door_2");
  ObjSet( "spr_nearpubext_open_2", {visible = 1} );
  ObjSet( "spr_nearpubext_stampext", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_letterbext", private.use_letterbext_inv );
cmn.AddSubscriber( "use_letterbext", private.use_letterbext_beg, private.room_objname );
cmn.AddSubscriber( "use_letterbext", private.use_letterbext_end, private.room_objname );
cmn.AddSubscriber( "use_letterbext", private.use_letterbext_logic );
cmn.AddSubscriber( "use_letterbext_inv", private.use_letterbext_inv, private.room_objname );
cmn.AddSubscriber( "use_letterbext_beg", private.use_letterbext_beg, private.room_objname );
cmn.AddSubscriber( "use_letterbext_end", private.use_letterbext_end, private.room_objname );
cmn.AddSubscriber( "use_letterbext_end", private.use_letterbext_logic );
--------------------------------------------------------------------------------------------
function public.use_letterbext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_letterbext" );
    cmn.CallEventHandler( "use_letterbext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_letterbext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_letterbext_inv" );
  cmn.CallEventHandler( "use_letterbext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_signext_anm_letter", "use_letter", func_end );
  SoundSfx( "aud_use_letterbext_nearpubext" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_stampext" ] = { type = "get", get_obj = "spr_signext_stampext", room = "rm_nearpubext", zz = "zz_signext", zz_gate = "gzz_nearpubext_signext" };

private.get_stampext_logic = function()
  
end;
private.get_stampext_inv = function()
  interface.InventoryItemAdd("inv_stampext","spr_signext_stampext");
end;
private.get_stampext_beg = function()
  ObjDelete("gfx_signext_stampext")
end;
private.get_stampext_end = function()
  if common_impl.ZzCompleteCheck("get_stampext") then ObjSet( common_impl.hint["get_stampext"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjSet( "anm_signext_anm_letter", {animfunc="end_letter", frame=0} );
   ObjDelete("spr_nearpubext_stampext")
end;

cmn.AddSubscriber( "get_stampext", private.get_stampext_inv );
cmn.AddSubscriber( "get_stampext", private.get_stampext_beg, private.room_objname );
cmn.AddSubscriber( "get_stampext", private.get_stampext_end, private.room_objname );
cmn.AddSubscriber( "get_stampext", private.get_stampext_logic );
--------------------------------------------------------------------
function public.get_stampext()
  ObjSet( "spr_signext_stampext", {visible = 1} );
  cmn.SetEventDone( "get_stampext" );
  cmn.CallEventHandler( "get_stampext" );
  if common_impl.ZzCompleteCheck("get_stampext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_pubemblemext_zone_clk()  -- rm_nearpubext.use_pubemblemext_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_pubemblemext' )
  end;  
  
  SoundSfx( "aud_touch_small_wood" );
  ld.Lock(1);
  ld.AnimPlay( "anm_signext_anm_emblem", "idle_1", func_end )
end;  

common_impl.hint[ "use_pubemblemext" ] = { type = "use", inv_obj = "inv_pubemblemext", use_place = "gfx_signext_pubemblemext_zone", room = "rm_nearpubext", zz = "zz_signext", zz_gate = "gzz_nearpubext_signext" };

private.use_pubemblemext_logic = function()
  ObjSet( "spr_signext_coinext4", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_signext_noteext2", { visible = 1, input = 1, active = 1 } )
end;
private.use_pubemblemext_inv = function()
  common_impl.ProcessMultiUseAll("pubemblemext", "pubemblemext")
end;
private.use_pubemblemext_beg = function()
  ObjDelete( "gfx_signext_pubemblemext_zone" );
end;
private.use_pubemblemext_end = function()
  if common_impl.ZzCompleteCheck("use_pubemblemext") then ObjSet( common_impl.hint["use_pubemblemext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_signext_anm_emblem", {animfunc = "end_emblem", frame = 0 } );
  ObjSet( "spr_signext_sh_coinext4", {visible = 1} );
  ObjDelete("spr_nearpubext_door_1");
  ObjSet( "spr_nearpubext_coinext4", {visible = 1} );
  ObjSet( "spr_nearpubext_open_1_a", {visible = 1} );
  ObjSet( "spr_signext_sh_noteext2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pubemblemext", private.use_pubemblemext_inv );
cmn.AddSubscriber( "use_pubemblemext", private.use_pubemblemext_beg, private.room_objname );
cmn.AddSubscriber( "use_pubemblemext", private.use_pubemblemext_end, private.room_objname );
cmn.AddSubscriber( "use_pubemblemext", private.use_pubemblemext_logic );
cmn.AddSubscriber( "use_pubemblemext_inv", private.use_pubemblemext_inv, private.room_objname );
cmn.AddSubscriber( "use_pubemblemext_beg", private.use_pubemblemext_beg, private.room_objname );
cmn.AddSubscriber( "use_pubemblemext_end", private.use_pubemblemext_end, private.room_objname );
cmn.AddSubscriber( "use_pubemblemext_end", private.use_pubemblemext_logic );
--------------------------------------------------------------------------------------------
function public.use_pubemblemext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pubemblemext" );
    cmn.CallEventHandler( "use_pubemblemext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pubemblemext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pubemblemext_inv" );
  cmn.CallEventHandler( "use_pubemblemext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_signext_anm_emblem", "use_emblem", func_end );
  SoundSfx( "aud_use_pubemblemext_nearpubext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coinext4" ] = { type = "get", get_obj = "spr_signext_coinext4", room = "rm_nearpubext", zz = "zz_signext", zz_gate = "gzz_nearpubext_signext" };

private.get_coinext4_logic = function()
  
end;
private.get_coinext4_inv = function()
  interface.InventoryItemAdd("inv_coinext","spr_signext_coinext4",function() level_inv.ProcessGetCoinextAll( "get_coinext4" ) end);
end;
private.get_coinext4_beg = function()
  ObjDelete("gfx_signext_coinext4")
end;
private.get_coinext4_end = function()
  if common_impl.ZzCompleteCheck("get_coinext4") then ObjSet( common_impl.hint["get_coinext4"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_signext_sh_coinext4");
  ObjDelete("spr_nearpubext_coinext4");
end;

cmn.AddSubscriber( "get_coinext4", private.get_coinext4_inv );
cmn.AddSubscriber( "get_coinext4", private.get_coinext4_beg, private.room_objname );
cmn.AddSubscriber( "get_coinext4", private.get_coinext4_end, private.room_objname );
cmn.AddSubscriber( "get_coinext4", private.get_coinext4_logic );
--------------------------------------------------------------------
function public.get_coinext4()
  cmn.SetEventDone( "get_coinext4" );
  cmn.CallEventHandler( "get_coinext4" );
  if common_impl.ZzCompleteCheck("get_coinext4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_noteext2" ] = { type = "get", get_obj = "spr_signext_noteext2", room = "rm_nearpubext", zz = "zz_signext", zz_gate = "gzz_nearpubext_signext" };

private.get_noteext2_logic = function()
  
end;
private.get_noteext2_inv = function()
  interface.InventoryItemAdd("inv_noteext2","spr_signext_noteext2");
end;
private.get_noteext2_beg = function()
  ObjDelete("gfx_signext_noteext2")
end;
private.get_noteext2_end = function()
  if common_impl.ZzCompleteCheck("get_noteext2") then ObjSet( common_impl.hint["get_noteext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_signext_sh_noteext2")
end;

cmn.AddSubscriber( "get_noteext2", private.get_noteext2_inv );
cmn.AddSubscriber( "get_noteext2", private.get_noteext2_beg, private.room_objname );
cmn.AddSubscriber( "get_noteext2", private.get_noteext2_end, private.room_objname );
cmn.AddSubscriber( "get_noteext2", private.get_noteext2_logic );
--------------------------------------------------------------------
function public.get_noteext2()
  cmn.SetEventDone( "get_noteext2" );
  cmn.CallEventHandler( "get_noteext2" );
  if common_impl.ZzCompleteCheck("get_noteext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_pubdoorext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_pubemblemext1" ] = { type = "get", get_obj = "spr_pubdoorext_pubemblemext1", room = "rm_nearpubext", zz = "zz_pubdoorext", zz_gate = "gzz_nearpubext_pubdoorext" };

private.get_pubemblemext1_logic = function()
  
end;
private.get_pubemblemext1_inv = function()
  interface.InventoryItemAdd("inv_pubemblemext","spr_pubdoorext_pubemblemext1",function() level_inv.ProcessGetPubemblemextAll( "get_pubemblemext1" ) end);
end;
private.get_pubemblemext1_beg = function()
  ObjDelete("gfx_pubdoorext_pubemblemext1")
end;
private.get_pubemblemext1_end = function()
  if common_impl.ZzCompleteCheck("get_pubemblemext1") then ObjSet( common_impl.hint["get_pubemblemext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_pubdoorext_sh_pubemblemext1");
  ObjDelete("spr_nearpubext_pubemblemext1");
end;

cmn.AddSubscriber( "get_pubemblemext1", private.get_pubemblemext1_inv );
cmn.AddSubscriber( "get_pubemblemext1", private.get_pubemblemext1_beg, private.room_objname );
cmn.AddSubscriber( "get_pubemblemext1", private.get_pubemblemext1_end, private.room_objname );
cmn.AddSubscriber( "get_pubemblemext1", private.get_pubemblemext1_logic );
--------------------------------------------------------------------
function public.get_pubemblemext1()
  cmn.SetEventDone( "get_pubemblemext1" );
  cmn.CallEventHandler( "get_pubemblemext1" );
  if common_impl.ZzCompleteCheck("get_pubemblemext1") then ld.CloseSubRoom() end;
  if cmn.IsEventDone("use_matchesext") and cmn.IsEventDone("get_pubemblemext1") then 
    ld.StartTimer( 0.5, function()  common_impl.Lock(0); cmn.GotoRoom("mg_pubmgext");  end );
  end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_matchesext_zone_clk() --rm_nearpubext.use_matchesext_zone_clk()
  local func_end = function()
     ld.Lock(0);
     common_impl.ShowBbt( 'need_matchesext' );
  end;  
  
  SoundSfx( "aud_touch_medium_door" ); 
  ld.Lock(1);
  ld.AnimPlay( "anm_pubdoorext_anm", "idle", func_end )
end;  


common_impl.hint[ "use_matchesext" ] = { type = "use", inv_obj = "inv_matchesext", use_place = "gfx_pubdoorext_matchesext_zone", room = "rm_nearpubext", zz = "zz_pubdoorext", zz_gate = "gzz_nearpubext_pubdoorext" };

private.use_matchesext_logic = function()
  ObjSet( "gmg_nearpubext_pubmgext", { visible = 1, input = 1, active = 1 } )

end;
private.use_matchesext_inv = function()
  common_impl.ProcessMultiUseAll("matchesext", "matchesext")
end;
private.use_matchesext_beg = function()
  ObjDelete( "gfx_pubdoorext_matchesext_zone" );
end;
private.use_matchesext_end = function()
  if common_impl.ZzCompleteCheck("use_matchesext") then ObjSet( common_impl.hint["use_matchesext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_pubdoorext_anm", {animfunc="end_matches"} );
  ObjSet( "obj_nearpubext_pubdoor_tr_tr_root", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_matchesext", private.use_matchesext_inv );
cmn.AddSubscriber( "use_matchesext", private.use_matchesext_beg, private.room_objname );
cmn.AddSubscriber( "use_matchesext", private.use_matchesext_end, private.room_objname );
cmn.AddSubscriber( "use_matchesext", private.use_matchesext_logic );
cmn.AddSubscriber( "use_matchesext_inv", private.use_matchesext_inv, private.room_objname );
cmn.AddSubscriber( "use_matchesext_beg", private.use_matchesext_beg, private.room_objname );
cmn.AddSubscriber( "use_matchesext_end", private.use_matchesext_end, private.room_objname );
cmn.AddSubscriber( "use_matchesext_end", private.use_matchesext_logic );
--------------------------------------------------------------------------------------------
function public.use_matchesext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_matchesext" );
    cmn.CallEventHandler( "use_matchesext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_matchesext") then 
      common_impl.Lock(1);
      ld.CloseSubRoom(); 
      ld.StartTimer( 0.5, function()  common_impl.Lock(0); cmn.GotoRoom("mg_pubmgext");  end );
    end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_matchesext_inv" );
  cmn.CallEventHandler( "use_matchesext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pubdoorext_anm", "matches", func_end );
  SoundSfx( "aud_use_matchesext_nearpubext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_rcdoorext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_leatherbagext" ] = { type = "get", get_obj = "spr_rcdoorext_leatherbagext", room = "rm_nearpubext", zz = "zz_rcdoorext", zz_gate = "gzz_nearpubext_rcdoorext" };

private.get_leatherbagext_logic = function()
  
end;
private.get_leatherbagext_inv = function()
  interface.InventoryItemAdd("inv_leatherbagext","spr_rcdoorext_leatherbagext");
  ObjSet( "inv_leatherbagext", { drag = 0 } );
end;
private.get_leatherbagext_beg = function()
  ObjDelete("gfx_rcdoorext_leatherbagext")
end;
private.get_leatherbagext_end = function()
  if common_impl.ZzCompleteCheck("get_leatherbagext") then ObjSet( common_impl.hint["get_leatherbagext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_rcdoorext_tr_leatherbag");
  ObjDetach("spr_rcdoorext_sh_leatherbagext");
  ObjDelete("spr_nearpubext_leatherbagext");
end;

cmn.AddSubscriber( "get_leatherbagext", private.get_leatherbagext_inv );
cmn.AddSubscriber( "get_leatherbagext", private.get_leatherbagext_beg, private.room_objname );
cmn.AddSubscriber( "get_leatherbagext", private.get_leatherbagext_end, private.room_objname );
cmn.AddSubscriber( "get_leatherbagext", private.get_leatherbagext_logic );
--------------------------------------------------------------------
function public.get_leatherbagext()
  cmn.SetEventDone( "get_leatherbagext" );
  cmn.CallEventHandler( "get_leatherbagext" );
  if common_impl.ZzCompleteCheck("get_leatherbagext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_tokenext_zone_clk()  -- rm_nearpubext.use_tokenext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_tokenext' );
  end;  
  
  SoundSfx( "aud_touch_very_small_metall" );
  ld.Lock(1);
  ld.AnimPlay( "anm_rcdoorext_anm_mailbox", "idle_b", func_end )
end;  



common_impl.hint[ "use_tokenext" ] = { type = "use", inv_obj = "inv_tokenext", use_place = "gfx_rcdoorext_tokenext_zone", room = "rm_nearpubext", zz = "zz_rcdoorext", zz_gate = "gzz_nearpubext_rcdoorext" };

private.use_tokenext_logic = function()
  ObjSet( "spr_rcdoorext_letterbext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_rcdoorext_letterbext", {active=1, visible = 1} );
end;
private.use_tokenext_inv = function()
  common_impl.ProcessMultiUseAll("tokenext", "tokenext")
end;
private.use_tokenext_beg = function()
  ObjDelete( "gfx_rcdoorext_tokenext_zone" );
end;
private.use_tokenext_end = function()
  if common_impl.ZzCompleteCheck("use_tokenext") then ObjSet( common_impl.hint["use_tokenext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_rcdoorext_anm_mailbox", {animfunc = "use_jetton", frame = 999 } );
  ObjDelete("spr_nearpubext_tr_box_1")
  ObjSet( "spr_nearpubext_tr_box_", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tokenext", private.use_tokenext_inv );
cmn.AddSubscriber( "use_tokenext", private.use_tokenext_beg, private.room_objname );
cmn.AddSubscriber( "use_tokenext", private.use_tokenext_end, private.room_objname );
cmn.AddSubscriber( "use_tokenext", private.use_tokenext_logic );
cmn.AddSubscriber( "use_tokenext_inv", private.use_tokenext_inv, private.room_objname );
cmn.AddSubscriber( "use_tokenext_beg", private.use_tokenext_beg, private.room_objname );
cmn.AddSubscriber( "use_tokenext_end", private.use_tokenext_end, private.room_objname );
cmn.AddSubscriber( "use_tokenext_end", private.use_tokenext_logic );
--------------------------------------------------------------------------------------------
function public.use_tokenext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tokenext" );
    cmn.CallEventHandler( "use_tokenext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_tokenext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tokenext_inv" );
  cmn.CallEventHandler( "use_tokenext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_rcdoorext_anm_mailbox", "use_jetton", func_end );
  SoundSfx( "aud_use_tokenext_nearpubext" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_letterbext" ] = { type = "get", get_obj = "spr_rcdoorext_letterbext", room = "rm_nearpubext", zz = "zz_rcdoorext", zz_gate = "gzz_nearpubext_rcdoorext" };

private.get_letterbext_logic = function()
  
end;
private.get_letterbext_inv = function()
  interface.InventoryItemAdd("inv_letterbext","spr_rcdoorext_letterbext");
end;
private.get_letterbext_beg = function()
  ObjDelete("gfx_rcdoorext_letterbext")
end;
private.get_letterbext_end = function()
  if common_impl.ZzCompleteCheck("get_letterbext") then ObjSet( common_impl.hint["get_letterbext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_rcdoorext_anm_mailbox", {animfunc = "end_jetton", frame = 0 } );
  ObjDelete("spr_nearpubext_tr_box_")
end;

cmn.AddSubscriber( "get_letterbext", private.get_letterbext_inv );
cmn.AddSubscriber( "get_letterbext", private.get_letterbext_beg, private.room_objname );
cmn.AddSubscriber( "get_letterbext", private.get_letterbext_end, private.room_objname );
cmn.AddSubscriber( "get_letterbext", private.get_letterbext_logic );
--------------------------------------------------------------------
function public.get_letterbext()
  ObjSet( "spr_rcdoorext_letterbext", {visible = 1} );
  cmn.SetEventDone( "get_letterbext" );
  cmn.CallEventHandler( "get_letterbext" );
  if common_impl.ZzCompleteCheck("get_letterbext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_coinext_zone_clk()  --rm_nearpubext.use_coinext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_coinext' )
  end;  
  
  SoundSfx( "aud_touch_medium_door" )
  ld.Lock(1);
  ld.AnimPlay( "anm_rcdoorext_anm_door", "idle_door", func_end )
end;

common_impl.hint[ "use_coinext" ] = { type = "use", inv_obj = "inv_coinext", use_place = "gfx_rcdoorext_coinext_zone", room = "rm_nearpubext", zz = "zz_rcdoorext", zz_gate = "gzz_nearpubext_rcdoorext" };

private.use_coinext_logic = function()
  ObjSet( "grm_nearpubext_mallext", { visible = 1, input = 1, active = 1 } )
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearpubext_mallext_focus");
    end;
end;
private.use_coinext_inv = function()
  common_impl.ProcessMultiUseAll("coinext", "coinext")
end;
private.use_coinext_beg = function()
  ObjDelete( "gfx_rcdoorext_coinext_zone" );
end;
private.use_coinext_end = function()
  if common_impl.ZzCompleteCheck("use_coinext") then ObjSet( common_impl.hint["use_coinext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_rcdoorext_anm_door", {animfunc = "open_door", frame = 999 } );
  ObjSet( "anm_rcdoorext_anm_mailbox", {animfunc = "use_coin", frame = 999 } );
  ObjDelete("fx_rcdoorext_p_light_red");
  ObjDelete("anm_nearpubext_anm_pub_open_m");
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_coinext", private.use_coinext_inv );
cmn.AddSubscriber( "use_coinext", private.use_coinext_beg, private.room_objname );
cmn.AddSubscriber( "use_coinext", private.use_coinext_end, private.room_objname );
cmn.AddSubscriber( "use_coinext", private.use_coinext_logic );
cmn.AddSubscriber( "use_coinext_inv", private.use_coinext_inv, private.room_objname );
cmn.AddSubscriber( "use_coinext_beg", private.use_coinext_beg, private.room_objname );
cmn.AddSubscriber( "use_coinext_end", private.use_coinext_end, private.room_objname );
cmn.AddSubscriber( "use_coinext_end", private.use_coinext_logic );
--------------------------------------------------------------------------------------------
function public.use_coinext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_coinext" );
    cmn.CallEventHandler( "use_coinext_end" );
    common_impl.Lock(0);
    --   if common_impl.ZzCompleteCheck("use_coinext") then ld.CloseSubRoom() end;
  end;

  local func_preend2 = function()
    ld.CloseSubRoom()
    ld.StartTimer( 0.5, function()
      SoundSfx( "aud_open_door_mall_nearpubext" );
      ld.AnimPlay( "anm_nearpubext_anm_pub_open_m", "open_m", func_end )
    end )
  end;  
  
  
  local func_preend = function()
   
    ld.AnimPlay( "anm_rcdoorext_anm_door", "open_door", func_preend2 )
  end;  
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_coinext_inv" );
  cmn.CallEventHandler( "use_coinext_beg" );
  common_impl.Lock(1);

  ObjAnimate( "fx_rcdoorext_p_light_red", 8, 0, 0, function() ObjSet( "fx_rcdoorext_p_light_red", {active=0, visible = 0} ); end, {0,0,1, 2.2,0,1, 2.4,0,0} );
  ld.AnimPlay( "anm_rcdoorext_anm_mailbox", "use_coin", func_preend );
  SoundSfx( "aud_use_coinext_nearpubext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_flowerbedext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.flowerbedext_flower_zone_clk()  --rm_nearpubext.flowerbedext_flower_zone_clk()
  local func_end = function()
     ObjSet( "obj_flowerbedext_flower_clk_zone", {input = 1} );
  end;  
  
  SoundSfx( "aud_touch_weed" ); 
  ObjSet( "obj_flowerbedext_flower_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_flowerbedext_anm_flower", "idle_4", func_end )
end;  
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_thistleext_zone_clk()  --rm_nearpubext.use_thistleext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_thistleext' )
  end;

  SoundSfx( "aud_touch_big_stone" );
  ld.Lock(1);
  ld.AnimPlay( "anm_flowerbedext_anm_1", "idle_1", func_end )  
end;  
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_thistleext" ] = { type = "use", inv_obj = "inv_thistleext", use_place = "gfx_flowerbedext_thistleext_zone", room = "rm_nearpubext", zz = "zz_flowerbedext", zz_gate = "gzz_nearpubext_flowerbedext" };

private.use_thistleext_logic = function()
  ObjSet( "spr_flowerbedext_earofwheatext", { visible = 1, input = 1, active = 1 } )
end;
private.use_thistleext_inv = function()
  common_impl.ProcessMultiUseAll("thistleext", "thistleext")
end;
private.use_thistleext_beg = function()
  ObjDelete( "gfx_flowerbedext_thistleext_zone" );
end;
private.use_thistleext_end = function()
  if common_impl.ZzCompleteCheck("use_thistleext") then ObjSet( common_impl.hint["use_thistleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_flowerbedext_anm_1");
  ObjDelete("spr_nearpubext_t_3");
  ObjSet( "spr_nearpubext_earofwheatext", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_thistleext", private.use_thistleext_inv );
cmn.AddSubscriber( "use_thistleext", private.use_thistleext_beg, private.room_objname );
cmn.AddSubscriber( "use_thistleext", private.use_thistleext_end, private.room_objname );
cmn.AddSubscriber( "use_thistleext", private.use_thistleext_logic );
cmn.AddSubscriber( "use_thistleext_inv", private.use_thistleext_inv, private.room_objname );
cmn.AddSubscriber( "use_thistleext_beg", private.use_thistleext_beg, private.room_objname );
cmn.AddSubscriber( "use_thistleext_end", private.use_thistleext_end, private.room_objname );
cmn.AddSubscriber( "use_thistleext_end", private.use_thistleext_logic );
--------------------------------------------------------------------------------------------
function public.use_thistleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_thistleext" );
    cmn.CallEventHandler( "use_thistleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_thistleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_thistleext_inv" );
  cmn.CallEventHandler( "use_thistleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_flowerbedext_anm_1", "use_thistle_1", func_end );
  SoundSfx( "aud_use_thistle_nearpubext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_earofwheatext" ] = { type = "get", get_obj = "spr_flowerbedext_earofwheatext", room = "rm_nearpubext", zz = "zz_flowerbedext", zz_gate = "gzz_nearpubext_flowerbedext" };

private.get_earofwheatext_logic = function()
  
end;
private.get_earofwheatext_inv = function()
  interface.InventoryItemAdd("inv_earofwheatext","spr_flowerbedext_earofwheatext");
end;
private.get_earofwheatext_beg = function()
  ObjDelete("gfx_flowerbedext_earofwheatext")
end;
private.get_earofwheatext_end = function()
  if common_impl.ZzCompleteCheck("get_earofwheatext") then ObjSet( common_impl.hint["get_earofwheatext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_flowerbedext_sh_earofwheatext");
  ObjDelete("spr_nearpubext_earofwheatext");
end;

cmn.AddSubscriber( "get_earofwheatext", private.get_earofwheatext_inv );
cmn.AddSubscriber( "get_earofwheatext", private.get_earofwheatext_beg, private.room_objname );
cmn.AddSubscriber( "get_earofwheatext", private.get_earofwheatext_end, private.room_objname );
cmn.AddSubscriber( "get_earofwheatext", private.get_earofwheatext_logic );
--------------------------------------------------------------------
function public.get_earofwheatext()
  cmn.SetEventDone( "get_earofwheatext" );
  cmn.CallEventHandler( "get_earofwheatext" );
  if common_impl.ZzCompleteCheck("get_earofwheatext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_twothistleext_zone_clk()  --rm_nearpubext.use_twothistleext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_twothistleext' )
  end;

  SoundSfx( "aud_touch_big_stone" );
  ld.Lock(1);
  ld.AnimPlay( "anm_flowerbedext_anm_2", "idle_2", func_end )  
end;  
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_twothistleext" ] = { type = "use", inv_obj = "inv_twothistleext", use_place = "gfx_flowerbedext_twothistleext_zone", room = "rm_nearpubext", zz = "zz_flowerbedext", zz_gate = "gzz_nearpubext_flowerbedext" };

private.use_twothistleext_logic = function()
  ObjSet( "spr_flowerbedext_pubemblemext3", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_flowerbedext_screwdriverext", { visible = 1, input = 1, active = 1 } )

end;
private.use_twothistleext_inv = function()
  common_impl.ProcessMultiUseAll("twothistleext", "twothistleext")
end;
private.use_twothistleext_beg = function()
  ObjDelete( "gfx_flowerbedext_twothistleext_zone" );
end;
private.use_twothistleext_end = function()
  if common_impl.ZzCompleteCheck("use_twothistleext") then ObjSet( common_impl.hint["use_twothistleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_flowerbedext_anm_2")
  ObjDelete("spr_nearpubext_t_2");
  ObjSet( "spr_nearpubext_screwdriverext", {visible = 1} );
  ObjSet( "spr_nearpubext_pubemblemext3", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_twothistleext", private.use_twothistleext_inv );
cmn.AddSubscriber( "use_twothistleext", private.use_twothistleext_beg, private.room_objname );
cmn.AddSubscriber( "use_twothistleext", private.use_twothistleext_end, private.room_objname );
cmn.AddSubscriber( "use_twothistleext", private.use_twothistleext_logic );
cmn.AddSubscriber( "use_twothistleext_inv", private.use_twothistleext_inv, private.room_objname );
cmn.AddSubscriber( "use_twothistleext_beg", private.use_twothistleext_beg, private.room_objname );
cmn.AddSubscriber( "use_twothistleext_end", private.use_twothistleext_end, private.room_objname );
cmn.AddSubscriber( "use_twothistleext_end", private.use_twothistleext_logic );
--------------------------------------------------------------------------------------------
function public.use_twothistleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_twothistleext" );
    cmn.CallEventHandler( "use_twothistleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_twothistleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_twothistleext_inv" );
  cmn.CallEventHandler( "use_twothistleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_flowerbedext_anm_2", "use_thistle_2", func_end );
  ld.StartTimer( 0.35, function() SoundSfx( "aud_use_thistle_nearpubext" ); end ) 
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pubemblemext3" ] = { type = "get", get_obj = "spr_flowerbedext_pubemblemext3", room = "rm_nearpubext", zz = "zz_flowerbedext", zz_gate = "gzz_nearpubext_flowerbedext" };

private.get_pubemblemext3_logic = function()
  
end;
private.get_pubemblemext3_inv = function()
  interface.InventoryItemAdd("inv_pubemblemext","spr_flowerbedext_pubemblemext3",function() level_inv.ProcessGetPubemblemextAll( "get_pubemblemext3" ) end);
end;
private.get_pubemblemext3_beg = function()
  ObjDelete("gfx_flowerbedext_pubemblemext3")
end;
private.get_pubemblemext3_end = function()
  if common_impl.ZzCompleteCheck("get_pubemblemext3") then ObjSet( common_impl.hint["get_pubemblemext3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_flowerbedext_sh_pubemblemext3");
  ObjDelete("spr_nearpubext_pubemblemext3");
end;

cmn.AddSubscriber( "get_pubemblemext3", private.get_pubemblemext3_inv );
cmn.AddSubscriber( "get_pubemblemext3", private.get_pubemblemext3_beg, private.room_objname );
cmn.AddSubscriber( "get_pubemblemext3", private.get_pubemblemext3_end, private.room_objname );
cmn.AddSubscriber( "get_pubemblemext3", private.get_pubemblemext3_logic );
--------------------------------------------------------------------
function public.get_pubemblemext3()
  cmn.SetEventDone( "get_pubemblemext3" );
  cmn.CallEventHandler( "get_pubemblemext3" );
  if common_impl.ZzCompleteCheck("get_pubemblemext3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_screwdriverext" ] = { type = "get", get_obj = "spr_flowerbedext_screwdriverext", room = "rm_nearpubext", zz = "zz_flowerbedext", zz_gate = "gzz_nearpubext_flowerbedext" };

private.get_screwdriverext_logic = function()
  
end;
private.get_screwdriverext_inv = function()
  interface.InventoryItemAdd("inv_screwdriverext","spr_flowerbedext_screwdriverext");
end;
private.get_screwdriverext_beg = function()
  ObjDelete("gfx_flowerbedext_screwdriverext")
end;
private.get_screwdriverext_end = function()
  if common_impl.ZzCompleteCheck("get_screwdriverext") then ObjSet( common_impl.hint["get_screwdriverext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_flowerbedext_sh_screwdriverext");
  ObjDelete("spr_nearpubext_screwdriverext");
end;

cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_inv );
cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_beg, private.room_objname );
cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_end, private.room_objname );
cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_logic );
--------------------------------------------------------------------
function public.get_screwdriverext()
  cmn.SetEventDone( "get_screwdriverext" );
  cmn.CallEventHandler( "get_screwdriverext" );
  if common_impl.ZzCompleteCheck("get_screwdriverext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_threethistleext_zone_clk()  --rm_nearpubext.use_threethistleext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_threethistleext' )
  end;

  SoundSfx( "aud_touch_big_stone" );
  ld.Lock(1);
  ld.AnimPlay( "anm_flowerbedext_anm_3", "idle_3", func_end )  
end;  
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_threethistleext" ] = { type = "use", inv_obj = "inv_threethistleext", use_place = "gfx_flowerbedext_threethistleext_zone", room = "rm_nearpubext", zz = "zz_flowerbedext", zz_gate = "gzz_nearpubext_flowerbedext" };

private.use_threethistleext_logic = function()
  ObjSet( "spr_flowerbedext_maracasext", { visible = 1, input = 1, active = 1 } )

end;
private.use_threethistleext_inv = function()
  common_impl.ProcessMultiUseAll("threethistleext", "threethistleext")
end;
private.use_threethistleext_beg = function()
  ObjDelete( "gfx_flowerbedext_threethistleext_zone" );
end;
private.use_threethistleext_end = function()
  if common_impl.ZzCompleteCheck("use_threethistleext") then ObjSet( common_impl.hint["use_threethistleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_flowerbedext_anm_3",{animfunc="use_thistle_3", frame=999});
  ObjDelete("spr_nearpubext_t_1")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_threethistleext", private.use_threethistleext_inv );
cmn.AddSubscriber( "use_threethistleext", private.use_threethistleext_beg, private.room_objname );
cmn.AddSubscriber( "use_threethistleext", private.use_threethistleext_end, private.room_objname );
cmn.AddSubscriber( "use_threethistleext", private.use_threethistleext_logic );
cmn.AddSubscriber( "use_threethistleext_inv", private.use_threethistleext_inv, private.room_objname );
cmn.AddSubscriber( "use_threethistleext_beg", private.use_threethistleext_beg, private.room_objname );
cmn.AddSubscriber( "use_threethistleext_end", private.use_threethistleext_end, private.room_objname );
cmn.AddSubscriber( "use_threethistleext_end", private.use_threethistleext_logic );
--------------------------------------------------------------------------------------------
function public.use_threethistleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_threethistleext" );
    cmn.CallEventHandler( "use_threethistleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_threethistleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_threethistleext_inv" );
  cmn.CallEventHandler( "use_threethistleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_flowerbedext_anm_3", "use_thistle_3", func_end );
  ld.StartTimer( 0.5, function() SoundSfx( "aud_use_thistle_nearpubext" ); end ) 
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_maracasext" ] = { type = "get", get_obj = "spr_flowerbedext_maracasext", room = "rm_nearpubext", zz = "zz_flowerbedext", zz_gate = "gzz_nearpubext_flowerbedext" };

private.get_maracasext_logic = function()
  
end;
private.get_maracasext_inv = function()
  interface.InventoryItemAdd("inv_maracasext","spr_flowerbedext_maracasext");
end;
private.get_maracasext_beg = function()
  ObjDelete("gfx_flowerbedext_maracasext")
end;
private.get_maracasext_end = function()
  if common_impl.ZzCompleteCheck("get_maracasext") then ObjSet( common_impl.hint["get_maracasext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_flowerbedext_sh_maracasext");
  ObjDelete("spr_nearpubext_maracasext");
end;

cmn.AddSubscriber( "get_maracasext", private.get_maracasext_inv );
cmn.AddSubscriber( "get_maracasext", private.get_maracasext_beg, private.room_objname );
cmn.AddSubscriber( "get_maracasext", private.get_maracasext_end, private.room_objname );
cmn.AddSubscriber( "get_maracasext", private.get_maracasext_logic );
--------------------------------------------------------------------
function public.get_maracasext()
  cmn.SetEventDone( "get_maracasext" );
  cmn.CallEventHandler( "get_maracasext" );
  if common_impl.ZzCompleteCheck("get_maracasext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cellarext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_beermugext_zone_clk()  -- rm_nearpubext.use_beermugext_zone_clk() 
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_beermugext' )
  end;  

  SoundSfx( "aud_touch_medium_door" )
  ld.Lock(1);
  ld.AnimPlay( "anm_cellarext_anm_beer", "idle", func_end )
end;  
-----------------------------------------------------------------------
common_impl.hint[ "use_beermugext" ] = { type = "use", inv_obj = "inv_beermugext", use_place = "gfx_cellarext_beermugext_zone", room = "rm_nearpubext", zz = "zz_cellarext", zz_gate = "gzz_nearpubext_cellarext" };

private.use_beermugext_logic = function()
  ObjSet( "spr_cellarext_albumext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_cellarext_ballerinaext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_cellarext_wineglassext_zone", {active=1, input = 1, visible = 1} );
  ObjSet( "gfx_cellarext_bottleext1_zone", {active=1, input = 1, visible = 1} );
  ObjSet( "gfx_cellarext_bottleext2_zone", {active=1, input = 1, visible = 1} );
end;
private.use_beermugext_inv = function()
  common_impl.ProcessMultiUseAll("beermugext", "beermugext")
end;
private.use_beermugext_beg = function()
  ObjDelete( "gfx_cellarext_beermugext_zone" );
end;
private.use_beermugext_end = function()
  if common_impl.ZzCompleteCheck("use_beermugext") then ObjSet( common_impl.hint["use_beermugext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_cellarext_sh_albumext", {visible = 1} );
  ObjSet( "spr_cellarext_sh_ballerinaext", {visible = 1} );
  ObjSet( "anm_cellarext_anm_beer",{animfunc="end", frame=0});
  ObjSet( "anm_cellarext_anm_wine", {visible = 1} );
  ObjSet( "anm_cellarext_anm_bottle_door", {visible = 1} );
  ObjDelete("spr_nearpubext_tr_3")
  ObjSet( "spr_nearpubext_tr_3_open", {visible = 1} );
  ObjSet( "spr_cellarext_paper", {input = 1} );
  ObjSet( "spr_nearpubext_paper", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_beermugext", private.use_beermugext_inv );
cmn.AddSubscriber( "use_beermugext", private.use_beermugext_beg, private.room_objname );
cmn.AddSubscriber( "use_beermugext", private.use_beermugext_end, private.room_objname );
cmn.AddSubscriber( "use_beermugext", private.use_beermugext_logic );
cmn.AddSubscriber( "use_beermugext_inv", private.use_beermugext_inv, private.room_objname );
cmn.AddSubscriber( "use_beermugext_beg", private.use_beermugext_beg, private.room_objname );
cmn.AddSubscriber( "use_beermugext_end", private.use_beermugext_end, private.room_objname );
cmn.AddSubscriber( "use_beermugext_end", private.use_beermugext_logic );
--------------------------------------------------------------------------------------------
function public.use_beermugext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_beermugext" );
    cmn.CallEventHandler( "use_beermugext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_beermugext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_beermugext_inv" );
  cmn.CallEventHandler( "use_beermugext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cellarext_anm_beer", "use_mug", func_end );
  SoundSfx( "aud_use_beermugext_nearpubext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_albumext" ] = { type = "get", get_obj = "spr_cellarext_albumext", room = "rm_nearpubext", zz = "zz_cellarext", zz_gate = "gzz_nearpubext_cellarext" };

private.get_albumext_logic = function()
  
end;
private.get_albumext_inv = function()
  interface.InventoryItemAdd("inv_albumext","spr_cellarext_albumext");
end;
private.get_albumext_beg = function()
  ObjDelete("gfx_cellarext_albumext")
end;
private.get_albumext_end = function()
  if common_impl.ZzCompleteCheck("get_albumext") then ObjSet( common_impl.hint["get_albumext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cellarext_sh_albumext");
  ObjDelete("spr_nearpubext_albumext")
end;

cmn.AddSubscriber( "get_albumext", private.get_albumext_inv );
cmn.AddSubscriber( "get_albumext", private.get_albumext_beg, private.room_objname );
cmn.AddSubscriber( "get_albumext", private.get_albumext_end, private.room_objname );
cmn.AddSubscriber( "get_albumext", private.get_albumext_logic );
--------------------------------------------------------------------
function public.get_albumext()
  cmn.SetEventDone( "get_albumext" );
  cmn.CallEventHandler( "get_albumext" );
  if common_impl.ZzCompleteCheck("get_albumext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ballerinaext" ] = { type = "get", get_obj = "spr_cellarext_ballerinaext", room = "rm_nearpubext", zz = "zz_cellarext", zz_gate = "gzz_nearpubext_cellarext" };

private.get_ballerinaext_logic = function()
  
end;
private.get_ballerinaext_inv = function()
  interface.InventoryItemAdd("inv_ballerinaext","spr_cellarext_ballerinaext");
end;
private.get_ballerinaext_beg = function()
  ObjDelete("gfx_cellarext_ballerinaext")
end;
private.get_ballerinaext_end = function()
  if common_impl.ZzCompleteCheck("get_ballerinaext") then ObjSet( common_impl.hint["get_ballerinaext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cellarext_sh_ballerinaext");
  ObjDelete("spr_nearpubext_ballerinaext")
end;

cmn.AddSubscriber( "get_ballerinaext", private.get_ballerinaext_inv );
cmn.AddSubscriber( "get_ballerinaext", private.get_ballerinaext_beg, private.room_objname );
cmn.AddSubscriber( "get_ballerinaext", private.get_ballerinaext_end, private.room_objname );
cmn.AddSubscriber( "get_ballerinaext", private.get_ballerinaext_logic );
--------------------------------------------------------------------
function public.get_ballerinaext()
  cmn.SetEventDone( "get_ballerinaext" );
  cmn.CallEventHandler( "get_ballerinaext" );
  if common_impl.ZzCompleteCheck("get_ballerinaext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_wineglassext_zone_clk()  --rm_nearpubext.use_wineglassext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_wineglassext' )
  end;

  ld.Lock(1);  
  SoundSfx( "aud_touch_small_plastic" )
  ld.AnimPlay( "anm_cellarext_anm_wine", "idle_box_2", func_end )
end; 
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wineglassext" ] = { type = "use", inv_obj = "inv_wineglassext", use_place = "gfx_cellarext_wineglassext_zone", room = "rm_nearpubext", zz = "zz_cellarext", zz_gate = "gzz_nearpubext_cellarext" };

private.use_wineglassext_logic = function()
  ObjSet( "spr_cellarext_buttonext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_cellarext_buttonext", {active=1, visible=1} );
end;
private.use_wineglassext_inv = function()
  common_impl.ProcessMultiUseAll("wineglassext", "wineglassext")
end;
private.use_wineglassext_beg = function()
  ObjDelete( "gfx_cellarext_wineglassext_zone" );
end;
private.use_wineglassext_end = function()
  if common_impl.ZzCompleteCheck("use_wineglassext") then ObjSet( common_impl.hint["use_wineglassext"].zz_gate, { visible = 0, input = 0 } ); end;
  --  ObjSet( "spr_cellarext_sh_buttonext", {visible = 1} );
  ObjSet( "anm_cellarext_anm_wine",{animfunc="use_wineglass", frame=999});
  ObjSet( "spr_nearpubext_buttonext", {visible = 1} );
  ObjDelete("spr_nearpubext_cover_2");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wineglassext", private.use_wineglassext_inv );
cmn.AddSubscriber( "use_wineglassext", private.use_wineglassext_beg, private.room_objname );
cmn.AddSubscriber( "use_wineglassext", private.use_wineglassext_end, private.room_objname );
cmn.AddSubscriber( "use_wineglassext", private.use_wineglassext_logic );
cmn.AddSubscriber( "use_wineglassext_inv", private.use_wineglassext_inv, private.room_objname );
cmn.AddSubscriber( "use_wineglassext_beg", private.use_wineglassext_beg, private.room_objname );
cmn.AddSubscriber( "use_wineglassext_end", private.use_wineglassext_end, private.room_objname );
cmn.AddSubscriber( "use_wineglassext_end", private.use_wineglassext_logic );
--------------------------------------------------------------------------------------------
function public.use_wineglassext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wineglassext" );
    cmn.CallEventHandler( "use_wineglassext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wineglassext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wineglassext_inv" );
  cmn.CallEventHandler( "use_wineglassext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cellarext_anm_wine", "use_wineglass", func_end );
  SoundSfx( "aud_use_wineglassext_nearpubext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_buttonext" ] = { type = "get", get_obj = "spr_cellarext_buttonext", room = "rm_nearpubext", zz = "zz_cellarext", zz_gate = "gzz_nearpubext_cellarext" };

private.get_buttonext_logic = function()
  
end;
private.get_buttonext_inv = function()
  interface.InventoryItemAdd("inv_buttonext","spr_cellarext_buttonext");
end;
private.get_buttonext_beg = function()
  ObjDelete("gfx_cellarext_buttonext")
end;
private.get_buttonext_end = function()
  if common_impl.ZzCompleteCheck("get_buttonext") then ObjSet( common_impl.hint["get_buttonext"].zz_gate, { visible = 0, input = 0 } ); end;
  -- ObjDelete("spr_cellarext_sh_buttonext");
  ObjSet( "anm_cellarext_anm_wine",{animfunc="end_wineglass", frame=0});
  ObjDelete("spr_nearpubext_buttonext");
end;

cmn.AddSubscriber( "get_buttonext", private.get_buttonext_inv );
cmn.AddSubscriber( "get_buttonext", private.get_buttonext_beg, private.room_objname );
cmn.AddSubscriber( "get_buttonext", private.get_buttonext_end, private.room_objname );
cmn.AddSubscriber( "get_buttonext", private.get_buttonext_logic );
--------------------------------------------------------------------
function public.get_buttonext()
  ObjSet( "spr_cellarext_buttonext", {visible = 1} );
  cmn.SetEventDone( "get_buttonext" );
  cmn.CallEventHandler( "get_buttonext" );
  if common_impl.ZzCompleteCheck("get_buttonext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_bottleext_zone_clk(num) --rm_nearpubext.use_bottleext_zone_clk(1)
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( "need_bottleext"..num )
  end;  
  
  ld.Lock(1);
  if not cmn.IsEventDone("use_bottleext1") and not cmn.IsEventDone("use_bottleext2") then 
    SoundSfx( "aud_touch_small_wood" );
    ld.AnimPlay( "anm_cellarext_anm_bottle_door", "idle_box_1", func_end )
  else 
    func_end();
  end;  
end;  


common_impl.hint[ "use_bottleext1" ] = { type = "use", inv_obj = "inv_bottleext1", use_place = "gfx_cellarext_bottleext1_zone", room = "rm_nearpubext", zz = "zz_cellarext", zz_gate = "gzz_nearpubext_cellarext" };

private.use_bottleext1_logic = function()
  if ld.CheckRequirements( {"use_bottleext1","use_bottleext2"} ) then
    ObjSet( "spr_cellarext_skittleext3", { visible = 0, input = 1, active = 1 } )
    ObjSet( "gfx_cellarext_skittleext3", {active=1, visible = 1} );
  end;

end;
private.use_bottleext1_inv = function()
  common_impl.ProcessMultiUseAll("bottleext1", "bottleext1")
end;
private.use_bottleext1_beg = function()
  ObjDelete( "gfx_cellarext_bottleext1_zone" );
end;
private.use_bottleext1_end = function()
  if common_impl.ZzCompleteCheck("use_bottleext1") then ObjSet( common_impl.hint["use_bottleext1"].zz_gate, { visible = 0, input = 0 } ); end;
  
  if ld.CheckRequirements( {"use_bottleext1","use_bottleext2"} ) then
    ObjDelete("anm_cellarext_anm_bottle1");
    ObjDelete("anm_cellarext_anm_bottle2");
    ObjSet( "anm_cellarext_anm_bottle_door",{animfunc="open_box", frame=999});
    ObjDelete("spr_nearpubext_bottle_1");
    ObjDelete("spr_nearpubext_bottle_2");
    ObjDelete("spr_nearpubext_cover_1");
    ObjSet( "spr_nearpubext_open_1", {visible = 1} );
    ObjSet( "spr_nearpubext_skittleext3", {visible = 1} );
    --  ObjSet( "spr_cellarext_sh_skittleext3", {visible = 1} );
  else 
    ObjSet( "anm_cellarext_anm_bottle1", {animfunc = "use_bottle_1", frame = 999 } );
    ObjSet( "spr_nearpubext_bottle_1", {visible = 1} );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bottleext1", private.use_bottleext1_inv );
cmn.AddSubscriber( "use_bottleext1", private.use_bottleext1_beg, private.room_objname );
cmn.AddSubscriber( "use_bottleext1", private.use_bottleext1_end, private.room_objname );
cmn.AddSubscriber( "use_bottleext1", private.use_bottleext1_logic );
cmn.AddSubscriber( "use_bottleext1_inv", private.use_bottleext1_inv, private.room_objname );
cmn.AddSubscriber( "use_bottleext1_beg", private.use_bottleext1_beg, private.room_objname );
cmn.AddSubscriber( "use_bottleext1_end", private.use_bottleext1_end, private.room_objname );
cmn.AddSubscriber( "use_bottleext1_end", private.use_bottleext1_logic );
--------------------------------------------------------------------------------------------
function public.use_bottleext1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bottleext1" );
    cmn.CallEventHandler( "use_bottleext1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bottleext1") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    if ld.CheckRequirements( {"use_bottleext2"} ) then
       ObjSet( "anm_cellarext_anm_bottle1", {visible = 0} );    
       ObjSet( "anm_cellarext_anm_bottle2", {visible = 0} );
       ObjSet( "anm_cellarext_anm_bottle_door", {animfunc = "open_box", frame = 0 } );
       SoundSfx( "aud_open_fish_box_nearpubext" )
       ld.AnimPlay( "anm_cellarext_anm_bottle_door", "open_box", func_end )
    else
       func_end();
    end;  
  end;  
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bottleext1_inv" );
  cmn.CallEventHandler( "use_bottleext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cellarext_anm_bottle1", "use_bottle_1", func_preend );
  SoundSfx( "aud_use_bottleext1_nearpubext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bottleext2" ] = { type = "use", inv_obj = "inv_bottleext2", use_place = "gfx_cellarext_bottleext2_zone", room = "rm_nearpubext", zz = "zz_cellarext", zz_gate = "gzz_nearpubext_cellarext" };

private.use_bottleext2_logic = function()
  if ld.CheckRequirements( {"use_bottleext2","use_bottleext1"} ) then
    ObjSet( "spr_cellarext_skittleext3", { visible = 0, input = 1, active = 1 } )
    ObjSet( "gfx_cellarext_skittleext3", {active=1, visible = 1} );
  end;

end;
private.use_bottleext2_inv = function()
  common_impl.ProcessMultiUseAll("bottleext2", "bottleext2")
end;
private.use_bottleext2_beg = function()
  ObjDelete( "gfx_cellarext_bottleext2_zone" );
end;
private.use_bottleext2_end = function()
  if common_impl.ZzCompleteCheck("use_bottleext2") then ObjSet( common_impl.hint["use_bottleext2"].zz_gate, { visible = 0, input = 0 } ); end;
  
  if ld.CheckRequirements( {"use_bottleext1","use_bottleext2"} ) then
    ObjDelete("anm_cellarext_anm_bottle1");
    ObjDelete("anm_cellarext_anm_bottle2");
    ObjSet( "anm_cellarext_anm_bottle_door",{animfunc="open_box", frame=999});
    --  ObjSet( "spr_cellarext_sh_skittleext3", {visible = 1} );
    ObjDelete("spr_nearpubext_bottle_1");
    ObjDelete("spr_nearpubext_bottle_2");
    ObjDelete("spr_nearpubext_cover_1");
    ObjSet( "spr_nearpubext_open_1", {visible = 1} );
    ObjSet( "spr_nearpubext_skittleext3", {visible = 1} );
  else 
    ObjSet( "anm_cellarext_anm_bottle2", {animfunc = "use_bottle_2", frame = 999 } );
    ObjSet( "spr_nearpubext_bottle_2", {visible = 1} );
  end;  
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bottleext2", private.use_bottleext2_inv );
cmn.AddSubscriber( "use_bottleext2", private.use_bottleext2_beg, private.room_objname );
cmn.AddSubscriber( "use_bottleext2", private.use_bottleext2_end, private.room_objname );
cmn.AddSubscriber( "use_bottleext2", private.use_bottleext2_logic );
cmn.AddSubscriber( "use_bottleext2_inv", private.use_bottleext2_inv, private.room_objname );
cmn.AddSubscriber( "use_bottleext2_beg", private.use_bottleext2_beg, private.room_objname );
cmn.AddSubscriber( "use_bottleext2_end", private.use_bottleext2_end, private.room_objname );
cmn.AddSubscriber( "use_bottleext2_end", private.use_bottleext2_logic );
--------------------------------------------------------------------------------------------
function public.use_bottleext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bottleext2" );
    cmn.CallEventHandler( "use_bottleext2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bottleext2") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    if ld.CheckRequirements( {"use_bottleext1"} ) then
       ObjSet( "anm_cellarext_anm_bottle1", {visible = 0} );    
       ObjSet( "anm_cellarext_anm_bottle2", {visible = 0} );
       ObjSet( "anm_cellarext_anm_bottle_door", {animfunc = "open_box", frame = 0 } );
       SoundSfx( "aud_open_fish_box_nearpubext" )
       ld.AnimPlay( "anm_cellarext_anm_bottle_door", "open_box", func_end )
    else
       func_end();
    end;  
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bottleext2_inv" );
  cmn.CallEventHandler( "use_bottleext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cellarext_anm_bottle2", "use_bottle_2", func_preend );
  SoundSfx( "aud_use_bottleext2_nearpubext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_skittleext3" ] = { type = "get", get_obj = "spr_cellarext_skittleext3", room = "rm_nearpubext", zz = "zz_cellarext", zz_gate = "gzz_nearpubext_cellarext" };

private.get_skittleext3_logic = function()
  
end;
private.get_skittleext3_inv = function()
  interface.InventoryItemAdd("inv_skittleext","spr_cellarext_skittleext3",function() level_inv.ProcessGetSkittleextAll( "get_skittleext3" ) end);
end;
private.get_skittleext3_beg = function()
  ObjDelete("gfx_cellarext_skittleext3")
end;
private.get_skittleext3_end = function()
  if common_impl.ZzCompleteCheck("get_skittleext3") then ObjSet( common_impl.hint["get_skittleext3"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjDelete("spr_cellarext_sh_skittleext3")
  ObjSet( "anm_cellarext_anm_bottle_door",{animfunc="end_open_box", frame=999});
  ObjDelete("spr_nearpubext_skittleext3")
end;

cmn.AddSubscriber( "get_skittleext3", private.get_skittleext3_inv );
cmn.AddSubscriber( "get_skittleext3", private.get_skittleext3_beg, private.room_objname );
cmn.AddSubscriber( "get_skittleext3", private.get_skittleext3_end, private.room_objname );
cmn.AddSubscriber( "get_skittleext3", private.get_skittleext3_logic );
--------------------------------------------------------------------
function public.get_skittleext3()
  ObjSet( "spr_cellarext_skittleext3", {visible = 1} );
  cmn.SetEventDone( "get_skittleext3" );
  cmn.CallEventHandler( "get_skittleext3" );
  if common_impl.ZzCompleteCheck("get_skittleext3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_pubmgext_for_nearpubext = function()
    if ld.CheckRequirements( {"win_pubmgext"} ) then
      ObjSet( "gmg_nearpubext_pubmgext", {input = 0, visible = 0} );
      ObjSet( "grm_nearpubext_pubext", {input = 1,active = 1, visible = 1} );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nearpubext_pubext_focus");
      end;
      ObjSet( "obj_nearpubext_pubdoor_tr_tr_root", {visible = 0} );
      ObjSet( "anm_nearpubext_anm_pub_open_p", {visible = 1} );
    end
  end;
  cmn.AddSubscriber("win_pubmgext", win_pubmgext_for_nearpubext, private.room_objname )
  
  local win_pubmgextinnearpubext = function()
    if ld.CheckRequirements( {"win_pubmgextinnearpubext"} ) then
      ObjSet( "anm_nearpubext_anm_pub_open_p", {animfunc="open_p", frame=999, visible=1} );
    end
  end;
  cmn.AddSubscriber("win_pubmgextinnearpubext", win_pubmgextinnearpubext, private.room_objname )

  
  function public.win_pubmgextinnearpubext()
    local func_end = function()
       ld.Lock(0);
       cmn.SetEventDone( "win_pubmgextinnearpubext" );
       cmn.CallEventHandler( "win_pubmgextinnearpubext" );
    end;  
    
    ld.Lock(1);
    SoundSfx( "aud_open_door_nearpubext" )
    ld.AnimPlay( "anm_nearpubext_anm_pub_open_p", "open_p", func_end )  
  end;  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_nearpubext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_nearpubext_env" )
  --if cmn.IsEventDone("win_pubmgext") then 
  --  ObjSet( "obj_nearpubext_pubdoor_tr_tr_root", {visible = 0} );
  --  ObjSet( "spr_nearpubext_door_pub", {visible = 1} );
  --end;  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_cellarext" );
  function zz_cellarext.Open()
  end;
  function zz_cellarext.PreOpen()
  end;
  function zz_cellarext.PreClose()
  end;
  function zz_cellarext.Close()
  end;

  subroom.Define( "zz_flowerbedext" );
  function zz_flowerbedext.Open()
  end;
  function zz_flowerbedext.PreOpen()
  end;
  function zz_flowerbedext.PreClose()
  end;
  function zz_flowerbedext.Close()
  end;

  subroom.Define( "zz_rcdoorext" );
  function zz_rcdoorext.Open()
  end;
  function zz_rcdoorext.PreOpen()
  end;
  function zz_rcdoorext.PreClose()
  end;
  function zz_rcdoorext.Close()
  end;

  subroom.Define( "zz_pubdoorext" );
  function zz_pubdoorext.Open()
  end;
  function zz_pubdoorext.PreOpen()
  end;
  function zz_pubdoorext.PreClose()
  end;
  function zz_pubdoorext.Close()
  end;

  subroom.Define( "zz_signext" );
  function zz_signext.Open()
  end;
  function zz_signext.PreOpen()
  end;
  function zz_signext.PreClose()
  end;
  function zz_signext.Close()
  end;
  
end;
--*********************************************************************************************************************
--------------------------- other funcs--------------------------
function public.nearpubext_click_1_zone_clk()
  local func_end = function()
     ObjSet( "obj_nearpubext_click_1_zone", {input = 1} );
  end;  
  
  SoundSfx( "aud_touch_small_plastic" ); 
  ld.AnimPlay( "anm_nearpubext_anm_pub_click_1", "click_1", func_end )
  ObjSet( "obj_nearpubext_click_1_zone", {input = 0} );
end;  


-----------------------------------------------------------------
local nearpubext_click_2_zone_clk_flag = false;
function public.nearpubext_click_2_zone_clk()
  local func_end = function()
    ObjSet( "obj_nearpubext_click_2_zone", {input = 1} );
  end;  
  
  if not nearpubext_click_2_zone_clk_flag then  
     ld.AnimPlay( "anm_nearpubext_anm_pub_lamp", "click2_1", func_end )
     nearpubext_click_2_zone_clk_flag = true;
     SoundSfx( "aud_light_on_nearpubext" );
  else
     ld.AnimPlay( "anm_nearpubext_anm_pub_lamp", "click2_2", func_end )
     nearpubext_click_2_zone_clk_flag = false;
     SoundSfx( "aud_light_off_nearpubext" );
  end;   
  
  ObjSet( "obj_nearpubext_click_2_zone", {input = 0} );
end;  
----------------------------------------------------------