-- name=rm_ruralroadext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_ruralroadext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  ld.NoteInit("spr_mailboxext_paper","spr_mailboxext_paper_big");
  -----------------------------------------------------------------------------------------------------------------------------------------
function private.opn_ruralroadext()
  if not ( cmn.IsEventDone( "opn_ruralroadext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_ruralroadext" );
      cmn.CallEventHandler( "opn_ruralroadext" )
      --ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opnruralroadext");
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_ruralroadext = function() end;
local opn_ruralroadext_logic = function() end;
cmn.AddSubscriber( "opn_ruralroadext", opn_ruralroadext_logic )
cmn.AddSubscriber( "opn_ruralroadext", opn_ruralroadext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_mailboxext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_ladybugext" ] = { type = "get", get_obj = "spr_mailboxext_ladybugext", room = "rm_ruralroadext", zz = "zz_mailboxext", zz_gate = "gzz_ruralroadext_mailboxext" };

private.get_ladybugext_logic = function()
  ObjSet("gfx_mailboxext_leverext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_ladybugext_inv = function()
  interface.InventoryItemAdd("inv_ladybugext","spr_mailboxext_ladybugext");
end;
private.get_ladybugext_beg = function()
  ObjDelete("gfx_mailboxext_ladybugext")
end;
private.get_ladybugext_end = function()
  ObjDelete("spr_mailboxext_sh_ladybugext")
  ObjDelete("spr_ruralroadext_ladybugext")
  ObjDelete("spr_mailboxext_tr_cover_1")
  if common_impl.ZzCompleteCheck("get_ladybugext") then ObjSet( common_impl.hint["get_ladybugext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_ladybugext", private.get_ladybugext_inv );
cmn.AddSubscriber( "get_ladybugext", private.get_ladybugext_beg, private.room_objname );
cmn.AddSubscriber( "get_ladybugext", private.get_ladybugext_end, private.room_objname );
cmn.AddSubscriber( "get_ladybugext", private.get_ladybugext_logic );
--------------------------------------------------------------------
function public.get_ladybugext()
  cmn.SetEventDone( "get_ladybugext" );
  cmn.CallEventHandler( "get_ladybugext" );
  if common_impl.ZzCompleteCheck("get_ladybugext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_leverext" ] = { type = "use", inv_obj = "inv_leverext", use_place = "gfx_mailboxext_leverext_zone", room = "rm_ruralroadext", zz = "zz_mailboxext", zz_gate = "gzz_ruralroadext_mailboxext" };

private.use_leverext_logic = function()
  ObjSet( "spr_mailbox_yellowwireext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_mailboxext_paper", {input = 1, visible = 1} );
end;
private.use_leverext_inv = function()
  common_impl.ProcessMultiUseAll("leverext", "leverext")
end;
private.use_leverext_beg = function()
  ObjDelete( "gfx_mailboxext_leverext_zone" );
end;
private.use_leverext_end = function()
  ObjSet( "spr_rm_ruralroadext_open_mail", {alp = 1} );
  -- ObjSet( "spr_ruralroadext_parcelext", {alp = 1} );
  -- ObjSet( "spr_mailboxext_sh_parcelext", {alp = 1} );
  ObjSet( "spr_ruralroadext_tr_yellowwireext", {visible = 1} );
  ObjSet( "spr_ruralroadext_tr_paper", {visible = 1} );
  ObjSet( "anm_mailboxext_anm_lever", {animfunc="end_lever",frame=0} );
  if common_impl.ZzCompleteCheck("use_leverext") then ObjSet( common_impl.hint["use_leverext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_leverext", private.use_leverext_inv );
cmn.AddSubscriber( "use_leverext", private.use_leverext_beg, private.room_objname );
cmn.AddSubscriber( "use_leverext", private.use_leverext_end, private.room_objname );
cmn.AddSubscriber( "use_leverext", private.use_leverext_logic );
cmn.AddSubscriber( "use_leverext_inv", private.use_leverext_inv, private.room_objname );
cmn.AddSubscriber( "use_leverext_beg", private.use_leverext_beg, private.room_objname );
cmn.AddSubscriber( "use_leverext_end", private.use_leverext_end, private.room_objname );
cmn.AddSubscriber( "use_leverext_end", private.use_leverext_logic );
--------------------------------------------------------------------------------------------
function public.use_leverext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_leverext" );
    cmn.CallEventHandler( "use_leverext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_leverext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_leverext_inv" );
  cmn.CallEventHandler( "use_leverext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mailboxext_anm_lever", "use_lever", func_end );
  SoundSfx( "aud_use_leverext_ruralroadext" )


end;
--------------------------------------------------------------------------------------------
----------------------------------------------------------------------
common_impl.hint[ "get_yellowwireext" ] = { type = "get", get_obj = "spr_mailbox_yellowwireext",room = "rm_ruralroadext", zz = "zz_mailboxext", zz_gate = "gzz_ruralroadext_mailboxext" };

private.get_yellowwireext_logic = function()
  -- ObjSet( "gfx_parcelext_clk_readletterext_zone", {active=1, input = 1, visible = 1} );
end;
private.get_yellowwireext_inv = function()
  interface.InventoryItemAdd("inv_yellowwireext","spr_mailbox_yellowwireext");
end;
private.get_yellowwireext_beg = function()
  ObjDelete("gfx_mailbox_yellowwireext");
end;
private.get_yellowwireext_end = function()
 
  if common_impl.ZzCompleteCheck("get_yellowwireext") then ObjSet( common_impl.hint["get_yellowwireext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_mailboxext_sh_yellowwireext");
  ObjDelete("spr_ruralroadext_tr_yellowwireext");
end;

cmn.AddSubscriber( "get_yellowwireext", private.get_yellowwireext_inv );
cmn.AddSubscriber( "get_yellowwireext", private.get_yellowwireext_beg );
cmn.AddSubscriber( "get_yellowwireext", private.get_yellowwireext_end );
cmn.AddSubscriber( "get_yellowwireext", private.get_yellowwireext_logic );
--------------------------------------------------------------------
function public.get_yellowwireext()
  cmn.SetEventDone( "get_yellowwireext" );
  cmn.CallEventHandler( "get_yellowwireext" );
  if common_impl.ZzCompleteCheck("get_yellowwireext") then ld.CloseSubRoom() end;
end
----------------------------------------------------------------------
----------------------------------------------------------------------
--common_impl.hint[ "get_parcelext" ] = { type = "get", get_obj = "spr_mailboxext_parcelext", room = "rm_ruralroadext", zz = "zz_mailboxext", zz_gate = "gzz_ruralroadext_mailboxext" };
--
--private.get_parcelext_logic = function()
--  
--end;
--private.get_parcelext_inv = function()
--  interface.InventoryItemAdd("inv_parcelext","spr_mailboxext_parcelext");
--  ObjSet( "inv_parcelext", { drag = 0 } );
--end;
--private.get_parcelext_beg = function()
--  ObjDelete("gfx_mailboxext_parcelext")
--end;
--private.get_parcelext_end = function()
--  ObjDelete("spr_mailboxext_sh_parcelext")
--  ObjDelete("spr_ruralroadext_parcelext")
--  if common_impl.ZzCompleteCheck("get_parcelext") then ObjSet( common_impl.hint["get_parcelext"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
--
--cmn.AddSubscriber( "get_parcelext", private.get_parcelext_inv );
--cmn.AddSubscriber( "get_parcelext", private.get_parcelext_beg, private.room_objname );
--cmn.AddSubscriber( "get_parcelext", private.get_parcelext_end, private.room_objname );
--cmn.AddSubscriber( "get_parcelext", private.get_parcelext_logic );
----------------------------------------------------------------------
--function public.get_parcelext()
--  cmn.SetEventDone( "get_parcelext" );
--  cmn.CallEventHandler( "get_parcelext" );
--  if common_impl.ZzCompleteCheck("get_parcelext") then ld.CloseSubRoom() end;
--end
----------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_screwdriverext" ] = { type = "use", inv_obj = "inv_screwdriverext", use_place = "gfx_mailboxext_screwdriverext_zone", room = "rm_ruralroadext", zz = "zz_mailboxext", zz_gate = "gzz_ruralroadext_mailboxext" };

private.use_screwdriverext_logic = function()
  ObjSet( "spr_mailboxext_martletext", { visible = 1, input = 1, active = 1 } )

end;
private.use_screwdriverext_inv = function()
  common_impl.ProcessMultiUseAll("screwdriverext", "screwdriverext")
end;
private.use_screwdriverext_beg = function()
  ObjDelete( "gfx_mailboxext_screwdriverext_zone" );
end;
private.use_screwdriverext_end = function()
  ObjSet( "spr_mailboxext_sh_martletext", {alp = 1} );
  ObjSet( "spr_ruralroadext_open_mail2", {alp = 1} );
  ObjSet( "spr_ruralroadext_martletext", {alp = 1} );
  ObjSet( "anm_mailboxext_anm_screwdriver", {animfunc="end_2",frame=0} );  
  if common_impl.ZzCompleteCheck("use_screwdriverext") then ObjSet( common_impl.hint["use_screwdriverext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_screwdriverext", private.use_screwdriverext_inv );
cmn.AddSubscriber( "use_screwdriverext", private.use_screwdriverext_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext", private.use_screwdriverext_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext", private.use_screwdriverext_logic );
cmn.AddSubscriber( "use_screwdriverext_inv", private.use_screwdriverext_inv, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_beg", private.use_screwdriverext_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_end", private.use_screwdriverext_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_end", private.use_screwdriverext_logic );
--------------------------------------------------------------------------------------------
function public.use_screwdriverext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_screwdriverext" );
    cmn.CallEventHandler( "use_screwdriverext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_screwdriverext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_screwdriverext_inv" );
  cmn.CallEventHandler( "use_screwdriverext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mailboxext_anm_screwdriver", "use_screwdriver", func_end );
  SoundSfx( "aud_use_screwdriverext_ruralroadext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_martletext" ] = { type = "get", get_obj = "spr_mailboxext_martletext", room = "rm_ruralroadext", zz = "zz_mailboxext", zz_gate = "gzz_ruralroadext_mailboxext" };

private.get_martletext_logic = function()
  
end;
private.get_martletext_inv = function()
  interface.InventoryItemAdd("inv_martletext","spr_mailboxext_martletext");
end;
private.get_martletext_beg = function()
  ObjDelete("gfx_mailboxext_martletext")
end;
private.get_martletext_end = function()
  ObjDelete("spr_mailboxext_sh_martletext")
  ObjDelete("spr_ruralroadext_martletext")
  if common_impl.ZzCompleteCheck("get_martletext") then ObjSet( common_impl.hint["get_martletext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_martletext", private.get_martletext_inv );
cmn.AddSubscriber( "get_martletext", private.get_martletext_beg, private.room_objname );
cmn.AddSubscriber( "get_martletext", private.get_martletext_end, private.room_objname );
cmn.AddSubscriber( "get_martletext", private.get_martletext_logic );
--------------------------------------------------------------------
function public.get_martletext()
  cmn.SetEventDone( "get_martletext" );
  cmn.CallEventHandler( "get_martletext" );
  if common_impl.ZzCompleteCheck("get_martletext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_kioskext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pocketknifeext_kioskext" ] = { type = "use", inv_obj = "inv_pocketknifeext", use_place = "gfx_kioskext_pocketknifeext_kioskext_zone", room = "rm_ruralroadext", zz = "zz_kioskext", zz_gate = "gzz_ruralroadext_kioskext" };

private.use_pocketknifeext_kioskext_logic = function()
  ObjSet( "spr_kioskext_handlerhombusext", { visible = 1, input = 1, active = 1 } )

end;
private.use_pocketknifeext_kioskext_inv = function()
  common_impl.ProcessMultiUseAll("pocketknifeext", "pocketknifeext_kioskext")
end;
private.use_pocketknifeext_kioskext_beg = function()
  ObjDelete( "gfx_kioskext_pocketknifeext_kioskext_zone" );
end;
private.use_pocketknifeext_kioskext_end = function()
  ObjDelete("anm_kioskext_anm_use_pocketknife")
  ObjSet( "anm_kioskext_anm_use_hacksaw", {pos_z = 0} );
  if common_impl.ZzCompleteCheck("use_pocketknifeext_kioskext") then ObjSet( common_impl.hint["use_pocketknifeext_kioskext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pocketknifeext_kioskext", private.use_pocketknifeext_kioskext_inv );
cmn.AddSubscriber( "use_pocketknifeext_kioskext", private.use_pocketknifeext_kioskext_beg, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_kioskext", private.use_pocketknifeext_kioskext_end, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_kioskext", private.use_pocketknifeext_kioskext_logic );
cmn.AddSubscriber( "use_pocketknifeext_kioskext_inv", private.use_pocketknifeext_kioskext_inv, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_kioskext_beg", private.use_pocketknifeext_kioskext_beg, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_kioskext_end", private.use_pocketknifeext_kioskext_end, private.room_objname );
cmn.AddSubscriber( "use_pocketknifeext_kioskext_end", private.use_pocketknifeext_kioskext_logic );
--------------------------------------------------------------------------------------------
function public.use_pocketknifeext_kioskext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});

    cmn.SetEventDone( "use_pocketknifeext_kioskext" );
    cmn.CallEventHandler( "use_pocketknifeext_kioskext_end" );
    public.get_handlerhombusext()    
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pocketknifeext_kioskext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pocketknifeext_kioskext_inv" );
  cmn.CallEventHandler( "use_pocketknifeext_kioskext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_kioskext_anm_use_pocketknife", "use_pocketknife", func_end );
  SoundSfx( "aud_use_pocketknifeext_kioskext" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_handlerhombusext" ] = { type = "get", get_obj = "spr_kioskext_handlerhombusext", room = "rm_ruralroadext", zz = "zz_kioskext", zz_gate = "gzz_ruralroadext_kioskext" };

private.get_handlerhombusext_logic = function()
  
end;
private.get_handlerhombusext_inv = function()
  interface.InventoryItemAdd("inv_handlerhombusext","spr_kioskext_handlerhombusext");
end;
private.get_handlerhombusext_beg = function()
  ObjDelete("gfx_kioskext_handlerhombusext")
end;
private.get_handlerhombusext_end = function()
  ObjDelete("spr_ruralroadext_handlerhombusext")
  if common_impl.ZzCompleteCheck("get_handlerhombusext") then ObjSet( common_impl.hint["get_handlerhombusext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_handlerhombusext", private.get_handlerhombusext_inv );
cmn.AddSubscriber( "get_handlerhombusext", private.get_handlerhombusext_beg, private.room_objname );
cmn.AddSubscriber( "get_handlerhombusext", private.get_handlerhombusext_end, private.room_objname );
cmn.AddSubscriber( "get_handlerhombusext", private.get_handlerhombusext_logic );
--------------------------------------------------------------------
function public.get_handlerhombusext()
  cmn.SetEventDone( "get_handlerhombusext" );
  cmn.CallEventHandler( "get_handlerhombusext" );
  if common_impl.ZzCompleteCheck("get_handlerhombusext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_kioskplateext" ] = { type = "use", inv_obj = "inv_kioskplateext", use_place = "gfx_kioskext_kioskplateext_zone", room = "rm_ruralroadext", zz = "zz_kioskext", zz_gate = "gzz_ruralroadext_kioskext" };

private.use_kioskplateext_logic = function()
  ObjSet( "spr_kioskext_petalext2", { visible = 1, input = 1, active = 1 } )

end;
private.use_kioskplateext_inv = function()
  common_impl.ProcessMultiUseAll("kioskplateext", "kioskplateext")
end;
private.use_kioskplateext_beg = function()
  ObjDelete( "gfx_kioskext_kioskplateext_zone" );
end;
private.use_kioskplateext_end = function()
  ObjSet( "anm_kioskext_anm_use_plate", {frame = 0,animfunc="end_plate"} );
  ObjSet( "spr_kioskext_sh_petalext2", {visible = 1} );
  ObjSet( "anm_kioskext_anm_use_hacksaw", {pos_z=4} );
  ObjSet( "spr_ruralroadext_plate", {alp = 1} );
  ObjSet( "spr_ruralroadext_petalext2", {pos_x=296,pos_y=361} );
  if common_impl.ZzCompleteCheck("use_kioskplateext") then ObjSet( common_impl.hint["use_kioskplateext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_kioskplateext", private.use_kioskplateext_inv );
cmn.AddSubscriber( "use_kioskplateext", private.use_kioskplateext_beg, private.room_objname );
cmn.AddSubscriber( "use_kioskplateext", private.use_kioskplateext_end, private.room_objname );
cmn.AddSubscriber( "use_kioskplateext", private.use_kioskplateext_logic );
cmn.AddSubscriber( "use_kioskplateext_inv", private.use_kioskplateext_inv, private.room_objname );
cmn.AddSubscriber( "use_kioskplateext_beg", private.use_kioskplateext_beg, private.room_objname );
cmn.AddSubscriber( "use_kioskplateext_end", private.use_kioskplateext_end, private.room_objname );
cmn.AddSubscriber( "use_kioskplateext_end", private.use_kioskplateext_logic );
--------------------------------------------------------------------------------------------
function public.use_kioskplateext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_kioskplateext" );
    cmn.CallEventHandler( "use_kioskplateext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_kioskplateext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_kioskplateext_inv" );
  cmn.CallEventHandler( "use_kioskplateext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_kioskext_anm_use_plate", "use_plate", func_end );
  SoundSfx( "aud_use_kioskplateext_ruralroadext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_petalext2" ] = { type = "get", get_obj = "spr_kioskext_petalext2", room = "rm_ruralroadext", zz = "zz_kioskext", zz_gate = "gzz_ruralroadext_kioskext" };

private.get_petalext2_logic = function()
  
end;
private.get_petalext2_inv = function()
  interface.InventoryItemAdd("inv_petalext2","spr_kioskext_petalext2");
end;
private.get_petalext2_beg = function()
  ObjDelete("gfx_kioskext_petalext2")
end;
private.get_petalext2_end = function()
  ObjDelete("spr_kioskext_sh_petalext2")
  ObjDelete("spr_ruralroadext_petalext2")
  if common_impl.ZzCompleteCheck("get_petalext2") then ObjSet( common_impl.hint["get_petalext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_petalext2", private.get_petalext2_inv );
cmn.AddSubscriber( "get_petalext2", private.get_petalext2_beg, private.room_objname );
cmn.AddSubscriber( "get_petalext2", private.get_petalext2_end, private.room_objname );
cmn.AddSubscriber( "get_petalext2", private.get_petalext2_logic );
--------------------------------------------------------------------
function public.get_petalext2()
  cmn.SetEventDone( "get_petalext2" );
  cmn.CallEventHandler( "get_petalext2" );
  if common_impl.ZzCompleteCheck("get_petalext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hacksawext" ] = { type = "use", inv_obj = "inv_hacksawext", use_place = "gfx_kioskext_hacksawext_zone", room = "rm_ruralroadext", zz = "zz_kioskext", zz_gate = "gzz_ruralroadext_kioskext" };

private.use_hacksawext_logic = function()
  ObjSet( "spr_kioskext_metaltwigext", { visible = 1, input = 1, active = 1 } )

end;
private.use_hacksawext_inv = function()
  common_impl.ProcessMultiUseAll("hacksawext", "hacksawext")
end;
private.use_hacksawext_beg = function()
  ObjDelete( "gfx_kioskext_hacksawext_zone" );
end;
private.use_hacksawext_end = function()
  ObjSet( "anm_kioskext_anm_use_hacksaw", {frame=0,animfunc="end_hacksaw"} );
  ObjSet( "spr_kioskext_sh_metaltwigext", {visible = 1} );
  ObjSet( "spr_ruralroadext_metaltwigext", {pos_x=249,pos_y=354} );
  if common_impl.ZzCompleteCheck("use_hacksawext") then ObjSet( common_impl.hint["use_hacksawext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hacksawext", private.use_hacksawext_inv );
cmn.AddSubscriber( "use_hacksawext", private.use_hacksawext_beg, private.room_objname );
cmn.AddSubscriber( "use_hacksawext", private.use_hacksawext_end, private.room_objname );
cmn.AddSubscriber( "use_hacksawext", private.use_hacksawext_logic );
cmn.AddSubscriber( "use_hacksawext_inv", private.use_hacksawext_inv, private.room_objname );
cmn.AddSubscriber( "use_hacksawext_beg", private.use_hacksawext_beg, private.room_objname );
cmn.AddSubscriber( "use_hacksawext_end", private.use_hacksawext_end, private.room_objname );
cmn.AddSubscriber( "use_hacksawext_end", private.use_hacksawext_logic );
--------------------------------------------------------------------------------------------
function public.use_hacksawext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hacksawext" );
    cmn.CallEventHandler( "use_hacksawext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hacksawext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hacksawext_inv" );
  cmn.CallEventHandler( "use_hacksawext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_kioskext_anm_use_hacksaw", "use_hacksaw", func_end );
  SoundSfx( "aud_use_hacksawext_ruralroadext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_metaltwigext" ] = { type = "get", get_obj = "spr_kioskext_metaltwigext", room = "rm_ruralroadext", zz = "zz_kioskext", zz_gate = "gzz_ruralroadext_kioskext" };

private.get_metaltwigext_logic = function()
  
end;
private.get_metaltwigext_inv = function()
  interface.InventoryItemAdd("inv_metaltwigext","spr_kioskext_metaltwigext");
end;
private.get_metaltwigext_beg = function()
  ObjDelete("gfx_kioskext_metaltwigext")
end;
private.get_metaltwigext_end = function()
  ObjDelete("spr_kioskext_sh_metaltwigext")
  ObjDelete("spr_ruralroadext_metaltwigext")
  if common_impl.ZzCompleteCheck("get_metaltwigext") then ObjSet( common_impl.hint["get_metaltwigext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_metaltwigext", private.get_metaltwigext_inv );
cmn.AddSubscriber( "get_metaltwigext", private.get_metaltwigext_beg, private.room_objname );
cmn.AddSubscriber( "get_metaltwigext", private.get_metaltwigext_end, private.room_objname );
cmn.AddSubscriber( "get_metaltwigext", private.get_metaltwigext_logic );
--------------------------------------------------------------------
function public.get_metaltwigext()
  cmn.SetEventDone( "get_metaltwigext" );
  cmn.CallEventHandler( "get_metaltwigext" );
  if common_impl.ZzCompleteCheck("get_metaltwigext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_exittofarmext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_nippersext" ] = { type = "use", inv_obj = "inv_nippersext", use_place = "gfx_exittofarmext_nippersext_zone", room = "rm_ruralroadext", zz = "zz_exittofarmext", zz_gate = "gzz_ruralroadext_exittofarmext" };

private.use_nippersext_logic = function()
  ObjSet( "grm_ruralroadext_farmext", { visible = 1, input = 1, active = 1 } )
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_ruralroadext_farmext_focus");
    end;
end;
private.use_nippersext_inv = function()
  common_impl.ProcessMultiUseAll("nippersext", "nippersext")
end;
private.use_nippersext_beg = function()
  ObjDelete( "gfx_exittofarmext_nippersext_zone" );
end;
private.use_nippersext_end = function()
  ObjSet( "spr_ruralroadext_gate_open", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_nippersext") then ObjSet( common_impl.hint["use_nippersext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_nippersext", private.use_nippersext_inv );
cmn.AddSubscriber( "use_nippersext", private.use_nippersext_beg, private.room_objname );
cmn.AddSubscriber( "use_nippersext", private.use_nippersext_end, private.room_objname );
cmn.AddSubscriber( "use_nippersext", private.use_nippersext_logic );
cmn.AddSubscriber( "use_nippersext_inv", private.use_nippersext_inv, private.room_objname );
cmn.AddSubscriber( "use_nippersext_beg", private.use_nippersext_beg, private.room_objname );
cmn.AddSubscriber( "use_nippersext_end", private.use_nippersext_end, private.room_objname );
cmn.AddSubscriber( "use_nippersext_end", private.use_nippersext_logic );
--------------------------------------------------------------------------------------------
function public.use_nippersext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_nippersext" );
    cmn.CallEventHandler( "use_nippersext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_nippersext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_nippersext_inv" );
  cmn.CallEventHandler( "use_nippersext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_exittofarmext_anm", "use_nippers", func_end );
  SoundSfx( "aud_use_nippersext_ruralroadext" )
  

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_benchext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletcockerelext" ] = { type = "use", inv_obj = "inv_amuletcockerelext", use_place = "gfx_benchext_amuletcockerelext_zone", room = "rm_ruralroadext", zz = "zz_benchext", zz_gate = "gzz_ruralroadext_benchext" };

private.use_amuletcockerelext_logic = function()
  ObjSet( "spr_benchext_decorpartext2", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_benchext_sickleext", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletcockerelext_inv = function()
  common_impl.ProcessMultiUseAll("amuletcockerelext", "amuletcockerelext")
end;
private.use_amuletcockerelext_beg = function()
  ObjDelete( "gfx_benchext_amuletcockerelext_zone" );
end;
private.use_amuletcockerelext_end = function()
  ObjSet( "anm_benchext_anm_1", {animfunc="end_1",frame=0} );
  ObjDelete("spr_ruralroadext_cover_1")
  ObjSet( "spr_ruralroadext_cover_2", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_amuletcockerelext") then ObjSet( common_impl.hint["use_amuletcockerelext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletcockerelext", private.use_amuletcockerelext_inv );
cmn.AddSubscriber( "use_amuletcockerelext", private.use_amuletcockerelext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletcockerelext", private.use_amuletcockerelext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletcockerelext", private.use_amuletcockerelext_logic );
cmn.AddSubscriber( "use_amuletcockerelext_inv", private.use_amuletcockerelext_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletcockerelext_beg", private.use_amuletcockerelext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletcockerelext_end", private.use_amuletcockerelext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletcockerelext_end", private.use_amuletcockerelext_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletcockerelext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletcockerelext" );
    cmn.CallEventHandler( "use_amuletcockerelext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletcockerelext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletcockerelext_inv" );
  cmn.CallEventHandler( "use_amuletcockerelext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_benchext_anm_1", "use_cockerel", func_end );
  SoundSfx( "aud_use_amuletcockerelext_ruralroadext" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_decorpartext2" ] = { type = "get", get_obj = "spr_benchext_decorpartext2", room = "rm_ruralroadext", zz = "zz_benchext", zz_gate = "gzz_ruralroadext_benchext" };

private.get_decorpartext2_logic = function()
  
end;
private.get_decorpartext2_inv = function()
  interface.InventoryItemAdd("inv_decorpartext","spr_benchext_decorpartext2",function() level_inv.ProcessGetDecorpartextAll( "get_decorpartext2" ) end);
end;
private.get_decorpartext2_beg = function()
  ObjDelete("gfx_benchext_decorpartext2")
end;
private.get_decorpartext2_end = function()
  ObjDelete("spr_benchext_sh_decorpartext2") 
  ObjDelete("spr_ruralroadext_decorpartext2") 
  if common_impl.ZzCompleteCheck("get_decorpartext2") then ObjSet( common_impl.hint["get_decorpartext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_decorpartext2", private.get_decorpartext2_inv );
cmn.AddSubscriber( "get_decorpartext2", private.get_decorpartext2_beg, private.room_objname );
cmn.AddSubscriber( "get_decorpartext2", private.get_decorpartext2_end, private.room_objname );
cmn.AddSubscriber( "get_decorpartext2", private.get_decorpartext2_logic );
--------------------------------------------------------------------
function public.get_decorpartext2()
  cmn.SetEventDone( "get_decorpartext2" );
  cmn.CallEventHandler( "get_decorpartext2" );
  if common_impl.ZzCompleteCheck("get_decorpartext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sickleext" ] = { type = "get", get_obj = "spr_benchext_sickleext", room = "rm_ruralroadext", zz = "zz_benchext", zz_gate = "gzz_ruralroadext_benchext" };

private.get_sickleext_logic = function()
  
end;
private.get_sickleext_inv = function()
  interface.InventoryItemAdd("inv_sickleext","spr_benchext_sickleext");
end;
private.get_sickleext_beg = function()
  ObjDelete("gfx_benchext_sickleext")
end;
private.get_sickleext_end = function()
  ObjDelete("spr_benchext_sh_sickleext")
  ObjDelete("spr_ruralroadext_sickleext")
  if common_impl.ZzCompleteCheck("get_sickleext") then ObjSet( common_impl.hint["get_sickleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_sickleext", private.get_sickleext_inv );
cmn.AddSubscriber( "get_sickleext", private.get_sickleext_beg, private.room_objname );
cmn.AddSubscriber( "get_sickleext", private.get_sickleext_end, private.room_objname );
cmn.AddSubscriber( "get_sickleext", private.get_sickleext_logic );
--------------------------------------------------------------------
function public.get_sickleext()
  cmn.SetEventDone( "get_sickleext" );
  cmn.CallEventHandler( "get_sickleext" );
  if common_impl.ZzCompleteCheck("get_sickleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_martletext" ] = { type = "use", inv_obj = "inv_martletext", use_place = "gfx_benchext_martletext_zone", room = "rm_ruralroadext", zz = "zz_benchext", zz_gate = "gzz_ruralroadext_benchext" };

private.use_martletext_logic = function()
  ObjSet( "spr_benchext_divanhandleext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_benchext_noteext1", { visible = 1, input = 1, active = 1 } )

end;
private.use_martletext_inv = function()
  common_impl.ProcessMultiUseAll("martletext", "martletext")
end;
private.use_martletext_beg = function()
  ObjDelete( "gfx_benchext_martletext_zone" );
end;
private.use_martletext_end = function()
  ObjSet("anm_benchext_anm_2",{animfunc="end_2",frame=0})
  ObjSet( "spr_benchext_sh_noteext1", {alp = 1} );
  ObjSet( "spr_benchext_sh_divanhandleext", {alp = 1} );
  ObjDelete("spr_ruralroadext_cover_3")  
  ObjSet( "spr_ruralroadext_cover_4", {alp = 1} );
  ObjSet( "spr_ruralroadext_divanhandleext", {alp = 1} );
  ObjSet( "spr_ruralroadext_noteext1", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_martletext") then ObjSet( common_impl.hint["use_martletext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_martletext", private.use_martletext_inv );
cmn.AddSubscriber( "use_martletext", private.use_martletext_beg, private.room_objname );
cmn.AddSubscriber( "use_martletext", private.use_martletext_end, private.room_objname );
cmn.AddSubscriber( "use_martletext", private.use_martletext_logic );
cmn.AddSubscriber( "use_martletext_inv", private.use_martletext_inv, private.room_objname );
cmn.AddSubscriber( "use_martletext_beg", private.use_martletext_beg, private.room_objname );
cmn.AddSubscriber( "use_martletext_end", private.use_martletext_end, private.room_objname );
cmn.AddSubscriber( "use_martletext_end", private.use_martletext_logic );
--------------------------------------------------------------------------------------------
function public.use_martletext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_martletext" );
    cmn.CallEventHandler( "use_martletext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_martletext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_martletext_inv" );
  cmn.CallEventHandler( "use_martletext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_benchext_anm_2", "use_swallow", func_end );
  SoundSfx( "aud_use_martletext_ruralroadext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_divanhandleext" ] = { type = "get", get_obj = "spr_benchext_divanhandleext", room = "rm_ruralroadext", zz = "zz_benchext", zz_gate = "gzz_ruralroadext_benchext" };

private.get_divanhandleext_logic = function()
  
end;
private.get_divanhandleext_inv = function()
  interface.InventoryItemAdd("inv_divanhandleext","spr_benchext_divanhandleext");
end;
private.get_divanhandleext_beg = function()
  ObjDelete("gfx_benchext_divanhandleext")
end;
private.get_divanhandleext_end = function()
  ObjDelete("spr_benchext_sh_divanhandleext")
  ObjDelete("spr_ruralroadext_divanhandleext")
  if common_impl.ZzCompleteCheck("get_divanhandleext") then ObjSet( common_impl.hint["get_divanhandleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_divanhandleext", private.get_divanhandleext_inv );
cmn.AddSubscriber( "get_divanhandleext", private.get_divanhandleext_beg, private.room_objname );
cmn.AddSubscriber( "get_divanhandleext", private.get_divanhandleext_end, private.room_objname );
cmn.AddSubscriber( "get_divanhandleext", private.get_divanhandleext_logic );
--------------------------------------------------------------------
function public.get_divanhandleext()
  cmn.SetEventDone( "get_divanhandleext" );
  cmn.CallEventHandler( "get_divanhandleext" );
  if common_impl.ZzCompleteCheck("get_divanhandleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_noteext1" ] = { type = "get", get_obj = "spr_benchext_noteext1", room = "rm_ruralroadext", zz = "zz_benchext", zz_gate = "gzz_ruralroadext_benchext" };

private.get_noteext1_logic = function()
  
end;
private.get_noteext1_inv = function()
  interface.InventoryItemAdd("inv_noteext1","spr_benchext_noteext1");
end;
private.get_noteext1_beg = function()
  ObjDelete("gfx_benchext_noteext1")
end;
private.get_noteext1_end = function()
  ObjDelete("spr_benchext_sh_noteext1")  
  ObjSet( "spr_ruralroadext_noteext1", {alp = 1} );
  if common_impl.ZzCompleteCheck("get_noteext1") then ObjSet( common_impl.hint["get_noteext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_noteext1", private.get_noteext1_inv );
cmn.AddSubscriber( "get_noteext1", private.get_noteext1_beg, private.room_objname );
cmn.AddSubscriber( "get_noteext1", private.get_noteext1_end, private.room_objname );
cmn.AddSubscriber( "get_noteext1", private.get_noteext1_logic );
--------------------------------------------------------------------
function public.get_noteext1()
  cmn.SetEventDone( "get_noteext1" );
  cmn.CallEventHandler( "get_noteext1" );
  if common_impl.ZzCompleteCheck("get_noteext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_ruralroadext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_ruralroadext_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_benchext" );
  function zz_benchext.Open()
  end;
  function zz_benchext.PreOpen()
  end;
  function zz_benchext.PreClose()
  end;
  function zz_benchext.Close()
  end;

  subroom.Define( "zz_exittofarmext" );
  function zz_exittofarmext.Open()
  end;
  function zz_exittofarmext.PreOpen()
  end;
  function zz_exittofarmext.PreClose()
  end;
  function zz_exittofarmext.Close()
  end;

  subroom.Define( "zz_kioskext" );
  function zz_kioskext.Open()
  end;
  function zz_kioskext.PreOpen()
  end;
  function zz_kioskext.PreClose()
  end;
  function zz_kioskext.Close()
  end;

  subroom.Define( "zz_mailboxext" );
  function zz_mailboxext.Open()
  end;
  function zz_mailboxext.PreOpen()
  end;
  function zz_mailboxext.PreClose()
  end;
  function zz_mailboxext.Close()
  end;
  
end;
--*********************************************************************************************************************