-- name=mg_bomboneextscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_bomboneextscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
 -- common_impl.hint[ "win_bomboneextscr" ] = {type = "win", use_place = "mg_bomboneextscr", room = "rm_farmext", zz = "mg_bomboneextscr", zz_gate = "gmg_farmext_bomboneextscr" };
 --
 -- local win_bomboneextscr_logic = function()
 --   if ld.CheckRequirements( {"win_bomboneextscr"} ) then
 --     --  ObjSet( "spr_bomboneextscr_bombmapext", { visible = 1, input = 1, active = 1 } )
 --     ObjSet( "spr_bomboneextscr_partswitchext3", { visible = 1, input = 0, active = 1 } )   
 --     ObjSet( "spr_bomboneextscr_bombmapext", {active=1, input = 0, visible = 1} );   
 --   
 --     ObjSet("gfx_bomboneextscr_clk_bomboneextscrlist",{active=1, input=1, visible=1});
 --   end
 -- end;
 -- local win_bomboneextscr = function()
 --   if ld.CheckRequirements( {"win_bomboneextscr"} ) then
 --     ObjSet( "obj_bomboneextscr_root", {input = 0} );
 --     --ObjSet( "anm_bomboneextscr_anim_bomba", {animfunc = "end_with", frame = 0 } );
 --     ObjDelete("anm_bomboneextscr_anim_bomba");
 --     ObjDelete("anm_bomboneextscr_anim_bomba_sig");
 --     ObjSet( "spr_bomboneextscr_sh_partswitchext3", {visible = 1} );
 --     ObjSet( "anm_bomboneextscr_anim_list", {active=1, visible = 1} );
 --   end
 -- end;
 -- cmn.AddSubscriber("win_bomboneextscr", win_bomboneextscr, private.room_objname )
 -- cmn.AddSubscriber("win_bomboneextscr", win_bomboneextscr_logic )
  --------------------------------------------------------------------------------------------
--------------------------------------------------------------------
--------------------------------------------------------------------  
private.bomboneextscr_fp_array={{{1,1},{2,1},{2,2},{3,1}},
                           {{0,0},{4,1},{4,2},{0,0}},
                           {{0,0},{0,0},{0,0},{0,0}},
                           {{3,2},{0,0},{0,0},{1,2}}};

private.bomboneextscr_win_array = {{{4,1},{0,0},{2,1},{0,0}},
                              {{0,0},{1,1},{0,0},{4,2}},
                              {{0,0},{0,0},{3,1},{1,2}},
                              {{3,2},{0,0},{2,2},{0,0}}}                           
  
--------------------------------------------------------------------  
--------------------------------------------------------------------
private.bomboneextscr_parts_init_flag = false; 

local bomboneextscr_pos_lights_array = {{338,211},
{454,210},
{570,207},
{688,211},
{336,312},
{453,310},
{572,311},
{688,310},
{335,413},
{453,412},
{572,412},
{689,412},
{339,513},
{455,514},
{571,516},
{690,511}};
--------------------------------------------------------------------
local points_count = 20; -- points  count on any line

---------------------------------------------------------------------
local color_line_array={{0,163/255,12/255},{1/255,81/255,163/255},{163/255,0,150/255},{163/255,115/255,0}}
local color_line_array_select={{0,1,35/255},{2/255,209/255,252/255},{1,0,254/255},{1,254/255,0}}
function private.bomboneextscr_parts_init()
  
  if private.bomboneextscr_parts_init_flag==false then 
     -- init pole parts
     local fpos={172,106};
     local pos_step={117,101};
     local light_count=0;
     
     for i=1,4,1 do 
       for j=1,4,1 do
         ObjCreate("obj_bomboneextscr_pos_"..i.."_"..j,"obj");
         ObjSet( "obj_bomboneextscr_pos_"..i.."_"..j, {input=1, pos_x=fpos[1]+pos_step[1]*j+0.01*i*j, pos_y=fpos[2]+pos_step[2]*i, inputrect_init=1, inputrect_x=-15, inputrect_y=-15, inputrect_w=30, inputrect_h=30} );
         ObjAttach("obj_bomboneextscr_pos_"..i.."_"..j,"obj_bomboneextscr_root")
   
         light_count=light_count+1;
         ObjCreate("spr_bomboneextscr_pos_light_"..i.."_"..j,"spr");
         ObjSet( "spr_bomboneextscr_pos_light_"..i.."_"..j, {input=0, visible=1, alp=0, pos_x=bomboneextscr_pos_lights_array[light_count][1], pos_y=bomboneextscr_pos_lights_array[light_count][2], res="assets/levels/levelext/mg_bomboneext/a"..light_count} );
         ObjAttach("spr_bomboneextscr_pos_light_"..i.."_"..j,"obj_bomboneextscr_root")
       end; 
     end;   
     ----------------------- 
     -- init line first and last points
    for i=1,4,1 do 
      --line root
  -- ObjCreate("obj_bomboneextscr_line_root_"..i,"obj");
  -- ObjAttach("obj_bomboneextscr_line_root_"..i,"obj_bomboneextscr_root");
  -- ObjSet( "obj_bomboneextscr_line_root_"..i, {pos_z=1, input=1} );
      for j=1,2,1 do 
          ObjCreate("spr_bomboneextscr_line_point_"..i.."_"..j,"spr");
          ObjSet( "spr_bomboneextscr_line_point_"..i.."_"..j, {res="assets/levels/levelext/mg_bomboneext/plug",input=1, inputrect_init=1, inputrect_w=40, inputrect_h=40, inputrect_x=-20, inputrect_y=-20, pos_z=5+(4-i), visible=1, 
             event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT)", drag=1, event_startdrag="mg_bomboneextscr.bomboneextscr_start_drag("..i..","..j..");", 
             event_drag="mg_bomboneextscr.bomboneextscr_drag("..i..","..j..")", event_dragdrop="mg_bomboneextscr.bomboneextscr_dragdrop("..i..","..j..")"} );
           ObjAttach("spr_bomboneextscr_line_point_"..i.."_"..j,"obj_bomboneextscr_root")
      end;  
    end;       
    ---------------------------------- 
    -- init points on line and line parts
    for  i=1,4,1 do 
      for j=1,points_count+1,1 do 
        ObjCreate("obj_bomboneextscr_part_l"..i.."_"..j,"obj");
        ObjAttach("obj_bomboneextscr_part_l"..i.."_"..j,"obj_bomboneextscr_root");
        ObjSet( "obj_bomboneextscr_part_l"..i.."_"..j, {input=0,visible=0} );
      end;  
      for j=1,points_count,1 do 
         ObjCreate("spr_bomboneextscr_line_"..i.."_"..j,"spr")
         ObjSet( "spr_bomboneextscr_line_"..i.."_"..j, {res="assets/levels/levelext/mg_bomboneext/wire", input=0, pos_z=6+(4-i), color_r=color_line_array[i][1],color_g=color_line_array[i][2],color_b=color_line_array[i][3]} );
         ObjAttach( "spr_bomboneextscr_line_"..i.."_"..j,"obj_bomboneextscr_root");
      end;  
   end;  
   ---------------------------------------  
  end;  
  private.bomboneextscr_parts_init_flag=true;
end;  
  
---------------------------------------------------------------------
---------------------------------------------------------------------  
function private.bomboneextscr_stand_on_pos()
  --   ld.LogTrace( "stand_on_pos" );
   local fpos={172,106};
   local pos_step={117,101};
   for i=1,4,1 do 
      -- ObjSet( "obj_bomboneextscr_line_root_"..i, {pos_z=5} );
       for j=1,4,1 do
         local i1,i2 = gm.state[i][j][1],gm.state[i][j][2]; 
             if i1~=0 then
               ObjSet( "spr_bomboneextscr_line_point_"..i1.."_"..i2, {input=1, pos_x=fpos[1]+pos_step[1]*j+0.01*i*j, pos_y=fpos[2]+pos_step[2]*i} );
          --     ld.LogTrace( "ObjSet spr_bomboneextscr_line_point_"..i1.."_"..i2 );
             end;
        end;
   end;   
   for i=1,4,1 do 
       for j=1,points_count,1 do 
           ObjSet( "spr_bomboneextscr_line_"..i.."_"..j, {color_r=color_line_array[i][1],color_g=color_line_array[i][2],color_b=color_line_array[i][3]} );
       end;  
       private.bomboneextscr_search_coord(i);
   end;    
   private.bomboneextscr_win_ver()  
end;  
   
function private.bomboneextscr_search_part_on_state(n_type,num)
  local ret_arr={0,0}
  for i=1,4,1 do
    for j=1,4,1 do 
       if gm.state[i][j][1]==n_type and gm.state[i][j][2]==num then ret_arr={i,j}; return ret_arr; end; 
    end;  
  end;  
end;  
   
 
private.bomboneextscr_win_ver_first_start_flag=false;
local bomboneextscr_win_ver_old_count = 0; 
local true_parts_array={0,0,0,0}; 
local select_line_count = 0;

function private.bomboneextscr_win_ver()
  --   ld.LogTrace( "win_ver" );
  true_parts_array={0,0,0,0}; 
  local count=0;
  for i=1,4,1 do 
    for j=1,4,1 do 
      if private.bomboneextscr_win_array[i][j][1]==gm.state[i][j][1] and gm.state[i][j][1]~=0 then
         true_parts_array[private.bomboneextscr_win_array[i][j][1] ]=true_parts_array[private.bomboneextscr_win_array[i][j][1] ]+0.5;
         count=count+1;
         ObjSet( "spr_bomboneextscr_pos_light_"..i.."_"..j, {alp=1, color_r=0, color_g=1, color_b=0} );
      else
         if gm.state[i][j][1]==0 then 
           ObjSet( "spr_bomboneextscr_pos_light_"..i.."_"..j, {alp=0} );
         else 
           ObjSet("spr_bomboneextscr_pos_light_"..i.."_"..j,{alp=1, color_r=1, color_g=0, color_b=0});
         end;  
      end;
    end;  
  end;  
  
  local current_line_count=0; 
  for i=1,4,1 do 
    if true_parts_array[i]==1 then
      --select_line_count=select_line_count+1;  
      current_line_count = current_line_count+1;
       ObjSet( "spr_bomboneextscr_lig_"..i, {alp=1} );
      for j=1,points_count,1 do 
        ObjSet( "spr_bomboneextscr_line_"..i.."_"..j, {color_r=color_line_array_select[i][1],color_g=color_line_array_select[i][2],color_b=color_line_array_select[i][3]} );
      end;
    else 
       ObjSet( "spr_bomboneextscr_lig_"..i, {alp=0} );  
    end;
  end;  
  
  --ld.LogTrace( " count= "..count  ); 
  if private.bomboneextscr_win_ver_first_start_flag == true then 
   if count > bomboneextscr_win_ver_old_count then
      SoundSfx( "aud_mg_bomb1_true" );
   elseif count == bomboneextscr_win_ver_old_count then  
      local ki,kj = private.bomboneextscr_start_drag_pos[1], private.bomboneextscr_start_drag_pos[2];
      if gm.state[ki][kj][1] == private.bomboneextscr_start_drag_pos_value[1] and  gm.state[ki][kj][2] == private.bomboneextscr_start_drag_pos_value[2] and private.bomboneextscr_win_array[ki][kj][1]==gm.state[ki][kj][1] and gm.state[ki][kj][1]~=0 then 
        SoundSfx( "aud_mg_bomb1_true" );
      else 
        SoundSfx( "aud_mg_bomb1_wrong" );
      end;  
   else 
      SoundSfx( "aud_mg_bomb1_wrong" );
   end;
  
   if current_line_count > select_line_count then SoundSfx( "aud_mg_bomb1_win" ); end;  
  end;  
  bomboneextscr_win_ver_old_count = count;
  select_line_count = current_line_count;
  if count==8 and  not cmn.IsEventDone("win_bomboneextscr") then  private.Win(); end; 
  private.bomboneextscr_win_ver_first_start_flag = true; 
end;  
---------------------------------------------------------------------
--------------------------------------------------------------------- 
----------------------lines
local line_lenght = 600;
local rad = line_lenght/2;
local d_rast=0;
local p3={0,0};

local p1={0,0};
local p2={0,0};
---    
--------------------------------------- drag funcs
local p_fp_array={};
private.bomboneextscr_start_drag_pos={0,0};
private.bomboneextscr_start_drag_pos_value={0,0};

function public.bomboneextscr_start_drag(n_type,num)
   ld.SetCursor(CURSOR_HAND);
   local obj = ObjGet("spr_bomboneextscr_line_point_"..n_type.."_"..num);
   p_fp_array={obj.pos_x, obj.pos_y}; 
   SoundSfx( "aud_mg_bomb1_get" )
   private.bomboneextscr_start_drag_pos = private.bomboneextscr_search_part_on_state(n_type,num);
   local ki,kj =  private.bomboneextscr_start_drag_pos[1], private.bomboneextscr_start_drag_pos[2];
   private.bomboneextscr_start_drag_pos_value = {gm.state[ki][kj][1],gm.state[ki][kj][2]};
end;  

function public.bomboneextscr_drag(n_type,num)
  private.bomboneextscr_search_coord(n_type);
  
  local cursor = GetZoomCursorPos(); 
  
  if d_rast>=line_lenght then ObjStopDrag("spr_bomboneextscr_line_point_"..n_type.."_"..num); ObjSet( "spr_bomboneextscr_line_point_"..n_type.."_"..num, {pos_x=p_fp_array[1], pos_y=p_fp_array[2]} ); private.bomboneextscr_stand_on_pos(); return; end;
  ObjSet( "spr_bomboneextscr_line_point_"..n_type.."_"..num, {pos_x=cursor[1], pos_y=cursor[2]} );
  
end;  

function public.bomboneextscr_dragdrop(n_type,num)
   for i=1,4,1 do 
    for j=1,4,1 do 
      if gm.state[i][j][1]==0 then 
        if ApplyObj("spr_bomboneextscr_line_point_"..n_type.."_"..num,"obj_bomboneextscr_pos_"..i.."_"..j) then 
          local old_pos = private.bomboneextscr_search_part_on_state(n_type,num);
          gm.state[old_pos[1] ][old_pos[2] ] = {0,0};
          gm.state[i][j]={n_type,num};
        end;  
      end;  
    end;  
  end; 
  private.bomboneextscr_stand_on_pos(); 
  ld.SetCursor(CURSOR_DEFAULT);
  SoundSfx( "aud_mg_bomb1_set" );
end;
------------------------lines
private.bomboneextscr_search_coord = function(n_type)
--  ld.LogTrace( "Serach_coord n_type = "..n_type );
  
  p1={ObjGet("spr_bomboneextscr_line_point_"..n_type.."_1").pos_x,ObjGet("spr_bomboneextscr_line_point_"..n_type.."_1").pos_y};
  p2={ObjGet("spr_bomboneextscr_line_point_"..n_type.."_2").pos_x,ObjGet("spr_bomboneextscr_line_point_"..n_type.."_2").pos_y};
  
--  ld.LogTrace( "p1 = "..p1[1].." "..p1[2].."/ p2 = "..p2[1].." "..p2[2] );
  
  d_rast = math.sqrt(math.pow(p2[1]-p1[1],2)+math.pow(p2[2]-p1[2],2));
  local buf_p3 =  private.bomboneextscr_search_p3();
  if buf_p3~=nil then 
    p3 = ld.TableCopy(buf_p3);
    --  ld.LogTrace( "need = "..buf_p3[1].." "..buf_p3[2] );
    --ObjSet( "spr_test_part3", {pos_x=buf_p3[1], pos_y=buf_p3[2]} );
    private.bomboneextscr_stand_over_point(buf_p3,n_type);
  else  
    ld.LogTrace( "nil" );
  end;  
end;  

---
private.bomboneextscr_search_p3 = function()
  local obj = {}
  obj.pos1 = {0,0}
  obj.pos2 = {p2[1]-p1[1],p2[2]-p1[2]};
  
  local x_rast = math.abs(p1[1]-p2[1]);
  local y_rast = math.abs(p1[2]-p2[2]);
  
  local koef = 0;
  
  if d_rast>=rad*2 then 
    koef=0;
  elseif d_rast == 0 then 
    koef = rad;
  else 
    local dop_zn = 0;  
    
    koef = -x_rast/2+rad; 
    
 --   if d_rast<rad then dop_zn=1+y_rast/koef; koef=koef*dop_zn; end;
    
   
    --koef = (y_rast/x_rast)*rad;
  end;  
  
  local sr_zn = {(p1[1]+p2[1])/2,(p1[2]+p2[2])/2}
  local min_x = 0; if p1[1]<p2[1] then min_x=p1[1] else min_x=p2[1] end;
  
 
  
  local Xc = x_rast/2 + min_x;
  local Yc = koef + sr_zn[2];
--local d_y =math.abs(p2[2]-p1[2]);
--local angl_alp = math.pi-(math.atan(d_y/d_rast)+math.atan(d_rast/d_y));
--local k=d_rast/(2*math.tan(angl_alp));
--local n_koef = d_y+k;
-- ld.LogTrace( "koef = "..koef );
--local Yc = n_koef + sr_zn[2];
  
  local coord = {Xc,Yc};
  
 -- ld.LogTrace( "UP COORD = "..(Xc-min_x).." "..(Yc-sr_zn[2]) );
  
  return coord;
  
end;  

-----
local stand_step=1/points_count;
function private.bomboneextscr_stand_over_point(cpos,n_type)
  local p41={0,0};
  local p42={0,0};
  
  local min_x, min_y = 0,0;
  local max_x, max_y = 0,0;
  local par_zn=1;
  
  if p1[1]<=p2[1] then min_x=p1[1];max_x=p2[1];min_y=p1[2];max_y=p2[2]; par_zn=1; else min_x=p2[1]; max_x=p1[1]; min_y=p2[2]; max_y=p1[2]; par_zn=1; end;
  local x_rast = math.abs(p1[1]-p2[1]);
  
  local koef = {};
  koef[1] = (min_y-p3[2])/((min_x-p3[1])*(min_x-p3[1]));
  koef[2] = (max_y-p3[2])/((max_x-p3[1])*(max_x-p3[1]));
  
-- p41[1]=0.25*x_rast+min_x;
-- ld.LogTrace( "koef41 = "..koef);
-- p41[2]=koef*(p41[1]-cpos[1])*(p41[1]-cpos[1]) + cpos[2];
---  p41[2]=-(p41[1]-cpos[1])*(p41[1]-cpos[1]) + cpos[2];
-- 
-- p42[1]=0.75*x_rast+min_x;
-- p42[2]=-koef*(p42[1]-cpos[1])*(p42[1]-cpos[1]) + cpos[2];
-- 
-- ld.LogTrace( "part41 = "..p41[1].." "..p41[2] );
-- 
-- ObjSet( "spr_test_part41", {pos_x=p41[1], pos_y=p41[2]} );
-- ObjSet( "spr_test_part42", {pos_x=p42[1], pos_y=p42[2]} );
  if p1[1]==p2[1] then 
    
  else  
    local koef_zn=1;
    for i=0,points_count,1 do 
      if i*stand_step>0.5 then koef_zn=2; end; 
      local myx = par_zn*i*stand_step*x_rast+min_x;
      local cur_koef =koef[koef_zn] 
      local myy = cur_koef*(myx-cpos[1])*(myx-cpos[1]) + cpos[2]
    
      ObjSet( "obj_bomboneextscr_part_l"..n_type.."_"..i+1, {pos_x=myx, pos_y=myy} );
    end;  
    private.bomboneextscr_lines_stand(n_type);
  end;
end;  

-----------------------------
function private.bomboneextscr_lines_stand(n_type)
  local cur_x, cur_y = 0,0;
  local cur_ang=0;
  local next_point=0;
  local cur_lenght = 0;
  local cur_scale=0;
  local line_lenght=200;
  for i=1,points_count,1 do 
    -- if i~=#private.carpetmg_lvl1_parts_pos then next_point=i+1; else next_point=1; end;
    next_point=i+1;
    local f_obj = ObjGet("obj_bomboneextscr_part_l"..n_type.."_"..i);
    local n_obj = ObjGet("obj_bomboneextscr_part_l"..n_type.."_"..next_point);
    
    cur_x= 0.5*(f_obj.pos_x + n_obj.pos_x);
    cur_y= 0.5*(f_obj.pos_y + n_obj.pos_y);
    cur_ang = math.atan((n_obj.pos_y-f_obj.pos_y)/(n_obj.pos_x-f_obj.pos_x))+0.5*math.pi;
    
    cur_lenght = math.pow((math.pow(f_obj.pos_x - n_obj.pos_x,2)+math.pow(f_obj.pos_y - n_obj.pos_y,2)),0.5);
    cur_scale=cur_lenght/line_lenght;
    
    ObjSet( "spr_bomboneextscr_line_"..n_type.."_"..i, {pos_x=cur_x, pos_y=cur_y, ang = -cur_ang, scale_y=cur_scale} );
  end;  
  
  ---------------------------- line light
 -- private.carpetmg_lines_light();

end;  
--------------------------------------------------------------------
---------------------------------------------------------------------
----------------------------------------------------------------------
--common_impl.hint[ "clk_bomboneextscrlist" ] = { type = "click", use_place = "gfx_bomboneextscr_clk_bomboneextscrlist", room = "rm_farmext", zz = "mg_bomboneextscr", zz_gate = "gmg_farmext_bomboneextscr" };
--
--private.clk_bomboneextscrlist_logic = function()
--  ObjSet( "gfx_bomboneextscr_clk_bomboneextscrlist2", {active=1, input = 1, visible = 1} );
--end;
--
--private.clk_bomboneextscrlist_beg = function()
--  ObjDelete("gfx_bomboneextscr_clk_bomboneextscrlist")
--end;
--private.clk_bomboneextscrlist_end = function()
--  if common_impl.ZzCompleteCheck("clk_bomboneextscrlist") then ObjSet( common_impl.hint["clk_bomboneextscrlist"].zz_gate, { visible = 0, input = 0 } ); end;
--  -- ObjDelete("anm_bomboneextscr_anim_bomba")
--  ObjSet( "anm_bomboneextscr_anim_list", {animfunc = "list1", frame = 0 } );
--end;
--
--
--cmn.AddSubscriber( "clk_bomboneextscrlist", private.clk_bomboneextscrlist_beg, private.room_objname );
--cmn.AddSubscriber( "clk_bomboneextscrlist", private.clk_bomboneextscrlist_end, private.room_objname );
--cmn.AddSubscriber( "clk_bomboneextscrlist", private.clk_bomboneextscrlist_logic );
--cmn.AddSubscriber( "clk_bomboneextscrlist_beg", private.clk_bomboneextscrlist_beg, private.room_objname );
--cmn.AddSubscriber( "clk_bomboneextscrlist_end", private.clk_bomboneextscrlist_end, private.room_objname );
--cmn.AddSubscriber( "clk_bomboneextscrlist_end", private.clk_bomboneextscrlist_logic );
----------------------------------------------------------------------
--function public.clk_bomboneextscrlist()
--  local func_end = function()
--     ld.Lock(0);
--     cmn.SetEventDone( "clk_bomboneextscrlist" );
--     cmn.CallEventHandler( "clk_bomboneextscrlist_end" );
--     if common_impl.ZzCompleteCheck("clk_bomboneextscrlist") then cmn.GotoRoom( "rm_farmext" ) end;
--  end;
--
--  ld.Lock(1);  
--  cmn.CallEventHandler( "clk_bomboneextscrlist_beg" );
--  SoundSfx( "aud_paper_open" );
--  ld.AnimPlay( "anm_bomboneextscr_anim_list", "list", func_end )
--end
----------------------------------------------------------------------
----------------------------------------------------------------------
--common_impl.hint[ "clk_bomboneextscrlist2" ] = { type = "click", use_place = "gfx_bomboneextscr_clk_bomboneextscrlist2", room = "rm_farmext", zz = "mg_bomboneextscr", zz_gate = "gmg_farmext_bomboneextscr" };
--
--private.clk_bomboneextscrlist2_logic = function()
--    ObjSet( "spr_bomboneextscr_partswitchext3", { visible = 1, input = 1, active = 1 } )   
--    ObjSet( "spr_bomboneextscr_bombmapext", {active=1, input = 1, visible = 1} );   
--end;
--
--private.clk_bomboneextscrlist2_beg = function()
--  ObjDelete("gfx_bomboneextscr_clk_bomboneextscrlist2")
--end;
--private.clk_bomboneextscrlist2_end = function()
--  if common_impl.ZzCompleteCheck("clk_bomboneextscrlist2") then ObjSet( common_impl.hint["clk_bomboneextscrlist2"].zz_gate, { visible = 0, input = 0 } ); end;
--  -- ObjDelete("anm_bomboneextscr_anim_bomba")
--  ObjDelete("anm_bomboneextscr_anim_list")
--end;
--
--cmn.AddSubscriber( "clk_bomboneextscrlist2", private.clk_bomboneextscrlist2_beg, private.room_objname );
--cmn.AddSubscriber( "clk_bomboneextscrlist2", private.clk_bomboneextscrlist2_end, private.room_objname );
--cmn.AddSubscriber( "clk_bomboneextscrlist2", private.clk_bomboneextscrlist2_logic );
--cmn.AddSubscriber( "clk_bomboneextscrlist2_beg", private.clk_bomboneextscrlist2_beg, private.room_objname );
--cmn.AddSubscriber( "clk_bomboneextscrlist2_end", private.clk_bomboneextscrlist2_end, private.room_objname );
--cmn.AddSubscriber( "clk_bomboneextscrlist2_end", private.clk_bomboneextscrlist2_logic );
----------------------------------------------------------------------
--function public.clk_bomboneextscrlist2()
--  local func_end = function()
--    ld.Lock(0);
--    cmn.SetEventDone( "clk_bomboneextscrlist2" );
--    cmn.CallEventHandler( "clk_bomboneextscrlist2_end" );
--    if common_impl.ZzCompleteCheck("clk_bomboneextscrlist2") then cmn.GotoRoom( "rm_farmext" ) end;
--  end;  
--  
--  ld.Lock(1);
--  cmn.CallEventHandler( "clk_bomboneextscrlist2_beg" );
--  SoundSfx( "aud_paper_close" )
--  ld.AnimPlay( "anm_bomboneextscr_anim_list", "list1", func_end )
--end
----------------------------------------------------------------------  
----------------------------------------------------------------------
--common_impl.hint[ "get_partswitchext3" ] = { type = "get", get_obj = "spr_bomboneextscr_partswitchext3", room = "rm_farmext", zz = "mg_bomboneextscr", zz_gate = "gmg_farmext_bomboneextscr" };
--
--private.get_partswitchext3_logic = function()
--  
--end;
--private.get_partswitchext3_inv = function()
--  interface.InventoryItemAdd("inv_partswitchext","spr_bomboneextscr_partswitchext3",function() level_inv.ProcessGetPartswitchextAll( "get_partswitchext3" ) end);
--end;
--private.get_partswitchext3_beg = function()
--  ObjDelete("gfx_bomboneextscr_partswitchext3")
--end;
--private.get_partswitchext3_end = function()
--  if common_impl.ZzCompleteCheck("get_partswitchext3") then ObjSet( common_impl.hint["get_partswitchext3"].zz_gate, { visible = 0, input = 0 } ); end;
--  -- ObjDelete("anm_bomboneextscr_anim_bomba")
--  ObjDelete("spr_bomboneextscr_sh_partswitchext3")
--end;
--
--cmn.AddSubscriber( "get_partswitchext3", private.get_partswitchext3_inv );
--cmn.AddSubscriber( "get_partswitchext3", private.get_partswitchext3_beg, private.room_objname );
--cmn.AddSubscriber( "get_partswitchext3", private.get_partswitchext3_end, private.room_objname );
--cmn.AddSubscriber( "get_partswitchext3", private.get_partswitchext3_logic );
----------------------------------------------------------------------
--function public.get_partswitchext3()
--  ObjSet( "spr_bomboneextscr_partswitchext3", {visible = 1} );
--  cmn.SetEventDone( "get_partswitchext3" );
--  cmn.CallEventHandler( "get_partswitchext3" );
--  if common_impl.ZzCompleteCheck("get_partswitchext3") then cmn.GotoRoom( "rm_farmext" ) end;
--end
---------------------------------------------------------------------- 
-----------------------------------------------------------------------  
--common_impl.hint[ "get_bombmapext" ] = { type = "get", get_obj = "spr_bomboneextscr_bombmapext", room = "rm_farmext", zz = "mg_bomboneextscr", zz_gate = "gmg_farmext_bomboneextscr" };
--
--private.get_bombmapext_logic = function()
--  
--end;
--private.get_bombmapext_inv = function()
--  interface.InventoryItemAdd("inv_bombmapext","spr_bomboneextscr_bombmapext");
--  ObjSet( "inv_bombmapext", { drag = 0 } );
--end;
--private.get_bombmapext_beg = function()
--  ObjDelete("gfx_bomboneextscr_bombmapext")
--end;
--private.get_bombmapext_end = function()
--  if common_impl.ZzCompleteCheck("get_bombmapext") then ObjSet( common_impl.hint["get_bombmapext"].zz_gate, { visible = 0, input = 0 } ); end;
--  
--end;
--
--cmn.AddSubscriber( "get_bombmapext", private.get_bombmapext_inv );
--cmn.AddSubscriber( "get_bombmapext", private.get_bombmapext_beg, private.room_objname );
--cmn.AddSubscriber( "get_bombmapext", private.get_bombmapext_end, private.room_objname );
--cmn.AddSubscriber( "get_bombmapext", private.get_bombmapext_logic );
----------------------------------------------------------------------
--function public.get_bombmapext()
--  cmn.SetEventDone( "get_bombmapext" );
--  cmn.CallEventHandler( "get_bombmapext" );
--  if common_impl.ZzCompleteCheck("get_bombmapext") then cmn.GotoRoom( "rm_farmext" ); end;
--end
----------------------------------------------------------------------
-------------------------------------------------------------------------------- 
  
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_bomboneextscr"} ) then
    cmn.MiniGameShow( "bomboneextscr" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_farmext_env" )
  if not ld.CheckRequirements( {"win_bomboneextscr"} ) then
     SoundEnv( "aud_mg_bomb1_env",1 )
  end;   
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_bomboneextscr"} ) then
    cmn.MiniGameHide( "bomboneextscr" );
  end
  SoundEnv( "aud_mg_bomb1_env",0 )
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function()
     gm.state = ld.TableCopy(private.bomboneextscr_fp_array);
     ng_global.progress["scr"]["win_bomboneextscr"].state = gm.state;
     private.bomboneextscr_win_ver_first_start_flag = false;
     private.bomboneextscr_stand_on_pos();
     -- private.Win();
     ObjAnimate( "obj_bomboneextscr_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.5,0,1} );
  end;
  
  ld.Lock(1);
  ObjAnimate( "obj_bomboneextscr_root", 8, 0, 0, func_end, {0,0,1, 0.5,0,0} );
end;
--*********************************************************************************************************************
function public.Skip()
  local func_end = function()
     gm.state = ld.TableCopy(private.bomboneextscr_win_array);
     ng_global.progress["scr"]["win_bomboneextscr"].state = gm.state;
     private.bomboneextscr_win_ver_first_start_flag = false;
     private.bomboneextscr_stand_on_pos();
     -- private.Win();
     ObjAnimate( "obj_bomboneextscr_root", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
  end;
  
  ld.Lock(1);
  ObjAnimate( "obj_bomboneextscr_root", 8, 0, 0, func_end, {0,0,1, 0.5,0,0} );
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_bomboneextscr" );
  rm_secretroomscr.GotoRoom( 'rm_secretroomscr' ) 
  
end;
--*********************************************************************************************************************
function private.Win()
  SoundEnv( "aud_mg_bomb1_env",0 )
  ld.Lock(1);
  cmn.MiniGameHide(true);
  ld.StartTimer( 0.3, function() 
    SoundSfx( "aud_mg_bomb1_defuse" )
    SoundSfx( "aud_mg_bomb1_cloth" );
    ld.AnimPlay( "anm_bomboneextscr_anim_bomba", "with", function()  ld.StartTimer( 0.5, private.WinEnd  ); end )
  end )
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  private.bomboneextscr_parts_init();
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["scr"]["win_bomboneextscr"].state then
      gm.state = ng_global.progress["scr"]["win_bomboneextscr"].state;
    else  
      ng_global.progress["scr"]["win_bomboneextscr"].state = ld.TableCopy(private.bomboneextscr_fp_array);
      gm.state = ng_global.progress["scr"]["win_bomboneextscr"].state;
    end
   
    gm.loaded  = true;
  else
  
  end;
  private.bomboneextscr_win_ver_first_start_flag = false;
  private.bomboneextscr_stand_on_pos();
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_bomboneextscr"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;