-- name=mg_gatespondextscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_gatespondextscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--  common_impl.hint[ "win_gatespondextscr" ] = {type = "win", use_place = "mg_gatespondextscr", room = "rm_farmext", zz = "mg_gatespondextscr", zz_gate = "gmg_farmext_gatespondextscr" };
--
--  local win_gatespondextscr_logic = function()
--    if ld.CheckRequirements( {"win_gatespondextscr"} ) then
--      
--    end
--  end;
--  local win_gatespondextscr = function()
--    if ld.CheckRequirements( {"win_gatespondextscr"} ) then
--      
--    end
--  end;
--  cmn.AddSubscriber("win_gatespondextscr", win_gatespondextscr, private.room_objname )
--  cmn.AddSubscriber("win_gatespondextscr", win_gatespondextscr_logic )
--  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;

--local gatespondextscr_pos_coord={{{320,218}, {692,218}},
--                              {{271,318}, {741,318}},
--                              {{271,431}, {741,431}},
--                              {{321,527}, {691,527}}}
--                              
                              
local gatespondextscr_pos_coord={{{320,218},{271,318},{271,431},{321,527}},{{692,218},{741,318}, {741,431}, {691,527}}}
                                                        
                              
-- 1-blue, 2 - yellow, 3-green, 4 -red         
local gatespondextscr_parts_fp={{{2,1},{3,1},{4,1},{1,1}},{{3,2},{4,2},{1,2},{2,2}}};    
---------------------------------------------------------------------------------------
function public.gatespondextscr_circle_mdown()
   for i=1,4,1 do 
     for j=1,2,1 do 
        ObjSet( "spr_gatespondextscr_a"..i.."_"..j, {input=0} );
        ObjSet( "spr_gatespondextscr_lig_"..i.."_"..j, {alp=0} );
     end;  
   end;  
   ObjStartDrag("obj_gatespondextscr_drag_zone"); 
   SoundSfx( "aud_mg_gatespondext_drag" );
end;  

local gatespondextscr_sd_pos={0,0};
local gatespondextscr_sd_ang = 0;
function public.gatespondextscr_startdrag()
     ObjSet("spr_gatespondextscr_lig_c",{alp=1})
  
  
     local center = {ObjGet("spr_gatespondextscr_c").pos_x,ObjGet("spr_gatespondextscr_c").pos_y};
     ld.SetCursor(CURSOR_HAND);
     local cursor = GetZoomCursorPos(); 
     gatespondextscr_sd_pos = ld.TableCopy(cursor);
     gatespondextscr_sd_ang = ObjGet("spr_gatespondextscr_c").ang;
     private.gatespondextscr_fa = gatespondextscr_sd_ang;
     local circle_ang = math.atan(math.abs(cursor[1]-center[1])/math.abs(cursor[2]-center[2]))*((cursor[1]-center[1])/math.abs(cursor[1]-center[1]))*((cursor[2]-center[2])/math.abs(cursor[2]-center[2]))
     if (cursor[2]-center[2])/math.abs(cursor[2]-center[2])==-1 then circle_ang=circle_ang+math.pi end;
 
     -- circle_ang = math.pi/2 - circle_ang;
  --   ld.LogTrace( "gatespondextscr_sd_ang = "..gatespondextscr_sd_ang );
     ObjSet( "obj_gatespondextscr_circle_root", {ang = circle_ang} );
end;
   
--function private.gatespondextscr_ang( a_beg, a_end )
--  if math.abs(a_beg-a_end) > math.pi then
--    if a_beg > a_end then
--      a_beg = a_beg - math.pi * 2
--    else
--      a_beg = a_beg + math.pi * 2
--    end;
--  end;
--  return a_beg;
--end; 
   
private.gatespondextscr_fa = 0;
private.gatespondextscr_sound_step = 10;
function private.gatespondextscr_circle_sound(ang)
  local step_on_rad = (private.gatespondextscr_sound_step/180)*math.pi;
  if math.abs(private.gatespondextscr_fa-ang)>=step_on_rad then
    SoundSfx( "aud_mg_gatespondext_rotate" );
    private.gatespondextscr_fa = ang;
  end;  
end;  


function public.gatespondextscr_drag()
   if not ApplyObj("obj_gatespondextscr_drag_zone","spr_gatespondextscr_c") then 
     ObjStopDrag("obj_gatespondextscr_drag_zone");
   else 
     local center = {ObjGet("spr_gatespondextscr_c").pos_x,ObjGet("spr_gatespondextscr_c").pos_y};
     local cursor = GetZoomCursorPos(); 
     local vector_a = {gatespondextscr_sd_pos[1]-center[1],gatespondextscr_sd_pos[2]-center[2]};
     local vector_b = {cursor[1]-center[1],cursor[2]-center[2]};
     local sc_pr = vector_a[1]*vector_b[1]+vector_a[2]*vector_b[2];
     local mod_a = math.pow((vector_a[1]*vector_a[1]+vector_a[2]*vector_a[2]),0.5);
     local mod_b = math.pow((vector_b[1]*vector_b[1]+vector_b[2]*vector_b[2]),0.5);
     local d_ang = math.acos(sc_pr/(mod_a*mod_b));
     if sc_pr/(mod_a*mod_b)>1 then d_ang = math.acos(1);  end;
     if sc_pr/(mod_a*mod_b)<-1 then d_ang = math.acos(-1);  end;
    -- ld.LogTrace( "sc_pr/(mod_a*mod_b) = "..sc_pr/(mod_a*mod_b) );
     
     --- search napr 
     local right_pos=ld.TableCopy(GetObjPosByObj("obj_gatespondextscr_right_zone"));
     local vector_c = {right_pos[1]-center[1],right_pos[2]-center[2]};
     local sc_pr2 =  vector_c[1]*vector_b[1]+vector_c[2]*vector_b[2];
     local mod_c = math.pow((vector_c[1]*vector_c[1]+vector_c[2]*vector_c[2]),0.5);
     local d_ang_c = math.acos(sc_pr2/(mod_c*mod_b));
     local zn=1;
     
     --   ld.LogTrace( "d_ang_c = "..d_ang_c );
     
     if d_ang_c<=math.pi/2 then zn=-1; else zn=1; end; 
       
     
    
     local new_ang = math.fmod((gatespondextscr_sd_ang+zn*d_ang)+4*math.pi,2*math.pi);
     -- local ang_n =  private.gatespondextscr_ang( new_ang, gatespondextscr_sd_ang);
     ObjSet( "spr_gatespondextscr_c", {ang = new_ang} ); 
     private.gatespondextscr_circle_sound(new_ang); --for sfx
     gatespondextscr_sd_pos = ld.TableCopy(cursor);
     gatespondextscr_sd_ang = ld.TableCopy(new_ang);
     local circle_ang = math.atan(math.abs(cursor[1]-center[1])/math.abs(cursor[2]-center[2]))*((cursor[1]-center[1])/math.abs(cursor[1]-center[1]))*((cursor[2]-center[2])/math.abs(cursor[2]-center[2]))
     if (cursor[2]-center[2])/math.abs(cursor[2]-center[2])==-1 then circle_ang=circle_ang+math.pi end;
     -- circle_ang = math.pi/2 - circle_ang;
     ObjSet( "obj_gatespondextscr_circle_root", {ang = circle_ang} );
  --   ObjSet( "obj_gatespondextscr_circle_root", {ang = gatespondextscr_sd_ang+math.pi/2} );
  --  ld.LogTrace( "ang = "..new_ang); 
   end;  
end;  
 
function public.gatespondextscr_dragdrop()
  ld.SetCursor(CURSOR_DEFAULT);
  ObjSet("spr_gatespondextscr_lig_c",{alp=0})
  gm.state[1]=ObjGet("spr_gatespondextscr_c").ang;
  private.gatesponext_circle_hard_stand()
  SoundSfx( "aud_mg_gatespondext_drop" );
end;  

private.gatespondextscr_apply_array = {
       {{{1,1},{2,1}},{{4,2},{2,2}}},
       {{{1,1},{1,1}},{{2,1},{2,1}},{{3,2},{2,2}}},
       {{{2,1},{1,1}},{{3,1},{2,1}},{{2,2},{2,2}},{{4,2},{1,2}}},
       {{{3,1},{1,1}},{{4,1},{2,1}},{{1,2},{2,2}},{{3,2},{1,2}}},
       {{{4,1},{1,1}},{{2,2},{1,2}}},
       {{{1,1},{2,2}},{{4,2},{2,1}}},
       {{{2,1},{2,2}},{{3,2},{2,1}},{{4,2},{1,1}}},
       {{{1,1},{1,2}},{{3,1},{2,2}},{{2,2},{2,1}},{{3,2},{1,1}}},
       {{{2,1},{1,2}},{{4,1},{2,2}},{{1,2},{2,1}},{{2,2},{1,1}}},
       {{{3,1},{1,2}},{{1,2},{1,1}}}}

private.gatespondeext_apply_angles={5.3649392822988,5.8274479584653,0.0041553633277438,0.45571553816957,0.92050429303383, 2.2189649193302,2.6787201632668,3.143189646724,3.606916163019,4.0668483061974}

private.gatespondextscr_current_ang=0;

function private.gatesponext_search_para(cur_ang,num)
  local count=0;
  local way=0;
  for i=1,#private.gatespondextscr_apply_array[cur_ang],1 do 
    if private.gatespondextscr_apply_array[cur_ang][i][1][1] == num then way =  private.gatespondextscr_apply_array[cur_ang][i][2][1]; break; end;
  end;  
  for i=1,#private.gatespondextscr_apply_array[cur_ang],1 do 
    if way== private.gatespondextscr_apply_array[cur_ang][i][2][1] then 
      count=count+1;
    end;
  end;  
  --  ld.LogTrace( "cur_ang = "..cur_ang.." way = "..way.." num = "..num.." count = "..count );
  if count==2 then return true; else return false; end;
end;  


--private.gatesponext_circle_hard_stand_first_start_flag=false;
function private.gatesponext_circle_hard_stand(first_load)
 -- ld.LogTrace( "hard stand" );
   local func_end = function() 
       private.gatespondextscr_stand_on_pos();
   end; 
   
  -- if first_load then private.gatespondextscr_stand_on_pos(); end;
    
   for i=1,#private.gatespondextscr_apply_array,1 do
     local count=0;
   --  ld.LogTrace( "number i="..i.." #private.gatespondextscr_apply_array[i] = "..#private.gatespondextscr_apply_array[i] );
     for j=1,#private.gatespondextscr_apply_array[i],1 do 
        if ApplyObj("obj_gatespondextscr_st_z_"..private.gatespondextscr_apply_array[i][j][1][1].."_"..private.gatespondextscr_apply_array[i][j][1][2],"obj_gatespondextscr_cr_z_"..private.gatespondextscr_apply_array[i][j][2][1].."_"..private.gatespondextscr_apply_array[i][j][2][2]) then 
           count=count+1;
    --       ld.LogTrace( "apply "..private.gatespondextscr_apply_array[i][j][1][1].."_"..private.gatespondextscr_apply_array[i][j][1][2].." and "..private.gatespondextscr_apply_array[i][j][2][1].."_"..private.gatespondextscr_apply_array[i][j][2][2] );
        end;   
     end;  
  --  ld.LogTrace( "number "..i.." count = "..count );  
     if count== #private.gatespondextscr_apply_array[i] then 
       ObjSet( "spr_gatespondextscr_c", {ang=private.gatespondeext_apply_angles[i]} ); 
       gm.state[1] = private.gatespondeext_apply_angles[i];
       for j=1,#private.gatespondextscr_apply_array[i],1 do  
          local pi,pj =  gm.state[2][private.gatespondextscr_apply_array[i][j][1][2] ][private.gatespondextscr_apply_array[i][j][1][1] ][1], gm.state[2][private.gatespondextscr_apply_array[i][j][1][2] ][private.gatespondextscr_apply_array[i][j][1][1] ][2]; 
          if  private.gatesponext_search_para(i,private.gatespondextscr_apply_array[i][j][1][1]) then 
            ObjSet( "spr_gatespondextscr_a"..pi.."_"..pj, {input=1} );
            ObjSet( "spr_gatespondextscr_lig_"..pi.."_"..pj, {alp=1} );
          end;  
       end;
       private.gatespondextscr_current_ang = i; 
       if first_load~=true then 
          SoundSfx( "aud_mg_gatespondext_active" );
        --  ld.LogTrace( "active" );
       end;
      -- private.gatesponext_circle_hard_stand_first_start_flag = true; 
       func_end();  
       return;
     end; 
   end;
 
    func_end();  
end;  
          
-----------------------------------------------------------------------------
local gatespondeext_parts_init_flag=false;
function private.gatespondeext_parts_init()
  if gatespondeext_parts_init_flag==false then
    for i=1,2,1 do 
      for j=1,2,1 do 
        ObjSet("obj_gatespondextscr_cr_z_"..i.."_"..j,{inputrect_init=1, inputrect_x=-1, inputrect_y=-1, inputrect_w=2, inputrect_h=2})
      end;  
    end;  
    for i=1,4,1 do 
      for j=1,2,1 do
        ObjCreate("spr_gatespondextscr_lig_"..i.."_"..j,"spr")
        ObjAttach("spr_gatespondextscr_lig_"..i.."_"..j,"spr_gatespondextscr_a"..i.."_"..j);
        ObjSet( "spr_gatespondextscr_lig_"..i.."_"..j, {res="assets/levels/levelext/mg_gatespondext/lig_a", input= 0, alp=0} );
        
        
        ObjSet( "spr_gatespondextscr_a"..i.."_"..j, {event_mdown="mg_gatespondextscr.gatespondextscr_part_mdown("..i..","..j..")", event_menter="ld.SetCursor(CURSOR_HAND)", event_mleave="ld.SetCursor(CURSOR_DEFAULT)"} );
      end;  
    end;  
 gatespondeext_parts_init_flag = true;
  end;  
end;  

function private.gatespondextscr_stand_on_pos()
  ObjSet( "spr_gatespondextscr_c", {ang = gm.state[1]} );
  --gatespondextscr_parts_fp={{{2,1},{3,1},{4,1},{1,1}},{{3,2},{4,2},{1,2},{2,2}}}; 
  for i=1,2,1 do
    for j=1,4,1 do
      ObjSet( "spr_gatespondextscr_a"..gm.state[2][i][j][1].."_"..gm.state[2][i][j][2], {pos_x=gatespondextscr_pos_coord[i][j][1], pos_y=gatespondextscr_pos_coord[i][j][2], event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT)"} );
    end;  
  end;  
  private.gatespondextscr_win_ver();
end;  
------------------------------------------------------------------------------
function private.gatespondextscr_win_ver()
  local count=0;
  for i=1,2,1 do
    for j=1,4,1 do 
      if gm.state[2][i][j][1]==j then count=count+1; end;
    end;  
  end;  
  if count==8 then private.Win(); end;
end;
------------------------------------------------------------------------------
function public.gatespondextscr_part_mdown(n_type,num)  --mg_gatespondextscr.gatespondextscr_part_mdown(n_type,num)
  --  ld.LogTrace( "______________________________" );
  --ld.LogTrace( "cur_part = "..n_type.." "..num );
  
  local p_pos= private.gatespondextscr_search_part_pos(n_type,num);
  -- ld.LogTrace( "p_pos = "..p_pos[1].." "..p_pos[2] );
  local next_part_array = private.gatespondextscr_search_part_way(p_pos);
 
  local p1_coord = gatespondextscr_pos_coord[p_pos[2] ][p_pos[1] ];
  -- ld.LogTrace( "p1_coord = "..p1_coord[1].." "..p1_coord[2] );
  local p2_coord = gatespondextscr_pos_coord[next_part_array.p_pos[2] ][next_part_array.p_pos[1] ];
  -- ld.LogTrace( "p1_coord = "..p2_coord[1].." "..p2_coord[2] );
 
  local next_part = ld.TableCopy(next_part_array.next_part);
  -- ld.LogTrace( "next_part = "..next_part[1].." "..next_part[2] );
  -- ld.LogTrace( "next part pos = "..next_part_array.p_pos[1].." "..next_part_array.p_pos[2] );
 
  local center = {ObjGet("spr_gatespondextscr_c").pos_x,ObjGet("spr_gatespondextscr_c").pos_y};
 
  
  local func_end = function()
     ld.Lock(0);
     buf = ld.TableCopy(gm.state[2][p_pos[2] ][p_pos[1] ]);
     gm.state[2][p_pos[2] ][p_pos[1] ] = ld.TableCopy(gm.state[2][next_part_array.p_pos[2] ][next_part_array.p_pos[1] ] );
     gm.state[2][next_part_array.p_pos[2] ][next_part_array.p_pos[1] ]  = ld.TableCopy(buf);
     private.gatesponext_circle_hard_stand();
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_mg_gatespondext_move" );
  ObjAnimate( "spr_gatespondextscr_a"..n_type.."_"..num, 3, 0, 0, function() end, {0,0,p1_coord[1],p1_coord[2], 0.25,0,center[1],center[2], 0.5,0,p2_coord[1],p2_coord[2]} );
  ObjAnimate( "spr_gatespondextscr_a"..next_part[1].."_"..next_part[2], 3, 0, 0, func_end, {0,0,p2_coord[1],p2_coord[2], 0.25,0,center[1],center[2], 0.5,0,p1_coord[1],p1_coord[2]} );
end;  


function private.gatespondextscr_search_part_pos(n_type,num)
  for i=1,2,1 do 
    for j=1,4,1 do 
      if gm.state[2][i][j][1]==n_type and gm.state[2][i][j][2]==num then 
        return {j,i};
      end;  
    end;  
  end;  
end;  

function private.gatespondextscr_search_part_way(p_pos)
  local cur_ang_num=private.gatespondextscr_current_ang;
  local cur_way = {0,0};
  local next_way = {0,0};
  local next_p_pos={0,0};
  local next_part={0,0};
  local return_array={};
  
  for i=1,#private.gatespondextscr_apply_array[cur_ang_num],1 do 
    if private.gatespondextscr_apply_array[cur_ang_num][i][1][1]==p_pos[1] and private.gatespondextscr_apply_array[cur_ang_num][i][1][2]==p_pos[2] then cur_way= private.gatespondextscr_apply_array[cur_ang_num][i][2] end;
  end;  
  
  for i=1,#private.gatespondextscr_apply_array[cur_ang_num],1 do 
    if private.gatespondextscr_apply_array[cur_ang_num][i][2][1]==cur_way[1] and private.gatespondextscr_apply_array[cur_ang_num][i][2][2]~=cur_way[2] then 
      next_way =  private.gatespondextscr_apply_array[cur_ang_num][i][2];
      next_p_pos = private.gatespondextscr_apply_array[cur_ang_num][i][1];
    end;  
  end;  
  
  next_part = ld.TableCopy(gm.state[2][next_p_pos[2] ][next_p_pos[1] ]);
  return_array.next_part = next_part;
  return_array.p_pos = next_p_pos;
  
  return return_array;
end;  
------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_gatespondextscr"} ) then
    cmn.MiniGameShow( "gatespondextscr" );
    private.gatesponext_circle_hard_stand();
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  iOS_NeedDrag(0);
  SoundEnv( "aud_farmext_env" )
  private.gatespondeext_parts_init();
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_gatespondextscr"} ) then
    cmn.MiniGameHide( "gatespondextscr" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
  iOS_NeedDrag(1);
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function()
   for i=1,4,1 do 
     for j=1,2,1 do 
        ObjSet( "spr_gatespondextscr_a"..i.."_"..j, {input=0} );
        ObjSet( "spr_gatespondextscr_lig_"..i.."_"..j, {alp=0} );
     end;  
   end;  
    
    private.gatespondextscr_current_ang=1;
   -- private.gatesponext_circle_hard_stand_first_start_flag = false;
    ng_global.progress["scr"]["win_gatespondextscr"].state = {0,ld.TableCopy(gatespondextscr_parts_fp)};
    gm.state = ng_global.progress["scr"]["win_gatespondextscr"].state; 
    private.gatesponext_circle_hard_stand();
    ObjAnimate( "obj_gatespondextscr_parts_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_gatespondextscr_parts_root", 8, 0, 0, function() end, {0,0,1, 0.25,0,0} );
  local cur_ang = ObjGet("spr_gatespondextscr_c").ang;
  ObjAnimate( "spr_gatespondextscr_c", 7, 0, 0, func_end, {0,0,cur_ang, 0.26,0,0} );  
end;
--*********************************************************************************************************************
function public.Skip()
  --private.Win();
  
  local win_array = {{{1,1},{2,1},{3,1},{4,1}},{{1,2},{2,2},{3,2},{4,2}}}
  
  local func_end = function()
    private.gatespondextscr_current_ang=0;
    ng_global.progress["scr"]["win_gatespondextscr"].state = {0,ld.TableCopy(win_array)};
    gm.state = ng_global.progress["scr"]["win_gatespondextscr"].state; 
    private.gatesponext_circle_hard_stand();
    ObjAnimate( "obj_gatespondextscr_parts_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_gatespondextscr_parts_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
  local cur_ang = ObjGet("spr_gatespondextscr_c").ang;
  ObjAnimate( "spr_gatespondextscr_c", 7, 0, 0, function() end, {0,0,cur_ang, 0.5,0,0} ); 
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_gatespondextscr" );
  rm_secretroomscr.GotoRoom( 'rm_secretroomscr' ) 
 -- cmn.CallEventHandler( "win_gatespondextscr" );
 -- if common_impl.ZzCompleteCheck( "win_gatespondextscr" ) then cmn.GotoRoom( "rm_farmext" ); end;
 -- interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
 
  cmn.MiniGameHide(true);
  SoundSfx( "aud_mg_gatespondext_win" );
  local time=0;
  local step=0.2;
  for i=1,2,1 do 
    for j=1,4,1 do 
     -- local cur_alph = ObjGet("spr_gatespondextscr_lig_"..j.."_"..i).alp;
     ObjAnimate( "spr_gatespondextscr_lig_"..j.."_"..i, 8, 0, 0, function() end, {0,0,0, time,0,0, time+0.3,0,1} );
     time = time+step;
    end;  
  end;  
  ld.StartTimer( 2, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["scr"]["win_gatespondextscr"].state then
      gm.state = ng_global.progress["scr"]["win_gatespondextscr"].state 
    else  
      ng_global.progress["scr"]["win_gatespondextscr"].state = {0,ld.TableCopy(gatespondextscr_parts_fp)};
      gm.state = ng_global.progress["scr"]["win_gatespondextscr"].state; 
    end
  
    gm.loaded  = true;
  else
   
  end;
  private.gatesponext_circle_hard_stand(true);
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_gatespondextscr"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;