-- name=levelscr

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 2000 );
  interface.WidgetAdd( InterfaceWidget_BtnMenu, 13 );
  --interface.WidgetAdd( InterfaceWidget_BtnGuide, 12 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 11 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  --interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 9 );

  interface.WidgetAdd( InterfaceWidget_Effects );

  --!!!!interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  interface.WidgetAdd( InterfaceWidget_DialogHo,30 );

  --interface.ButtonLockAdd();
  interface.LockAdd();

  --interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  interface.WidgetAdd( InterfaceWidget_ItemPanel,9 );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog,30 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo,30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory,30 );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 30 );

  --interface.WidgetAdd( InterfaceWidget_StrategyGuide,30 );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial,30 );

  --!!!!!interface.WidgetAdd( InterfaceWidget_Map, 16  );

  interface.PanelNotificationAdd(10);

  --interface.PanelscrAdd(9)
  --interface.DialogTaskscrAdd(1000)
  --interface.DeployInvAdd(7);
  --interface.ComplexInvAdd( 9 )
  interface.DialogHintAdd(20);
  --interface.Btn_DiaryAdd(12)
  --interface.InvestigationButtonAdd( 17 );
  --interface.DiaryAdd( 18 );
  --interface.DiaryDcnAdd( 31 ); 

  interface.PanelhopairAdd(9)
  --interface.ButtonTaskAdd(20)
  --interface.DialogTaskAdd(1000)

  private.Init();



  
  
  ModLoad( "assets/levels/levelscr/mod_levelscr_inv" );
  levelscr_inv.Init()
  private.TutorInit(); --функции туториала


  
  if not param or param=="5" then 
    param = "rm_secretroomscr"
  end
  ld.LogTrace( param );
  
  common.LevelLoad( "levelscr", "scr", param );
  


  --ModLoad( "assets/interface/map/mod_map" );
  --interface.ArrInvPlus()  -- проверка состояния плюсика для деплойных инв предметов
  --public.init_diary_analysis()  ---клики для дневника

  --interface.KeyUpdate();

  --временно залочена кнопка SG
  interface.WidgetSetInput(InterfaceWidget_BtnGuide, 0)

  --interface.CheckCards()
  --interface.CheckMorphing()
end;


function private.Init ()

  game = {};
  game.room_names =
  {
  "rm_secretroomscr", 
  
  "mg_fencepuzzlescr",
  "mg_vitragemgscr",
  "mg_grillemgscr",
  "mg_gatemgscr",
  "mg_crossingscr",
  "mg_flowscr",
  "mg_storystormscr",
  "mg_carpetmgscr",
  "mg_clockmgscr",
  "mg_bomboneextscr",
  "mg_gatespondextscr",
  "mg_pubmgextscr",
  "mg_mechanismextscr",
  
  "ho_barnscr",
  "ho_commodehoscr",
  "ho_groundhoscr",
  "ho_pantryscr",  
  "ho_bookhoscr",
  "ho_chatterhoscr",
  "ho_puddlescr",
  "ho_suitcasescr",
  "ho_crystalhoscr",
  "ho_rootshoextscr",
  "ho_innerporchhoextscr",
  "ho_bombthreeextscr",  
  "ho_sweetsextscr",

  };

  game.progress_names =
  {
  

  "win_fencepuzzlescr",
  "win_vitragemgscr",
  "win_grillemgscr",
  "win_gatemgscr",
  "win_crossingscr",
  "win_flowscr",
  "win_storystormscr",
  "win_carpetmgscr",
  "win_clockmgscr",
  "win_bomboneextscr",
  "win_gatespondextscr",
  "win_pubmgextscr",
  "win_mechanismextscr",
  
  "opn_barnscr",
  "win_barnscr",
  "opn_commodehoscr",
  "win_commodehoscr",
  "opn_groundhoscr",
  "win_groundhoscr",
  "opn_pantryscr",
  "win_pantryscr",
  "opn_bookhoscr",
  "win_bookhoscr",
  "opn_chatterhoscr",
  "win_chatterhoscr",
  "opn_puddlescr",
  "win_puddlescr",
  "opn_suitcasescr",
  "win_suitcasescr",
  "opn_crystalhoscr",
  "win_crystalhoscr",
  "opn_rootshoextscr",
  "win_rootshoextscr",
  "opn_innerporchhoextscr",
  "win_innerporchhoextscr",
  "opn_bombthreeextscr",
  "win_bombthreeextscr",
  "opn_sweetsextscr",
  "win_sweetsextscr",

  
  };
  
    game.relations = {};
  
 end
  
  
  
----------------------
function private.TutorInit()
----------------------progress for tutorial
  game.tutorial_progress =
  {
      "tutorial_opnscr" -- открытие секретрум
      ,"tutorial_counterscr"  -- счетчик предметов
      ,"tutorial_timerscr"  -- таймер    
      ,"tutorial_achscr"    -- ачивки
      ,"tutorial_prgbar"    -- шкала


  };

  for i=1, #game.tutorial_progress do

    table.insert(   game.progress_names, game.tutorial_progress[ i ] );

    levelscr[game.tutorial_progress[ i ] ] = {}
  end;


   levelscr.tutorial_current = "";


  

 
 ----------------------------------------------------------------------------------------
  function public.TutorialDisable() -- skip tutor all
    levelscr.tutorial_current = nil
    for i = 1, ( #game.tutorial_progress ), 1 do

      local tutorial_element = game.tutorial_progress[ i ];

      cmn.SetEventDone( tutorial_element );

    end;

  end;
  function private.TutorialGameModeCheck(tutorial_name)  -- проверка на кастом режим и выключен ли туториал
    if ng_global.gamemode == 3 and not ng_global.gamemode_custom["tutorial"] then
      cmn.SetEventDone(tutorial_name)
    end
    if not cmn.IsEventDone(tutorial_name) and cmn.IsEventDone( "tutorial_opnscr" ) then
      return true
    else
      return false
    end
  end 
  
----------------------------------------------------------------------------------------
  function public.tutorial_opnscr.first()

    if ( ng_global.gamemode == 0 ) then
      if  ( not cmn.IsEventDone( "tutorial_opnscr" ) )
      then
        levelscr.tutorial_current = "tutorial_opnscr";
        interface.TutorialShow( "str_tutorial_opnscr", 1, 500, 300 );
      end;
    elseif ng_global.gamemode == 3  then
      if  not ng_global.gamemode_custom["tutorial"] then  --
        --DbgTrace("off tutor")
        for i = 1, ( #game.tutorial_progress), 1 do
          local tutorial_element = game.tutorial_progress[ i ];
          cmn.SetEventDone( tutorial_element );
        end;
      end

      if  ( not cmn.IsEventDone( "tutorial_opnscr" ) )
      then
        levelscr.tutorial_current = "tutorial_opnscr";
        interface.TutorialShow( "str_tutorial_opnscr", 1, 500, 300 );
      end;


    else
      levelscr.TutorialDisable();
    end;

  end;
--------------------------------------------------------------------------------------------
  function public.tutorial_opnscr.click() -- событие по клику на да
    levelscr.tutorial_current = nil
    interface.TutorialHide();
    cmn.SetEventDone( "tutorial_opnscr" );
    --ld.Lock(1)
    ld.StartTimer( 0.3, function() public.tutorial_counterscr.first();ld.Lock(0); end )
  end
  function public.tutorial_opnscr.click_no() --не обязательно
    interface.TutorialHide();
    levelscr.TutorialDisable();

  end  
  
  --------------------------------------------------------------------------------------------
  function public.tutorial_counterscr.first()
      if  ( cmn.IsEventDone( "tutorial_opnscr" ) )
      and ( private.TutorialGameModeCheck( "tutorial_counterscr" ) ) then
        levelscr.tutorial_current = "tutorial_counterscr";
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        local tut_arrows={{pos_x = -300-offset,pos_y=-90,ang=0.785}};
        interface.TutorialShow( "str_tutorial_counterscr", false, 500, 300,tut_arrows );
      end
  end

  function public.tutorial_counterscr.click()
    ld.LogTrace( "tutorial_counterscr done" );
    levelscr.tutorial_current = nil
    interface.TutorialHide();
    
    cmn.SetEventDone( "tutorial_counterscr" );
    --ld.Lock(1)
    ld.StartTimer( 0.3, function() public.tutorial_timerscr.first();ld.Lock(0); end )
    
  end
  --------------------------------------------------------------------------------------------
  function public.tutorial_timerscr.first()
      if  ( cmn.IsEventDone( "tutorial_counterscr" ) )
      and ( private.TutorialGameModeCheck( "tutorial_timerscr" ) ) then
        levelscr.tutorial_current = "tutorial_timerscr";
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        local tut_arrows={{pos_x = 350+offset,pos_y=300,ang=3.925}};
        interface.TutorialShow( "str_tutorial_timerscr", false, 500, 300,tut_arrows );
      end
  end

  function public.tutorial_timerscr.click()
    levelscr.tutorial_current = nil
    interface.TutorialHide();
    cmn.SetEventDone( "tutorial_timerscr" );
    --ld.Lock(1)
    ld.StartTimer( 0.3, function() public.tutorial_achscr.first();ld.Lock(0); end )   
  end  
  --------------------------------------------------------------------------------------------
  function public.tutorial_achscr.first()
      if  ( cmn.IsEventDone( "tutorial_timerscr" ) )
      and ( private.TutorialGameModeCheck( "tutorial_achscr" ) ) then
        levelscr.tutorial_current = "tutorial_achscr";
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        local tut_arrows={{pos_x = 0,pos_y=150,ang=3.14}};
        interface.TutorialShow( "str_tutorial_achscr", false, 500, 450,tut_arrows );
      end
  end

  function public.tutorial_achscr.click()
    levelscr.tutorial_current = nil
    interface.TutorialHide();
    cmn.SetEventDone( "tutorial_achscr" );
  end   
  --------------------------------------------------------------------------------------------
  function public.tutorial_prgbar.first()
      if  ( cmn.IsEventDone( "tutorial_opnscr" ) )
      and ( private.TutorialGameModeCheck( "tutorial_prgbar" ) ) then
        levelscr.tutorial_current = "tutorial_prgbar";
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        local tut_arrows={{pos_x = -170,pos_y=170,ang=3.14}};
        interface.TutorialShow( "str_tutorial_prgbar", false, 500, 420,tut_arrows );
      end
  end

  function public.tutorial_prgbar.click()
    levelscr.tutorial_current = nil
    interface.TutorialHide();
    cmn.SetEventDone( "tutorial_prgbar" );
  end   
end  