-- name=rm_extra
--******************************************************************************************
function public.Init()
              
  ObjAttach( "rm_extra", "rooms_hub" );


--  ObjSet("spr_extra_button_main_menu",{ 
--    event_mdown =  function() private.Exit()           end,
--    event_menter = function() private.ButtonMouseEnter( "main_menu" ); end,
--    event_mleave = function() private.ButtonMouseLeave( "main_menu" ); end 
--                    })
--
--
--  ObjSet("spr_extra_button_ach", 
--  {
--    event_mdown = private.AchDown,
--    event_menter = function() public.ButtonMouseEnter('ach'); end,
--    event_mleave = function() public.ButtonMouseLeave('ach'); end
--  });
--
--  ObjSet("spr_extra_button_screensaver", 
--  {
--    event_mdown = private.ScreenSaverDown,
--    event_menter = function() private.ButtonMouseEnter('screensaver'); end,
--    event_mleave = function() private.ButtonMouseLeave('screensaver'); end
--  });
--
  --ObjSet("spr_extra_button_collectibles", 
  --{
  --  event_mdown = private.Collectibles,
  --  event_menter = function() private.ButtonMouseEnter('collectibles'); end,
  --  event_mleave = function() private.ButtonMouseLeave('collectibles'); end
  --});
--
if (GetPlatform() == "ios") then
  ObjSet("spr_extra_button_savemusic",{ active = false, visible = false, input = false, alp = 0 });
end;

end;
--******************************************************************************************
function public.PreOpen()
  if not ng_global.progress[ "ext" ].common.gamewin == true then
    ObjSet( "spr_extra_tr", {alp = 1} );
  else
    ObjSet( "spr_extra_tr", {alp = 0} );
  end
  SoundEnv( "aud_bonus_content_env" )
  ObjSet( "anm_extra_anim", {frame=1, playing=1} );
end;
--******************************************************************************************
function public.Open()
  SoundTheme( 0 )
  --SoundEnv( 0 )

  public.PlayExtraTrack( private.music_current );
end;

function public.PreClose()
  if private.music_is_play then

    common_impl.StopAllMus();

    local name = "spr_extra_music_track"..private.music_current.."_play";
    ObjSet( name, { alp = 1, input = 1 } );

    name = "spr_extra_music_track"..private.music_current.."_pause";
    ObjSet( name, { input = 0, alp = 0 } );

    ObjSet( "spr_extra_music_track"..private.music_current.."_light", { active = 0 } );
    ObjSet( "obj_extra_music_track"..private.music_current.."_light", { alp = 0 } );
    private.music_is_play = false;

  end;
end

function public.Close()
   SoundEnv( 0 )
end
--******************************************************************************************
--******************************************************************************************
function public.Exit()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  common.GotoRoom( "rm_menu" );
end

--******************************************************************************************
function public.AchDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  common.MenuAchievements();
end;
--******************************************************************************************
function public.ScreenSaverDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  common.GotoRoom( "rm_screensaver" );
end;
function public.Collectibles()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  common.GotoRoom( "rm_collectibles" );
end;




ObjAttach("rm_extra", "ng_rooms_hub");


----------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------

private.tab = 
{
  "art",
  "music",
  "wallpaper",
  "playextra",

};

private.music = 
{ 
  "soundtrack_1",
  "soundtrack_2",
  "soundtrack_3",
  "soundtrack_4",
  "soundtrack_5"
};

private.tab_current       = 4;
private.wallpaper_current = 1;
private.wallpaper_max    = 16;
private.screensaver_current = 1;
private.art_current       = 1;
private.art_max        = 12;
private.music_current     = 1;
private.music_is_play     = false;

----------------------------------------------------------------------------------------------------
function public.UpdateExtraScr( new_scr )

  new_scr = tonumber( new_scr );
  SoundSfx( "aud_click_menu" )

  public.ActivateExtraScr( 0 );
  local name = "obj_extra_"..private.tab[ new_scr ]
  local tme = 0.5;
      ObjSet( 'rm_extra', {  input = 0 } );
      ObjSet( name, { visible = 1 } );
      ObjAttach( name, "rm_extra" );
      ObjAnimate( name, "alp", 0, 0, function() public.ActivateExtraScr( 1,name);ObjSet( 'rm_extra', {  input = 1 } );end, 
      {
         0.0, 0, 0,
         tme, 0, 1
      } );

end;

function public.CloseExtraScr( new_scr )
  new_scr = tonumber( new_scr );
  SoundSfx( "aud_click_menu" )
  name = "obj_extra_"..private.tab[ new_scr ];
      ObjSet( 'rm_extra', {  input = 0 } );
      ObjAnimate( name, "alp", 0, 0, function() ObjSet( name, { visible = 0, input = 0 } ); ObjAttach( '"..name.."', 'hub_extra' );ObjSet( 'rm_extra', {  input = 1 } );end, 
      { 
        0.0, 0, ObjGet( name ).alp, 
        0.5, 0, 0
      } );
end


----------------------------------------------------------------------------------------------------
function public.ActivateExtraScr( vinput, name )

  ObjSet( "obj_extra_buttons", { input = vinput } );

  if name then

    ObjSet( name, { input = vinput });

  end;

end;
----------------------------------------------------------------------------------------------------

function public.WallpaperNext( inc )

  local max_count = private.wallpaper_max;
  local new_num;

  if private.wallpaper_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.wallpaper_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.wallpaper_current + inc;
  end;
  ObjSet( 'rm_extra', {  input = 0 } );
  local name     = "spr_extra_wallpaper_";
  local name_arr = "obj_extra_wallpaper_arrows";
  local tme      = 0.3;
  public.ActivateExtraScr( 0, name_arr );

  ObjAnimate( name..new_num, "alp", 0, 0, "", { 0,0,0, tme,0,1 } );
  ObjAnimate( name..private.wallpaper_current, "alp", 0, 0, function() public.ActivateExtraScr( 1,name_arr );ObjSet( 'rm_extra', {  input = 1 } );end, { 0,0,1, tme,0,0 } );
    
  ObjSet( "txt_extra_wallpaper_counter", { text = new_num.."/"..max_count } );
  private.wallpaper_current = new_num;
  SoundSfx( "aud_click_menu" )


end;

----------------------------------------------------------------------------------------------------

function public.ScreensaverNext( inc )

  local max_count = 3;
  local new_num;

  if private.screensaver_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.screensaver_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.screensaver_current + inc;
  end;

  local name     = "spr_extra_screensaver_";
  local name_arr = "obj_extra_screensaver_arrows";
  local tme      = 0.3;
  public.ActivateExtraScr( 0, name_arr );
  ObjSet( 'rm_extra', {  input = 0 } );
  ObjAnimate( name..new_num, "alp", 0, 0, "", { 0,0,0, tme,0,1 } );
  ObjAnimate( name..private.screensaver_current, "alp", 0, 0, function() public.ActivateExtraScr( 1,name_arr );ObjSet( 'rm_extra', {  input = 1 } );end, { 0,0,1, tme,0,0 } );
    
  ObjSet( "txt_extra_screensaver_counter", { text = new_num.."/"..max_count } );
  
--  ObjSet( "txt_extra_screensaver_name", { text = "str_extra_screensaver_name_"..new_num } );

  private.screensaver_current = new_num;
  SoundSfx( "aud_click_menu" )

end;

----------------------------------------------------------------------------------------------------

function public.ArtNext( inc )

  inc = tonumber( inc );
  local max_count = private.art_max  ;
  local new_num;

  if private.art_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.art_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.art_current + inc;
  end;

  local name     = "spr_extra_art_";
  local name_arr = "obj_extra_art_arrows";
  local tme      = 0.3;

  public.ActivateExtraScr( 0, name_arr );
  ObjSet( 'rm_extra', {  input = 0 } );
  ObjAnimate( name..new_num, "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    tme, 0, 1
  } );

  ObjAnimate( name..private.art_current, "alp", 0, 0, function() public.ActivateExtraScr(1,name_arr);ObjSet( 'rm_extra', {  input = 1 } );end, 
  {
    0.0, 0, 1,
    tme, 0, 0
  } );
    
  ObjSet( "txt_extra_art_counter", { text = new_num.."/"..max_count } );
  private.art_current = new_num;

  SoundSfx( "aud_click_menu" )

end

----------------------------------------------------------------------------------------------------

function public.PlayExtraTrack( new_mus, is_button )

  new_mus = tonumber( new_mus );

  local name = "";
  local tme = 0.0;

  if not IsNoSoundDevice()  then

    local track_path = "menu/rm_extra/aud_"..private.music[ tonumber( new_mus ) ].."_mus";

    if private.music_is_play then

      common_impl.StopAllMus();

      
      local str_name = "spr_extra_button_music_track"..private.music_current.."_play";
      ObjAnimate( str_name, "alp", 0, 0, function() ObjSet( str_name, { input = 1 } ); end, { 0,0,0, tme,0,1 } );

      name = "spr_extra_button_music_track"..private.music_current.."_pause";
      ObjSet( name, { input = 0 } );
      ObjAnimate( name, "alp", 0, 0, "", { 0,0,1, tme,0,0 } );
      ObjSet( "spr_extra_music_track"..private.music_current.."_light", { active = 0 } );

    end;



    name = "txt_extra_music_track"..private.music_current;

      ObjAnimate( name, 12, 0, 0, "", 
    {
       0.0, 0, ObjGet( name ).color_r, ObjGet( name ).color_g, ObjGet( name ).color_b,
       tme, 0, 1.0, 1, 0.5215 
    } );



    private.music_current = tonumber( new_mus );    
    local next_track = private.music_current + 1;

    if next_track > #private.music then

      next_track = 1;

    end;

    common_impl.PlayAudio( "mus", track_path, 1 );--, "", function()private.PlayExtraTrack( next_track );end, 0.5 );

    private.music_is_play = true;

    name = "spr_extra_button_music_track"..private.music_current.."_play";
    ObjSet( name, { input = 0 } );
    ObjAnimate( name, "alp", 0, 0, "", { 0,0,1, tme,0,0 } );

    local str_name = "spr_extra_button_music_track"..private.music_current.."_pause";
    ObjAnimate( str_name, "alp", 0, 0, function()     ObjSet( str_name, { input = 1 } ); end, { 0,0,0, tme,0,1 } );
    
    ObjSet( "spr_extra_music_track"..private.music_current.."_light", { active = 1 } );


    name = "txt_extra_music_track"..private.music_current;
    ObjAnimate( name, 12, 0, 0, "", 
    {
       0.0, 0, ObjGet( name ).color_r, ObjGet( name ).color_g, ObjGet( name ).color_b,
       tme, 0, 1, 0.964, 0.8627 
    } );


  else

    if is_button then
      
      common.DialogWindowShow( "common", "noaudio" );

    end;

--    if tonumber( new_mus ) ~= private.music_current or private.music_current ~= 0 then
--
--      ObjSet( "spr_extra_music_track"..private.music_current.."_light", { active = 0 } );
--
--      name = "obj_extra_music_track"..private.music_current.."_light";
--      ObjAnimate( name, "alp", 0, 0, "", { 0,0,ObjGet( name ).alp, tme,0,0 } );
--
--      name = "txt_extra_music_track"..private.music_current;
--      ObjAnimate( name, 12, 0, 0, "", 
--      {
--         0.0, 0, ObjGet( name ).color_r, ObjGet( name ).color_g, ObjGet( name ).color_b,
--         tme, 0, 0.0, 0.0, 0.0 
--      } );
--
--    end;
--
    --private.music_current = tonumber( new_mus );    
    --name = "obj_extra_music_track"..private.music_current.."_light";
--    ObjAnimate( name, "alp", 0, 0, "", { 0,0,ObjGet( name ).alp, tme,0,1 } );
--
--    name = "txt_extra_music_track"..private.music_current;
--    ObjAnimate( name, 12, 0, 0, "", 
--    {
--       0.0, 0, ObjGet( name ).color_r, ObjGet( name ).color_g, ObjGet( name ).color_b,
--       tme, 0, 0.0, 0.0, 0.0 
--    } );


  end;

end;

----------------------------------------------------------------------------------------------------
function public.PauseExtraTrack( cur_mus )

  SoundSfx( "aud_click_menu" )

  common_impl.StopAllMus();
  private.music_is_play = false;

  local name = "spr_extra_button_music_track"..cur_mus.."_pause";
  local tme = 0.0;
  ObjSet( name, { input = 0 } );
  ObjAnimate( name, "alp", 0, 0, "", { 0,0,1, tme,0,0 } );

  local str_name = "spr_extra_button_music_track"..cur_mus.."_play";
  ObjAnimate( str_name, "alp", 0, 0, function()   ObjSet(str_name, { input = 1 } ) end, { 0,0,0, tme,0,1 } );

  ObjSet( "spr_extra_music_track"..private.music_current.."_light", { active = 0 } );


  name = "txt_extra_music_track"..private.music_current;
  ObjAnimate( name, 12, 0, 0, "", 
  {
     0.0, 0, ObjGet( name ).color_r, ObjGet( name ).color_g, ObjGet( name ).color_b,
     tme, 0, 01, 1, 0.5215 
  } );


end;

----------------------------------------------------------------------------------------------------
function public.ButtonDownExit()
  
  SoundSfx( "aud_click_menu" )
  
  cmn.GotoRoom( "rm_menu", nil, true );

end;
private.txt_color = {
  playextra = { 0.259,0.659,0.788,0.639,0.914,    1},
  other     = { 0.145,0.027,0.043,0.957,0.643,0.271},
}
----------------------------------------------------------------------------------------------------
function public.ButtonMouseEnter( but_name,not_clr_txt )

  SoundSfx( "aud_guidance" );
  SetCursor( CURSOR_HAND );



  local obj = "spr_extra_button_"..but_name.."_focus";
  local txt_obj = "txt_extra_button_"..but_name
  --"art",
  --"music",
  --"wallpaper",
  --"playextra",
  --"screensaver"
  --"achievments"
  --"collectibles"
  --"secretroom"

  if but_name == "menu" then
    SetCursor(CURSOR_DOWN)
  elseif but_name == "art" or but_name == "music" or but_name == "wallpaper" or but_name == "playextra" or 
         but_name == "screensaver" or but_name == "achievments" or but_name == "collectibles" or  but_name == "secretroom" then
    SetCursor(CURSOR_HAND)
    --interface.PopupShow( "str_extra_button_"..but_name );
  end


  local alp = ObjGet( obj ).alp;

  ObjAnimate( obj, 8, 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

--  ObjAnimate( "", 8, 0, 0, "", {0,0,0, 0.5,0,1} );

  
  if ObjGet(txt_obj) then
    if but_name == "playextra" then
    ObjAnimate( txt_obj, 12, 0, 0, "", 
    {
       0.0, 0, ObjGet( txt_obj ).color_r, ObjGet( txt_obj ).color_g, ObjGet( txt_obj ).color_b,
       ( common_impl.animtime * ( 1 - alp ) ), 0, private.txt_color.playextra[4], private.txt_color.playextra[5], private.txt_color.playextra[6] 
    } );
   elseif not_clr_txt then
     
   else 
    ObjAnimate( txt_obj, 12, 0, 0, "", 
    {
       0.0, 0, ObjGet( txt_obj ).color_r, ObjGet( txt_obj ).color_g, ObjGet( txt_obj ).color_b,
       ( common_impl.animtime * ( 1 - alp ) ), 0, private.txt_color.other[4], private.txt_color.other[5], private.txt_color.other[6]
    } );     
    end
  end

end;
--------------------------------------------------------------------
function public.ButtonMouseLeave( but_name,not_clr_txt )

  SetCursor( CURSOR_DEFAULT );
  --interface.PopupHide()
  local obj = "spr_extra_button_"..but_name.."_focus";
  local txt_obj = "txt_extra_button_"..but_name
  local alp = ObjGet( obj ).alp;
  --local pfx_obj = "pfx_extra_button_"..but_name.."_focus";
  ObjAnimate( obj, 8, 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
  --ObjAnimate( pfx_obj, 8, 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
  
  if ObjGet(txt_obj) then
    if but_name == "playextra" then
    ObjAnimate( txt_obj, 12, 0, 0, "", 
    {
       0.0, 0, ObjGet( txt_obj ).color_r, ObjGet( txt_obj ).color_g, ObjGet( txt_obj ).color_b,
       ( common_impl.animtime * alp  ), 0, private.txt_color.playextra[1], private.txt_color.playextra[2], private.txt_color.playextra[3] 
    } );
    elseif not_clr_txt then
     
    else 
    ObjAnimate( txt_obj, 12, 0, 0, "", 
    {
       0.0, 0, ObjGet( txt_obj ).color_r, ObjGet( txt_obj ).color_g, ObjGet( txt_obj ).color_b,
       ( common_impl.animtime * alp  ), 0,private.txt_color.other[1], private.txt_color.other[2], private.txt_color.other[3] 
    } );     
    end
  end

end;

----------------------------------------------------------------------------------------------------
function public.Setwallpaper()

  SetCursor( CURSOR_DEFAULT );
  SoundSfx( "aud_click_menu" )

  if IsDemoEdition()  then

    common.DialogWindowShow( "common", "not_in_demo", true );
  else

    common.DialogWindowShow( "common", "set_wallpaper", true );

  end;

end;
----------------------------------------------------------------------------------------------------
function public.Saveart()

  SetCursor( CURSOR_DEFAULT );
  SoundSfx( "aud_click_menu" )  

  if IsDemoEdition()  then

    common.DialogWindowShow( "common", "not_in_demo", true );

  else

   common.DialogWindowShow( "common", "save_conceptart", true );

  end;

end;
----------------------------------------------------------------------------------------------------
function public.Savemusic()

  SetCursor( CURSOR_DEFAULT );
  SoundSfx( "aud_click_menu" )

  if IsDemoEdition()  then

    common.DialogWindowShow( "common", "not_in_demo", true );

  else

    common.DialogWindowShow( "common", "save_music", true );

  end;  

end;


--------------------------------------------------------------------
--------------------------------------------------------------------
function public.ButtonScreensaver()

  SoundSfx( "aud_click_menu" )
  cmn.GotoRoom( "rm_screensaver" );


end;
--------------------------------------------------------------------
--------------------------------------------------------------------
--------------------------------------------------------------------
function public.ButtonCollectibles()

  SoundSfx( "aud_click_menu" )
  cmn.GotoRoom( "rm_collectibles" );
--  if not(private.load_ach) then
--
--    private.load_ach=true
--
--
--
--     -- ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
--     -- TrgExecute( "trg_achievements_init" );
--  end
--    TrgExecute( "trg_achiev_init" );
--    LoadCurrentProfile();
--  ng_var.previous_room = GetCurrentRoom();
--
--  cmn.GotoRoom( "rm_collectibles", nil, true );

end;
--------------------------------------------------------------------
--------------------------------------------------------------------
function public.ButtonSecretroom()
  SoundSfx( "aud_click_menu" )
----  ld.PlayAudio( "sfx", "common/audio/aud_click_menu" );
--  if not(private.load_ach) then
--
--    private.load_ach=true
--
--
--     -- ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
--     -- TrgExecute( "trg_achievements_init" );
--  end
--
--  --  TrgExecute( "trg_achiev_init" );
--    LoadCurrentProfile();
--  ng_var.previous_room = GetCurrentRoom();
--
 --cmn.GotoRoom( "rm_secretroom" );
  
end;
--------------------------------------------------------------------
--------------------------------------------------------------------
--------------------------------------------------------------------
function public.ButtonAchievments()
 SoundSfx( "aud_click_menu" )
----  ld.PlayAudio( "sfx", "common/audio/aud_click_menu" );
--  if not(private.load_ach) then
--
--    private.load_ach=true
--
--
--     -- ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
--     -- TrgExecute( "trg_achievements_init" );
--  end
--
--  --  TrgExecute( "trg_achiev_init" );
--    LoadCurrentProfile();
--  ng_var.previous_room = GetCurrentRoom();
--
 cmn.GotoRoom( "rm_achievements" );
  
end;

--CONFIG EXTRA------------------

--if IsSurveyEdition() == 1 then
--
--  ObjDelete( "spr_extra_button_playextra" );
--  ObjDelete( "spr_extra_button_wallpaper" );
--  ObjDelete( "spr_extra_button_art" );
--
--
--  ObjDelete( "obj_extra_wallpaper" );
--  ObjDelete( "obj_extra_art" );
--
--  ObjAttach( "obj_extra_music", "rm_extra" );
--  ObjSet( "obj_extra_music", { input = 1, visible = 1, alp = 1 } );
--
--end;

function public.ButtonCard()
   cmn.GotoRoom( "rm_cards" );
   SoundSfx( "aud_click_menu" )
end


--------------------------------------------------------------------
function public.PlayExtra(prg)

  SoundSfx( "aud_click_menu" )
  SetCursor( CURSOR_DEFAULT );

  if (prg == "ext" and ng_global.progress[ "std" ].common.gamewin) or (prg == "scr" and ng_global.progress[ "ext" ].common.gamewin) then

  -- DbgTrace(prg);

    if ng_global.progress[ prg ].common.gamewin == true and
      ng_global.progress[ prg ].common.gamestart == false then
      common.DialogWindowShow( "common", "finish"..prg, true );
    
    else

      ng_global.currentprogress = prg;

      if ( not ng_global.progress[ prg ].common.gamestart ) then
        ng_global.progress[ prg ].common.gamestart = true;
      end;

      SetCursor( CURSOR_DEFAULT );
      local level = ng_global.progress[ prg ].common.chapter;
      cmn.is_inmenunow = false;

     common.LevelSwitch( level );

    end;

  else
    
    if IsDemoEdition() or IsSurveyEdition()  then

      common.DialogWindowShow( "common", "not_in_demo", true );

    else
      if prg == "ext" then
        common.DialogWindowShow( "common", "unlockextra", true );
      elseif prg == "scr" then
        common.DialogWindowShow( "common", "unlockscr", true );
      end

    end;

  end;


end;
--------------------------------------------------------------------




common.dialog.common.buttons[ "save_conceptart" ] = { left = { text = "yes", func = "save_conceptart" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "set_wallpaper" ] = { left = { text = "yes", func = "set_wallpaper" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "save_music" ] = { left = { text = "yes", func = "save_music" }, center = nil, right = { text = "no", func = "Close" } };
--common.dialog.common.buttons[ "setscreensaver_walp" ] = { left = { text = "yes", func = "setscreensaver_walp" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "unlockextra" ] = { left = nil, center = { text = "ok", func = "unlockextra" }, right = nil };
common.dialog.common.buttons[ "unlockscr" ] = { left = nil, center = { text = "ok", func = "unlockscr" }, right = nil };
common.dialog.common.buttons[ "finishext" ] = { left = { text = "yes", func = "finishext" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "not_in_demo" ] = { left = nil, center = { text = "ok", func = "not_in_demo" }, right = nil };

function common.dialog.common.save_conceptart ()
  common.dialog.common.Close()
  CopyFileToMyDocs( "assets/levels/menu/rm_extra/content/art_"..private.art_current );
end;

function common.dialog.common.set_wallpaper ()
  common.dialog.common.Close()
  CopyFileToMyDocs( "assets/levels/menu/rm_extra/content/wallpaper_"..private.wallpaper_current);
end;

function common.dialog.common.save_music ()
  common.dialog.common.Close()
  CopyFileToMyDocs( "assets/levels/menu/rm_extra/content/soundtrack_"..private.music_current );
end;

--function common.dialog.common.setscreensaver_walp ()
--  common.dialog.common.Close()
--  SetWallpaper( "assets/levels/menu/rm_screensaver/content/wallpaperscreensaver_"..private.screensaver_current..".jpg");
--end;

function common.dialog.common.unlockextra ()
  common.dialog.common.Close()
end;

function common.dialog.common.unlockscr ()
  common.dialog.common.Close()
end;

function common.dialog.common.finishext ()

  --common.dialog.common.Close()

  common.dialog.playchoice.resetprogress = "ext";
  --local commonsave = ng_global.progress[ prg ].common;
  --ng_global.currentprogress = prg;
  common.dialog.common.Reset()

  --SaveProfiles();

 -- ld.dialog.common.close();
  --common.DialogWindowShow( "gamemode", "newgame" );

end;
function common.dialog.common.not_in_demo ()
  common.dialog.common.Close() 
end